var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"./scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"./scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"./scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3ds_max_dotnet_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3ds Max .NET SDK</h1></div><p>This section describes the .NET functionality of the 3ds Max SDK.</p>\n\
<p>3ds Max exposes some of the SDK via .NET assemblies, and provides a sample .NET plug-in.</p>\n\
<p>.NET plug-in system requirements are listed in <a href=\"about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a>.</p>\n\
<p>This topic provides a short primer for doing .NET development on top of the 3ds Max SDK. Some familiarity with 3ds Max plug-in development and the .NET platform is assumed. Also see the <a href=\"3ds_max_sdk_-_the_learning_path/lesson_7_writing_dotnet_plug-ins.html\">Lesson 7: Writing .Net Plug-ins</a> for a tutorial on setting up a .NET plug-in project.</p>\n\
<p>You can also find an example .NET plug-in project called Explode Geometry on the <a href=\"https://github.com/ADN-DevTech/3dsMax-Explode-Geometry\" target=\"_blank\">Autodesk Developer Network Githug repository</a>.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p> The reference documentation for the various assemblies is provided as Visual Studio integrated documentation. You can use the Object Browser in Visual Studio to browse the reference documentation.</p>\n\
\n\
</div></div>\n\
\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/3ds_max_dotnet_assemblies.html\">3ds Max .NET Assemblies</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/loading_3ds_max_dotnet_assemblies.html\">Loading 3ds Max .NET Assemblies</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/dotnet_action_items.html\">.NET Action Items</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/dotnet_user_interface.html\">.NET User Interface</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/passing_function_callbacks_in_dotnet.html\">Passing Function Callbacks in .NET</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/using_ccli.html\">Using C++/CLI</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"3ds_max_dotnet_sdk/troubleshooting_dotnet_plug-ins.html\">Troubleshooting .NET Plug-ins</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";