var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_ccli\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using C++/CLI</h1></div><p>To enable interoperability between managed .NET code and native unmanaged C++ code, Microsoft created the C++/CLI language as a superset of native C++. The C++/CLI compiler is available in Visual Studio 2008, and is enabled by using the command-line option <code>/clr</code>. The C++/CLI Language Specification is published by ECMA International as Standard ECMA-372 and is available for download at the following link:</p>\n\
<p><a href=\"http://www.ecma-international.org/publications/standards/Ecma-372.htm\" target=\"_blank\">http://www.ecma-international.org/publications/standards/Ecma-372.htm</a>.</p>\n\
<p>Section 8. Language Overview (of ECMA specification) provides a useful introduction to the language. The remainder of the specification is useful as a reference.</p>\n\
<p>Developers must use C++/CLI to make calls into the native 3ds Max SDK from a managed project. Developers can also use C++/CLI to wrap native types in managed objects and export these managed wrapper classes outside their assembly. Such exported types may be called from any .NET language: C#, C++/CLI, Visual Basic, etc.</p>\n\
<p>The .NET Framework classes can be used from C++/CLI similar to how they are used in C#. Developers familiar with native C++ and C# will find that their C# experience carries over easily to C++/CLI. Any good documentation on the .NET platform will be useful for C++/CLI work.</p>\n\
<h2 id=\"creating-a-c-cli-plug-in-to-be-loaded-by-3ds-max\">Creating a C++ / CLI plug-in to be loaded by 3ds Max</h2><p>To create a C++/CLI plug-in, we generally follow the same procedure as for a native plug-in documented elsewhere in the SDK documentation. The major difference is that the CLR language extensions must be turned on in the project settings using the <code>/clr</code> option.</p>\n\
<p>Additionally to refer to the .NET 3ds Max SDK components, a <code>\\#using</code> reference path must be configured in the project settings. These components are in the  <em>maxsdk\\assemblies</em>  and  <em>maxsdk\\x64\\assemblies</em>  folders. This setting for the sample C++ / CLI project can be found in: <em>Project Properties</em> &gt; <em>Configuration Properties</em> &gt; <em>C/C++</em> &gt; <em>General</em> &gt; <em>Resolve #using References: ..\\..\\assemblies</em></p>\n\
<p>The 3ds Max SDK installation includes a sample how-to plug-in demonstrating some of the fundamental issues involved in creating a .NET plug-in for 3ds Max. The plug-in project file and code is in <code>howto\\\\SceneExplorerExtension</code> under your 3ds Max SDK installation folder. This sample plug-in is loaded by the managed plugin loader. This plugin then makes calls into managed code to add a new &quot;Hit Points&quot; property column to the Scene Explorer.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_dotnet_sdk.html\">3ds Max .NET SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";