var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"lesson_1_sample_utility_plug-in\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Lesson 1: Sample utility plug-in</h1></div><h2 id=\"start-working-with-the-plug-in-wizard\">Start Working with the Plug-in Wizard</h2><p>In this lesson we demonstrate the minimum required steps to create a plug-in that gets loaded by 3ds Max. The IDE and compiler configurations are reviewed, and practical steps are taken to make the plug-in recognized by 3ds Max.</p>\n\
<p>Please refer to <a href=\"./../about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a> to ensure that you meet the platform requirements to start developing 3ds Max plug-ins. We will be using the Plug-in Wizard (AppWizard) in MS Visual Studio 2019 to create plug-ins. Refer to <a href=\"./../writing_plug-ins/creating_a_plug-in_project/using_appwizard_to_create_a_new_/installing_the_plug-in_wizard.html\">Installing the Plug-in Wizard (AppWizard)</a> and add the 3ds Max Plug-in Wizard template to the list of installed templates for Visual C++.</p>\n\
<p>Our plug-in this lesson will be a utility plug-in, one of the simplest plug-in types. We will start with a plug-in that only gets loaded by 3ds Max and will add some very basic functionality to display a custom message in the prompt area of 3ds Max.</p>\n\
<p>You can now create a new project in MS Visual Studio using the installed 3ds Max Plug-in Wizard. This will automatically set some of your project properties (e.g. configuration type of your project or additional include folders) and generate the minimum required code for your plug-in to compile and be loaded in to 3ds Max. Once you select the plug-in wizard to create your project, you will need to enter a name for your project. In the next step, set your plug-in type to &quot;utility&quot; for this example. This will automatically set the base class to <code>UtilityObj</code> in the next page. The wizard will then ask you some information about the name, category and description of your plug-in. What you enter here will not affect any functionality of your plug-in, so you can enter any string such as &apos;My Utility&apos; for the name, &apos;Test Plug-ins&apos; for the category and &apos;My first utility plug-in&apos; for description.</p>\n\
<p>The last page in the plug-in wizard will ask for the path to three different folders. The first path is that of the maxsdk (e.g.  <em>C:\\Program Files\\Autodesk\\3ds Max 2020 SDK\\maxsdk</em> ) to include its header and library folders. The output path is usually the \\plugins folder in the 3ds Max installation folder (i.e.  <em>C:\\Program Files\\Autodesk\\3ds Max 2020\\plugins</em> ), because there is the location searched by 3ds Max for the plug-ins during the start up. The last path is the location of the file 3dsmax.exe on the hard drive. By default, that should be  <em>C:\\Program Files\\Autodesk\\3ds Max 2020</em> .</p>\n\
<p>This last page also provides options to implement <a href=\"./../3ds_max_sdk_features/miscellaneous_topics/parameter_maps.html\">Parameter Maps</a>  and Extension <a href=\"./../3ds_max_sdk_features/modeling/geometry_pipeline_system/channels.html\">Channels</a>, and to use Qt for the UI (see <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins.html\">Using Qt with 3ds Max Plug-ins</a> for more information).  This last option is enabled by default for those plug-in types (such as Utility) where it is available.  Make sure it is checked for this lesson.  When Qt is used for the user interface, the wizard adds a form file (<em>plugin_form.ui</em>) and wrapper class (<code>QtPluginRollup</code>) to the project, and adds <code>QObject</code> to the base class inheritance.</p>\n\
<h2 id=\"plug-in-wizard-39-s-automatically-generated-files\">Plug-in Wizard&apos;s Automatically Generated Files</h2><p>At this point, the plug-in wizard will create your project solution including the following files:</p>\n\
<ul>\n\
<li><em>&lt;yourprojectname&gt;.def</em> </li>\n\
<li><em>DllEntry.cpp</em> </li>\n\
<li><em>&lt;yourprojectname&gt;.rc</em> </li>\n\
<li>*3dsmaxsdk_preinclude.h * </li>\n\
<li><em>resource.h</em> </li>\n\
<li><em>&lt;yourprojectname&gt;.h</em> </li>\n\
<li>*&lt;yourprojectname&gt;.cpp * </li>\n\
<li><em>plugin_form.ui</em></li>\n\
<li><em>QtPluginRollup.cpp</em></li>\n\
<li><em>QtPluginRollup.h</em></li>\n\
</ul>\n\
<p>You will not need to make any change in the plug-in wizard generated code of most of these files (this holds true for any utility plug-in). All you need to in order to specialize your utility plug-in is to modify the file &lt;yourprojectname&gt;.cpp. Here we will have a quick review on all these files, with more emphasize on  <em>&lt;yourprojectname&gt;.cpp</em>  that forms the most important part of your plug-in project.</p>\n\
<h3 id=\"-lt-yourprojectname-gt-def\">&lt;yourprojectname&gt;.def</h3><p>A .DEF file describes various attributes of a DLL file. In our case, it declares the mandatory functions explained in <a href=\"getting_started_writing_plug-ins.html\"\"\">Getting Started Writing Plug-ins</a> to 3ds Max. Note that even if all those functions are implemented correctly, 3ds Max cannot find them (and consequently will not load the plug-in) unless you have listed those functions in this file. You can refer to <a href=\"./../writing_plug-ins/creating_a_plug-in_project/manually_creating_a_new_plug-in_/creating_the_def_file.html\">Creating the DEF File</a> for more information on this file.</p>\n\
<h3 id=\"dllentry-cpp\">DllEntry.cpp</h3><p>This file includes the implementation of the functions explained in <a href=\"getting_started_writing_plug-ins.html\"\"\">Getting Started Writing Plug-ins</a> (that are also declared in the .def file), plus a DLL entry point function (<code>DllMain()</code>) that MS Windows requires from all DLLs. This function is called by Windows when the DLL is loaded, and may also be called many times during time-critical operations such as rendering. The content of this file needs to be almost the same if you are creating your plug-in manually.</p>\n\
<h3 id=\"-lt-yourprojectname-gt-rc\">&lt;yourprojectname&gt;.rc</h3><p>This file contain windows resources needed for your plug-in. The strings you entered for the plug-in name, category and description when the wizard created a new project are stored here as a string table. </p>\n\
<p>This file also defines and stores a Win32 UI panel (named <code>IDD_PANEL</code> by default) that is used as the UI for the plug-in if Qt support is not enabled when the project is created.  This is the legacy method of creating plug-in UIs.</p>\n\
<p>You can manually edit the .rc file after it was created. However, remember that this file is not a requirement of 3ds Max. All you need to do is to return a string in the specific functions of your plug-in (e.g. the DLL function <code>LibDescription()</code> or the member function <code>&amp;lt;yourclassdescriptor&amp;gt;:: Category()</code>).</p>\n\
<h3 id=\"3dsmaxsdk_preinclude-h\">3dsmaxsdk_preinclude.h</h3><p>This file defines macros required for generating the compile-time to-do messages. You will not need this file if you are creating your project manually.</p>\n\
<h3 id=\"resource-h\">resource.h</h3><p>Similar to the .rc file, this file is created by the resource editor and stores the constant values used in the resource file. You will not need this file if you are creating your plug-in manually.</p>\n\
<h3 id=\"plugin_form-ui-qtpluginrollup-cpp-qtpluginrollup-h\">plugin_form.ui, QtPluginRollup.cpp, QtPluginRollup.h</h3><p>These files define the plug-ins user interface.  The plugin_form.ui file is a Qt Creator file that defines a Widget parent used as the plug-in&apos;s rollup.  You can use Qt Creator to edit this file.  The QtPluginRollup class (defined in QtPluginRollup.cpp and QtPluginRollup.h) extends the QMaxParamBlockWidget class.  This class connects parameter blocks to Qt widgets using a special naming convention.  This class includes the form class generated by plugin_form.ui (ui_plugin_form.h), and implements some of the methods required by QMaxParamBlockWidget.  It also implements any methods <em>not</em> connected to a parameter block, using the Qt signal/slot mechanism.</p>\n\
<h3 id=\"-lt-yourprojectname-gt-h\">&lt;yourprojectname&gt;.h</h3><p>This file contains the include statements for your plug-in class. The important included file here is <code>utilapi.h</code>, which includes the definition of the <code>UtilityObj</code> class. You will see that the rest of the included files are almost always the same if you use the plug-in wizard to create other types of plug-ins.</p>\n\
<p>There is also a global variable and a global function (both defined in the <code>DllEntry.cpp</code>) that are declared in this file. The global variable (<code>hInstance</code>) is a handle to the plug-in DLL module in the OS memory space. This global variable is initialized after the plug-in is loaded using a value the OS provides, and is used when the plug-in is calling 3ds Max, so 3ds Max knows where (in which DLL) it should look for the resources.</p>\n\
<p>The global function (<code>GetString()</code>) is used to return a string from a string table whose index is given. The plug-in wizard stores the strings you enter for the plug-in name, category and description in a string table in the resource file ( <code>&amp;lt;yourprojectname&amp;gt;.rc</code>) and retrieves them using this function.</p>\n\
<p>All you will need to do for this file if you are not using the plug-in wizard is to include <code>utilapi.h</code>, which defines the <code>UtilityObj</code> class, and <code>maxapi.h</code>, which defines the interface class. We need the latter one when we want to add the UI panel as a 3ds Max rollup page.</p>\n\
<h3 id=\"-lt-yourprojectname-gt-cpp\">&lt;yourprojectname&gt;.cpp</h3><p>Being a utility plug-in, your plug-in extends from the <code>UtilityObj</code> class. Because all the member functions of <code>UtilityObj</code> are pure virtual, you will need to implement all of them so your plug-in can be compiled and loaded in 3ds Max. Fortunately, the plug-in wizard generates the minimum code required to implement these member functions. All these functions are from the base class <code>UtilityObj</code>. You will see later that other plug-in types (other than the utility plug-ins) need to implement functions from the parents of the base class as well.</p>\n\
<p>The file <code>&amp;lt;yourprojectname&amp;gt;.cpp</code> contains the majority of your plug-in, including your plug-in class (extended from <code>UtilObj</code>), the class descriptor (<code>&amp;lt;yourpluginname&amp;gt;ClassDesc</code>), and a global function (<code>get&amp;lt;yourpluginname&amp;gt;Desc()</code>) that is called from the DLL function <code>LibClassDesc()</code> and returns the address of a static object of the plug-in class-descriptor class.</p>\n\
<p>You can have only one instance of a utility plug-in in 3ds Max (as opposed to a geometrical object plug-in, for example). This is why you will see that your plug-in uses a singleton access pattern: whenever 3ds Max calls the <code>&amp;lt;yourpluginname&amp;gt;ClassDesc::Create()</code> function to instantiate a new object, a pointer to the same static object is returned.</p>\n\
<p>The &quot;class descriptor&quot; class is the primary link to 3ds Max. The plug-in wizard names it <code>&amp;lt;yourpluginname&amp;gt;ClassDesc</code>, but if you are manually creating your plug-in, you can use any name for it. It must inherit from <code>ClassDesc2</code>. It describes the type of the plug-in class we are implementing, its name, its class ID, etc. It also implements a function to provide instances of this plug-in class when requested. The plugin wizard does not implement the code for any of the functions in this class -- it is the responsibility of the plug-in developers to implement them.</p>\n\
<p>The plug-in wizard automatically generates a class ID for your plug-in. However, you can refer to the topic  <a href=\"./../writing_plug-ins/plug-in_basics/generating_class_ids.html\">Generating Class IDs</a> if you are not using the plug-in wizard.</p>\n\
<h2 id=\"the-first-custom-interaction-with-3ds-max\">The first custom interaction with 3ds Max</h2><p>The learning path source zip file contains a folder named &quot;Lesson1a&quot;. This is a compressed Visual Studio project created using the plug-in wizard. To demonstrate an interaction with the 3ds Max that we can observe on the screen, we print a message in the prompt bar of the 3ds Max window when the user selects our plug-in. For this purpose we have modified the function <code>&amp;lt;yourpluginname&amp;gt;::BeginEditParams()</code> that plug-in wizard has created.</p>\n\
<p><code>UtilObj::BeginEditParams()</code> is called when the utility plug-in is started and usually adds the UI panel we have defined in the .rc file to the 3ds Max window as a rollout panel. When 3ds Max calls this function, it includes a pointer to the 3ds Max main interface as an argument that we will use to access the <code>Interface::PushPrompt()</code> function that prints a message in to the prompt area:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void UtilitySample::BeginEditParams(Interface* ip,IUtil* iu) \n\
{\n\
    // This is template code:\n\
    this-&gt;iu = iu;\n\
    widget = new QWidget;\n\
    ui.setupUi(widget);\n\
\n\
    // We can connect UI signals here using Qt Functor syntax\n\
    QObject::connect(ui.pushButton, &amp;QPushButton::clicked, this, &amp;UtilitySample::DoSomething);\n\
    ip-&gt;AddRollupPage(*widget, L&quot;Plug-in Rollup&quot;);\n\
\n\
    // We add this for Lesson 1:\n\
    ip-&gt;PushPrompt(_M(&quot;Hello World from Lesson 1.  Called from BeginEditParams()&quot;));\n\
}</code></pre><p>Adding the last line has resulted the following message to appear in the 3ds Max window when the UtilitySample plug-in is selected from the utility plug-in list:</p>\n\
<p><img src=\"./images/GUID-C51349FF-152F-4210-82DE-1EB7FC77771F-low.png\" alt></p>\n\
<p>However, this message will stay in the prompt area even if another plug-in is selected. We will need to pop this message from the prompt stack when the plug-in is not active anymore. We edit the function <code>UtilObj::EndEditParam()</code> for this purpose. This function is called by 3ds Max when the plug-in is de-activating. This function is implemented as following in the included project Lesson1a:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void UtilitySample::EndEditParams(Interface* ip,IUtil*)\n\
{\n\
    this-&gt;iu = nullptr;\n\
    ip-&gt;DeleteRollupPage(*widget);\n\
\n\
    ip-&gt;PopPrompt();\n\
}</code></pre><p>Adding the last line will remove the last message in the prompt area and restore it to its previous message.</p>\n\
<h2 id=\"a-note-on-debugging-your-plug-in-in-visual-studio\">A note on debugging your plug-in in Visual Studio</h2><p>At some point, you will probably want to debug your plug-ins to fix the bugs, to observe the flow of the program or to observe the interaction between 3ds Max and your plug-in. Although your plug-in is not a stand-alone application, you still can take advantage of all the debugging tools in Visual Studio, such as break points, variable watch, heap or stack memory viewer and the registers display. You can refer to the topic <a href=\"./../writing_plug-ins/troubleshooting/debugging_3ds_max_plug-ins_using.html\">Debugging 3ds Max plug-ins using Visual Studio</a> for detailed information about using the debugger for your plug-in.</p>\n\
<p>You can also use the <code>DebugPrint()</code> function for logging errors, reporting values or events, and tracing information in your program. For example, you can use it in the plug-in wizard generated function <code>LibClassDesc()</code> in the file  <em>DLLEntry.cpp</em>  to see when and how it is called:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">__declspec( dllexport ) ClassDesc* LibClassDesc(int i)\n\
{\n\
    DebugPrint(_M(&quot;The LibClassDesc() was called with the input %x&quot;), i);\n\
    switch(i) \n\
    {\n\
        case 0: return GetUtilitySampleDesc();\n\
        default: return 0;\n\
    }\n\
}</code></pre><p>The above code will print a message in Visual Studio&apos;s debug output whenever 3ds Max calls the <code>LibClassDesc()</code> function in your DLL. You can find the output window in the Debug menu &gt; Windows &gt; Output. Make sure that you have &quot;Show output from: Debug&quot; in that window.</p>\n\
<h2 id=\"-em-how-to-create-a-project-without-the-plug-in-wizard-em-\"><em>How to Create a Project without the Plug-in Wizard</em></h2><p>The Plug-in Wizard creates the .vcxproj file to configure the project settings in visual studio and also creates the template code for your plug-in. If you are not using the Plug-in Wizard, you can still create a 3ds Max plug-in from an &quot;Empty Project&quot; template as long as you manually configure the project settings and create the required files and codes. In the list of templates, in the &quot;Visual C++&quot;, group select &quot;General&quot;, and then select &quot;Empty Project&quot;. The project Lesson1b implements a utility plug-in similar to what we reviewed above, but it is created from an empty project template without using the Plugin Wizard. You will see that both the number and the content of the files are reduced in this project. Note that there is no rollout page and no string table used there. However, the following settings have been applied to the project properties.</p>\n\
<h3 id=\"configure-project-properties\">Configure Project Properties</h3><p>Plug-in Wizard automatically configures the following settings for the project properties. If you are not using the plug-in wizard, make sure that you apply these settings:</p>\n\
<p>In <em>Project</em> &gt; <em>[yourprojectname] Properties</em> &gt; <em>Configuration Properties</em> &gt; <em>General</em>:</p>\n\
<ul>\n\
<li>Output directory: &lt;your 3ds Max installation folder&gt;\\plugins</li>\n\
<li>Intermediate directory: .\\Debug\\</li>\n\
<li>Target Name: &lt;your selected target name, e.g. testPlugin&gt;</li>\n\
<li>Target Extension: .dlu</li>\n\
<li>Platform Toolset: V141</li>\n\
<li>Configuration Type: Dynamic Library (.DLL)</li>\n\
<li>Character Set: Use Unicode Character Set</li>\n\
</ul>\n\
<p>The information you provide to Plug-in Wizard will be used for configuring the following settings:</p>\n\
<p>In <em>Project</em> &gt; <em>[yourprojectname] Properties</em> &gt; <em>Configuration Properties</em> &gt; <em>Linker</em> &gt; <em>General</em>:</p>\n\
<ul>\n\
<li>Output file: &lt;your 3ds Max installation folder&gt;\\plugins\\&lt;your project name&gt;.dlu</li>\n\
<li>Additional Library Directories: &lt;maxsdk path&gt;\\lib\\x64\\Release</li>\n\
</ul>\n\
<p>In <em>Project</em> &gt; <em>[yourprojectname] Properties</em> &gt; <em>Configuration Properties</em> &gt; <em>Linker</em> &gt; <em>Input</em>:</p>\n\
<ul>\n\
<li>Additional Dependencies: bmm.lib;core.lib;geom.lib;gfx.lib;mesh.lib;maxutil.lib;maxscrpt.lib;gup.lib;paramblk2.lib;%(AdditionalDependencies)</li>\n\
</ul>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> The following setting is accessible only after you&apos;ve added the first .cpp file to your project:</div>\n\
<p>In <em>Project</em> &gt; <em>[yourprojectname] Properties</em> &gt; <em>Configuration Properties</em> &gt; <em>C/C++</em> &gt; <em>General</em>:</p>\n\
<ul>\n\
<li>Additional Include Directories: &lt;maxsdk path&gt;\\include</li>\n\
</ul>\n\
<h3 id=\"creating-the-files-and-template-code\">Creating the files and template code</h3><p>The plug-in wizard also creates the files mentioned above with a minimum code and adds them to your Visual Studio project. This however does not include any functionality for the plug-in. It will be up to you as a developer to complete the code of the functions or add new functions for achieving the desired functionality. You will need to refer to the relevant sections of the <a href=\"./../3ds_max_sdk_features.html\">3ds Max SDK Features</a> to know what functions exist for each type of plug-in and then use those functions according the documentation to achieve your goals. Do not forget to use the <a href=\"./../writing_plug-ins/plug-in_basics/generating_class_ids.html\">Generating Class IDs</a> program, gencid.exe to create class IDs for your plug-ins. You can also refer to the examples provided in 3ds Max in  <em>&lt;3ds Max installation folder&gt;\\maxsdk\\howto</em>  and  <em>&lt;3ds Max installation folder&gt;\\maxsdk\\samples</em>  to see examples of working plug-ins and get ideas on how to implement your plug-in.</p>\n\
<h3 id=\"creating-the-dialogs\">Creating the dialogs</h3><p>You can also manually add one or more dialogs to your project if you are not using the plug-in wizard. These dialogs will then be used as rollout pages in 3ds Max for your plug-in. You can right click on the project name in the project explorer and then add a dialog (Add &gt; Dialog). An example procedure is:</p>\n\
<ol>\n\
<li><p>Right click on the project, click <em>Add</em> &gt; <em>Resource</em> &gt; <em>Dialog</em></p>\n\
</li>\n\
<li><p>Modify the dialog by doing the following:</p>\n\
<ul>\n\
<li>Delete the OK and Cancel buttons, they usually are not required.</li>\n\
<li>Right click on the dialog and select Properties. Change the style to &quot;Child&quot;</li>\n\
<li>Turn off &quot;System Menu&quot; and &quot;Title Bar&quot; (set them to <em>False</em> in the dialog Properties panel).</li>\n\
<li>Set &quot;Border&quot; to none</li>\n\
<li>Resize the panel size to100 by 100</li>\n\
<li>Set the ID to &quot;IDD_PANEL&quot;</li>\n\
</ul>\n\
</li>\n\
<li><p>Now switch from the &quot;Properties&quot; window to &quot;Toolbox&quot; and Add a &quot;Static Text&quot; UI item. Set the caption to anything you want, for example &quot;My Plug-in rollout page&quot; In the properties window of the static text. You can add any UI item you might need for your plug-in.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_sdk_-_the_learning_path.html\">3ds Max SDK - The Learning Path</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";