var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_animation_keys\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Animation Keys</h1></div><p>Extracted keys are stored in the <code>IGameKey</code> class that maintains a list for all the Key types: bezier, TCB, linear and sampled. Data is accessed depending on the controller type. The code sample below retrieves all the bezier keys for position:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IGameControl pGC;\n\
\n\
IGameKeyTab BezKeys;\n\
If(pGC-&gt;GetBezierKeys(BezKeys, IGAME_POS))\n\
{\n\
    for(int i = 0;i&lt;BezKeys.Count();i++)\n\
    {\n\
        if(Type== IGAME_POS || Type== IGAME_POINT3)\n\
        {\n\
            Point3 k = BezKeys[i].bezierKey.pval;\n\
             //use data here\n\
        }\n\
    }\n\
}</code></pre><p>Because this sample uses bezier position data, the <code>IGameControl::GetBezierKeys()</code> method is used with the <code>IGAME_POS</code> flag. If successful, <code>BezKeys</code> contains a list of keys used to access the <code>bezierKey</code> members. This list is maintained by <code>IGameKey</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";