var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_custom_user_data\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Custom User Data</h1></div><p>Every node in 3ds Max can have user data added to it using the object properties dialog box. 3DXI can extract such data as an <code>IGameProperty</code>. Access to it is defined through the <code>IGameProp.xml</code> file. It uses the data found in the <code>&amp;lt;ExportUserData&amp;gt;</code> field to correctly extract the data found. Each piece of user data is contained in a <code>&amp;lt;UserProperty&amp;gt;</code>. The following table enumerates UserProperty elements:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>&lt;id&gt;</td>\n\
<td>The unique ID for the Parameter. This has to be unique to the file</td>\n\
</tr>\n\
<tr>\n\
<td>&lt;simplename&gt;</td>\n\
<td>A field that can be used for a more detailed description of the user property. This field has no relevance to 3DXI and is used only to more easily identify a UserProperty editing/examining the IGameProp.xml file.</td>\n\
</tr>\n\
<tr>\n\
<td>&lt;keyName&gt;</td>\n\
<td>The name of data chunk. This can not contain spaces</td>\n\
</tr>\n\
<tr>\n\
<td>&lt;type&gt;</td>\n\
<td>The data type, User data supports <em>int</em>, <em>float</em>, <em>bool</em> and <em>string</em></td>\n\
</tr>\n\
</tbody></table>\n\
<p>In the XML file (shown below), the developer adds the following entry, so that the Property Manager can parse the data and provide access to it using the <code>IGameProperty</code> interface.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&lt;ExportUserData&gt;\n\
- &lt;!--\n\
Access to the Node User Data\n\
- &lt;!--\n\
The id must be unique to the file\n\
\n\
  &lt;UserProperty&gt;\n\
    &lt;id&gt;101&lt;/id&gt;\n\
    &lt;simplename&gt;IGameTestString&lt;/simplename&gt;\n\
    &lt;keyName&gt;string&lt;/keyName&gt;\n\
    &lt;type&gt;string&lt;/type&gt;\n\
  &lt;/UserProperty&gt;\n\
  &lt;UserProperty&gt;\n\
    &lt;id&gt;102&lt;/id&gt;\n\
    &lt;simplename&gt;IGameTestInt&lt;/simplename&gt;\n\
    &lt;keyName&gt;int&lt;/keyName&gt;\n\
    &lt;type&gt;int&lt;/type&gt;\n\
  &lt;/UserProperty&gt;\n\
  &lt;UserProperty&gt;\n\
  &lt;id&gt;103&lt;/id&gt;\n\
    &lt;simplename&gt;IGameTestFLoat&lt;/simplename&gt;\n\
    &lt;keyName&gt;float&lt;/keyName&gt;\n\
    &lt;type&gt;float&lt;/type&gt;\n\
  &lt;/UserProperty&gt;\n\
  &lt;UserProperty&gt;\n\
    &lt;id&gt;104&lt;/id&gt;\n\
    &lt;simplename&gt;IGameTestBool&lt;/simplename&gt;\n\
    &lt;keyName&gt;bool&lt;/keyName&gt;\n\
    &lt;type&gt;bool&lt;/type&gt;\n\
  &lt;/UserProperty&gt;\n\
&lt;/ExportUserData&gt;\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";