var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_error_reporting\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Error Reporting</h1></div><p>During an error condition most 3DXI functions set a global error code. Two global functions are available are <code>GetLastIGameError()</code> for retrieving the last error code and <code>GetLastIGameErrorText()</code> for the last error message.</p>\n\
<p>An error callback object can also be registered using <code>SetErrorCallback()</code>. This event is fired when the global error is set, so it can be trapped before the calling method at fault has actually returned. This approach is a convenient way to provide a full diagnostic dump for the user after an export completes. The following code shows a simple example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MyErrorProc : public  IGameErrorCallBack\n\
{\n\
public:\n\
    void ErrorProc(IGameError error)\n\
    {\n\
        TCHAR * buf = GetLastIGameErrorText();\n\
        DebugPrint(&quot;ErrorCode = %d ErrorText = %s\\n&quot;, error,buf);\n\
    }\n\
};\n\
\n\
MyErrorProcpErrorProc;\n\
SetErrorCallBack(&amp;pErrorProc);\n\
\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";