var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_materials_and_textures\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Materials and Textures</h1></div><p>Materials are stored globally as <code>IGameMaterial</code>, with each node providing an index into this global array. The standard 3ds Max material (<code>StdMtl2</code>) is directly supported with methods for getting basic material data such as ambient and diffuse color, glossiness and opacity. Other material found provides access to the <code>IPropertyContainer</code> so that parameter extraction is possible using <code>IGameProperty</code>.</p>\n\
<p>The multi-material is supported, with access to the sub-materials, the material ID being used on the sub-Object level. Materials also provide access to any texture that is used, with direct support for bitmap textures. All properties of bitmap textures, including clipping data, are supported.</p>\n\
<p>3DXI supports DirectX 9 Shader Material using <code>IGameMaterial</code>. Direct 3D effect data is held in the <code>IGameFX</code> interface and access to global parameters, samplers, and transform data is provided. The following code is an example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// mat is a pointer to an IGameMaterial\n\
TSTR buf;\n\
int texCount = mat-&gt;GetNumberOfTextureMaps();\n\
for(int i=0;i&lt;texCount;i++)\n\
{\n\
     IGameTextureMap * tex = mat-&gt;GetIGameTextureMap(i);\n\
    TCHAR * name = tex-&gt;GetTextureName();\n\
    if(tex-&gt;IsEntitySupported()) //its a bitmap texture\n\
    {\n\
        IGameProperty * prop = tex-&gt;GetClipHData();\n\
        DumpProperties(bitmapTexture,prop);\n\
        prop = tex-&gt;GetClipUData();\n\
        DumpProperties(bitmapTexture,prop);\n\
        prop = tex-&gt;GetClipVData();\n\
        DumpProperties(bitmapTexture,prop);\n\
        prop = tex-&gt;GetClipWData();\n\
        DumpProperties(bitmapTexture,prop);\n\
    }\n\
}</code></pre><p>Textures also provide access to the coordinate rollout data used by textures to handle transformations. Either the complete transform or the individual elements that make up the transform can be accessed.</p>\n\
<div class=\"note note:\"><em><span class=\"notetitle\">Note:</span> 3DXI</em> does provide the ability to export faces based on either smoothing groups or material IDs.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";