var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_modifiers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Modifiers</h1></div><p>3DXI provides direct access to modifiers using the <code>IGameObject</code> interface with no knowledge of derived objects or internal mechanisms. <code>IGameObject</code> maintains a list of modifiers applied to the object with access to both the name used in the stack and the internal name, so the developer can simply determine if the modifier is needed.</p>\n\
<p>As an extension to this, <code>IGameModifier</code> directly supports the skin deformation modifiers of &quot;max skin&quot; and &quot;physique&quot;. Even though both modifiers provide their own APIs, they are quite different. 3DXI provides a unified access to both skin modifiers. By using the method <code>IGameModifier::IsSkin()</code>, the developer can cast to <code>IGameSkin</code> for direct access of weights and bone bindings.</p>\n\
<p><code>IGameModifier</code> still provides access to the original 3ds Max modifier because some data is user-defined such that 3ds Max can not extract it. This is usually in the form of LocalModData or Per-Face Data, and hence must be accessed directly by the developer who wrote it.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int numMod = igameObj-&gt;GetNumModifiers();\n\
\n\
if(numMod &gt; 0)\n\
{\n\
    for(int i=0;i&lt;numMod;i++)\n\
    {\n\
        IGameModifier * m = igameObj-&gt;GetIGameModifier(i);\n\
        // access data here...\n\
    }\n\
}</code></pre><p>The <code>IGameModifier</code> interface also provides a list of all the nodes that are affected by the modifier, so, on export, you can choose to export nodes based on modifiers, such as physique.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";