var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_node\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Node</h1></div><p>The <code>IGameNode</code> is a container which maintains a scene object, any controller associated with that object, or a material in the scene. The following code demonstrates how materials are accessed at the root level using <code>IGameScene</code>. One call to <code>IGameScene::GetRootMaterialCount()</code> obtains the number of materials in the scene, and an enumeration of the count provides a direct index into the material list using <code>IGameScene::GetRootMaterial()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IGameScene* pIGame;\n\
\n\
void IGameExporter::ExportMaterials()\n\
{\n\
    TSTR buf;\n\
    if(exportMaterials)\n\
    {\n\
        int matCount = pIgame-&gt;GetRootMaterialCount();\n\
        buf.printf(&quot;%d&quot;,matCount);\n\
        for(int j =0;j&lt;matCount;j++)\n\
        {\n\
            IGameMaterial * mat = pIgame-&gt;GetRootMaterial(j);\n\
             if(mat)\n\
                 DumpMaterial(matNode,mat,j);\n\
        }\n\
    }\n\
}</code></pre><p>Nodes are accessed in a similar manner. The code, in the following example, accesses and exports the parent (top-level) nodes. <code>ExportNodeInfo()</code> is not a part of the game interfaces.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IGameScene* pIGame\n\
\n\
for(int loop = 0; loop &lt; pIgame-&gt;GetTopLevelNodeCount();loop++)\n\
{\n\
    IGameNode * pGameNode = pIgame-&gt;GetTopLevelNode(loop);\n\
    if(pGameNode-&gt;IsTarget())\n\
        continue;\n\
    ExportNodeInfo(pGameNode);\n\
    pIgame-&gt;ReleaseIGameNode(&amp;pGameNode); // free the memory\n\
}</code></pre><p>Because the <code>IGameNode</code> is simply the object container, <code>GetIGameObject()</code> must be called to access the actual object. Similarly, access to the node&apos;s material and controller is accomplished using <code>GetNodeMaterial()</code> and <code>GetIGameControl()</code> respectively. You then call <code>IGameScene::ReleaseIGameObject()</code>, which frees the memory associated with that object. Freeing the memory of the <code>IGameObject</code> does not affect the controller or material data.</p>\n\
<p>Access to a 3ds Max <code>INode</code> can be achieved through the function <code>IGameNode::GetMaxNode()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";