var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dxi_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3DXI Objects</h1></div><p>An <code>IGameObject</code> is a scene entity with relevant properties. <code>IGameObject</code> defines the type of object, whether a camera, a lights etc. <code>IGameNode</code> is the container for <code>IGameObject</code>s. The developer must then cast the object to its correct interface, as shown in the following code from the <code>IGameExporter</code> sample (edited for clarity):</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">//child is an IGameNode pointer\n\
IGameObject * obj = child-&gt;GetIGameObject();\n\
switch(obj-&gt;GetIGameType())\n\
{\n\
    case  IGameObject::IGAME_MESH:\n\
        if(exportGeom )\n\
        {\n\
            IGameMesh * gM = (IGameMesh*)obj;\n\
             if(gM-&gt;InitializeData())\n\
            {\n\
                 DumpMesh(gM,geomData);\n\
            }\n\
             else\n\
            {\n\
                DebugPrint(&quot;BadObject\\n&quot;)\n\
            }\n\
        }\n\
        break;\n\
    case  IGameObject::IGAME_SPLINE:\n\
        if(exportSplines)\n\
        {\n\
            IGameSpline * sp = (IGameSpline*)obj;\n\
             sp-&gt;InitializeData();\n\
             DumpSpline(sp,splineData);\n\
        } \n\
        break;\n\
}\n\
child-&gt;ReleaseIGameObject();</code></pre><p>In the above example, we call <code>IGameObject::GetIGameType()</code> and cast the <code>IGameObject</code> to its associated interface. The following table is a list of <code>IGameObject</code> types and their associated interfaces:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>IGame Object Type</td>\n\
<td>IGame Interface</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_UNKNOWN</td>\n\
<td>IGameGenObject</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_LIGHT</td>\n\
<td>IGameLight</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_MESH</td>\n\
<td>IGameMesh</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_SPLINE</td>\n\
<td>IGameSpline</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_CAMERA</td>\n\
<td>IGameCamera</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_HELPER</td>\n\
<td>IGameHelperObject</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_BONE</td>\n\
<td>IGameHelperObject</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_IKCHAIN</td>\n\
<td>IGameIKChain</td>\n\
</tr>\n\
<tr>\n\
<td>IGAME_XREF</td>\n\
<td>IGameXRefObject</td>\n\
</tr>\n\
</tbody></table>\n\
<p>To preserve memory, <code>IGameObject</code> has an <code>InitializeData()</code> method which instructs the 3DXI system to start the actual object conversion. Objects such as editable meshes can consume much memory, so this conversion happens only at the request of the developer. For example: in the case that only the simple node transformation data is required, you do not need to call <code>InitializeData()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3dxi.html\">3DXI</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";