var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"animatables_and_sub-animatables\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Animatables and Sub-Animatables</h1></div><p>The <code>Animatable</code> class is the base class for many of the items in 3ds Max. In addition to numerous utility functions, it contains methods related specifically to the Track View (see <a href=\"track_view.html\"\">Track View</a> for more information) and for enumerating the sub-animatables. A sub-animatable is an object managed by an animatable, that is itself also an animatable. For example a parameter a parameter block.</p>\n\
<p>The following functions expose the sub-animatables to 3ds Max: <code>Animatable::NumSubs()</code>, <code>Animatable::SubAnim()</code> and <code>Animatable::SubAnimName()</code>. For more information on implementing these see the topic <a href=\"./../../writing_plug-ins/plug-in_basics/enumerating_and_identifying_sub-.html\">Enumerating and Identifying Sub-Animatables</a>.</p>\n\
<p>Below is a partial screen capture of Track View that demonstrates some sub-animatables:</p>\n\
<p><img src=\"./images/GUID-84247461-5BFF-499D-B343-5DB238313208-low.gif\" alt=\"\"></p>\n\
<p>A node has six sub-animatables:</p>\n\
<ul>\n\
<li>Space Warp Bindings</li>\n\
<li>Transform Controller</li>\n\
<li>Object Reference of the node</li>\n\
<li>Material</li>\n\
<li>Visibility Controller</li>\n\
<li>Image Motion Blur Controller</li>\n\
</ul>\n\
<p>If a node does not have some of these assigned (for example the material and visibility controller) these sub-animatables are NULL. Any sub-animatables that are NULL don&#39;t appear in Track View.</p>\n\
<p>In the example above, the node <code>Box01</code> has two sub-animatables that are non-NULL: the transform controller (labeled <code>Transform</code>) and the object reference (labeled <code>Object</code>( Box)). The other node, <code>Box02</code>, has three non-NULL sub-anims. These are the transform controller (<code>Transform</code>), the derived object (<code>Modified``Object</code>), and the Material (<code>Material01</code>).</p>\n\
<p>Note that sub-animatables may have sub-animatables themselves. This can be seen in the parameters of <code>Box01</code> sub-animatables <code>Object</code>( Box). Objects derived from <code>SimpleObject</code> (like <code>Object</code>( Box)) have the parameter block as an animatable. The box&#39;s parameter block has six sub-animatables (Length, Width, etc.). Note also that the node <code>Box02</code> sub-animatable <code>Material</code> #1 has sub-animatables of its own. These are its parameters and its texture maps.</p>\n\
<p>Sub-animatables are often the animatable parameters of a plug-in. In 3ds Max any animated parameter has a controller to control the animation. The controller for a parameter appears in the track view. This allows the user to view the animation associated with a parameter in several formats such as in key frames, as a range of time over which the animation takes place, and graphically as a function curve.</p>\n\
<p>Sub-animatable are accessed by a method that returns a pointer to the nth sub-animatables. These methods are <code>Animatable::NumSubs()</code>, <code>Animatable::SubAnim</code>( i) and <code>Animatable::SubAnimName</code>( i).</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../animation_time_and_controllers.html\">Animation, Time, and Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";