var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"controllers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Controllers</h1></div><p>All animation in 3ds Max is managed by a plug-in type called an <em>animation controller</em> (or <em>controller</em> for short). A controller manages the animation by returning a specific value given a specific time value.</p>\n\
<p>Controllers are either keyframe based or procedure.</p>\n\
<ul>\n\
<li>A keyframe based controller sets the value of the controller at important (key) points in time and the controller provides all the values at other times by interpolating between the key values.</li>\n\
<li>A procedural controller computes the value at a certain point in time based on a programmed effect (for instance, the Noise controller uses a fractal function to compute the value).</li>\n\
</ul>\n\
<p>There are six basic controller types. Each one controls a specific data type:</p>\n\
<ul>\n\
<li>Floating point controllers (<code>float</code>)</li>\n\
<li>Point3 controllers (<code>Point3</code>)</li>\n\
<li>Position controllers (<code>Matrix3</code>)</li>\n\
<li>Rotation controllers (<code>Quat</code>)</li>\n\
<li>Scale controllers (<code>ScaleValue</code>)</li>\n\
<li>Transform controllers (<code>Matrix3</code>)</li>\n\
</ul>\n\
<p>Plug-in developers can create new controller types, or work with the properties of existing types.</p>\n\
<p>A controller returns a specific value when given a time in the animation. In the following table controllers are categorized according to the type of value they produce, and correspondingly their SuperClass ID:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Type of Value</td>\n\
<td>SuperClassID of associated controller</td>\n\
</tr>\n\
<tr>\n\
<td>float</td>\n\
<td>CTRL_FLOAT_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>Point3 (including color)</td>\n\
<td>CTRL_POINT3_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>position</td>\n\
<td>CTRL_POSITION_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>rotation</td>\n\
<td>CTRL_ROTATION_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>scale</td>\n\
<td>CTRL_SCALE_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>transform</td>\n\
<td>CTRL_MATRIX3_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>morph</td>\n\
<td>CTRL_MORPH_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>(user-defined)</td>\n\
<td>CTRL_USERTYPE_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>master (master point)</td>\n\
<td>CTRL_MASTERPOINT_CLASS_ID</td>\n\
</tr>\n\
<tr>\n\
<td>masterblock</td>\n\
<td>MASTERBLOCK_SUPER_CLASS_ID</td>\n\
</tr>\n\
</tbody></table>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/controller_api_elements.html\">Controller API Elements</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/point_rotation_scale_prs_control.html\">Point Rotation Scale (PRS) Controller</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/constraints.html\">Constraints</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/controllers_and_parameter_blocks.html\">Controllers and Parameter Blocks</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/transform_controllers_and_nodes.html\">Transform Controllers and Nodes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/the_undo_mechanism_and_transform.html\">The Undo Mechanism and Transform Controllers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controllers/controller_data_access.html\">Controller Data Access</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../animation_time_and_controllers.html\">Animation, Time, and Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";