var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"controller_api_elements\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Controller API Elements</h1></div><h2 id=\"principal-classes\">Principal Classes</h2><p>The following are the main class used when dealing with controllers in the SDK.</p>\n\
<ul>\n\
<li><code>Control</code> - This is the base class for the creation of controller plug-ins.</li>\n\
<li><code>StdControl</code> -This class provides a simplified way to create controller plug-ins. Developers who sub-classs their plug-in from this class will have fewer methods to implement.</li>\n\
<li><code>IKeyControl</code> - This class is used to access the properties of controllers. The standard 3ds Max plug-ins support this interface. plug-in developers are encouraged to do so as well. This allows other third-party developers to access your controller&#39;s data.</li>\n\
<li><code>SetXFormPacket</code> - This class is used to allow a transform controller to know that it is being specifically moved, rotated, or scaled.</li>\n\
<li><code>EaseCurveList</code> - Ease curves vary the timing of a superior function curve. A normal function curve charts an animated parameter value over time. An Ease curve charts changes to the time of a function curve over time. A 3ds Max user may apply multiple ease curves to a parameter. This class holds a list of ease curves and allows developers to access their data.</li>\n\
<li><code>MultCurveList</code> - The value of a multiplier curve is a scale factor applied to the value of its superior function curve. This class holds a list of multiplier curves and allows developers to access their data.</li>\n\
</ul>\n\
<h2 id=\"interfaces\">Interfaces</h2><p>The following interface classes provide access to the parameters for the standard 3ds Max controllers:</p>\n\
<ul>\n\
<li>Path Controller: <code>IPathPosition</code></li>\n\
<li>Noise Controller: <code>INoiseControl</code></li>\n\
<li>Surface Position: <code>ISurfPosition</code></li>\n\
<li>Link Inheritance Controller: <code>ILinkCtrl</code></li>\n\
<li>Look At Controller: <code>ILookatControl</code></li>\n\
</ul>\n\
<h3 id=\"global-functions\">Global Functions</h3><p>There are some global functions developer may use that relate to controllers. These provide things such as setting the default controllers used for various controller types, creating new instances of different controller types, turning animation mode on and off, temporarily suspending animate mode, and getting/setting the animation start and end times. There are also some global functions which provide access to the default tangent types for both the Bezier and TCB controllers.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../controllers.html\">Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";