var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"controller_data_access\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Controller Data Access</h1></div><p>This section provided an overview of accessing 3ds Max controller data. Since 3ds Max supports both keyframe and procedural controllers different techniques are required to retrieve the data. Keyframe controller can usually use the <code>IKeyControl</code> interface. Procedural controller must be sampled using <code>GetValue()</code>, usually at each frame. The values that a controller stores are in the local coordinate system of the controller. The matrix passed to <code>GetValue()</code> for a transform controller defines the coordinate system of the transformation.</p>\n\
<p>This topic presents information on accessing the data of 3ds Max&#39;s keyframe and procedural controllers. There are sections which explain how the keyframe data for the PRS controller can be interpreted, various APIs for keyframe data access, and procedural controller data access.</p>\n\
<p>Example keyframe controllers are the Tension/Continuity/Bias (TCB), Bezier, and Linear controllers. Each keyframe controller in 3ds Max is used to animate a value. The keys of the controller store the values at the key frames. The controller&#39;s job is to interpolate between these keys. This topic discusses the way developers may access and interpret the keys stored by keyframe controllers (in particular the keys stored by the Position/Rotation/Scale transform controllers).</p>\n\
<p>3ds Max also allows the use of procedural controllers. Procedural controllers are those that compute their value algorithmically, based on user specified parameters or outside data, rather than interpolating between stored keyframes. Examples include the Noise Controller, Expression Controller, Audio Controller, Path Controller, and Waveform Controller. This topic presents information on how procedural controllers may be sampled to retrieve their data.</p>\n\
<p>Source code is provided demonstrating how developers may access both keyframe and procedural controller data.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"controller_data_access/keyframe_key_data_for_the_prs_co.html\">Keyframe Key Data for the PRS Controller</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controller_data_access/keyframe_data_access_classes_and.html\">Keyframe Data Access Classes and Methods</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controller_data_access/keyframe_interpolation.html\">Keyframe Interpolation</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"controller_data_access/procedural_controller_data_acces.html\">Procedural Controller Data Access</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../controllers.html\">Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";