var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"keyframe_key_data_for_the_prs_co\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Keyframe Key Data for the PRS Controller</h1></div><p>The default keyframe transform controller in 3ds Max is a PRS controller. This means that it handles orienting a node in the scene using separate controllers for Position, Rotation and Scale. To generate a complete transformation, first the position is applied, then the rotation, then the scaling.</p>\n\
<p>Position and scale keys are stored in the local coordinate system of the controller, with each key independent of the others. Rotation keys are stored in local coordinates as well, but each is stored relative to the previous key in the track. Thus the first key stored represents the actual value for the rotation key in terms of the relative space of the controller. The second key is just an offset from the first key. Thus to get the actual rotation for the second key you need to multiply it on the left by the first key. To get the third key, you need to multiply it by the second computed key (which was computed from the first). These computed rotation key values will then be the absolute quaternions for each key for that controller.</p>\n\
<p>It is important to understand however that the entire animation track for position, rotation and scale are all relative to the matrix passed into the controller when its <code>Control::GetValue()</code> method is called. For additional details on how a controller updates <code>Control::GetValue()</code> see the Advanced Topics section <a href=\"./../../../modeling/transformation_and_rotation/node_transformations.html\">Node Transformations</a>.</p>\n\
<p>Note the following points:</p>\n\
<ul>\n\
<li>When developers access key data from 3ds Max, the data is returned in the local coordinate system of the controller.</li>\n\
<li>The key values that appear in the Key Info dialog for a controller are in the local coordinate system of the controller (with the appropriate units for display -- for example, angles are shown in degrees in Key Info but are stored in radians).</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../controller_data_access.html\">Controller Data Access</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";