var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"the_undo_mechanism_and_transform\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>The Undo Mechanism and Transform Controllers</h1></div><p>The following is a discussion of how a transform controller responds to movement of the mouse when the user is dragging and how the undo mechanism is involved.</p>\n\
<p>When the user first clicks the mouse button down to begin a drag operation, the initial position of a node is stored. As each move takes place a new vector is calculated from the initial position to the new position of the mouse. This new calculation is used to update the position of the node. This is different than accumulating the new position from the previous position. The accumulation approach can introduce error. It may also be a problem for the user to get back to the initial position of the node if they move the mouse back to the initial position.</p>\n\
<p>3ds Max uses the undo mechanism to avoid the problems associated with the accumulation approach. Every time the user moves the mouse 3ds Max re-computes the entire modification. So 3ds Max uses the original point and the current location of the mouse to compute the position. What this means internally is that every time the user moves the mouse the state at initial mouse down must be restored. To do this, when the mouse is initially pressed,<code>theHold</code>.Begin() is called to create a <code>RestoreObj</code> that stores the initial state. When the mouse is moved, <code>theHold</code>.Restore() is called. This restores the state to when <code>theHold</code>.Begin() was called.</p>\n\
<p>As noted above, when the user initially mouses down, <code>theHold</code>.Begin() is called. Then at each mouse move <code>theHold</code>.Restore() is called. In iterative operations such as this it is often useful to set one of the flags of Animatable to indicate that a restore object is being held. In the example above, when the user first clicks down on the mouse the developer checks if <code>theHold</code> is holding and if it is calls <code>theHold</code>.Put() to register a restore object. Then the developer calls athe method <code>Animatable::SetAFlag()</code> with the value <code>A_HELD</code>. This sets the <code>A_HELD</code> bit of the <code>Animatable``aflag</code> data member to indicate the restore object is held. Then on each iteration the bit is tested to see if it is set and if so another restore object is not registered. A single restore object can be restored over and other again.</p>\n\
<p>When <code>theHold</code>. Accept() or <code>theHold</code>. Cancel() is called, the system calls a method of the restore object called <code>EndHold()</code>. The developer may then clear the <code>A_HELD</code> bit to indicate the restore object is no longer being held.</p>\n\
<p>For sample code that does this see any of the transform controllers, for example,  <em>\\MAXSDK\\SAMPLES\\CONTROLLERS\\BOOLCTRL.CPP</em> . Also, see the topics on <a href=\"./../../the_undo_and_redo_system.html\">The Undo and Redo System</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../controllers.html\">Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";