var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_messages_during_animat\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference Messages During Animation</h1></div><p>When playing back an animation the messaging system is quiet (e.g. there are no change notification messages) because it is known (through validity intervals) what is changing and what is not. The exception is in the geometry pipeline where we actually use the messaging system to track caches (which multiple entities may have pointers into) as they are discarded during updating.</p>\n\
<p>The message in particular is <code>REFMSG_OBJECT_CACHE_DUMPED</code>. Nodes need to know about this message because they hold the final object cache. However dependents on a node do not need to receive this message because it doesn&apos;t mean that the object actually changed, it just means that the location in memory where the object that results from the pipeline is stored has changed. For example, the path controller doesn&apos;t care if a cache was dumped when updating the spline which the path controller references. The shape of that spline hasn&apos;t changed therefore the path controller&apos;s result hasn&apos;t changed.</p>\n\
<p>The problem is in <code>BaseNode::NotifyRefChanged()</code> which handles the following two messages as one combined case:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">case REFMSG_OBJECT_CACHE_DUMPED:\n\
case REFMSG_CHANGE:</code></pre><p>Consider a node &apos;A&apos; with a path controller that references node &apos;B&apos; (a spline object with an animated pipeline). When updating B&apos;s object pipeline, B receives a <code>RESMSG_OBJECT_CACHE_DUMPED</code> message. It processes this message as it should however the message is then propagated to node B&apos;s dependents, in this case the path controller for node A. The path controller doesn&apos;t respond to <code>RESMSG_OBJECT_CACHE_DUMPED</code> but it is still propagated to its dependents - ultimately node A. Node A then thinks that its object&apos;s cache was dumped.</p>\n\
<p>Also a side affect of the fact that <code>BaseNode::NotifyRefChanged()</code> handles <code>REFMSG_CHANGE</code> along with the cache dumped message results in a bug:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">case RESMSG_OBJECT_CACHE_DUMPED:\n\
case REFMSG_CHANGE:\n\
  if (hTarg==tmControl) {\n\
    InvalidateTreeTM();\n\
    ...</code></pre><p>The cache dumped message did come through the <code>tmControl</code> (because it came from the connection the path controller made (in affect) from node A to node B). The result is that if trajectory display is turned on, things get pretty slow because the trajectory for node A is constantly invalidated as the spline from node B updates.</p>\n\
<p>The way to handle the problem is when receiving a <code>RESMSG_OBJECT_CACHE_DUMPED</code> message in a controllers, stop the propagation of the message by returning <code>REF_STOP</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../animation_time_and_controllers.html\">Animation, Time, and Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";