var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"time_functions\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Time Functions</h1></div><p>Time is stored internally in 3ds Max as an integer number of <em>ticks</em>. Each second of an animation is divided into 4800 ticks. This value is chosen in part because it is evenly divisible by the standard frame per second settings in common use (24 -- Film, 25 -- PAL, and 30 -- NTSC).</p>\n\
<p>The data type used to store a specific instance of time is the <code>TimeValue</code>. A <code>TimeValue</code> stores the number of ticks the time represents. When a developer specifies time to almost all the functions in the SDK they use <code>TimeValues</code>.</p>\n\
<p>In 3ds Max, time may be displayed in one of four formats. These are just display formats (the internal representation never changes). The formats are:</p>\n\
<ul>\n\
<li>Frames - Integer number of frames.</li>\n\
<li>SMPTE - SMPTE time code. This format uses <code>hours</code>:minutes:seconds:frames. 3ds Max abbreviates this by not including the hours designation to <code>minutes</code>:seconds.frames.</li>\n\
<li>FRAME:TICKS - Integer number of frames:number of ticks.</li>\n\
<li>MM:SS:TICKS - Minutes:Seconds:Ticks.</li>\n\
</ul>\n\
<p>A developer may get and set the current time displayed format. The functions to accomplish this are <code>GetTimeDisplayMode()</code> and <code>SetTimeDisplayMode()</code>. When these settings are changed a message is sent throughout 3ds Max to handle updating any UI controls that reflect time settings (including plug-in custom controls).</p>\n\
<p>A developer can retrieve the number of ticks per frame using the function <code>GetTicksPerFrame()</code>, and can set this number using <code>SetTicksPerFrame()</code>.</p>\n\
<p>A developer can also get and set the current frame rate. This is the number of frames per second. The functions for this are <code>GetFrameRate()</code> and <code>SetFrameRate()</code>. This is just an alternate way to specify the number of ticks per frame.</p>\n\
<p>There are also functions to convert between the numeric and ASCII representations of time. The functions for this are <code>TimeToString()</code> and <code>StringToTime()</code>.</p>\n\
<p>Note that some methods related to time are part of various interface classes. For example Class <code>Interface</code> provides methods to retrieve the current frame slider setting and the current animation range. These methods are <code>GetTime()</code> and <code>GetAnimRange()</code>. You can also set these using <code>SetTime()</code> and <code>SetAnimRange()</code>. There is also a method <code>RegisterTimeChangeCallback()</code> that allows a plug-in to be notified every time the user changes the frame slider.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../animation_time_and_controllers.html\">Animation, Time, and Controllers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";