var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"broadcast_notification_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Broadcast Notification System</h1></div><p>The broadcast notification system is an alternative mechanism to the reference message system that calls callback functions when certain events occur. These are events such as the system unit settings changing, system time setting changing, or the user executing File/Reset, File/New, etc.</p>\n\
<p>The header file <code>notify.h</code> contains the list of notification event ID&apos;s that can be handled.</p>\n\
<p>The plug-in must creates a callback function to process the notification. The notification callback function pointer (<code>NOTIFYPROC</code>) is defined as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">typedef void (* NOTIFYPROC)(void *param, NotifyInfo *info);</code></pre><p>The <code>NotifyInfo</code> structure is passed to the <code>NOTIFYPROC</code> function pointer to inform it of what it&apos;s being notified about.</p>\n\
<p>The sample code below shows how this system may be used.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MyPlugIn : public MyPlugInBaseClass\n\
{\n\
  // Declare the callback function\n\
  static void TimeUnitsChanged(void *param, NotifyInfo *info)\n\
  {\n\
    // Handle the units changing...\n\
  }\n\
\n\
public:\n\
\n\
  MyPlugIn()\n\
  {\n\
    ...\n\
    // Register the callback\n\
    RegisterNotification(TimeUnitsChanged, this, NOTIFY_TIMEUNITS_CHANGE);\n\
  }\n\
\n\
  ~MyPlugIn()\n\
  {\n\
    ...\n\
    // When done, unregister the callback\n\
    UnRegisterNotification(TimeUnitsChanged, this, NOTIFY_TIMEUNITS_CHANGE);\n\
  }\n\
</code></pre><p>See also the topic <a href=\"scenes_and_nodes/nodes/monitoring_the_node_events.html\">Monitoring the Node Events</a> for an example of using the notification system to respond to node deletion events.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_sdk_features.html\">3ds Max SDK Features</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";