var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"biped_hierarchy\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Biped Hierarchy</h1></div><p>The biped hierarchy that is used to determine the relationships between the biped parent and child body parts is different from the hierarchy presented by the max nodes parent/child relationships. The reason for this difference is to make the biped move more naturally when it is being animated. For example, the upper arm links inherit their rotation from the center of mass, instead of from the clavicle, to which they are connected. This enables you to animate the spine without counter rotating the arms.</p>\n\
<p>The internal biped body parts might have different parents for both rotation and position. Here is a brief description about the hierarchy.</p>\n\
<h2 id=\"rotation-hierarchy\">Rotation Hierarchy</h2><ul>\n\
<li>The base of the spine, the base of the neck, the upper arms and legs, and the feet inherit their rotation from the center of mass.</li>\n\
<li>The clavicle inherits its rotation from the last spine link.</li>\n\
<li>The other biped body parts inherit their rotation from their parent <code>INode</code>.</li>\n\
</ul>\n\
<h2 id=\"axis-of-rotation\">Axis of Rotation</h2><p>You can see the local axis of rotation for a bone by selecting the <strong>Local</strong> option from the Reference Coordinate System drop-down menu in the main toolbar. Typically, these are the rotation characteristics.</p>\n\
<ul>\n\
<li>The X axis is through the length of the bone.</li>\n\
<li>Joints with one degree of freedom usually rotate along the Z axis.</li>\n\
<li>There are no thresholds for rotation except when Inverse Kinematics (IK) is applied to a limb.</li>\n\
</ul>\n\
<h2 id=\"position-hierarchy\">Position Hierarchy</h2><ul>\n\
<li>The base of the spine inherits its position from the center of the mass.</li>\n\
<li>The clavicle inherits its position from the last spine link.</li>\n\
<li>The upper leg link inherits its position from the pelvis.</li>\n\
<li>The other biped body parts inherit their position from the parent <code>INode</code>.</li>\n\
</ul>\n\
<h2 id=\"biped-degrees-of-freedom\">Biped Degrees of Freedom</h2><p>The following biped body parts lack three degrees of freedom.</p>\n\
<ul>\n\
<li>The pelvis has two degrees of freedom.</li>\n\
<li>The clavicle has two degrees of freedom.</li>\n\
<li>The knee and elbow have one degree of freedom.</li>\n\
<li>The horse ankle in a four link leg have one degree of freedom.</li>\n\
<li>The finger and toe segments excluding the base have one degree of freedom.</li>\n\
</ul>\n\
<h2 id=\"converting-the-bone-transformation-hierarchy\">Converting the Bone Transformation Hierarchy</h2><p>To convert the bone transformation hierarchy of a biped by using the general SDK calls on the nodes, perform the following steps:</p>\n\
<ol>\n\
<li>Traverse the bone link hierarchy and extract the local transformation matrices.</li>\n\
<li>Convert the transformation matrices into either quaternion or Euler angles by using your own conventions.</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../character_studio.html\">Character Studio</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";