var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"finding_a_physique_modifier\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Finding a Physique Modifier</h1></div><p>Below is a code example, for finding a physique modifier if it exists for a given <code>INode</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Modifier* FindPhysiqueModifier (INode* nodePtr)\n\
{\n\
  // Get object from node. Abort if no object.\n\
  Object* ObjectPtr = nodePtr-&gt;GetObjectRef();\n\
\n\
  if (!ObjectPtr) return NULL;\n\
  // Is derived object ?\n\
  while (ObjectPtr &amp;&amp; ObjectPtr-&gt;SuperClassID() == GEN_DERIVOB_CLASS_ID)\n\
  {\n\
    // Yes -&gt; Cast.\n\
     IDerivedObject *DerivedObjectPtr = ( IDerivedObject *)(ObjectPtr);\n\
\n\
    // Iterate over all entries of the modifier stack.\n\
    int ModStackIndex = 0;\n\
    while (ModStackIndex &lt; DerivedObjectPtr-&gt;NumModifiers())\n\
    {\n\
      // Get current modifier.\n\
      Modifier* ModifierPtr = DerivedObjectPtr-&gt;GetModifier(ModStackIndex);\n\
\n\
      // Is this Physique ?\n\
      if (ModifierPtr-&gt;ClassID() == Class_ID(PHYSIQUE_CLASS_ID_A, PHYSIQUE_CLASS_ID_B)) {\n\
        // Yes -&gt; Exit.\n\
        return ModifierPtr;\n\
      }\n\
\n\
      // Next modifier stack entry.\n\
      ModStackIndex++;\n\
    }\n\
    ObjectPtr = DerivedObjectPtr-&gt;GetObjRef();\n\
  }\n\
\n\
  // Not found.\n\
  return NULL;\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../physique_export_interface.html\">Physique Export Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";