var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"main_physique_export_api_element\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Main Physique Export API Elements</h1></div><p>The following is a list of primary classes and functions in the physique export interface contained in the file <code>PhyExp</code>.h.</p>\n\
<h2 id=\"rigid-vertex-interface\">Rigid Vertex Interface</h2><p>A rigid vertex is represented by an instance of <code>IPhyRigidVertex</code>.</p>\n\
<ul>\n\
<li><code>IPhyRigidVertex::GetNode()</code> - Returns a pointer to the <code>INode</code> to which the given vertex is assigned (controlled).</li>\n\
<li><code>IPhyRigidVertex::GetOffsetVector()</code> - Returns a <code>Point3</code> offset vector in the local coordinate space of the nth <code>INode</code>.</li>\n\
</ul>\n\
<h2 id=\"blended-rigid-vertex-interface\">Blended Rigid Vertex Interface</h2><p>A blended rigid vertex is represented by an instance of <code>IPhyBlendedRigidVertex</code>.</p>\n\
<ul>\n\
<li><code>IPhyBlendedRigidVertex::GetNumberNodes()</code> - Return an int value which specifies how many nodes (Physique Links) this vertex is assigned to. The deformation of this vertex will be a blended (weighted average).</li>\n\
<li><code>IPhyBlendedRigidVertex::GetNode()</code> - Return a pointer to the nth <code>INode</code> to which the given vertex is assigned (controlled).</li>\n\
<li><code>IPhyBlendedRigidVertex::GetOffsetVector()</code> - Return a Point3 offset vector in the local coordinate space of the nth <code>INode</code>.</li>\n\
<li><code>IPhyBlendedRigidVertex::GetWeight()</code> - Return a floating point weight for the nth <code>INode</code>.</li>\n\
</ul>\n\
<h2 id=\"physique-export-interface\">Physique Export Interface</h2><p>The physique export interface is represented by an instance of <code>IPhysiqueExport</code>. It is accessed from a physique modifier using a call to <code>Animatable::GetInterface()</code> with the class ID <code>I_PHYINTERFACE</code>.</p>\n\
<ul>\n\
<li><code>IPhysiqueExport::GetContextInterface()</code>- Returns a ModContext Export Interface for the ModContext associated with the given INode.</li>\n\
<li><code>IPhysiqueExport::ReleaseContextInterface()</code> - Must be called to free the context interface from memory.</li>\n\
<li><code>IPhysiqueExport::GetInitNodeTM()</code> - Returns the node transformation matrix in the initial position given a node pointer. Passing a node pointer for the deformable object itself will return the object offset matrix at the initial position, instead of the node transformation matrix. The return values are one of the following:</li>\n\
<li><ul>\n\
<li><code>MATRIX_RETURNED</code></li>\n\
<li><code>NODE_NOT_FOUND</code></li>\n\
<li><code>NO_MATRIX_SAVED</code></li>\n\
<li><code>INVALID_MOD_POINTER</code></li>\n\
</ul>\n\
</li>\n\
<li><code>MATRIX_RETURNED</code></li>\n\
<li><code>NODE_NOT_FOUND</code></li>\n\
<li><code>NO_MATRIX_SAVED</code></li>\n\
<li><code>INVALID_MOD_POINTER</code></li>\n\
<li><code>IPhysiqueExport::Version()</code> - Returns the version of the export interface. For physique 2.2 the return value is 22.</li>\n\
<li><code>IPhysiqueExport::SetInitialPose()</code> - Puts the model in/out the initial position. Passing TRUE puts the model in the initial pose, Passing FALSE allows the model to deform normally.</li>\n\
</ul>\n\
<h2 id=\"physique-context-export-interface\">Physique Context Export Interface</h2><p>The physique context export interface is represented by an instance of <code>IPhysiqueContextExport</code>. A pointer to <code>IPhysiqueContextExport</code> can be retrieved using the method <code>IPhysiqueExport::GetContextInterface()</code>. The context Interface is associated with a physique modifier associated with a node.</p>\n\
<ul>\n\
<li><code>IPhysiqueContextExport::GetNumberVertices()</code> - Returns the number of vertices for the given physique object.</li>\n\
<li><code>IPhysiqueContextExport::ConvertToRigid()</code> - When called with the value TRUE as an argument, all vertices accessed by <code>IPhysiqueContextExport::GetVertexInterface()</code> will be converted to rigid vertices. If passed the value FALSE as an argument, then any deformable vertices will return NULL when retrieved using <code>IPhysiqueContextExport::GetVertexInterface()</code>.</li>\n\
<li><code>IPhysiqueContextExport::GetVertexInterface()</code> - Returns an <code>IPhyExport</code> pointer for the nth vertex.</li>\n\
<li><ul>\n\
<li>Rigid non-blended vertices (assigned rigid to a single Node) will return an object that derives from <code>IPhyRigidVertex</code>.</li>\n\
<li>Rigid Blended vertices (assigned rigid to more than one Node) will return an object that derives from <code>IPhyBlendedRigidVertex</code>.</li>\n\
<li>All other vertices will return NULL, unless <code>ConvertToRigid()</code> has been called with the argument TRUE, in which case all vertices return either <code>IPhyRigidVertex</code> or <code>IPhyBlendedRigidVertex</code>.</li>\n\
</ul>\n\
</li>\n\
<li>Rigid non-blended vertices (assigned rigid to a single Node) will return an object that derives from <code>IPhyRigidVertex</code>.</li>\n\
<li>Rigid Blended vertices (assigned rigid to more than one Node) will return an object that derives from <code>IPhyBlendedRigidVertex</code>.</li>\n\
<li>All other vertices will return NULL, unless <code>ConvertToRigid()</code> has been called with the argument TRUE, in which case all vertices return either <code>IPhyRigidVertex</code> or <code>IPhyBlendedRigidVertex</code>.</li>\n\
<li><code>IPhysiqueContextExport::ReleaseVertexInterface()</code> - You must call this method to free the vertex interface from memory.</li>\n\
</ul>\n\
<h2 id=\"vertex-export-interface\">Vertex Export Interface</h2><p>The vertex export interface is an instance of <code>IPhyVertexExport</code> and can is retrieved by calling <code>IPhyContextExport::GetVertexInterface()</code>. This is the base class for all vertex export interface classes.</p>\n\
<ul>\n\
<li><code>IPhyVertexExport::GetVertexType()</code> - Returns an integer representing the defined vertex type for the a vertex interface. We suggest using <code>dynamic_cast</code>&lt;T*&gt; and comparing against <code>NULL</code> instead to query the interface type.</li>\n\
</ul>\n\
<h2 id=\"rigid-vertex-export-interface\">Rigid Vertex Export Interface</h2><p>The interface <code>IPhyRigidVertex</code> derives from <code>IPhyVertexExport</code> and is the base class for all non-blended rigid vertex assignments.</p>\n\
<ul>\n\
<li><code>IPhyRigidVertex::GetNode()</code> - Returns an <code>INode</code> pointer for the node (bone/link) to which the vertex is assigned.</li>\n\
<li><code>IPhyRigidVertex::GetOffsetVector()</code> - Returns the coordinates of the vertex in the local coordinates of the associated <code>INode</code>.</li>\n\
</ul>\n\
<h2 id=\"blended-rigid-vertex-export-interface\">Blended Rigid Vertex Export Interface</h2><p>The interface <code>IPhyBlendedRigidVertex</code> derives from <code>IPhyVertexExport</code> and is the base class for all blended rigid vertex assignments.</p>\n\
<ul>\n\
<li><code>IPhyBlendedRigidVertex::GetNumberNodes()</code> - Returns the number of nodes to which this vertices is assigned with blending.</li>\n\
<li><code>IPhyBlendedRigidVertex::GetNode()</code> - Returns an <code>INode</code> pointer for the nth node (bone/link) to which the vertex is assigned with blending.</li>\n\
<li><code>IPhyBlendedRigidVertex::GetOffsetVector()</code> - Returns the coordinates of the vertex in the local coordinates of the nth <code>INode</code> pointer.</li>\n\
<li><code>IPhyBlendedRigidVertex::GetWeight()</code> - Returns the weight of the vertex assigned to the nth <code>INode</code> pointer.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../physique_export_interface.html\">Physique Export Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";