var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_the_physique_export_interf\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using the Physique Export Interface</h1></div><p>Below is a code example using the physique export interface (<code>IPhysiqueExport</code>) which uses the function <code>FindPhysiqueModifier()</code> from the topic <a href=\"finding_a_physique_modifier.html\"\">Finding a Physique Modifier</a>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void ExportPhysiqueData(TimeValue t, ModContext &amp;mc, ObjectState *os, INode *node)\n\
{\n\
  Modifier *phyMod = FindPhysiqueModifier(node);\n\
  if (!phyMod) return;    // Physique Modifier does not exist for given Node\n\
\n\
  // create a Physique Export Interface for the given Physique Modifier        \n\
   IPhysiqueExport *phyExport = ( IPhysiqueExport*)phyMod-&gt;GetInterface(I_PHYINTERFACE);\n\
  if (phyExport)\n\
  {\n\
    // create a ModContext Export Interface for the specific node of the Physique Modifier\n\
     IPhyContextExport *mcExport = ( IPhyContextExport *)phyExport-&gt;GetContextInterface(node);\n\
    if (mcExport)\n\
    {\n\
      // we convert all vertices to Rigid in this example\n\
      mcExport-&gt;ConvertToRigid(TRUE);\n\
\n\
      // compute the transformed Point3 at time t\n\
      for (int i = 0; i &lt; os-&gt;obj-&gt;NumPoints();  i++)\n\
      {\n\
          IPhyVertexExport *vtxExport = mcExport-&gt;GetVertexInterface(i);\n\
         if (vtxExport)\n\
         {\n\
             //need to check if vertex has blending\n\
             if (vtxExport-&gt;GetVertexType() &amp; BLENDED_TYPE)\n\
            {\n\
               IPhyBlendedRigidVertex *vtxBlend = ( IPhyBlendedRigidVertex *)vtxExport;\n\
               Point3 BlendP(0.0f, 0.0f, 0.0f);\n\
                for (int n = 0; n &lt; vtxBlend-&gt;GetNumberNodes(); n++)\n\
               {\n\
                 INode *Bone = vtxBlend-&gt;GetNode(n);\n\
                 Point3 Offset = vtxBlend-&gt;GetOffsetVector(n);\n\
                  float Weight = vtxBlend-&gt;GetWeight(n);\n\
                  BlendP += (Bone-&gt;GetNodeTM(t) * Offset) * Weight;\n\
               }\n\
\n\
                // set the Point of the object (to test the export is correct)\n\
                os-&gt;obj-&gt;SetPoint(i, BlendP);\n\
                mcExport-&gt;ReleaseVertexInterface(vtxExport);\n\
                vtxExport = NULL;\n\
            }\n\
             else\n\
            {\n\
               IPhyRigidVertex *vtxNoBlend = ( IPhyRigidVertex *)vtxExport;\n\
               INode *Bone = vtxNoBlend-&gt;GetNode();\n\
               Point3 Offset = vtxNoBlend-&gt;GetOffsetVector();\n\
\n\
                // set the Point of the object (to test the export is correct)\n\
                os-&gt;obj-&gt;SetPoint(i, Bone-&gt;GetNodeTM(t) * Offset);\n\
                mcExport-&gt;ReleaseVertexInterface(vtxExport);\n\
                vtxExport = NULL;\n\
            }\n\
          }\n\
        }\n\
        phyExport-&gt;ReleaseContextInterface(mcExport);\n\
      }\n\
      phyMod-&gt;ReleaseInterface(I_PHYINTERFACE, phyExport);\n\
    }\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../physique_export_interface.html\">Physique Export Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";