var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"function_publishing\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Function Publishing</h1></div><p>The function publishing system allows plug-ins to publish their major functions and operations in such a way that code outside the plug-in can discover and make enquiries about these functions and is thus able to call them though a common calling mechanism. Functionality that is exposed through function publishing can be controlled from scripts written in MAXScript.</p>\n\
<p>The whole system is very similar to Window&#39;s COM and OLE Automation systems and share many similar concepts in the architecture. However, the Function Publishing System is not based on COM and OLE but instead is a custom architecture more suited and optimized for 3ds Max.</p>\n\
<p>Some of the purposes of the API are:</p>\n\
<ul>\n\
<li>Modularizing plug-in code into various &quot;engines&quot; that are able to supply services to other parts of 3ds Max and other plug-ins and can be delivered to the user through various different user-interfaces.</li>\n\
<li>Providing automatic scripting capabilities by exposing the published functions directly to MAXScript. Each plug-in class appears in MAXScript as a 3ds Max class object, that can be used to construct instances of the plug-in, do class tests, etc. If a plug-in publishes interfaces, they are visible in MAXScript as properties on this class object. The internal name for the interface is used as the property name. All the functions in the interface are accessible.</li>\n\
<li>Providing alternate means of invoking plug-in functions in the UI, such as via the new manipulator system, scripted menus, quad menus, hot keys, macro scripts, toolbar buttons, etc.</li>\n\
<li>Allowing the MAXScript Macro Recorder to automatically generate calls to the published functions, in the event that these are invoked by the expanded ParamMap2 system or other UI mechanisms such as hot keys or menu items.</li>\n\
<li>Facilitate automatic generation of COM interfaces and OLE Type Libraries in such a way that external COM clients can invoke the published functions in the plug-in code.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/principal_function_publishing_cl.html\">Principal Function Publishing Classes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/the_function_publishing_api.html\">The Function Publishing API</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/what_would_a_plug-in_publish.html\">What would a Plug-in Publish?</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/mesh_example.html\">Mesh Example</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/mixin_interfaces.html\">Mixin Interfaces</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/publishing_mixin_interface_on_ar.html\">Publishing Mixin Interface on Arbitrary Classes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/passing_fpinterfaces_as_paramete.html\">Passing FPInterfaces as Parameters and Results</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/core_interfaces.html\">Core Interfaces</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/action_interfaces.html\">Action Interfaces</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/parammap2_buttons.html\">ParamMap2 Buttons</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/the_fpinterface_class_hierarchy.html\">The FPInterface Class Hierarchy</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/parameter_validation.html\">Parameter Validation</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/exception_handling.html\">Exception Handling</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/property_accessors.html\">Property Accessors</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/symbolic_enumerations.html\">Symbolic Enumerations</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/supported_types.html\">Supported Types</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/published_functions_and_maxscrip.html\">Published Functions and MAXScript</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/extending_animatablegetinterface.html\">Extending Animatable::GetInterface()</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/global_function_publishing_api_f.html\">Global Function Publishing API Functions</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/using_fpinterfaceinvoke.html\">Using FPInterface::Invoke()</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"function_publishing/function_publishing_example.html\">Function Publishing Example</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_sdk_features.html\">3ds Max SDK Features</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";