var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"exception_handling\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Exception Handling</h1></div><p>FnPub interface functions can report fatal error conditions to callers by using C++ exception-handling. There is a new exception base class, MAXException, defined in iFnPub.h that can be thrown directly, or subclassed as needed for error grouping. The class is defined as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MAXException\n\
{\n\
   public:\n\
     TSTR message;\n\
     int error_code;\n\
     MAXException(TCHAR* msg, intcode=0)\n\
       : message(msg), error_code(code) { }\n\
};</code></pre><p>It contains a message buffer and an optional error code. You would signal an error using the <code>MAXException()</code> constructor and the C++ throw statement, as in the following example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">if (discrim &lt; 0.0) // oh-oh, not good\n\
   throwMAXException (&quot;Unableto findroot.&quot;, -23);</code></pre><p>This signals a fatal error with the message and code shown. If the error occurs during a call to the function by MAXScript code, it will be trapped by MAXScript and the error message will be displayed and the running script will be terminated (but 3ds Max will continue running). If the error occurs during a C++-level call, typically the outer 3ds Max error catcher will catch and report the error and then exit 3ds Max, or clients of the interface can install their own catch code.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";