var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"function_publishing_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Function Publishing Example</h1></div><p>The following is an example of function publishing taken from the Position constraint controller example, in the file <code>\\\\Samples\\\\Controllers\\\\Position_cnstrnt.cpp</code>. The <code>IPosConstPosition</code> class represents an interface to the Position constraint. This class inherits from <code>FPMixinInterface</code> which means that it can expose it functionality using the <a href=\"./../function_publishing.html\">Function Publishing</a>.</p>\n\
<p>The following code declares identifiers for each of the exposed functions.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">enum {  \n\
  get_num_targets,    \n\
  get_node,      \n\
  get_target_weight,    \n\
  set_target_weight,    \n\
  append_target,     \n\
  delete_target\n\
};   \n\
</code></pre><p>The following code in the main body of the constraint creates the function map.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Function Map for function publishing system\n\
BEGIN_FUNCTION_MAP\n\
FN_0(get_num_targets,      TYPE_INT,   GetNumTargets);\n\
FN_1(get_node,            TYPE_INODE, GetNode, TYPE_INDEX);\n\
FN_1(get_target_weight,    TYPE_FLOAT, GetTargetWeight, TYPE_INDEX);\n\
FN_2(set_target_weight,    TYPE_BOOL,  SetTargetWeight, TYPE_INDEX, TYPE_FLOAT);\n\
FN_2(append_target,        TYPE_BOOL,  AppendTarget, TYPE_INODE, TYPE_FLOAT);\n\
FN_1(delete_target,        TYPE_BOOL,  DeleteTarget, TYPE_INDEX);\n\
END_FUNCTION_MAP\n\
</code></pre><p>The following is a list of virtual functions exposed to external developers:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual int     GetNumTargets()=0;\n\
virtual INode*  GetNode(int targetNumber)=0;\n\
virtual float   GetTargetWeight(inttargetNumber)=0;\n\
virtual BOOL    SetTargetWeight(inttargetNumber, float weight)=0;\n\
virtual BOOL    AppendTarget(INode *target, float weight=50.0)=0;\n\
virtual BOOL    DeleteTarget(int selection)=0;</code></pre><p>In the main body of the code in <code>position_cnstrnt</code>.cpp we find:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static  FPInterfaceDesc pos_constraint_interface(\n\
  POS_CONSTRAINT_INTERFACE,\n\
  _T(&quot;constraints&quot;),\n\
  0,\n\
  &amp;posCD,\n\
  0,\n\
   IPosConstPosition::get_num_targets,   \n\
    _T(&quot;getNumTargets&quot;), 0, TYPE_INDEX, 0, 0,\n\
   IPosConstPosition::get_node,          \n\
    _T(&quot;getNode&quot;),  0, TYPE_INODE, 0, 1,\n\
    _T(&quot;nodeNumber&quot;),  0, TYPE_INDEX,\n\
   IPosConstPosition::get_target_weight,  \n\
    _T(&quot;getWeight&quot;), 0, TYPE_FLOAT, 0, 1,\n\
    _T(&quot;targetNumber&quot;),  0, TYPE_INDEX,\n\
   IPosConstPosition::set_target_weight,  \n\
    _T(&quot;setWeight&quot;), 0, TYPE_BOOL, 0, 2,\n\
    _T(&quot;targetNumber&quot;),  0, TYPE_INDEX,\n\
    _T(&quot;weight&quot;),  0, TYPE_FLOAT,\n\
   IPosConstPosition::append_target,    \n\
    _T(&quot;appendTarget&quot;), 0, TYPE_BOOL, 0, 2,\n\
    _T(&quot;target&quot;),  0, TYPE_INODE,\n\
    _T(&quot;weight&quot;),  0, TYPE_FLOAT,\n\
   IPosConstPosition::delete_target,    \n\
    _T(&quot;deleteTarget&quot;), 0, TYPE_BOOL, 0, 1,\n\
    _T(&quot;targetNumber&quot;), 0, TYPE_INDEX,\n\
  end\n\
);</code></pre><p>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";