var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parammap2_buttons\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>ParamMap2 Buttons</h1></div><h2 id=\"parammap2-buttons\">ParamMap2 Buttons</h2><p>The <code>f_ui</code> option for an Action Function can be used to make the <code>ParamMap2</code> system connect the action function to a button in a ParamMap2-mediated rollup in your plug-in&apos;s UI. This means you have to be using the ParamBlock2 system in the interface&apos;s plug-in (ie, same <code>ClassDesc2</code>) and have at least one paramblock containing a paramMap whose rollup contains the button dialog item.</p>\n\
<p>In the <code>f_ui</code> option, you first specify the BlockID of the paramblock containing this paramMap and then MapID of the map within that block (single map blocks use MapID 0). This is followed by a control type code, and its required parameters, as listed below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_BUTTON, &lt;dlg_item_ID&gt;</code></pre><p>a standard push button. The dialog item must be a 3ds Max <code>CustButton</code> custom control.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_CHECKBUTTON, &lt;dlg_item_ID&gt;, &lt;highlight_color&gt;</code></pre><p>a standard check button. Again, the dialog item must be a 3ds Max <code>CustButton</code> custom control, the 2nd parameters is the button highlight color as a <code>COLORREF</code> word, either one of the predefined colors in <code>maxsdk</code>\\include\\custcont.h, or an RGB value using the system <code>RGB()</code> macro.</p>\n\
<p>This is basically all you need to do. Whenever the specified map opens its rollup, say as part of a <code>BeginEditParams</code>, it will automatically look for any Action functions associated via an <code>f_ui</code> and will call that action function whenever the button is clicked. If an <code>isEnabled</code> predicate is supplied, the <code>ParamMap2</code> will call it at various display update times to determine whether to enable or disable (gray out) the button. For CheckButtons, an <code>isChecked</code> predicate must be supplied and will be called at similar times to update the pressed or not-pressed state of the button display.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";