var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"passing_fpinterfaces_as_paramete\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Passing FPInterfaces as Parameters and Results</h1></div><p>FPInterfaces themselves can now be passed directly as parameters and results via the new type, <code>TYPE_INTERFACE</code>. These turn up in MAXScript as instances of a new value class, <code>FPInterface</code>, with all the interface&apos;s methods accessible as properties.</p>\n\
<p>In cases where you have an class publishing a single mixin interface, it is possible to pass instances directly as <code>TYPE_INTERFACE</code> and let the FPInterface* type-cast implied by <code>TYPE_INTERFACE</code> extract the mixin interface. This is a useful simple alternative to the <code>IObject</code> scheme for publishing a mixin interface on non-Animatables, since you don&apos;t actually need to implement the <code>IObject</code> protocol in these cases. If the Foo example above had a single mixin, it would publish it in a similar way to the following:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class IFoo : public  FPMixinInterface\n\
{\n\
   virtualvoid Frabulate(Point3 p)=0;\n\
   //...\n\
};\n\
\n\
class Foo : public OtherBaseClass, publicIFoo\n\
{\n\
   // Foo methods\n\
   ...\n\
   // IFoo methods\n\
   voidFrabulate(Point3 p) { ... }\n\
   //...\n\
};</code></pre><p>The same Foo*-returning <code>GetFoo()</code> method in the previous example would then be declared using <code>TYPE_INTERFACE</code> in the <code>FUNCTION_MAP</code> as:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">FN_1(my_getFoo, TYPE_INTERFACE, GetFoo, TYPE_INODE);</code></pre><p>and in the descriptor constructor as:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">my_getFoo, _T(&quot;getFoo&quot;), 0, TYPE_INTERFACE, 0, 1,\n\
     _T(&quot;object&quot;), 0, TYPE_INODE,</code></pre><p>In this case, calling <code>getFoo()</code> in MAXScript would return an <code>FPInterface</code> value that exposes the <code>IFoo</code> methods directly as properties.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">f = getFoo $\n\
f.frabulate [10,0,0] --call the Foo1 frabulate method</code></pre><p>Note again this scheme won&apos;t work for class publishing multiple multiple mixins since implied FPInterface* cast becomes ambiguous - you must use the IObject mechanism in this case.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";