var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"published_functions_and_maxscrip\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Published Functions and MAXScript</h1></div><p>MAXScript automatically provides access to all functions published by a plug-in via the FnPub system. The current scheme is experimental and may change somewhat. Each plug-in class appears in MAXScript as a 3ds Max class object, that can be used to construct instances of the plug-in, do class tests, etc. If a plug-in publishes interfaces, they are visible in MAXScript as properties on this class object. The internal name for the interface is used as the property name. All the functions in the interface are accessible as named properties on the interface. So, if the previous example interfaces were published by EditMesh, the following script frags would work:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">EditMesh.faceOps.extrude $foo.mesh #{1,2,3} 10</code></pre><p>calls the Extrude function in the FaceOps interface on $foo&apos;s mesh, faces 1, 2 and 3, amount 10 units.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">EditMesh.actions</code></pre><p>retrieves and displays the action functions. Each interface is stored as a struct definition in the class object.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">EditMesh.actions.create ()</code></pre><p>starts (or stops) the create mode. This would (should!) have the side-effect of highlighting/unhighlighting the Create button in the EditMesh rollups. Calls to Action functions in MAXScript return <code>true</code> if the function returns <code>FPS_OK</code> and <code>false</code> otherwise.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">if EditMesh.actions.create.isChecked() then ...</code></pre><p>The predicate functions for an Action Function are available as properties on the action function object itself, as shown. You can determine if a predicate is supplied by asking:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">if EditMesh.actions.create.isChecked != undefined\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";