var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"added_base_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Added Base Types</h1></div><table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>TYPE_POINT</td>\n\
<td>a Win32 POINT struct</td>\n\
</tr>\n\
<tr>\n\
<td>TYPE_TSTR</td>\n\
<td>a 3ds Max SDK TSTR class</td>\n\
</tr>\n\
<tr>\n\
<td>TYPE_IOBJECT</td>\n\
<td>a new FnPub system IObject</td>\n\
</tr>\n\
<tr>\n\
<td>TYPE_INTERFACE</td>\n\
<td>a FPInterface</td>\n\
</tr>\n\
<tr>\n\
<td>TYPE_HWND</td>\n\
<td>a Win32 HWND handle</td>\n\
</tr>\n\
<tr>\n\
<td>TYPE_NAME</td>\n\
<td>a variant of TYPE_STRING, meant to be interpreted as an interned symbol orname in the client (eg, MAXScript represents these Name instances, as in #foo, etc.)</td>\n\
</tr>\n\
</tbody></table>\n\
<p>All the new base types are passed naturally as pointers, so there are <code>\\_BV</code> and <code>\\_BR</code> variants for all of them (except for <code>TYPE_HWND</code>). There are also <code>\\_TAB</code>, <code>\\_TAB_BR</code>, <code>\\_TAB_BV</code> variants for them all. For reference, all the currently available types are in the ParamType2 enumeration in <code>/include</code>/iparmb2.h. Some base types are naturally passed by value, others by pointer. Basically, all the int and float-derived types are passed naturally by-value and all the rest by pointer. The by-value base types are:</p>\n\
<h2 id=\"integers\">Integers</h2><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_INT\n\
TYPE_BOOL\n\
TYPE_TIMEVALUE,\n\
TYPE_RADIOBTN_INDEX\n\
TYPE_INDEX</code></pre><h2 id=\"floats\">Floats</h2><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_FLOAT\n\
TYPE_ANGLE\n\
TYPE_PCNT_FRAC\n\
TYPE_WORLD\n\
TYPE_COLOR_CHANNEL</code></pre><p>The <code>FPValue</code> class has a union containing fields for all the base and table types and show the natural passing mode for each. Note that the <code>\\_BP</code> by-pointer variants of the base types are passed as iptr &amp; fptr pointer fields in the <code>PValue</code> union. For the types that are passed naturally by pointer, the <code>\\_BV</code> variants cause local copies to be made and owned by the <code>FPValue</code> carrying them. The <code>FPValue</code> destructor will free memory taken by these copies. Also, the <code>\\_BR</code> variants of naturally-pointer types need to supplied as pointers to the <code>FPValue</code>(or <code>FPParams</code>) constructors and are dereferenced at parameter delivery time. So, for example, the following <code>FPInterface</code> method:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Tab&lt;int&gt; Foo(INode* object, Tab&lt;Point3*&gt;&amp; points);</code></pre><p>would be declared in the <code>FUNCTION_MAP</code> as</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">FN_2(my_foo, TYPE_INT_TAB_BV, Foo, TYPE_INODE, TYPE_POINT3_TAB_BR);</code></pre><p>and in the descriptor constructor as</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">my_foo, _T(&quot;foo&quot;), 0, TYPE_INT_TAB_BV, 0, 2,\n\
   _T(&quot;object&quot;), 0, TYPE_INODE,\n\
   _T(&quot;points&quot;), 0, TYPE_POINT3_TAB_BR,\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../symbolic_enumerations.html\">Symbolic Enumerations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";