var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"additional_paramtype2_codes_for_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Additional ParamType2 Codes for Function Publishing and MAXScript</h1></div><h2 id=\"paramtype2-codes\">ParamType2 Codes</h2><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_FPVALUE    // FPValue*, variant value\n\
TYPE_VALUE     // MAXScript Value*</code></pre><p><code>TYPE_FPVALUE</code> can be used to pass a variant data type, containing one of the types of data that <code>FPValue</code> can hold. This allows a function to be defined that can accept many types of values for a <code>TYPE_FPVALUE</code> parameter, the function can determine the type from the &apos;type&apos; field in the <code>FPValue</code> passed. MAXScript supports <code>TYPE_PFVALUE</code> parameters and return values and will convert back-and-forth between the MAXScript types that correspond to the various <code>FPValue</code> types. <code>TYPE_FPVALUE</code> also supports <code>TYPE_FPVAUE_BV</code> and <code>TYPE_FPVALUE_BR</code> variants. MAXScript arrays will attempt to convert themselves into <code>TYPE_XXX_TAB</code> FPValues if the array elements are all of the same type, for example all integers generate a <code>TYPE_INT_TAB</code>, all scene nodes generate a <code>TYPE_INODE_TAB</code>, etc. If the array contains mixed value types or types not in the following list, a <code>TYPE_FPVALUE_TAB</code> will be generated, containing an <code>FPValue</code>* variant value for each element in the array. Supported homogeneous types are:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TYPE_INT_TAB\n\
TYPE_FLOAT_TAB\n\
TYPE_TIMEVALUE_TAB\n\
TYPE_STRING_TAB\n\
TYPE_NAME_TAB\n\
TYPE_POINT3_TAB\n\
TYPE_POINT2_TAB\n\
TYPE_INODE_TAB\n\
TYPE_REFTARG_TAB (allother  ReferenceTarget*s, modifiers, mtls, ctlrs, etc.)</code></pre><p><code>TYPE_VALUE</code> is basically a fallback to be used in situations where MAXScript values of types not covered by <code>FPValue</code> types need to be passed into a published function. The called function is responsible for using the MAXScript SDK to convert to and from the <code>Value</code>* in <code>TYPE_VALUE</code> values.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../symbolic_enumerations.html\">Symbolic Enumerations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";