var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"the_fpinterface_class_hierarchy\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>The FPInterface Class Hierarchy</h1></div><p>The <code>FPInterface</code> class hierarchy is such that static and mixin interfaces and interface descriptors each have their own types.</p>\n\
<ul>\n\
<li><code>FPInterface</code> The base class for all interfaces, prime client type for using interfaces<ul>\n\
<li><code>FPInterfaceDesc</code> Contains the interface metadata<ul>\n\
<li><code>FPStaticInterface</code> Use as the base class for defining static or core virtual interface classes.</li>\n\
</ul>\n\
</li>\n\
<li><code>FPStaticInterface</code> Use as the base class for defining static or core virtual interface classes.</li>\n\
<li><code>FPMixinInterface</code> Use as the base class for defining object-based mixin interface classes, use <code>FPInterfaceDesc</code> for mixin interface descriptors</li>\n\
</ul>\n\
</li>\n\
<li><code>FPInterfaceDesc</code> Contains the interface metadata<ul>\n\
<li><code>FPStaticInterface</code> Use as the base class for defining static or core virtual interface classes.</li>\n\
</ul>\n\
</li>\n\
<li><code>FPStaticInterface</code> Use as the base class for defining static or core virtual interface classes.</li>\n\
<li><code>FPMixinInterface</code> Use as the base class for defining object-based mixin interface classes, use <code>FPInterfaceDesc</code> for mixin interface descriptors</li>\n\
</ul>\n\
<p>The <code>FPInterface</code> class continues to provide all the original method and predicate invocation functions required by an SDK-level client of the interface. A pure virtual method, <code>GetDesc()</code>, should be used to get the <code>FPInterfaceDesc</code> instance for the interface. The metadata definition and accessing methods and the metadata data members now all live in the <code>FPInterfaceDesc</code>.</p>\n\
<p>All the original interface query methods in the API (such as <code>Animatable::GetInterface</code>( id), <code>ClassDesc2::GetInterface</code>(id), <code>GetCOREInterface</code>( id)) still return <code>FPInterface</code> pointers, so you would use <code>GetDesc()</code> in constructs like the following to get at an interface&apos;s metadata:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">FPInterface* fpi = GetCOREInterface(FOO_INTERFACE);\n\
TCHAR* iname = fpi-&gt;GetDesc()-&gt;internal_name.data();</code></pre><p>The <code>FPInterface::GetDesc()</code> method has a default implementation in <code>FPInterfaceDesc</code>(and so <code>FPStaticInterface</code>), simply returning &apos;this&apos;, since instances of these classes contain the metadata). <code>FPMixinInterface</code> subclasses provide implementations of <code>GetDesc()</code>, returning their associated <code>FPInterfaceDesc</code> instance.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";