var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_would_a_plug-in_publish\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What would a Plug-in Publish?</h1></div><p>The various kinds of functions published by a plug-in usually fall into the following categories. You can, however, publish anything you want.</p>\n\
<ul>\n\
<li>Important algorithms in the plug-in, for example, the Edit Mesh modifier might publish its face extrude and mesh attach functions, or the flex modifier its soft-body dynamics algorithms. In these cases, the functions would be parameterized in the most general way, independent of any current scene state or UI mode in 3ds Max, for example, the face extrude might take a Mesh, a set of faces and a distance.</li>\n\
<li>Functions that enquire about or affect the state of one of the plug-in&#39;s objects in the scene. Usually, these are unnecessary if the plug-in stores its state as parameters in ParamBlock2s, which are already accessible externally, but in cases were this is not done or certain kinds of state are not cleanly accessible via the ParamBlock2 system, extra functions may be published by the plug-in. These usually take an instance of one of the plug-in&#39;s objects as one of their parameters, and should be independent of any UI mode, for example, they should not require that the object being manipulated be the current focus in the Command Panel. Prior to R4, plug-ins that wished to provide scripter access to internal functions would use the MAXScript SDK to provide scripter wrapper functions. In R4, the recommended and much simpler technique, is to use the Function Publishing system, as this not only provides automatic scriptability, but is a general mechanism for any external system to control and use the plug-in.</li>\n\
<li>UI action functions. These basically provide a programmatic way of &quot;pressing&quot; buttons and keys in the UI for a plug-in and are specifically meant to be UI modal. They take no parameters, since these are defined by the current state in the UI. For example, the vertex delete action function for an Editable Mesh object would operate on the current vertex selection for the current object in the Modify panel. These are not unlike the keyboard ShortcutTables that plug-ins could publish in R3, but by publishing them as action functions, any external system can effectively control the UI of a plug-in. As well as being automatically exposed in the scripter like other published functions, Action functions are automatically entered into the new ActionTable system. This is a generalization of the R3 ShortcutTable system and basically holds all the commands and actions that may be bound to hotkeys or added to menus or put in buttons on a toolbar using the R4 CUI system, so that by publishing your action functions using the FnPub system, you are making them automatically available for binding to hotkeys and placing in menus and toolbar buttons. Action functions are treated specially in the FnPub system, and have extra descriptor data for things like menu item text, tooltip text, enable predicates, etc.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../function_publishing.html\">Function Publishing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";