var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"local_value_arrays\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Local Value Arrays</h1></div><p>If the number of new locals to be protected is unknown at compile you can use the following macros that create protected arrays of values. One form creates the array on the stack using <code>\\_alloc()</code> and so is useful inside one function call, the other puts the array in the heap and so can be used across functions. In both cases, you also need to declare a <code>Value</code>** variable to hold the pointer to the array.</p>\n\
<h2 id=\"stack-resident-array\">Stack-resident Array</h2><ul>\n\
<li><code>value_local_array</code> - allocates the array of <code>Value</code>* variables</li>\n\
<li><code>pop_value_local_array</code> - dismisses the array of <code>Value</code>* variables</li>\n\
</ul>\n\
<h2 id=\"heap-resident-array\">Heap-resident Array</h2><ul>\n\
<li><code>value_temp_array</code> - allocates the array of <code>Value</code>* variables</li>\n\
<li><code>realloc_value_temp_array</code> - resizes the array</li>\n\
<li><code>pop_value_temp_array</code> - dismisses the array</li>\n\
</ul>\n\
<h2 id=\"example\">Example</h2><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value** items;\n\
value_local_array(items, n);\n\
for (int i = 0; i &lt; n; i++)\n\
  items[i] = Float::intern(data[i]);\n\
pop_value_local_array(items);\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced_maxscript_topics.html\">Advanced MAXScript Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";