var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"calling_maxscript_from_c\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Calling MAXScript from C++</h1></div><h2 id=\"executing-string-expressions\">Executing String Expressions</h2><p>The global function <code>ExecuteMAXScriptScript()</code> can be used to execute MAXScript from C++. This function has the following signature:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">BOOL ExecuteMAXScriptScript(MCHAR *s, BOOL quietErrors = FALSE, FPValue *fpv = NULL);</code></pre><p>This takes a maxscript expression in the form of a string. It does not take a filename. If the string is successfully compiled and executed by the MAXScript script engine, and a pointer to an <code>FPValue</code> is provided, any value returned from the script is converted to an <code>FPValue</code> and returned through the <code>fpv</code> parameter.</p>\n\
<p>If the string is not successfully compiled and evaluated, error messages are written to the Scripting Listener or logged using <code>LogSys</code>. If net rendering, or the <code>quietError</code> argument is <code>TRUE</code>, error messages with only be logged using <code>LogSys</code>.</p>\n\
<p>This function returns <code>TRUE</code> if the script was compiled and executed successfully.</p>\n\
<h2 id=\"executing-script-files\">Executing Script Files</h2><p>3ds Max 2013 now exposes two functions for executing maxscript files from C++ code. These two methods are detailed below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void filein_script(const MCHAR* filename = NULL);</code></pre><p>This takes a string containing the fully qualified path to a maxscript file. If the <code>filename</code> parameter is NULL, then a dialog will open prompting the user to select a file.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">BOOL filein_script_ex(const MCHAR* filename, MCHAR* error_message);</code></pre><p>This is similar to the method above, and in fact is called by <code>filein_script</code>. This file can handle maxscript files (*.ms), macroscript files (*.mcr), maxscript zip files (*.mzp) and encrypted maxscript files (*.mse). This method takes an extra out parameter which will contain an error message if one should occur.</p>\n\
<p>Note all methods described here are found in  <em>maxscript.h</em>  and are exported from the maxscript dll file.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";