var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"exposing_a_function_to_maxscript\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Exposing a Function to MAXScript</h1></div><p>This topic is about manually exposing a function to MAXScript using the MAXScript API. Usually, a plug-in uses the function publishing system to expose functions to MAXScript. For more information see the section about <a href=\"./../function_publishing/what_would_a_plug-in_publish.html\">What would a Plug-in Publish?</a>.</p>\n\
<p>Functions are exposed to MAXScript using the <code>Primitive</code> class (defined in  <em>maxscript\\foundation\\functions.h</em> ). A <code>Primitive</code> class exposes a function pointer to the MAXScript engine.</p>\n\
<p>The standard practice for doing so is to use the <code>def_visible_primitive</code> macro, from the header file  <em>maxscript\\macros\\define_instantiation_functions.h</em>  as shown below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include &lt;maxscript\\macros\\define_instantiation_functions.h&gt;\n\
def_visible_primitive(IntervalArray, &quot;IntervalArray&quot;);</code></pre><p>This expands during pre-processing to the following:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* IntervalArray_cf(Value**, int);\n\
PrimitiveIntervalArray_pf(&quot;IntervalArray&quot;, IntervalArray_cf);</code></pre><p>In this case you would next need to provide a function body for the function <code>IntervalArray_cf()</code>. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include &lt;maxscript\\maxscript.h&gt;\n\
#include &lt;maxscript\\macros\\define_instantiation_functions.h&gt;\n\
def_visible_primitive(IntervalArray, &quot;IntervalArray&quot;);\n\
\n\
Value* IntervalArray_cf(Value **arg_list, int count)\n\
{\n\
   return &amp;ok;\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";