var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"local_variables_in_maxscript_exp\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Local Variables in MAXScript Exposed Functions</h1></div><p>When writing functions that are exposed to MAXScript through and that use <code>Value</code> instances it is common practice to declare local variables using special macros found in <code>maxscrpt</code>/maxscrpt.h that protect them from the collector.</p>\n\
<ul>\n\
<li><code>one_value_local(name)</code></li>\n\
<li><code>two_value_locals(name1, name2)</code></li>\n\
<li><code>three_value_locals(name1, name2, name3)</code></li>\n\
<li>etc.</li>\n\
</ul>\n\
<p>These macros will define a single local variable named <code>vl</code> (for &apos;v&apos;alue &apos;l&apos;ocals) that will have a number of fields corresponding to the number of arguments. Each field has the name passed to the macro, and is of type <code>Value</code>*.</p>\n\
<p>For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">two_typed_value_locals(Array* result, String* item);\n\
vl.result = new Array (5);\n\
vl.item = new String (&quot;foo&quot;);\n\
vl.result-&gt;append(vl.item);</code></pre><p>There also typed versions of these macros:</p>\n\
<ul>\n\
<li><code>one_typed_value_local(type name)</code></li>\n\
<li><code>two_typed_value_local(type1 name1, type2 name2)</code></li>\n\
<li>etc.</li>\n\
</ul>\n\
<p>There can be only one <code>value_local</code> declaration macro per C++ block.</p>\n\
<h2 id=\"finalizing-local-variables\">Finalizing Local Variables</h2><p>Value locals variables must be explicitly dismissed before the block is exited. One way to do this is with the macro: <code>pop_value_locals()</code>. This returns management of the <code>Value</code> variables to the collector.</p>\n\
<p>However if you want to return one of the new values as the result, then this variable must continue to be protected from the garbage collector. You can use the macro <code>return_value()</code> to dismiss all local values and places the return value in a protected area.</p>\n\
<p>In another case, you may have taken a value out of some rooted structure (say an array in a MAXScript global) and want to hand that back as a function result. To protect it against being collected if, for example, that rooted structure gets dropped, you can use the macro: <code>return_protected()</code> which protects the return value as does <code>return_value()</code> but doesn&apos;t dismiss any local values.</p>\n\
<p>All functions in the MAXScript core that return potentially new values, including all the new operators, use one of these return value protection schemes. Since this means that a new value returned to you is safe until another function call or operation that might create another new value, you can forego the protection scheme in those cases in which you are immediately returning the new value.</p>\n\
<p>One thing to note about these protected variables is that they are considered to be part of the root set and are scanned by the collector for internal references, so you only need to protect the top-level object if you are constructing some tree of values.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";