var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"maxscript_compiler_and_interpret\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>MAXScript Compiler and Interpreter</h1></div><p>The MAXScript engine executes MAXScript code using the following steps:</p>\n\
<ul>\n\
<li>First a <code>Parser</code> object (found in <code>maxscrpt</code>\\parser.h) is instantiated with an output stream (i.e. a <code>CharStream</code> object found <code>maxscrpt</code>\\streams.h) for debugging and error output.</li>\n\
<li>Next the <code>Parser::Compile</code>(CharStream*) method is called, which will return an expression that can be executed represented as a <code>Value</code>*. This might be <code>CodeTree</code> instance, but could also be a simple literal.</li>\n\
<li>The method <code>Value::eval()</code> is then called to the <code>CodeTree</code> instance or do nothing if the <code>Value</code> is a literal..</li>\n\
</ul>\n\
<p>The following code snippet demonstrates these steps:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* file_in(CharStream* source, int quiet)\n\
{\n\
   // declare a thread-safe local variable called vl with three fields\n\
   three_typed_value_locals(Parser* parser, Value* code, Value* result);\n\
\n\
   CharStream* out = thread_local(current_stdout);  \n\
\n\
   vl.parser = new Parser (out);  \n\
   if (!quiet)  \n\
     source-&gt;log_to(out);  \n\
\n\
   // loop through file compiling and evaluating all expressions  \n\
   try  \n\
   {  \n\
     source-&gt;flush_whitespace();  \n\
     while (!source-&gt;at_eos())  \n\
     {  \n\
       vl.code = vl.parser-&gt;compile(source);  \n\
       vl.result = vl.code-&gt;eval();\n\
\n\
       if (!quiet)  \n\
         vl.result-&gt;print();  \n\
\n\
        source-&gt;flush_whitespace();  \n\
     }  \n\
     source-&gt;close();  \n\
   }  \n\
   catch (...)  \n\
   {  \n\
     // catch any errors and tell what file we are in if any  \n\
     out-&gt;puts(&quot;Error occurred during fileIn: &quot;);  \n\
     source-&gt;sprin1(out);  \n\
     out-&gt;puts(&quot;\\n&quot;);  \n\
     throw;  \n\
   }  \n\
\n\
   //return last expression in stream as result\n\
   if (vl.result == NULL)\n\
   vl.result = &amp;ok;  \n\
   return_value(vl.result);  \n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";