var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"maxscript_functions\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>MAXScript Functions</h1></div><p>MAXScript functions are represented using the class <code>MAXScriptFunction</code> defined in the header file <code>maxscrpt</code>\\funcs.h. If you have an instance of <code>MAXScriptFunction</code> you can use the following method to evaluate the function:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* MAXScriptFunction::apply(Value** arglist, int count, CallContext* cc=NULL)</code></pre><p>Functions exposed to the MAXScript engine using the <a href=\"./../function_publishing/what_would_a_plug-in_publish.html\">What would a Plug-in Publish?</a> are represented as instances of the class <code>InterfaceFunction</code>.</p>\n\
<p>All MAXScript functions are derived from the <code>Value</code> class, meaning that they first class values in MAXScript.</p>\n\
<h2 id=\"primitive-functions\">Primitive Functions</h2><p>The most important kind of 3ds Max function is the <code>Primitive</code> function of which there are three kinds:</p>\n\
<ul>\n\
<li>Standard - defined using the macro <code>def_visible_primitive</code>( function_pointer, name)</li>\n\
<li>Mapped - These are represented using the <code>MappedPrimitive</code> function and are defined using the macro <code>def_mapped_primitive</code>(function_pointer, name)</li>\n\
<li>Lazy - arguments to these functions are not pre-evaluated <code>def_lazy_primitive</code>( function_pointer, name)</li>\n\
</ul>\n\
<p>The <code>function</code> argument to these macros must have the following signature:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* &lt;name&gt;_cf(Value** arg_list, int count)</code></pre><p>To avoid name conflicts the C++ function implementation must have the suffix &quot;_cf&quot;. The <code>name</code> argument to the macro is used to define a global MAXScript variable with the given name. This global variable will hold the function.</p>\n\
<h2 id=\"type-and-argument-checking\">Type and Argument Checking</h2><p>There is no implicit type or argument checking in this calling mechanism - you have to do it yourself in the C++ implementation function. The following macros to help with this:</p>\n\
<ul>\n\
<li><code>check_arg_count</code>( fn_name, wanted_count, got_count)</li>\n\
<li><code>type_check</code>( val, class, fn_name_or_description)</li>\n\
</ul>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* open_file_cf(Value** arg_list, int count)\n\
{\n\
  // check that we have 1 arg and that it&apos;s a string\n\
  check_arg_count(openFile, 1, count);\n\
  type_check(arg_list[0], String, &quot;openFile filename&quot;);\n\
  ...\n\
  char* fn = arg_list[0]-&gt;to_string();\n\
  ...\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";