var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"maxscript_global_variables\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>MAXScript Global Variables</h1></div><p>You can define new system global variables with the <code>define_system_global()</code> function. It has the following signature:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void define_system_global(TCHAR* name, Value*(*getter)(), Value*(*setter)(Value*));</code></pre><p>Where name points to the string naming the new global and getter and setter are pointers to functions that allow modification of the variable. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Value* get_frame_rate()\n\
{\n\
    return Integer::intern(GetFrameRate());\n\
}\n\
\n\
Value* set_frame_rate(Value* val)\n\
{\n\
    SetFrameRate(val-&gt;to_int());\n\
    return val;\n\
}\n\
\n\
define_system_global(&quot;frameRate&quot;, get_frame_rate, set_frame_rate);</code></pre><p>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";