var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"useful_maxscript_tips\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Useful MAXScript Tips</h1></div><h2 id=\"accessing-the-3ds-max-sdk\">Accessing the 3ds Max SDK</h2><p>You can load the <code>Autodesk.Max.dll</code> assembly to use the 3ds Max SDK from MAXScript. Add the following MAXScript code to your start-up scripts and use the MaxGlobal variable to access the 3ds Max SDK as shown in the following example.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">fn loadAutodeskMax = (\n\
  local Assembly = dotNetClass &quot;System.Reflection.Assembly&quot;\n\
  local maxroot = pathConfig.GetDir #maxroot\n\
  Assembly.LoadFile (maxroot + &quot;\\\\Autodesk.Max.dll&quot;)\n\
  local GlobalInterface = dotNetClass &quot;Autodesk.Max.GlobalInterface&quot;  \n\
  global MaxGlobal = GlobalInterface.Instance\n\
)\n\
loadAutodeskMax ()</code></pre><p>See <a href=\"./../../3ds_max_dotnet_sdk/3ds_max_dotnet_assemblies/autodesk.max.dll.html\">Autodesk.Max.dll</a> for more information about the assembly.</p>\n\
<h2 id=\"executing-the-maxscript-code\">Executing the MAXScript Code</h2><p>You can execute MAXScript code using the <code>ExecuteMAXScriptScript()</code> global function. See the <code>maxscript\\\\maxscript.h</code> header for more information. Also, see <a href=\"calling_maxscript_from_c.html\"\">Calling MAXScript from C++</a>.</p>\n\
<h2 id=\"text-output-to-the-scripting-listener-window\">Text Output to the Scripting Listener Window</h2><p>You can output text to the Scripting Listener window as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include &lt;maxscript/maxscript.h&gt;\n\
#include &lt;maxscript/util/listener.h&gt;\n\
...\n\
the_listener-&gt;edit_stream-&gt;printf(&quot;Hello&quot;) \n\
// you could also define a handy macro:\n\
#define DebugPrint (the_listener-&gt;edit_stream-&gt;printf)</code></pre><p>See the <code>maxscript/maxscript.h</code> header for more information.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";