var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"wrapping_3ds_max_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Wrapping 3ds Max Objects</h1></div><p>All of the 3ds Max object types (i.e. instances of classes derived from <code>Object</code>) accessible in MAXScript are represented by instances of the <code>MAXWrapper</code> and derived classes. These are declared in the header file <code>maxscrpt</code>/maxobj.h. The wrapped reference is a reference created with <code>ReferenceMaker::ReplaceReference()</code>. The <code>MAXWrapper</code> class inherits from both <code>Value</code> and <code>ReferenceMaker</code>. This reference allows MAXScript to be notified of MAX-side changes to the object, particularly deletion.</p>\n\
<p>The classes that derive from Value:</p>\n\
<ul>\n\
<li><code>MAXNode</code></li>\n\
<li><code>MAXModifier</code></li>\n\
<li><code>MAXControl</code></li>\n\
<li><code>MAXKey</code></li>\n\
<li><code>MAXMaterial</code></li>\n\
<li><code>MAXMultiMaterial</code></li>\n\
<li><code>MAXTexture</code></li>\n\
<li><code>MAXMaterialLibrary</code></li>\n\
<li><code>MAXObject</code></li>\n\
<li><code>MAXSubAnim</code></li>\n\
</ul>\n\
<p>The class <code>MAXBitMap</code> is used to wrap 3ds Max bitmaps, but it is not a <code>ReferenceMaker</code> because bitmaps in MAX can not be a reference target.</p>\n\
<p>The <code>MAXSubAnim</code> which is used to wrap objects which derive from <code>Animatable</code> and are accessible inside other Max objects via the <code>Animatable::SubAnim()</code> function. This is used in MAXScript to wrap the modifier gizmo sub-objects, for example.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"wrapping_3ds_max_objects/instantiating_wrappers.html\">Instantiating Wrappers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"wrapping_3ds_max_objects/handling_deleted_wrapped_objects.html\">Handling Deleted Wrapped Objects</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"wrapping_3ds_max_objects/extracting_wrapped_objects.html\">Extracting Wrapped Objects</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";