var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3ds_max_initialization_and_final\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>3ds Max Initialization and Finalization</h1></div><p>The following are the initialization and finalization steps of 3ds Max that concern a plug-in&#39;s DLL.</p>\n\
<h2 id=\"initialization-steps-\">Initialization Steps:</h2><ol>\n\
<li>Each non-MAXScript plug-in is loaded into memory and initialized through a called to <code>LibInitialize()</code>.</li>\n\
<li>The MAXScript engine is initialized</li>\n\
<li>All MAXScript plug-ins are loaded into memory and initialized through a called to <code>LibInitialize()</code>.</li>\n\
<li><code>NOTIFY_SYSTEM_STARTUP</code> is broadcast to all plug-ins.</li>\n\
</ol>\n\
<h2 id=\"finalization-steps\">Finalization Steps</h2><ol>\n\
<li><p><code>NOTIFY_SYSTEM_SHUTDOWN</code> is broadcast to all plug-ins.</p>\n\
</li>\n\
<li><p><code>NOTIFY_SYSTEM_SHUTDOWN2</code> is broadcast to all plug-ins.</p>\n\
</li>\n\
<li><p>The global utility plug-in manager shuts down all global utility plug-in. This involves calling the global utility plug-in <code>DeleteThis()</code> methods.</p>\n\
</li>\n\
<li><p>MAXScript is uninitialized, according to the following steps:</p>\n\
<ol>\n\
<li>The macro-recorder is turned off.</li>\n\
<li>A notification is broadcast <code>NOTIFY_MXS_SHUTDOWN</code>.</li>\n\
<li>The COM bridge is uninitialized.</li>\n\
<li>The MAXScript interrupt checker thread is stopped. This is the thread that checks if the escape key is pressed during MAXScript execution.</li>\n\
<li>The MAXScript plug-ins (*.dlx files) are freed</li>\n\
</ol>\n\
</li>\n\
<li><p>The macro-recorder is turned off.</p>\n\
</li>\n\
<li><p>A notification is broadcast <code>NOTIFY_MXS_SHUTDOWN</code>.</p>\n\
</li>\n\
<li><p>The COM bridge is uninitialized.</p>\n\
</li>\n\
<li><p>The MAXScript interrupt checker thread is stopped. This is the thread that checks if the escape key is pressed during MAXScript execution.</p>\n\
</li>\n\
<li><p>The MAXScript plug-ins (*.dlx files) are freed</p>\n\
</li>\n\
<li><p>Each plug-in is shutdown through a call to <code>LibShutDown()</code>. This is where a plug-in should free any remaining allocated memory, and perform the final uninitialization steps.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";