var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"collections\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Collections</h1></div><p>3ds Max uses a template class called <code>Tab</code> (short for table) as a general purpose collection class.</p>\n\
<p><code>Tab</code> is a type-safe variable length array class which also supports list-like operations of insertion, appending and deleting. When using <code>Tab</code> note that the <code>Tab</code>&lt;&gt;:: Delete() method does not resize the storage: instead call<code>Tab</code>&lt;&gt;::Shrink().</p>\n\
<p>If you are going to do a sequence of calls to <code>Tab</code>&lt;&gt;::Append(), its more efficient to first call <code>Tab</code>&lt;&gt;::Resize() to make room for them.</p>\n\
<p>Beware when using the <code>Tab</code>&lt;&gt;::Addr() function that it returns a pointer which may be invalid after subsequent <code>Tab</code>&lt;&gt;::Insert(),<code>Tab</code>&lt;&gt;::Append(),<code>Tab</code>&lt;&gt;::Delete(),<code>Tab</code>&lt;&gt;::Resize(), or <code>Tab</code>&lt;&gt;::Shrink() operations.</p>\n\
<p>Using <code>Tab</code>&lt;&gt;::SetCount() implicitly calls <code>Tab</code>&lt;&gt;::Resize().</p>\n\
<p>The <code>Tab</code>&lt;&gt; template is not meant to support more than 2 billion items (specifically 2 147 483 648); if you need to have more items, consider using an STL container which does not have the 2 billion barrier and is most likely more optimized than this version.</p>\n\
<p>The implementation minimizes the storage of empty tables: they are represented by a single NULL pointer. Also, the major part of the code is generic, shared by different Tabs for different types of items.</p>\n\
<h2 id=\"important-note\">Important Note</h2><p>Do not use <code>Tab&amp;lt;&amp;gt;</code> with objects that have non-trivial constructors, copy constructors, or destructors. This is because <code>Tab</code>&lt;&gt; does not call constructors and destructors for items in the table, nor will it call the copy operator. So <code>Tab&amp;lt;BitArray&amp;gt;</code> and <code>Tab&amp;lt;MSTR&amp;gt;</code> are not acceptable, but <code>Tab&amp;lt;BitArray*&amp;gt;</code> or <code>Tab&amp;lt;Float&amp;gt;</code> is okay.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";