var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"comdcom_interface\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>COM/DCOM Interface</h1></div><p>The idea behind this COM (Component Object Model) object is to expose the core of 3ds Max so applications can invoke 3ds Max to generate images. The whole implementation of the COM interface was done as a plug-in itself so developers have the option of enhancing it in any manner they wish. Not just by adding interfaces to this object but also by creating entire new objects using this implementation as a code base. The code is extensively documented and the test &quot;Client Application&quot; is also extensively documented in a way where even developers who don&#39;t have any experience with COM objects can make use of it. For those with experience, the 3ds Max COM interface is implemented entirely using ATL which makes it very simple to add and/or modify any aspect of the code.</p>\n\
<p>COM Interfaces and their types are defined in an &quot;<code>IDL</code>&quot; file. They may be found in <em>\\MAXSDK\\SAMPLES\\GUP\\COMSRV\\COMSRV.IDL</em> .</p>\n\
<h2 id=\"registering-3ds-max-as-a-dcom-server\">Registering 3ds Max as a DCOM Server</h2><p>The following steps register 3ds Max as a DCOM server:</p>\n\
<p>1) Build  <em>\\MAXSDK\\SAMPLES\\UTILITIES\\COMSRV.VCPROJ</em>  and copy the resulting <code>COMSRVUI</code>.DLU to the 3ds Max PLUGINS directory.</p>\n\
<p>2) Start 3ds Max and go the Utility Panel. Choose More and pick COM/DCOM Server Control.</p>\n\
<p>3) If the button in the comand panel says &quot;Register&quot; then click it, or if it says &quot;Unregister&quot;, then do nothing (as 3ds Max is already registered).</p>\n\
<p>Now 3ds Max is registered as a DCOM server and an instance of it can be created from any COM client.</p>\n\
<p>It is also possible to register and unregister 3ds Max from the command line. There are two command line options that can be passed to 3ds Max:</p>\n\
<p><code>3DSMAX</code> -RegisterMAXRenderer</p>\n\
<p><code>3DSMAX</code> -UnregisterMAXRenderer</p>\n\
<h2 id=\"the-maxrenderer-interface\">The MaxRenderer Interface</h2><p>This is the main interface exported by this COM object. Through its methods you can load a 3ds Max scene, define the parameters for a resulting image, request 3ds Max to render any number of frames, collect the resulting images, and so on. The other interfaces defined are support interfaces used by the different methods of the 3ds Max Renderer Interface.</p>\n\
<h2 id=\"properties\">Properties</h2><p>These properties are the same ones found in the 3ds Max API. They are exposed here so applications can query or define the different attributes of a scene to be rendered.</p>\n\
<ul>\n\
<li><code>AnimationStart()</code> - Sets or returns the frame number defined as the starting frame for the current animation. The frame number argument is a float in order to isolate the foreign application from 3ds Max&#39; frame granularity. A 3ds Max frame can be divided into around 4096 time slices. In other words, it is possible to generate animation images with a 1/(30 * 4096) of a second resolution.</li>\n\
<li><code>AnimationEnd()</code> - Same as above but for the last frame of the current animation.</li>\n\
<li><code>RenderFieldRender()</code>- Defines (or gets the current state) if the rendered images will be field rendered.</li>\n\
<li><code>RenderColorCheck()</code> - Defines (or gets the current state) if the generated images will be checked for invalid colors.</li>\n\
<li><code>RenderSuperBlack()</code> - Defines (or gets the current state) how pure blacks are generated.</li>\n\
<li><code>RenderHidden()</code> - Defines (or gets the current state) if hidden objects are to be rendered.</li>\n\
<li><code>RenderForceTwoSide()</code> - Defines (or gets the current state) if both sides of an object are to be rendered. Usually, just the &quot;outside&quot; is rendered.</li>\n\
<li><code>RenderAtmosphere()</code> - Defines (or gets the current state) if atmospheric effects are to be rendered.</li>\n\
<li><code>RenderFieldOrder()</code> - Defines (or gets the current order) the order fields are rendered (if field rendering).</li>\n\
</ul>\n\
<h2 id=\"methods\">Methods</h2><p>These methods are a superset of the methods found in the 3ds Max API. They encapsulate some of the API functions (specifically those related to rendering) in order to simplify the process as well as to isolate the foreign applications from classes and data not exposed.</p>\n\
<ul>\n\
<li><code>LoadScene()</code> - Loads the given 3ds Max scene. Note that the location of the scene is from the perspective of the computer where the 3ds Max instance is being created. The use of physical drive letters should only be used if you know the scene file resides in the same computer. In doubt, use UNC path names.</li>\n\
<li><code>SaveScene()</code> - The counterpart of the above to save the given 3ds Max scene.</li>\n\
<li><code>ImportFile()</code> - Similar to <code>LoadScene()</code> but it deals with non 3ds Max files. This can be used to write a &quot;translator&quot; where scene files are imported and then saved as 3ds Max files.</li>\n\
<li><code>EnumCameras()</code> - Use this to enumerate all cameras defined in a scene. When you request 3ds Max to render a scene, one of the arguments you need to pass is the name of the camera to use. This method will return all cameras defined in the current scene. The returned names are collected through the _ImaxRendererEvents() interface defined below.</li>\n\
<li><code>OpenRenderer()</code> - Opens the renderer and prepares it to render. The first argument is the camera name to use. You can enumerate all cameras defined in a scene using the EnumCameras() methods described above. The pBif argument is a pointer to a ImaxBitmapInfo() interface (defined below). This object will define the parameters of the resulting image to be created. The last argument defines if the render will be a full image or just a region.</li>\n\
<li><code>SetRegion()</code> - If you are rendering just a region of the image, use this to define the region to be rendered. Given as an example a scene you want rendered at 640x480. If you want to render just the first quarter of the image, you would pass a rectangle starting at 0,0, 320 pixels wide, and 240 pixels high.</li>\n\
<li><code>RenderFrame()</code> - You&#39;ve loaded a scene, opened the renderer, now you want to render an image. Use this method to generate the image. The first argument defines the frame you want to render. The second defines the duration of the frame. Render progress is processed through the _ImaxRendererEvents() interface defined below. This method returns immediately. You keep track of the progress through the sink event defined above until you receive a OnRenderDone() event call.</li>\n\
<li><code>CancelRenderer()</code> - Cancels the rendering.</li>\n\
<li><code>CloseRenderer()</code> - When done, use this to close the renderer.</li>\n\
<li><code>GetLine()</code> - Use this method to collect the image you just rendered. The first argument defines the bitmap layout. You can collect the image in many different formats depending on what channels you requested to be rendered in the ImaxBitmapInfo() argument passed to OpenRenderer(). The second argument defines which line you want to collect. The third argument defines if you want the image to be linear or gamma processing should take place.</li>\n\
<li><code>GetPreviewLine()</code> - Used to collect sub-sampled lines used to maintain a preview of the render process as it is happening.</li>\n\
<li><code>ExecuteMAXScriptString()</code> - These are used if you need to request 3ds Max to do something and the method for doing this something is not exposed above, you could issue a 3ds Max Script command (or a whole 3ds Max Script file) in order to accomplish this &quot;something&quot; task. Note: These two calls are untested, and unfortunately, there is no error control.</li>\n\
</ul>\n\
<h2 id=\"the-_imaxrendererevents-sink-interface\">The _ImaxRendererEvents() sink interface</h2><p>Use this interface to receive notifications and events from 3ds Max.</p>\n\
<ul>\n\
<li><code>OnEnumCameras()</code> - When you issue a <code>ImaxRenderer::EnumCameras()</code>, <code>OnEnumCameras()</code> will be fired for every camera found in the scene.</li>\n\
<li><code>OnRenderProgress()</code> - This event will be fired during the render process to update the current progress of the render process.</li>\n\
<li><code>OnRenderMessage()</code> - This event will be fired with message updates describing the current stage of the render process.</li>\n\
<li><code>OnRenderDone()</code>- This event is fired when the render is complete.</li>\n\
</ul>\n\
<h2 id=\"the-maxbitmapinfo-interface\">The MaxBitmapInfo Interface</h2><p>This interface is used to define the characteristics of the resulting image generated by 3ds Max. There are only properties. The only one that might need explanation is the Channels() property. Use this to define what types of special channels you want generated. These are in addition to the standard RGBA channels.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";