var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"custom_file_streams\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Custom File Streams</h1></div><p>Arbitrary user data can be written to and read from 3ds Max scene files (or any other <a href=\"https://msdn.microsoft.com/en-us/library/windows/desktop/aa380369(v=vs.85).aspx\" target=\"_blank\">OLE Structure Storage-based files</a>) using the Custom File Stream API. </p>\n\
<p>Within 3ds Max, this API is used by <em>CustomFileStream.dlu</em> and implemented by <em>CustomFileStreamAPI.dll</em> source.  The source for these are in \n\
<em>maxsdk\\samples\\utilities\\CustomFileStream</em>.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p><strong></strong> These interfaces are also accessible by MAXScript. See the documentation for the <code>CustomFileStream</code> and <code>CustomFileStreamManager</code> interfaces.</p>\n\
\n\
</div></div>\n\
\n\
<p><em>CustomFileStreamAPI.dll</em> defines the low level file access methods that are used by CustomFileStream.dlu, and can be used by external applications \n\
to read, write, and modify the <code>CustomFileStream</code> as supported by the <code>CustomSceneStreamManager</code> and <code>CustomFileStream</code> interfaces. \n\
To use this dll, you would link against <em>CustomFileStreamAPI.lib</em> in <em>maxsdk\\libs</em>.  There are no dependencies by <em>CustomFileStreamAPI.dll</em> on other 3ds \n\
Max dlls. To see how these low level methods should be tied together, see the <em>CustomFileStream.dlu</em> source.</p>\n\
<p>This API will read and write CustomFileStream to 3ds Max scene files written by any version of 3ds Max. \n\
The <code>CustomSceneStreamManager</code> is required to persist the custom data streams across scene file load and save operations.\n\
<code>CustomFileStream</code> as supported by <code>CustomSceneStreamManager</code> and <code>CustomFileStream</code> are located in the CustomFileStream IStorage\n\
of the 3ds Max scene file main IStorage. </p>\n\
<p>Each stream consists of a header consisting of a 1 WORD version number and two 32 bit DWORD \n\
values (see <code>CustomFileStreamHeader</code>), followed by a non-null terminated wchar string or an array of null terminated wchar strings.\n\
The current version number is 1.</p>\n\
<p>The first 32 bit DWORD is considered private (flag bit usage defined by Autodesk) and the second is considered public (flag bit usage \n\
defined by the creator of the stream).</p>\n\
<p>Currently, bits 1 to 3 of the private DWORD are used.</p>\n\
<p><strong>Bit 1</strong> signifies that the stream is a persistent stream. When this bit is set, the <code>CustomSceneStreamManager</code> will write this stream to the scene file \n\
when the scene file is saved. This allows a <code>CustomFileStream</code> to be automatically persisted across a load/save operation.</p>\n\
<p><strong>Bit 2</strong> signifies that the stream is to be saved to the scene file when the scene file is saved, but the stream is not necessarily a persistent \n\
stream. This allows the user to add streams to <code>CustomSceneStreamManager</code>&#39;s cache and have those streams be written to the scene file. This bit is \n\
not persisted to the scene file, and is cleared when read from the scene file.</p>\n\
<p><strong>Bit 3</strong> signifies that the stream is not to be added to the <code>CustomSceneStreamManager</code>&#39;s cache when the scene file is loaded.\n\
If neither of the first 2 bits are set, <code>CustomSceneStreamManager</code> does not write this stream to the scene file when the scene file is saved.</p>\n\
<p>The content of the stream is considered to be an array of strings if the last character in the content is a null character (signifying\n\
an array of null terminated strings), otherwise the content is considered to be a single non-null terminated string.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";