var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"inverse_kinematics\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Inverse Kinematics</h1></div><p>The Inverse Kinematics (IK) API&#39;s are divided over three files: <code>IIKSys.h</code>, <code>IKSolver.h</code>, and <code>IKHierarchy.h</code>. IIKSys.h contains the interface definition of the two types of controllers, IIKControl and IIKChainControl. They are both TM controllers. The former is used in joints (nodes on which IK will be applied), and the latter is used in the IK goals (nodes that serve as IK goals).</p>\n\
<p>The <code>IKControl</code> and <code>IKChainControl</code> are knit together as the IK system. When an IK solution is called for, the IK system will invoke the IK solver, which is a mathematical algorithm that, given the goal position/orientation, and incidental parameters, produces a solution in terms of joint angles (rotation values of respective nodes). While the controllers involved in IK are not expandable via plugin, the IK solver is actually plug-able. The IK system will recognize a plug-in solver by putting it in the solver list wherever it appears.</p>\n\
<p>An interface pointer to the <code>IKControl</code> class can be obtained by using <code>Animatable::GetInterface()</code> with <code>I_IKCONTROL</code> as an argument.</p>\n\
<p>An example on using the IK API can be found in the 3ds Max SDK,  <em>\\MAXSDK\\SAMPLES\\IKSOLVERS\\IKLIMB</em> .</p>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li><p><code>IKChainActions</code></p>\n\
</li>\n\
<li><p><code>IKSolver</code></p>\n\
</li>\n\
<li><p><code>IIKChainControl</code></p>\n\
</li>\n\
<li><p><code>IIKControl</code></p>\n\
</li>\n\
<li><p><code>ZeroPlaneMap</code></p>\n\
</li>\n\
<li><p><code>RootLink</code></p>\n\
</li>\n\
<li><p><code>Link</code></p>\n\
</li>\n\
<li><p><code>LinkChain</code></p>\n\
</li>\n\
<li><p><code>Animatable</code></p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"inverse_kinematics/ik_concepts.html\">IK Concepts</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"inverse_kinematics/ik_solvers.html\">IK Solvers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"inverse_kinematics/iikchaincontrol.html\">IIKChainControl</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"inverse_kinematics/ik_system_interfaces.html\">IK System Interfaces</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";