var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"iikchaincontrol\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>IIKChainControl</h1></div><h2 id=\"reference-indices\">Reference Indices</h2><p>The following enum constants are indices to the reference targets made by the <code>IIKChainControl</code>. For example, <code>GetReference</code>(<code>IIKChainControl::kPBlockRef</code>) will return a pointer to <code>IParamBlock2</code>. These reference indices are:</p>\n\
<ul>\n\
<li><code>kPBlockRef</code> - The IparamBlock2 parameter block.</li>\n\
<li><code>kGoalTMRef</code> - A Matrix3 controller representing the sub-controller that defines the transformation matrix of this node</li>\n\
<li><code>kEndJointRefINode</code> - The INode reference for the End Joint.</li>\n\
<li><code>kEnableRef</code> - Bool (float) controller. This switch indicates when the IK chain is enabled or effective.</li>\n\
<li><code>kStartJointRef</code> - The INode reference for the Start Joint.</li>\n\
<li><code>kLastRef</code> - Place holder.</li>\n\
</ul>\n\
<h2 id=\"parameter-block-indices\">Parameter Block Indices</h2><p>There is just one parameter block. Its index to <code>Animatable::GetParamBlock()</code> is given by enum constant <code>kParamBlock</code>.</p>\n\
<h2 id=\"parameter-indices\">Parameter Indices</h2><p>The following enumerated constants represent the indices of the parameters in the parameter block:</p>\n\
<ul>\n\
<li><code>kStartJoint</code> INode, referenced by kStartJointRef</li>\n\
<li><code>kEndJoint</code> INode, referenced by kEndJointRef</li>\n\
<li><code>kSolverName</code> String, the solver name.</li>\n\
<li><code>kAutoEnable</code> BOOL, auto-enable.</li>\n\
<li><code>kSwivel</code> Angle, swivel angle.</li>\n\
<li><code>kPosThresh</code> Float, pos threshold.</li>\n\
<li><code>kRotThresh</code> Float, rot threshold.</li>\n\
<li><code>kIteration</code> Integer, iterations.</li>\n\
<li><code>kEEDisplay</code> BOOL, EE display.</li>\n\
<li><code>kEESize</code> Float, EE size.</li>\n\
<li><code>kGoalDisplay</code> BOOL, display goals.</li>\n\
<li><code>kGoalSize</code> Float, goal size.</li>\n\
<li><code>kVHDisplay</code> BOOL, VH display.</li>\n\
<li><code>kVHSize</code> Float, VH size.</li>\n\
<li><code>kVHLength</code> Float, VH length.</li>\n\
<li><code>kSolverDisplay</code> BOOL, display solvers.</li>\n\
<li><code>kAutoSnap</code> BOOL, auto snap.</li>\n\
<li><code>kVHUseTarget</code> BOOL, VH use target.</li>\n\
<li><code>kVHTarget</code> INode, VH target.</li>\n\
<li><code>kLastParam</code> Place holder.</li>\n\
</ul>\n\
<p>Most parameters have separate querying methods. For example;</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GetParamBlock( IIKChainControl::kParamBlock)&gt;GetINode( IIKChainControl::kStartJoint)</code></pre><p>will return turns the same pointer as does <code>StartJoint()</code>. The <code>kStartJoing</code> and <code>kEndJoint</code> parameters that define the IK Chain Delimiters can be obtained by using the <code>INode</code>* StartJoint() and <code>INode</code>* EndJoint() methods.</p>\n\
<h2 id=\"swivel-angles\">Swivel Angles</h2><p>Most of the time, joints are drawn on a plane (planar IK chains). A desirable quality of an IK solver is not to disturb this plane. Those solvers would use only the Start Joint to rotate the plane. When the End Joint is adhered to the goal, the rotation about the axis from the Start Joint to the End Joint is called Swivel. Swivel angle is the amount of this rotation.</p>\n\
<p>In order for the swivel angle to make sense, however, we need a reference point. When a chain is put at the preferred pose, meaning that all the joint angles are set to preferred angles, the plane expanded by the pivots of all the joints on the chain is called Initial Plane, and the axis from the Start Joint to End Joint is called Initial End Effector Axis (EEAxis). Since Preferred Angles are animation variable, so is the Initial Plane and EEAxis. The <code>InitPlane()</code> and <code>InitEEAxis()</code> methods return the normal to the Initial Plane and the unit vector of the Initial EEAxis. These are represented in the parent space of the Start Joint. To obtain the normal in object space, use the method <code>ChainNormal()</code>. The relationship between <code>ChainNormal()</code> and <code>InitPlane()</code> is (in pseudo code):</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">InitPlane() = ChainNormal() * StartJoint()-&gt;PrefRotation()</code></pre><p>When the joints do not lie on a plane, the closest plane, in certain sense, can be used. Let&apos;s call this plane the solver plane.</p>\n\
<p>The class <code>ZeroPlaneMap</code> is defined in <code>IKHierarchy</code>.h. This provides the functionality that, given a unit axis, which is to be substituted for by EE Axis, produces a unit vector, which will be interpreted as the normal to a plane. This plane will be taken as the zero plane to which the swivel angle is relative: the plane corresponds to swivel angle being zero. The amount of rotation that will bring the Zero Plane to the current solver plane is the Swivel Angle, which corresponds to the parameter of index <code>kSwivel</code> and can be obtained using the <code>SwivelAngle()</code> method. The following relationship holds (in pseudo code):</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">ChainNormal() * StartJoint()-&gt;Rotation() = ZeroPlaneMap(EEAxis) * &lt;Rotation aboutEEAxis bySwivelAngle()&gt;</code></pre><p>A plugin solver may have its own ZeroPlaneMap. In case it does not have a preference, it can use the default one provided by the IK system as <code>IKSys::ZeroPlaneMap</code>* DefaultZeroPlaneMap().</p>\n\
<p>The solver plane can be controlled by an extra node and this is often desired by the user. In this case, they want the solver plane to align with the plane defined by the Start Joint, the End Joint, and the extra node, called the swivel angle target. Since the target and the swivel angle are meant to control the same thing, only one of them can be used. The parameter of index <code>kVHUseTarget</code> determines which will be used. It is not animatable. If it is true, the swivel angle target will be used. The target node can be obtained from the parameter of index <code>kVHTarget</code>. When the target node is NULL, the swivel angle will be used.</p>\n\
<h2 id=\"solver-properties\">Solver Properties</h2><p>The method <code>IKSolver</code>* Solver() returns the IK solver whose responsibility it is to solve the IK problem. Its class name is stored as the parameter of index <code>kSolverName</code>. As mentioned, there is an animatable variable that determines, at a specific time, whether IK is enabled. Whether the solver is enabled or disabled can be checked using the <code>SolverEnabled()</code> method.</p>\n\
<p>This is just an interface to the sub-controller with reference index <code>kEnableRef</code>. Since its value is used to determine whether joints in an IK chain depend on the IK goal when reference message is received, developers should not replace it, using the 3ds Max Reference APIs, with an arbitrary controller whose dependency structure is general. This would create a time variable dependency structure and is not desirable. The built in controller is a key-frame controller.</p>\n\
<p>Sometimes, we still want to invoke IK by moving the goal even if <code>SolverEnabled()</code> is false. In such cases the purpose of IK is to set keys on the FK sub-controllers of the joints. The feature is called &quot;Use IK to FK&quot;, which is only meaningful during an interactive session. For this purpose <code>CanAutoEnabled()</code> corresponds to the parameter of index <code>kAutoEnable</code> and indicates whether the feature of &quot;Use IK to FK&quot; is desired. The <code>AutoEnableSet()</code> method provides the transient state of the IK chain: whether IK is currently enabled due to this feature. It is only set, if it is ever set, during the next update cycle, with regard to when the goal is moved, or its TM is set to new value.</p>\n\
<h2 id=\"valid-ik-chains\">Valid IK Chains</h2><p>A valid IK chain is one that has a good Solver, Start and End joints, where the Start Joint is an ancestor of the End Joint in the scene hierarchy. The <code>Valid()</code> and <code>INode</code>* GetNode() methods are available for this. The latter returns the node that holds it as its TM controller. The IK Chain Controller is not designed to be instanced. It is expected to have a unique node.</p>\n\
<p><code>LinkChain</code> - A LinkChain is a hierarchy of transformations. At the top is the <code>RootLink</code> and it is followed by a number of Link&apos;s . Each link, be it a <code>RootLink</code> or <code>Link</code>, evaluates to a matrix, called the link matrix (<code>LinkMatrix</code>). This matrix consists of two parts, one is a variable part (degrees of freedom) and the other is a relatively constant part, called rigid extend (<code>RigidExtend</code>). It can be graphically represented as:</p>\n\
<p><code>RootLink</code> - The link variable is a rotation, <code>rotXYZ</code>. The link matrix is defined as</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">RigidExtend * R x (rotXYZ.x) * R y (rotXYZ.y) * R z (rotXYZ.z)</code></pre><p>where <code>R x (.)</code> stands for rotation about the x-axis, etc.</p>\n\
<p><code>Link</code> - The variable part of a Link is of one degree of freedom. It can be translational or rotational. A typical 3 degrees of freedom (xyz) rotational joint can be decomposed into 3 Links, with the first two being null links:</p>\n\
<p><code>LinkChain</code> - A <code>LinkChain</code> consists of a <code>RootLink</code> and a number of Link&apos;s. The reason that the <code>LinkChain</code> can start with rotation, the variable part of the <code>RootLink</code>, is that the IK system will collapse all the node transformations from the root of the scene to the parent matrix of the Start Joint and the translation part of the Start Joint, called the parent matrix, and transform the node hierarchy of the IK chain into this space. The author of the plugin solver does not have to be concerned about <code>parentMatrix</code>. They work on the problem as it is rooted at the origin of the world. The data structure of <code>LinkChain</code> should be sufficient for those solvers that <code>DoesOneChainOnly()</code> and <code>UseSwivelAngle()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../inverse_kinematics.html\">Inverse Kinematics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";