var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"ik_system_interfaces\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>IK System Interfaces</h1></div><p>The IK system services two interfaces, one through the CORE, and the other through the IK Chain Controller class.</p>\n\
<p><code>IKCmdOps</code></p>\n\
<p>The interface ID is defined in <code>IIKSys.h</code> as <code>IK_FP_INTERFACE_ID</code> and is published through the CORE, i.e., to get a pointer to this interface, call <code>GetCOREInterface</code>(<code>IK_FP_INTERFACE_ID</code>).</p>\n\
<p>To create a new IK chain, use the method <code>CreateIKChain()</code>. Given two pointers, <code>start</code> and <code>end</code>, that are intended for the Start and End joints respectively, and the solver&apos;s name, <code>solver</code>, this method will create a node that has an <code>IKChainControl</code> as the TM controller. This method will return false and fail if: 1) <code>start</code> joint is not a proper ancestor of <code>end</code> joint in the scene graph; or 2) there is a node along the path from the start joint to the end joint whose TM controller is not an IK Control and is not replaceable, or 3) no IK solver is found with the given name.</p>\n\
<p><code>IKChainActions</code></p>\n\
<p>The interface ID is defined in <code>IIKsys.h</code> as <code>IKCHAIN_FP_INTERFACE_ID</code> and is published through the class <code>IKChainControl</code>, i.e., to get a pointer to this interface, call;</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GET_IKCHAIN_CD-&gt;GetInterface(IKCHAIN_FP_INTERFACE_ID)</code></pre><p>where <code>GET_IKCHAIN_CD</code> is a macro defined in the same file that produces a pointer to the class descriptor of class <code>IKChainControl</code>.</p>\n\
<p>This interface also publishes a number of actions. An action acts on the currently selected IK chain node. The following method returns TRUE if there is exactly one valid IK chain node selected: <code>IsSnapEnabled()</code>. The following methods execute snapping on the currently selected IK chain node: <code>SnapAction()</code> , <code>IKSnapAction()</code>, and <code>FKSnapAction()</code>. The first one does IK snapping if its Enabled is false and FK snapping if its Enabled is true. The next two will do IK snapping and FK snapping, respectively.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../inverse_kinematics.html\">Inverse Kinematics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";