var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"adding_the_roll-up_to_the_comman\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Adding the Roll-up to the Command Panel</h1></div><p>When the user may edit an object&apos;s parameters the rollup pages must be added to the command panel. This can be done using the <code>CreateCPParamMap()</code> function. This function creates a parameter map to handle the display of parameters in the command panel. Shown below are two samples from the sphere&apos;s <code>Animatable::BeginEditParams()</code> method.</p>\n\
<p>This first call to <code>CreateCPParamMap()</code> manages the variables of the Sphere Object (not the parameter block).</p>\n\
<p>The <code>CreateCPParamMap()</code> method takes several arguments. The first is the array of <code>ParamUIDescs</code>, one element for each control to be managed. The second is the number of items in this array. The third parameter is a pointer to the virtual array of parameters. The example below uses the <code>this</code> pointer of the sphere object to indicate which parameter array. The <code>this</code> pointer means the <code>SphereObject</code> itself is the <code>IParamArray</code> pointer (the <code>SphereObject</code> was derived from <code>IParamArray</code>). In this way, the parameter map may access the variables of the sphere object. The fourth parameter is the interface pointer passed into the <code>BeginEditParams()</code> method. The fifth parameter is the DLL instance handle of the plugin. The sixth parameter is the dialog template for the rollup page (created using the resource editor). The next parameter is the title displayed in the rollup page title bar. The final parameter is a set of flags to control settings of the rollup page. After this call finishes, the &quot;Creation Method&quot; rollup has been added to the command panel.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">pmapCreate = CreateCPParamMap(\n\
 descCreate,CREATEDESC_LENGH,\n\
 this,\n\
 ip,\n\
 hInstance,\n\
 MAKEINTRESOURCE(IDD_SPHEREPARAM1),\n\
 _T(&quot;Creation Method&quot;),\n\
 0);</code></pre><p>The example below is similar, however it uses the parameter block pointer <code>pblock</code> to indicate which virtual array to manage. The parameters in this case are all stored as part of the parameter block (the IParamBlock class is derived from IParamArray). After this call finishes, the &quot;Parameters&quot; rollup has been added to the command panel.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">pmapParam = CreateCPParamMap(\n\
 descParam,PARAMDESC_LENGH,\n\
 pblock,\n\
 ip,\n\
 hInstance,\n\
 MAKEINTRESOURCE(IDD_SPHEREPARAM2),\n\
 _T(&quot;Parameters&quot;),\n\
 0);\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";