var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"basic_concepts_of_parameter_maps\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Basic Concepts of Parameter Maps</h1></div><p>A parameter map can be considered as a table of parameter handlers. The parameter map provides the processing required to map the UI controls to the variables that these controls affect. The parameter map operates on an array of parameters. Each control is one element of the virtual array. Each roll-up page in the command panel is treated as its own virtual array.</p>\n\
<p>For processing parameter blocks, the parameter map manages everything. When a user operates the UI controls of the plug-in, the parameter map processes the messages sent by the controls and stores any values in the parameter block which need to be set.</p>\n\
<p>For processing other variables, the developer needs to provide a way for the parameter map to get and set an element of the virtual array. To do this, the developer assigns an integer index to each parameter. The developer also implements a set of <code>GetValue()</code> and <code>SetValue()</code> methods.</p>\n\
<p>The primary classes involving parameter maps the developer must be aware of:</p>\n\
<ul>\n\
<li><code>ParamUIDesc</code> - These are descriptors that define the properties of the UI control such as its type (spinner, radio button, check box, and so others), which resource ID it refers to (which control in the dialog template), and which index in the virtual array to use.</li>\n\
<li><code>ParamBlockDescID</code> - This class describes each parameter of a parameter block by its type (int, float, point, color), whether it can be animated or is constant, and an ID used to help manage backward compatibility of parameter blocks.</li>\n\
<li><code>IParamArray</code> - This is the base class from which parameter maps and parameter blocks are derived. This class represents a virtual array of parameters.</li>\n\
<li><code>IParamMap</code> - This class provides a set of methods to work with the parameter map, for example, retrieving a pointer to the parameter block used.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";