var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_the_parameter_block_and\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating the Parameter Block and Referencing It</h1></div><p>A parameter block 1 must be created from the parameter block descriptors (<code>ParamBlockDescID</code>). Items in the parameter block are referred to by index. The index is derived from the order in which the descriptors appear in the <code>ParamBlockDescID</code> array.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#define PB_RADIUS 0\n\
#define PB_SEGS 1\n\
#define PB_SMOOTH 2\n\
#define PB_HEMI 3\n\
#define PB_SQUASH 4\n\
#define PB_RECENTER 5\n\
static  ParamBlockDescID descVer1[] = {\n\
 { TYPE_FLOAT, NULL, TRUE, 0 }, // Radius\n\
 { TYPE_INT, NULL, TRUE, 1 }, // Segs\n\
 { TYPE_INT, NULL, TRUE, 2 }, // Smooth\n\
 { TYPE_FLOAT, NULL, TRUE, 3 }, // Hemi\n\
 { TYPE_INT, NULL, FALSE, 4 }, // Squash\n\
 { TYPE_INT, NULL, FALSE, 5 } }; // Recenter\n\
#define PBLOCK_LENGTH 6</code></pre><p>A reference is made to the parameter block as well. For more information on references see topic on <a href=\"./../../reference_system.html\">Reference System</a>. After the parameter block is created, default values are initialized. This is done using the <code>SetValue()</code> method of the parameter block. The developer must pass the index of the parameter, the time to set the value at, and the value to set.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">SphereObject::SphereObject()\n\
{\n\
    ReplaceReference(CreateParameterBlock(descVer1, PBLOCK_LENGTH, CURRENT_VERSION));\n\
    assert(pblock);\n\
    pblock-&gt;SetValue(PB_RADIUS,0,crtRadius);\n\
    pblock-&gt;SetValue(PB_SMOOTH,0,dlgSmooth);\n\
    pblock-&gt;SetValue(PB_SEGS,0,dlgSegments);\n\
    pblock-&gt;SetValue(PB_SQUASH,0,0);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";