var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"describing_the_controls\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Describing the Controls</h1></div><p>The developer must define the <code>ParamUIDesc</code> arrays to establish the properties of the UI controls such as their type (spinner, radio button, check box, etc.), which resource ID they refer to, and which index into the virtual array they use. Below is the <code>ParamUIDesc</code> array for the parameters roll-up page. It calls several overloaded constructors passing the values needed to describe the controls. See the <code>ParamUIDesc</code> Reference section for detailed information on the constructors.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static int squashIDs[] = {IDC_HEMI_CHOP,IDC_HEMI_SQUASH};\n\
static ParamUIDesc descParam[] = {\n\
 // Radius\n\
 ParamUIDesc(\n\
  PB_RADIUS, // Virtual array index\n\
  EDITTYPE_UNIVERSE, // Type of value to edit\n\
  IDC_RADIUS,IDC_RADSPINNER, // Resource IDs\n\
  MIN_RADIUS,MAX_RADIUS, // Upper and lower limits on the value\n\
  SPIN_AUTOSCALE), // Scale factor for up/down arrow clicks\n\
 // Segments\n\
 ParamUIDesc(\n\
  PB_SEGS,\n\
  EDITTYPE_INT,\n\
  IDC_SEGMENTS,IDC_SEGSPINNER,\n\
  (float)MIN_SEGMENTS,(float)MAX_SEGMENTS,\n\
  0.1f),\n\
 // Smooth\n\
 ParamUIDesc(PB_SMOOTH,TYPE_SINGLECHEKBOX,IDC_OBSMOOTH),\n\
 // Hemisphere\n\
 ParamUIDesc(\n\
  PB_HEMI,\n\
  EDITTYPE_FLOAT,\n\
  IDC_HEMISPHERE,IDC_HEMISPHERESPINNER,\n\
  0.0f,1.0f,\n\
  0.005f),\n\
 // Chop/squash\n\
 ParamUIDesc(PB_SQUASH,TYPE_RADIO,squashIDs,2),\n\
 // Recenter\n\
 ParamUIDesc(PB_RECENTER,TYPE_SINGLECHEKBOX,IDC_HEMI_RECENTER)\n\
 };\n\
#define PARAMDESC_LENGH 6</code></pre><p>A list of possible controls can be found in the topic <a href=\"./../../plug-ins/parameter_blocks/creating/parameter_specification_argument/parameter_ui_control_types.html\">Parameter UI Control Types</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";