var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"providing_a_name_and_dimension_f\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Providing a Name and Dimension for the Parameters</h1></div><p>The developer must provide a name for each parameter used in a parameter block. This name is needed because the animated parameters show up in the track view and must be labeled. The parameter block takes care of displaying them in the track view, but has no idea of the name for each one, it only knows them by index. The developer provides the name to display by implementing the method <code>GetParameterName()</code> and returning the name of the parameter whose index into the parameter block is passed.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TSTR SphereObject::GetParameterName(int pbIndex)\n\
 {\n\
 switch (pbIndex) {\n\
  casePB_RADIUS:\n\
   return TSTR(_T(&quot;Radius&quot;));\n\
  casePB_HEMI:\n\
   return TSTR(_T(&quot;Hemisphere&quot;));\n\
  casePB_SEGS:\n\
   return TSTR(_T(&quot;Segments&quot;));\n\
  casePB_SMOOTH:\n\
   return TSTR(_T(&quot;Smooth&quot;));\n\
  default:\n\
   return TSTR(_T(&quot;&quot;));\n\
  }\n\
 }</code></pre><p>The developer must provide a dimension for each parameter used in a parameter block. This dimension is basically the type and magnitude of the value stored in the parameter block. Pre-defined constants are used as the return values. For more information, see the Reference section on <code>ParamDimension</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">ParamDimension *SphereObject::GetParameterDim(int pbIndex)\n\
 {\n\
 switch (pbIndex) {\n\
  casePB_RADIUS:\n\
   return stdWorldDim;\n\
  casePB_HEMI:\n\
   return stdNormalizedDim;\n\
  casePB_SEGS:\n\
   return stdSegmentsDim;\n\
  casePB_SMOOTH:\n\
   return stdNormalizedDim;\n\
  default:\n\
   return defaultDim;\n\
  }\n\
 }\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";