var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"setting_up_the_parameter_block\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Setting Up the Parameter Block</h1></div><p>Several of the controls used allow animated values. For example, the radius, and segments parameters may be animated. The developer uses a parameter block to store these values. The developer must define the parameter block descriptor which describes the properties of each parameter.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class  ParamBlockDescID {\n\
 public:\n\
  ParamType type;\n\
  UserType *user;\n\
  BOOLanimatable;\n\
  DWORDid;\n\
 };</code></pre><p>This class is initialized by passing four values per parameter. These values are:</p>\n\
<ol>\n\
<li><p><code>ParamType</code> type - The Parameter Type - The following are the types which may be used:</p>\n\
</li>\n\
<li><ul>\n\
<li><code>TYPE_INT</code> - Integers values.</li>\n\
<li><code>TYPE_FLOAT</code> - Floating point values.</li>\n\
<li><code>TYPE_POINT3</code> - Point values.</li>\n\
<li><code>TYPE_RGBA</code> - Color values - Red, Green, and Blue.</li>\n\
<li><code>TYPE_BOOL</code> - Boolean values.</li>\n\
</ul>\n\
</li>\n\
<li><p><code>TYPE_INT</code> - Integers values.</p>\n\
</li>\n\
<li><p><code>TYPE_FLOAT</code> - Floating point values.</p>\n\
</li>\n\
<li><p><code>TYPE_POINT3</code> - Point values.</p>\n\
</li>\n\
<li><p><code>TYPE_RGBA</code> - Color values - Red, Green, and Blue.</p>\n\
</li>\n\
<li><p><code>TYPE_BOOL</code> - Boolean values.</p>\n\
</li>\n\
<li><p><code>UserType* user</code> - This value is NOT USED - it must always be passed as NULL.</p>\n\
</li>\n\
<li><p><code>BOOL</code> animatable - This is a flag indicating if the parameter may be animated or not. Pass TRUE if the value may be animated and FALSE if just a constant value should be stored.</p>\n\
</li>\n\
<li><p><code>DWORD</code> id - This is an ID assigned to each parameter. This is used for backwards compatibility if you change the parameter block structure in the future. There is a mechanism that allows older format parameter blocks to be converted to a newer format using these IDs to match corresponding parameters between the new and old format. This is described below under Backwards Compatibility.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_maps.html\">Parameter Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";