var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"post-load_callbacks\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Post-Load Callbacks</h1></div><p>A post-load callback is a function object derived from <code>PostLoadCallback</code>. Post-load callbacks are used for any processing that must happen immediately after loading, for example when upgrading parameter block versions, or from parameter block 1 to parameter block 2. A post-load callback is registered with the 3ds Max file loading system through a call to <code>ILoad::RegisterPostLoadCallback()</code>.</p>\n\
<p>Post-load callback can also be useful to do processing with references during the loading process. This is because in a plug-in&#39;s implementation of its <code>ReferenceMaker::Load ()</code> method, the references are not in place yet. The references are not in place until everything in the 3ds Max file is loaded. The callback is called after all loading is complete. Inside the callback the plug-in&#39;s references will be in place and they may be processed by the plug-in.</p>\n\
<h2 id=\"important-note-regarding-3ds-max-stability\">Important Note Regarding 3ds Max Stability</h2><p>If a scene evaluation is performed in a post-load callback, it is possible that other objects aren&#39;t sufficiently initialized to be evaluated. When implementing a post-load callback (i.e. a class derived from <code>PostLoadCallBack</code>) there are two considerations to assure 3ds Max stability during scene file loads:</p>\n\
<ol>\n\
<li>Your object must be safe to evaluate if it is evaluated before your post-load callback is run.</li>\n\
<li>You should not do a scene/node evaluation (e.g. perform no changes to a scene hierarchy) in a high priority post-load callback . This means that no changes to the scene hierarchy should occur in a post-load callback with a priority less than 7. The priority of the callback can be retrieved using the member function <code>PostLoadCallBack::Priority()</code>.</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../miscellaneous_topics.html\">Miscellaneous Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";