var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modeling\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modeling</h1></div><p>In 3ds Max there are two levels of editing and creation of objects.</p>\n\
<ul>\n\
<li>Base Object Editing - This is the editing of the object at its most basic representation level. The following editable representations are available, with a list of the representative objects.<ul>\n\
<li>Triangles - The primary class for working with triangular meshes is <code>Mesh</code>. The <code>TriObject</code> class represent the data that flows through the geometry pipeline.</li>\n\
<li>Polygons - The primary classes for working with polygon meshes is <code>MNMesh</code>. The <code>PolyObject</code> class objects are what actually flow through the geometry pipeline. The <code>EPoly</code> class provides an editable interface to <code>PolyObject</code>.</li>\n\
<li>Patches - The <code>PatchMesh</code> is the primary class for working with patch meshes. Internally a <code>PatchMesh</code> is converted to a Mesh, so a <code>PatchMesh</code> flows down the pipeline as a collection of <code>TriObject</code>s.</li>\n\
<li>Splines - A <code>SplineShape</code> is made up of <code>Spline3d</code> objects. Some modifiers can act on spline shapes.</li>\n\
<li>NURBS - A <code>NURBSObject</code> can be one of several kinds of NURBS types such as <code>NURBSPoint</code>, <code>NURBSCurve</code>, and <code>NURBSSurface</code>. Some modifiers can act on generic NURBS objects.</li>\n\
</ul>\n\
</li>\n\
<li>Stack-based Editing - A base object can also be edited through the application of a stack of modifiers. This mechanism of editing objects, can also be used in conjunction with base object editing, by converting to an editable base object representation as a stage in the stack. Each modifier in the stack declares which kind of object it can edit in its <code>Modifier::InputType()</code> method.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/geometric_objects.html\">Geometric Objects</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/geometry_pipeline_system.html\">Geometry Pipeline System</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/modifiers.html\">Modifiers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/meshes.html\">Meshes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/transformation_and_rotation.html\">Transformation and Rotation</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/shapes_and_splines.html\">Shapes and Splines</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/patches_and_faces.html\">Patches and Faces</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"modeling/working_with_nurbs.html\">Working with NURBS</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_sdk_features.html\">3ds Max SDK Features</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";