var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"how_objects_are_drawn_in_the_vie\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>How Objects are Drawn in the Viewport</h1></div><p>The following steps describe how a simple object is drawn in the viewport.</p>\n\
<ol>\n\
<li>The object&apos;s drawing code is in its override <code>BaseObject::Display()</code> method. An <code>INode</code> and a <code>ViewExp</code> are passed into this method.</li>\n\
<li>The implementation of <code>BaseObject::Display()</code> calls <code>INode::GetObjectTM()</code>. This method returns the matrix that is used to transform the points of the object from object space to world space.</li>\n\
<li>The <code>BaseObject::Display()</code> method then takes the matrix returned from <code>INode::GetObjectTM()</code> and sets it into the graphics window (using <code>GraphicsWindow::setTransform()</code>). In this way, when the object starts drawing points in object space, they will be transformed with this matrix. This puts them into world space as they are drawn.</li>\n\
</ol>\n\
<p>Below is the code from the <code>SimpleObject</code> implementation of <code>BaseObject::Display()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int  SimpleObject::Display(TimeValue t,\n\
         INode* inode,\n\
         ViewExp *vpt,\n\
         int flags)\n\
{\n\
   if (!OKtoDisplay(t)) return 0;\n\
   GraphicsWindow *gw = vpt-&gt;getGW();\n\
   Matrix3 mat = inode-&gt;GetObjectTM(t);\n\
   UpdateMesh(t); // UpdateMesh just calls BuildMesh() if req&apos;d at time t.\n\
\n\
   gw-&gt;setTransform(mat);\n\
   mesh.render( gw, inode-&gt;Mtls(),\n\
         (flags&amp;USE_DAMAGE_RECT) ? &amp;vpt-&gt;GetDammageRect() : NULL, COMP_ALL,\n\
         inode-&gt;NumMtls());\n\
   return(0);\n\
}\n\
\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../geometric_objects.html\">Geometric Objects</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";