var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"geometry_pipeline_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Geometry Pipeline System</h1></div><p>3ds Max uses a system called a pipeline to manage the transformation of scene objects by processing objects called modifiers. Each <code>INode</code> in a scene graph has its own pipeline. The input of a pipeline is called the base object (an object that inherits from <code>Object</code>) and the output is called the derived object. If there are modifiers in the pipeline the output object will inherit from <code>DerivedObject</code> otherwise it will be the same object as was input into the pipeline.</p>\n\
<p>A modifier transforms an object or mesh, by applying a transform on a representation of an object&#39;s state. In the 3ds Max user interface the pipeline is graphically represented by a modifier stack. The pipeline takes an initial object or mesh (called the base object) and applies each modifier in the stack in order from the bottom of the modifier stack to the top. The output of the pipeline is a representation of the object in world space which is rendered in the 3D viewports.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/pipeline_overview.html\">Pipeline Overview</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/pipeline_terminology.html\">Pipeline Terminology</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/object_state.html\">Object State</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/object_state_transformation_matr.html\">Object State Transformation Matrix</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/viewport_rendering_and_the_pipel.html\">Viewport Rendering and the Pipeline</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/pipeline_optimizations.html\">Pipeline Optimizations</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/objects_flowing_through_the_pipe.html\">Objects Flowing through the Pipeline</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/object_space_and_world_space.html\">Object Space and World Space</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/cache_system.html\">Cache System</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/cache_validity_intervals.html\">Cache Validity Intervals</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/object_locking.html\">Object Locking</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/world_space_modifiers_and_object.html\">World Space Modifiers and Object Transformations</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"geometry_pipeline_system/channels.html\">Channels</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../modeling.html\">Modeling</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";