var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"channels\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Channels</h1></div><p>A channels represents a subset of an object&#39;s properties. This is used to optimize processing performed by the geometry pipeline system by minimizing the amount of processing that must be performed by each modifier.</p>\n\
<p>For example, there is a separate channel for the vertices of the object. If a modifier affects only the vertices, the system has considerably less work to do than if it had to reevaluate the entire state of the object including its face structure, UV coordinates, material assignments, etc. The Bend modifier is an example of a modifier that affects only the vertices (geometry) of an object; other channels do not require evaluation when the Bend modifier modifies vertices.</p>\n\
<p>There are separate object channels for:</p>\n\
<ul>\n\
<li><code>GEOM_CHANNEL</code> - The geometry channel, for vertex modification.</li>\n\
<li><code>TOPO_CHANNEL</code> - The topology channel, for the face or polygon structures.</li>\n\
<li><code>GEOM_CHANNEL</code> - The vertices of the object.</li>\n\
<li><code>TEXMAP_CHANNEL</code> - The texture vertices and procedural mappings.</li>\n\
<li><code>SELECT_CHANNEL</code> - The sub-object selection channel.</li>\n\
<li><code>SUBSEL_TYPE_CHANNEL</code> - The current level of selection.</li>\n\
<li><code>DISP_ATTRIB_CHANNEL</code> - Display attributes channel. The miscellaneous bits controlling the item&#39;s display.</li>\n\
<li><code>VERTCOLOR_CHANNEL</code> - The color per vertex channel.</li>\n\
<li><code>DISP_APPROX_CHANNEL</code> - Displacement approximation.</li>\n\
<li><code>EXTENSION_CHANNEL</code> - The channel used by extension channel objects.</li>\n\
<li><code>TM_CHANNEL</code> - The <code>ObjectState</code> transformation matrix that flows down the pipeline.</li>\n\
</ul>\n\
<p>Each object defines the meaning of the channels. The three main channels (those that get allocated dynamically) are the <code>GEOM_CHANNEL</code>, <code>TOPO_CHANNEL</code>, and the <code>TEXMAP_CHANNEL</code>.</p>\n\
<p>For example in a <code>TriObject</code> the <code>GEOM_CHANNEL</code> to mean the points or vertices of the mesh. The <code>TriObject</code> also defines the <code>TOPO_CHANNEL</code> to mean the face or polygon structures. This includes the smoothing groups and materials as well. For a <code>SplineShape</code> the <code>TOPO_CHANNEL</code> is undefined. This is because a <code>SplineShape</code> is essentially just an array of points and has no topology.</p>\n\
<p>Individual caches can be constructed for different channels at different points along the pipeline. So for example, if the texture coordinate portion of the pipeline changes, and the geometric portion of the pipeline is cached, the geometry portion won&#39;t need to be reevaluated. This means that modifiers that only depend on geometry may not need to be reevaluated.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"channels/channel_locking.html\">Channel Locking</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"channels/channel_copying.html\">Channel Copying</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"channels/preparing_channels_for_modificat.html\">Preparing Channels for Modification</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../geometry_pipeline_system.html\">Geometry Pipeline System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";