var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"channel_copying\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Channel Copying</h1></div><p>When an object flows through the geometry pipeline a shallow copy is made of the object, also called the shell. This shallow copy contains a full copy of modified channels and a shallow copy of unmodified channels, in order to optimize the memory footprint and performance.</p>\n\
<p>The geometry pipeline calls <code>Object::MakeShallowCopy()</code> to make a shallow copy of the object. This method specifies the channels that must be shallow copied, the other channels will be deep copied. A typical implementation of <code>Object::MakeShallowCopy()</code> will call <code>Object::ShallowCopy()</code> on the newly created object shell, to perform the actual copy of the pointers.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Object* TriObject::MakeShallowCopy(ChannelMask channels) {\n\
  TriObject* newob = CreateNewTriObject();\n\
  newob-&gt;ShallowCopy(this, channels);\n\
  return newob;\n\
}</code></pre><p>Some channels are always present in the shallow copy. For example the <code>SUBSEL_TYPE_CHANNEL</code>, <code>SELECT_CHANNEL</code> and <code>DISP_ATTRIB_CHANNEL</code> state channel are each just a single value. These are not allocated or de-allocated dynamically, and are always present. Other channels like the <code>GEOM_CHANNEL</code>, <code>TOPO_CHANNEL</code>, and <code>TEXMAP_CHANNEL</code> are allocated dynamically so the system tries to not have extra copies of them when possible.</p>\n\
<p>A deep copy (clone) of channels is requested by the pipeline by calling the plug-in implemented method <code>Object::NewAndCopyChannels()</code>. The pipeline will not call this method for unlocked channels.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../channels.html\">Channels</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";