var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"channel_locking\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Channel Locking</h1></div><p>Certain channels within an object can be locked instead of the whole object itself. For example, once a modifier is applied it may have the geometry channel cached (such as an array of vertices cached somewhere in the pipeline). When the system is evaluating this pipeline, if a certain channel it requires is cached, instead of evaluating the rest of the pipeline, it will use the cache. It will do a shallow copy of the cached channel into the object going down the pipeline. This is just copying the pointer to the cached channel into the object flowing down the pipeline. So essentially there are two <code>TriObject</code>s whose geometry channels are both pointing to the same array of vertices. This reduces the memory overhead required because instead of copying the whole array of vertices two meshes share the same memory. 3ds Max takes care of all of this, keeping track of who owns what so nothing is deleted twice or deleted when in use.</p>\n\
<p>The channel lock methods below deal with this system. These methods are implemented and called by the system and not the plugin object. They simply manipulate a private data member inside the <code>Object</code> class.</p>\n\
<ul>\n\
<li><code>Object::LockChannels()</code> - Locks the specified channels of the object.</li>\n\
<li><code>Object::UnlockChannels()</code> - Unlocks the specified channels of the object.</li>\n\
<li><code>Object::GetChannelLocks()</code> - Returns the locked status of the channels. There are two versions of this method in the <code>Object</code> reference. One returns all locked channels, the other accepts a <code>ChannelMask</code> argument.</li>\n\
<li><code>Object::SetChannelLocks()</code> - Sets the locked status of the object&#39;s channels.</li>\n\
</ul>\n\
<p>If a channel is locked, this means that the object does not own the channel and it should not free it. If the channel is unlocked, this means the object does own it, and may free it. A channel that is locked should also not be modified. For example, if a channel that was cached upstream in the pipeline was modified, the cached version would not be correct anymore. The locking of the cached channel prevents this modification from happening.</p>\n\
<p>The <code>ChannelMask</code> used in the above methods is an unsigned long. Each channel is represented by a bit.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> Developers must not get confused between channel numbers (<code>TOPO_CHAN_NUM</code>, <code>GEOM_CHAN_NUM</code>, etc.) and channel bits (<code>TOPO_CHANNEL</code>, <code>GEOM_CHANNEL</code>, etc.). Some methods refer to the channel by number and some by bit. Developers must not confuse these two as the compiler will not catch this as an error.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../channels.html\">Channels</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";