var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"object_locking\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Object Locking</h1></div><p>3ds Max uses a set of &#39;locks&#39; that indicate when it is not okay to free memory or modify the objects. The object lock and channel lock methods are both implemented and called by the system. The plug-in developer implements methods to maintain validity intervals for the channels, create new copies of channels as needed, and free the memory associated with channels that are no longer needed. Again, the main purpose of this is to minimize the overhead of the object flowing down the pipeline.</p>\n\
<p>The following methods from class <code>Object</code> for object locking and unlocking are implemented and called by the system:</p>\n\
<ul>\n\
<li><code>Object::LockObject</code>() - This method locks the object as a whole.</li>\n\
<li><code>Object::UnlockObject</code>() - This method unlocks the object as a whole.</li>\n\
<li><code>Object::IsObjectLocked</code>() - Returns nonzero if the object is locked; otherwise 0.</li>\n\
</ul>\n\
<p>If an object in the pipeline is locked, then it cannot be deleted by the system but only by whoever locked it. For example, a sphere in the pipeline will be locked. This is because it exists in the scene and must not be deleted. If a bend modifier was applied to the sphere, then the sphere would convert itself to a <code>TriObject</code>. This <code>TriObject</code> is flowing down the pipeline and is just a temporary object. This object will be unlocked meaning that it may be deleted. This is true unless the system decides to cache it. In this case it will become locked because the system has taken ownership of it and therefore it should not be deleted. Note that these methods are implemented and called by the system and not the plug-in object. They simply manipulate a private data member inside the <code>Object</code> class.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../geometry_pipeline_system.html\">Geometry Pipeline System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";