var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"object_state_transformation_matr\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Object State Transformation Matrix</h1></div><p>An <code>ObjectState</code> object maintains a transformation matrix as it flows up the pipeline. This matrix starts as the identity matrix. The following steps describe what happens to an object state transformation matrix as it flows through the pipeline.</p>\n\
<ul>\n\
<li>Object space modifiers are applied to the transformation matrix if the object flowing through the pipeline has no points to deform (i.e. is not deformable) such as a camera. In most cases no modifiers are applied.</li>\n\
<li>The node&#39;s transform controller object offset transformation matrix and node transformation matrix is applied to the object state matrix. First the node&#39;s object offset matrix is multiplied by the node transformation matrix. The resulting matrix is then multiplied to the object state transformation matrix, and stored back in to the <code>ObjectState</code> matrix.</li>\n\
<li>When a world space modifier is applied to a deformable object, the <code>ObjectState</code> matrix is applied to an object&#39;s points. This transforms the object from object space to world space. When this happens the <code>ObjectState</code> matrix is reset to the identity matrix. The world space modifier is also applied to the object state transformation matrix when the object is non-deformable such as a camera.</li>\n\
<li>Note that world space modifiers have their own nodes, with their own object transformation matrices. The object transformation matrix of a world space modifier is used to make sure that the modifier is applied in the correct space.</li>\n\
<li>The node maintains the resultant <code>ObjectState</code> to serve as the world space cache.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../geometry_pipeline_system.html\">Geometry Pipeline System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";