var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"degenerate_faces\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Degenerate Faces</h1></div><p>A <em>degenerate face</em> is a face with two vertex indices that are identical, and therefore no geometric area, and no normal . Some applications consider degenerate faces illegal, and do not allow them to be created or imported. 3ds Max allows them to be created in <code>Mesh</code> objects, but they are generally discouraged. They cannot be created in <code>MNMesh</code> objects. Some native geometric shapes, such as the teapot, contain degenerate faces when converted to an Editable Mesh.</p>\n\
<p>Degenerate faces will cause a hard edge on smoothed meshes, and this is the one legitimate case for creating them. Many importers for 3ds Max, from both Autodesk and third parties, may create meshes that contain degenerate faces and other &quot;unfriendly&quot; geometry. Your plugin code should be careful when dealing with meshes that are imported. There are no native <code>Mesh</code> methods that create degenerate faces inadvertently; you must explicitly create duplicate vertices. The <code>Mesh</code> copy and clone methods do not check for degenerate faces.</p>\n\
<p>There are some things to consider when writing algorithms that deal with <code>Mesh</code> objects that might contain degenerate faces. Some APIs do not account for degenerate faces; for example, <code>AdjFaceList</code> will report incorrect results if the mesh contains them. You should also be careful when walking an edge from vertex to vertex, as degenerate faces can cause a circular loop. This is because if you hit a degenerate face, you will have an edge that looks like this: A &lt;-- -- --&gt;A. Always check that you are walking forward, and never assume you are working with valid geometry. Similarly, tessellation algorithms or any code that divides faces should check for degenerate faces and skip them, or clear all degenerate faces on the mesh to begin with, as dividing degenerate faces has no effect and is a performance overhead. The <code>Mesh.RemoveDegenerateFaces()</code> method provides an easy way to do this.</p>\n\
<p>See the UVUnwrap sample ( <em>maxsdk/samples/modifiers/uvwunwrap/MeshTopData.cpp</em> ) for an example of detecting and dealing with degenerate faces.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../meshes.html\">Meshes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";