var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"mesh_stripping\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Mesh Stripping</h1></div><p>Stripping is the process of taking a mesh and turning it into all set of strips as shown below. Without stripping, when a triangle mesh is sent down the graphics display pipeline, three vertices plus three normals or colors must be sent for each triangle. However, in some cases triangles occur in a &#39;strip&#39;, where one triangle points up, the next points down, then the next up, etc. forming parallel lines along the top and bottom.</p>\n\
<p><img src=\"./images/GUID-7BB900D2-B6D0-41FA-B090-06EEC6EA90FC-low.gif\" alt=\"\"></p>\n\
<p>In this case all that needs to be transmitted along the pipeline is one triangle plus one vertex per additional triangle. Since the communication between the CPU and the graphics card is one of the bottlenecks in the graphics pipeline this results in a significant speed increase.</p>\n\
<p>This can only happen if 3ds Max knows that each new triangle is adjoining the previous one. Stripping then, is the process of taking whatever configuration the mesh is in originally, and turning it into a sequence of sequence of vertices that all correspond to strips as shown above. This speeds up the display process dramatically.</p>\n\
<p>Developers who create their own mesh objects for display need to be aware of two new methods for dealing with stripping if maximum speed is to be achieved. These method are <code>Mesh::BuildStrips()</code> and <code>Mesh::BuildStripsAndEdges()</code>. These builds the strip (and edge) databases inside the mesh. The standard 3ds Max primitives call <code>BuildStripsAndEdges()</code> after creating their meshes for instance.</p>\n\
<p>Changes have been made to the 3ds Max geometry pipeline that make this important. In 3ds Max 1.x, an algorithm was used to build the edge database when the mesh was about to be displayed. So for example, if a mesh was built, and some modifiers acted upon it, for instance a Bend, the geometry pipeline would be evaluated and then the when the object was about to be displayed its edge list would be built. If the modifers were animated (say the Bend angle changed), the geometry pipeline would be evaluated and the edge list would be built again. This was very inefficient because the edge list would only get used for one display, and then would be thrown out, and then calculated again. Since a Bend modifier doesn&#39;t alter the mesh topology the edge list was actually still valid.</p>\n\
<p>In 3ds Max 2.0 this changed. The edge and new strip topology flows down the pipeline. In this way, if a primitive builds its own edges and strips by calling <code>BuildStripsAndEdges()</code>, when animated modifiers are applied the display is dramatically faster. This is because the strip and edge database is never rebuilt unless the topology changes. Therefore when a developer creates a mesh to be displayed they should call <code>BuildStripsAndEdges()</code>. If this is not done, they won&#39;t be available to flow down the pipeline, and must be build automatically at the end of the pipeline.</p>\n\
<p>If a developer knows that their strips are invalid, for example they&#39;ve deleted a vertex or face, or otherwise changed the topology of the mesh, then the method <code>InvalidateStrips()</code> and <code>InvalidateEdgeList()</code> should be called. A developer could also call <code>InvalidateTopologyCache()</code> which simply calls both of the above.</p>\n\
<p>However, if a modifier is written that changes topology (<code>ChannelsChanged()</code> includes <code>TOPO_CHANNEL</code>), for example with the Bomb modifier, then the invalidation happens automatically. Other objects or modifiers may have to make an explicit call to <code>InvalidateTopologyCache()</code>. For example, the Editable Mesh Object or the Edit Mesh Modifier can operate on a mesh at the push and pull vertex level rather than at the pipeline level. In these cases the mesh is being directly modified and thus the invalidate call is required.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../meshes.html\">Meshes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";