var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"mnmesh_edges\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>MNMesh Edges</h1></div><p><code>MNMesh</code> like the regular <code>Mesh</code> class has no edge data members. Edge selection and visibility data must initially be stored in the <code>MNFace</code> members. Before a call to <code>MNMesh::FillInMesh()</code> there are no <code>MNEdge</code>s to store them in. There are a number of methods in the library (and many more the developer could design) which would invalidate the topological data, rendering the <code>MNEdge</code> list invalid. Also, eventually, we&apos;re going to want to convert each <code>MNMesh</code> back into a regular mesh using the <code>MNMesh::OutToTri()</code> method, so it&apos;s convenient to store edge selection and visibility information in the faces for this purpose.</p>\n\
<p>Thus, although the <code>MNEdge</code>scontain <code>MN_SEL</code> and <code>MN_EDGE_INVIS</code> flags, the more fundamental location for this data is in the <code>MNFace</code>s using that edge. When altering an <code>MNMesh</code> to make edges visible or invisible, or to change their selection status, be sure to make the changes in the <code>MNFace</code>s using the edge, otherwise the information can be easily overwritten, and generally won&apos;t get passed to the output mesh.</p>\n\
<p>The methods <code>MNMesh::SetEdgeVis()</code> and <code>MNMesh::SetEdgeSel()</code> are the best way to do this, as they also set the <code>visedg</code> state of the faces on either side. You can also set the face&apos;s <code>visedg</code> state directly (as shown below).</p>\n\
<p>The following demonstrates how to make an edge visible and selected:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void MakeEdgeVisAndSel(MNMesh &amp; mm, int ee)\n\
{\n\
   assert(mm.GetFlag(MN_MESH_FILLED_IN));\n\
   MNEdge *me = mm.E(ee);\n\
   MNFace *mf1 = mm.F(me-&gt;f1);\n\
   MNFace *mf2 =(me-&gt;f2&gt;-1) ? mm.F(me-&gt;f2) : NULL;\n\
\n\
   // Change the edge as desired\n\
   me-&gt;ClearFlag(MN_EDGE_INVIS | MN_EDGE_HALF_INVIS);\n\
   me-&gt;SetFlag(MN_SEL);\n\
\n\
   // Make the corresponding changes in face 1\n\
   inti;\n\
   i = mf1-&gt;EdgeIndex(ee);\n\
   mf1-&gt;visedg.Set(i);\n\
   mf1-&gt;edgsel.Set(i);\n\
\n\
   // Make the corresponding changes in face 2\n\
   if(mf2)\n\
   {\n\
     i = mf2-&gt;EdgeIndex(ee);\n\
     mf2-&gt;visedg.Set(i);\n\
     mf2-&gt;edgsel.Set(i);\n\
   }\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../meshes.html\">Meshes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";