var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"retrieving_mesh_strip_data\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Retrieving Mesh Strip Data</h1></div><p>The mesh strip data is accessible through the <code>Mesh::strips</code> member variable. This is declared as a <code>StripTab</code> which is a <code>Tab</code>&lt;&gt; collection of <code>Strip</code> pointers.</p>\n\
<p>The data is maintained as an array of indexes into the main mesh data of the vertex, normals and texture coordinates each being its own DWORD tab. If you are writing hardware shaders then the graphics layer will pass this information in the form of a <code>MeshData</code> pointer</p>\n\
<p>The following code can be used to extract the mesh strip data:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Utility function to give us the TriObject\n\
TriObject* GetTriObjectFromNode(INode *node, TimeValue t,\n\
    int &amp;deleteIt)\n\
{\n\
    deleteIt = FALSE;\n\
    Object *obj = node-&gt;EvalWorldState(t).obj;\n\
    if (obj-&gt;CanConvertToType(Class_ID(TRIOBJ_CLASS_ID,\n\
        0))) {\n\
        TriObject *tri = (TriObject *) obj-&gt;\n\
        ConvertToType(t, Class_ID(TRIOBJ_CLASS_ID, 0));\n\
\n\
        // Note that the TriObject should only be deleted\n\
        // if the pointer to it is not equal to the object\n\
        // pointer that called ConvertToType()\n\
        if (obj != tri) deleteIt = TRUE;\n\
             return tri;\n\
        }\n\
        else {\n\
             return NULL;\n\
        }\n\
}\n\
\n\
void GetStripData()\n\
{\n\
    INode *sNode = ip-&gt;GetSelNode(0);\n\
    if(!sNode) return;\n\
    BOOL deleteTri = FALSE;\n\
    TriObject *pTri = GetTriObjectFromNode(sNode,\n\
        ip-&gt;GetTime(), deleteTri);\n\
    Mesh m = pTri-&gt;mesh;\n\
\n\
    //Make sure the strips are there and upto date ?\n\
    m.BuildStripsAndEdges();   \n\
    StripTab *pStab = m.stab;\n\
    int c = pStab-&gt;Count(); //How may Strips do we have ?  \n\
    for(int i=0; i&lt;c; i++) {\n\
        Strip *pS = (*pStab)[i]; // Access the Strip data\n\
        int d= pS-&gt;v.Count(); // Access the Vertex Tab data  \n\
        for(int j=0; j&lt;d; j++) {\n\
            DebugPrint(&quot;Vertex Index %d\\n&quot;, pS-&gt;v[j]);\n\
        }\n\
    }\n\
    //If we own it - remember to delete it !!\n\
    if(deleteTri) pTri-&gt;DeleteThis();\n\
}</code></pre><p>The same method would be used to access the normals and texture vertex data.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../meshes.html\">Meshes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";