var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"vertex_color_information\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Vertex Color Information</h1></div><p>Vertex color information is stored with a Mesh. This information can be used in conjunction with the vertex color map ( <em>\\MAXSDK\\SAMPLES\\MATERIALS\\VERTCOL.CPP</em> ) or the Color Per Vertex utility and modifier ( <em>\\MAXSDK\\SAMPLES\\UTILITIES\\APPLYVC\\APPLYVC.CPP</em>  and  <em>AVCMOD.CPP</em> ).</p>\n\
<p>Several public member fields and methods in the <code>Mesh</code> class provide access to this data.</p>\n\
<h2 id=\"data-members\">Data Members</h2><ul>\n\
<li><code>Mesh::numCVerts</code> - The number of color vertices.</li>\n\
<li><code>Mesh::vertCol</code> - Array of color vertices. Note that <code>VertColor</code> is a <code>Point3</code> typedef.</li>\n\
<li><code>Mesh::vcFace</code> - Array of vertex color faces.</li>\n\
<li><code>Mesh::vertColArray</code> - The source data for vertex colors can come from other than the internal vertex color array (<code>Mesh::vertCol</code>). The data can come from an external array or one of the map channels. When 3ds Max is rendering, the color values come from the <code>Mesh::vertColArray</code> variable. This array defaults to the internal array (<code>Mesh::vertCol</code>) but can be set to an external array or a mapping channel.</li>\n\
<li><code>Mesh::curVCArray</code> - If an external array is used this data member points to it (it defaults to NULL).</li>\n\
<li><code>Mesh::curVCChan</code> - If a mapping channel is used this data member indicates which one. It defaults to 0.</li>\n\
<li><code>Mesh::vcFaceData</code> - When 3ds Max is rendering the vertex lookup comes from this variable. The defaults is to use the <code>Mesh::vcFace</code> data. However if a mapping channel is used for color lookup then 3ds Max uses its <code>TVFace</code> structure.</li>\n\
</ul>\n\
<h2 id=\"methods\">Methods</h2><p>The methods associates with this are as follows:</p>\n\
<ul>\n\
<li><code>Mesh::setNumVertCol()</code> - Sets the number of vertex colors.</li>\n\
<li><code>Mesh::getNumVertCol()</code> - Gets the number of vertex colors.</li>\n\
<li><code>Mesh::setNumVCFaces()</code> - Sets the number of vertex color faces.</li>\n\
<li><code>Mesh::setCVertArray()</code> - Is used to set a different source array for vertex color data. This can be either an external array or one of the mapping channels.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../meshes.html\">Meshes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";