var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"adding_modifiers_to_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Adding Modifiers to Objects</h1></div><p>When a modifier is created using <code>CreateInstance()</code> it is then added using the function <code>Interface7::AddModifier()</code>. The following code demonstrates the process:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">INode* MakeBentCylinder(float radius, float height, int segments, float angle)\n\
{\n\
     // Create a new object using CreateInstance()\n\
     Object *obj = (Object*)CreateInstance(GEOMOBJECT_CLASS_ID, Class_ID(CYLINDER_CLASS_ID,0));\n\
\n\
     // Get ahold of the parameter block\n\
     IParamArray *iCylParams = obj-&gt;GetParamBlock();\n\
\n\
     // Get the current animation time\n\
     TimeValue time = GetCOREInterface()-&gt;GetTime();\n\
\n\
     // Set the value of radius, height and segments.\n\
     iCylParams-&gt;SetValue(obj-&gt;GetParamBlockIndex(CYLINDER_RADIUS), time, radius);\n\
     iCylParams-&gt;SetValue(obj-&gt;GetParamBlockIndex(CYLINDER_HEIGHT), time, height);\n\
     iCylParams-&gt;SetValue(obj-&gt;GetParamBlockIndex(CYLINDER_SEGMENTS), time, segments);\n\
\n\
     // Create the object\n\
     INode *node = ip-&gt;CreateObjectNode(obj);\n\
\n\
     // Create a bend modifier\n\
     Modifier *bend = (Modifier*)ip-&gt;CreateInstance(OSM_CLASS_ID, Class_ID(BENDOSM_CLASS_ID,0));\n\
\n\
     // Set the bend angle\n\
     IParamBlock2* ipBendBlock = ((Animatable*)bend)-&gt;GetParamBlock(0);  //only one pblock2\n\
                    ipBendBlock-&gt;SetValue(BEND_ANGLE,time,angle);\n\
\n\
     // Create a node in the scene for the object\n\
     // Note that COREInterface12 derives from Interface7\n\
     GetCOREInterface12()-&gt;AddModifier(*node, *bend);\n\
     return node;     \n\
}\n\
\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../modifiers.html\">Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";