var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modifier_compatible_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modifier Compatible Types</h1></div><p>In order for the modifier to inform 3ds Max what type of object it needs it implements the method <code>Modifier::InputType()</code>. This method returns the <code>Class_ID</code> of the type of object it needs for input. For example, the Edit Spline modifier implements this method as shown below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Class_ID InputType() { return Class_ID(SPLINESHAPE_CLASS_ID,0); }</code></pre><p>This tells 3ds Max which objects the modifier can be applied to. Only those objects that are spline shapes, or are able to convert themselves to spline shapes, may be modified by Edit Spline. The same is true for Volume Select Modifier. It requires objects that are triangle meshes for it to do its work. Therefore it implements <code>InputType()</code> as shown below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Class_ID InputType() { return Class_ID(TRIOBJ_CLASS_ID,0); }</code></pre><p>When an object is selected in 3ds Max, only those modifiers that are appropriate for modifying it are enabled in the user interface. This is done by querying the modifiers to see if their <code>InputType()</code> matches the <code>Class_ID</code> of the selected object, or the objects that it can convert itself to. If it is, the modifier is enabled, otherwise its disabled.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../modifiers.html\">Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";