var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"material_modifiers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Material Modifiers</h1></div><p>Material modifiers alter the material ID stored by the object. An example of this type of modifier is the Material Modifier implemented by the <code>MatMod</code> class in the file  <em>\\MAXSDK\\SAMPLES\\MODIFIERS\\SURFMOD.CPP</em> .</p>\n\
<p>Below are the implementations of <code>Modifier::InputType()</code>, <code>Modifier::ChannelsUsed()</code>, and <code>Modifier::ChannelsChanged()</code> of the Material modifier. Note that materials are rolled into the face structure of the object so this modifier alters the topology channel.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Class_ID InputType() {\n\
  return triObjectClassID;\n\
} \n\
\n\
ChannelMask ChannelsUsed() {\n\
  return OBJ_CHANNELS;\n\
}\n\
\n\
ChannelMask ChannelsChanged() {\n\
  return GEOM_CHANNEL|TOPO_CHANNEL;\n\
}</code></pre><p>This modifier specifies it changes the geometry channel, however it doesn&apos;t need to since it only changes the material index at the face level and nothing at the vertex level.</p>\n\
<p>Below is the implementation of the Material modifier&apos;s <code>Modifier::ModifyObject()</code>. Note that when the modifier is done it updates the validity of the object flowing down the pipeline by calling <code>UpdateValidity()</code> and passing the topology channel number.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void MatMod::ModifyObject(TimeValue t, ModContext &amp;mc,\n\
            ObjectState *os, INode *node)\n\
{\n\
   Interval valid = FOREVER;\n\
   int id;\n\
   pblock-&gt;GetValue(PB_MATID,t,id,valid); \n\
   id--;\n\
   if (id&lt;0) id = 0;\n\
   if (id&gt;0xffff) id = 0xffff;\n\
\n\
   dbgAssert(os-&gt;obj-&gt;IsSubClassOf(triObjectClassID));\n\
   TriObject *triOb = ( TriObject *)os-&gt;obj;\n\
   BOOL useSel = triOb-&gt;mesh.selLevel==MESH_FACE;\n\
\n\
   for (int i=0; i&lt;triOb-&gt;mesh.getNumFaces(); i++)\n\
   {\n\
     if (!useSel || triOb-&gt;mesh.faceSel[i])\n\
     {\n\
      triOb-&gt;mesh.setFaceMtlIndex(i,(MtlID)id);\n\
     }\n\
   }\n\
\n\
   triOb-&gt;UpdateValidity(TOPO_CHAN_NUM, valid); \n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../object_modifiers.html\">Object Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";