var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"selection_modifiers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Selection Modifiers</h1></div><p>Selection modifiers alter the selection level of objects. An example is the Volume Select modifier which can be found at  <em>\\MAXSDK\\SAMPLES\\MODIFIERS\\SELMOD.CPP</em> .</p>\n\
<p>Below is the implementations of <code>Modifer::InputType()</code>, <code>Modifer::ChannelsUsed()</code>, and <code>Modifer::ChannelsChanged()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Class_ID InputType() {\n\
  return triObjectClassID;\n\
}\n\
\n\
ChannelMask ChannelsUsed() {\n\
  return OBJ_CHANNELS;\n\
} \n\
\n\
ChannelMask ChannelsChanged() {\n\
   return SELECT_CHANNEL|SUBSEL_TYPE_CHANNEL|GEOM_CHANNEL;\n\
}</code></pre><p>Note that <code>Modifier::ChannelsChanged()</code> for the Volume Select modifier doesn&apos;t specify <code>DISP_ATTRIB_CHANNEL</code>. Technically it really should since it changes the mesh display flags. The reason this isn&apos;t a problem however is that this is only a single integer in the Mesh and isn&apos;t dynamically allocated. So it is actually always present even without actually being specified in channels used or channels used.</p>\n\
<p>Below is the implementation of the Volume Select modifier&apos;s <code>Modifer::ModifyObject()</code>. Note that when the modifier is done it updates the validity of the object flowing down the pipeline by calling <code>UpdateValidity()</code> on the four appropriate channels.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void SelMod::ModifyObject(TimeValue t, ModContext &amp;mc,\n\
            ObjectState *os, INode *node)\n\
{\n\
   Interval valid = LocalValidity(t);\n\
   int level, method, type, vol, invert;\n\
\n\
   pblock-&gt;GetValue(PB_LEVEL,t,level,FOREVER);\n\
   pblock-&gt;GetValue(PB_METHOD,t,method,FOREVER);\n\
   pblock-&gt;GetValue(PB_TYPE,t,type,FOREVER);\n\
   pblock-&gt;GetValue(PB_VOLUME,t,vol,FOREVER);\n\
   pblock-&gt;GetValue(PB_INVERT,t,invert,FOREVER);\n\
\n\
   assert(os-&gt;obj-&gt;IsSubClassOf(triObjectClassID));\n\
   TriObject *obj = (TriObject*)os-&gt;obj;\n\
   Mesh &amp;mesh = obj-&gt;mesh;\n\
\n\
   // Prepare the controller and set up mats\n\
   if (!tmControl || (flags&amp;CONTROL_OP)) InitControl(mc,obj,type,t);\n\
   Matrix3 tm;\n\
   tm = Inverse(CompMatrix(t,&amp;mc,NULL,TRUE,FALSE));\n\
\n\
   Box3 mcbox = *mc.box;\n\
   FixupBox(mcbox);\n\
\n\
   switch (level)\n\
   {\n\
     case SEL_OBJECT:\n\
      obj-&gt;mesh.selLevel = MESH_OBJECT;\n\
      obj-&gt;mesh.ClearDispFlag(DISP_VERTTICKS|DISP_SELVERTS|DISP_SELFACES);\n\
      break;\n\
\n\
     case SEL_VERTEX:\n\
      obj-&gt;mesh.selLevel = MESH_VERTEX;\n\
      obj-&gt;mesh.SetDispFlag(DISP_VERTTICKS|DISP_SELVERTS);\n\
      SelectVertices(obj-&gt;mesh,method,type,vol,invert,tm,mcbox);\n\
      break;\n\
\n\
     case SEL_FACE:\n\
      obj-&gt;mesh.selLevel = MESH_FACE;\n\
      obj-&gt;mesh.SetDispFlag(DISP_SELFACES);\n\
      SelectFaces(obj-&gt;mesh,method,type,vol,invert,tm,mcbox);\n\
      break;\n\
   }\n\
\n\
   obj-&gt;UpdateValidity(SELECT_CHAN_NUM,valid);\n\
   obj-&gt;UpdateValidity(GEOM_CHAN_NUM,valid);\n\
   obj-&gt;UpdateValidity(TOPO_CHAN_NUM,valid);\n\
   obj-&gt;UpdateValidity(SUBSEL_TYPE_CHAN_NUM,FOREVER);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../object_modifiers.html\">Object Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";