var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"topology_modifiers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Topology Modifiers</h1></div><p>Topology modifiers alter the face or polygon structures of the objects they are applied to. Smoothing groups and materials are also part of the topology channel. Edge visibility is also part of this channels since it is an attribute of the face structure. The face normals are also part of the topology channel. The example below is from the Normals modifier which allows the user to unify and flip the face normals of a mesh. The full source code is available in <code>\\\\MAXSDK</code>\\SAMPLES\\MODIFIERS\\SURFMOD.CPP.</p>\n\
<p>Below are the implementations of <code>Modifier::InputType()</code>, <code>Modifier::ChannelsUsed()</code>, and <code>Modifier::ChannelsChanged()</code> from the Normals modifier.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Class_ID InputType() {\n\
  return triObjectClassID;\n\
}\n\
\n\
ChannelMask ChannelsUsed() {\n\
  return OBJ_CHANNELS;\n\
}\n\
\n\
ChannelMask ChannelsChanged() {\n\
  return GEOM_CHANNEL|TOPO_CHANNEL;\n\
}</code></pre><p>Note that this modifier only operates on triangle mesh objects, or those objects that are able to convert themselves to triangle meshes. Also note that this modifier specifies the object channels for those that it needs up to date to perform its modification. Since this modifier changes the vertex and face structure of the mesh to alter the normals it specifies it modifies the geometry channel and the topology channel in <code>Modifier::ChannelsChanged()</code>.</p>\n\
<p>Below is the implementation of <code>Modifier::ModifyObject()</code>. Note that when the modifier is done it updates the validity of the object flowing down the pipeline by calling <code>Object::UpdateValidity()</code> and passing the topology channel number.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void NormalMod::ModifyObject(TimeValue t, ModContext &amp;mc, ObjectState *os, INode *node)\n\
{\n\
   Interval valid = FOREVER;\n\
   int flip, unify;\n\
   pblock-&gt;GetValue(PB_FLIP,t,flip,valid); \n\
   pblock-&gt;GetValue(PB_UNIFY,t,unify,valid); \n\
   assert(os-&gt;obj-&gt;IsSubClassOf(triObjectClassID));\n\
   TriObject *triOb = ( TriObject *)os-&gt;obj;\n\
   BOOL useSel = triOb-&gt;mesh.selLevel==MESH_FACE;\n\
   if (unify) {\n\
     triOb-&gt;mesh.UnifyNormals(useSel); \n\
   }\n\
   if (flip)\n\
   {\n\
     for (int i=0; i&lt;triOb-&gt;mesh.getNumFaces(); i++)\n\
     {\n\
      if (!useSel || triOb-&gt;mesh.faceSel[i])\n\
       {\n\
         FlipMeshNormal(&amp;triOb-&gt;mesh,(DWORD)i);\n\
       }\n\
     }\n\
   }\n\
\n\
   triOb-&gt;UpdateValidity(TOPO_CHAN_NUM,valid); \n\
   ...\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../object_modifiers.html\">Object Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";