var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"world-space_modifiers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>World-Space Modifiers</h1></div><p>World space modifiers (WSM) affect objects in world space instead of in the object&#39;s local space like an ordinary modifier. A WSM is a combination of non-rendering object and modifier. A WSM affect other objects in the scene based on the position and orientation of the other objects that are bound to the object. For example, the Ripple Space Warp applies a sine wave deformation to objects bound to it. Other examples of WSMs include things like explosions, wind fields, and gravity.</p>\n\
<p>The main difference between a regular object space modifier and a WSM modifier is that WSM modifiers usually have a reference to the WSM object&#39;s node and are applied after the object has been transformed into world space.</p>\n\
<p>WSMs are created in the Creation branch of the command panel. WSMs can also affect particle systems. For example, a force field can be applied to a particle system by a space warp. The force field provides a function of position in space, velocity and time that gives a force. The force is then used to ompute an acceleration on a particle which modifies its velocity. A collision object can also be applied to a particle system by a space warp. The collision object checks a particle&#39;s position and velocity and determines if the particle will collide with it in the next period of time. If so, it modifies the position and velocity.</p>\n\
<p>A WSM has two components: A WSM object and a WSM modifier. A WSM object is an object derived from <code>WSMObject</code>. It exists in the scene and can have modifiers (including other WSMs) applied to it. When an item is bound to a WSM object, a WSM modifier (derived from <code>Modifier</code> or <code>WSModifier</code>) is created and inserted in the object&#39;s history. A WSM object is like a derived object (<code>IDerivedObject</code>).</p>\n\
<p>World space modifiers are very similar to regular object space modifiers -- in fact, they are derived from the same base class: <code>Modifier</code>. They are referenced from a modification context in the pipeline, but WSM modifiers aren&#39;t instanced. When a user binds more than one object to a WSM object at once, a unique WSM modifier is created for each object. This is done because a WSM modifier may contain parameters specific to that application of the modifier. For example, the Ripple world space modifier has a &#39;Flexibility&#39; parameter which allows the affect of the Ripple to be scaled on a per application basis.</p>\n\
<p>A WSM modifier references its corresponding WSM object&#39;s node so it can get the node&#39;s world space transformation matrix. It uses this matrix to transform the points of the object it is deforming into the space of the WSM object where it actually performs the deformation. After the deformation is applied, the points are transformed back to world space. This is similar to the way object space modifiers transform their points into the space defined by the ModContext transformation matrix -- however this space is defined by the WSM object&#39;s node. So in general, if an object&#39;s node is moved, the object appears to move through the deformation field defined by the WSM object it is bound to. If the WSM object moves, a similar effect is apparent. If an object and the WSM object it is bound to move together (if one is a child of the other, for example) then the affect appears to be more like an object space modifier.</p>\n\
<p>There are two places where WSM user interface parameters can appear:</p>\n\
<ul>\n\
<li>In the parameters of the WSM object. Any centralized parameters should be contained in the WSM object. Since WSM modifiers are never instanced, any parameters that the user would want to change and affect all objects bound to the WSM would belong here. For example, the Ripple WSM has its Amplitude, Phase, WaveLength and Decay parameters in the WSM Object.</li>\n\
<li>In the parameters of the WSM modifier. These parameters are specific to the object bound to the WSM. For example, Ripple has its flexibility parameter here. Often time these modifiers won&#39;t need to have any parameters at all. An example might be a Dynamics WSM that has modifier parameters for the objects mass and surface characteristics.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../modifiers.html\">Modifiers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";