var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"patch_code_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Patch Code Example</h1></div><p>Below is some sample code that shows the interpolation of the surface points, the book keeping code for shared edges, the construction of the mesh faces, the handling of texture vertices and faces, and how bind patches are handled.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// vertices ( a b c d ) are in counter clockwise order when viewed from\n\
// outside the surface\n\
static void MakeQuad(int nVerts, Face *f,\n\
          int a, int b , int c , int d,\n\
          DWORD sm, MtlID m,\n\
          int e1a, int e1b, int e1c,\n\
          int e2a, int e2b, int e2c,\n\
          int hide )\n\
{\n\
   //DebugPrint(&quot;Make quad %d %d %d %d \\n&quot;,a,b,c,d);\n\
   assert(a&lt;nVerts);\n\
   assert(b&lt;nVerts);\n\
   assert(c&lt;nVerts);\n\
   assert(d&lt;nVerts);\n\
   f[0].setVerts( a, b, c);\n\
   f[0].setSmGroup(sm);\n\
   f[0].setEdgeVisFlags(e1a,e1b,e1c);\n\
   f[0].setMatID(m);\n\
   f[0].SetHide(hide);\n\
   f[1].setVerts( c, d, a);\n\
   f[1].setSmGroup(sm);\n\
   f[1].setEdgeVisFlags(e2a,e2b,e2c);\n\
   f[1].setMatID(m);\n\
   f[1].SetHide(hide);\n\
}\n\
\n\
//watje 12-8-98\n\
#define MAKE_QUAD(na,nb,nc,nd,sm,m,e1a,e1b,e1c,e2a,e2b,e2c,hide) { MakeQuad(nVerts,&amp;(mesh.faces[face]),na, nb, nc, nd, sm, m,e1a,e1b,e1c,e2a,e2b,e2c,hide); face+=2; }\n\
\n\
// Make texture face quad\n\
static void MakeTQuad(int chan, int nTVerts, TVFace *f, int a, int b , int c , int d)\n\
{\n\
   assert(a&lt;nTVerts);\n\
   assert(b&lt;nTVerts);\n\
   assert(c&lt;nTVerts);\n\
   assert(d&lt;nTVerts);\n\
   f[0].setTVerts( a, b, c);\n\
   f[1].setTVerts( c, d, a);\n\
}\n\
\n\
#define MAKE_TQUAD(ch,na,nb,nc,nd) { MakeTQuad(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nb, nc, nd); tface+=2; }\n\
// vertices ( a b c d ) are in counter clockwise order when viewed from\n\
// outside the surface\n\
//watje 12-8-98\n\
staticvoidMakeTri(intnVerts, Face *f,\n\
          int a, int b, int c,\n\
          DWORD sm, MtlID m,\n\
          int ea, int eb, int ec,\n\
          int hide)\n\
{\n\
   assert(a&lt;nVerts);\n\
   assert(b&lt;nVerts);\n\
   assert(c&lt;nVerts);\n\
\n\
   //DebugPrint(&quot;Making tri %d %d %d \\n&quot;,a,b,c);\n\
   f-&gt;setVerts( a, b, c);\n\
   f-&gt;setSmGroup(sm);\n\
   f-&gt;setEdgeVisFlags(ea,eb,ec);\n\
   f-&gt;setMatID(m);\n\
   f-&gt;SetHide(hide);\n\
}\n\
//watje 12-8-98\n\
#define MAKE_TRI(na,nb,nc,sm,mat,ea,eb,ec,hide) { MakeTri(nVerts,&amp;(mesh.faces[face]),na, nb, nc, sm, mat,ea,eb,ec,hide); face++; }\n\
\n\
#define MAKE_QUAD_SPECIAL(na,nm,nb,nc,sm,mat,ea,eb,ec,ed,hide) \\\n\
{ MakeTri(nVerts,&amp;(mesh.faces[face]),na, nm, nc, sm, mat,ea,0,ed,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nm, nb, nc, sm, mat,eb,ec,0,hide); face++; }\n\
\n\
#define MAKE_PENTA_EDGE1(na,nm,nb,nc,nd,sm,mat,ea,eb,ec,ed,hide) { \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),na, nm, nc, sm, mat,ea,0,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nm, nb, nc, sm, mat,ea,eb,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nc, nd, na, sm, mat,ec,ed,0,hide); face++; \\\n\
}\n\
\n\
#define MAKE_PENTA_EDGE2(na,nb,nm,nc,nd,sm,mat,ea,eb,ec,ed,hide) { \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),na,nb,nm, sm, mat,ea,eb,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),na, nm, nc, sm, mat,0,eb,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nc, nd, na, sm, mat,ec,ed,0,hide); face++; \\\n\
} \n\
\n\
#define MAKE_PENTA_EDGE3(na,nb,nc,nm,nd,sm,mat,ea,eb,ec,ed,hide) { \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),na,nb,nc, sm, mat,ea,eb,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nc, nm, na, sm, mat,ec,0,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nm, nd, na, sm, mat,ec,ed,0,hide); face++; \\\n\
} \n\
\n\
#define MAKE_PENTA_EDGE4(na,nb,nc,nd,nm,sm,mat,ea,eb,ec,ed,hide) { \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),na,nb,nc, sm, mat,ea,eb,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nc, nd, nm, sm, mat,ec,ed,0,hide); face++; \\\n\
MakeTri(nVerts,&amp;(mesh.faces[face]),nc, nm, na, sm, mat,0,ed,0,hide); face++; \\\n\
}\n\
\n\
\n\
// Make texture face triangle\n\
static void MakeTTri(int chan, int nTVerts, TVFace *f, int a, int b, int c)\n\
{\n\
   assert(a&lt;nTVerts);\n\
   assert(b&lt;nTVerts);\n\
   assert(c&lt;nTVerts);\n\
   f-&gt;setTVerts( a, b, c);\n\
}\n\
#define MAKE_TTRI(ch,na,nb,nc) { MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nb, nc); tface++; }\n\
#define MAKE_TQUAD_SPECIAL(ch,na,nm,nb,nc) \\\n\
{ MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nm, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nm, nb, nc); tface++; \\\n\
tvertHookStart++; }\n\
\n\
#define MAKE_TPENTA_EDGE1(ch,na,nm,nb,nc,nd) \\\n\
{ \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nm, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nm, nb, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nc, nd, na); tface++; \\\n\
tvertHookStart++; }\n\
\n\
#define MAKE_TPENTA_EDGE2(ch,na,nb,nm,nc,nd) \\\n\
{ \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nb, nm); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nm, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nc, nd, na); tface++; \\\n\
tvertHookStart++; }\n\
\n\
#define MAKE_TPENTA_EDGE3(ch,na,nb,nc,nm,nd) \\\n\
{ \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nb, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nc, nm, na); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nm, nd, na); tface++; \\\n\
tvertHookStart++; }\n\
\n\
#define MAKE_TPENTA_EDGE4(ch,na,nb,nc,nd,nm) \\\n\
{ \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),na, nb, nc); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nc, nd, nm); tface++; \\\n\
MakeTTri(ch, nTVerts[ch], &amp;(mesh.mapFaces(ch)[tface]),nc, nm, na); tface++; \\\n\
tvertHookStart++; }\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../patches_and_faces.html\">Patches and Faces</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";