var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"patch_interpolator_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Patch Interpolator Example</h1></div><p>The following is source code for a triangular and quadrilateral patch interpolator</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Triangular patch interpolator\n\
Point3 Patch::interp(PatchMesh *pMesh, float pu, float pv, float pw)\n\
{\n\
   // It had better be a triangular patch!\n\
   assert(type == PATCH_TRI);\n\
   Point3 p;\n\
   PatchVert *vp = pMesh-&gt;verts;\n\
   PatchVec *vecp = pMesh-&gt;vecs;\n\
   float pu2 = pu * pu;\n\
   float pu3 = pu2 * pu;\n\
   float pu4 = pu3 * pu;\n\
   float pv2 = pv * pv;\n\
   float pv3 = pv2 * pv;\n\
   float pv4 = pv3 * pv;\n\
   float pw2 = pw * pw;\n\
   float pw3 = pw2 * pw;\n\
   float pw4 = pw3 * pw;\n\
\n\
   // Hold on to your hats -- Here it comes!\n\
   p = vp[v[0]].p * pw4 +\n\
   aux[0] * 4.0f * pu * pw3 +\n\
   aux[1] * 6.0f * pu2 * pw2 +\n\
   aux[2] * 4.0f * pu3 * pw +\n\
   vp[v[1]].p * pu4 +\n\
   aux[3] * 4.0f * pv * pu3 +\n\
   aux[4] * 6.0f * pu2 * pv2 +\n\
   aux[5] * 4.0f * pv3 * pu +\n\
   vp[v[2]].p * pv4 +\n\
   aux[6] * 4.0f * pw * pv3 +\n\
   aux[7] * 6.0f * pv2 * pw2 +\n\
   aux[8] * 4.0f * pw3 * pv +\n\
   vecp[interior[0]].p * 12.0f * pu * pv * pw2 +\n\
   vecp[interior[1]].p * 12.0f * pu2 * pv * pw +\n\
   vecp[interior[2]].p * 12.0f * pu * pv2 * pw;\n\
   return p;\n\
}\n\
\n\
// Quadrilateral patch interpolator\n\
Point3 Patch::interp(PatchMesh *pMesh, float pu, float pv)\n\
{\n\
   // It had better be a quad patch!\n\
   assert(type == PATCH_QUAD);\n\
   Point3 p;\n\
   PatchVert *vp = pMesh-&gt;verts;\n\
   PatchVec *vecp = pMesh-&gt;vecs;\n\
   float pu2 = pu * pu;\n\
   float pu1 = 1.0f - pu;\n\
   float pu12 = pu1 * pu1;\n\
   float u0 = pu12 * pu1;\n\
   float u1 = 3.0f * pu * pu12;\n\
   float u2 = 3.0f * pu2 * pu1;\n\
   float u3 = pu2 * pu;\n\
   float pv2 = pv * pv;\n\
   float pv1 = 1.0f - pv;\n\
   float pv12 = pv1 * pv1;\n\
   float v0 = pv12 * pv1;\n\
   float v1 = 3.0f * pv * pv12;\n\
   float v2 = 3.0f * pv2 * pv1;\n\
   float v3 = pv2 * pv;\n\
\n\
   // Hold on to your hats -- Here it comes!\n\
   p = vp[v[0]].p * u0 * v0 +\n\
   vecp[vec[7]].p * u1 * v0 +\n\
   vecp[vec[6]].p * u2 * v0 +\n\
   vp[v[3]].p * u3 * v0 +\n\
   vecp[vec[0]].p * u0 * v1 +\n\
   vecp[interior[0]].p * u1 * v1 +\n\
   vecp[interior[3]].p * u2 * v1 +\n\
   vecp[vec[5]].p * u3 * v1 +\n\
   vecp[vec[1]].p * u0 * v2 +\n\
   vecp[interior[1]].p * u1 * v2 +\n\
   vecp[interior[2]].p * u2 * v2 +\n\
   vecp[vec[4]].p * u3 * v2 +\n\
   vp[v[1]].p * u0 * v3 +\n\
   vecp[vec[2]].p * u1 * v3 +\n\
   vecp[vec[3]].p * u2 * v3 +\n\
   vp[v[2]].p * u3 * v3;\n\
   return p;\n\
}</code></pre><p>Building the vertices are just a matter of looping through your patches and then running through each patches UV space to get the corresponding point on the surface. Below is a sample showing the basics.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">float fpd = (float)patchDivs;\n\
for(px = 0; px &lt; numPatches; ++px)\n\
{\n\
   Patch &amp;p = patches[px];\n\
   switch(p.type)\n\
   {\n\
     case PATCH_TRI:\n\
     {\n\
      for(intax = patchDivs - 1; ax &gt; 0; --ax)\n\
       {\n\
         for(int bx = 1; bx &lt; ax; ++bx)\n\
         {\n\
          float u = (float)bx / fpd;\n\
          float v = (float)(patchDivs - ax) / fpd;\n\
          float w = 1.0f - u - v; // Barycentric validity guaranteed!\n\
          mesh.setVert(vert++, p.interp(this, u, v, w));\n\
         }\n\
       }\n\
     }\n\
     break;\n\
     case PATCH_QUAD:\n\
     {\n\
      for(intu = 1; u &lt; patchDivs; ++u)\n\
       {\n\
         float fu = (float)u / fpd;\n\
         for(int v = 1; v &lt; patchDivs; ++v)\n\
         {\n\
          float fv = (float)v / fpd;\n\
          mesh.setVert(vert++, p.interp(this, fu, fv));\n\
         }\n\
       }\n\
     }\n\
     break;\n\
   }\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../patch_interpolation.html\">Patch Interpolation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";