var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"principal_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Principal Classes</h1></div><p>The SDK provides the following classes for creating and manipulating patch objects.</p>\n\
<ul>\n\
<li><code>PatchObject</code> - This is the base class for the creation of Patch Objects in 3ds Max. The <code>PatchObject</code> is the object that flows down the 3ds Max geometry pipeline. This object stores a <code>PatchMesh</code> as well as a <code>Mesh</code> cache. This is similar to the way a <code>TriObject</code> has a <code>Mesh</code>. The <code>TriObject</code> provides methods to manage the operations associated with flowing down the pipeline, while the <code>Mesh</code> stores the vertex, edge and face information. In the <code>PatchObject</code> case, the <code>PatchObject</code> provides methods for working with the pipeline while the <code>Mesh</code> cache is used for display in the viewports.</li>\n\
<li><code>PatchMesh</code> - A <code>PatchMesh</code> can be made up of any number of Patches. Each of these patches can be three or four sided. The topology of these patches are not quite as freeform as a regular <code>TriObject</code> mesh. For example, in a normal triangle mesh you can have an edge that is used by any number of faces. However with patches, in order for the system to figure out how the topology is connected together, each edge can only be used by either one patch (which makes it an open edge), or two patches (which makes it a transitional edge between the two).</li>\n\
<li><code>Patch</code> - A <code>Patch</code> is like a fast face, and the <code>PatchMesh</code> is like the <code>Mesh</code>. The <code>Patch</code> contains the vertices (three or four), and a set of vectors (six or eight) that go between the vertices (two per edge). There are also a set of vertices in the interior of the patch (three or four of these).</li>\n\
<li><code>PatchVec</code> - Represents a patch vector. This can be either an interior vector or an edge vector.</li>\n\
<li><code>PatchVert</code> - This class stores the information associated with a patch vertex and provides methods to access this data. This information includes the vertex location, a table of vectors attached to the patch, and a table of patches using the vertex.</li>\n\
<li><code>PatchEdge</code> - This class describes a patch edge using the vertices at the edge ends, and the indices of the patches sharing the edge.</li>\n\
<li><code>TVPatch</code> - This class is a texture vertex patch structure. This is similar to the <code>TVFace</code> class used with a <code>Mesh</code>.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../patches_and_faces.html\">Patches and Faces</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";