var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"calling_copybasedata\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Calling CopyBaseData()</h1></div><p>The <code>ShapeObject</code> class has a method, <code>ShapeObject::CopyBaseData()</code>, which is used by derived classes to make sure that, when they copy themselves, they are also copying the data in the <code>ShapeObject</code>. This is usually used in the assignment operator of derived classes. It is also used in the <code>ShallowCopy</code> method of objects that are passed up the modifier pipeline. In this case, it is vital that you surround all calls to <code>ShapeObject::CopyBaseData()</code> with calls to <code>Hold::Suspend()</code> and <code>Hold::Resume()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">theHold.Suspend();\n\
CopyBaseData(*fob);\n\
theHold.Resume();</code></pre><p>If this is not done, when certain undo functions are performed, a crash can occur due to the temporary pipeline object being destroyed. Just remember to wrap the call as shown in any code that is used as part of the modifier pipeline evaluation.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shapes_and_splines.html\">Shapes and Splines</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";