var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"shape_and_spline_principal_class\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Shape and Spline Principal Classes</h1></div><p>The following are the main classes used when working with shapes and splines:</p>\n\
<ul>\n\
<li><code>ShapeObject</code> - These are open or closed hierarchical shape objects. This is the base class that <code>SimpleSpline</code>, <code>SimpleShape</code>, <code>SplineShape</code>, and <code>LinearShape</code> are derived from. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\OBJECT.H.</li>\n\
<li><code>SplineShape</code> - The <code>SplineShape</code> is the shape object flows down the geometry pipeline of 3ds Max. The <code>SplineShape</code> contains a <code>BezierShape</code>. A <code>SplineShape</code> and its contained <code>BezierShape</code> are analogous to a <code>TriObject</code> which flows down the pipeline and its <code>Mesh</code>. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\SPLSHAPE.H.</li>\n\
<li><code>BezierShape</code> - The <code>BezierShape</code> is effectively a collection of Bezier Splines. For example, the 3ds Max Donut object has two splines in a hierarchy to make a shape. The <code>BezierShape</code> contains these splines. The <code>BezierShape</code> is analogous to the <code>Mesh</code> of the <code>TriObject</code>. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\SHAPE.H.</li>\n\
<li><code>Spline3D</code> - This is a general 3D spline class. The <code>BezierShape</code> class has a list of these splines that make up the bezier shape. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\SPLINE3D.H.</li>\n\
<li><code>PolyShape</code> - This class is used in the caching of bezier shapes. This is used for doing a one time interpolation of a bezier shape into a form that is the same shape but doesn&#39;t require any further interpolation. In this way the system can do the complex calculations once, store the shape into this <code>PolyShape</code> representation, and not have to go through the cubic spline calculations to figure out where the points are in the future. This class maintains an array of <code>PolyLines</code>. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\POLYSHP.H.</li>\n\
<li><code>PolyLine</code> - This class describes a single polygon in a <code>PolyShape</code> using linear segments. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\POLYSHP.H.</li>\n\
<li><code>SimpleSpline</code> - This is a class used in the creation of shape plugins. Most of the 3ds Max shapes and splines are derived from this class. For example, Line, Arc, Circle, Ellipse and Star are all <code>SimpleSplines</code>. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\SIMPSPL.H.</li>\n\
<li><code>SimpleShape</code> - This class is used to make procedural shape primitives easier to create. The 3ds Max Helix procedural shape is derived from this class. It&#39;s defined in <code>\\\\MAXSDK</code>\\INCLUDE\\SIMPSHP.H.</li>\n\
<li><code>LinearShape</code> - This class is similar to a <code>SplineShape</code> except this class uses a <code>PolyShape</code> as its data while a <code>SplineShape</code> uses a <code>BezierShape</code> as its data. Therefore this is a shape made up of entirely linear segments. This class is defined in <code>\\\\MAXSDK</code>\\INCLUDE\\LINSHAPE.H.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shapes_and_splines.html\">Shapes and Splines</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";