var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"emulating_reset_transform_and_re\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Emulating Reset Transform and Reset Scale</h1></div><p>The 3ds Max user interface provides users with an Adjust Transform rollout which can be used to reset transform or reset scale.</p>\n\
<ul>\n\
<li>Reset transform - Resets the orientation of an objects local axis coordinates to align with the world coordinate system, regardless of the current orientation of the object. This does not affect descendants.</li>\n\
<li>Reset scale - Resets the scale values in the transformation matrix to reflect the new scale of the object. There is no visual change in the object.</li>\n\
</ul>\n\
<p>In order to emulate the reset transform and reset scale behavior you can use the following code snippet:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Interface *ip = theResetScale.ip;\n\
TimeValue t = ip-&gt;GetTime();\n\
Control *tmControl = node-&gt;GetTMController();\n\
BOOL lookAt = tmControl-&gt;GetRollController() ? TRUE : FALSE;\n\
Matrix3 ntm = node-&gt;GetNodeTM(t);\n\
Matrix3 ptm = node-&gt;GetParentTM(t);\n\
Matrix3 rtm = ntm * Inverse(ptm);\n\
Matrix3 otm(1);\n\
Quat rot;\n\
\n\
// Grab the transform\n\
Point3 trans = rtm.GetTrans();\n\
\n\
// Clear the transform on the matrix\n\
rtm.NoTrans();\n\
\n\
// We&apos;re only doing scale - save out the\n\
// rotation so we can put it back\n\
AffineParts parts;\n\
decomp_affine(rtm, &amp;parts);\n\
rot = parts.q;\n\
\n\
// Build the offset transform matrix\n\
otm.PreTranslate(node-&gt;GetObjOffsetPos());\n\
if (node-&gt;GetObjOffsetRot()!=IdentQuat()) {\n\
    PreRotateMatrix(otm,node-&gt;GetObjOffsetRot());\n\
}\n\
Point3 tS(1,1,1);\n\
\n\
if ( node-&gt;GetObjOffsetScale().s != tS ) {\n\
    ApplyScaling(otm,node-&gt;GetObjOffsetScale());\n\
}\n\
\n\
// Apply the relative transform matrix to the offset\n\
otm = otm * rtm;\n\
decomp_affine(otm, &amp;parts);\n\
node-&gt;SetObjOffsetPos( parts.t);\n\
node-&gt;SetObjOffsetScale( ScaleValue(parts.k*parts.f,parts.u));\n\
\n\
// Now set the transform controller with a matrix\n\
// that has no rotation or scale\n\
rtm.IdentityMatrix();\n\
rtm.SetTrans(trans);\n\
if (!lookAt) {\n\
    PreRotateMatrix(rtm,rot);\n\
}\n\
\n\
// But first, want to keep children stationary.\n\
Matrix3 ttm = rtm*ptm;\n\
for (int i=0; iNumberOfChildren(); i++)  {\n\
    Control *tmc  = node-&gt;GetChildNode(i)-&gt;GetTMController();\n\
    Matrix3 oldtm = node-&gt;GetChildNode(i)-&gt;GetNodeTM(t);\n\
     SetXFormPacket pk(oldtm,ttm);\n\
    tmc-&gt;SetValue(t,&amp;pk);\n\
}\n\
SetXFormPacket pckt(rtm);\n\
tmControl-&gt;SetValue(t,&amp;pckt);\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";