var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"a_matrix3_as_an_axis_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>A Matrix3 as an Axis System</h1></div><p>A <code>Matrix3</code> can also be used to specify an axis system. For example, the <code>INode</code> method <code>Rotate()</code> is used to rotate a node about a specified axis system. One of the arguments to this method is a <code>Matrix3</code> that specifies this axis system. Essentially, a matrix <em>is</em> just an axis system.</p>\n\
<p>For example, if you think of an axis tripod in a viewport, this is basically all the information a matrix has. The axis tripod has three vectors (the directions of the axes: X, Y, Z) and a position in space (the point where the axes converge). A transformation matrix holds this same information. The 0th row of a matrix is the X vector, the 1st row of the matrix is the Y vector, the 2nd row of the matrix is the Z vector, and the 3rd row of the matrix is the position.</p>\n\
<p>You can picture this if you consider the identity matrix. Its 0th row (X) is <code>\\[ 1</code>0 0 ] and this is just a vector along the X axis. Its 1st row (Y) is <code>\\[ 0</code> 1 0 ] and this is simply a vector along the Y axis. Its 2nd row (Z) is <code>[ 0</code> 0 1 ] and this is just a vector along the Z axis. And the 3rd row (position) is <code>\\[ 0</code> 0 0] and this is the origin. Therefore the identity matrix is just an axis system without any rotation, positioned at the origin. This same thing holds true for any transformation matrix, it&apos;s just not as easy to visualize as it is with the identity matrix. Therefore, any transformation matrix is really just an axis system.</p>\n\
<p>To construct an axis system then, you can simply create an identity matrix, and apply transformations to the matrix to put the matrix into the coordinate system you need. For example, if you had an axis system that was rotated 45 degrees about the Z axis and centered at (10, 20, 30) you could use the following code to build it:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Matrix3 mat(1); // Identity\n\
mat.RotateZ(DegToRad(45.0f));\n\
mat.SetTrans(Point3(10.0f, 20.0f, 30.0f));\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../matrix_representations_of_3d_tra.html\">Matrix Representations of 3D Transformations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";