var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"rotation\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Rotation</h1></div><p>The cells in a rotation matrix are the sines and cosines of the angle of rotation. In the <code>Matrix3</code> right-handed coordinate system, positive angles move in a counterclockwise direction, when looking down an axis from positive to negative. In the diagram below, the cones along the XYZ axes point in the positive direction, and the cones in the circles around each axis point in the positive direction of rotation.</p>\n\
<p><img src=\"./images/GUID-2DA2F1A0-FA16-476A-988E-4065254FD120-low.gif\" alt></p>\n\
<p>The matrices for rotation about the three axes are shown below. In each case <code>a</code> represents the angle of rotation in radians:</p>\n\
<h2 id=\"x-rotation\">X rotation</h2><p><img src=\"./images/GUID-7AD4E7E3-1B4D-4373-A89C-B4C002ECC302-low.gif\" alt></p>\n\
<h2 id=\"y-rotation\">Y rotation</h2><p><img src=\"./images/GUID-7F280F7A-6C90-4E32-B8F0-F011170C6CFB-low.gif\" alt></p>\n\
<h2 id=\"z-rotation\">Z rotation</h2><p><img src=\"./images/GUID-0ABD27C8-AC87-4E69-9136-8EB72D74DF95-low.gif\" alt></p>\n\
<p>There are global functions in the 3ds Max API to create these rotation matrices and to apply rotation to existing matrices. Several of these are given below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Matrix3 RotateXMatrix(floatangle);</code></pre><p>Builds a new matrix for use as a X rotation transformation. The angle is specified in radians.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Matrix3 RotateYMatrix(floatangle);</code></pre><p>Builds a new matrix for use as a Y rotation transformation.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Matrix3 RotateZMatrix(floatangle);</code></pre><p>Builds a new matrix for use as a Z rotation transformation.</p>\n\
<p>Developer can also remove the rotation from a given matrix using the <code>Matrix3</code> method:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void NoRot();</code></pre><p>This method nulls the rotation portion of the matrix.</p>\n\
<h3 id=\"creating-quaternions-from-rotation-matrices\">Creating Quaternions from Rotation Matrices</h3><p>A quaternion can be created from a rotation matrix. By passing the <code>Matrix3</code> to the constructor of the <code>Quat</code>, its rotation values are used to initialize the quaternion. The following code shows an example of this. It takes a <code>Point3</code>v and creates a quaternion based on the angles stored after snapping them using the current 3ds Max angle snap settings.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Matrix3 mat;\n\
mat.IdentityMatrix();\n\
mat.RotateX(ip-&gt;SnapAngle(v.x));\n\
mat.RotateY(ip-&gt;SnapAngle(v.y));\n\
mat.RotateZ(ip-&gt;SnapAngle(v.z)); \n\
Quat q(mat);\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../matrix_representations_of_3d_tra.html\">Matrix Representations of 3D Transformations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";