var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"node_transformation_matrix\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Node Transformation Matrix</h1></div><p>The <code>INode::GetNodeTM()</code> method may be used to get the node transformation matrix. This method returns the world space transformation matrix of the node at the specified time. This matrix contains the node&apos;s controller transformation and the parent node&apos;s transformation. This matrix does not include the object-offset transformation, or any world space modifier (Space Warp) effects.</p>\n\
<p>The node transformation matrix is inherited:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">NodeLocalTM = NodeWorldTM * Inverse(Parent.NodeWorldTM)</code></pre><p>There are two methods that a developer may use to set the node transformation matrix.:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual void INode::SetNodeTM(TimeValue t, Matrix3&amp; tm)=0;</code></pre><p>This sets the node&apos;s world space transformation matrix, and will call <code>Control::SetValue()</code> on the transform controller.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual void Interface::SetNodeTMRelConstPlane(INode *node, Matrix3&amp; mat)=0;</code></pre><p>This sets the node&apos;s transform relative to the current construction plane. This may be used during creating so you can set the position of the node in terms of the construction plane and not in world units.</p>\n\
<p>To get the final state of an object with all transforms applied, you must use <code>INode::EvalWorldState()</code>.</p>\n\
<p>See <a href=\"./../modifiers/world-space_modifiers.html\">World-Space Modifiers</a> and <a href=\"object_offset_transformation.html\"\">Object Offset Transformation</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";