var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"prs_controllers_and_node_transfo\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>PRS Controllers and Node Transformation Matrices</h1></div><p>This topic describes how 3ds Max constructs the node transformation matrix for the point rotation scale (PRS) controller.</p>\n\
<p>The PRS controller uses sub-controllers to create the final transformation. The PRS controller is passed a matrix to its <code>Control::GetValue()</code> method. This matrix belongs to the parent of the node. If the node has no parent, the matrix starts out as the identity matrix. <code>Control::GetValue()</code> is first called on the position controller, then the rotation controller, then the scale controller.</p>\n\
<p>First the position controller pre-multiplies its position. If the matrix passed is the identity, this is equivalent to setting the bottom row (the translation row) of the matrix. Next, <code>Control::GetValue()</code> is called on the rotation controller and the matrix passed includes the position controller information. The rotation is pre-multiplied in. Next, <code>Control::GetValue()</code> is called on the scale controller and the matrix passed includes the position and rotation controller information. The scale is pre-multiplied in.</p>\n\
<p>The position is not affected by rotation or scale, but the rotation is affected by the position, and the scale is affected by the position and rotation. If the transformations were not applied in this way, the scaling would be skewed by the rotation.</p>\n\
<p>Note that some position controllers can actually apply more than just position to the matrix. For example, the Path Controller when the Follow switch is active applies some rotation to have the node remain tangent to the path it is following. Thus when the rotation controllers receives the matrix in <code>Control::GetValue()</code>, the matrix already has some rotation applied.</p>\n\
<p>The matrix passed to <code>Control::GetValue()</code>, after the position, rotation and scale transformation have updated it, becomes the node transformation matrix that 3ds Max uses to position, rotate and scale nodes in the scene.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";