var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"rotation_concepts\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Rotation Concepts</h1></div><p>This section describes the different ways rotation is represented in the 3ds Max SDK and the various classes used in storing and interpolating rotation.</p>\n\
<p>There are several class used in 3ds Max that describe rotations in 3D space. These classes are <code>Quat</code>, <code>AngAxis</code>, and <code>Matrix3</code>. There are also methods that convert between these classes.</p>\n\
<h2 id=\"the-visualization-of-rotation-space\">The Visualization of Rotation Space</h2><p>The set of <em>all</em> rotations in space may be visualized as:</p>\n\
<ol>\n\
<li>The set of all unit length axis vectors with one endpoint centered at the sphere center (0,0,0) and the other endpoint on the surface of the unit sphere.</li>\n\
<li>The set of rotations about each vector axis (rotations about the radius vectors that point to each endpoint on the sphere).</li>\n\
</ol>\n\
<p>One way to visualize this is to imagine that you could nail a dinner plate to the surface of a ball that is fixed in space (with the top surface of the plate facing the center of the ball, and the nail going from the center of the plate to the center of the sphere -- see the figure below). For each nailed position on the ball, imagine you can rotate the plate about the nail (axis). The point of placement of the nail on the ball, and the plate&apos;s rotation about it describes each of the possible rotations of the plate in a unique way.</p>\n\
<p><img src=\"./images/GUID-DA5F0213-5068-48A3-A644-DD407A538751-low.gif\" alt></p>\n\
<p>Unit sphere with axis and plate shown.</p>\n\
<h2 id=\"quaternion-representation-of-rotation\">Quaternion Representation of Rotation</h2><p>A quaternion may be visualized in a similar way:</p>\n\
<ol>\n\
<li>An arbitrary unit length axis vector (one of the endpoints on the unit sphere...or the nail position).</li>\n\
<li>A rotation about the axis (one on the rotations about the radius vectors that point to each endpoint on the sphere).</li>\n\
</ol>\n\
<p>In the simplest terms, the rotational space described by each quaternion is a 3D unit vector plus a rotation. The <code>Quat</code> class has four public data members that store this information:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">float x, y, z, w;</code></pre><p>A normalized quaternion can represent -PI to +PI rotation -- that is -180 to 180 degrees of rotation. Quaternions use the left-hand rule for determining positive rotation.</p>\n\
<h2 id=\"angaxis-representation-of-rotation\">AngAxis Representation of Rotation</h2><p>This class is similar to a quaternion, except that a normalized quaternion only represents -PI to +PI rotation (that is -180 to 180 degrees of rotation). The <code>AngAxis</code> class can instead have any number of revolutions stored. It has two public data members:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Point3 axis;\n\
float angle;</code></pre><p>The <code>axis</code> is similar to the values in the <code>Quat</code> class. The <code>angle</code> value can represent any rotation amount in radians.</p>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li><p><code>Quat</code></p>\n\
</li>\n\
<li><p><code>AngAxis</code></p>\n\
</li>\n\
<li><p><code>Matrix3</code></p>\n\
</li>\n\
<li><p><a href=\"matrix_representations_of_3d_tra.html\"\">Matrix Representations of 3D Transformations</a></p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"rotation_concepts/euler_angles.html\">Euler Angles</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"rotation_concepts/handling_sign_flips_when_convert.html\">Handling Sign Flips when Converting a Rotation Controller to an Euler Controller</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";