var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"euler_angles\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Euler Angles</h1></div><p>Multiple rotations are not independent. When you rotate something twice, the second rotation rotates the first rotation. For this reason, the order of rotation is important. The 3ds Max Euler angle controller, by default, has an XYZ ordering. That is, the first rotation is done along the X axis, then along the Y axis, and finally along the Z axis. In other words, the default Euler angle controller has a type of EULERTYPE_XYZ (described below). The 3ds Max local Euler angle controller is similar, but specifies rotations around an object&apos;s local coordinates instead of the world coordinates. It has a type of (EULERTYPE_XYZ | EULERTYPE_RF).</p>\n\
<p>The SDK provides functions for converting from a Matrix3 to Euler angles using various rotation orderings. The angles are returned here in the same order as specified by type (for example <code>EULERTYPE_XYZ</code> would be ang[0]=x, ang[1]=y, ang[2]=z.) You need the different types because you get different interpolation of the float values with the each type. These types are: one of the following values:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">EULERTYPE_XYZ\n\
EULERTYPE_XZY\n\
EULERTYPE_YZX\n\
EULERTYPE_YXZ\n\
EULERTYPE_ZXY\n\
EULERTYPE_ZYX\n\
EULERTYPE_XYX\n\
EULERTYPE_YZY\n\
EULERTYPE_ZXZ</code></pre><p><code>N</code>ote: Internally, 3ds Max uses static coordinate frames. Set the <code>EULERTYPE_RF</code> bit (by OR&apos;ing it with the value) if you have a special need to use a rotating coordinate frame. This is described in Ken Shoemaker&apos;s paper in Graphic Gems IV, pp. 222-229.</p>\n\
<p>The Euler conversion functions are:</p>\n\
<ul>\n\
<li><code>MatrixToEuler()</code> - Converts the specified matrix to Euler angles using the <code>type</code> parameter to determine the order.</li>\n\
<li><code>EulerToMatrix()</code> - Converts from the specified Euler angle format (specifying rotation with a triple of angles) to a Matrix3 format.</li>\n\
<li><code>QuatToEuler()</code> - Converts the quaternion to Euler angles. When converting a quaternion to Euler angles using this method, the correct order of application of the resulting three rotations is specified by the <code>type</code> parameter.</li>\n\
<li><code>EulerToQuat()</code> - Converts Euler angles to a quaternion.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rotation_concepts.html\">Rotation Concepts</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";