var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"transform_controller_coordinate_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Transform Controller Coordinate Systems</h1></div><p>A controller can be thought of as operating internally within its own local coordinate system. For both keyframe and procedural controllers, the data generated is provided in the local space of the controller. It is not until the controller supplies its transformation to 3ds Max does the coordinate system become relative to anything other than the controller itself.</p>\n\
<p>Every controller, regardless of type, provides data to 3ds Max at a specified time via <code>Control::GetValue()</code>. One of the parameters passed to this method is a <code>void</code> pointer. Depending on the controller type, different data types are passed using this pointer (see <code>Control::GetValue()</code> for a complete discussion of all the data types). For example, a transform controller will be passed a <code>Matrix3</code> data type. It is the job of this transform controller to update the matrix with its transformation. It does this by <em>pre-multiplying</em> its transformation with the matrix passed.</p>\n\
<p>The controller operates within its own space internally, but when it pre-multiplies its data with the matrix passed, it essentially means the controller is then working in the coordinate system of the matrix. Another way to think of this is that the <code>Matrix3</code> passed is actually transforming the controllers data. Thus, what the final coordinate system ends up being depends upon the client of the controller and not on the controller itself -- it depends on the matrix passed to <code>GetValue()</code>.</p>\n\
<p>To better understand this consider the following examples. For a transform controller, the matrix passed to <code>GetValue()</code> is the transformation matrix of the node&#39;s parent. Consider a simplified keyframe transform controller that only provided position (no rotation or scale). This controller would just update the bottom row of the matrix (translation data) passed by pre-multiplying its value. If the node the controller was assigned to was not hierarchically linked, that is it had no parent other than the world, then the matrix passed to <code>GetValue()</code> would be the identity. In this case, when the controller pre-multiplied its value, it would simply be setting the translation row.</p>\n\
<p>Consider a different case when the node the controller is assigned to <em>is</em> hierarchically linked. As before, the keys of the controller are stored in the local space of the controller. But in this case, when <code>GetValue()</code> is called, the matrix passed is not necessarily the identity. Rather it will be the transformation matrix of the parent of the node the controller is assigned to. If the parent is not located at the origin, or is scaled or rotated in some way, the parent matrix passed will provide an additional transformation to the one the controller itself provides.</p>\n\
<p>For transform controllers, the matrix that is updated in <code>GetValue()</code> becomes the node transform matrix and is used to position and orient the node in the scene.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";