var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_the_node_and_object_offset\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using the Node and Object Offset Transformations</h1></div><p>The following code is from the Reset Transform utility (<code>\\\\MAXSDK</code>\\SAMPLES\\MODIFIERS\\RESETTM.CPP). This utility is used to push object rotation and scale values onto the Modifier Stack and align object pivot points and bounding boxes with the world coordinate system. Reset Transform removes all rotation and scale values from selected objects and places those transforms in an XForm modifier. The code below demonstrates the use of the node transformation and object offset transformations discussed above.</p>\n\
<p>As previously noted, there are two transforms that affect an object: the node transform which is the result of the transform controller plus inheritance, and the object offset transform which positions the geometry relative to the pivot point.</p>\n\
<p>The Reset Transform utility takes the node transform (minus inheritance), and the offset transform, and combines them into a matrix which is given to an XForm modifier which is then placed at the top of the modifier stack.</p>\n\
<p>The node and offset transforms can then be set back to the identity (actually, the position component of the node TM is left unchanged). Here is the code -- it operates on all the selected nodes.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">for (int i=0; i&lt;ip-&gt;GetSelNodeCount(); i++)\n\
{\n\
   INode *node = pi-&gt;GetSelNode(i);\n\
   Matrix3 ntm, ptm, rtm(1), piv(1), tm;\n\
\n\
   // Get Parent and Node TMs\n\
   ntm = node-&gt;GetNodeTM(ip-&gt;GetTime());\n\
   ptm = node-&gt;GetParentTM(ip-&gt;GetTime());\n\
\n\
   // Compute the relative TM\n\
   ntm = ntm * Inverse(ptm);\n\
\n\
   // The reset TM only inherits position\n\
   rtm.SetTrans(ntm.GetTrans());\n\
\n\
   // Set the node TM to the reset TM \n\
   tm = rtm*ptm;\n\
   node-&gt;SetNodeTM(ip-&gt;GetTime(), tm);\n\
\n\
   // Compute the pivot TM\n\
   piv.SetTrans(node-&gt;GetObjOffsetPos());\n\
   PreRotateMatrix(piv,node-&gt;GetObjOffsetRot());\n\
   ApplyScaling(piv,node-&gt;GetObjOffsetScale());\n\
\n\
   // Reset the offset to 0\n\
   node-&gt;SetObjOffsetPos(Point3(0,0,0));\n\
   node-&gt;SetObjOffsetRot(IdentQuat());\n\
   node-&gt;SetObjOffsetScale(ScaleValue(Point3(1,1,1)));\n\
\n\
   // Take the position out of the matrix since\n\
   // we don&apos;t reset position\n\
   ntm.NoTrans();\n\
\n\
   // Apply the offset to the TM\n\
   ntm = piv * ntm;\n\
\n\
   // Apply a derived object to the node&apos;s object\n\
   Object *obj = node-&gt;GetObjectRef();\n\
    IDerivedObject *dobj = CreateDerivedObject(obj);\n\
\n\
   // Create an XForm mod\n\
   SimpleMod *mod = (SimpleMod*)ip-&gt;CreateInstance(\n\
   OSM_CLASS_ID,\n\
   Class_ID(CLUSTOSM_CLASS_ID,0));\n\
\n\
   // Apply the transformation to the mod.\n\
    SetXFormPacket pckt(ntm);\n\
   mod-&gt;tmControl-&gt;SetValue(ip-&gt;GetTime(),&amp;pckt);\n\
\n\
   // Add the modifier to the derived object.\n\
   ModContext* mc = new ModContext(new Matrix3(1), NULL, NULL);\n\
   dobj-&gt;AddModifier(mod, mc);\n\
\n\
   // Replace the node&apos;s object\n\
   node-&gt;SetObjectRef(dobj);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../transformation_and_rotation.html\">Transformation and Rotation</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";