var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_and_retrieving_3ds_max_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating and Retrieving 3ds Max NURBS Objects</h1></div><h2 id=\"createnurbsobject-\">CreateNURBSObject()</h2><p>The <code>CreateNURBSObject()</code> function takes a <code>NURBSSet</code> as input and outputs a pointer to an editable NURBS object whose Class_ID is <code>EDITABLE_SURF_CLASS_ID</code>. For example, this is what all the standard 3ds Max primitives do when they implement <code>Object::ConvertToType()</code>. If you want to make a node in the scene reference a NURBS object, put the objects into a <code>NURBSSet</code> and use this function to create the NURBS object. Then pass this object to <code>Interface::CreateObjectNode()</code>.</p>\n\
<ul>\n\
<li>IObjParam* ip - The 3ds Max interface pointer. If non-NULL, this is used to get at the 3ds Max function to do unique naming. If a NULL is specified the names are not made unique.</li>\n\
<li>NURBSSet *nset - Points to the set of input objects to create. These are defined in object space. The matrix below is used to transform these. For instance, the <code>NURBSSet</code> could be defined in a unit cube and the <code>mat</code> parameter could be used to scale it up. Note: The NURBSIds and parent NURBSIds in this NURBS set are filled in the process of doing the creation. Thus, you pass this set in, and the function modifies it so you can work with the set immediately (you don&#39;t have to later call <code>GetNURBSSet()</code> to get an appropriate one to work with). For example, say you create a <code>NURBSCVSurface</code> using this API and then want to animate some of the CVs on the surface. You&#39;d pass in this set, then when the object is created the CVs on the surface will have the parent ids filled in so you can actually manipulate the surface in the scene.</li>\n\
<li>Matrix3&amp; mat - This is a transformation applied to all of the objects.</li>\n\
</ul>\n\
<h2 id=\"getnurbsset-\">GetNURBSSet()</h2><p><code>The GetNURBSSet()</code> function is used to retrieve a <code>NURBSSet</code> that corresponds to the specified NURBS object. This allows adeveloper to access the internal objects inside a 3ds Max editableNURBS object. If the <code>Relational</code> parameter is FALSE the <code>NURBSSet</code> will contain CV curves and CV surfaces. So for example, if you passan object that has a relational model (perhaps two CV surfaces anda dependent blend surface) it will decompose them into three CVsurfaces. This will be the CV surfaces that represent the twosurfaces and the blend, but you won&#39;t have the blend relationaldata. If <code>Relational</code> is TRUE, you&#39;dget back two CV surfaces and a NURBS blend surface. If you get backa relational model, check the type of object using the base classmethod <code>NURBSObject::GetType()</code> and then cast the object to the appropriate type. Then you may callthat classes methods on the object to work with it.</p>\n\
<p>If you were using this API as part of an export plug-in, you&#39;d probably want to set <code>Relational</code> to FALSE because getting back a relational blend surface would not be useful, but having CV surface data you could export would. On the other hand, if you simply wanted to animate the tension parameters on the blend surface you&#39;d set <code>Relational</code> to TRUE and then call the methods of the blend surface object to change the tension parameters (<code>NURBSBlendSurface::SetTension()</code>).</p>\n\
<p>Important Note: Developers must use the method <code>NURBSSet::DeleteObjects()</code> when done with the <code>NURBSSet</code> to free the memory used.</p>\n\
<ul>\n\
<li><code>Object *object</code> - The input object. This need to be a NURBS object (Class_ID <code>EDITABLE_SURF_CLASS_ID</code>).</li>\n\
<li><code>TimeValue t</code> - The time at which the object is evaluated and converted.</li>\n\
<li><code>NURBSSet &amp;nset</code> - A <code>NURBSSet</code> that corresponds to the specified object is returned here.</li>\n\
<li><code>BOOL Relational</code> - If TRUE the <code>NURBSSet</code> will contain relational data; if FALSE the <code>NURBSSet</code> will contain a CV curve or CV surface equivalent of the object.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../additional_functions_for_working.html\">Additional Functions for Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";