var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_primitive_nurbs_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating Primitive NURBS Objects</h1></div><h2 id=\"gennurbslathesurface-\">GenNURBSLatheSurface()</h2><p>The <code>GenNURBSLatheSurface()</code> function generates a NURBS surface of revolution given an input curve, origin, up axis, and start and end angles. The output of this function is a NURBS CV Surface that matches the definition, not a relational surface.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>NURBSCurve&amp; curve</code> - This is the NURBS curve that is revolved.</li>\n\
<li><code>Point3&amp; origin</code> - Specifies the origin of the revolution.</li>\n\
<li><code>Point3&amp; north</code> - This is the axis that specified the up direction.</li>\n\
<li><code>float start</code> - This is the start angle of the revolution in radians.</li>\n\
<li><code>float end</code> - This is the end angle of the revolution in radians.</li>\n\
<li><code>NURBSSurface&amp; surf</code> - The surface definition is returned here.</li>\n\
</ul>\n\
<h2 id=\"gennurbsspheresurface-\">GenNURBSSphereSurface()</h2><p>The <code>GenNURBSSphereSurface()</code> Generates a NURBS sphere as a non-closed NURBS Surface. Note that this is a CV surface that matches the definition, not a relational surface.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>float radius</code> - The radius of the sphere.</li>\n\
<li><code>Point3&amp; center</code> - The center point of origin of the sphere.</li>\n\
<li><code>Point3&amp; northAxis</code> - This specifies the up axis. Use Point3(0,0,1) for the Z axis for example.</li>\n\
<li><code>Point3&amp; refAxis</code> - This is the direction of the seam. The sphere primitive uses Point3(0,-1,0) as this value.</li>\n\
<li><code>float startAngleU</code> - The start angle for the sphere in the U direction, specified in radians.</li>\n\
<li><code>float endAngleU</code> - The end angle for the sphere in the U direction, specified in radians.</li>\n\
<li><code>float startAngleV</code> - The start angle for the sphere in the V direction, specified in radians.</li>\n\
<li><code>float endAngleV</code> - The end angle for the sphere in the V direction, specified in radians.</li>\n\
<li><code>NURBSSurface&amp; surf</code> - The surface definition is returned here. This is a CV surface that matches the definition, not a relational surface.</li>\n\
</ul>\n\
<h2 id=\"gennurbscylindersurface-\">GenNURBSCylinderSurface()</h2><p>The <code>GenNURBSCylinderSurface()</code> function generates a NURBS cylinder as a non-closed NURBS Surface. Note that this is a CV surface that matches the definition, not a relational surface.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>float radius</code> - The radius of the cylinder.</li>\n\
<li><code>float height</code> - The height of the cylinder.</li>\n\
<li><code>Point3&amp; origin</code> - The origin of the cylinder.</li>\n\
<li><code>Point3&amp; symAxis</code> - The axis of symmetry. The standard cylinder primitive specifies Point3(0,0,1).</li>\n\
<li><code>Point3&amp; refAxis</code> - This is the direction of the seam. The standard cylinder primitive specifies Point3(0,1 ,0).</li>\n\
<li><code>float startAngle</code> - The start angle in radians.</li>\n\
<li><code>float endAngle</code> - The end angle in radians.</li>\n\
<li><code>NURBSSurface&amp; surf</code> - The surface definition is returned here.</li>\n\
</ul>\n\
<h2 id=\"gennurbsconesurface-\">GenNURBSConeSurface()</h2><p>The <code>GenNURBSConeSurface()</code> function generates a NURBS cone surface as a non-closed NURBS Surface. Note that this is a CV surface that matches the definition, not a relational surface.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>float radius1</code> - One of the radii of the cone.</li>\n\
<li><code>float radius2</code> - The other radius of the cone.</li>\n\
<li><code>float height</code> - The height of the cone.</li>\n\
<li><code>Point3&amp; origin</code> - The origin of the cone.</li>\n\
<li><code>Point3&amp; symAxis</code> - The axis of symmetry.</li>\n\
<li><code>Point3&amp; refAxis</code> - This is the direction of the seam.</li>\n\
<li><code>float startAngle</code> - The start angle in radians.</li>\n\
<li><code>float endAngle</code> - The end angle in radians.</li>\n\
<li><code>NURBSSurface&amp; surf</code> - The surface definition is returned here.</li>\n\
</ul>\n\
<h2 id=\"gennurbstorussurface-\">GenNURBSTorusSurface()</h2><p>This <code>GenNURBSTorusSurface()</code> function generates a NURBS torus surface as a non-closed NURBS Surface. Note that this is a CV surface that matches the definition, not a relational surface.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>float majorRadius</code> - This is the radius of the entire &#39;donut&#39; shape.</li>\n\
<li><code>float minorRadius</code> - The is the radius of the &#39;tube&#39;.</li>\n\
<li><code>Point3&amp; origin</code> - The origin of the cone.</li>\n\
<li><code>Point3&amp; symAxis</code> - The axis of symmetry.</li>\n\
<li><code>Point3&amp; refAxis</code> - This is the direction of the seam.</li>\n\
<li><code>float startAngleU</code> - The start angle of the torus in the U direction.</li>\n\
<li><code>float endAngleU</code> - The end angle of the torus in the U direction.</li>\n\
<li><code>float startAngleV</code> - The start angle of the torus in the V direction.</li>\n\
<li><code>float endAngleV</code> - The end angle of the torus in the V direction.</li>\n\
<li><code>NURBSSurface&amp; surf</code> - The surface definition is returned here.</li>\n\
</ul>\n\
<h2 id=\"createnurbslatheshape-\">CreateNURBSLatheShape()</h2><p>The <code>CreateNURBSLatheShape()</code> function generates a NURBS object based on the specified lathe (surface of revolution) definition and returns a pointer to it. This is used by the lathe modifier.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>IObjParam* ip</code> - The 3ds Max interface pointer. If non-NULL, this is used to get at the 3ds Max function to do unique naming. If a NULL is specified the names are not made unique.</li>\n\
<li><code>TSTR name</code> - The name for the object. If the pointer above is non-NULL this name is made unique.</li>\n\
<li><code>TimeValue t</code> - The time at which to revolve the shape.</li>\n\
<li><code>ShapeObject *shape</code> - Points to the shape object to revolve. Note that if the ShapeObject pointed to is a bezier spline then capping won&#39;t work properly.</li>\n\
<li><code>Matrix3&amp; axis</code> - This specifies the axis of revolution.</li>\n\
<li><code>float degrees</code> - The angle for the surface of revolution in degrees.</li>\n\
<li><code>int capStart</code> - Specifies if the surface should be capped at the beginning: TRUE to cap; FALSE to leave open. Note that this is only used if the ShapeObject is a NURBS curve.</li>\n\
<li><code>int capEnd</code> - Specifies if the surface should be capped at the ending: TRUE to cap; FALSE to leave open. Note that this is only used if the ShapeObject is a NURBS curve.</li>\n\
<li><code>int capType</code> - This parameter is not currently used and the value passed is ignored.</li>\n\
<li><code>BOOL weldCore</code> - TRUE to collapse any coincident vertices at the center of the surface; otherwise FALSE.</li>\n\
<li><code>BOOL flipNormals</code> - TRUE to invert the orientation of surface normals; otherwise FALSE.</li>\n\
<li><code>BOOL texturing</code> - TRUE to generate mapping coordinates; otherwise FALSE.</li>\n\
<li><code>int segs</code> - This parameter is not currently used and the value passed is ignored.</li>\n\
<li><code>BOOL matIds</code> - If TRUE special material Ids are assigned to the surfaces and caps.</li>\n\
<li><code>BOOL shapeIDs</code> - If TRUE shape IDs are used. When on, this function uses the material ID values assigned to segments in the spline to be lathed, or curve sub-objects in the NURBS curve to be lathed. This is available only when matIds is TRUE.</li>\n\
</ul>\n\
<h2 id=\"createnurbsextrudeshape-\">CreateNURBSExtrudeShape()</h2><p>The <code>CreateNURBSExtrudeShape()</code> function generates a NURBS object based on the specified extrusion definition and returns a pointer to it. This is used by the extrude modifier.</p>\n\
<p>Parameters:</p>\n\
<ul>\n\
<li><code>IObjParam* ip</code> - The 3ds Max interface pointer. If non-NULL, this is used to get at the 3ds Max function to do unique naming. If a NULL is specified the names are not made unique.</li>\n\
<li><code>TSTR name</code> - The name for the surface. If the pointer above is non-NULL this name is made unique.</li>\n\
<li><code>TimeValue t</code> - The time at which to extrude the shape.</li>\n\
<li><code>ShapeObject *shape</code> - Points to the shape object to extrude. Note that if the <code>ShapeObject</code> pointed to is a bezier spline then capping won&#39;t work properly.</li>\n\
<li><code>float amount</code> - Specifies the height of the extrusion.</li>\n\
<li><code>int capStart</code> - Specifies if the surface should be capped at the bottom: TRUE to cap; FALSE to leave open. Note that this is only used if the <code>ShapeObject</code> is a NURBS curve.</li>\n\
<li><code>int capEnd</code> - Specifies if the surface should be capped at the top: TRUE to cap; FALSE to leave open. Note that this is only used if the <code>ShapeObject</code> is a NURBS curve.</li>\n\
<li><code>int capType</code> - This parameter is not currently used and the value passed is ignored.</li>\n\
<li><code>BOOL texturing</code> - If TRUE texture coordinates are assigned; otherwise they are not.</li>\n\
<li><code>BOOL matIds</code> - If TRUE special material Ids are assigned to the surfaces and caps.</li>\n\
<li><code>BOOL shapeIDs</code> - If TRUE shape IDs are used. When on, this function uses the material ID values assigned to segments in the spline to be extruded, or curve sub-objects in the NURBS curve to be extruded. This is available only when the <code>matIds</code> parameter is TRUE.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../additional_functions_for_working.html\">Additional Functions for Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";