var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modifying_existing_nurbs_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modifying Existing NURBS Objects</h1></div><h2 id=\"addnurbsobjects-\">AddNURBSObjects()</h2><p><code>AddNURBSObjects()</code> adds the specified <code>NURBSSet</code> to the specified object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - Points to the object to have the specified <code>NURBSSet</code> added to. This object must be a NURBS object (otherwise it will simply return 0).</li>\n\
<li>IObjParam* ip - The 3ds Max interface pointer. If non-NULL, this is used to get at the 3ds Max function to do unique naming. If a NULL is specified the names are not made unique.</li>\n\
<li>NURBSSet *nset - Points to the NURBS set that is added to the object.</li>\n\
</ul>\n\
<h2 id=\"setsurfaceapprox-\">SetSurfaceApprox()</h2><p><code>SetSurfaceApprox()</code> sets the surface approximation characteristics of an existing NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object to modify.</li>\n\
<li>BOOL viewport - TRUE to set the viewport approximation settings; FALSE to set the rendering settings.</li>\n\
<li>TessApprox *tess - Specifies the properties of the tesselation approximation to the mathematical surface.</li>\n\
<li>BOOL clearSurfs=FALSE - This tells the NURBS object to clear any over-ridden values on individual surfaces. The NURBS UI lets users set surface approximation value on individual surfaces that override the values for the whole object. When this is TRUE, then these are cleared.</li>\n\
</ul>\n\
<h2 id=\"setcurveapprox-\">SetCurveApprox()</h2><p>Sets the curve approximation characteristics of an existing NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object to modify.</li>\n\
<li>BOOL viewport - TRUE to set the viewport approximation settings; FALSE to set the rendering settings.</li>\n\
<li>TessApprox *tess - Specifies the properties of the tesselation approximation to the mathematical curve.</li>\n\
<li>BOOL clearSurfs - Tells the NURBS object to clear any overridden values on individual curves. The NURBS UI lets users set surface approximation value on individual surfaces that override the values for the whole object. When this is TRUE, then these are cleared.</li>\n\
</ul>\n\
<h2 id=\"setdispapprox-\">SetDispApprox()</h2><p><code>SetDispApprox()</code> sets the displacement mapping approximation characteristics of an existing NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object to modify.</li>\n\
<li>TessApprox *tess - Specifies the properties of the tesselation approximation to the mathematical curve.</li>\n\
<li>BOOL clearSurfs - This tells the NURBS object to clear any over-ridden values on individual surfaces. The NURBS UI lets users set surface approximation value on individual surfaces that override the values for the whole object. When this is TRUE, then these are cleared.</li>\n\
</ul>\n\
<h2 id=\"setsurfacedisplaysettings-\">SetSurfaceDisplaySettings()</h2><p><code>SetSurfaceDisplaySettings()</code> sets the display properties of an existing NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object to modify.</li>\n\
<li>NURBSDisplay&amp; disp - The display properties to use. See <code>NURBSDisplay</code>.</li>\n\
</ul>\n\
<h2 id=\"getsurfacedisplaysettings-\">GetSurfaceDisplaySettings()</h2><p><code>GetSurfaceDisplaySettings()</code> retrieves the display properties of an existing NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object to check.</li>\n\
<li>NURBSDisplay&amp; disp - The display properties are returned here. See Class NURBSDisplay.</li>\n\
</ul>\n\
<h2 id=\"transform-\">Transform()</h2><p><code>Transform()</code> transforms the specified sub-objects within the NURBS object passed. Note that the parameter xPack is used for the transformation when Animate mode is on, and mat is used when Animate is off. This stems from the fact that 3ds Max delays creation of controllers on NURBS sub-objects until they are animated.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose sub-objects are modified.</li>\n\
<li>NURBSIdTab&amp; ids - The table of NURBS Ids of the sub-objects to transform. These are the sub-objects within the 3ds Max NURBS object obj that are transformed.</li>\n\
<li>SetXFormPacket&amp; xPack - When Animate mode is on, this matrix is used for the transformation. See Class SetXFormPacket.</li>\n\
<li>Matrix3 mat - When not in Animate mode, this matrix is used for the transformation.</li>\n\
<li>TimeValue t - The time at which to do the transformation.</li>\n\
</ul>\n\
<h2 id=\"breakcurve-\">BreakCurve()</h2><p><code>BreakCurve()</code> takes a specified NURBS curve sub-object and generates two curves from it.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose curve sub-object is broken.</li>\n\
<li>NURBSId id - The id of the curve sub-object to break.</li>\n\
<li>double u - The point along the curve at which the break is made.</li>\n\
<li>TimeValue t - The time at which the curve is broken. The u parameter is relative to the state of the curve at this time (for instance if it&#39;s animated).</li>\n\
</ul>\n\
<h2 id=\"breaksurface-\">BreakSurface()</h2><p><code>BreakSurface()</code> takes the specified NURBS surface sub-object and generates two surfaces from it.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose surface sub-object is broken.</li>\n\
<li>NURBSId id - The id of the surface sub-object to break.</li>\n\
<li>BOOL breakU - If TRUE the break occurs along a constant U parameter; otherwise along a constant V parameter.</li>\n\
<li>double param - The distance in U or V space that the break should happen in.</li>\n\
<li>TimeValue t - The time at which the surface is broken. The u parameter is relative to the state of the surface at this time (for instance if it&#39;s animated).</li>\n\
</ul>\n\
<h2 id=\"joincurves-\">JoinCurves()</h2><p><code>JoinCurves()</code> takes two curves and joins them together and makes a single curve out of them. That is, the endpoints of the two curve objects are connected by new segments, and the two original curves are replaced by a single curve. Returns the NURBSId of the newly joined curve.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose curve sub-objects are joined.</li>\n\
<li>NURBSId id1 - The id of the first curve sub-object.</li>\n\
<li>NURBSId id2 - The id of the second curve sub-object.</li>\n\
<li>BOOL begin1 - Specifies if the beginning or the end of curve 1 if joined. If TRUE the beginning is used; otherwise the end is used. The beginning of the curve is the point of minimum parameter value.</li>\n\
<li>BOOL begin2 - Specifies if the beginning or the end of curve 2 if joined. If TRUE the beginning is used; otherwise the end is used. The beginning of the curve is the point of minimum parameter value.</li>\n\
<li>double tolerance - A distance in 3ds Max units. If the gap between the curves you are joining is greater than this value, this function creates the join by first creating a blend curve and then joining the three parts. If the gap is less than this value, or if the curves are overlapping or coincident, no blend is created. Creating a blend and then joining the three curves into a single curve is the better technique. The result matches the parent curves well. Without the blend step, the resulting curve can deviate from the parent curves, in order to maintain smoothness. (The amount of deviation depends on how far from tangent the two input curves were at the join.). A problem arises when there is a gap but it is too small. In this case, this function generates the blend but because there isn&#39;t enough room for it, the resulting curve has a loop in it. To avoid this loop, set this parameter higher than the gap distance. If you use a value of 0.0, the function chooses a value to use for the tolerance.</li>\n\
<li>double ten1 - Specifies the tension of the new curve at the end of the first curve sub-object.</li>\n\
<li>double ten2 - Specifies the tension of the new curve at the end of the second curve sub-object.</li>\n\
<li>TimeValue t - The time at which the curves are joined.</li>\n\
</ul>\n\
<h2 id=\"joinsurfaces-\">JoinSurfaces()</h2><p><code>JoinSurfaces()</code> takes two surfaces and joins them together and makes a single surface out of them. That is, the specified edges of the two surface objects are connected by a new surface, and the two original surfaces are replaced by a single surface. This function returns the NURBSId of the newly joined surface.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose surface sub-objects are joined.</li>\n\
<li>NURBSId id1 - The id of the first surface sub-object.</li>\n\
<li>NURBSId id2 - The id of the second surface sub-object.</li>\n\
<li>int edge1 - The index of the edge of surface 1 to join.</li>\n\
<li>int edge2 - The index of the edge of surface 2 to join.</li>\n\
<li>double tolerance - A distance in 3ds Max units. If the gap between the surfaces you are joining is greater than this value, this function creates the join by first creating a blend surface. If the gap is less than this value, or if the surfaces are overlapping or coincident, 3ds Max doesn&#39;t create the blend. Creating a blend and then joining the three surfaces into a single surface is the better technique. The result matches the parent surfaces well. Without the blend step, the resulting surface can deviate from the parent surfaces, in order to maintain smoothness. (The amount of deviation depends on how far from tangent the two input surfaces were at the join.)/ A problem arises when there is a gap but it is too small. In this case, this function generates the blend but because there isn&#39;t enough room for it, the resulting surface has a loop in it. To avoid this loop, set the tolerance parameter higher than the gap distance. If you set the tolerance to 0.0, the function chooses a value to use for the tolerance.</li>\n\
<li>double ten1 - Specifies the tension of the new surface at the edge of the first surface sub-object.</li>\n\
<li>double ten2 - Specifies the tension of the new surface at the edge of the second surface sub-object.</li>\n\
<li>TimeValue t - The time at which the surfaces are joined.</li>\n\
</ul>\n\
<h2 id=\"zipcurves-\">ZipCurves()</h2><p><code>ZipSurfaces()</code> concatenates two curves by concatenating the CV lattices of the two original curves. Zipping can change the shape of the original curves, but usually it produces a better result than joining. If both curves are untrimmed point curves, the result is a point curve. In all other cases, the result of zipping is a CV curve. Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose curve sub-objects are zipped.</li>\n\
<li>NURBSId id1 - The id of the first curve sub-object.</li>\n\
<li>NURBSId id2 - The id of the second curve sub-object.</li>\n\
<li>BOOL begin1 - Specifies if the beginning or the end of curve 1 if joined. If TRUE the beginning is used; otherwise the end is used. The beginning of the curve is the point of minimum parameter value.</li>\n\
<li>BOOL begin2 - Specifies if the beginning or the end of curve 2 if joined. If TRUE the beginning is used; otherwise the end is used. The beginning of the curve is the point of minimum parameter value.</li>\n\
<li>double tolerance 0- A distance in 3ds Max units. If the gap between the curves you are zipping is greater than this value, this function creates the join by first creating a blend curve and then joining the three parts. If the gap is less than this value, or if the curves are overlapping or coincident, no blend is created. If you use a value of 0.0, the function chooses a value to use for the tolerance.</li>\n\
<li>TimeValue t - The time at which the surfaces are joined.</li>\n\
</ul>\n\
<h2 id=\"zipsurfaces-\">ZipSurfaces()</h2><p><code>ZipSurfaces()</code> concatenates the CV lattices of the two original surfaces. Zipping can change the shape of the original surfaces, but compared to joining it usually produces a simpler surface that is easier to edit.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose surface sub-objects are zipped.</li>\n\
<li>NURBSId id1 - The id of the first surface sub-object.</li>\n\
<li>NURBSId id2 - The id of the second surface sub-object.</li>\n\
<li>int edge1 - The index of the edge of surface 1 to join.</li>\n\
<li>int edge2 - The index of the edge of surface 2 to join.</li>\n\
<li>double tolerance - A distance in 3ds Max units. If the gap between the surfaces you are zipping is greater than this value, this function creates the join by first creating a blend surface. If the gap is less than this value, or if the surfaces are overlapping or coincident, 3ds Max doesn&#39;t create the blend. If you set the tolerance to 0.0, the function chooses a value to use for the tolerance.</li>\n\
<li>double ten1 - Specifies the tension of the new surface at the edge of the first surface sub-object.</li>\n\
<li>double ten2 - Specifies the tension of the new surface at the edge of the second surface sub-object.</li>\n\
<li>TimeValue t - The time at which the surfaces are joined.</li>\n\
</ul>\n\
<h2 id=\"makeindependent-\">MakeIndependent()</h2><p><code>MakeIndependent()</code> takes a dependent sub-object (fillet, offset, blend, etc.) and turns it into a CV variant of itself such that it is independent (no longer dependent on a parent). Returns the NURBSId of the resulting object or zero if it could not be done.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose sub-object is made independent.</li>\n\
<li>NURBSId id - The id of the dependent sub-object.</li>\n\
<li>TimeValue t - The time at which the sub-object is made independent.</li>\n\
</ul>\n\
<h2 id=\"makerigid-\">MakeRigid()</h2><p><code>MakeRigid()</code> makes any kind of surface sub-object into a rigid surface in order to improve performance. Once you have made a surface rigid, the only editing allowed is to transform it at the Surface sub-object level. You can&#39;t move a rigid surface&#39;s points or CVs, or change the number of points or CVs. Rigid surfaces reduce the amount of memory used by the NURBS model. Making surfaces rigid improves performance, especially for large and complex models. Returns the NURBSId of the rigid surface.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* obj - The NURBS object whose surface sub-objects is made rigid.</li>\n\
<li>NURBSId id - The id of the sub-object who is made rigid.</li>\n\
<li>TimeValue t - The time at which to make it rigid.</li>\n\
</ul>\n\
<h2 id=\"setapproxpreset-\">SetApproxPreset()</h2><p><code>SetApproxPreset()</code> chooses one of the Tesselation Presets which appear in the 3ds Max UI in the Surface Approximation rollup. These are the Low, Medium and High buttons. See also <code>GetTessPreset()</code> and <code>SetTessPreset()</code> below.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The objects whose specified Tesselation Preset is set.</li>\n\
<li>int i - Specifies which preset to make active. One of the following values:</li>\n\
<li><ul>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
</ul>\n\
</li>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
</ul>\n\
<p>ToggleShadedLattice()</p>\n\
<p>Inverts the state of the Shaded Lattice setting for the object. This goes between &#39;Tesselated Mesh&#39; and &#39;Shaded Lattice&#39; surface display mode.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The object whose Shaded Lattice setting is toggled.</li>\n\
</ul>\n\
<h2 id=\"gettesspreset-\">GetTessPreset()</h2><p><code>GetTessPreset()</code> returns a pointer to the tesselation object corresponding to the specified type of tesselation preset.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>int which - Determines which type of tesselation is set. One of the following values:</li>\n\
<li><ul>\n\
<li>0: Curve tesselation in the viewports.</li>\n\
<li>1: Curve tesselation by the production renderer.</li>\n\
<li>2: Surface tesselation in the viewports.</li>\n\
<li>3: Surface tesselation by the production renderer.</li>\n\
<li>4: Displacement mapping (by the production renderer).</li>\n\
</ul>\n\
</li>\n\
<li>0: Curve tesselation in the viewports.</li>\n\
<li>1: Curve tesselation by the production renderer.</li>\n\
<li>2: Surface tesselation in the viewports.</li>\n\
<li>3: Surface tesselation by the production renderer.</li>\n\
<li>4: Displacement mapping (by the production renderer).</li>\n\
<li>int preset - Specifies which preset to get. One of the following values:</li>\n\
<li><ul>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
</ul>\n\
</li>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
</ul>\n\
<h2 id=\"settesspreset-\">SetTessPreset()</h2><p><code>SetTessPreset()</code> sets the tesselation object corresponding to the specified type of tesselation preset.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>int which - Determines which type of tesselation is set. One of the following values:</li>\n\
<li><ul>\n\
<li>0: Curve tesselation in the viewports.</li>\n\
<li>1: Curve tesselation by the production renderer.</li>\n\
<li>2: Surface tesselation in the viewports.</li>\n\
<li>3: Surface tesselation by the production renderer.</li>\n\
<li>4: Displacement mapping (by the production renderer).</li>\n\
</ul>\n\
</li>\n\
<li>0: Curve tesselation in the viewports.</li>\n\
<li>1: Curve tesselation by the production renderer.</li>\n\
<li>2: Surface tesselation in the viewports.</li>\n\
<li>3: Surface tesselation by the production renderer.</li>\n\
<li>4: Displacement mapping (by the production renderer).</li>\n\
<li>int preset - Specifies which preset to get. One of the following values:</li>\n\
<li><ul>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
</ul>\n\
</li>\n\
<li>0: Low</li>\n\
<li>1: Medium</li>\n\
<li>2: High</li>\n\
<li>TessApprox&amp; tess - The tesselation object to set.</li>\n\
</ul>\n\
<h2 id=\"buildemobjectfromlofterobject-\">BuildEMObjectFromLofterObject()</h2><p><code>BuildEMObjectFromLofterObject()</code> generates a new NURBS object from the specified loft object at the current time. This function is intended for internal usage in the lofter to convert a loft object to a NURBS surface. It returns a pointer to the new NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object *loftObject - Points to the source loft object.</li>\n\
<li>double tolerance - This parameter is the maximum deviation of the NURBS approximation to the true loft surface.</li>\n\
</ul>\n\
<h2 id=\"buildemobjectfrompatchobject-\">BuildEMObjectFromPatchObject()</h2><p><code>BuildEMObjectFromPatchObject()</code> generates a new NURBS object from the specified patch object at the current time. Returns a pointer to the new NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object *patchObject - Points to the source patch object.</li>\n\
</ul>\n\
<h2 id=\"detachobjects-\">DetachObjects()</h2><p><code>DetachObjects()</code> creates a new named NURBS object in the scene respecting the copy and relational flags like the 3ds Max Detach operation. Returns a pointer to the new object created by the detach, or NULL if an error occured.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>TimeValue t - The time at which to detach the object.</li>\n\
<li>INode *pNode - The node of the existing object.</li>\n\
<li>Object* pobj - Points to the NURBS object whose sub-objects are detached.</li>\n\
<li>NURBSIdList list - The list of objects to detach. Note: typedef Tab&lt;NURBSId&gt; NURBSIdList.</li>\n\
<li>char *newObjName - The name for the new node created.</li>\n\
<li>BOOL copy - TRUE to create a copy for the detached objects leaving the original; FALSE to remove the originals.</li>\n\
<li>BOOL relational - If TRUE the object will contain relational data; if FALSE the object will contain a CV curve or CV surface equivalent of the object.</li>\n\
</ul>\n\
<h2 id=\"getselectionlevel-\">GetSelectionLevel()</h2><p><code>GetSelectionLevel()</code> returns the current sub-object selection level for the specified NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The object to check.</li>\n\
</ul>\n\
<h2 id=\"setselectionlevel-\">SetSelectionLevel()</h2><p><code>SetSelectionLevel()</code> sets the current sub-object selection level for the specified NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose sub-object selection state is set.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level.</li>\n\
</ul>\n\
<h2 id=\"getselection-\">GetSelection()</h2><p><code>GetSelection()</code> returns a BitArray containing the sub-object selection state of a NURBS object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose sub-object selection data is retrieved.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level data to get. See NURBS Sub-Object Level Options.</li>\n\
<li>BitArray&amp; selset - The BitArray for the result. Bits set are selected components. See Class BitArray.</li>\n\
</ul>\n\
<h2 id=\"setselection-\">SetSelection()</h2><p><code>SetSelection()</code> sets the specified sub-object selection state of the NURBS object passed.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose sub-object selection state is set.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>BitArray&amp; selset - The BitArray with the selection data. Bits which are set indicate items to select.</li>\n\
</ul>\n\
<h2 id=\"movecurrentselection-\">MoveCurrentSelection()</h2><p><code>MoveCurrentSelection()</code> moves the current sub-object selection at the specified level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The object whose components are transformed.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TimeValue t - The time to transform the sub-objects.</li>\n\
<li>Matrix3&amp; partm - The &#39;parent&#39; transformation matrix.</li>\n\
<li>Matrix3&amp; tmAxis - The axis system about which the selection is transformed.</li>\n\
<li>Point3&amp; val - The amount of the transformation relative to the axis system.</li>\n\
<li>BOOL localOrigin - If TRUE the transformation takes place about the nodes local origin; otherwise about the world origin.</li>\n\
</ul>\n\
<h2 id=\"rotatecurrentselection-\">RotateCurrentSelection()</h2><p><code>RotateCurrentSelection()</code> rotates the current sub-object selection at the specified level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The object whose components are transformed.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TimeValue t - The time to transform the sub-objects.</li>\n\
<li>Matrix3&amp; partm - The &#39;parent&#39; transformation matrix.</li>\n\
<li>Matrix3&amp; tmAxis - The axis system about which the selection is transformed.</li>\n\
<li>Quat&amp; val - The amount of the transformation relative to the axis system.</li>\n\
<li>BOOL localOrigin - If TRUE the transformation takes place about the nodes local origin; otherwise about the world origin.</li>\n\
</ul>\n\
<h2 id=\"scalecurrentselection-\">ScaleCurrentSelection()</h2><p>ScaleCurrentSelection() scales the current sub-object selection at the specified level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - The object whose components are transformed.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TimeValue t - The time to transform the sub-objects.</li>\n\
<li>Matrix3&amp; partm - The &#39;parent&#39; transformation matrix.</li>\n\
<li>Matrix3&amp; tmAxis - The axis system about which the selection is transformed.</li>\n\
<li>Point3&amp; val - The amount of the transformation relative to the axis system.</li>\n\
<li>BOOL localOrigin - If TRUE the transformation takes place about the nodes local origin; otherwise about the world origin.</li>\n\
</ul>\n\
<h2 id=\"subobjectcount-\">SubObjectCount()</h2><p><code>SubObjectCount()</code> returns the number of sub-objects at the specified level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object to check.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
</ul>\n\
<h2 id=\"namedselsetcount-\">NamedSelSetCount()</h2><p><code>NamedSelSetCount()</code> returns the number of named selection sets at the specified level</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object to check.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
</ul>\n\
<h2 id=\"getnamedselsetname-\">GetNamedSelSetName()</h2><p><code>GetNamedSelSetName()</code> returns the name of the nth named selection set of the specified sub-object level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object to check.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>int i - The zero based index of the selection set (between 0 and NamedSelSetCount()-1).</li>\n\
</ul>\n\
<h2 id=\"getnamedselset-\">GetNamedSelSet()</h2><p><code>GetNamedSelSet()</code> retrieves the name of, and BitArray holding, the named selelction set for the specified sub-object level.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose named selection set is retrieved.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TCHAR* name - The retrieved name of the set.</li>\n\
<li>BitArray&amp; selSet - The retrieved selection set data. See Class BitArray.</li>\n\
</ul>\n\
<h2 id=\"setnamedselset-\">SetNamedSelSet()</h2><p><code>SetNamedSelSet()</code> sets the specified named selection set. The set must exist. To add a new set see AppendNamedSelSet().</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose named selection set is stored.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TCHAR* name - The name of the set.</li>\n\
<li>BitArray&amp; sel - The selection data.</li>\n\
</ul>\n\
<h2 id=\"appendnamedselset-\">AppendNamedSelSet()</h2><p><code>AppendNamedSelSet()</code> adds a new named selection set to the specified object.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose named selection set list is appended.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>TCHAR* name - The name for the set.</li>\n\
<li>BitArray&amp; sel - The selection data. See Class BitArray.</li>\n\
</ul>\n\
<h2 id=\"deletecurrentselection-\">DeleteCurrentSelection()</h2><p><code>DeleteCurrentSelection()</code> deletes the current sub-object selection.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose current selection is deleted.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
</ul>\n\
<h2 id=\"mapnurbsidtoselsetindex-\">MapNURBSIdToSelSetIndex()</h2><p><code>MapNURBSIdToSelSetIndex()</code> returns the index into a sub-object selection set of the sub-object component.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose sub-object component selection set index is returned.</li>\n\
<li>NURBSId id - The ID of the sub-object to find.</li>\n\
<li>int&amp; index - The zero based selection set index is returned here.</li>\n\
<li>NURBSSubObjectLevel&amp; level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
</ul>\n\
<h2 id=\"mapselsetindextonurbsid-\">MapSelSetIndexToNURBSId()</h2><p>The <code>MapSelSetIndexToNURBSId()</code> returns the NURBSId of the sub-object component whose selection set index is passed.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Object* pObj - Points to the object whose sub-object component NURBSId is returned.</li>\n\
<li>int index - The zero based index into the selection set.</li>\n\
<li>NURBSSubObjectLevel level - The sub-object level. See NURBS Sub-Object Level Options.</li>\n\
<li>NURBSId&amp; id - The ID is returned here.</li>\n\
</ul>\n\
<h3 id=\"updatesurfacemapper-\">UpdateSurfaceMapper()</h3><p>The <code>UpdateSurfaceMapper()</code> function has the effect of pressing the &quot;Update&quot; button. If any other modifier is passed in, the function does nothing.</p>\n\
<p>Parameters</p>\n\
<ul>\n\
<li>Modifier* pMod - Points to the NURBS Surface Mapper WSM.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../additional_functions_for_working.html\">Additional Functions for Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";