var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"materials_assignment_and_texture\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Materials Assignment and Texture Coordinates</h1></div><h2 id=\"materials-and-nurbs\">Materials and NURBS</h2><p>Each NURBS surface has its own material ID. If you assign a Multi-SubObject material you can apply a different material to each surface in a NURBS object. The method to do this is <code>NURBSSurface::MatID()</code>. In release 3.0 and later each <code>NURBSCurve</code> can have an associated material. This is used by the Lathe and Extrude modifiers for example.</p>\n\
<h2 id=\"texture-coordinates-and-nurbs\">Texture Coordinates and NURBS</h2><p>Texture coordinates are assigned to each of the four corners of a NURBS surface. On the standard 3ds Max primitives for example most are assigned to use (0,0) to (1,1) across the surface. Some primitive, such as the Prism, don&#39;t use (0,0) to (1,1) because of the way they wrap. Developers may of course assign any values using the API. The method to do this is <code>NURBSSurface::SetTextureUVs()</code>.</p>\n\
<h2 id=\"sample-code\">Sample Code</h2><p>There is a demonstration utility plugin that utilizes the NURBS API. This is available in  <em>\\MAXSDK\\SAMPLES\\UTILITIES\\NURBS\\</em> . This is an excellent place to look for simple, clear sample code.</p>\n\
<p>The standard 3ds Max primitives also use the NURBS API. See this code in the various primitive objects in directory <em>\\MAXSDK\\SAMPLES\\OBJECTS</em> . Additionally, the Lathe and Extrude use the API. Developers can review this code in  <em>\\MAXSDK\\SAMPLES\\MODIFIERS\\EXTRUDE.CPP</em>  and <em>SURFREV.CPP</em> .</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_nurbs.html\">Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";