var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"nurbs_terminology\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>NURBS Terminology</h1></div><p>This section provides definitions of various terms used later in this topic and in the NURBS classes.</p>\n\
<ul>\n\
<li>NURBS - An acronym for Non-Uniform Rational B-Splines. Non-Uniform means that the extent of a control vertex&#39;s influence can vary. This is useful when modeling irregular surfaces. Rational means that the equation used to represent the curve or surface is expressed as a ratio of two polynomials, rather than a single summed polynomial. The rational equation provides a better model of some important curves and surfaces, especially conic sections, cones, spheres, and so on. A B-spline (for basis spline) is a way to construct a curve that is interpolated between three or more points. Shape curves you create in 3ds Max using the Line tool and other Shape tools are Bezier curves, which are a special case of B-splines.</li>\n\
<li>Point - A point in three-space. A Point Curve or Point Surface is constrained to pass through its points. Points behave somewhat like vertices for 3ds Max spline objects, but their behavior is not identical and they are a distinct object type.</li>\n\
<li>Curve - This is a NURBS Curve. There are two kinds of NURBS curves in 3ds Max. A Point Curve is controlled by points, which always lie on the curve. A CV Curve is controlled by control vertices (CVs), which don&#39;t necessarily lie on the curve.</li>\n\
<li>CV - This is a Control Vertex of a NURBS Curve or NURBS Surface. It&#39;s a vertex that controls a CV Curve or CV Surface. The 3D location of each CV affects the shape of the curve or surface. CVs aren&#39;t constrained to lie on the curve or surface. Each CV has a rational weight that can be used to adjust the influence of the CV on the curve&#39;s or surface&#39;s shape.</li>\n\
<li>Point Curve - A NURBS curve defined by points. The points are constrained to lie on the curve.</li>\n\
<li>CV Curve - A NURBS curve defined by CVs. The CVs don&#39;t necessarily lie on the curve. Instead, they form a control lattice that affects the curvature of the curve.</li>\n\
<li>Surface - This is an individual quadrilateral NURBS Surface. NURBS surfaces have essentially the same properties as NURBS curves, extended from a one-dimensional parameter space to two dimensions.There are two kinds of NURBS surfaces: A Point Surface is controlled by points, which always lie on the surface. A CV Surface is controlled by control vertices (CVs). Instead of lying on the surface, CVs form a control lattice that surrounds the surface.</li>\n\
<li>Point Surface - A NURBS surface defined by points. The points are constrained to lie on the surface. More than one NURBS solution is possible for a Point Surface.</li>\n\
<li>CV Surface - A surface defined by CVs. Instead of lying on the surface, CVs form a control lattice that surrounds the surface.</li>\n\
<li>Independent point/curve/surface - This is an object (point, curve, surface) that is not dependent on any other object.</li>\n\
<li>Dependent point/curve/surface - This is an object (point, curve, surface) that depends on another object to define what it is. For example, a Blend Curve depends on the two curves that it blends between (as well as its own two tension parameters).</li>\n\
<li>Constrained point - Another term for a dependent point. A NURBS Point that is dependent on either another Point, Curve, or Surface, and that exists either on the object or relative to it. The relative cases are XYZ-relative, along a normal, or along a tangent (or set of tangents for a surface-dependent constrained point).</li>\n\
<li>Continuity - A curve is continuous if it is unbroken.</li>\n\
<li>Multiplicity - The property that coincident or nearly coincident CVs reduce the continuity level of the curve or surface. Two coincident CVs locally increase curvature. Three coincident CVs (or more) create an angular cusp. Fusing CVs shows the effect of multiplicity.</li>\n\
<li>Degree - The degree of a curve is highest exponent in the equation used to represent it. A linear equation is degree 1, a quadratic equation degree 2. NURBS curves typically are represented by cubic equations and have a degree of 3.</li>\n\
<li>Order - The order of a curve refers to its mathematical order. For instance a cubic curve is order 4, a quadratic curve is order 3, a linear curve is order 2. This is one more than the degree of polynomial of any segment of the curve.</li>\n\
<li>Iso Line - This is short for isoparametric line. It&#39;s a line of constant parameter value, similar to a contour line. Iso lines can be used to display a NURBS surface.</li>\n\
<li>Segment - The portion of a curve between two of its controlling points or CVs.</li>\n\
<li>Knot - This is a mathematical construct that helps define the span of control of CVs and blending functions that define NURBS Curves and Surfaces. The knots are an array of <em>double</em> precision values that determines the parameterization of a curve. . Values in the knot vector are nondecreasing. The knots specify the region of influence of the CVs on the curve. It is a way of partitioning the parameter space up into different segments. A B spline curve or a NURBS curve is a curve that is defined by a series of segments. On each one of the segments the curve is like a polynomial, or in the case of a rational one, it&#39;s like the ratio of polynomials. The knot vector describes how to partition the parameter space of the curve up for each of the different pieces of the polynomial.</li>\n\
<li>Parameter space - In addition to their existence in 3D space, NURBS objects have a parameter space that includes the array of knot values. NURBS curves have a single U dimension in parameter space. NURBS surfaces have two dimensions, UV, in parameter space.</li>\n\
<li>Refine - To increase the number of CVs on a curve or surface.</li>\n\
<li>B-spline - Short for basis spline. A kind of spline generated by so-called basis functions. The advantage of B-splines over Bezier curves (which are a special case of B-splines) is that the control vertices (CVs) of a B-spline affect only their local region of the curve or surface.</li>\n\
<li>Bezier curve - A curve modeled using a parametric polynomial technique. Bezier curves were developed by P. Bezier for computer modeling in automobile design. They are a special case of B-splines.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_nurbs.html\">Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";