var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"nurbs_curve_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>NURBS Curve Classes</h1></div><h2 id=\"independent-curves\">Independent Curves</h2><p>The following classes provide the ability to create independent curves.</p>\n\
<ul>\n\
<li><code>NURBSCurve</code> - This base class describes the properties of a NURBS curve. This includes its open/closed state, and number of trim points. The <code>Evaluate()</code> method is used to compute points and tangents on the curve.</li>\n\
<li><code>NURBSPointCurve</code> - This class is derived from <code>NURBSCurve</code>. It defines a curve that uses points to describe its shape. All the points lie on the curve itself. There are methods to get/set the number of points in the curve, get/set the points themselves, refine the curve (add points without changing its shape), and to get/set the transformation matrix used by the curve to position it within a NURBSSet.</li>\n\
<li><code>NURBSCVCurve</code> - This class is derived from <code>NURBSCurve</code>. It defines a curve that uses control vertices (CVs) to describe its shape. The CVs define a control lattice which surrounds the curve. This class has methods to close the curve, set its order, number of knots and number of CVs, and get/set the knots and CVs. There is also a method to add additional CVs to the curve.</li>\n\
</ul>\n\
<h2 id=\"dependent-curves\">Dependent Curves</h2><p>A dependent curve is an object that depends on one or more other objects to define what it is. For example, a Blend Curve depends on the two parent curves that it blends between when it was created (as well as on its two tension parameters). The following classes are derived from <code>NURBSCurve</code>.</p>\n\
<ul>\n\
<li><code>NURBSBlendCurve</code> - This class defines a dependent blend curve. A blend curve connects the specified end of one curve to the specified end of another, blending the curvature of the parents to create a smooth curve between them.</li>\n\
<li><code>NURBSOffsetCurve</code> - This class defines a dependent offset curve. An offset curve is offset from the original, parent curve. It lies in the same plane as its parent, and is normal to the original.</li>\n\
<li><code>NURBSXFormCurve</code> - This class defines a dependent transform (xform) curve. A transform curve is a copy of the original curve with a different position, rotation, or scale</li>\n\
<li><code>NURBSMirrorCurve</code> - This class defines a dependent mirror curve. A mirror curve is similar to a mirror object that you create using the Mirror tool (on the 3ds Max toolbar) or the Mirror modifier. It is the original curve relfected about one or two axes.</li>\n\
<li><code>NURBSFilletCurve</code> - This class defines a dependent fillet curve. A fillet is a curve that creates a circular arc corner between two parent curves.</li>\n\
<li><code>NURBSChamferCurve</code> - This class defines a dependent chamfer curve. A chamfer curve creates a straight line corner between two parent curves.</li>\n\
<li><code>NURBSIsoCurve</code> - This class defines a dependent iso curve. U and V iso curves are dependent curves created along lines of constant parameter value of a NURBS surface. Note the difference between &quot;Iso Lines&quot;, which are a display artifact, and &quot;Iso Curves&quot; which are the dependent objects.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview_of_the_principal_nurbs_.html\">Overview of the Principal NURBS Classes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";