var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"nurbs_point_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>NURBS Point Classes</h1></div><h2 id=\"independent-points-\">Independent Points:</h2><p>Independent points are those that don&#39;t rely on other objects to define their location. This is different than the dependent (or constrained) points described later.</p>\n\
<ul>\n\
<li><code>NURBSPoint</code> - This class describes a point in 3 space. It is used as a base class for many of the dependent points in the API. It has methods to set and get the point position in various formats and floating point precisions. This is an abstract base class so only objects that are subclasses of this class can be created.</li>\n\
<li><code>NURBSIndependentPoint</code> - This class is derived from <code>NURBSPoint</code>. It is used to create an independent, free-standing point. There are methods to set the position of the point in various floating point formats and operators to compare points.</li>\n\
<li><code>NURBSControlVertex</code> - This is a Control Vertex of a NURBS Curve or NURBS Surface. This class shares may of the same properties as a <code>NURBSPoint</code> and has the added property of a rational weight. The weight value of a CV is rational. That is, it is relative to other CVs in the curve or surface. Changing the weight of all CVs at once has no effect, because this doesn&#39;t change the ratio between weights.</li>\n\
<li><code>NURBSTrimPoint</code> - This class defines a point on a curve used to trim a portion of the curve from the point towards one of the ends of the curve.</li>\n\
</ul>\n\
<h2 id=\"dependent-constrained-points-\">Dependent (Constrained) Points:</h2><p>The following classes provide the ability to create dependent points. Dependent points are related to the objects they depend on such that the relationship established initially remains if the point, curve or surface moves. For example, a point can be created such that it always remains a certain distance from another point. The options are XYZ-relative, along a normal, or along a tangent (or set of tangents for a surface-dependent constrained point).</p>\n\
<p>All the following classes are derived from <code>NURBSPoint</code>.</p>\n\
<ul>\n\
<li><code>NURBSPointConstPoint</code> - This class is used to create a dependent point that lies at a point or relative to it. It is a point constrianed relative to another point. This can be a point used to define a point surface or point curve, it can be a trim point, or just a point in space.</li>\n\
<li><code>NURBSCurveConstPoint</code> - This class is used to create a dependent point that lies on a curve or relative to it.</li>\n\
<li><code>NURBSCurveCurveIntersectionPoint</code> - This class is used to create a dependent point at the intersection of two curves.</li>\n\
<li><code>NURBSSurfConstPoint</code> - This class is used to create a dependent point on a surface or related to it.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview_of_the_principal_nurbs_.html\">Overview of the Principal NURBS Classes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";