var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"nurbs_surface_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>NURBS Surface Classes</h1></div><h2 id=\"independent-surface-classes\">Independent Surface Classes</h2><ul>\n\
<li><code>NURBSSurface</code> - This base class describes the properties of a NURBS surface. This includes its material ID, texture/tiling options, renderable state, and open/closed state, and normal inverted state. The <code>Evaluate()</code> method is used to compute points and tangents on the surface.</li>\n\
<li><code>NURBSPointSurface</code> - This class is derived from <code>NURBSSurface</code>. It defines a surface that uses points to describe its shape. This class has methods to close the surface in U and V, set the number of points in U and V, and get/set the points in U and V. There is also a method to add additional points to the surface. The point surface has a transformation matrix used to set the position of the surface within a <code>NURBSSet</code>.</li>\n\
<li><code>NURBSCVSurface</code> - This class is derived from <code>NURBSSurface</code>. It defines a surface that uses control vertices (CVs) to describe its shape. The CVs define a control lattice which surrounds the surface. This class has methods to close the surface in U and V, set its order in U and V, set the number of knots and CVs in U and V, and get/set the knots and CVs in U and V. There is also a method to add additional CVs to the surface. The CV surface has a transformation matrix used to position the surface within a <code>NURBSSet</code>.</li>\n\
</ul>\n\
<h2 id=\"dependent-surfaces\">Dependent Surfaces</h2><p>Dependent surfaces are surface sub-objects whose geometry depends on other surfaces or curves in the NURBS model. When you change the geometry of the original parent surface or curve, the dependent surface changes as well.</p>\n\
<ul>\n\
<li><code>NURBSBlendSurface</code> - This class defines a dependent blend surface. A blend surface connects the edge of one surface to the edge of another, blending the curvature of the parents to create a smooth surface between them.</li>\n\
<li><code>NURBSOffsetSurface</code> - This class defines a dependent offset surface. An Offset surface is offset a specified distance from the original along the parent surface&#39;s normals.</li>\n\
<li><code>NURBSXFormSurface</code> - This class defines a dependent transform (xform) surface. A transform surface is a copy of the original surface with a different position, rotation, or scale</li>\n\
<li><code>NURBSMirrorSurface</code> - This class defines a dependent mirror surface. A mirror surface is similar to a mirror object that you create using the Mirror tool (on the 3ds Max toolbar) or the Mirror modifier. It is the original surface relfected about one or two axes.</li>\n\
<li><code>NURBSRuledSurface</code> - This class defines a dependent ruled surface. A ruled surface is generated from two curve sub-objects. It lets you use curves to design the two opposite borders of a surface.</li>\n\
<li><code>NURBSULoftSurface</code> - This class defines a dependent U Loft surface. A U Loft surface interpolates a surface across multiple curve sub-objects. The curves become U-axis contours of the surface.</li>\n\
<li><code>NURBSExtrudeSurface</code> - This class defines a dependent extrude surface. An extrude surface is extruded from a curve sub-object. It is similar to a surface created with the Extrude modifier. The advantage is that an extrude sub-object is part of the NURBS model, so you can use it to construct other curve and surface sub-objects</li>\n\
<li><code>NURBSLatheSurface</code> - This class defines a dependent lathe surface. A lathe surface is generated from a curve sub-object. It is similar to a surface created with the Lathe modifier. The advantage is that a lathe sub-object is part of the NURBS model, so you can use it to construct other curve and surface sub-objects.</li>\n\
<li><code>NURBSCurveSurfaceIntersectionPoint</code> - This class is used to create a dependent point at the intersection of a curve and a surface.</li>\n\
<li><code>NURBSProjectNormalCurve</code> - This class provides access to the Normal Proejcted Curve. A Normal Projected curve lies on a surface. It is based on an existing curve, which is projected onto the surface in the direction of the surface&#39;s normals</li>\n\
<li><code>NURBSProjectVectorCurve</code> - This class provides access to the Vector Projected Curve. A Vector Projected curve lies on a surface. This is almost the same as a Normal Projected curve, except that the projection from the existing curve to the surface is in the direction of a vector that you can control. Vector projected curves may be used for trimming.</li>\n\
<li><code>NURBSSurfaceNormalCurve</code> - This provides access to the Surface Normal Curve. This is a curve created at a specified distance from a surface and normal to it.</li>\n\
<li><code>NURBSSurfSurfIntersectionCurve</code> - This class provides access to the Surface-Surface Intersection Curve. This is a curve that is defined by the intersection of two surfaces. You can use surface-surface intersection curves for trimming.</li>\n\
<li><code>NURBSCurveOnSurface</code> - This class provides access to the CV curve on surface parameters. These curves can be used for trimming the surface they lie on.</li>\n\
<li><code>NURBSPointCurveOnSurface</code> - This class provides access to the point curve on surface parameters. These curves can be used for trimming the surface they lie on.</li>\n\
<li><code>NURBSUVLoftSurface</code> - This class provides access to the UV Loft Surface. This surface is similar to the U Loft surface, but has a set of curves in the V dimension as well as the U dimension.</li>\n\
<li><code>NURBSNBlendSurface</code> - This class provides access to the Multisided Blend surface. A Multisided Blend surface is a surface that &quot;fills in&quot; the edges defined by three or four other curve or surfaces. Unlike a regular, two-sided blend surface, the curves or surfaces edges must form a closed loop. They must completely surround the opening the Multisided Blend will cover.</li>\n\
<li><code>NURBS1RailSweepSurface</code> - This class provides access to the 1-Rail Sweep Surface. A 1-Rail Sweep Surface uses at least two curves. One curve, the &quot;rail,&quot; defines one edge of the surface. The other curves define the surface&#39;s cross sections. The cross-section curves should intersect the rail curve. If the cross sections don&#39;t intersect the rail, the resulting surface is unpredicable.</li>\n\
<li><code>NURBS2RailSweepSurface</code> - This class provides access to the 2-Rail Sweep Surface. A 2-Rail Sweep surface uses at least three curves. Two curves, the &quot;rails,&quot; define the two edges of the surface. The other curves define the surface&#39;s cross sections. A 2-Rail Sweep surface is similar to a 1-Rail sweep. The additional rail gives you more control over the shape of the surface.</li>\n\
<li><code>NURBSCapSurface</code> - This class provides access to the Cap Surface. A Cap Surface is a surface that caps a closed curve or the edge of a closed surface. Caps are especially useful with extruded surfaces.</li>\n\
<li><code>NURBSMultiCurveTrimSurface</code> - This class provides access to the mult-icurve trim surface which is a surface that is trimmed by multiple curves forming a loop.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview_of_the_principal_nurbs_.html\">Overview of the Principal NURBS Classes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";