var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"the_nurbs_api\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>The NURBS API</h1></div><p>The NURBS API provides an interface into the NURBS objects used by 3ds Max. Unlike much of the 3ds Max API, the NURBS objects 3ds Max provides don&apos;t use this API. Rather, the NURBS API has been added to allow developers to access the NURBS objects 3ds Max uses internally. Using the API developer can create new NURBS objects or modify existing ones.</p>\n\
<h2 id=\"classids-of-the-nurbs-objects\">ClassIDs of the NURBS Objects</h2><p>Developers can check if an object is a NURBS object by checking it <code>ClassID()</code>. If it matches any of the following</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#define EDITABLE_SURF_CLASS_ID    Class_ID(0x76a11646, 0x12a822fb)\n\
#define FITPOINT_PLANE_CLASS_ID    Class_ID(0x76a11646, 0xbadbeef)\n\
#define EDITABLE_CVCURVE_CLASS_ID   Class_ID(0x76a11646, 0x12a82144)\n\
#define EDITABLE_FPCURVE_CLASS_ID   Class_ID(0x76a11646, 0x12a82142)</code></pre><p>then it&apos;s a NURBS object and the NURBS API may be used to manipulate it.</p>\n\
<h2 id=\"necessary-include-file\">Necessary Include File</h2><p>The main NURBS include file is <code>\\\\MAXSDK</code>\\INCLUDE\\SURF_API.H. This is not included by default by <code>MAX</code>.H so you need to specifically include it via the following statement:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include&quot;surf_api.h&quot;</code></pre><h2 id=\"reference-information-on-nurbs-mathematics\">Reference Information on NURBS Mathematics</h2><p>Developers who wish to understand the mathematics of NURBS should see:</p>\n\
<p>The NURBS Book: Les Piegl, Wayne Tiller, The NURBS Book (Berlin Heidelberg New York: Springer-Verlag, 1995). ISBN: 3-540-55069-0.</p>\n\
<h2 id=\"nurbsids-and-indexes\">NURBSIds and Indexes</h2><p>An important concept to understand when working with <code>NURBSSet</code>s and the other NURBS classes is the way you identify component items that are in the set. Before a <code>NURBSet</code> is instantiated in the scene as a NURBS object, the individual points, curves, and surfaces are identified by an index number. As you append objects to the set they are assigned successive indexes, starting at 0. When you want to refer to a particular item, say to specify the parent surfaces in a blend surface, you use this index. Once an object has been added to a <code>NURBSSet</code>, its index can retrieved using.</p>\n\
<p>However, once a <code>NURBSSet</code> is associated with a scene object, either by being instantiated or because it was directly created from an existing scene object, this index is no longer valid. Instead, a different number, called a <code>NURBSId</code>, is assigned to each item and you must use that Id when referring to items from then on. The <code>NURBSId</code> of any item in an instantiated <code>NURBSSet</code> can be obtained through the <code>NURBSObject::GetId()</code> method of that object.</p>\n\
<h2 id=\"seed-value-parameters\">Seed Value Parameters</h2><p>Some kinds of dependent objects depend on geometry that might have more than one solution. For example, if you want to create a surface-curve intersection point but the curve intersects the surface more than once, 3ds Max must decide which intersection is to be the location of the point.</p>\n\
<p>For these kinds of objects, seed value parameters control the decision. The seed location is a location on a parent object, and the location nearest to the seed value that satisfies the creation condition is the one that 3ds Max chooses.</p>\n\
<p>For example, the seed location for a surface-curve intersection point is a U position along the length of the parent curve. The surface-curve intersection closest to the seed is chosen as the location of the dependent point.</p>\n\
<p>For a surface, the seed location is a pair of UV coordinates in the surface&apos;s parameter space.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_nurbs.html\">Working with NURBS</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";