var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"interface_querying\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Interface Querying</h1></div><p>When navigating a scene a plug-in reference will often be retrieved without knowledge of the concrete type of the plug-in. There are two separate mechanism used for querying run-time type information from a plug-in. Each mechanism uses a method named &quot;GetInterface()&quot;. These methods both return an abstract base class (interface) using an interface identifier.</p>\n\
<h2 id=\"interfaceserver-getinterface-\">InterfaceServer::GetInterface()</h2><p>The first mechanism to retrieve interfaces is the <code>InterfaceServer::GetInterface()</code> which uses the type <code>Interface_ID</code> to identify interfaces. An <code>Interface_ID</code> for a given interface can usually be found as a macro in the same file as the interface definition. For example <code>IDX8PixelShader</code> has its interface ID defined in the same header file <code>idx8pixelshader.h</code>.</p>\n\
<h2 id=\"animatable-getinterface-\">Animatable::GetInterface()</h2><p>The other mechanism to retrieve interfaces is <code>Animatable::GetInterface()</code> which uses integers to identify interface IDs. Consult the C++ Reference&#39;s &quot;<code>Modules &amp;gt; List of interface IDs supported by different plugin types</code>&quot; for the list of pre-defined constants used to identify interfaces. Checking whether an animatable implements a certain interface is the recommended way for determining if that animatable can be used as the type represented by that interfaced, as opposed to performing casts using <code>dynamic_cast</code> or <code>static_cast</code>.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> <code>Animatable</code> derives from <code>InterfaceServer</code>, so objects deriving from <code>Animatable</code> will need to support both <code>InterfaceServer::GetInterface()</code> and <code>Animatable::GetInterface()</code>.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-ins.html\">Working with Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";