var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_blocks\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter Blocks</h1></div><p>Parameter blocks provide a mechanism for storing values associated with a plug-in. The parameter block is useful for exposing the values to a user using UI controls. The parameter block managing the controller which handles the interpolation or generation of values. Parameter blocks are implemented as an object of class <code>IParamBlock2</code>.</p>\n\
<p>When a parameter block is constructed the developer specifies the number of parameters, types, and associated UI controls (if any) of each parameter using a parameter block descriptor. Parameter types consist of a range of built in types like integer, float, 3D Point, and Color.</p>\n\
<p>Parameters may be animated or constant. In order for a parameter to be animatable, it must have a <a href=\"./../animation_time_and_controllers.html\">Animation, Time, and Controllers</a>. Different parameter types require different controller types. For example, a floating point value, like the angle parameter for the bend modifier, requires a floating point controller. A node transformation matrix requires a transform controller. The most common controllers are interpolating or &#39;key frame&#39; controllers.</p>\n\
<p>The following image demonstrates how parameters can be accessed from multiple locations such as the track-view and the roll-out:</p>\n\
<p><img src=\"./images/GUID-885B1D55-67C3-43FB-8D12-92566BE6DC7F-low.png\" alt=\"\"></p>\n\
<p>One of the main purposes of parameter blocks is to manage the complexity of maintaining different animation controllers for different parameters. To access the values in the parameter block, the plug-in developer uses <code>GetValue()</code> and <code>SetValue()</code> methods, each take a <code>TimeValue</code> as a parameter. If the value hasn&#39;t yet been animated, that is, <code>SetValue()</code> hasn&#39;t been called with time not equal to 0, then a constant value is stored. When <code>SetValue()</code> is called with time not equal to 0, and animation starts, a new instance of the default controller for the parameter type is plugged in to the parameter block and initialized with the parameter&#39;s values. The parameter block also handles displaying animated parameters in the track view.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/responsibilities_of_a_parameter_.html\">Responsibilities of a Parameter Block</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/parameter_block_ui.html\">Parameter Block UI</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/creating.html\">Creating a Parameter Block</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/saving_loading_and_deleting_para.html\">Saving, Loading, and Deleting Parameter Blocks</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/getting_and_setting_pb_values.html\">Getting and Setting Parameter Block Values</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/accessing_and_exposing_parameter.html\">Accessing and Exposing Parameter Blocks</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/pb1_to_pb2_conversion.html\">Updating from ParamBlock1 to Paramblock2</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/parameter_block_1.html\">Parameter Block 1</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_blocks/advanced.html\">Advanced Parameter Block Topics</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-ins.html\">Working with Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";