var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"monitoring_parameter_changes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Monitoring Parameter Changes</h1></div><p>Developers can monitor parameter changes using a call-back mechanism, by overriding the <code>PBAccessor</code> class. This allows continuous monitoring of the parameter change. <code>PBAccessor</code> has a get method, <code>PBAccessor::Get()</code>, and three set methods, <code>PBAccessor::PreSet()</code>, <code>PBAccessor::PostSet()</code>, and <code>PBAccessor::Set()</code>. As of 3ds Max 2018, plug-ins should generally use <code>PreSet()</code>, as the state of the value returned by <code>GetValue()</code> inside this method is guaranteed to be the &quot;original&quot; value. (In <code>PostSet()</code>, it&apos;s guaranteed to be the new value).</p>\n\
<p>In the bend modifier in the below example, the function <code>Set()</code> has been used to check the values of <code>bend_from</code> and <code>bend_to</code>.</p>\n\
<p><code>PBAccessor::Set()</code> is passed a <code>PB2Value</code> structure which holds the data being changed and an ID of the parameter changing. The following <code>PBAccessor</code> changes the value of <code>bend_from</code> and <code>bend_to</code> depending on a comparison of each other.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class bendPBAccessor : public PBAccessor\n\
{\n\
public:\n\
   void Set(PB2Value&amp; v, ReferenceMaker* owner, ParamID id, int tabIndex, TimeValue t)\n\
   {\n\
     BendMod* u = (BendMod*)owner;\n\
     IParamMap2* pmap = u-&gt;pblock2-&gt;GetMap();\n\
     float from, to;\n\
\n\
     switch(id)\n\
     {\n\
      case bend_from:\n\
         u-&gt;pblock2-&gt;GetValue(bend_to,t,to,FOREVER);\n\
         from = v.f;\n\
         if (from &gt;to) {\n\
          u-&gt;pblock2-&gt;SetValue(bend_to,t,from);\n\
         }\n\
         break;\n\
\n\
      case bend_to:\n\
         u-&gt;pblock2-&gt;GetValue(bend_from,t,from,FOREVER);\n\
         to = v.f;\n\
         if (from&gt;to) {\n\
          u-&gt;pblock2-&gt;SetValue(bend_from,t,to);\n\
         }\n\
         break;\n\
     }\n\
   }\n\
};\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced.html\">Advanced Parameter Block Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";