var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_multiple_roll-ups\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using Multiple Roll-ups</h1></div><p>The <code>P_MULTIMAP</code> flag in the parameter block descriptor indicates that the block being described will have more than one rollup. Here&apos;s a sample rework of the main parameter block in GeoSphere into two rollups:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">enum { geo_map_1, geo_map_2 }; // enum IDs for the 2 parammaps\n\
\n\
static  ParamBlockDesc2 geo_param_blk ( geo_params, _M(&quot;GeosphereParameters&quot;),\n\
                    0, &amp;gsphereDesc, P_AUTO_CONSTRUCT +\n\
                   P_AUTO_UI + P_MULTIMAP, PBLOCK_REF_NO,\n\
\n\
// map rollups\n\
2,\n\
geo_map_1, IDD_GSPHERE_1, IDS_PARAMETERS_1, 0, 0, NULL,\n\
geo_map_2, IDD_GSPHERE_2, IDS_PARAMETERS_2, 0, 0, NULL,\n\
\n\
// params\n\
geo_hemi, _M(&quot;hemisphere&quot;), TYPE_BOOL, P_ANIMATABLE, IDS_HEMI,\n\
   p_default, FALSE,\n\
   p_ui, geo_map_2, TYPE_SINGLECHEKBOX, IDC_HEMI,\n\
   p_end,\n\
geo_segs, _M(&quot;segs&quot;), TYPE_INT, P_ANIMATABLE, IDS_RB_SEGS,\n\
   p_default, 4,\n\
   p_range, MIN_SEGMENTS, MAX_SEGMENTS,\n\
   p_ui, geo_map_1, TYPE_SPINNER, EDITTYPE_INT,\n\
   IDC_SEGMENTS, IDC_SEGSPINNER, 0.05f,\n\
   p_end,\n\
geo_radius, _M(&quot;radius&quot;), TYPE_FLOAT, P_ANIMATABLE + P_RESET_DEFAULT, IDS_RB_RADIUS,\n\
   p_default, 0.0,\n\
   p_ms_default, 25.0,\n\
   p_range, MIN_RADIUS, MAX_RADIUS,\n\
   p_ui, geo_map_1, TYPE_SPINNER, EDITTYPE_UNIVERSE,\n\
   IDC_RADIUS, IDC_RADSPINNER, 1.0,\n\
   p_uix, geo_map_2,\n\
   p_end,\n\
\n\
//...</code></pre><p>First, there is an enum to provide IDs for the two maps in the main block, geo_map_1 and geo_map_2. The <code>P_MULTIMAP</code> flag is added to the block flags in the main descriptor constructor arguments to indicate multiple parameter maps are present. If <code>P_AUTO_UI</code> is specified, the usual single rollup template spec is replaced by a count (of rollups) followed by that many sets of rollup specs, each beginning with the associated mapID. The auto UI mechanism will add the rollups in the order given in this list.</p>\n\
<p>In the parameter definition section, the only other change needed is that the <code>p_ui</code> tag will require a map ID before the rest of the UI specification to say which rollup the parameter specification relates to. In this case, we&apos;ve put the hemisphere checkbox in the 2nd rollup and the &quot;segs&quot; and &quot;radius&quot; spinners in the first.</p>\n\
<p>The option <code>p_uix</code> is used to indicate that a parameter is to appear in more than one rollup. In this case, the radius spinner also shows up in the second rollup, geo_map_2. When you do this, all the controls that connect to this parameter are ganged together; they all change when any one of them changes and all show keyframe highlights and so on. The current limitations on this are that the type of UI control and its various dialog template item IDs must be the same in each rollup in which it appears.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced.html\">Advanced Parameter Block Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";