var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating a Parameter Block</h1></div><p>Parameter blocks are created from parameter block descriptors (<code>ParamBlockDesc2</code>). There are two methods for a plug-in to create a parameter block. The most common method is through a call to <code>ClassDesc2::MakeAutoParamBlocks()</code>. This will ask 3ds Max to automatically create all parameter blocks that have been registered with the class descriptor using the method, <code>ClassDesc2::AddParamBlockDesc()</code>. In order for this approach to work, parameter block descriptions needs to have the <code>P_AUTO_CONSTRUCT</code> flag set.</p>\n\
<p>It is standard practice to call the <code>ClassDesc2::MakeAutoParamBlocks()</code> when the plug-in object gets created - usually this is done in the plug-in&apos;s constructor function. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">const BlockID paramBlockID = 0;\n\
\n\
static MyClassDesc2 classDesc;\n\
\n\
static  ParamBlockDesc2 blockDesc(paramBlockID, &quot;my_class&quot;,\n\
  MY_ROLLOUT_TITLE_RES_STRING_ID, &amp;classDesc, P_AUTO_CONSTRUCT | P_AUTO_UI | ..., ...);\n\
\n\
MyClass::MyClass()\n\
{\n\
    classDesc.MakeAutoParamBlocks(this);\n\
}</code></pre><p>The global function <code>CreateParameterBlock2()</code> from the file <code>iparamb2</code>.h can also be used to create a parameter block manually.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"creating/describing_a_parameter_block.html\">Describing a Parameter Block</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"creating/parameter_block_flags.html\">Parameter Block Flags</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"creating/parameter_block_ui_specification.html\">Parameter Block UI Specification Arguments</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"creating/parameter_specification_argument.html\">Parameter Specification Arguments</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_blocks.html\">Parameter Blocks</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";