var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_block_flags\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter Block Flags</h1></div><p>The following are the block/descriptor flags. One or more flags may be OR&apos;d together as in <code>P_AUTO_CONSTRUCT</code> | <code>P_AUTO_UI</code>.</p>\n\
<p><code>P_VERSION</code> - Indicates that a version number is expected immediately after the flags field, before the reference number field. This version number will be stored as type <code>ParamBlockDesc2::version</code> and returned as a <code>IParamBlock2::GetVersion()</code>.</p>\n\
<p><code>P_CLASS_PARAMS</code> - Indicates this block holds class-level parameters which are attached to the ClassDesc2 for the plug-in. Such class level parameters are shared by each instance of the class. The block is automatically allocated by and stored in the descriptor. You get at its parameters via GetValue()/SetValue() calls on the descriptor.</p>\n\
<p><code>P_AUTO_CONSTRUCT</code> - Indicates the parameter block2 will be constructed and referenced automatically to its owner in the call to ClassDesc2::MakeAutoParamBlocks(). If this flag is set, the parameter block&apos;s reference number in the owning object should be given immediately following the flag word in the descriptor constructor. See &lt;auto_construct_block_refno&gt; .</p>\n\
<p><code>P_AUTO_UI</code> - Indicates this block supports automatic UI rollout management in calls to ClassDesc2::BeginEditParams(), ClassDesc2::EndEditParams(),ClassDesc2::CreateParamDlg(), ClassDesc2::CreateParamDialog(), etc.</p>\n\
<p>If set, the &lt;auto_ui_parammap_specs&gt; must be supplied in the descriptor constructor.</p>\n\
<p><code>P_HASCATEGORY</code> - The category field that can be used to order rollups (see Class IRollupWindow) to various Parameter Map creation methods. In order to use the category field with AutoUI, this flag has to be declared together with P_AUTO_UI in the ParamBlockDesc2. An additional int, that describes the category has to be appended to the parameter list after the ParamMap2UserDlgProc* proc parameter. The same thing is true for multimaps. The P_HASCATEGORY field can only be declared for the whole pblock. That means, that every multimap has to have the category parameter. To use the standard value ROLLUP_CAT_STANDARD can be used. In the example below 4900 is used as the integer describing the category;</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static  ParamBlockDesc2 std2_shader_blk ( std2_shader,\n\
_M(&quot;shaderParameters&quot;), 0, &amp;stdmtl2CD,\n\
P_AUTO_CONSTRUCT + P_AUTO_UI + P_HASCATEGORY, SHADER_PB_REF,\n\
//rollout\n\
IDD_DMTL_SHADER4, IDS_KE_SHADER, 0, 0, &amp;shaderDlgProc, 4900,\n\
// params\n\
std2_shader_type, _M(&quot;shaderType&quot;), TYPE_INT, 0, IDS_JW_SHADERTYPE,</code></pre><p><code>P_USE_PARAMS</code> - Indicates that this block shares (exactly) the parameter definitions from another descriptor. This is used to specify an already established <code>ParamBlockDesc2</code> instance whose parameters you wish to share. This effectively gives the referring descriptor a pointer to the established descriptors parameter definitions array. In this case no other parameters definition can be supplied to referencing descriptors constructor.</p>\n\
<p><code>P_INCLUDE_PARAMS</code> - Indicates that this block loads in a copy the parameter definitions from another descriptor. This is used to take a copy of an already established descriptor&apos;s parameters, to which you can add extra parameter definitions in the referencing descriptors constructor. This provides a method to reuse common parameters, but note it is a copy; any subsequent changes to the referenced descriptor&apos;s parameter definitions are not reflected in the referencing descriptor.</p>\n\
<p>You give the pointer to the <code>ParamBlockDesc2</code> supplying the existing parameter definitions following the other optional block-level parameters: following the flag word is the block&apos;s reference number if <code>P_AUTO_CONSTRUCT</code> is specified, then the rollout dialog template info if P_AUTO_UI is specified, then the pointer to the sourcing descriptor if <code>P_USE_PARAMS</code> or <code>P_INCLUDE_PARAMS</code> is specified. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static  ParamBlockDesc2 metal2_param_blk ( shdr_params, _M(&quot;shaderParameters&quot;), 0, &amp;metalCD, P_AUTO_CONSTRUCT + P_USE_PARAMS,\n\
// pblock refno 0,\n\
// use params from existing descriptor\n\
&amp;const_param_blk\n\
);</code></pre><p><code>P_SCRIPTED_CLASS</code> - This is for internal use only. It means that the descriptor was defined on the fly as a side-effect of writing a scripted plug-in.</p>\n\
<p><code>P_TEMPORARY</code> - This is for internal use only.</p>\n\
<p><code>P_TEMPLATE_UI</code> - This indicates that dialog templates will be provided or constructed.</p>\n\
<p><code>P_CALLSETS_ON_LOAD</code> - Signals that this block should have <code>IParamBlock2::CallSets()</code> called on it during post-load processing on scene loads &amp;merges. This effectively ensures that all <code>PBAccessor::Set()</code> methods will be called after the flagged parameter block is fullyloaded, so that they can track loaded parameter values, forexample. This allows a single point for parameter value tracking inthe <code>PBAccessor::Set()</code> and precludes the need for individual objects to implementparameter load callbacks to do this tracking themselves. <code>P_MULTIMAP</code> - Indicates that the block being described will have more than onerollup/map. If you specify this flag, the constructor interpretsthe rollup template and parameter definitions arguments in amodified syntax. For more information see the topic <a href=\"./../advanced/using_multiple_roll-ups.html\">Using Multiple Roll-ups</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../creating.html\">Creating a Parameter Block</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";