var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_flags\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter Flags</h1></div><p>The following are the flags used in the parameter specification.</p>\n\
<ul>\n\
<li><code>P_ANIMATABLE</code> - Indicates the parameter is animatable.</li>\n\
<li><code>P_TRANSIENT</code> - Indicates the parameter should not be saved in the scene file. One might do this, for example, for virtual parameters that don&#39;t actually hold data but reflect data held elsewhere in the object (and accessed via a <code>PBAccessor</code>) which is saved explicitly by it. This might save file space. In some cases, parameters might be provided that are derived from other state in the object that is computed each time you load the object and made available say as a help to script authors. In these cases also, you might decide not to take up file space.</li>\n\
<li><code>P_NO_INIT</code> - This is obsolete.</li>\n\
<li><code>P_COMPUTED_NAME</code> - This allows a plug-in to provide a dynamically-created local name for a parameter or <code>Tab</code>&lt;&gt; parameter entry. If you specify this parameter flag, you also need to supply a <code>PBAccessor</code> instance pointer (using the <code>p_accessor</code> tag) that has the <code>PBAccessor::GetLocalName()</code> method implemented.</li>\n\
<li><code>P_INVISIBLE</code> - Prevents the animatable parameter from being shown in the track view.</li>\n\
<li><code>P_RESET_DEFAULT</code> - Indicates to not make creation parameters sticky, rather always reset to default values.</li>\n\
<li><code>P_SUBANIM</code> - Indicates this is a non-animatable reference target parameter is to be published as a sub-animatable. This makes it visible in Track View.</li>\n\
<li><code>P_TV_SHOW_ALL</code> - This is used for <code>Tab</code>&lt;&gt; animatable parameters, and indicates to show all entries in Track View even if there is no controller assigned.</li>\n\
<li><code>P_NO_REF</code> - For reference target parameters, this indicates to not maintain the reference automatically (rather simply keep a copy of the pointer).</li>\n\
<li><code>P_OWNERS_REF</code> - Indicates this is a reference target parameter owned by the parameter block&#39;s owner not the block itself. Make sure to supply the owner&#39;s reference number using the <code>p_refno</code> tag. If neither <code>P_REF_NO</code> or <code>P_OWNERS_REF</code> is set, the parameter block owns and maintains the reference.</li>\n\
<li><code>P_CAN_CONVERT</code> - Indicates the validator supplied using the <code>p_classID</code> tag is used in a call to the <code>CanConvertoTo()</code> function, rather than requiring an exact <code>ClassID</code> match.</li>\n\
<li><code>P_SUBTEX</code> - Indicates a texture map parameter is managed by the owner using the <code>MtlBase</code> sub-texture map methods. The integer index of the sub-texture map must be provided using the <code>p_subtexno</code> tag. See the <a href=\"./../../advanced/sub-texture_map_parameters.html\">Sub-Texture Map Parameters</a> topic for more information.</li>\n\
<li><code>P_VARIABLE_SIZE</code> - Indicates a <code>Tab</code>&lt;&gt; parameter is variable in size. This allows scripted changes.</li>\n\
<li><code>P_NO_AUTO_LABELS</code> - Disables the automatic setting of button text for texture maps, materials, files, etc. You can use the method <code>IParamMap2::SetText()</code> to set it by hand.</li>\n\
<li><code>P_SHORT_LABELS</code> - This is for use with TYPE_TEXMAP, TYPE_MTL and TYPE_BITMAP parameters that are associated with ParamMap2 picker buttons. If you specify this flag, a shortened form of the object name is installed in the picker button label. For texture maps and materials, the <code>MtlBase::GetName()</code> rather than <code>MtlBase::GetFullName()</code> is used, and for bitmaps just the filename rather than the full path name is used.</li>\n\
<li><code>P_READ_ONLY</code> - This parameter can not be assigned using MAXScript. It allows try-and-buy 3rd-party plugins.</li>\n\
<li><code>P_OBSOLETE</code> - When used as a parameter flag, the parameter will not be saved to disk or maintain references or animation keys. When loading older files, the parameter will be reset after the load is completed, but will be valid during a post-load callback</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_specification_argument.html\">Parameter Specification Arguments</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";