var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_tags\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter Tags</h1></div><p>The following are the optional parameter tags. These are special values used in the <code>ParamBlockDesc2</code> constructor or the <code>ParamBlockDesc2::ParamOption()</code> method to indicate additional information is present. They are defined as enumerated values in the enumeration <code>ParamTags</code>.</p>\n\
<p><code>p_default</code> - This identifies the next values as the default value assigned when a block is first created. The default value must be of the correct type to match the <code>ParamType</code> of the parameter. For example <code>float</code> (or <code>TYPE_FLOAT_TYPE</code>) for <code>TYPE_FLOAT</code>s, <code>Point3</code> (or <code>TYPE_RGBA_TYPE</code>) for <code>TYPE_RGBA</code>, etc.) Defaults can only be supplied for the following base types: <code>TYPE_ANGLE</code>, <code>TYPE_PCNT_FRAC</code>, <code>TYPE_COLOR_CHANNEL</code>, <code>TYPE_FLOAT</code>, <code>TYPE_TIMEVALUE</code>, <code>TYPE_INT</code>, <code>TYPE_BOOL</code>, <code>TYPE_RADIOBTN_INDEX</code>, <code>TYPE_POINT3</code>, <code>TYPE_RGBA</code>, <code>TYPE_STRING</code>, <code>TYPE_FILENAME</code>, <code>TYPE_MATRIX3</code>.</p>\n\
<div class=\"note note:\"><strong><span class=\"notetitle\">Note:</span></strong> An explicit dimension specified by <code>p_dim</code> is not applied to the value specified by <code>p_default</code>, nor is implicit dimensioning by type (for example,\n\
<code>TYPE_ANGLE</code>).  The default is considered a &quot;raw&quot; data value.  For example, for <code>p_dim, stdPercentDim</code>, a default of 1 corresponds to 100%.\n\
However, the dimension <em>is</em> applied to <code>p_range</code> values.</div>\n\
<p>Examples:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_default,   FALSE,\n\
p_default,   1,\n\
p_default,   Point3(0,0,0),\n\
p_default,   25.0,</code></pre><p><code>p_ms_default</code> - This establishes the default value used during MAXScript creation. For example the MAXScript command <code>sphere</code>. radius defaults to 25.0 when created by the script engine, but <code>p_default</code> is set to 0.0 so interactive creation starts out with a point-sized sphere when the first mouse click is made.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_ms_default, 25.0,</code></pre><p><code>p_range</code> - This establishes allowable ranges used in MAXScript validation and spinner setup. Supplied as two values of the correct type. Ranges can only be supplied for the following types: <code>TYPE_ANGLE</code>, <code>TYPE_PCNT_FRAC</code>, <code>TYPE_COLOR_CHANNEL</code>, <code>TYPE_FLOAT</code>, <code>TYPE_TIMEVALUE</code>, <code>TYPE_INT</code>, <code>TYPE_RADIOBTN_INDEX</code>, <code>TYPE_POINT3</code>, <code>TYPE_RGBA</code>.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_range,   -99999999.0, 99999999.0,</code></pre><p><code>p_ui</code> - This is the user interface control specification. For more information see the topic <a href=\"parameter_ui_control_types.html\"\">Parameter UI Control Types</a>.</p>\n\
<p><code>p_uix</code> - This specifies which additional rollup / map the parameter is supposed to appear in.</p>\n\
<p><code>p_validator</code> - Specifies a validator object. You supply a pointer to an instance of a class derived from <code>PBValidator</code>. This class has a <code>PBValidator::Validate()</code> method which should return <code>TRUE</code> if the <code>PB2Value</code> passed to it is valid, or <code>FALSE</code> otherwise. This can be used for instance by a node pick button to check if a chosen node is acceptable.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_validator, &amp;fOutValidator,</code></pre><p><code>p_accessor</code> - Specifies an accessor object (see Class PBAccessor). You supply a pointer to an instance of a class derived from PBAccessor. This class is used to provide a parameter Get/SetValue callback. The callback can be used to monitor parameter value changes, or to implement dynamically-computed virtual parameters. The class has two virtual methods, Get() and Set(), each given a PB2Value&amp;, parameter ID, etc. In the case of a Get() you can modify the value in the PB2Value&amp; to implement a virtual get.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_accessor,  &amp;cmap_accessor,</code></pre><p><code>p_vals</code> - This defines radio button values in button order if button settings need to correspond to non-ordinal numbers. The value of the parameter defaults to the ordinal number of the radio button, starting at 0. You can optionally supply this tag immediately following the <code>TYPE_RADIO</code>. This tag should be followed by a list of numbers, one for each radio button. These numbers will become the (non-ordinal) parameter value corresponding to which button is set.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_vals,  0,1,2,4,3 ,</code></pre><p><code>p_refno</code> - This is used if the flag value in a &lt;required_param_specs&gt; includes P_OWNERS_REF. For these reference target parameters this specifies the reference number in the block&apos;s owner for this reference. If the parameter is a Tab&lt;&gt;, then the reference number supplied is the base reference number of the 0&apos;th element, with sequential reference numbers for the following elements.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_refno,  UVGEN_REF,</code></pre><p><code>p_subtexno</code> - For Texmap items in Mtls this defines the integer SubTexmap index for this Texmap in the owner Mtl. This is used by TYPE_TEXMAPBUTTON ParamMap2 control types to give to the Material Edtor for automatic button and Drag And Drop handling.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_subtexno,  0,</code></pre><p><code>p_submtlno</code> - Defines the sub-material integer index for this material in an owner material. This is used by <code>TYPE_MTLBUTTON</code> ParamMap2 control types to give to the Material Edtior for automatic button and Drag And Drop handling.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_submtlno,  1,</code></pre><p><code>p_dim</code> - This allows you to supply a dimension for this parameter. You specify a <code>ParamDimension</code>* as the argument. Certain parameter types have an implied dimension. Defaults to <code>defaultDim</code>.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_dim,    stdWorldDim,</code></pre><p><code>p_classID</code> - This specifies the class ID used as a validator for the various reference target parameters. This is used by the scripter, picknode filter, etc. For example, if you supply this in a <code>TYPE_INODE</code> parameter and use a <code>TYPE_PICKNODE</code> parammap control, the picker uses this class ID in the picking filter. If you set the <code>P_CAN_CONVERT</code> parameter flag, it applies an <code>Object::CanConvertTo()</code> test to the node&apos;s world state using the <code>Class_ID</code> supplied to perform the filter test.</p>\n\
<p><code>p_sclassID</code> - This specifies the super class ID used as a validator for the various reference target parameters. For example, if you supply this in a <code>TYPE_INODE</code> parameter and use a <code>TYPE_PICKNODE</code> parammap control, the picker uses this super class ID in the picking filter.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_sclassID,  SHAPE_CLASS_ID,</code></pre><p><code>p_enabled</code> - Supply <code>TRUE</code> or <code>FALSE</code> to indicate whether associated UI controls are enabled or disabled when the rollout dialog is first opened. If not supplied, defaults to <code>TRUE</code>. Can be overridden by <code>p_enable_ctrls</code>.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_enabled,  FALSE,</code></pre><p><code>p_enable_ctrls</code> - For <code>TYPE_BOOL</code>s, lists which other parameters would be automatically UI enabled/disabled by changes in state of this parameter. This allows you to easily set up conditional enabling of other UI controls based on the state of the controlling parameter.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">p_enable_ctrls, 3, sel_falloff, sel_pinch, sel_bubble,</code></pre><p><code>p_prompt</code> - This sets the status line prompt string resource ID for various picker buttons.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\"> p_prompt, IDS_PICK_CAM_PROMPT,</code></pre><p><code>p_caption</code> - This is a caption string resource ID for <code>TYPE_FILEOPENBUTTON</code> or <code>TYPE_FILESAVEBUTTON</code> open/save file dialogs.</p>\n\
<p><code>p_init_file</code> - This establishes the initial filename for open/save file dlgs. Use a direct string for the argument, not a resource ID. The filename can be changed at runtime; do this by setting the init_file member of the ParamDef for the parameter.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">ParamBlockDesc2* pbdesc = ...;\n\
pbdesc-&gt;GetParamDef(file_param).init_file = new_file_name;</code></pre><p><code>p_file_types</code> - This is used by open/save file dialogs. The argument is a string resource ID. This string sets up the file type drop-down in the open/save dialog. It is in the following form:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&quot;&lt;description1&gt;|&lt;pattern1&gt;|&lt;description2&gt;|&lt;pattern2&gt;|...|&quot;</code></pre><p>In other words, it is a sequence of file type descriptions and file type patterns each separated by a &apos;|&apos; vertical bar and terminated by a &apos;|&apos; vertical bar. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&quot;Data(*.dat)|*.dat|Excel(*.csv)|*.csv|All|*.*|&quot;</code></pre><p>specifies 3 types in the file type dropdown, the first reading &quot;Data(*.dat)&quot; and matching *.dat and the second reading &quot;Excel(*.csv)&quot; and matching *.csv and the third reading &quot;All&quot; and matching any file.</p>\n\
<p><code>p_tooltip</code> - This lets you specify a tooltip string to be displayed for the user interface control associated with a parameter described in a parameter block. The <code>p_tooltip</code> tag needs to be followed by the resource id of the string representing the tooltip.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\"> p_tooltip, &lt;tooltip_str_id&gt;</code></pre><p><code>p_end</code> - Signals the end of the &lt;required_param_specs&gt; entry.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_specification_argument.html\">Parameter Specification Arguments</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";