var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter Types</h1></div><p>The parameter types are identified by a <code>ParamType</code> or <code>ParamType2</code> enumeration. These are defined in the header file <code>paramtype</code>.h.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> <code>TYPE_RGBA</code> has a misleading name because it has no alpha field, and only corresponds to parameters defined as a <code>Point3</code>. If you want to use a color with an alpha field consider using <code>TYPE_FRGBA</code> which accepts <code>Point4</code>.</div>\n\
<p>The following are the valid types for parameters in parameter blocks. Note that the actual type of a parameter block object type is the name of the parameter type appended with the suffix <code>\\_TYPE</code>. For example the type of a <code>TYPE_FLOAT</code> parameter is defined as <code>TYPE_FLOAT_TYPE</code>.</p>\n\
<p>Note that the parameter types have associated <code>Tab</code>&lt;&gt; collections, and are noted by the suffix <code>\\_TAB</code> (e.g. <code>TYPE_FLOAT_TAB</code>). The collections are passed as pointers to the appropriate parameterization of <code>Tab</code>&lt;&gt; (e.g. <code>Tab</code>&lt;<code>TYPE_FLOAT</code>&gt;*).</p>\n\
<ul>\n\
<li><code>TYPE_FLOAT</code> (<code>float</code>) - A single floating point value.</li>\n\
<li><code>TYPE_INT</code> (<code>int</code>) - A single integer value.</li>\n\
<li><code>TYPE_RGBA</code> (<code>Point3</code>) - Note that this is a <code>Point3</code>value representing color data with an implied <code>stdColor255Dim</code> dimension.</li>\n\
<li><code>TYPE_POINT3</code> (<code>Point3</code>) - A <code>Point3</code> data type value.</li>\n\
<li><code>TYPE_FRGBA</code> (<code>Point3</code>) - A <code>Point4</code> value representing color data with an implied <code>stdColor255Dim</code> dimension.</li>\n\
<li><code>TYPE_POINT4</code> (<code>Point3</code>) - A <code>Point4</code> data type value.</li>\n\
<li><code>TYPE_BOOL</code> (<code>BOOL</code>) - An integer used as a boolean value.</li>\n\
<li><code>TYPE_ANGLE</code> (<code>float</code>) - A floating point value with an implied <code>stdAngleDim</code> dimension.</li>\n\
<li><code>TYPE_PCNT_FRAC</code> (<code>float</code>) - A floating point with an implied <code>stdPercentDim</code> dimension.</li>\n\
<li><code>TYPE_WORLD</code> (<code>float</code>) 0 Specify that a parameter represents world distance units. This implies a parameter dimension of <code>stdWorldDim</code>.</li>\n\
<li><code>TYPE_STRING</code> (<code>MCHAR</code>*) - A character string. The string has a local copy made and managed by the parameter block.</li>\n\
<li><code>TYPE_FILENAME</code> (<code>MCHAR</code>*) - Used to identify file names .</li>\n\
<li><code>TYPE_HSV</code> (<code>Point3</code>) - This option is obsolete.</li>\n\
<li><code>TYPE_COLOR_CHANNEL</code> (<code>float</code>) - A single floating point value with an implied <code>stdColor255Dim</code> dimension.</li>\n\
<li><code>TYPE_TIMEVALUE</code> (<code>int</code>) - A single integer value used as a TimeValue -- implies a <code>stdTimeDim</code> dimension.</li>\n\
<li><code>TYPE_RADIOBTN_INDEX</code> (<code>int</code>) - This is used as integer for parameters represented as radio buttons in the UI.</li>\n\
<li><code>TYPE_MTL</code> (<code>Mtl</code>*) - A pointer to a material object. This can be one of three types: a reference owned by the parameter block, a reference owned by the block owner, or no reference management (just a copy of the pointer).</li>\n\
<li><code>TYPE_TEXMAP</code> (<code>Texmap</code>*) - A pointer to a texture map object. This can be one of three types: a reference owned by the parameter block, a reference owned by the block owner, or no reference management (just a copy of the pointer).</li>\n\
<li><code>TYPE_BITMAP</code> (<code>PBBitmap</code>*) - A pointer to a bitmap object. This can be one of three types: a reference owned by the parameter block, a reference owned by the block owner, or no reference management (just a copy of the pointer).</li>\n\
<li><code>TYPE_INODE</code> (<code>INode</code>*) - A pointer to a node. This can be one of three types: a reference owned by the parameter block, a reference owned by the block owner, or no reference management (just a copy of the pointer).</li>\n\
<li><code>TYPE_REFTARG</code> (<code>ReferenceTarget</code>*) - A pointer to a reference target. All reference targets in this group can be one of three types: reference owned by parameter block, reference owned by block owner, or no reference management (just a copy of the pointer).</li>\n\
<li><code>TYPE_INDEX</code> (<code>int</code>) - This is used for parameters that are 0-based, but exposed to MAXScript as 1-based. For example a vertex index.</li>\n\
<li><code>TYPE_MATRIX3</code> (<code>Matrix3</code>*) - A standard 3ds Max matrix.</li>\n\
<li><code>TYPE_PBLOCK2</code> (<code>IParamBlock2</code>*) - A pointer to an IParamBlock2 object. Note &quot;TYPE_PBLOCK2_TYPE&quot; is not defined.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_specification_argument.html\">Parameter Specification Arguments</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";