var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parameter_ui_control_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parameter UI Control Types</h1></div><p>If the optional <code>p_ui</code> tag is included in a parameter block descriptor, then it is followed by the user interface control specification. This tag is followed by a variable list of arguments depending on the type of UI control specified. The first value following the <code>p_ui</code> tag is a control type identifier, which defines the number and type arguments which must follow.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> If a <code>p_ui</code> is supplied for a <code>Tab</code>&lt;&gt; parameter type and the control is not one of the list box types (see <a href=\"parameter_ui_control_types/list_box_control_types.html\">List Box Control Types</a>), the table size should be fixed and supplied as a <code>table_size</code> argument (preceding the <code>flags</code> argument), and you should supply a set of dialog item ID&#39;s for each element in the table. See the example in the topic <a href=\"parameter_ui_control_types/spinner_and_slider_control_types.html\">Spinner and Slider Control Types</a> and the topic <a href=\"./../describing_a_parameter_block.html\">Describing a Parameter Block</a>.</div>\n\
<p>The control types are identified by the following <code>ControlType</code> and <code>ControlType2</code> enumerations:</p>\n\
<ul>\n\
<li><code>TYPE_SPINNER</code> - The spinner control is used to provide input of values limited to a fixed numeric type. For example, the control may be limited to the input of only positive integers. The input options are integer, float, universe (world space units), positive integer, positive float, positive universe, and time. This control allows the user to increment or decrement a value by clicking on the up or down arrows. The user may also click and drag on the arrows to interactively adjust the value. The Ctrl key may be held to accelerate the value changing speed, while the Alt key may be held to decrease the value changing speed. See the topic <a href=\"parameter_ui_control_types/spinner_and_slider_control_types.html\">Spinner and Slider Control Types</a> for more information</li>\n\
<li><code>TYPE_SLIDER</code> - A standard 3ds Max slider control. See the topic <a href=\"parameter_ui_control_types/spinner_and_slider_control_types.html\">Spinner and Slider Control Types</a> for more information</li>\n\
<li><code>TYPE_RADIO</code> - Radio buttons are used to provide the user with a single boolean choice, or when used in groups, to select among several options. These are the standard Win32 radio button controls. Following the <code>TYPE_RADIO</code>, you must supply an integer count of the number of radio buttons in this group and then a list of dialog item IDs for each button. A radio button can be used with <code>TYPE_INT</code> or <code>TYPE_RADIOBTN_INDEX</code> parameters. The value of the parameter defaults to the ordinal number of the radio button, starting at 0. You can optionally supply a <code>p_vals</code> tag immediately following the <code>p_ui</code> section, which would be followed by a list of numbers, one for each radio button. These numbers will become the (non-ordinal) parameter value corresponding to which button is set.</li>\n\
<li><code>TYPE_SINGLECHEKBOX</code> - Check boxes are used to provide the user with a single boolean choice. This is the standard Win32 check box control. The <code>TYPE_SINGLECHEKBOX</code> must be followed dialog item ID. A <code>TYPE_SINGLECHEKBOX</code> can only be used with <code>TYPE_INT</code> or <code>TYPE_BOOL</code> parameters.</li>\n\
<li><code>TYPE_CHECKBUTTON</code> - A check button control. This button&#39;s state is either pressed or not. This control functions just like <code>TYPE_SINGLECHEKBOX</code> but is represented by a button in either a pressed in or unpressed state.</li>\n\
<li><code>TYPE_MULTICHEKBOX</code> - Multiple check boxes are not supported.</li>\n\
<li><code>TYPE_COLORSWATCH</code> - The color swatch control presents the user with the standard 3ds Max modeless color selector when the user clicks on the control. The color swatch control displays the currently selected color. The <code>TYPE_COLORSWATCH</code> with the dialog item ID of the swatch custom control. This can only be used with <code>TYPE_POINT3</code> or <code>TYPE_RGBA</code> parameter.</li>\n\
<li><code>TYPE_EDITBOX</code> - An edit box control. This is a 3ds Max custom edit box control. The <code>TYPE_EDITBOX</code> must be followed by the dialog item ID of the edit box custom control. This can only be used with <code>TYPE_STRING</code> and <code>TYPE_FILENAME</code> parameters.</li>\n\
<li><code>TYPE_PICKNODEBUTTON</code> - A scene node (<code>INode</code>) picker button. This is a 3ds Max <code>ICustButton</code> control used in a <code>CBT_CHECK</code> mode with <code>GREEN_WASH</code> highlight color, as per node picking button conventions. Follow the control type with the dialog item ID of the button control. When the user presses this button a <code>PickModeCallback</code> command mode is entered and the user can pick a scene node under the filtering of any validation supplied (see tags <code>p_validator</code>, <code>p_classID</code> and <code>p_sclassID</code>). This can only be used with <code>TYPE_INODE</code> parameters. Use the <code>p_prompt</code> tag to supply a status line prompt.</li>\n\
<li><code>TYPE_TEXMAPBUTTON</code> - A texture map selector button that supports drag and drop of texture maps. This is an <code>ICustButton</code> control used in <code>CBT_PUSH</code> mode. The control type must be followed by the dialog item ID of the button control. This button opens up a map selector dialog when pressed. This can only be used with <code>TYPE_TEXMAP</code> parameters. Use the <code>p_prompt</code> tag to supply a status line prompt.</li>\n\
<li><code>TYPE_MTLBUTTON</code> - A material selector button that supports drag and drop of materials. This is an <code>ICustButton</code> control used in <code>CBT_PUSH</code> mode. The control type must be followed by the dialog item ID of the button control. This button throws up a material selector dialog when pressed. This can only be used with <code>TYPE_MTL</code> parameters. Use the <code>p_prompt</code> tag to supply a status line prompt.</li>\n\
<li><code>TYPE_FILEOPENBUTTON</code> - This is an <code>ICustButton</code> control used in <code>CBT_PUSH</code> mode. The control type with the dialog item ID of the button control. This button open a standard Windows Open File dialog for selecting a file name. This type can only be used with TYPE_STRING and TYPE_FILENAME parameters. Use any of the <code>p_caption</code>, <code>p_init_file</code>, and <code>p_file_types</code> tags to further control the dialog.</li>\n\
<li><code>TYPE_FILESAVEBUTTON</code> - This is an <code>ICustButton</code> control used in <code>CBT_PUSH</code> mode. The control type with the dialog item ID of the button control. This button open a standard Windows Save File dialog for selecting a file name. This type can only be used with TYPE_STRING and TYPE_FILENAME parameters. Use any of the <code>p_caption</code>, <code>p_init_file</code>, and <code>p_file_types</code> tags to further control the dialog.</li>\n\
<li><code>TYPE_INTLISTBOX</code> - A list box control for integers. See the topic <a href=\"parameter_ui_control_types/list_box_control_types.html\">List Box Control Types</a> for more information.</li>\n\
<li><code>TYPE_FLOATLISTBOX</code> - A list box control for floats. See the topic <a href=\"parameter_ui_control_types/list_box_control_types.html\">List Box Control Types</a> for more information.</li>\n\
<li><code>TYPE_INT_COMBOBOX</code> - A combo box control that can be used with parameters of type <code>TYPE_INT</code> and <code>TYPE_INT_TAB</code>. See the topic <a href=\"parameter_ui_control_types/combo_box_control_types.html\">Combo Box Control Types</a> for more information.</li>\n\
<li><code>TYPE_POINT3LISTBOX</code> - A series a controls for displaying and managing a list box control containing a <code>Tab</code>&lt;<code>Point3</code>&gt; parameter. The setup consists of a list box control, 3 buttons (for adding, replacing and deleting items), a source spinner type, three pairs of edit boxes and spinners, and a display scale. After the control type, you must supply 4 dialog item IDs. The first is the list box control, then dialog item IDs for 3 custom button controls for an add, replace, and delete button, respectively. Follow this with the source spinner type, and the edit box and spinner for the first item, and finally the display scale. Note that you can only use this with <code>TYPE_POINT3_TAB</code> parameters.</li>\n\
<li><code>TYPE_STRINGLISTBOX</code> - A series a controls for displaying and managing a list box control containing a <code>Tab</code>&lt; string&gt; parameter. The setup consists of a list box control, 3 buttons (for adding, replacing and deleting items), and a 3ds Max custom edit box to supply source strings. After the control type, you supply 4 dialog item IDs. The first is the list box control, then dialog item IDs for 3 custom button controls for the add, replace and delete button, respectively. These are followed with the custom edit control dialog item ID. You can supply the value 0 for any of the add, replace, delete buttons or custom edit control IDs if you don&#39;t need them in the dialog. This can only be used with <code>TYPE_STRING_TAB</code> parameters. The add, replace, and delete buttons automatically keep the parameter value synchronized with the list..</li>\n\
<li><code>TYPE_NODELISTBOX</code> - A series a controls for displaying and managing a list box control containing a <code>Tab</code>&lt;<code>INode</code>&gt; parameter. The setup consists of a list box control, 3 buttons (for picking, replacing and deleting items). After the control type, you supply 4 dialog item IDs. The first is the list box control, then one for 3 custom button controls for the pick, replace, and delete button, respectively. The pick and replace buttons act exactly as <code>TYPE_PICKNODEBUTTONS</code> to get nodes to add to or replace in the list. You can supply the value 0 for any of the add, replace, delete buttons IDs if you don&#39;t need them in the dialog. This control type can only be used with <code>TYPE_INODE_TAB</code> parameters. The pick, replace, and delete buttons automatically keep the Tab&lt;&gt; parameter in step with the list, including managing References as needed.</li>\n\
</ul>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li>For a list of the 3ds Max User controls see the topic</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_ui_control_types/spinner_and_slider_control_types.html\">Spinner and Slider Control Types</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_ui_control_types/list_box_control_types.html\">List Box Control Types</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"parameter_ui_control_types/combo_box_control_types.html\">Combo Box Control Types</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_specification_argument.html\">Parameter Specification Arguments</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";