var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"combo_box_control_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Combo Box Control Types</h1></div><p>This combo box parameter control type can be used with parameters of type <code>TYPE_INT</code> and <code>TYPE_INT_TAB</code>. When used with parameters of type TYPE_INT, it needs to be followed by a series of controls for displaying and managing a combo-box control, as shown below:</p>\n\
<p><code>... p_ui</code>,<code>TYPE_INT_COMBOBOX</code>, &lt;control id&gt;, &lt;number ofitems&gt;, [ &lt;item1 string id&gt;, &lt;item2 string id&gt;, ... ] ...</p>\n\
<p>where:</p>\n\
<ul>\n\
<li><code>&amp;lt;control</code> id&gt; - the resource id of the combo-box control</li>\n\
<li><code>&amp;lt;number</code> of items&gt; - the number of items in the combo-box. If zero, no resource string ids need to be provided.</li>\n\
<li><code>&amp;lt;item1</code> string id&gt;, <code>&amp;lt;item2</code> stringid&gt;, ... - the string resource ids for the user visible names of the combo-box items.</li>\n\
</ul>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">pb_int_combobox1, _T(&quot;TYPE_INT_COMBOBOX1&quot;),\n\
    TYPE_INT, // parameter type\n\
    P_RESET_DEFAULT+P_ANIMATABLE, IDS_INT_COMBOBOX,\n\
    p_ui, TYPE_INT_COMBOBOX,\n\
        IDC_INT_COMBOBOX, // resource id of combo box ui widget\n\
        4, // number of items in the combobox\n\
        IDS_COMBOBOX_ITEM1, IDS_COMBOBOX_ITEM2, IDS_COMBOBOX_ITEM3, IDS_COMBOBOX_ITEM4, // string resource ids representing the &quot;human readable&quot; names of the combobox items\n\
    p_vals, 10, 50, 30, 20,\n\
    p_default, 10,\n\
    p_tooltip, IDS_INT_COMBOBOX,\n\
p_end</code></pre><p>When the <code>TYPE_INT_COMBOBOX</code> is used with parameters of type <code>TYPE_INT_TAB</code>, it needs to be followed by a series of controls for displaying and managing one combo-box control per tab element, as in:</p>\n\
<p>... p_ui, TYPE_INT_COMBOBOX, &lt;control id1&gt;,&lt;control id2&gt;, ..., &lt;control idN&gt;, &lt;number of items&gt;, [ &lt;item1 string_id&gt;, &lt;item2_str_id&gt;, ... ] ...</p>\n\
<p>where:</p>\n\
<p>&lt;ctrl_idn&gt;: resource ids of the combo-box control, 1 &lt;= n &lt;= number of tab elements</p>\n\
<p>&lt;num_items&gt;: is the number of items in each combo-box. If zero, no resource string ids need to be provided</p>\n\
<p>&lt;item1_str_id&gt;, &lt;item2_str_id&gt;, ...: optional string resource ids for the user visible names of the combo-box items.</p>\n\
<p>Example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">pb_int_combobox2, _T(&quot;TYPE_INT_COMBOBOX2&quot;),\n\
    TYPE_INT_TAB, 2, // parameter type and number of elements in the tab\n\
    P_RESET_DEFAULT+P_ANIMATABLE, IDS_LISTBOX,\n\
    p_ui, TYPE_INT_COMBOBOX,\n\
        IDC_INT_COMBOBOX2_1, IDC_INT_COMBOBOX2_2, // one combo-box resource id per tab element\n\
        4, IDS_COMBOBOX_ITEM1, IDS_COMBOBOX_ITEM2, IDS_COMBOBOX_ITEM3, IDS_COMBOBOX_ITEM4, // string resource ids representing the &quot;human readable&quot; names of the combo box items\n\
    p_vals, 10, 50, 30, 20,\n\
    p_default, 10,\n\
    p_tooltip, IDS_INT_COMBOBOX,\n\
p_end</code></pre><p>The <code>p_vals</code> flag may follow a combo-box UI specification. If specified, the list of integer values that follows represents the values associated with each combo-box item. These values are not required to be consecutive or in order.</p>\n\
<p>If <code>p_vals</code> does not follow <code>TYPE_INT_COMBOBOX</code> each combo-box item is mapped to an integer value starting with zero and up to the number of items in the combo-box.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_ui_control_types.html\">Parameter UI Control Types</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";