var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"list_box_control_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>List Box Control Types</h1></div><p>The parameter types <code>TYPE_INTLISTBOX</code> and <code>TYPE_FLOATLISTBOX</code> specifies a series of controls for displaying and managing a list box control containing a <code>Tab&amp;lt;int&amp;gt;</code> or <code>Tab&amp;lt;float&amp;gt;</code> parameter respectively. The setup consists of a list box control, 3 buttons (for adding, replacing and deleting items) and a 3ds Max spinner to supply source values for add and replace. After the control type, you must supply 4 dialog item IDs. The first is the list box control, then dialog item IDs for 3 custom button controls for the add, replace, and delete button respectively. These are followed with a spinner type, an edit box dialog item ID a spinner dialog item ID, and a display scale You can supply the value 0 for any of the add, replace, or delete buttons if you don&apos;t need them in the dialog. This can only be used with the following parameter types:</p>\n\
<p>For <code>TYPE_INTLISTBOX</code>:</p>\n\
<ul>\n\
<li><code>TYPE_TIMEVALUE_TAB</code></li>\n\
<li><code>TYPE_INT</code></li>\n\
<li><code>TYPE_INT_TAB</code></li>\n\
</ul>\n\
<p>For <code>TYPE_FLOATLISTBOX</code>:</p>\n\
<ul>\n\
<li><code>TYPE_ANGLE_TAB</code></li>\n\
<li><code>TYPE_PCNT_FRAC_TAB</code></li>\n\
<li><code>TYPE_COLOR_CHANNEL_TAB</code></li>\n\
<li><code>TYPE_FLOAT_TAB</code></li>\n\
</ul>\n\
<p>The add, replace, delete buttons automatically keep the <code>Tab&amp;lt;&amp;gt;</code> parameter synchronized with the list.</p>\n\
<p>The <code>TYPE_INT</code> parameter type and <code>TYPE_INTLISTBOX</code> control type combination is treated as a special case and is used to allow a drop-down list to be associated with an int parameter such that the selection index in the drop-down becomes the integer parameter value. In this mode, after the control type you supply the list box control ID, then a count followed by that number of string resource IDs. These strings are used to populate the drop-down. The number of items can be zero, and the strings can be loaded manually in the dialog procedure.</p>\n\
<p>For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">... p_ui, TYPE_INTLISTBOX, &lt;listcontrol id&gt;, &lt;number ofitems&gt;, [ &lt;item1 string id&gt;, &lt;item2 string id&gt;, ... ] ...</code></pre><p>See the <code>std2_shader_type</code> parameter in <code>\\\\MAXSDK</code>\\SAMPLES\\MATERIALS\\STDMTL2.CPP for an example.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_ui_control_types.html\">Parameter UI Control Types</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";