var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_a_parameter_block_1\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating a Parameter Block 1</h1></div><p>This topic describes how to create the now parameter blocks used in earlier versions of 3ds Max. The original parameter block 1 type is deprecated, but still supported for compatibility issues, and the parameter block 2 system should be used instead.</p>\n\
<p>Throughout this topic an example of a plug-in with three parameters is used. An angle, a length, and a integer count parameter. A parameter block descriptor is used to describe each parameter. It is initialized by passing three arguments per parameter. (Note that another version uses four arguments. The version with four arguments is used to help maintain backward compatibility. The two descriptors are otherwise the same).</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class  ParamBlockDesc {\n\
 public:\n\
  ParamType type;\n\
  UserType *user;\n\
  BOOLanimatable;\n\
 };\n\
// This version of the descriptor has an ID for each parameter.\n\
class  ParamBlockDescID {\n\
 public:\n\
  ParamType type;\n\
  UserType *user;\n\
  BOOLanimatable;\n\
  DWORDid;\n\
 };</code></pre><p>The arguments to <code>ParamBlockDesc</code> are:</p>\n\
<p><code>ParamType</code>type</p>\n\
<p>The Parameter Type - The following types may be used:</p>\n\
<ul>\n\
<li><code>TYPE_INT</code> - Integers values.</li>\n\
<li><code>TYPE_FLOAT</code> - Floating point value.</li>\n\
<li><code>TYPE_POINT3</code> - Point values.</li>\n\
<li><code>TYPE_RGBA</code> - Color values - Red, Green, and Blue. (Alpha is premultiplied).</li>\n\
<li><code>TYPE_BOOL</code> - Boolean values.</li>\n\
<li><code>UserType</code> *user</li>\n\
</ul>\n\
<p>The next value is NOT USED - it must always be passed as NULL.</p>\n\
<p><code>BOOL</code>animatable - This is a flag indicating if the parameter may be animated or not. Pass TRUE if the value may be animated and FALSE if it is constant.</p>\n\
<p><code>DWORD</code>id (Second version only) - This is an ID used to identify this parameter. This provides a solution to the problem of backwards compatibility. If you alter the parameter structure of your plug-in in the future (by adding or deleting parameter for example) previously saved 3ds Max files will be incompatible. You can however use a mechanism which uses these IDs to convert older versions to the current version.</p>\n\
<p>Items in the parameter block are referred to by index. The index is derived from the order in which the descriptors appear in the <code>ParamBlockDesc</code> array.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Parameter block indices\n\
#define PB_INDEX_ANGLE 0\n\
#define PB_INDEX_LENGTH 1\n\
#define PB_INDEX_COUNT 2\n\
ParamBlockDesc pdesc[] = {\n\
 { TYPE_FLOAT, NULL, TRUE }, // Angle\n\
 { TYPE_FLOAT, NULL, TRUE }, // Length\n\
 { TYPE_INT, NULL, FALSE } // Count\n\
};</code></pre><p>A parameter block is created from this array by calling <code>CreateParameterBlock()</code>. This function requires two values, a pointer to the <code>ParamBlockDesc</code> array and a count of the number of parameters. (Note there is an alternate version for use with the backwards compatibility mechanism discussed above that uses three arguments. The third argument is used to indicate a version of the parameter block. See the topic on <a href=\"./../../../miscellaneous_topics/parameter_maps.html\">Parameter Maps</a> for more information).</p>\n\
<p><code>IParamBlock* CreateParameterBlock( ParamBlockDesc *pdesc, int count);</code></p>\n\
<p>or</p>\n\
<p><code>IParamBlock* CreateParameterBlock( ParamBlockDescID *pdesc, int count,DWORD version);</code></p>\n\
<p>The function returns a pointer to the parameter block it creates.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_block_1.html\">Parameter Block 1</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";