var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"loading_old_parameter_data_using\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Loading Old Parameter Data using IParamBlock2</h1></div><p>If you have parameter data stored in the original parameter block format and want to upgrade to IParamBlock2 you can use the <code>ParamBlock2PLCB</code>class (Parameter block 2 post-load call-back). An instance of this class is passed to <code>ILoad::RegisterPostLoadCallback()</code> to enable automatic conversion of old-parameter block versions of the plug-in. Developers give the constructor for this class a <code>ParamVersionDesc</code> array and the current block descriptor and it will load old parameter block objects into ParamBlock2 objects.</p>\n\
<p>To take advantage of this system the original <code>ParamBlockDesc</code> is used but now using the newly created parameter Ids. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">enum { bend_params,};\n\
\n\
// The order here must be the same as the order in the older version PB\n\
enum { bend_angle,\n\
     bend_dir,\n\
     bend_axis,\n\
     bend_fromto,\n\
     bend_from,\n\
     bend_to,\n\
};\n\
\n\
// The old ParamBlockDescID has been updated to use the IDs created in the ENUM\n\
static  ParamBlockDescID descVer0[] = {\n\
   { TYPE_FLOAT, NULL, TRUE, bend_angle },\n\
   { TYPE_FLOAT, NULL, TRUE, bend_dir },\n\
   { TYPE_INT, NULL, FALSE, bend_axis } };\n\
\n\
// The current version\n\
static  ParamBlockDescID descVer1[] = {\n\
   { TYPE_FLOAT, NULL, TRUE, bend_angle },\n\
   { TYPE_FLOAT, NULL, TRUE, bend_dir },  \n\
   { TYPE_INT, NULL, FALSE, bend_axis },\n\
   { TYPE_INT, NULL, FALSE, bend_fromto },\n\
   { TYPE_FLOAT, NULL, TRUE, bend_from },\n\
   { TYPE_FLOAT, NULL, TRUE, bend_to } };\n\
\n\
#define PBLOCK_LENGTH   6\n\
#define NUM_OLDVERSIONS   2\n\
\n\
// Array of old versions\n\
static  ParamVersionDesc versions[] = {\n\
   ParamVersionDesc(descVer0,3,0),\n\
   ParamVersionDesc(descVer1,PBLOCK_LENGTH,1)\n\
   };</code></pre><p>In the <code>BendMod::Load()</code> method a callback is registered which maps the incoming IDs to new enumerated IDs. It is important to note that old parameter maps still need to be loaded using the original mapping techniques before the new parameter block ids are used.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IOResult BendMod::Load(ILoad *iload)\n\
   {\n\
   Modifier::Load(iload);\n\
\n\
    ParamBlock2PLCB* plcb = new ParamBlock2PLCB(versions, NUM_OLDVERSIONS, &amp;bend_param_blk, this, SIMPMOD_PBLOCKREF);\n\
   iload-&gt;RegisterPostLoadCallback(plcb);\n\
\n\
   return IO_OK;\n\
   }\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_block_1.html\">Parameter Block 1</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";