var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"pb1_to_pb2_conversion\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Updating from ParamBlock1 to Paramblock2</h1></div><p>This topic provides an overview of the &quot;new&quot; parameter block system (based on Paramblock2), and a walk-through of how to convert plug-ins from the legacy Paramblock to the new Paramblock2 system.</p>\n\
<h2 id=\"overview\">Overview</h2><p>3ds Max 3 introduced a new Parameter Block and Parameter Map mechanism.  The goal of this new mechanism was to make it possible for plug-ins to host all of their user-visible parameters in one or more parameter blocks, including complex parameters such as ReferenceTargets, Sub-Anims, dynamic parameter tables (<code>Tabs&lt;&gt;</code>), and class parameters.  Further, the new parameter blocks make handling of old-version loading and reference management automatic.  </p>\n\
<p>To help support these new parameters the Parameter Map mechanism was updated to provide automatic UI creation for the new parameter types, including common 3ds Max controls such as node pickers, texmap selectors, and list boxes for tabular parameters.  For plug-ins using a Qt UI, the new parameter types provide automatic mapping to Qt widgets.\n\
The new parameter block system exposed the plug-in data to systems like the MAXScript, the Macro Recorder and the Schematic View.</p>\n\
<h2 id=\"overview-of-the-main-new-classes\">Overview of the Main new Classes</h2><h3 id=\"-code-classdesc2-code-\"><code>ClassDesc2</code></h3><p>All plug-ins have a ClassDesc.  From 3ds Max R3 a new class descriptor, sub-classed from ClassDesc is used.  ClassDesc2 maintains a table of ParamBlockDesc2&#39;s and allows for automatic creation of the User Interface.</p>\n\
<h3 id=\"-code-iparamblock2-code-\"><code>IParamBlock2</code></h3><p>This is the interface into the parameter blocks.  It contains all the necessary GetValue() and SetValue() methods needed to access the new forms of data.</p>\n\
<h3 id=\"-code-paramblockdesc2-code-\"><code>ParamBlockDesc2</code></h3><p>An instance of this class contains the descriptive data for a ParamBlock2 and all the parameters it contains.  These are created using a var-args constructor, the arguments to which define the block and its parameters.  A table of all the parameter block descriptors for a plug-in class is kept in its ClassDesc2 instance.  A ParamBlockDesc2 contains an array of ParamDef instances, one for each parameter, and a set of block-level flags and UI information.  A ParamDef structure contains a list of flags and descriptions for describing the user interface.</p>\n\
<h3 id=\"-code-paramblock2plcb-code-\"><code>ParamBlock2PLCB</code></h3><p>Instances of this class are given to <code>ILoad::RegisterPostLoadCallback()</code> to enable automatic conversion of old-parameter block versions of the plug-in.  Developers give the constructor for this class a ParamVersionDesc array and the current ParamBlockDesc2 and it will load old parameter block objects into ParamBlock2 objects.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"pb1_to_pb2_conversion/tutorial1.html\">Tutorial 1 - Converting the Bend Modifier</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"pb1_to_pb2_conversion/tutorial2.html\">Tutorial 2 : Converting the Box Object</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_blocks.html\">Parameter Blocks</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";