var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plug-in_architecture\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plug-in Architecture</h1></div><p>An abstract base class (i.e. a class containing one or more abstract virtual functions) is called an interface in the 3ds Max SDK documentation. In 3ds Max interfaces are used to expose services from 3ds Max to plug-ins (called the core interfaces).</p>\n\
<h2 id=\"core-interfaces\">Core Interfaces</h2><p>Core interfaces are interfaces to a singleton object that exposes services provided by 3ds Max. The most recent version which should be used in new plug-ins is the <code>COREInterface16</code> class. A pointer to this class can be relieved using the function <code>GetCOREInterface16()</code>. The most recent core interface version is also returned by <code>GetCoreInterface()</code>.</p>\n\
<h2 id=\"plug-in-interfaces\">Plug-in Interfaces</h2><p>Plug-in interfaces are the base classes that a plug-in implements in order to expose functionality to 3ds Max. The most important plug-in base classes are derived from Animatable (see the list of <a href=\"plug-in_base_classes.html\"\">Plug-in Base Classes</a>). Additional interfaces such as <code>IPainterInterface_V5</code> can also be implemented in order to expose additional functionality to 3ds Max.</p>\n\
<p>The plug-in interfaces can be broken up roughly into two categories:</p>\n\
<ul>\n\
<li><code>Animatable</code> derived classes. E.g. <code>Control</code>, <code>Modifier</code>, and <code>GeomObject</code>. The animatable derived classes are usually not referred to as interfaces in the documentation, except in the context of the function <code>Animatable::GetInterface()</code>.</li>\n\
<li><code>BaseInterface</code> derived classes. E.g. <code>IPainter</code>, <code>IMaterial</code>, and <code>IGeometryChecker</code>. When writing objects that support interfaces we recommend that you derive from <code>FPMixinInterface</code> so that you can provide function publishing functionality either immediately or in the future. For more information see the topic <a href=\"./../function_publishing.html\">Function Publishing</a>.</li>\n\
</ul>\n\
<p>Both classes derive from the <code>InterfaceServer</code> base class which provides an interface querying mechanism.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-ins.html\">Working with Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";