var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plug-in_base_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plug-in Base Classes</h1></div><p>Each plug-in type exposes its functionality to 3ds Max by defining a class that derives from a specific base-class and providing implementations of key virtual functions. The most important base class is <code>Animatable</code>, which most plug-ins implement from.</p>\n\
<p>The following is a list of the most important plug-in types and the base classes they derive from:</p>\n\
<ul>\n\
<li>3D Texture Map - <code>Tex3D</code>.</li>\n\
<li>Animation Controllers - <code>Control</code>.</li>\n\
<li>Atmospheric - <code>Atmospheric</code>.</li>\n\
<li>Bitmap Texture - <code>BitmapTex</code>.</li>\n\
<li>Camera Object - <code>GenCamera</code>.</li>\n\
<li>Color Selection - <code>ColPick</code>.</li>\n\
<li>Compound Objects - <code>IBoolObject</code>.</li>\n\
<li>Crowd Behavior - <code>BaseBehavior</code>.</li>\n\
<li>File Export - <code>SceneExport</code>.</li>\n\
<li>File Import - <code>SceneImport</code>.</li>\n\
<li>Geometric Objects - <code>GeomObject</code> or <code>SimpleObject2</code>.</li>\n\
<li>Global Utility - <code>GUP</code>.</li>\n\
<li>Hardware Shaders - <code>IDX9DataBridge</code>.</li>\n\
<li>Image Filters - <code>ImageFilter</code>.</li>\n\
<li>Image Import/Export - <code>BitmapIO</code>.</li>\n\
<li>Image Viewers - <code>ViewFile</code>.</li>\n\
<li>IK Solver - <code>IKSolver</code>.</li>\n\
<li>Helper Objects - <code>ConstObject</code> or <code>HelperObject</code>.</li>\n\
<li>Light Objects - <code>LightObject</code> or <code>GenLight</code>.</li>\n\
<li>Linear Shape Object - <code>LinearShape</code>.</li>\n\
<li>Manipulator Objects - <code>Manipulator</code> or <code>SimpleManipulator</code>.</li>\n\
<li>Material Plug-in - <code>Mtl</code>.</li>\n\
<li>MAXScript Extensions - <code>MSPlugin</code>.</li>\n\
<li>Modifier - <code>Modifier</code> or <code>SimpleMod</code>.</li>\n\
<li>Multi-pass Camera Effects - <code>IMultiPassCameraEffect</code>.</li>\n\
<li>Particle Objects - <code>ParticleObject</code> or <code>SimpleParticle</code>.</li>\n\
<li>Patch Objects - <code>PatchObject</code>.</li>\n\
<li>Radiosity Effect - <code>RadiosityEffect</code>.</li>\n\
<li>Renderer - <code>Renderer</code>.</li>\n\
<li>Rendering Effects - <code>Effect</code>.</li>\n\
<li>Render Elements - <code>IRenderElement</code>.</li>\n\
<li>Sampler - <code>Sampler</code>.</li>\n\
<li>Shader - <code>Shader</code>.</li>\n\
<li>Shape Objects - <code>ShapeObject</code>.</li>\n\
<li>Snaps - <code>Osnap</code>.</li>\n\
<li>Sound - <code>SoundObj</code>.</li>\n\
<li>Spline Objects - <code>SimpleSpline</code>.</li>\n\
<li>Spring Systems - <code>SpringSys</code>.</li>\n\
<li>Texture Map - <code>Texmap</code>.</li>\n\
<li>Track View Utility - <code>TrackViewUtility</code>.</li>\n\
<li>Utility - <code>UtilityObj</code>.</li>\n\
<li>World Space Modifier - <code>WSModifier</code>.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-ins.html\">Working with Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";