var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference System</h1></div><p>The 3ds Max reference system is primarily a mechanism for scene objects and plug-ins to communicate. A reference between two objects models the subject-observer pattern.</p>\n\
<p>When talking about a &quot;reference&quot; the SDK documentation is talking about a reference link from a reference maker to a reference target. A reference maker manages the references and exposes them via the function <code>ReferenceMaker::GetReference()</code>. Each reference managed by a reference maker is identified by an integer value called the reference index.</p>\n\
<p>Objects that wish to be notified of changes in target objects (i.e. observers) are called reference makers and must derive from <code>ReferenceMaker</code>. The target object (i.e. subject) is called the reference target and must derived from <code>ReferenceTarget</code>. In 3ds Max all subjects can also be observers so <code>ReferenceTarget</code> derives from <code>ReferenceMaker</code> .</p>\n\
<p>Strong references are used by 3ds Max to manage the lifetime of scene objects.</p>\n\
<p>There are three kinds of references:</p>\n\
<ul>\n\
<li><a href=\"reference_system/kinds_of_references/strong_references.html\">Strong References</a> - Strong references are the most common kind of references, and are usually what is meant when referring to simply &quot;references&quot;. Strong references add ownership semantics to subject-observer relations. This means that when a strong reference exists between an observer and its subject, the subject is considered to be owned by the observer. 3ds Max will prevent deletion of <code>ReferenceTarget</code> objects (except nodes) when a strong direct reference exists to it. When a <code>ReferenceTarget</code> has no more strong direct references it will be automatically deleted by 3ds Max.</li>\n\
<li><a href=\"reference_system/kinds_of_references/weak_references.html\">Weak References</a> - Weak references model a simple observer-subject relationship. A <code>ReferenceMaker</code> that depends on a <code>ReferenceTarget</code>, but can function properly without it, should create a weak reference to it. A weak reference does not prevent a <code>ReferenceTarget</code> from being deleted. When the <code>ReferenceTarget</code> is deleted the dependent <code>ReferenceMaker</code> is notified.</li>\n\
<li><a href=\"reference_system/kinds_of_references/indirect_references.html\">Indirect References</a> - Indirect references are similar to weak references but prevent the propagation of message sent from the <code>ReferenceMaker</code> to the <code>ReferenceTarget</code> to other observers of that target. The purpose of an indirect reference is to model reciprocal subject-observer relationships between scene elements, and prevent loops.</li>\n\
</ul>\n\
<p>Reference relationships themselves are not represented by a specific class, but are managed through methods of <code>ReferenceMaker</code>.</p>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li><a href=\"./../overview/overview_reference_system.html\">Overview: Reference System</a></li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/how_plug-ins_observe_reference_t.html\">How Plug-ins Observe Reference Targets</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/writing_reference_makers.html\">Writing Reference Makers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/writing_reference_targets.html\">Writing Reference Targets</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/creating_and_changing_references.html\">Creating and Changing References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/deleting_references.html\">Deleting References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/loading_and_saving_of_references.html\">Loading and Saving of References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/reference_messages.html\">Reference Messages</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/kinds_of_references.html\">Kinds of References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/managing_variable_number_of_refe.html\">Managing Variable Number of References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/reference_hierarchy_functions.html\">Reference Hierarchy Functions</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/reference_object_lifetime_manage.html\">Reference Object Lifetime Management</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/reference_system_common_tasks.html\">Reference System Common Tasks</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_system/guidelines_for_changing_the_refe.html\">Guidelines for Changing the Reference Structure</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../3ds_max_sdk_features.html\">3ds Max SDK Features</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";