var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_and_changing_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating and Changing References</h1></div><p>The same mechanism is used for creating and changing (replacing) a reference. References from a reference maker to a reference target are created by first declaring a <code>RefTargetHandle</code> initialized to <code>NULL</code>, and then by calling <code>ReferenceMaker::ReplaceReference()</code> for each reference. The <code>ReferenceMaker::ReplaceReference()</code> method is also be used to reassign a reference instead of <code>ReferenceMaker::SetReference()</code>.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> you should always initialize a <code>RefTargetHandle</code> to NULL before its first use.</div>\n\
<p>The following sample code demonstrates these steps:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MyRefMaker : publicReferenceMaker\n\
{\n\
private:\n\
  // Note: RefTargetHandle is in fact a pointer to ReferenceTarget\n\
  RefTargetHandle target;\n\
\n\
public:\n\
\n\
 MyRefMaker(RefTargetHandle ref)\n\
    : target(NULL)\n\
  {\n\
    ReplaceReference(0, ref);\n\
  }\n\
\n\
  intNumRefs() {\n\
     return 1;\n\
  }  \n\
\n\
  RefTargetHandle GetReference(int i) {\n\
    assert(i == 0);\n\
    return target;\n\
  }\n\
\n\
  voidSetReference(inti, RefTargetHandle rtarg) {\n\
    assert(i==0) ;\n\
    target = rtarg;\n\
  }\n\
\n\
  RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget,\n\
     PartID&amp; partID, RefMessage message)\n\
  {\n\
     if (hTarget == target) {\n\
        // perform processing according to the message        \n\
     }     \n\
  }\n\
};\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";