var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"guidelines_for_changing_the_refe\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Guidelines for Changing the Reference Structure</h1></div><p>A plug-in can save a different reference structure than it exposes to 3ds Max at run-time (e.g. <code>ReferenceMaker::GetReference()</code>, <code>ReferenceMaker::NumRefs()</code>). You need to override the virtual function <code>ReferenceMaker::SpecifySaveReferences()</code> and use the <code>ReferenceSaveManager</code> parameter to describe the differences between its actual and to-be-saved reference structure as a series of add, remove and change operations. Changes to indirect references are also supported. A plug-in can also specify another version of plug-in to be saved instead of itself. There will be strict restrictions for changing the reference structure if the plug-in does not use the <code>ReferenceSaveManager</code> API. This will be discussed later.</p>\n\
<p>The following member functions are used to describe changes to the structure of direct references of a plug-in:</p>\n\
<ul>\n\
<li><code>void ReferenceSaveManager::AddReferenceSlot(int insertAt, ReferenceTarget* theRef) ;</code></li>\n\
<li><code>void ReferenceSaveManager::ReplaceReferenceSlot(int which, ReferenceTarget* theRef) ;</code></li>\n\
<li><code>void ReferenceSaveManager::RemoveReferenceSlot(int which) ;</code></li>\n\
<li><code>void ReferenceSaveManager::SetReplacementReferenceTarget(ReferenceTarget* replacementRefTarg) ;</code></li>\n\
</ul>\n\
<p>Similar functions exist for specifying indirect reference changes.\n\
The alternate reference hierarchy is exposed via the following member functions of the class ReferenceSaveManager:</p>\n\
<ul>\n\
<li><code>ReferenceTarget* ReferenceSaveManager::GetIndirectReference(int i, bool usePersistenceTests) ;</code></li>\n\
<li><code>ReferenceTarget* ReferenceSaveManager::GetReference(int i, bool usePersistenceTests) ;</code></li>\n\
<li><code>int ReferenceSaveManager::NumIndirectRefs() ;</code></li>\n\
<li><code>int ReferenceSaveManager::NumRefs() ;</code></li>\n\
</ul>\n\
<p>When an alternate reference hierarchy hasn&#39;t been defined, the <code>ReferenceSaveManager</code> member functions will use the reference structure currently define by the plug-in. If the plug-in defines an alternate reference hierarchy, it exists only during a file save operation.\n\
While developers are encouraged to use the <code>ReferenceSaveManager</code> API to change the reference structure, there is a certain case in which it is easier to do that without using that API. This is when a new reference is added as the last one to the list of references. Following is the guidelines the plug-in should follow if the <code>ReferenceSaveManager</code> API is not used.</p>\n\
<ul>\n\
<li>The meaning (e.g. type) associated with a reference index must not be changed. This also means that reference indexes must not be swapped.</li>\n\
<li>If a reference is removed from any position other than the last, the number of references returned by <code>ReferenceMaker::NumRefs()</code> must not be reduced and NULL must be returned for that reference index.</li>\n\
<li>New references must only be added to the last position.</li>\n\
</ul>\n\
<p>In summary for this case, the order and type of references should not change. If a reference is no longer needed, its reference number should remain valid but always return NULL. If a reference needs to change type then it should return NULL, and a new one of the desired type should be added at the end of the list. To avoid instabilities all reference positions should support NULL references.</p>\n\
<p>For more information and sample code, see the documentation of <code>ReferenceMaker::SpecifySaveReferences()</code> member function and <code>ReferenceSaveManager</code> class.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";