var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"indirect_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Indirect References</h1></div><p>An indirect reference from a reference maker to a reference target means that the reference maker contains a member reference member, which holds a direct reference to the target. Indirect references allow limited circular reference hierarchies. This could be useful, for example, if a script and expression controller variable points to a node, where the controller is under the node in the reference hierarchy.</p>\n\
<p>An example of a plug-in that uses indirect references is Ring Array. The Ring Array plug-in driver controller needs to know about the nodes in the system object at the same time that the driven controllers of each node that is part of a Ring Array system object need to reference the driver controller in order to react to changes in the parameters it holds. Thus, the driver controller cannot reference the nodes, since they reference the driven controllers which reference the driver controller. The Ring Array driver controller holds indirect references to the nodes that are part of the system.</p>\n\
<p>An indirect reference is implemented as an <code>IIndirectReferenceMaker</code> interface on a reference maker.</p>\n\
<p>The member reference member is not exposed as a direct reference by the parent reference maker, as a result notifications and reference hierarchy enumerations aren&#39;t automatically performed between the parent and the member. If needed, the member passes notifications to the parent, and the parent passes enumerations to the member, in an implementation-specific manner.</p>\n\
<p>The reference from the member to the target must be a weak direct reference. Otherwise, we could end up with undeletable &quot;islands&quot; of references. For example, if A holds a strong reference to B, and B holds an indirect reference to A, if the indirect reference to A was strong, then A would never be deleted because there is always at least one strong reference to it, and B would not be deleted because A is never deleted. If the method <code>IIndirectReferenceMaker::ShouldPersistIndirectRef()</code> returns <code>FALSE</code> (which it does by default), saving or loading the reference maker implementing <code>IIndirectReferenceMaker</code> does not force the target to be saved or loaded. Thus indirect references would normally not be forced to save or load when the maker is saved or loaded. Typical cases where an implementation of this method would return TRUE is if the indirect reference is to a node (such as in <code>NodeTransformMonitor</code>) or post-load callbacks are used to check and process the indirect reference. If <code>ShouldPersistIndirectRef</code> returns <code>FALSE</code>, it is possible that the target will be saved or loaded due to other references. In this case, the indirect reference link between the reference maker and the reference target will be retained.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"indirect_references/node_monitors.html\">Node Monitors</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"indirect_references/using_indirect_references_instea.html\">Using Indirect References Instead of Pointers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"indirect_references/indirect_reference_example.html\">Indirect Reference Example</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"indirect_references/indirect_references_and_object_x.html\">Indirect References and Object XRefs</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../kinds_of_references.html\">Kinds of References</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";