var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"indirect_reference_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Indirect Reference Example</h1></div><p>The following MAXScript code and diagram illustrate an example when a reference hierarchy would need to be circular. The MAXScript code creates references that point upwards in the reference hierarchy using indirect references. A diagram of the various scene entities and their relationships follows. The dashed lines in the diagram represent indirect references. If these indirect references were assumed to be ordinary or strong references, code that followed the reference tree would find itself in an infinite loop.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">-- Create two spheres\n\
s1 = sphere pos:[100,100,0] \n\
s2 = sphere pos:[-100,100,0]\n\
\n\
-- Create a float contoller for the radius\n\
rc = float_script()\n\
s2.radius.controller = rc  \n\
\n\
-- Create a teapot\n\
t1 = teapot()\n\
rc.AddNode &quot;teapot&quot; t1\n\
\n\
-- Create and assign a position controller to the teapot\n\
sc = Position_Script()\n\
t.pos.controller = sc\n\
\n\
-- Display the controller dialogs\n\
displayControlDialog rc &quot;sphere radius&quot;\n\
displayControlDialog sc &quot;teapotpos&quot;\n\
\n\
-- Add the sphere as a node to the script controller\n\
sc.AddNode &quot;s1_Node_Node&quot; s1\n\
rtm = RefTargMonitor refTarg:s2.baseobject \n\
sc.AddObject &quot;s_base_object&quot;\n\
\n\
-- Post load\n\
sc = $teapot01.pos.controller\n\
rc = $sphere02.radius.controller\n\
displayControlDialog rc &quot;sphere radius&quot;\n\
displayControlDialog sc &quot;teapotpos&quot;\n\
rtm = sc.getVarValue &quot;s_base_object&quot;\n\
rtm.reftarg</code></pre><p><img src=\"./images/GUID-DDD1D581-1628-44ED-868F-CBC5868BBD07-low.png\" alt></p>\n\
<p>The 3ds Max SDK provides the following indirect reference makers that plug-in developers can use: <code>INodeMonitor</code>, <code>INodeTransformMonitor</code>, <code>IRefTargMonitorClass</code>, and <code>IIndirectRefTargContainer</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../indirect_references.html\">Indirect References</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";