var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"indirect_references_and_object_x\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Indirect References and Object XRefs</h1></div><p>Developers use <a href=\"./../indirect_references.html\">Indirect References</a> in situations where direct references would create circular references. This is done instead of using pointers so that when an object XRef is loaded, the references can be recreated correctly.</p>\n\
<h2 id=\"recording-information-to-remap-node-references-during-xref\">Recording Information to Remap Node References During XRef</h2><p>References to nodes held by scene entities that are XRef&#39;d must be remapped when updating XRefs. 3ds Max records node-ref-remap entries automatically when merging objects for the purpose of XRef&#39;s . References to nodes held by object XRef&#39;d reference makers must also be remapped when updating XRef records.</p>\n\
<p>In most cases, 3ds Max automatically records data required to remap node references when XRefing objects. For the legacy version of the plug-in to be XRef-able, the plug-in must record remapping information in a postload-callback for the indirect references to nodes.</p>\n\
<p>Use <code>ILoad::RecordNodeRefRemap()</code> to record remap information for indirect references to nodes. For more information, see <code>ioapi</code>.h.</p>\n\
<h2 id=\"sample-code\">Sample Code</h2><p>Here is a list of plugins in the <em>3ds Max SDK</em> Samples that use <code>INodeMonitor</code> and indirect references:</p>\n\
<ul>\n\
<li>Ring array -  <em>maxsdk\\samples\\objects\\ringarray.cpp</em> </li>\n\
<li>Layer controller -  <em>maxsdk\\samples\\controllers\\layerctrl</em> . cpp</li>\n\
<li>The hose object -  <em>maxsdk\\samples\\objects\\extendedobjects\\hose.cpp</em> </li>\n\
<li>The sunlight system object -  <em>maxsdk\\samples\\systems\\sunlight\\sunlight.cpp</em></li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../indirect_references.html\">Indirect References</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";