var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"weak_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Weak References</h1></div><p>The weak direct reference represents simply the observer relationship with no additional semantics (e.g. lifetime management). Weak direct references do not prevent reference targets from being deleted from a scene.</p>\n\
<p>A reference maker informs 3ds Max that a reference is weak by returning <code>FALSE</code> in the implementation <code>ReferenceMaker::IsRealDependency()</code> for the specified reference target.</p>\n\
<p>If the method <code>ReferenceMaker::ShouldPersistWeakRef()</code> returns <code>FALSE</code> (which it does by default), saving or loading the reference maker does not force the target to be saved or loaded. If the target is a weak reference and <code>ReferenceMaker::ShouldPersistWeakRef()</code> returns <code>FALSE</code>, it is still possible that the target will be saved or loaded due to other references. In this case, the weak reference link between the maker and the target is retained.</p>\n\
<p>Weak references would normally not force a save or load of the reference target when the maker is saved or loaded. If the target is a weak reference, and <code>ReferenceMaker::ShouldPersistWeakRef()</code> returns <code>TRUE</code>, it is possible that on reloading the saved file that the reference maker will hold the only reference to the target. If something else temporarily creates a direct reference to the target, the target will be deleted when that reference is dropped. From the user&#39;s perspective, this will seem to be a randomly occurring event. Also, if a maker holds the target as a weak reference, most of the time there is no way via the maker to view the user interface for the target. For example, consider a case where a weak reference is held to the parameter block of another object. If the object &quot;owning&quot; the parameter block is not also loaded, there is no way to display the UI for the parameter block. A typical case where an implementation of <code>ReferenceMaker::ShouldPersistWeakRef()</code> would return TRUE is when post-load callbacks are used to check and process the references, checking for things like ownerless parameter blocks.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../kinds_of_references.html\">Kinds of References</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";