var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_messages\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference Messages</h1></div><p>A reference message is sent from a target to reference makers which maintain a direct reference (either strong or weak) to it. A reference message is represented by the type <code>RefMessage</code>. Reference messages are sent by a reference target in response to a call to <code>ReferenceTarget::NotifyDependents()</code>. The message is received by an observing reference maker in the method <code>ReferenceMaker::NotifyRefChanged()</code>. A plug-in will override this method to process messages received from any scene objects that it observes and depends on.</p>\n\
<p>Reference messages are integer constants defined in the file <code>ref.h.</code> A full list of reference messages can be found in the topic <code>Reference Messages</code> in the 3ds Max SDK reference guide.</p>\n\
<p>Some of the most common reference messages follow:</p>\n\
<ul>\n\
<li><code>REFMSG_TARGET_DELETED</code> - This message is sent when a <code>ReferenceTarget</code> is deleted.</li>\n\
<li><code>REFMSG_CHANGE</code> - Sent to dependents of a <code>ReferenceTarget</code> that has changed in some way.</li>\n\
<li><code>REFMSG_BEGIN_EDIT</code> - This is used by modifiers to indicate when they are beginning an edit.</li>\n\
<li><code>REFMSG_END_EDIT</code> - This is used by modifiers to indicate when they are ending an edit.</li>\n\
<li><code>REFMSG_MOD_EVAL</code> - Modifier uses this to tell modified objects to call their <code>Object::Eval()</code> procedure.</li>\n\
</ul>\n\
<p>User defined reference messages should be defined as a value greater than <code>REFMSG_USER</code>. For example.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">const RefMessage MYMSG1 = REFMSG + 0;\n\
const RefMessage MYMSG2 = REFMSG + 1;\n\
// ...\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"reference_messages/handling_reference_messages.html\">Handling Reference Messages</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"reference_messages/viewing_reference_messages.html\">Viewing Reference Messages</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";