var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"viewing_reference_messages\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Viewing Reference Messages</h1></div><p> This section discusses a utility plug-in called the Reference Watcher. This plug-in is used to help understand the reference structure of a chosen item and to monitor the reference messages it sends. This provides a quick, visual way for developers to examine the use of references in 3ds Max.\n\
 This plug-in allows you to create a reference to a chosen Reference Target and then watch the messages sent as you work with the target. For instance, follow the steps below to analyze the reference messages sent by a node in the scene.</p>\n\
<h2 id=\"setting-up-reference-watcher-in-visual-studio\">Setting up Reference Watcher in Visual Studio</h2><p>  The project is in  <em>\\MAXSDK\\HOWTO\\UTILITIES\\REFERENCECHECK\\</em>\n\
  Load this project into VC++, set up your input and output paths and build it. Place <code>REFCHECK</code>.DLU into your 3ds Max DLL search path (for example in the \\Plug-inS directory). You can then run the program by choosing How To/Reference Watcher in the utility panel.</p>\n\
<h3 id=\"running-reference-watcher-in-3ds-max\">Running Reference Watcher in 3ds Max</h3><p>  Reset 3ds Max and create a single Box in the scene called Sphere01. Leave it selected after creation.\n\
  Launch the Reference Watcher from the Utility branch of the command panel.\n\
  Click on the <em>Pick Reference Target to Watch button</em> and choose the Sphere01 node from the track bar dialog by opening the Objects branch and selecting the Sphere01 label then pressing OK.</p>\n\
<h2 id=\"result\">Result</h2><p>  The Reference Watcher utility creates a reference to the box node in the scene and displays information about it.\n\
  As you work with the node (select it/deselect it, assign modifiers, bind to space warps, assign materials, change controllers, drag the item in the viewports, etc.), you can monitor the reference messages sent. You recognized them because the use the <code>\\#define</code> name from <code>ref</code>.h (for example <em>REFMSG_CHANGE</em> ) in the upper most window. If you want to clear the message list so you can see what messages are sent for a particular action, press the Clear Message List button first.</p>\n\
<h3 id=\"listbox-reference-messages-recieved-from-target\">ListBox - Reference Messages Recieved From Target</h3><p>  This upper most list box shows a list of reference messages. The list is blank at first, but once the sphere is moved, it fills with messages as shown below.<br>  <img src=\"./images/reference_watcher.png\" alt=\"\">  </p>\n\
<h2 id=\"listbox-referencemakers-who-reference-this-item\">ListBox - ReferenceMakers Who Reference This Item</h2><p>  The second list box in the dialog shows the items referencing the node you have selected. This provides a way to see who is referencing an item. In the case of the Sphere01 node these are:</p>\n\
<ul>\n\
<li>0: NodeSelection</li>\n\
<li>1: Animatable</li>\n\
<li>2: (This Reference Watcher)</li>\n\
<li>3: Animatable</li>\n\
<li>4: Animatable<h2 id=\"listbox-referencetargets-this-item-references\">ListBox - ReferenceTargets This Item References</h2>The bottom most list box shows the references that the node itself has. Sphere01 node has 16 reference targets. Many ReferenceTargets are NULL but you can see a few references of interest in the following table:</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_messages.html\">Reference Messages</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";