var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_object_lifetime_manage\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference Object Lifetime Management</h1></div><p>Objects managed by the 3ds reference system, are normally destroyed automatically when there are no more strong references to them. One exception to this are nodes (<code>INode</code>) which can be deleted by a user. Occasionally user code needs to destroy objects derived directly or indirectly from class <code>Animatable</code>, <code>ReferenceMaker</code>, or <code>ReferenceTarget</code>.</p>\n\
<p>When these objects are destroyed by calling the delete operator on a pointer to them, the reference links between these objects are not properly disconnected, which can make 3ds Max unstable.</p>\n\
<p>To make it easier for plug-ins to use the correct method of destroying objects via pointers to class <code>Animatable</code>, <code>ReferenceMaker</code> or <code>ReferenceTarget</code>, the destructor of these classes has been made protected. As a side effect, instances of these classes cannot be stack based. That means they cannot be allocated on the stack or passed by value as function parameters.</p>\n\
<p>Never use operator delete directly on a plug-in instance, or any instance of classes derived from class <code>Animatable</code>, class <code>ReferenceMaker</code>, and class <code>ReferenceTarget</code>. Instead use one of the following techniques for deleting objects:</p>\n\
<ul>\n\
<li>Objects derived from <code>ReferenceTarget</code> should be deleted by calling <code>ReferenceTarget::MaybeAutoDelete()</code>. This is going to be the most common scenario, as most 3ds Max entities are derived from <code>ReferenceTarget</code>.</li>\n\
<li>Objects derived from <code>ReferenceMaker</code> and not <code>ReferenceTarget</code> should be deleted by calling <code>ReferenceMaker::DeleteMe()</code>.</li>\n\
<li>Objects that derive from <code>ReferenceTarget</code> but overwrite <code>ReferenceTarget::AutoDelete()</code> to prevent their deletion should be deleted by calling <code>ReferenceMaker::DeleteMe()</code>.</li>\n\
<li>Objects derived from <code>Animatable</code> but are not derived from <code>ReferenceMaker</code> should be deleted by calling <code>Animatable::DeleteThis()</code>.</li>\n\
</ul>\n\
<p>When an object is deleted via <code>ReferenceTarget::MaybeAutoDelete()</code> or <code>ReferenceMaker::DeleteMe()</code> all of the dependent are notified, the reference are deleted, and undo is handled properly.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";