var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"cloning_reference_targets\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Cloning Reference Targets</h1></div><p>If you wish to clone an object derived from <code>ReferenceTarget</code> you must use <code>RemapDir::CloneRef()</code> or <code>::CloneRefHierarchy()</code> instead of <code>ReferenceTarget::Clone()</code>. This will correctly perform backpatching of references in the reference hierarchy. If backpatching is not performed, a reference graph can keep references to the original object, instead of to the copied object.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">ReferenceTarget* Clone(ReferenceTarget* aTarget)\n\
  {\n\
    return CloneRefHierarchy(aTarget);\n\
  }  \n\
};</code></pre><p>In some cases you may need to clone a group of references, in which case you would need to use an instance of <code>RemapDir</code>. The following code demonstrates such a scenario:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">PRSControl&amp; PRSControl::operator=(const PRSControl&amp; ctrl) {\n\
  RemapDir *remap = NewRemapDir();\n\
  ReplaceReference(PRS_POS_REF,remap-&gt;CloneRef(ctrl.pos));\n\
  ReplaceReference(PRS_ROT_REF,remap-&gt;CloneRef(ctrl.rot));\n\
  ReplaceReference(PRS_SCL_REF,remap-&gt;CloneRef(ctrl.scl));\n\
\n\
  // Make sure that if any sub-controller references this \n\
  // controller that it will get backpatched correctly  \n\
  remap-&gt;AddEntry(ctrl,this);\n\
  remap-&gt;DeleteThis();\n\
  mLocked = ctrl.mLocked;\n\
  return(*this);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system_common_tasks.html\">Reference System Common Tasks</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";