var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"counting_observers_of_a_referenc\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Counting Observers of a Reference Target</h1></div><p>The following code demonstrates how to count the number of reference makers that are directly observing a reference target.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">unsigned int GetImmediateDependencyCount(ReferenceTarget* rtarg)\n\
{\n\
  unsigned int count = 0;\n\
  DependentIterator di(rtarg);\n\
  while (di.Next() != NULL) \n\
  {\n\
    count++;\n\
  }\n\
  return count;\n\
}\n\
</code></pre><p>To count all references that are dependent on an object, directly or indirectly you would use <code>ReferenceTarget::DoEnumDependents()</code>. This would be done as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">unsigned int GetAllDependencyCount(ReferenceTarget* rtarg)\n\
{  \n\
  struct CallBack : DependentEnumProc {\n\
    int count;\n\
    CallBack() : count(0) { }\n\
    virtual int proc(ReferenceMaker* rmaker) { \n\
      ++count;\n\
    }\n\
  };\n\
\n\
  CallBack cb;\n\
  rtarg-&gt;DoEnumDependents(&amp;cb);\n\
  return cb.count();  \n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system_common_tasks.html\">Reference System Common Tasks</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";