var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_reference_makers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Reference Makers</h1></div><p>Most plug-ins are reference makers (i.e. derived from <code>ReferenceMaker</code>). If a plug-in wants to observe an object, it is responsible for implementing functions from <code>ReferenceMaker</code> for managing the reference links and to respond to reference messages from the objects it references.</p>\n\
<p>A class derived from <code>ReferenceMaker</code> will usually manage its observed reference targets via member variables. These member variables should be initialized to NULL in its constructor.</p>\n\
<p>The following are some methods of <code>ReferenceMaker</code> that must be implemented by a class that wishes to observe reference targets:</p>\n\
<ul>\n\
<li><code>ReferenceMaker::NotifyRefChanged()</code> - This method is called by 3ds Max when a referenced target has sent a reference message.</li>\n\
<li><code>ReferenceTarget::NotifyDependents()</code> - If a plug-in wishes for its dependents to be notified of the same message it should call on itself.</li>\n\
<li><code>ReferenceMaker::NumRefs()</code> - Returns the number of references a maker has.</li>\n\
<li><code>ReferenceMaker::GetReference()</code> - Provides access to a reference maker&apos;s references. This allows 3ds Max to access a reference maker&apos;s references.</li>\n\
<li><code>ReferenceMaker::SetReference()</code> - Allows 3ds Max to set the reference maker&apos;s references. Normally you would not call this method directly, instead you would call <code>ReferenceMaker::ReplaceReference()</code> which would call this method.</li>\n\
<li><code>ReferenceMaker::IsRealDependency()</code> - Indicates whether a given reference is strong or not.</li>\n\
</ul>\n\
<p>A reference maker is also responsible to call <code>ReferenceTarget::NotifyDependents()</code> whenever it changes in ways that it can affect reference makers that depend on it. It sends a reference message that encodes the nature of the change to the dependents of the reference target. This method is implemented by 3ds Max.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> In addition to <code>ReferenceTarget</code> and <code>ReferenceMaker</code> some functions accept the typedefs <code>RefTargetHandle</code> and <code>RefMakerHandle</code>:</div>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">typedef ReferenceTarget* RefTargetHandle;\n\
tyepdef ReferenceMaker* RefMakerHandle;\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";