var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_reference_targets\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Reference Targets</h1></div><p>Most plug-ins are reference targets (i.e. derived from <code>ReferenceTarget</code>) meaning that they can send notifications to observers.</p>\n\
<p>The primary responsibility of a reference target is to notify its dependents of any changes to its structure of exposed values.</p>\n\
<p>The following is a list of some of the important functions that must be implemented by a reference target.</p>\n\
<ul>\n\
<li><code>ReferenceTarget::NotifyDependents()</code> - Your reference target should call this whenever it wants to notify observers of a change to the reference target. 3ds Max will automatically notify dependents if the target is deleted.</li>\n\
<li><code>ReferenceTarget::Clone()</code> - Called by 3ds Max when an object is cloned by the user or via a call to <code>RemapDir::CloneRef()</code> or <code>CloneRefHierarchy()</code>. An override should creates an instance of the new object, and then calls <code>ReferenceTarget::BaseClone()</code>.</li>\n\
<li><code>ReferenceTarget::BaseClone()</code> - This is called by a plug-in from <code>ReferenceTarget::Clone()</code> and allows an object to copy any custom data, and allow derived classes to copy this data in their clone implementations.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../reference_system.html\">Reference System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";