var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"bitmap_gamma_overview\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Bitmap Color Management Overview</h1></div><p>The <code>Bitmap</code> class has properties and methods related to OCIO-based color management as well as the older gamma workflow — which ones are relevant depends on the color management settings of the scene.</p>\n\
<p>In either case, the function <code>Bitmap::GetPixels()</code> returns pixels as they are represented in memory, and the function <code>Bitmap::GetLinearPixels()</code> returns the pixel colors in the rendering (i.e. physical) space:</p>\n\
<ul>\n\
<li>In OCIO mode, <code>Bitmap::GetLinearPixels()</code> applies the appropriate transform to convert from the bitmap&#39;s assigned color space. If the bitmap is already in the rendering space then the null transform is applied.</li>\n\
<li>In gamma mode, it performs an inverse gamma using the input gamma if the bitmap is in perceptual space. If the bitmap is already in physical space then it returns the pixels as is.</li>\n\
</ul>\n\
<h2 id=\"ocio-based-modes\">OCIO-based Modes</h2><p>When using OCIO-based color management, <code>BitmapInfo::ColorSpace()</code> returns the assigned color space of the bitmap. You can also find extra color space information using related functions in <code>BitmapInfo</code>.</p>\n\
<p>When saving, the default output conversion depends on the settings defined in <code>IColorPipelineMgr</code>. You can override this output conversion for an individual bitmap using <code>BitmapInfo::SetOutputColorConversion</code>.</p>\n\
<h2 id=\"gamma-workflow\">Gamma Workflow</h2><p>When using gamma-based color management, the bitmap gamma is used to convert between perceptual space and physical space representation of images. The precise usage of gamma depends on the kind of bitmap.</p>\n\
<ul>\n\
<li>Low Dynamic Range (LDR) bitmaps - This is the most common kind of bitmap. An LDR bitmap is virtually always in perceptual space. In 3ds Max an LDR bitmap is represented using the class <code>BitmapStorageLDR</code>.</li>\n\
<li>High Dynamic Range (HDR) bitmaps - HDR bitmaps are usually (as per recommendation) a representation of an image in physical space on disk. An example is the raw result of a render. In 3ds Max an HDR bitmap is represented using the class <code>BitmapStorageLDR</code>.</li>\n\
</ul>\n\
<p>When a bitmap is loaded from disk into 3ds Max, the memory representation of a bitmap is as it is stored on disk. When a bitmap is the result of a render the memory representation will always be in physical space.</p>\n\
<p>When saving a bitmap to disk:</p>\n\
<ul>\n\
<li>An LDR bitmap must be converted to perceptual space.</li>\n\
<li>An HDR bitmap must be saved as is (i.e. physical space).</li>\n\
</ul>\n\
<h3 id=\"the-two-bitmapinfo-gamma-values\">The Two BitmapInfo Gamma Values</h3><p>A <code>BitmapInfo</code> struct contains two gamma values: the file gamma and the custom gamma.</p>\n\
<ul>\n\
<li>File Gamma - The file gamma is the gamma which was embedded in the original file on disk. For bitmap file types that support this value it indicates the output gamma used when the file was originally save. The file gamma is accessed via <code>BitmapInfo::Gamma()</code> and set using <code>BitmapInfo::SetGamma()</code>. A bitmap will use file gamma as its input gamma if the <code>BMM_CUSTOM_FILEGAMMA</code> flag is set via <code>BitmapInfo::SetCustomFlags()</code>.</li>\n\
<li>Custom Gamma - This is either an override gamma value provided by the user or the default gamma value, depending on options specified by the user when the file was loaded. It is important to set this to 1.0 for bump or displacement maps because they encode linear data. The custom gamma can be read using <code>BitmapInfo::GetCustomGamma()</code> and set using <code>BitmapInfo::SetCustomGamma().</code> A bitmap will use the custom gamma as its input gamma if the <code>BMM_CUSTOM_GAMMA</code> flag is set via <code>BitmapInfo::SetCustomFlags()</code>.</li>\n\
</ul>\n\
<p>The method <code>BitmapInfo::GetEffectiveGamma()</code> will return either the custom gamma or file gamma, depending on the flags set in the bitmap.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../bitmap_gamma_correction.html\">Bitmap Color Management</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";