var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"changing_bitmap_texture_map_gamm\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Changing Bitmap Texture Map Gamma</h1></div>\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>  <strong></strong> This information applies when using the older gamma-based workflow for color management.</p>\n\
\n\
</div></div>\n\
\n\
<p>In order to change the gamma value of a Bitmap Texture that has been loaded, it is recommended that you reload the bitmap from disk. This can be accomplished using <code>BitmapTex::ReloadBitmapAndUpdate()</code>.</p>\n\
<p>In order to assure that bitmap is reloaded with the desired gamma value, you must change the gamma setting of the bitmap info (<code>BitmapInfo</code>) stored in the bitmap texture&#39;s parameter block. This must be done prior to the reload.</p>\n\
<p>In order for the custom gamma to take effect when reloading the bitmap, the <code>BMM_CUSTOM_GAMMA</code> flag must be set on the bitmap info using <code>BitmapInfo::SetCustomFlag()</code>. The gamma value itself can be set using the method <code>BitmapInfo::SetCustomGamma()</code>.</p>\n\
<p>The following code demonstrates this.</p>\n\
<p>&#39;&#39;&#39;\n\
void SetBitmapTextureGamma(BitmapTex* texmap)\n\
{\n\
   IParamBlock2* pb2 = texmap-&gt;GetParamBlock(0);</p>\n\
<p>  // get the bitmap parameter\n\
  int n = pb2-&gt;GetDesc()-&gt;NameToIndex(&quot;bitmap&quot;);\n\
  ParamID id = pb2-&gt;GetDesc()-&gt;IndextoID(n);\n\
  PBBitmap* pbBitmap = pb2-&gt;GetBitmap(id);</p>\n\
<p>  // tell the bitmap info struct not to use a file gamma\n\
  pbBitmap-&gt;bi.ResetCustomFlag(BMM_CUSTOM_FILEGAMMA);</p>\n\
<p>   // set a fake gamma value for demonstration purposes\n\
  pbBitmap-&gt;bi.SetCustomGamma( 2.5f );</p>\n\
<p>   // now reload the bitmap from the disk.\n\
  texmap-&gt;ReloadBitmapAndUpdate();\n\
}</p>\n\
<p>&#39;&#39;&#39;</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../bitmap_gamma_correction.html\">Bitmap Color Management</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";