var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"extending_render_to_texture_to_s\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Extending Render To Texture to Support New Materials</h1></div><p>The Render to Texture feature provides the ability to render out various elements from a standard render, for example light maps and specular maps. It works in conjunction with the new UVW Unwrap modifier, which can now flatten texture coordinates. Please see the user guide for a more detailed description.</p>\n\
<p>This new feature now creates certain maps that do not fit into any particular material map slot for example, a light map. However 3rd party materials may exist that support extended features. <code>BakeTextureMappings.ini</code> file allows developers to add support for new materials. This provides the mapping between the different baked elements and the map slots in the material.</p>\n\
<p>An example INI file can be seen below.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">[DeclareFileMappings]\n\
DeclareFileMapping1=SaveAll\n\
DeclareFileMapping2=CompleteOnly\n\
DeclareFileMapping3=\n\
DeclareFileMapping4=\n\
DeclareFileMapping5=\n\
DeclareFileMapping6=\n\
DeclareFileMapping7=\n\
DeclareFileMapping8=\n\
DeclareFileMapping9=\n\
DeclareFileMapping10=\n\
\n\
[CompleteOnly]\n\
shaderName =  blinn\n\
ambientMap=\n\
diffuseMap =   CompleteMap\n\
specularMap=\n\
diffuseLevelMap=\n\
specularLevelMap=\n\
glossinessMap=\n\
selfIllumMap=\n\
opacityMap=\n\
filterMap=\n\
bumpMap=\n\
reflectionMap=\n\
refractionMap=\n\
displacementMap=\n\
diffuseRoughnessMap=\n\
anisotropyMap=\n\
orientationMap=\n\
glossinessMap2=\n\
anisotropyMap2=\n\
orientationMap2=\n\
\n\
[SaveAll]\n\
shaderName=  oren-nayar-blinn\n\
ambientMap=  CompleteMap\n\
diffuseMap=  DiffuseMap\n\
diffuseLevelMap= ShadowsMap\n\
specularLevelMap=SpecularMap\n\
bumpMap=  NormalsMap\n\
opacityMap=  AlphaMap\n\
selfIllumMap= LightingMap\n\
displacementMap= BlendMap</code></pre><p>The first section of the file is used to populate the drop down list in the RTT dialog box. For each entry there must be a subsequent entry defining the mapping. In the save all section all the supported baked elements are mapped to a standard material. This provides a method of viewing all the maps created, not necessarily to produce the correct rendering</p>\n\
<p>The names, on the left hand side are the supported MAXScript names for the parameters that have been defined in the <code>ParamBlockDesc2</code> of the material. The name on the right is the actual baked element name used in the RTT. This mapping and naming needs to be accurate as it can cause a run time error in the RTT macro script</p>\n\
<p>The Render To Texture script has been written to use the <code>ViewportManager</code> to handle viewport shaders. Internally it supports the Metal Bump and Light Map shaders. The script can be found in the 3ds Max installation folder at <code>\\\\UI\\\\Macroscripts\\\\Macro_BakeTextures.mcr</code>. In the function called <code>UpdateMaterial</code>, there is a section that provides additional Viewport vhader support. The script lists all available shaders, so all that is needed is for the developer to supply the correct setup for the shader. Examples can be found in the function <code>setupLightMapShader</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";