var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"principal_light_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Principal Light Classes</h1></div><p>The following are the primary classes used for working with lights in the 3ds Max SDK.</p>\n\
<ul>\n\
<li><code>LightObject</code> - This is a base class for plug-in lights. It has a method used to retrieve the light&#39;s properties at a certain time, a method to create an <code>ObjLightDesc</code> object. It also has methods that allow the many properties of the light to be read and altered.</li>\n\
<li><code>GenLight</code> - This is also a possible candidate for plug-in lights to sub-class from. This class, sub-classed from <code>LightObject</code>, provides a set of additional methods (for example access to the controllers handling the animation of the light&#39;s properties).</li>\n\
<li><code>LightscapeLight</code> - This class derives from <code>GenLight</code>, and is the base class for all Photometric lights. This class provides methods for getting and setting photometric settings, such as distribution and intensity.</li>\n\
<li><code>Light</code> - This class describes the properties of the lights used in the interactive renderer. See <code>Light methods in Class GraphicsWindow</code> for a list of methods that use this class.</li>\n\
<li><code>DefaultLight</code> - An array of these objects is passed in the <code>Render::Open()</code> method of a renderer plug-in. This class contains the transformation matrix of the light and a <code>LightState</code> object (described below) that describes the characteristics of the light.</li>\n\
<li><code>LightState</code> - This structure describes the properties of a light. When the method <code>LightObject::EvalLightState()</code> is called, the <code>LightState</code> structure is updated. This is used, for example, by many of the file format export plug-ins to grab data about the lights they are exporting.</li>\n\
<li><code>LightDesc</code> - This class has a single method <code>LightDesc::Illuminate()</code> used to determine the color and direction of the light striking a point. It has two public data members that indicate if the diffuse and/or specular color of objects should be affected by the light.</li>\n\
<li><code>ObjLightDesc</code> - This class derives from <code>LightDesc</code> (described above). There is an instance of this class for every instance of a light in the scene. The renderer asks each light in the scene to create one of these objects by calling <code>LightObject::CreateLightDesc()</code> and passing it the light node. This class has data members that provide information such as a pointer to the node for the light, a <code>LightState</code> object, various transformation matrices that provide conversions between the light&#39;s space and world and camera space. It has a method to retrieve the lights exclusion list, and a method to update the light&#39;s data members in this class once per render. It also has a method used in computing volume lighting effects, TraverseVolume().</li>\n\
</ul>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> Skylight ise not exposed as a class in the SDK. However, you can create instances of this class in a scene by passing its class ID to <code>CreateInstance()</code>.</p>\n\
\n\
</div></div>\n\
\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../lights.html\">Lights</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";