var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"assigning_materials_to_nodes_in_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Assigning Materials to Nodes in the Scene</h1></div><p>A developer may also wish to create materials and assign them to nodes in the scene.</p>\n\
<p>Sample code using many of these functions is available in the .3ds importer plug-in. This code may be found in <em>\\MAXSDK\\SAMPLES\\IMPORT_EXPORT\\3DSIMP.CPP</em> .</p>\n\
<p>The code below demonstrates how a 3ds Max Standard material may be assigned to a mesh object. It assigns a material with Red Ambient and Diffuse settings to the first node in the current selection set.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void AssignMtl(Interface *ip)\n\
{\n\
   if (! ip-&gt;GetSelNodeCount()) return; // Nothing to assign.\n\
   INode *node = ip-&gt;GetSelNode(0);\n\
\n\
   // Create a new Standard material.\n\
   StdMat *m = NewDefaultStdMat();\n\
\n\
   // Set its properties...\n\
   m-&gt;SetName(_T(&quot;Sample&quot;));\n\
   m-&gt;SetAmbient(Color(1.0f,0.0f,0.0f),0); // Pure Red\n\
   m-&gt;SetDiffuse(Color(1.0f,0.0f,0.0f),0);\n\
   m-&gt;SetSpecular(Color(1.0f,1.0f,1.0f),0);\n\
   m-&gt;SetShininess(0.5f,0);\n\
   m-&gt;SetShinStr(.7f,0);\n\
\n\
   // Assign it to the node.\n\
   node-&gt;SetMtl(m);\n\
   ip-&gt;RedrawViews(ip-&gt;GetTime());\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../materials_textures_and_maps.html\">Materials, Textures and Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";