var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"material_libraries\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Material Libraries</h1></div><p>3ds Max stores groups of materials in a library file with the .mat file extension. The API provides methods to access the materials stored in these libraries. You can use the methods <code>Interface::LoadMaterialLib()</code> and <code>Interface::SaveMaterialLib()</code>. This class also has a method <code>GetMaterialLibrary()</code> which returns a reference to the currently loaded library. You may then use class <code>MtlBaseLib</code> to access the materials themselves. The sample code below shows how this is done. It loads a materials library, removes a single material, and saves it again.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void TestMaterialLib()\n\
{\n\
   // TODO: Change the path\n\
   TCHAR *n1 = _T(&quot;D:\\\\3DSMAX\\\\MAPS\\\\3DSMAX.MAT&quot;);\n\
\n\
   int okay = ip-&gt;LoadMaterialLib(n1);\n\
   if (! okay) return;\n\
\n\
   // Declare this as references since we want to manipulate the\n\
   // original material library and not a copy.\n\
   MtlBaseLib &amp;mlib1 = ip-&gt;GetMaterialLibrary();\n\
   intindex = mlib1.FindMtlByName(TSTR(_T(&quot;Aqua Glaze&quot;)));\n\
   if (index != -1)\n\
     mlib1.Remove(mlib1[index]);\n\
\n\
   ip-&gt;SaveMaterialLib(n1);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../materials_textures_and_maps.html\">Materials, Textures and Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";