var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"principal_classes_for_materials_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Principal Classes for Materials and Textures</h1></div><p>The following are the main classes associated with materials and textures.</p>\n\
<ul>\n\
<li><code>MtlBase</code> - The base class for all materials and texture classes.</li>\n\
<li><code>Mt</code>l - The base class for all material plug-ins.</li>\n\
<li><code>Texmap</code> - The base class for procedural textures plug-ins.</li>\n\
<li><code>ShadeContext</code> - Provides data members and methods used in communication between the renderer and the plug-in material or texture. An instance of this class is passed into various methods associated with materials and texture maps.</li>\n\
<li><code>RenderGlobalContext</code> - Used by materials, texture maps, and other classes, to retrieve information about the global rendering environment, such as the renderer in use, the project type for rendering, the output device width and height, several matrices for transforming between camera and world coordinates, the environment map, the atmospheric effects, the current time, field rendering information, and motion blur information.</li>\n\
<li><code>IMtlParams</code> - An interface class passed to a material or texture map when it is being edited in the materials editor. The class has methods to do things such as add roll-up pages to the dialog, remove rollup pages, and retrieve the current time (frame slider position).</li>\n\
<li><code>ParamDlg</code> - Every <code>MtlBase</code> derived class (i.e. texture map and material) defines a <code>ParamDlg</code> to manage its part of the material editor user interface. See the topic on <a href=\"editing_material_and_texture_par.html\"\">Editing Material and Texture Parameters</a> for details on how this class is used.</li>\n\
<li><code>UVGen</code> - Most texture maps that use UV-coordinate systems will use a <code>UVGen</code>. This class encapsulates a lot of the user interface for setting mirroring, tiling and so on. The <code>UVGen</code> is given a <code>MapSampler</code> callback, and the plug-in lets the <code>UVGen</code> call it. This lets the <code>UVGen</code> figure out the components for anti-aliasing, and it includes any transform including scaling, rotation, moving, and noise on the UVs.</li>\n\
<li><code>MapSampler</code> - A texture map implements this class and passes it into the methods <code>UVGen::EvalUVMap()</code>, <code>UVGen::EvalUVMapMono()</code>, and <code>UVGen::EvalDeriv()</code> to evaluate itself with tiling &amp; mirroring. Each of the methods of this class are used to sample the map at a single UV coordinate.</li>\n\
<li><code>XYZGen</code> - Generates <code>Point3</code> coordinates based on the <code>ShadeContext</code>. A reference to one of these is referenced by all 3D texture maps. <code>XYZGen</code> does for 3D Texmaps what <code>UVGen</code> does for 2D Texmaps. It puts up the 3D &quot;Coordinates&quot; rollup, and supplies the 3D Texmap with transformed 3D coordinates.</li>\n\
<li><code>TextureOutput</code> - This class may be used by textures to provide control over their output. The standard rollup page &#39;Output&#39; is managed by this class. The Output Amount, RGB Level, and RGB Offset are settable. In the future this may be enhanced to include other things that are often desirable on the output stage such as tinting, color shifting, etc.</li>\n\
</ul>\n\
<p>The following are the main classes associated with <em>accessing</em> properties of materials and textures:</p>\n\
<ul>\n\
<li><code>StdMat</code> - Provides access to the parameters of the 3ds Max Standard material.</li>\n\
<li><code>MultiMtl</code> - Provides access to the developer alterable properties of the 3ds Max Multi/Sub-Object material.</li>\n\
<li><code>BitmapTex</code> - Provides access to the parameters of the 3ds Max Bitmap texture.</li>\n\
<li><code>StdUVGen</code> - Provides access to the parameters of the 3ds Max UVGen class. These are the settings in the &#39;Coordinates&#39; and &#39;Noise&#39; rollups such as UV offsets, angle, blur, noise level, etc.</li>\n\
<li><code>StdXYZGen</code> - Provides access to the parameter of the 3ds Max XYZGen class.</li>\n\
<li><code>MtlBaseLib</code> - Provides access to the materials stored in a materials library. See the sample code in <a href=\"material_libraries.html\"\">Material Libraries</a> below for an example of use.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../materials_textures_and_maps.html\">Materials, Textures and Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";