var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"network_rendering\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Network Rendering</h1></div><p>The network rendering API is exposed through the <code>MaxNetManager</code> class which allows clients to connect to the Network Rendering Manager to perform any and all functions offered. The API handles all the networking code and communication protocols.</p>\n\
<p>Within 3ds Max, the Network Job Assignment dialog uses the Network Rendering API to submit new jobs to the network queue while the Queue Manager uses the API to provide all of its functionality. Neither of these components have any other type of network access or private access to network rendering facilities. The <code>MaxNet</code> API provides all of these itself.</p>\n\
<p>The entire API is derived from the <code>MaxNet</code> class, which is used solely for exception handling. In order to handle exceptions you can catch a <code>MaxNet</code> object as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">try\n\
{\n\
   // the code being tried\n\
}\n\
catch (MaxNet* maxerr)\n\
{\n\
   // handle the error\n\
   // do NOT delete maxerr\n\
   // use maxerr-&gt;GetErrorText() to get the error description\n\
   // use maxerr-&gt;GetError() to get the error code\n\
}</code></pre><p>The MaxNet class provides the error code in both numeric form, through <code>GetError()</code> in the form of <code>maxnet_error_t</code>type, and in text form, through <code>GetErrorText()</code>. Most methods in the Network Rendering API will return errors only through this mechamisn, particularly methods that handle network transactions.</p>\n\
<p>The Network Rendering API provides two functions that deal with the creation and destruction of the <code>MaxNetManager</code> class instance, these are, <code>CreateManager()</code> and <code>DestroyManager()</code>. The <code>CreateManager()</code> function will return a newly created instance of the <code>MaxNetManager</code> class which can be deleted, when done, by <code>DestroyManager()</code>.</p>\n\
<h2 id=\"queue-control\">Queue Control</h2><p>At any given moment, only one connected client can be in control of the network queue. This means, only one connected client can perform changes. All other clients operate in a &quot;read only&quot; mode.</p>\n\
<h2 id=\"maxnetcallback\">MaxNetCallBack</h2><p>The Network Rendering API provides a callback mechanism through the <code>MaxNetManager</code> class. If you wish to use the callback mechanism you can create your own class derived from <code>MaxNetCallBack</code> and pass it as the argument for <code>MaxNetManager::SetCallBack()</code>. All methods are optional, thus you only need to implement those you require.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";