var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"new_rendering_api\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>New Rendering API</h1></div><p>The topics in this section describe the &quot;new&quot; rendering API for 3ds Max, introduced in <strong>3ds Max 2017</strong>.</p>\n\
<p>A new SDK component, the Rendering API, has been introduced to make writing rendering plugins easier and less error-prone than it has been in the past. Its goals are:</p>\n\
<ol>\n\
<li>To encapsulate code and behaviour that would likely be duplicated by most renderer plugins.</li>\n\
<li>To unify the interfaces for offline and interactive rendering, enabling them to share common design and implementation.</li>\n\
<li>To break up the monolithic API (e.g. class <code>Renderer</code>) into a suite of well-defined interfaces that simplify the design and maintenance of a renderer plugin.</li>\n\
</ol>\n\
<p>A renderer plugin, implemented from this API, should be much simpler to develop - but it should also be better positioned to evolve over time, as more code and behavior are added to the API.</p>\n\
<h2 id=\"file-locations\">File Locations</h2><p>The headers and classes described in these topics are located in these locations in the 3ds Max SDK:</p>\n\
<ul>\n\
<li><em>maxsdk/include/NotificationAPI</em></li>\n\
<li><em>maxsdk/include/RenderingAPI</em></li>\n\
<li><em>maxsdk/samples/render/NofificationSystem</em></li>\n\
<li><em>maxsdk/samples/render/RenderingAPI</em></li>\n\
</ul>\n\
<h2 id=\"use-of-stl\">Use of STL</h2><p>The 3ds Max SDK has traditionally avoided the use of STL to avoid compatibility issues when mixing different compiler versions. But with the advent of C++11, the language has made large strides through STL directly.</p>\n\
<p>The Rendering API makes extensive use of the C++11 smart pointers - <code>unique_ptr</code> and <code>shared_ptr</code> - to enforce a simpler design and safer code. It also uses <code>std::vector</code>, where appropriate, as a replacement to <code>MaxSDK::Array</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/legacy_vs_new.html\">The Legacy vs. New Rendering API</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/unified_renderer.html\">The Unified Renderer</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/render_session.html\">The Render Session</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/render_session_context.html\">The Render Session Context</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/notification_system.html\">The Notification System</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"new_rendering_api/translator_component.html\">The Translator Component</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";