var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"legacy_vs_new\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>The Legacy vs. New Rendering API</h1></div><p>The legacy rendering API is dominated by two classes: Renderer for offline rendering, and IInteractiveRenderer for interactive rendering; with several other (extension) classes which may be grafted onto these two. Class Renderer enforces a monolithic design to the renderer plugin. The same class is responsible for: UI, file I/O, scene translation, and process management.</p>\n\
<p><img src=\"./images/legacy_rendering_api.png\" alt=\"Legacy API Concept\"></p>\n\
<p>The Rendering API introduces a more stringent framework by splitting the design into multiple components. This provides a more coherent structure to the renderer plugin and enables a significant part of the logic to be moved to the 3ds Max core.</p>\n\
<p><img src=\"./images/new_rendering_api.png\" alt=\"New API Concept\"></p>\n\
<p>The four main components of the Rendering API are:</p>\n\
<ol>\n\
<li><p>The <strong>Unified Renderer</strong>, which unifies the renderer plugin interfaces for both offline and interactive rendering. This component lives in the 3ds Max scene, it is responsible for UI exposure, file I/O, scripting, etc.</p>\n\
</li>\n\
<li><p>The <strong>Render Session</strong>, which is responsible for performing the actual rendering. The session is transient - it is a temporary object that lives for the purpose of a single render operation (be it multiple offline frame, or an interactive session). Separating the session from the plugin enables multiple sessions to exist concurrent for a single plugin.</p>\n\
</li>\n\
<li><p>The <strong>Translator</strong>, an optional component which simplifies the tasks of translating a 3ds Max scene to the renderer&#39;s own representation. It provides a framework for managing dependencies between the 3ds Max scene and its translated representation. It also includes basic, common functionality for translating most major 3ds Max scene components.</p>\n\
</li>\n\
<li><p>The <strong>Notification System</strong>, which implements a centralized mechanism for keeping track of any changes in a 3ds Max scene. This is the first system to offer a completely, truly safe method for monitor a 3ds Max scene for arbitrary interactive changes.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../new_rendering_api.html\">New Rendering API</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";