var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"unified_renderer\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>The Unified Renderer</h1></div><p>The Unified Renderer is the entry point to the renderer plugin. It is attached to and lives in the 3ds Max scene.</p>\n\
<p><img src=\"./images/unified_renderer.png\" alt=\"Unified Renderer\"></p>\n\
<p>The Unified Renderer, implemented as class UnifiedRenderer, serves as the base class for a renderer plugin. It replaces classes Renderer and IInteractiveRenderer from the legacy API, and also integrates functionality from various extension classes. Its responsibilities are:</p>\n\
<ul>\n\
<li>It is the entry point for the renderer plugin, meaning that:</li>\n\
<li>It encapsulates the render settings (ideally through parameter blocks).</li>\n\
<li>It manages the UI for the render settings.</li>\n\
<li>It manages file I/O for the render settings (usually automatically through parameter blocks).</li>\n\
<li>It manages maxscript exposure of the render settings (usually automatically through parameter blocks).</li>\n\
<li>It publishes its set of capabilities, e.g. which material plugins are compatible with the renderer.</li>\n\
<li>It manages the creation and destruction of render session (both offline and interactive).</li>\n\
<li>It aggregated and abstracts the contents of the scene to be rendered, re-purposing the data normally passed to Renderer::Open() and Renderer::Render().</li>\n\
<li>It manages the contents of the Render Session Context (to be presented in a following section), which encapsulates all communication between the render session and the system.</li>\n\
</ul>\n\
<h2 id=\"implementing-a-renderer-plugin\">Implementing a Renderer Plugin</h2><p>The plugin developer would start by creating a class that derives from UnifiedRenderer. All important methods have been made pure virtual in UnifiedRenderer, including core methods inherited from Animatable, ReferenceMaker, etc. The most important methods, defined by class UnifiedRenderer, which the plugin developer must implement, are:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual std::unique_ptr&lt;IOfflineRenderSession&gt; CreateOfflineSession(\n\
    IRenderSessionContext&amp; sessionContext) = 0;\n\
virtual std::unique_ptr&lt;IInteractiveRenderSession&gt; CreateInteractiveSession(\n\
    IRenderSessionContext&amp; sessionContext) = 0;</code></pre><p>These govern the creation of the offline and interactive render sessions, with which the actual rendering work is performed. The destruction of a render session is managed through the unique_ptr returned by these methods.\n\
The other important parts of the functionality (render settings, UI, file I/O, etc.) all use the standard mechanisms - generally the parameter block system.</p>\n\
<h3 id=\"class-descriptor\">Class Descriptor</h3><p><code>Class UnifiedRenderer::ClassDescriptor</code> is the base class from which the class descriptor of a UnifiedRenderer plugin must derive. Internally, it implements functionality related to filtering of compatible material and texture plugins.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../new_rendering_api.html\">New Rendering API</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";