var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"posting_messages_to_video_post\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Posting Messages to Video Post</h1></div><p>This section discusses the posting of messages in video post. There are three message types supported:</p>\n\
<ol>\n\
<li>The progress message <code>BMM_PROGRESS</code> updates the dialog with how much of the image has been processed.</li>\n\
<li>The check abort message <code>BMM_CHECKABORT</code> allows the plug-in to detect if the user has canceled the operation.</li>\n\
<li>The text message <code>BMM_TEXTMSG</code> allows the plug-in to send a string to the video post &quot;Progress Report&quot; dialog.</li>\n\
</ol>\n\
<p>These messages are sent via the Window API <code>SendMessage()</code> function listed below. The arguments for each message are listed as well as a single example of use.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">LRESULT SendMessage(\n\
 HWNDhwnd,     // handle of destination window\n\
 UINTuMsg,     // message to send\n\
 WPARAMwParam, // first message parameter\n\
 LPARAMlParam  // second message parameter\n\
);</code></pre><h2 id=\"bmm_progress\">BMM_PROGRESS</h2><p>Sent by the plug-in to notify the host of its current progress.</p>\n\
<ul>\n\
<li>wParam - Current amount processed.</li>\n\
<li>lParam - Total amount to process.</li>\n\
</ul>\n\
<h2 id=\"bmm_checkabort\">BMM_CHECKABORT</h2><p>Sent by the plug-in to check for process interruption. The host should set *lParam to FALSE if it&apos;s OK to continue or TRUE to abort the process.</p>\n\
<ul>\n\
<li>wParam - Always 0.</li>\n\
<li>lParam - Pointer to a BOOL.</li>\n\
</ul>\n\
<h2 id=\"bmm_textmsg\">BMM_TEXTMSG</h2><p>Sent by the plug-in to display an optional text message to the &quot;Progress Report&quot; dialog while rendering in Video Post.</p>\n\
<ul>\n\
<li>wParam - Pass 0</li>\n\
<li>lParam - Pass a LPCTSTR.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";