var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"programming_hardware_shaders\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Programming Hardware Shaders</h1></div><p>This topic describes how to program hardware shaders using DirectX. Any version of the DirectX SDK can be used as long as the core runtime component is DirectX 9.0c or DirectX 11.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> Support for DirectX 9 is a legacy feature, and will be removed in a future release. Developers should use the Nitrous APIs instead. See the <a href=\"./../viewports_and_graphics_windows/nitrous.html\">Nitrous</a> topics.</p>\n\
\n\
</div></div>\n\
\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> Support for the DirectX 10 legacy driver has been removed from the SDK as of 3ds Max 2015.</p>\n\
\n\
</div></div>\n\
\n\
<p>Plug-ins can be built to use any version of DirectX because different versions of Direct X sit side by side (i.e. later versions do not replace earlier version). Only the utility functions are updated with the DirectX updates; the core runtime does not change. Autodesk does not ship with a DirectX 8 driver anymore. However a developer is free to create his or her own window using a DirectX 8 device.</p>\n\
<p>It is the core DirectX runtime that needs to be consistent. So if a developer request for the main DirectX device from 3ds Max, then they need to be using the same runtime component.</p>\n\
<p>There are two main components to DirectX</p>\n\
<ul>\n\
<li>The DirectX core</li>\n\
<li>Direct3d Extension (D3DX)</li>\n\
</ul>\n\
<p>D3DX consists of utility/helper functions. This is what changes with each SDK update. It contains the High Level Shader Language (HLSL) compilers, which is why Autodesk updates its usage when required. The core does not change except for a new runtime.</p>\n\
<p>In addition to reading this section, you should examine  <em>dxstdmtl.cpp</em>  and <em>dxstdmtl.h</em>  in the  <em>samples\\material</em>  folder.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/hardware_rendered_materials.html\">Hardware Rendered Materials</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/directx_10.html\">DirectX 10</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/hardware_shader_ui_feature.html\">Hardware Shader UI Feature</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/determining_directx_version.html\">Determining DirectX Version</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/accessing_the_directx_device.html\">Accessing the DirectX Device</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/parsers_and_shader_effect_files.html\">Parsers and Shader Effect Files</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/shader_semantics_and_annotations.html\">Shader Semantics and Annotations</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/obtaining_shader_parameters.html\">Obtaining Shader Parameters</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"programming_hardware_shaders/loading_and_parsing_shader_effec.html\">Loading and Parsing Shader Effect Files</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";