var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"determining_directx_version\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Determining DirectX Version</h1></div><p>The interface that provides access to DirectX devices is ID3D9GraphicsWindow (for DirectX 9). DirectX 10 is no longer supported.</p>\n\
<p>To determine whether DirectX 9 is enabled in a viewport, or whether DirectX 9 is enable in the current viewport the following snippet can be used.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// return NULL if DirectX 9 is not being used\n\
ID3D9GraphicsWindow* GetDirectX9Window(ViewExp* view)\n\
{  \n\
    if (!view) return NULL;\n\
\n\
    GraphicsWindow* gw = view-&gt;getGW();\n\
    if (!gw) return NULL;\n\
\n\
    return static_cast&lt; ID3D9GraphicsWindow*&gt;(gw-&gt;GetInterface( D3D9_GRAPHICS_WINDOW_INTERFACE_ID));\n\
}\n\
\n\
\n\
// Returns true if the active window supports DirectX 9 \n\
bool DoesActiveViewSupportDirectX9()\n\
{\n\
  // get the currently active viewport\n\
  ViewExp* view = GetCOREInterface()-&gt;GetActiveViewport();\n\
\n\
  // check if DirectX 9 windows are available\n\
  bool b = GetDirectX9Window(view) ;\n\
\n\
  // always release the viewport to avoid causing a memory lead\n\
  GetCOREInterface()-&gt;ReleaseViewport(view);\n\
\n\
  return b;\n\
}\n\
\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../programming_hardware_shaders.html\">Programming Hardware Shaders</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";