var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"hardware_rendered_materials\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Hardware Rendered Materials</h1></div><p>3ds Max supports hardware rendering of materials using DirectX. The main interface to use is the <code>IDX9DataBridge</code> interface. This interface provides the communication between the materials and the Direct3D graphics layer. The graphics layer will query for this interface to make sure the material supports a &quot;hardware&quot; interface. The graphics layer will then continue to query for the <code>DX9_VERTEX_SHADER_INTERFACE_ID</code>. This interface is derived from <code>IDX9VertexShader</code>.</p>\n\
<p><code>IDX9VertexShader</code> provides the direct drawing communication between the graphics layer and the material. The material can simply create an instance of the class that implements this interface and use this in the communication to the graphics layer.</p>\n\
<p>A typical <code>InterfaceServer::GetInterface()</code> and would look like (example taken from  <em>\\samples\\hardwareshaders\\MetalBump9</em> ):</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MaxVertexShader : public IDX9VertexShader, public IStdDualVSCallback\n\
{\n\
  // ...\n\
}\n\
\n\
class MaxShader : public  ReferenceTarget, public IDX9DataBridge,  TimeChangeCallback\n\
{\n\
    MaxVertexShader *m_VS;\n\
\n\
    BaseInterface* GetInterface(Interface_ID id)\n\
    {\n\
       if (id ==  VIEWPORT_SHADER_CLIENT_INTERFACE) {\n\
           return static_cast&lt; IDXDataBridge*&gt;(this);\n\
       }\n\
       else if (id==  VIEWPORT_SHADER9_CLIENT_INTERFACE)\n\
       {\n\
           return static_cast&lt; IDX9DataBridge*&gt;(this);\n\
       }\n\
       else if(id ==  DX9_VERTEX_SHADER_INTERFACE_ID)\n\
       {\n\
           return(( IDX9VertexShader *)m_VS);\n\
       }\n\
       else\n\
       {\n\
           return( BaseInterface::GetInterface(id));\n\
       }\n\
    }\n\
\n\
    //...\n\
}</code></pre><p>The method <code>IDX9VertexShader::DrawMeshStrips()</code> is used if you want a hardware vertex shader to draw the mesh. If this method return returns true it is assumed that the material will draw the mesh and 3ds Max will not continue any further drawing of the object. The developer can make use of the <code>IRenderMesh</code> interface to assist in creating a Hardware version of the 3ds Max mesh. If you want 3ds Max to do the drawing, then you are restricted to the vertex format being sent to the vertex buffer. In particular no Tangent or Binormal vectors are generated by the base mesh classes. An example of allowing max to perform the drawing can be seen in  <em>\\samples\\hardwareshaders\\Membrane</em> .</p>\n\
<p>To receive information about the validity of the mesh, you can use the <code>IStdDualVS</code> and <code>IStdDualVSCallback</code>. The callback will inform the material that something about the mesh has changed - usually a topological change - and the <code>InitValid</code> method is called. Using <code>InitValid</code>, you can rebuild any internal structures or mesh data ready for the next draw call. To execute your custom draw routines, assuming that <code>IDX9VertexShader::DrawMeshStrips</code> returns <code>True</code>, initiate them from <code>IDX9VertexShader::Initialize()</code>, which is called for each render pass for each material.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../programming_hardware_shaders.html\">Programming Hardware Shaders</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";