var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"hardware_shader_ui_feature\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Hardware Shader UI Feature</h1></div><p>If your material supports hardware rendering it can indicate so the user through the interface <code>IMaterialViewportShading</code>. 3ds Max will query for this interface to report what support is offered to the user. This interface is defined as a <code>ULONG</code>, so it uses the override of <code>Animatable::GetInterface</code>( ULONG). The system allows for any material to define if it supports a hardware mode. A simple example is shown below. For a more complete example, see  <em>samples\\material\\StdMaterialViewportShading.cpp</em> .</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void mrArchMaterialShading::SetMaterial(MtlBase* pMaterial)\n\
{\n\
      if (NULL != pMaterial &amp;&amp;\n\
           pMaterial-&gt;ClassID() == MRARCHMATERIAL_CLASS_ID)\n\
      {\n\
           m_pMaterial = pMaterial;\n\
      }\n\
      else\n\
      {\n\
           m_pMaterial = NULL;\n\
      }\n\
}\n\
\n\
bool mrArchMaterialShading::IsShadingModelSupported(\n\
      IN MaterialViewportShading_tmodel) const\n\
{\n\
      DbgAssert(NULL != m_pMaterial);\n\
\n\
      if(!TestDxSupport())\n\
      {\n\
           return false;\n\
      }\n\
      switch (model)\n\
      {\n\
      case MaterialViewportShading::Standard:\n\
      case MaterialViewportShading::Hardware:\n\
           returntrue;\n\
      default:\n\
           return false;\n\
      }\n\
}\n\
\n\
MaterialViewportShading_t mrArchMaterialShading::GetCurrentShadingModel()const\n\
{\n\
      DbgAssert(NULL != m_pMaterial);\n\
      if (m_pMaterial-&gt;TestMtlFlag(MTL_HW_MAT_ENABLED))\n\
      {\n\
           returnMaterialViewportShading::Hardware;\n\
      }\n\
      else\n\
      {\n\
           returnMaterialViewportShading::Standard;\n\
      }\n\
}\n\
\n\
bool mrArchMaterialShading::SetCurrentShadingModel(\n\
      IN MaterialViewportShading_tmodel)\n\
{\n\
      DbgAssert(NULL != m_pMaterial);\n\
      if (model == GetCurrentShadingModel())\n\
      {\n\
           returntrue;\n\
      }\n\
      switch (model)\n\
      {\n\
      case MaterialViewportShading::Hardware:\n\
           m_pMaterial-&gt;SetMtlFlag(MTL_HW_MAT_ENABLED);\n\
           GetCOREInterface()-&gt;ForceCompleteRedraw();\n\
           break;\n\
      case MaterialViewportShading::Standard:\n\
           m_pMaterial-&gt;ClearMtlFlag(MTL_HW_MAT_ENABLED);\n\
           GetCOREInterface()-&gt;ForceCompleteRedraw();\n\
           break;\n\
      default:\n\
           returnfalse;\n\
      }\n\
      return true;\n\
}\n\
\n\
int mrArchMaterialShading::GetSupportedMapLevels()const\n\
{\n\
      return 1;\n\
}</code></pre><p>Key to note is the setting of the material flag <code>MTL_HW_MAT_ENABLED</code>. This is the flag that tells the system to look for all the additional interfaces used to support hardware shading. If this is not set, then the original viewport drawing code is used. Also note that it tests for DirectX and only continues if this is active.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../programming_hardware_shaders.html\">Programming Hardware Shaders</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";