var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"parsers_and_shader_effect_files\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Parsers and Shader Effect Files</h1></div><p>DirectX materials used by 3ds Max are described by shader effect files written in either High Level Shader Language (HLSL) or the NVIDIA Cg language. These are processes by a 3ds Max effect file parser. An effect parser implements the interface <code>IEffectParser</code>. The parameters of the effect file (i.e. the parameters of the hardware material) are extracted, and displayed to the user by 3ds Max. The effect manager provides access to the effect parameters and is exposed as an interface <code>IEffectManager</code> that is implemented in 3ds Max by the DirectX material.</p>\n\
<p>An effect file can define what parser is required to fully support the syntax of the file. This is implemented in the effect file with the following:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">string ParamID = &quot;&lt;parser_id&gt;&quot;;</code></pre><p>The following are the valid parser ids</p>\n\
<ul>\n\
<li>0x0000 (default) - The original HLSL parser for 3ds Max.</li>\n\
<li>0x0001 - Microsoft SAS specification version 0.8.</li>\n\
<li>0x0002 - CgFX compliant parser using the DirectX profiles.</li>\n\
<li>0x0003 - Microsoft SAS specification (0.8) with scene effect support.</li>\n\
</ul>\n\
<p>A shader effect file contains variables. These variables can contain a user-defined hint, called a semantic, which helps applications provide the correct data to the shader without having to decipher the variable names. For example WORLDVIEW and PROJECTION are semantics:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// texture\n\
texture Tex0\n\
&lt;\n\
  string name = &quot;tiger.bmp&quot;;\n\
  string UIName = &quot;BaseTexture&quot;;\n\
  string UIType = &quot;bitmap&quot;;\n\
&gt;;\n\
\n\
// Transforms\n\
float4x3 WorldView : WORLDVIEW;\n\
float4x4 Projection : PROJECTION;</code></pre><p>Additionally, each variable can have an optional annotation. The annotation is a structure that contains data that the effect author wants to communicate to a parser. In the following example the variables GlowColor, GlowAmbient, and GlowThickness all have annotation to describe the name and type for constructing the UI element. The GlowThickness has additional annotations which describe the minimum and maximum values to be selected in the interface:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">float4 GlowColor &lt;\n\
  string UIName = &quot;GlowColor&quot;;\n\
  string UIType = &quot;MaxSwatch&quot;;\n\
&gt; = float4(0.5f, 0.2f, 0.2f, 1.0f);\n\
\n\
float4 GlowAmbient &lt;\n\
  string UIName = &quot;GlowAmbient&quot;;\n\
  string UIType = &quot;ColorSwatch&quot;;\n\
&gt;   = float4(0.2f, 0.2f, 0.0f, 0.0f);\n\
\n\
float GlowThickness&lt;\n\
  string UIName = &quot;GlowThickness&quot;;\n\
  string UIType = &quot;FloatSpinner&quot;;\n\
  float UIMin = 0.0f;\n\
  float UIMax = 10.0f;\n\
&gt;   = 0.015f;</code></pre><p>3ds Max uses the annotations to create the UI elements. The effect file created by combining the above two snippets gives the following UI:</p>\n\
<p><img src=\"./images/GUID-A1EC7D78-FAFA-4D65-8209-E5AA2036FADA-low.png\" alt></p>\n\
<p>For more information on annotations see <a href=\"shader_semantics_and_annotations/supported_hlsl_shader_annotation.html\">Supported HLSL Shader Annotations</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../programming_hardware_shaders.html\">Programming Hardware Shaders</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";