var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"supported_hlsl_shader_annotation\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Supported HLSL Shader Annotations</h1></div><p>The following are the currently supported set of shader effect file annotations by the HLSL parser. Note that case is ignored in both the names and string values, so &quot;IntSpinner&quot; is treated the same as &quot;INTSPINNER&quot; or &quot;intspinner&quot;.</p>\n\
<ul>\n\
<li>string UIName - Defines the name displayed in the UI. A UI element is not created if this is not present</li>\n\
<li>string UIType - Defines the UI element to use. Supported UITypes are &quot;Spinner&quot;, &quot;FloatSpinner&quot;, &quot;Bitmap&quot;, and &quot;Color&quot;.</li>\n\
<li>float (or int) UIMin - Defines the minimum value for a spinner UI element.</li>\n\
<li>float (or int) UIMax - Defines the maximum value for a spinner UI element.</li>\n\
<li>float (or int) UIStep - Defines the increment value for a spinner UI element</li>\n\
<li>string UIObject (or Object) - Defines the type of 3ds Max object to be used to provide data for the parameter. Currently &quot;TargetLight&quot; and &quot;OmniLight&quot; are supported options. This allows a tighter bond between the workspace and the shader.</li>\n\
<li>string Name (or File) - Specifically defines a bitmap file. If the file cannot be found then it is simply presented as &quot;<code>None</code>&quot;.</li>\n\
<li>int RefID - This is used for lights and defines a unique number that is used for lookups by other parameters that use light parameters. This would typically be used with the LIGHTCOLOR semantics.</li>\n\
<li>int LightRef (or ParentRef) - This defines the parent light, from which any relevant data is accessed. If positional and directional light data are needed, the developer can define one element with a UI (parent) and the other can simply reference the parent - no UI is needed. This reduces UI of clutter from multiple light definitions.</li>\n\
<li>int drivesMaxOpacity - Set this integer to 0 or 1 to determine if Max should evaluate transparency. 1=evaluate, 0=do not evaluate.</li>\n\
<li>string Type - This is used in conjunction with a texture. You can specify either &quot;Cube&quot;, &quot;Volume&quot; or &quot;RenderTarget&quot;. If nothing is specified it is assumed to be a standard 2d texture. The &quot;RenderTarget&quot; option allows for support of multiple passes where the output of one pass is used as an input to another pass.</li>\n\
<li>string TargetTechnique (or Source) - This defines the technique used for the rendering of the &quot;RenderTarget&quot; type. If you define a technique with &quot;<strong>_</strong>&quot; as the first character of the name, it will not be displayed to the user as a selectable technique in the material rollout.</li>\n\
<li>string Format - This defines the pixel format of the texture to create. It is used primarily for the &quot;RenderTarget&quot; type and currently defaults to &quot;A32B32G32R32F&quot;. Acceptable formats are listed in the topic <a href=\"supported_direct3d_texture_forma.html\"\">Supported Direct3D Texture Formats</a>. Ignored for disk-based textures.</li>\n\
<li>int TexCoord - Used to define the texture coordinates channel to use. This can be used with textures and with the TEXCOORD semantic.</li>\n\
<li>int MapChannel - Used to define the mapping channel to fill out the data for the defined TexCoord(n) channel. This can be used with textures and also with the TEXCOORD semantic.</li>\n\
<li>bool ColorChannel - If set to true the system will not swap the UV coordinates around. This means that if the channel is a color channel the colors will remain intact and not flipped in order to support the correct UV lookup for the texture. DirectX 10 only.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shader_semantics_and_annotations.html\">Shader Semantics and Annotations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";