var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"supported_hlsl_shader_semantics\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Supported HLSL Shader Semantics</h1></div><p>The following is a list of 3ds Max supported semantics for DirectX 9 hardware rendered materials through the original HLSL parser, identified by the paramId string &quot;0x0000&quot;.</p>\n\
<h2 id=\"render-semantics\">Render Semantics</h2><p>The following are supported render semantics:</p>\n\
<ul>\n\
<li>DIFFUSEMAP</li>\n\
<li>OPACITYMAP</li>\n\
<li>SPECULARMAP</li>\n\
<li>BUMPMAP or NORMALMAP</li>\n\
<li>LIGHTMAP</li>\n\
<li>DISPLACEMENTMAP</li>\n\
<li>REFLECTIONMAP</li>\n\
</ul>\n\
<h2 id=\"basic-transformations\">Basic Transformations</h2><p>The following are supported basic transformations (I = Inverse and T = Transpose)</p>\n\
<ul>\n\
<li>WORLD</li>\n\
<li>WORLDI</li>\n\
<li>WORLDIT</li>\n\
<li>VIEW</li>\n\
<li>VIEWI</li>\n\
<li>VIEWIT</li>\n\
<li>PROJECTION</li>\n\
<li>PROJECTIONI</li>\n\
<li>PROJECTIONIT</li>\n\
<li>WORLDVIEW</li>\n\
<li>WORLDVIEWI</li>\n\
<li>WORLDVIEWIT</li>\n\
<li>WORLDVIEWPROJ</li>\n\
<li>WORLDVIEWPROJI</li>\n\
<li>WORLDVIEWPROJIT</li>\n\
<li>WORLDT</li>\n\
<li>VIEWT</li>\n\
<li>PROJECTIONT</li>\n\
<li>VIEWPORT</li>\n\
</ul>\n\
<h2 id=\"geometry-semantics\">Geometry Semantics</h2><p>The following are supported geometry based semantics:</p>\n\
<ul>\n\
<li>WORLD_CAMERA_POSITION or WORLDCAMERAPOSITION</li>\n\
<li>LOCAL_BBOX_MIN or LOCALBBOXMIN</li>\n\
<li>LOCAL_BBOX_MAX or LOCALBBOXMAX</li>\n\
<li>LOCAL_BBOX_SIZE or LOCALBBOXSIZE</li>\n\
<li>RECIP_LOCAL_BBOX_SIZE or RECIPLOCALBBOXSIZE</li>\n\
</ul>\n\
<h2 id=\"lighting-semantics\">Lighting Semantics</h2><p>The following lighting based semantics are used to populate the light drop downs with the correct style of light.</p>\n\
<ul>\n\
<li>POSITION</li>\n\
<li>DIRECTION</li>\n\
<li>LIGHTCOLOR</li>\n\
<li>LIGHTHOTSPOT &lt;float value&gt;</li>\n\
<li>LIGHTFALLOFF &lt;float value&gt;</li>\n\
<li>LIGHTATTENUATION &lt;vector4&gt; - X = near attenuation start, Y = near attenuation stop, Z = far attenuation start, A = far attenuation end</li>\n\
</ul>\n\
<p>The following is an example of using lighting based semantics</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// light direction (view space)\n\
float3 lightDir : Direction &lt;  \n\
  string UIName = &quot;Light Direction&quot;;\n\
  string Object = &quot;TargetLight&quot;;\n\
  int RefID = 0;\n\
&gt; = {-0.577, -0.577, 0.577};\n\
\n\
//diffuse setting controlled by the light if available\n\
float4 k_d : LightColor &lt;\n\
  string UIName = &quot;Diffuse&quot;;\n\
  int LightRef = 0;\n\
&gt; = float4( 1.0f, 1.0f, 1.0f, 1.0f );    </code></pre><h2 id=\"mapping-channel-semantics\">Mapping Channel Semantics</h2><p>3ds Max has the concept of mapping channels. The TEXCOORD semantic allows the developer to define which channel is provided on which texture coordinate input for the vertex shader.</p>\n\
<p>The following is an example of its usage</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int texcoord0 : TEXCOORD\n\
&lt;\n\
  int Texcoord = 0;\n\
  int MapChannel = 0;\n\
&gt; = 0;</code></pre><p>This will provide mapping channel 0 (the vertex color channel) to texcoord0. Currently the actual value of the parameter, in this case texcoord0, is ignored, and the parser only reads the annotation.</p>\n\
<h2 id=\"miscellaneous-semantics\">Miscellaneous Semantics</h2><p>The following are non-categorized semantics:</p>\n\
<ul>\n\
<li>BKRGCOLOR - The current background color of the max viewport</li>\n\
<li>TIME - The current time in the animation sequence.</li>\n\
<li>BITMAPOVERRIDE (deprecated) - Defines the bitmap used for the bitmap render option of the DirectX 9 Shader (deprecated)</li>\n\
<li>COLOROVERRIDE (deprecated) - Defines the shaded render color of the DirectX 9 Shader</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shader_semantics_and_annotations.html\">Shader Semantics and Annotations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";