var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"supported_sas_shader_annotations\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Supported SAS Shader Annotations</h1></div><p>The following are the currently supported set of shader effect file annotations for the various SAS parsers. Note that case is ignored in both the names and string values, so &quot;Spinner&quot; is treated the same as &quot;SPINNER&quot; or &quot;spinner&quot;.</p>\n\
<ul>\n\
<li>String UIName - Defines the name displayed in the UI. A UI element is not created if this is not present</li>\n\
<li>String UIWidget - Defines the UI element to use. Corresponds to UIType in the HLSL parser. Supported UIWidget values are &quot;Spinner&quot;, &quot;FloatSpinner&quot;, &quot;Bitmap&quot;, and &quot;Color&quot;.</li>\n\
<li>float (int) UIMin - Defines the minimum value for a spinner UI element.</li>\n\
<li>float (int) UIMax - Defines the maximum value for a spinner UI element.</li>\n\
<li>float (int) UIStep - Defines the increment value for a spinner UI element</li>\n\
<li>string ResourceType - Type of texture. You can specify either &quot;Cube&quot;, &quot;Volume&quot; or &quot;RenderTarget&quot;. If nothing is specified it is assumed to be a standard 2d texture. The &quot;RenderTarget&quot; option allows for support of multiple passes where the output of one pass is used as an input to another pass.</li>\n\
<li>string ResourceName - The file name for a texture</li>\n\
<li>vector2 (or vector3) Dimensions - The width, height, &amp; optional depth for a procedural or RenderTarget texture. Mutually exclusive with the Width, Height, Depth, and ViewportRatio annotations.</li>\n\
<li>int Width - Width of the texture. Mutually exclusive with the Dimensions and ViewportRatio annotations.</li>\n\
<li>int Height - Height of the texture. Mutually exclusive with the Dimensions and ViewportRatio annotations.</li>\n\
<li>int Depth - Depth of the texture. Mutually exclusive with the Dimensions and ViewportRatio annotations.</li>\n\
<li>string Format - This defines the pixel format of the texture to create. It is used primarily for the &quot;RenderTarget&quot; type and currently defaults to &quot;A32B32G32R32F&quot;. Acceptable formats are listed in the topic <a href=\"supported_direct3d_texture_forma.html\"\">Supported Direct3D Texture Formats</a>. Ignored for disk-based textures.</li>\n\
<li>int MipLevels (or Levels) - The number of MIP levels to create.</li>\n\
<li>float2 ViewportRatio - Dimensions based on the ratio of the viewport. For example <code>float2</code>ViewportRatio = {1,1} results in the same dimensions as the screen while <code>float2</code> ViewportRatio = {0.5, 1.0} would result in a texture one half as wide as the render window, but just as tall. Mutually exclusive with Width, Height, Depth, and Dimensions annotations.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li>int RefID - This is used for lights and defines a unique number that is used for lookups by other parameters that use light parameters. This would typically be used with the LIGHTCOLOR semantics.</li>\n\
<li>int LightRef (ParentRef) - This defines the parent light, from which any relevant data is accessed. If positional and directional light data are needed, the developer can define one element with a UI (parent) and the other can simply reference the parent - no UI is needed. This reduces UI of clutter from multiple light definitions.</li>\n\
<li>int texcoord - Used to define the texcoord channel to use. This can be used with Textures and also with the TEXCOORD semantic.</li>\n\
<li>int MapChannel - Used to define the mapping channel to fill out the data for the define Texcoord(n) channel. This can be used with textures and also with the TEXCOORD semantic.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li>string TargetTechnique (or Source) - This defines the technique used for the rendering of the &quot;RenderTarget&quot; type. If you define a technique with &quot;<strong>_</strong>&quot; as the first character of the name, it will not be displayed to the user as a selectable technique in the material rollout.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shader_semantics_and_annotations.html\">Shader Semantics and Annotations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";