var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"supported_sas_shader_semantics\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Supported SAS Shader Semantics</h1></div><p>The following is a list of 3ds Max supported semantics for DirectX 9 hardware rendered materials through the SAS based parsers. The Microsoft SAS 0.8 specification with and without scene effect source identified by the <code>paramId</code> strings &quot;0x0003&quot; and &quot;0x0001&quot; respectively, and the Cg parser identified by the <code>paramId</code> string &quot;0x0002&quot;.</p>\n\
<h2 id=\"render-semantics\">Render Semantics</h2><p>The following are supported render semantics:</p>\n\
<ul>\n\
<li>DIFFUSEMAP</li>\n\
<li>OPACITYMAP</li>\n\
<li>SPECULARMAP</li>\n\
<li>BUMPMAP or NORMALMAP</li>\n\
<li>LIGHTMAP</li>\n\
<li>DISPLACEMENTMAP</li>\n\
<li>REFLECTIONMAP</li>\n\
<li>RENDERCOLORTARGET</li>\n\
<li>RENDERDEPTHSTENCILTARGET</li>\n\
</ul>\n\
<h2 id=\"basic-transformations\">Basic Transformations</h2><p>The following are supported basic transformations (note that unlike HLSL parser the names are longer and use INVERSE instead of I and TRANSPOSE instead of T).</p>\n\
<ul>\n\
<li>WORLD</li>\n\
<li>WORLDINVERSE</li>\n\
<li>WORLDINVERSETRANSPOSE</li>\n\
<li>VIEW</li>\n\
<li>VIEWINVERSE</li>\n\
<li>VIEWINVERSETRANSPOSE</li>\n\
<li>PROJECTION</li>\n\
<li>PROJECTIONINVERSE</li>\n\
<li>PROJECTIONINVERSETRANSPOSE</li>\n\
<li>WORLDVIEW</li>\n\
<li>WORLDVIEWINVERSE</li>\n\
<li>WORLDVIEWINVERSETRANSPOSE</li>\n\
<li>WORLDVIEWPROJ</li>\n\
<li>WORLDVIEWPROJINVERSE</li>\n\
<li>WORLDVIEWPROJINVERSETRANSPOSE</li>\n\
<li>WORLDTRANSPOSE</li>\n\
<li>VIEWTRANSPOSE</li>\n\
<li>PROJECTIONTRANSPOSE</li>\n\
<li>VIEWPORTPIXELSIZE</li>\n\
</ul>\n\
<h2 id=\"geometry-semantics\">Geometry Semantics</h2><p>The following are supported geometry based semantics. Note that unlike HLSL parsers cameras are not supported:</p>\n\
<ul>\n\
<li>LOCAL_BBOX_MIN or LOCALBBOXMIN</li>\n\
<li>LOCAL_BBOX_MAX or LOCALBBOXMAX</li>\n\
<li>LOCAL_BBOX_SIZE or LOCALBBOXSIZE</li>\n\
<li>RECIP_LOCAL_BBOX_SIZE or RECIPLOCALBBOXSIZE</li>\n\
</ul>\n\
<h2 id=\"lighting-semantics\">Lighting Semantics</h2><p>The following lighting based semantics are used to populate the light drop downs with the correct style of light.</p>\n\
<ul>\n\
<li>POSITION</li>\n\
<li>DIRECTION</li>\n\
<li>LIGHTCOLOR</li>\n\
<li>LIGHTHOTSPOT &lt;float value&gt;</li>\n\
<li>LIGHTFALLOFF &lt;float value&gt;</li>\n\
<li>LIGHTATTENUATION &lt;vector4&gt; - X = near attenuation start, Y = near attenuation stop, Z = far attenuation start, A = far attenuation end</li>\n\
</ul>\n\
<p>3ds Max has its own lighting semantic that differ from the SAS 0.8 specification. You can use the 3ds Max semantics by identifying Max specific sections in the shader file using <code>\\#ifdef</code> / <code>\\#else</code> / <code>\\#endif</code> blocks, as in the following example.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">/// Point Lamp 0\n\
float3 Lamp0Pos : POSITION\n\
&lt;\n\
    string Object = &quot;PointLight0&quot;;\n\
    string UIName =  &quot;Light Position&quot;;\n\
    string Space = &quot;World&quot;;\n\
    int refID = 0;\n\
&gt;\n\
= {-0.5f,2.0f,1.25f};\n\
\n\
#ifdef _MAX_\n\
float3 Lamp0Color : LIGHTCOLOR\n\
&lt;\n\
    int LightRef = 0;\n\
    string UIWidget = &quot;None&quot;;\n\
&gt;\n\
= float3(1.0f, 1.0f, 1.0f);\n\
#else\n\
float3 Lamp0Color : Specular &lt;\n\
    string UIName =  &quot;Lamp 0&quot;;\n\
    string Object = &quot;Pointlight0&quot;;\n\
    string UIWidget = &quot;Color&quot;;\n\
&gt;\n\
= {1.0f,1.0f,1.0f};\n\
#endif</code></pre><h2 id=\"mapping-channel-semantics\">Mapping Channel Semantics</h2><p>3ds Max has the concept of mapping channels. The TEXCOORD semantic allows the developer to define which channel is provided on which texture coordinate input for the vertex shader.</p>\n\
<p>The following is an example of its usage</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int texcoord0 : TEXCOORD\n\
&lt;\n\
  int Texcoord = 0;\n\
  int MapChannel = 0;\n\
&gt; = 0;</code></pre><p>This will provide mapping channel 0 (the vertex color channel) to texcoord0. Currently the actual value of the parameter, in this case texcoord0, is ignored, and the parser only reads the annotation.</p>\n\
<h2 id=\"miscellaneous-semantics\">Miscellaneous Semantics</h2><p>The following are non-categorized semantics:</p>\n\
<ul>\n\
<li>BKRGCOLOR - The current background color of the max viewport</li>\n\
<li>TIME - The current time in the animation sequence.</li>\n\
<li>BITMAPOVERRIDE (deprecated) - Defines the bitmap used for the bitmap render option of the DirectX 9 Shader (deprecated)</li>\n\
<li>COLOROVERRIDE (deprecated) - Defines the shaded render color of the DirectX 9 Shader</li>\n\
</ul>\n\
<h2 id=\"unsupported-semantics\">Unsupported Semantics</h2><p>The following semantics defined for SAS 0.8 are not supported by 3ds Max</p>\n\
<ul>\n\
<li>DIFFUSE</li>\n\
<li>NORMAL</li>\n\
<li>SPECULAR</li>\n\
<li>SPECULARMAP</li>\n\
<li>ENVMAP</li>\n\
<li>ENVIRONMENTNORMAL</li>\n\
<li>ENVIRONMENT</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../shader_semantics_and_annotations.html\">Shader Semantics and Annotations</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";