var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"render_elements\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Render Elements</h1></div><p>Render elements allow renderers to output to separate bitmaps portions of the final shaded image so that they can be manipulated/composited at a later time, without re-rendering.</p>\n\
<p>Render elements are specific to a given renderer. 3ds Max defines both a general interface that all render elements (<code>IRenderElement</code>) must support &amp; an interface specific to elements supporting the max default renderer. Part of the general interface allows the system to figure out which installed render elements belong to which renderer, &amp; to only list those compatible elements.</p>\n\
<p>3ds Max render elements are supported by code in each material. After shading, each active render element&#39;s <code>IRenderElement::PostIllum()</code> method is called in turn. It is provided with;</p>\n\
<ul>\n\
<li>the full shade context used to do the shading</li>\n\
<li>pointers to the material &amp; (if there is one) shader used to do the computation</li>\n\
<li>textured inputs to the shader (e.g. diffuse color blended w/ diffuse texture color by the amount spinner)</li>\n\
<li>component-wise output from the shading process (diffuse term, reflection term)</li>\n\
<li>there is provision for extending the component-wise outputs to include arbitrary name-matched channels (this allows materials w/ special components, e.g. fluorescence in ray material, to be communicated to an element. The element must of course be looking for the special component. The component-wise outputs maybe computed either with or without shadows, depending on a query on the element interface.</li>\n\
</ul>\n\
<p>Essentially, this is all of the information that is passed to 3ds Max Shaders, plus the shadowed or unshadowed component-wise output from the materials shading process. This means that each render element may in fact be a complete, alternate, special-purpose shader. This is intentional, of course, so that any wacky thing might be created. Most current render elements don&#39;t take advantage of this, tho, they merely process the component-wise output from the materials shading process, but the potential is very powerful.</p>\n\
<p>3ds Max Render elements then store their computed shade in an extended <code>ShadeOutput</code> class (imtl.h) that is part of the <code>ShadeContext.</code> The <code>ShadeOutput</code> has an array of element output values, one per element &amp; each max render element is given an index into the array to use. The <code>ShadeOutput</code> will follow the fragments being shaded all through the compositing process, so that transparency &amp; partial coverage is properly resolved.</p>\n\
<p>Atmosphere cannot be properly computed at shading time since the object may be covered by a transparent object, dividing the needed calculation into two: atmosphere from the eye to the transparent object, composited over atmosphere between the two objects &amp; the final objects color. Hence there is a second, optional call to each render element after the atmosphere is computed. The general interface tells the system whether to apply atmosphere to the render elements color, does so if desired &amp; calls the <code>MaxRenderElement::PostAtmosphere()</code> method on the render element.</p>\n\
<p>Finally, a last query on the general interface determines whether to apply the anti-aliasing filter when outputting the element to its bitmap, or merely blending with other elements in the pixel.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../rendering.html\">Rendering</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";