var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"face-mapped_materials\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Face-Mapped Materials</h1></div><p>Face-mapped materials require no application of mapping coordinates by the user. The user can create a face-mapped material in the 3ds Max Materials Editor. When a face-mapped material is applied to an object, the map is automatically applied to each facet of the object. Below is the code used internally by 3ds Max that computes the texture coordinates for face mapping:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static Point3 basic_tva[3] = {\n\
   Point3(0.0,0.0,0.0),\n\
   Point3(1.0,0.0,0.0),\n\
   Point3(1.0,1.0,0.0)};\n\
\n\
static Point3 basic_tvb[3] = {\n\
   Point3(1.0,1.0,0.0),\n\
   Point3(0.0,1.0,0.0),\n\
   Point3(0.0,0.0,0.0)};\n\
\n\
static int nextpt[3] = {1,2,0};\n\
static int prevpt[3] = {2,0,1};\n\
\n\
static void make_face_uv(Face *f, Point3 *tv)\n\
{\n\
   intna,nhid,i;\n\
   Point3 *basetv;\n\
\n\
   /* makethe invisibleedge be2-&gt;0 */\n\
   nhid = 2;\n\
   if (!(f-&gt;flags&amp;EDGE_A)) nhid=0;\n\
   elseif (!(f-&gt;flags&amp;EDGE_B)) nhid = 1;\n\
   elseif (!(f-&gt;flags&amp;EDGE_C)) nhid = 2;\n\
   na = 2-nhid;\n\
   basetv = (f-&gt;v[prevpt[nhid]]&lt;f-&gt;v[nhid]) ? basic_tva : basic_tvb;\n\
   for (i=0; i&lt;3; i++)\n\
   {\n\
     tv[i] = basetv[na];\n\
     na = nextpt[na];\n\
   }\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../textures_maps.html\">Textures Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";