var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"mapping_channels\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Mapping Channels</h1></div><p>A map&#39;s UVW map coordinates channel (or just map channel) identifies which set of an object&#39;s mapping coordinates to use when mapping textures to the object. Each map channel has a separate UVW vertex and face list for an object. A mapping channel is associated with a <code>MeshMap</code> object instance.</p>\n\
<p>Different map channels allow maps for the same object to use different coordinates. For example, a user might use one channel for diffuse mapping and a different one for bump mapping. Map channels also let different maps use different coordinates within a compound material, a compositor map, or a multi-material.</p>\n\
<p>Each object can have from 1 to 99 UVW mapping coordinate channels. The default mapping (from the Generate Mapping Coordinates toggle) is always UVW 1. The UVW Map modifier can send coordinates to any of these channels. Each map in a material can use any UVW channel (if present), or other type of mapping that depends on whether the map is 2D or 3D.</p>\n\
<p>Users can set the mapping channel used by a NURBS surface sub-objects in their creation or modification parameters.</p>\n\
<p>The channels are as follows:</p>\n\
<ul>\n\
<li>Channel 0 - Vertex color channel.</li>\n\
<li>Channel 1 - The texture vertices array. The default channel.</li>\n\
<li>Channel 2 to <code>MAX_MESHMAPS</code> - 1 - User defined mapping channels.</li>\n\
</ul>\n\
<p>There are also two &quot;hidden&quot; map channels that are identified using negative numbers:</p>\n\
<ul>\n\
<li><code>MAP_SHADING</code>: The shading (or illumination) map. Set to -1.</li>\n\
<li><code>MAP_ALPHA</code>: The alpha channel map. Note that only the x (or u) coordinate of the map vertices is currently used. Set to -2.</li>\n\
</ul>\n\
<p>The number of hidden map channels is identified by the number <code>NUM_HIDDEN_MAPS</code> but are not counted by the function <code>Mesh::getNumMaps()</code>. In other words the valid channel indexes range from is -<code>NUM_HIDDEN_MAPS</code> to <code>MAX_MESHMAPS</code>-1.</p>\n\
<p>Note the following details on adding map channels:</p>\n\
<ol>\n\
<li><p>To support a map channel in a mesh, call <code>Mesh::setMapSupport</code>(channel, TRUE). This works for the vertex colors (channel 0), the texture vertices (channel 1), or the custom channels.</p>\n\
</li>\n\
<li><p>The method <code>Mesh::setMapSupport()</code> allocates the map faces, since there are always <code>Mesh::numFaces</code> of these, but it does not allocate the map vertices, since the number of these can change from map to map.</p>\n\
</li>\n\
<li><p>Use <code>Mesh::setNumMapVerts()</code> to set the number of map vertices.</p>\n\
</li>\n\
<li><p>Calls to <code>Mesh::setNumFaces()</code> also set the number of map faces in all supported maps.</p>\n\
</li>\n\
<li><p>Keep in mind that the <code>Mesh::mapVerts``()</code> and <code>Mesh::mapFaces``()</code> methods return pointers that may be invalid later if the number of vertices or faces is reallocated. For example, the following won&#39;t work:</p>\n\
<p>UVVert *mv = mesh.mapVerts(43); // map channel 43\n\
mesh.setNumMapVerts(43, 98);\n\
for (i=0; i&lt;98; i++) mv[i] = UVVert(0,0,0);</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../textures_maps.html\">Textures Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";