var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"texture_coordinates\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Texture Coordinates</h1></div><p>This section discusses how UVW texture coordinates are interpreted by the renderer for texture maps in 3ds Max. The <code>Mesh</code> class provides access to the texture coordinates of a Mesh. The <code>PatchMesh</code> class provides access to the texture coordinates of a Patch. Both use a very similar approach. In this section we&#39;ll look at how this is done for the Mesh class.</p>\n\
<p>The texture coordinates are available in the Mesh class public data member <code>UVVert</code> *tVerts;</p>\n\
<p>Note that a <code>UVVert</code> is simply a <code>Point3</code>, i.e.: <code>typedef``Point3``UVVert</code>;</p>\n\
<p><code>tVerts</code> is a pointer to the list of texture vertices. Each <code>UVVert</code> stores a single UVW coordinate (as the X, Y and Z public data members of the <code>Point3</code>). The UVW coordinates parallel the relative direction of the XYZ coordinates. If you look at a 2D map image, U is equivalent to X, and represents the horizontal direction of the map; V is the equivalent of Y, and represents the vertical direction of the map; W is the equivalent of Z and represents a direction perpendicular to the UV plane of the map. For a 2D mapping, only two of the coordinates are used, i.e. UV, VW, or WU. This provides greater flexibility for the user as it allows them to flip the orientation of the map relative to the geometry. Radio buttons in the Materials Editor user interface allow the user to choose which two are used. The texture coordinates don&#39;t provide exclusive control over the mapping -- the material containing the map may apply other transformations that affect how the texture coordinates are interpreted by the renderer. First we&#39;ll look at the default case where the material imparts no additional transformations. Later we&#39;ll see what happens when the material applies a transformation, and how we can access and interpret additional material transformations.</p>\n\
<p>The texture coordinates stored in the <code>tVerts</code> array can be any floating point values. If we assume that the settings in the material do not apply any additional transformations (the default settings), then an image is fit in its entirety between texture coordinates 0.0 to 1.0. For example, if the two triangles pictured below in Figure 0 had the mapping coordinates shown at each vertex, the bitmap image in figure 1 would be mapped across the entire two triangles. This mapping is shown in Rendering 1. As you can see, the mapping coordinates from 0.0 to 1.0 provide an exact match, fitting the bitmap across the entire quad.</p>\n\
<p><img src=\"./images/GUID-63180940-5717-4DB0-8F7E-BE6D9BAAB245-low.gif\" alt></p>\n\
<p>Figure 0:</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> In figure 0 and those below &#39;TC&#39; stands for Texture Coordinate (i.e. the value in the <code>tVerts</code> array)</div>\n\
<p><img src=\"./images/GUID-440470DA-2AB8-43A9-8101-12BF23F702EF-low.gif\" alt></p>\n\
<p>Figure 1: The original bitmap (on a black background).</p>\n\
<p><img src=\"./images/GUID-440470DA-2AB8-43A9-8101-12BF23F702EF-low.gif\" alt></p>\n\
<p>Rendering 1:</p>\n\
<p>The next example shows how an image can be tiled across the geometry by using mapping coordinates greater than 1.0. The X mapping coordinate for vertex 1 and vertex 2 are 2.0 (and the material tiling check box are enabled in the Materials Editor). This results in the image being repeated in the U direction twice as shown below. Note that it is only tiled once in V since the Y coordinates are still 1.0.</p>\n\
<p><img src=\"./images/GUID-BF993E79-6A0E-46B4-A6CD-D8D148E35658-low.gif\" alt></p>\n\
<p>Figure 2:</p>\n\
<p><img src=\"./images/GUID-8A9A8CFE-22F3-4930-B61D-5F518D34CBD2-low.gif\" alt></p>\n\
<p>Rendering 2:</p>\n\
<p>The next example shows how negative texture coordinates are used to reverse the way the image is mapped to the geometry. In the figure below, the X texture coordinates are -2.0 for vertex 1 and vertex 2. This results in the image be mirrored about the vertical axis of the map. It is also repeated twice since the coordinates are -2.0 and not -1.0.</p>\n\
<p><img src=\"./images/GUID-237ED9B9-1E4D-4927-8D47-E755F00F061C-low.gif\" alt></p>\n\
<p>Figure 3:</p>\n\
<p><img src=\"./images/GUID-C2F5F815-3C99-406E-810F-615B478D23A0-low.gif\" alt></p>\n\
<p>Rendering 3:</p>\n\
<p>The next diagram shows how mapping coordinate greater than 0.0 start the image off at a offset within the image. Here the coordinates are the same as in example 1, except all the values have been shifted by 0.5 in X and 0.5 in Y. This results in the image being shifted on the geometry. Here again, tiling is on, so the pattern begins in the center of geometry, but is tiled and thus reappears from the left and bottom edges.</p>\n\
<p><img src=\"./images/GUID-8847A6DE-4646-4C5E-B134-B224AE456CCC-low.gif\" alt></p>\n\
<p>Figure 4:</p>\n\
<p><img src=\"./images/GUID-A0B5376C-DD5F-428A-9CE8-076BB8D49534-low.gif\" alt></p>\n\
<p>Rendering 4:</p>\n\
<p>There is something special about UVW coordinates in the range of 0.0 to 1.0. If image tiling is turned off in the Materials Editor (the &#39;Tile&#39; check box is unchecked for a certain direction), then the image will only appear where the texture coordinates are in this range. UV values outside the range 0.0 to 1.0 will not be mapped when tiling is off in that direction. This is shown in the diagram below. The material editor settings have tiling off in both the U and V directions, and the mapping coordinates are from [0.0 to 2.0]. Note that the image only appears where the mapping coordinates are in the range [0.0 to 1.0], i.e. the lower left corner.</p>\n\
<p><img src=\"./images/GUID-9F584F54-40D8-4F5D-8028-CF389872CDEF-low.gif\" alt></p>\n\
<p>Figure 5:</p>\n\
<p><img src=\"./images/GUID-96CCB574-E20C-4A2A-9189-D5272A5875DA-low.gif\" alt></p>\n\
<p>Rendering 5:</p>\n\
<p>As mentioned above, users may alter the tiling, mirroring, angle, and offset settings from within the material. These controls adjust the position of the map relative to the mapping coordinates. In the figure shown below, the material controls have been used to add an additional transformation to the mapping shown above in figure 5. The texture coordinates stored with the geometry are just the same, but a U Offset of 0.5 and a V Offset of 0.5 were used to shift the map onto the center of the geometry. Additionally, a U tiling setting of 0.75 was used to &#39;stretch&#39; the mapping in the U direction. Thus the image is no longer square, but is rather elongated in U. Rendering 6 below shows the resulting image.</p>\n\
<p><img src=\"./images/GUID-6CEB8250-7AF6-4148-967F-BD860B20A641-low.gif\" alt></p>\n\
<p>Rendering 6:</p>\n\
<p>Developers may access all the users material transformation settings using the methods of class <code>StdUVGen</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../textures_maps.html\">Textures Maps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";