var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"dithering_and_filtering\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Dithering and Filtering</h1></div><p>When converting images with a palette of a greater number of colors to an image with a palette of fewer colors, dithering is a means of simulating colors not in the more limited palette by mixing different colored pixels together.</p>\n\
<p>Dithering is also a method of smoothing the edges between two color regions by mixing their pixels so the edges appear to blend together.</p>\n\
<p>In 3ds Max, you have the option of setting dithering if you are rendering for the limited colors of an 8-bit display (256 colors). It can help prevent a banding effect in color gradients. Dithering does increase the size of 8-bit files and slows down the playback speed of animations.</p>\n\
<p>3ds Max is designed to render 64-bit color output. Consequently, you also have the option of setting dithering for true color (24 or 32-bit color). The Dither True Color option ensures that you get the best quality on true-color displays.</p>\n\
<p>Users turn dithering on and off in the Rendering page of the Preferences dialog. Users can also set dithering for scene motion blur in Video Post. Here, dithering provides a smoothing effect between the separate images making up the &quot;blur&quot;. Video Post dither is set as a percentage of total dither.</p>\n\
<p>A developer can determine if a bitmap is dithered by calling <code>Bitmap::IsDithered()</code>. A developer can ask the system to dither an image at render time using the method <code>Bitmap::SetDither()</code>.</p>\n\
<p>Normally, a developer is not directly concerned with the dithering or filtering of bitmaps. These two operations are performed by the renderer, and the 3ds Max user sets these characteristics of the bitmaps using the 3ds Max user interface. A developer can however determine if a bitmap will be filtered by calling <code>Bitmap::HasFilter()</code>. A developer can also ask the system to filter an image when its rendered. This is done using the method <code>Bitmap::SetFilter()</code>. See <code>List of Bitmap Filter Types</code> for more details on the types of filtering available. There is also a method of the <code>Bitmap</code> class called <code>GetFiltered()</code> to compute averaged colors over a specified area of the bitmap using the bitmap&#39;s current filtering algorithm.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";