var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"error_reporting\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Error Reporting</h1></div><p>When an image loader/saver plug-in (derived from class <code>BitmapIO</code>) encounters an error during a bitmap operation (for example &quot;No Disk Space&quot; when attempting to write a bitmap) there is a system flag that controls how the error should be reported to the user.</p>\n\
<p>The image loader/saver base class <code>BitmapIO</code> provides the method <code>BitmapIO::ProcessImageIOError()</code> for reporting errors. This presents a standard dialog that provides the user with options to cancel or retry the operation. So, when a developer runs into an error condition while processing a bitmap, they would use the <code>BitmapIO::ProcessImageIOError()</code> method to report it. Some &quot;common&quot; error messages are already defined, and for those you would simply use one of the error codes defined in <code>BITMAP</code>.H. These are:</p>\n\
<ul>\n\
<li><code>BMMRES_MEMORYERROR</code> - Generic memory error.</li>\n\
<li><code>BMMRES_CANTSTORAGE</code> - Generic can&#39;t create storage error.</li>\n\
<li><code>BMMRES_BADFRAME</code> - Generic Invalid Frame Number Requested.</li>\n\
</ul>\n\
<p>More of these exist but are for internal use only. To send your own message, simply pass a <code>TCHAR</code> string instead. The file name and/or device name are taken from the given <code>BitmapInfo</code> object.</p>\n\
<p>The <code>BitmapIO::ProcessImageIOError()</code> returns either BMMRES_ERRORRETRY or<code>BMMRES_ERRORTAKENCARE</code> depending on the users selection from the dialog box. Normally a developer doesn&#39;t care about the return value and simply returns it and exits.</p>\n\
<p>The idea of a standard error processing dialog is to control the display of dialogs. For example, when 3ds Max is running in network rendering mode, no dialogs should be displayed. That would cause the machine to just sit there since there would be no user to respond to the dialog.</p>\n\
<p>If you must handle the error yourself (that is, if you want to display your own error dialog), you should first check to see if dialogs are allowed by checking the <code>BitmapManager::SilentMode()</code> method. This method returns a value indicating if dialogs should indeed be displayed or not.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";