var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"loading_bitmaps\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Loading Bitmaps</h1></div><p>The following code demonstrates how to load a bitmap using <code>BitmapManager::SelectFileInput()</code> to allow the user to choose a file to load (and initialize the <code>BitmapInfo</code> instance passed to it).</p>\n\
<p>First we declare a <code>Bitmap</code> pointer and a <code>BitmapInfo</code> instance.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Bitmap *bmap;\n\
BitmapInfo bi;</code></pre><p>Next, we use a method of the bitmap manager to allow the user to choose an image file. This method returns <code>FALSE</code> if the user cancels and <code>TRUE</code> if they select an image. If you want to directly indicate which file to load, just set the fields of <code>BitmapInfo</code> yourself (for example <code>.SetName</code>(_T(&quot;TEST.JPG&quot;)); )</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Let the user choose the file to open\n\
BOOL res = TheManager-&gt;SelectFileInput(&amp;bi, ip-&gt;GetMAXHWnd(), _T(&quot;Open File&quot;));\n\
\n\
if (!res) return; // User cancelled...</code></pre><p>After <code>SelectFileInput()</code> returns, the <code>BitmapInfo</code> instance passed to it contains the necessary information about the bitmap to load. To load the bitmap, the <code>Load()</code> method of the bitmap manager is used.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Load the selected image\n\
BMMRES status;\n\
bmap = TheManager-&gt;Load(&amp;bi, &amp;status);\n\
if (status != BMMRES_SUCCESS)\n\
{\n\
   MessageBox(ip-&gt;GetMAXHWnd(), _T(&quot;Error loading bitmap.&quot;),\n\
   _T(&quot;Error&quot;), MB_ICONSTOP);\n\
}</code></pre><p>Once the image is loaded, you can work with it like any other bitmap. For example to display the bitmap in a window, use the <code>Bitmap::Display()</code> method.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Display the opened bitmap\n\
bmap-&gt;Display(title, BMM_CN, FALSE, TRUE);</code></pre><p>A few more notes on the bitmap manager <code>Load()</code> method -- Additional options may be set by calling <code>BitmapManager::ImageInputOptions()</code> before calling <code>Load()</code>. This method will ask the user for special details such as custom positioning of smaller/larger images, etc. This method sets the proper fields in <code>BitmapInfo</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";