var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"principal_bitmap_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Principal Bitmap Classes</h1></div><p>The following are the primary classes used when working with bitmaps:</p>\n\
<ul>\n\
<li><p><code>BitmapManager</code> - There is a global object defined by 3ds Max called <code>TheManager</code>. This is an instance of the class <code>BitmapManager</code>. This object manages and enables developers to work with bitmaps in 3ds Max. For example, this class provides methods for creating and loading bitmaps. It also has methods for displaying some common dialogs that let users interactively specify files and devices to work with, and set options for bitmaps.</p>\n\
</li>\n\
<li><p><code>BitmapInfo</code> -<code>BitmapInfo</code> is the class used to describe the properties of a bitmap. The developer can declare an instance of this class and use its methods such as <code>SetWidth()</code>, SetHeight(), SetGamma(), and <code>SetName()</code> to describe the bitmap properties. The other classes related to bitmaps then use this information. Thus <code>BitmapInfo</code> is the heart of all image input/output. For example, all but a few methods in the <code>BitmapManager</code> use a <code>BitmapInfo</code> object as the main argument. For instance, if you wish to create a bitmap, you declare an instance of <code>BitmapInfo</code> and use its methods to establish the bitmap properties. Then when you call the <code>BitmapManager</code> method <code>Create()</code>, you pass the <code>BitmapInfo</code> object. The <code>BitmapManager</code> uses this information to determine how much memory to allocate based on the width, height and color depth.</p>\n\
<p>This class also has methods to get and set the number of frames used in multi-frame bitmaps, and to define &#39;custom&#39; properties of the bitmap. Custom properties let you specify only a portion of the main bitmap, such as a smaller, sub-region of the original, or fewer frames than the original (different begin and end settings or a different frame increment step size for multi-frame bitmaps). These custom properties are read and used by bitmap copying operations for example.</p>\n\
</li>\n\
<li><p><code>Bitmap</code> - The <code>Bitmap</code> class represents the bitmap itself. All image access is done through this class. This class provides standard methods to retrieve and store pixels from the image. The <code>Bitmap</code> class has methods to retrieve parameters of the bitmap such as its width, height, whether it is dithered, or has an alpha channel. Additional methods allow developers to open bitmaps for output, write multi-frame images, and to copy pixel data between bitmaps.</p>\n\
</li>\n\
</ul>\n\
<p>There are other bitmap related classes used only by developers who create 3ds Max plug-ins used to load and save new bitmap file formats. The methods of these classes are called by the <code>BitmapManager</code> and <code>Bitmap</code> classes and not by developers themselves. The primary classes used for creating image loading and saving plug-ins are:</p>\n\
<ul>\n\
<li><p><code>BitmapIO</code> - This is the main plug-in class used by developers creating image loader / saver plug-ins. For example, a developer creating a plug-in to support the PCX file format would derive their plug-in class from <code>BitmapIO</code>. This class is used for both files and devices (devices are items such as digital disk recorders). Developers implement pure virtual methods of this class to provide information about the image loader / saver they are creating. This is information such as the plug-in author name, copyright data, image format description, filename extension(s) used, and other capabilities of the image loader / saver. The developer also implements methods to load the image from disk, prepare it for output, write image data to it, and close it. Image loader / saver plug-ins use the <code>BitmapStorage</code> class described below to load and save their actual pixel data.</p>\n\
</li>\n\
<li><p><code>BitmapStorage</code> - When an image is loaded or created, the buffer that will hold the image data is an instance of the <code>BitmapStorage</code> class. This class allows developers to access the image in a uniform manner even though the underlying storage might be 1, 8, 16, 32 or 48 bit. For example, a paletted 8-bit format is perfect for loading GIF files but not for loading 32-bit Targa files. The inverse is also true. There is no point in creating a true color 64-bit storage to load a GIF file that only has 8-bit color information.</p>\n\
<p>Again, note that the <code>BitmapStorage</code> class is a low level access mechanism used by image loader / saver (<code>BitmapIO</code>) plug-ins. Developers wanting to access an image use the methods in the <code>Bitmap</code> class instead.</p>\n\
<p>The <code>BitmapStorage</code> mechanism was created so images could be kept in memory in a more efficient way. Instead of loading everything in 3ds Max&#39;s internal 64-bit format, bitmaps are loaded and/or created using the most efficient storage for their type. The <code>BitmapStorage</code> class provides an uniform set of pixel access methods to hide these different formats from the developer using bitmaps. For example, standard methods are available for getting and putting pixels at various color depths. In this way, even though an image may be a 1-bit monochrome line art bitmap, pixels may be retrieved or stored at other color depths. For example the <code>BitmapStorage</code> methods <code>Get16Gray()</code>/Put16Gray(), <code>GetTruePixels()</code>/PutTruePixels(), and <code>GetIndexPixels()</code>/PutIndexPixels()provide access to pixel data at various color depths.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";