var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"resolution__palettes__pixel_stor\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Resolution / Palettes / Pixel Storage Topics</h1></div><h2 id=\"bitmap-adjustment-changes-to-resolution-and-color-depth\">Bitmap Adjustment - Changes to Resolution and Color Depth</h2><p>There are several ways to change the resolution of a bitmap. In each case this involves creating a new bitmap and copying the existing bitmap to the new. To change the image size without any scaling of the pixel data, use <code>Bitmap::CopyImage()</code> and specify the <code>COPY_IMAGE_CROP</code> operation. To resize the bitmap you use <code>Bitmap::CopyImage()</code> as well. This method lets you specify either a low quality (faster) or a higher quality (slower) copy. See <code>Copy Image Operations</code> for examples of each.</p>\n\
<p>To change the color depth (number of bits per pixel), you must create a new bitmap of the desired color depth, and copy the original to the new using <code>Bitmap::CopyImage()</code>.</p>\n\
<h2 id=\"palettes\">Palettes</h2><p>Some color bitmaps use only 8-bits per pixel. These images, unlike true color images where every pixel can be a unique color, are limited by the colors stored in a palette. For example, an 8-bit GIF file has a 256 color palette. The color values stored by the palette can be any color, but the actual bitmap image can only be comprised of colors from the palette. And since the palette is limited to 256 colors, the image has a maximum of 256 unique colors. For paletted bitmaps, each pixel in the image is actually an index into the palette (sometimes called a color lookup table). So the pixel value tells the system which palette slot to look in, and the value in that palette slot determines the exact color.</p>\n\
<p>In contrast, true color images, for example a 24-bit TGA file, store the color of the pixel directly in the pixel value. There is no palette used.</p>\n\
<p>In 3ds Max, every bitmap has storage for a palette even if it is not used. There are methods of the Bitmap class used to work with palettes. A developer may use <code>Bitmap::IsPaletted()</code> to determine if an image is indeed paletted. To access the palette of a bitmap, <code>Bitmap::GetPalette()</code> and <code>Bitmap::SetPalette()</code> may be used.</p>\n\
<p>Palettes are primarily a concern for image loader plug-in derived from <code>BitmapIO</code>. When loading an 8 bit image, the loader would create an 8-bit storage and set the palette through <code>BitmapStorage::SetPalette()</code>. Sample code is available showing how this is done in <code>\\\\MAXSDK</code>\\SAMPLES\\IO\\BMP\\BMP.CPP in the <code>Load()</code> method.</p>\n\
<h2 id=\"pixel-storage\">Pixel Storage</h2><p>There are several in-memory storage formats for pixel data. For a list of the available formats see the section<code>Pixel Storage Types</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";