var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"saving_bitmaps\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Saving Bitmaps</h1></div><p>The example below demonstrates how to save files for a multi-frame file.</p>\n\
<p>First we declare a <code>Bitmap</code> pointer and a <code>BitmapInfo</code> instance.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Bitmap *bmap;\n\
BitmapInfo bi;</code></pre><p>To allow the user to choose an output file type, use the <code>BitmapManager</code> method <code>SelectFileOutput()</code>. This brings up the &apos;Browse Images for Output&apos; dialog box. This method returns TRUE if the user selected a file; it returns FALSE if they cancel the dialog box. This method also handles checking if the filename chosen already exists, and if so provides an overwrite question dialog. This method will fill in the proper fields of the <code>BitmapInfo</code> passed.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">BOOL gotIt = TheManager-&gt;SelectFileOutput(&amp;bi, ip-&gt;GetMAXHWnd());\n\
if (!gotIt) return; // User cancelled</code></pre><p>Next we need to set the image size and the properties of <code>BitmapInfo</code> related to multi-frame images. Below we do this for a 30 frame sequence.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bi.SetWidth(640)\n\
bi.SetHeight(480)\n\
bi.SetFirstFrame(0)\n\
bi.SetLastFrame(29)</code></pre><p>With the <code>BitmapInfo</code> setup, we can call the <code>BitmapManager</code> to create the sequence:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bmap = TheManager-&gt;Create(&amp;bi);</code></pre><p>The next code is used to open the bitmap for output. This indicates to the system that the bitmap is open for output and we can write to.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bmap-&gt;OpenOutput(&amp; bi);</code></pre><p>Next we write the images for each frame:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">for (frame = 0; frame &lt; 30; frame++)\n\
{\n\
   // Do something to the image\n\
   // ...\n\
   // Write the image\n\
   bmap-&gt;Write(&amp;bi, frame);\n\
}</code></pre><p>When we are done we need to close the image:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bmap-&gt;Close(&amp; bi)</code></pre><div class=\"note note:\"><span class=\"notetitle\">Note:</span> You can add any number of outputs to a bitmap. Just keep calling <code>bmap</code>-&gt;OpenOutput() with different outputs (for instance a TGA file and Frame Buffer). To write or close a specific output, use <code>Write()</code>and <code>Close()</code>. To write and close them all at once, use the <code>Bitmap</code> methods <code>WriteAll()</code> and <code>CloseAll()</code>. It is okay to use <code>WriteAll()</code> and <code>CloseAll()</code> if you have just one output defined.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../working_with_bitmaps.html\">Working With Bitmaps</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";