var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"asset_file_path_resolution\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Asset File Path Resolution</h1></div><p>All resolutions of asset files are performed through the <code>MaxSDK::AssetManagement::AssetUser</code> object which uses <code>IFileResolutionManager</code>. The <code>IFileResolutionManager</code> can also be used for resolutions of assets. File resolution is based on the asset file name and the asset type.</p>\n\
<p>In order to use the asset file resolution manager your project needs to link to the <code>assetmanagement</code>.lib library. Below is an example of how to get a pointer to the file resolution manager and invoke a function defined in its interface.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include &quot;path.h&quot;\n\
#include &quot;AssetType.h&quot;\n\
#include &quot; IFileResolutionManager.h&quot;\n\
\n\
IFileResolutionManager* pFRM = IFileResolutionManager::GetInstance();\n\
MaxSDK::Util::Path path(_M(&quot;myBitmap.bmp&quot;));\n\
if (pFRM-&gt;GetFullFilePath(path, MaxSDK::AssetManagement::kBitmapAsset))\n\
{\n\
  // path now holds a fully qualified path\n\
}\n\
else\n\
{\n\
  // the bitmap file could not be found using 3ds Max asset\n\
  // resolution rules. The value of path is left unchanged\n\
}</code></pre><p><code>IFileResolutionManager</code> also provides methods for a plug-in to query, enable, and disable caching of resolved file paths, as well as to control the cache duration. When the cache is enabled and still valid, <code>IFileResolutionManager::GetFullFilePath()</code> will return the last path resolved without trying to resolve it again.</p>\n\
<p>To resolve XRef&apos;d asset files using <code>IFileResolutionManager::GetFullFilePath()</code> set the <code>assetType</code> parameter to <code>AssetType::kXRefAsset</code>.</p>\n\
<p>To resolve externally referenced files using <code>IFileResolutionManager::GetFullFilePath()</code> set the <code>assetType</code> parameter to <code>MaxSDK::AssetManagement::AssetType::kXRefAsset</code>.</p>\n\
<p>For more information on the asset file resolution manager see the header file <code>maxsdk\\\\include\\\\IFileResolutionManager.h</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../assets.html\">Assets</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";