var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"session_paths\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Session Paths</h1></div><p>Session paths are a type of asset path. They function exactly the same as the paths seen in the Customize-&gt;Configure Paths dialog, &quot;External Files&quot; and &quot;XRefs&quot; tabs. However, session paths are not shown in the UI and are not saved. They exist only for the remainder of the 3ds Max session in which they are applied. They are used to specify a set of paths to be searched for assets and XRef&#39;d scene files.</p>\n\
<p>Session paths support a mechanism whereby paths can be defined on a per-file basis. It is used by 3ds Max for network and command-line rendering, but it can also be used by customers developing their own asset management systems. The suggested use to define a concept of a &quot;Project&quot; where each project has its own asset folders. Users would open their files using a custom dialog that would set up the Session Paths to point to the appropriate folders for the given project.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> Session Paths will not be reported by the methods <code>IPathConfigMgr::GetAssetDirCount()</code> and <code>IPathConfigMgr::GetAssetDir()</code>. These methods operate only on normal (non-session) paths. You can get the combined total of paths using <code>IPathConfigMgr::GetCurAssetDirCount()</code> and access them using <code>IPathConfigMrg::GetCurAssetDir()</code>.</div>\n\
<p>The class used to manage the session paths is <code>IPathConfigMgr</code>. A global object of this type can be accessed through the method <code>IPathConfigMgr::GetPathConfigMgr()</code>. This class contains the following methods specifically for dealing with session paths:</p>\n\
<ul>\n\
<li><code>IPathConfigMgr::AddSessionAssetDir()</code> - Adds a session path.</li>\n\
<li><code>IPathConfigMgr::GetSessionAssetDirCount()</code> - Returns the number of session directories in path.</li>\n\
<li><code>IPathConfigMgr::GetSessionAssetDir()</code> - Returns the session directory in path.</li>\n\
<li><code>IPathConfigMgr::DeleteSessionAssetDir()</code> - Deletes a session path.</li>\n\
<li><code>IPathConfigMgr::SetSessionProjectFolder()</code> - Sets a project folder which will be used for this application session only.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../assets.html\">Assets</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";