var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"application_data\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Application Data</h1></div><p>Application-specific data may be attached to any <code>Animatable</code> in the scene using application data chunks. Application data chunks are represented using <code>AppDataChunk</code>. With the related APIs any 3ds Max object (controller, object, node, modifier, material, etc.) can have custom data attached by other objects. These chunks are saved in the .MAX file and can be accessed through the object they are attached to.</p>\n\
<p>The following methods used to create and retrieve application data are from class <code>Animatable</code>. The data is accessed using three owner identifiers: The <code>SuperClassID</code> and the <code>Class_ID</code> of the owner, and a sub-index.</p>\n\
<ul>\n\
<li><code>Animatable::AddAppDataChunk()</code> - This method is used to add an <code>AppDataChunk</code> to this Animatable. The chunk is identified using the <code>Class_ID</code>, and <code>SuperClassID</code> of the owner, and an ID for sub-chunks.</li>\n\
<li><code>Animatable::GetAppDataChunk()</code> - This method is used to retrieve a pointer to an <code>AppDataChunk</code>.</li>\n\
<li><code>Animatable::RemoveAppDataChunk()</code> - This method is used to delete an <code>AppDataChunk</code>.</li>\n\
</ul>\n\
<p>Sample code using these APIs can be found in <code>\\\\maxsdk\\\\samples\\\\utilities\\\\appdata.cpp</code>.</p>\n\
<p>Developers who have 3D Studio / DOS IPAS application data associated with nodes being imported into 3ds Max have APIs available in 3ds Max to help process this imported data. Application data was used by IPAS plug-ins to store special data with nodes. This was used for example by IK and spline patches. These APIs allow a 3ds Max plug-in to request incoming application data from an IPAS plug-in and use it. plug-ins can register a callback that gets called when application data is loaded. The callback can then interpret the data and create a new object that will be used instead of the usual triangle mesh. For more details see the <code>ObjectDataReaderCallback</code>.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> Although it is possible to associate application data with the scene or the root node, that data won&#39;t be saved in the 3ds Max file since the scene and the root node are not saved.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../custom_scene_data.html\">Custom Scene Data</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";