var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"custom_user_properties\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Custom User Properties</h1></div><p>In addition to <a href=\"custom_attributes.html\"\">Custom Attributes</a> another method of attaching data to a node is using custom user properties. This is data that a user can add and edit using the object properties dialog.</p>\n\
<p>This data can be ASCII text, an integer value, a float value, or a boolean value. These values are stored and retrieved using a &apos;key&apos; string. This is a string of any length -- the only limitation is that the key string must not contains spaces, tabs or the equal sign (=) character.</p>\n\
<p>To get and set specific data values developers may use the following methods of <code>INode:</code></p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Getter Functions</td>\n\
<td>Setter Functions</td>\n\
</tr>\n\
<tr>\n\
<td><code>INode::GetUserPropString()</code></td>\n\
<td><code>INode::SetUserPropString()</code></td>\n\
</tr>\n\
<tr>\n\
<td><code>INode::GetUserPropInt()</code></td>\n\
<td><code>INode::SetUserPropInt()</code></td>\n\
</tr>\n\
<tr>\n\
<td><code>INode::GetUserPropFloat()</code></td>\n\
<td><code>INode::SetUserPropFloat()</code></td>\n\
</tr>\n\
<tr>\n\
<td><code>INode::GetUserPropBool()</code></td>\n\
<td><code>INode::SetUserPropBool()</code></td>\n\
</tr>\n\
</tbody></table>\n\
<p>An end user may enter this data as well (in the 3ds Max user interface it is referred to as a &quot;User Defined Property&quot;). Using the Object Properties dialog a user may enter text in the following format:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">PropertyName1=PropertyValue 1\n\
PropertyName2=PropertyValue 2\n\
...</code></pre><p>The property name corresponds to the key string. The property name must appear at the start of the line (although it can be preceded by spaces or tabs) and there can be only one property per line.</p>\n\
<p>A developer may access the entire user-defined property text buffer if they wish to parse it themselves. The methods to do this are <code>INode::GetUserPropBuffer()</code> and <code>INode::SetUserPropBuffer()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../custom_scene_data.html\">Custom Scene Data</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";