var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"getting_the_nodes_that_reference\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Getting the Nodes that Reference an Object</h1></div><p>Every object is referenced by one or more <code>INode</code>s. To find the first <code>INode</code> in the dependency graph that references an object by sending a reference message <code>REFMSG_GET_NODE_HANDLE</code> to its dependents using <code>ReferenceTarget::NotifyDependents()</code>. This will retrieve a handle of the first node that references the object. Using the method <code>Interface::GetINodeByHandle()</code> a node can then be retrieved.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">INode* GetNodeFromObject(BaseObject* obj) {\n\
  ULONG handle = 0;\n\
  rm-&gt;NotifyDependents(FOREVER, (PartID)&amp;handle, REFMSG_GET_NODE_HANDLE);\n\
  INode *node = GetCOREInterface()-&gt;GetINodeByHandle(handle);\n\
  return node;\n\
}</code></pre><p>ITo find all of the nodes that reference an object use the instancemanager&apos;s <code>IInstanceMgr::GetInstances()</code> method passing it the <code>INode</code> thatyou have acquired. A pointer to a global instance of <code>IInstanceMgr</code> can be retrieved using the static member function: <code>IInstanceMgr::GetInstanceMgr()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void GetAllReferencingNodes(BaseObject* obj, INodeTab&amp; nodes) {\n\
  INode* node = GetNodeFromObject(obj);\n\
  DbgAssert(node != NULL); // should never be NULL\n\
   IInstanceMgr::GetInstanceMgr()-&gt;GetInstamces(*node, nodes);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../nodes.html\">Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";