var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"node_parent__child_relationships\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Node Parent / Child Relationships</h1></div><p>Nodes in 3ds Max can be linked to one another to form parent / child hierarchies. This is also called node linking. The 3ds Max SDK provides a developer with methods to work with this hierarchy via the <code>INode</code> class. A node that is linked to another node is referred to as a child node. A node that has children is referred to as a parent node. A node may have several children, but only a single parent.</p>\n\
<p>Developers can manipulate the hierarchy using methods <code>INode::AttachChild()</code>, <code>INode::Detach()</code>, and <code>INode::GetParentNode()</code>. One can check if a node is linked using <code>INode::GetParentNode()</code>. If the returned node is the root node (i.e. the function <code>INode::IsRootNode()</code> returns true) then the first node is not linked. The following sample function shows how to check this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bool IsNodeLinked(INode* node) \n\
{\n\
    return node-&gt;GetParentNode()  != NULL  &amp;&amp; !node-&gt;GetParentNode()-&gt;IsRootNode();\n\
}\n\
\n\
-   `INode::AttachChild()` - Adds a child / parent relationship. The parent will receive the reference message `REFMSG_NODE_LINK`.\n\
-   `INode::Detach()` - Removes a child / parent relationship. The parent will receive the reference message `REFMSG_NODE_LINK`.\n\
-   `INode::NumberOfChildren()` - used to retrieve the number of children a node has.\n\
-   `INode::GetParentNode()` - Returns the parent node of a child.\n\
-   `INode::IsRootNode()` - determines if a node is a root node (does not have a parent node).\n\
-   `INode::GetChildNode()` - returns an `INode` pointer to the nth child.\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../nodes.html\">Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";