var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"nodes_and_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Nodes and References</h1></div><p>A node maintains at least six references that allow it to get notified when items that affect it change. These references are listed and defined below:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Node References:</td>\n\
<td>Description:</td>\n\
</tr>\n\
<tr>\n\
<td>Transform Controller</td>\n\
<td>This is a reference to the node&#39;s transform controller. This controller governs the position, rotation and scaling of the node in the scene. You can get and set the transform controller using <code>INode::GetTMController()</code> and <code>INode::SetTMController()</code>. Most nodes use the PRS transform controller (for example mesh objects). Other items (such as target spotlights and cameras) use the Look At transform controller.</td>\n\
</tr>\n\
<tr>\n\
<td>Object Reference</td>\n\
<td>Each node maintains a pointer to an object. This is a pointer to the base object (mesh, light, camera) or a derived object (see the <a href=\"./../../modeling/geometry_pipeline_system.html\">Geometry Pipeline System</a> topic for details on derived objects). The path that follows between object references are what make up a geometry pipeline in 3ds Max. The node&#39;s object reference is where the pipeline starts. The object reference can be accessed and assigned using the methods <code>INode::GetObjectRef()</code> and <code>INode::SetObjectRef()</code></td>\n\
</tr>\n\
<tr>\n\
<td>Pin Node for Inverse Kinematics</td>\n\
<td>The reference at index 2 (e.g. <code>GetReference(2)</code>) is a pointer to the pin node for Inverse Kinematics. This reference is not assigned by default and is thus NULL initially.</td>\n\
</tr>\n\
<tr>\n\
<td>Material Reference</td>\n\
<td>Materials in 3ds Max are assigned at the node level. There is a single material assigned per node. This reference is a pointer to the material for the node. A developer can get and set the material using the methods <code>INode::GetMtl()</code> and <code>INode::SetMtl()</code>. If a material is assigned, this reference tracks it. This reference is not assigned by default and is thus NULL initially.</td>\n\
</tr>\n\
<tr>\n\
<td>Visibility Controller</td>\n\
<td>In Track View the user can assign this visibility controller using the &#39;Add Visibility Track&#39; icon. When this controller is assigned this reference points to the controller managing the node visibility. This reference is not assigned by default and is thus NULL initially. You can get or set the visibility controller using the methods <code>INode::GetVisController()</code> and <code>INode::SetVisController()</code>.</td>\n\
</tr>\n\
<tr>\n\
<td>Image Blur Controller</td>\n\
<td>This reference is not assigned by default and is thus NULL initially. The image blur controller can be get and set using the methods <code>INode::GetImageBlurMultController()</code> and <code>INode::SetImageBlurMultController()</code>.</td>\n\
</tr>\n\
<tr>\n\
<td>Layer</td>\n\
<td>The layer reference can be accessed using <code>GetReference(NODE_LAYER_REF)</code>. For more information on layers see <a href=\"./../organizing_nodes/layers.html\">Layers</a>.</td>\n\
</tr>\n\
</tbody></table>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../nodes.html\">Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";