var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"working_with_containers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Working with Containers</h1></div><p>It is possible to have objects linked to containers or contents of containers without being part of the container content, but this is not recommended.</p>\n\
<p>It is not possible to instance containers within a scene (that is to have multiple references to the same shared container), but they can be copied, and then changes to one of the copies can be saved, and all containers can be reloaded, and all copies will inherit the changes. Many containers can point to the same definition.</p>\n\
<p>In addition to the content, containers also govern what users of a container are allowed to do with the content if they inherit the container. This is called the container rules. At the moment, the only options are either no access (the user can only read in the content but make no modification) or edit in-place, which allows someone inheriting the container to modify the content and save the result, overwriting the original definition.</p>\n\
<h2 id=\"common-container-tasks\">Common Container Tasks</h2><p>The following are some common tasks associated with containers:</p>\n\
<ul>\n\
<li>Creating a container - You can create a new local container using the method <code>IContainerManager::CreateContainer()</code>.</li>\n\
<li>Importing a container into a scene - You can import (inherit) an existing container into a scene using the method <code>IContainerManager::CreateInheritedContainer()</code>.</li>\n\
<li>Saving and loading the content - A container and its content is saved in a Max file separate from the main scene file called the container definition file. By convention definition files use a different file extension: .MAXC. This is to allow users to distinguish container definitions from regular scene files when browsing folders, and prevent mistaken edits of container definitions. It is possible to rename the container definition and open it as a MAX file. Local containers use a local definition file. Inherited containers reference a source definition file.</li>\n\
<li>Adding content to a container - Content can be added to a container using the methods: <code>IContainerObject::AddNodeToContent()</code> and <code>IContainerObject::AddNodesToContent()</code>, and <code>IContainerObject::RemoveNodeFromContent()</code>. Nodes added to a container should not have references to other nodes outside of the container, otherwise these references can disappear during operations performed on the container. Content nodes in containers become children of the container.</li>\n\
<li>Removing content from a container - Content can be removed from a container using the method <code>IContainerObject::RemoveNodeFromContent()</code>.</li>\n\
<li>Unloading of content from scene - When content is unloaded, changes are saved to the definition file, and the content is removed from the scene. See <code>IContainerObject::UnloadContainer()</code>.</li>\n\
<li>Loading of content into scene - If content has been unloaded, it can be loaded back into the scene using <code>IContainer::LoadContainer()</code>. Calling <code>IContainerObject::ReloadContent()</code> causes content in the scene to be updated with the contents in the definition file, and to lose local modifications. Calling <code>IContainerObject::UpdateContent()</code> behaves like a merge, maintaining local modifications. This would be used if multiple users are collaborating using the same container.</li>\n\
<li>Copying content - A referenced (inherited) container can be made into a local (unique) container by calling <code>IContainerObject::MakeUnique()</code> or <code>IContainerObject::MergeSource()</code>. All future changes (and previously unsaved changes) to the content will not be saved to the original container definition file. <code>IContainerObject::MakeUnique()</code> is recursively applied to nested containers while <code>IContainerObject::MergeSource()</code>is not.</li>\n\
<li>Deleting the container from the scene - If a container is deleted from the scene all associated data is deleted.</li>\n\
<li>Querying containers for content - The <code>IContainerManager</code> interface is used to query whether a container contains a node through the method <code>IContainerManager::IsInContainer()</code>.</li>\n\
<li>Saving and loading of a container - A container is saved automatically in the main 3ds Max scene file as a file asset, while the container contents are saved in the container definition file.</li>\n\
<li>Modifying container permissions - Containers can prevent or allow edits to be performed on their content. This is called &#39;closing&#39; or &#39;opening&#39; a container respectively. When a container is closed the content behaves like an XRef&#39;d scene, it will be displayed and its contents rendered but it can not be selected or edited. Some methods related to container permissions are: <code>IContainerObject::IsOpen()</code>, <code>IContainerObject::SetOpen()</code>, <code>IContainerObject::IsContainerOpenableOrClosable()</code>.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../containers.html\">Containers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";