var topic = "<html>\n\
<head>\n\
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n\
\n\
  <link rel=\"stylesheet\" href=\"/view/clientframework/client.css\" type=\"text/css\" />\n\
\n\
  <meta name=\"experiencelevel\" content=\"expert\" />\n\
  <meta name=\"audience\" content=\"programmer\" />\n\
  <meta name=\"language\" content=\"ENU\" />\n\
  <meta name=\"product\" content=\"MAXDEV\" />\n\
  <meta name=\"release\" content=\"2024\" />\n\
  <meta name=\"book\" content=\"Developer\" />\n\
  <meta name=\"component\" content=\"Max-Developer-Help\" />\n\
  <meta name=\"topicid\" content=\"iterating_over_layers_by_index\" />\n\
  <meta name=\"helpsystempath\" content=\"/view/MAXDEV/2024/ENU/\" />\n\
\n\
  <script src=\"/view/clientframework/client.js\" type=\"text/javascript\"><!--filler--></script>\n\
  <meta name=\"topic-subtype\" content=\"C++\" />\n\
\n\
<title>Iterating over Layers by Index</title>\n\
\n\
</head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Iterating over Layers by Index</h1></div><p>The <code>IFPLayerManager</code> class is also an interface class that manages scene layers in 3ds Max. This class however is a function published interface, and thus is quite different from the previously discussed layer manager. This class is the C++ interfaces to the MAXScript <code>LayerManager</code> class. This class has a useful method fro returning a layer by integer index. Thus you can iterate over scene layers without knowing the names of the layers. To get a pointer to this object you call the <code>GetCOREInterface()</code> function.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IFPLayerManager* layer_manager = static_cast&lt; IFPLayerManager*&gt; GetCOREInterface( LAYERMANAGER_INTERFACE);</code></pre><p>The <code>LAYERMANAGER_INTERFACE</code> identifies the <code>IFPLayerManager</code> interface. With the resulting pointer you can get a scene layer by integer index.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">ILayerProperties* hLayer = layer_manager-&gt;getLayer(i);</code></pre><p>This <code>IFPLayerManager::getLayer()</code> method returns a <code>ILayerProperties</code> pointer which has much less functionality than <code>ILayer</code>.</p>\n\
<p>To get an <code>ILayer</code> pointer you can get a pointer to any object on that layer, and extract the <code>ILayer</code> pointer from it.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../layers.html\">Layers</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";