var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"node_grouping\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Node Grouping</h1></div><p>A 3ds Max user can take a node in the scene and make it part of a group. Groups allow the user to select all the nodes in the group as one element without having to select each piece. Groups can be included in other groups so nesting can occur. <code>INode::IsGroupMember()</code> indicates whether a node is included in a group or not by returning <code>TRUE</code> if the node is in a group and <code>FALSE</code> if not.</p>\n\
<p>The following interfaces on the Interface class are also used for working with node groups:</p>\n\
<ul>\n\
<li><code>Interface::GroupNodes()</code> - Creates a node group.</li>\n\
<li><code>Interface::UngroupNodes()</code> - Dissolves a group into its component objects (or sub-groups) and deletes the group dummy object. This is not recursive.</li>\n\
<li><code>Interface::ExplodeNodes()</code> - Dissolves a group and all its subgroups recursively.</li>\n\
<li><code>Interface::OpenGroup()</code> - Allows editing of individual nodes in a group.</li>\n\
<li><code>Interface::CloseGroup()</code> - Prevents editing of individual nodes in a group.</li>\n\
<li><code>Interface::DetachNodesFromGroup()</code> - Excludes nodes from a group.</li>\n\
<li><code>Interface::FlashNodes()</code> - Forces a redraw of a node group causing their associated objects to flash in the viewport</li>\n\
</ul>\n\
<p>When 3ds Max constructs a group it first creates an invisible dummy node and linking the group members to this dummy. The dummy node is called the group head. The method <code>INode::IsGroupHead()</code> tells if the node is one of the dummy nodes that heads a group.</p>\n\
<p>If you have a member of a group and want to get a pointer to the group head use <code>INode::GetParentNode()</code>. If you go through the children of the head (and all their children), and all the member booleans are set, the nodes are still part of the same group.</p>\n\
<p>Groups may be opened allowing the user to edit the individual components (without otherwise breaking up the group). The method <code>INode::IsOpenGroupMember()</code> returns <code>TRUE</code> if the node is a member of an open group and <code>FALSE</code> if not. Group head nodes can be checked if they are open by calling <code>INode::IsOpenGroupHead()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../organizing_nodes.html\">Organizing Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";