var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"xref_scenes_and_objects\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>XRef Scenes and Objects</h1></div><p>Scenes and objects can be stored in separate 3ds Max files, and referenced from a master file. This process is called external referencing or XRef for short. These XRef scenes and objects are loaded when the master file is loaded, but can not be modified from the master file.</p>\n\
<p>An XRef object can be an object, controller, or material. An XRef object can be animated only if its transform controller in the external scene has also been merged with the master scene. When loading XRef object&#39;s the user has options to merge materials, and merge transforms from the scene file containing the XRef object.</p>\n\
<p>An XRef scene is an entire external 3ds Max scene.</p>\n\
<p>The following <code>INode</code> member functions are used for working with scene XRefs:</p>\n\
<ul>\n\
<li><code>INode::GetXRefFile()</code> - Returns the file asset of the nth scene XRef.</li>\n\
<li><code>INode::SetXRefFile()</code> - Sets the file asset of the nth scene XRef.</li>\n\
<li><code>INode::GetXRefFileCount()</code> - Returns the number of scene XRefs.</li>\n\
<li><code>INode::AddNewXRefFile()</code> - Adds a new scene XRef file asset.</li>\n\
<li><code>INode::DeleteXRefFile()</code> - Deletes the nth scene XRef file asset.</li>\n\
<li><code>INode::BindXRefFile()</code> - Merges a scene XRef into the scene and deletes the XRef.</li>\n\
<li><code>INode::DeleteAllXRefs()</code> - Deletes all scene XRefs from the scene.</li>\n\
<li><code>INode::ReloadXRef()</code> - This method will update the specified scene XRef, by reloading it from disk.</li>\n\
<li><code>INode::FlagXrefChanged()</code> - Sets a flag indicating that the specified XRef has been changed and should be updated.</li>\n\
<li><code>INode::UpdateChangedXRefs()</code> - Updates all XRefs which have their changed flag set.</li>\n\
<li><code>INode::GetXRefTree()</code> - Returns the root node of the tree for the specified XRef.</li>\n\
<li><code>INode::GetXRefParent()</code> - Returns the node in the scene (if any) which the scene XRef is linked to.</li>\n\
<li><code>INode::SetXRefParent()</code> - Sets the parent node of the XRef scene.</li>\n\
<li><code>INode::FindUnresolvedXRefs()</code> - Generates a list of names of unresolved XRefs in scene.</li>\n\
<li><code>INode::AttemptToResolveUnresolvedXRefs()</code> - Attempts to load unresolved XRef scenes.</li>\n\
<li><code>INode::GetXRefFlags()</code> - Returns a set of flags for the nth XRef scene.</li>\n\
<li><code>INode::SetXRefFlags()</code> - Sets the specified flags for the nth XRef scene.</li>\n\
</ul>\n\
<p>For working with object XRefs see:</p>\n\
<ul>\n\
<li><code>IXRefItem</code></li>\n\
<li><code>IObjXRefManager8</code></li>\n\
<li><code>IObjXRefRecord</code></li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../organizing_nodes.html\">Organizing Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";