var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"scene_graph\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Scene Graph</h1></div><p>3ds Max scenes are organized internally as trees (directed acyclic graphs with single parents) of <code>INode</code>s. Every element of the scene corresponds to one or more node in the graph. Graph nodes are represented by <code>INode</code> objects. The root of the graph can be retrieved via the method <code>Interface::GetRootNode()</code>. The children of each node can be accessed using <code>INode::NumberOfChildren()</code> and <code>INode::GetChildNode()</code>.</p>\n\
<h2 id=\"scene-graph-evaluation\">Scene Graph Evaluation</h2><p>The scene graph is evaluated by 3ds Max by calling <code>INode::EvalWorldState()</code> on each of its nodes within a viewport area that needs to be redrawn and if they are invalid. Nodes that are not visible in the viewport are not evaluated at all.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> <code>INode::EvalWorldState()</code> should not be called from within post-load-callbacks.</div>\n\
<h2 id=\"displaying-the-scene-graph\">Displaying the Scene Graph</h2><p>The scene graph is displayed in the viewport using a technique of minimal culling, based on the 2d viewport rectangle. In order to maintain the frame per second rate during animation an adaptive degradation rendering system is used. Bounding boxes and gizmos are drawn after the scene nodes are drawn.</p>\n\
<h2 id=\"iterating-over-the-scene-graph\">Iterating over the Scene Graph</h2><p>The preferred way to iterate over the nodes in a scene is to use <code>IScene::EnumTree()</code>. A pointer to the <code>IScene</code> can be retrieved using the method <code>Interface7::GetScene()</code>. The method <code>IScene::EnumTree()</code> takes a callback object as a parameter, that inherits from <code>ITreeEnumProc</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../scenes_and_nodes.html\">Scenes and Nodes</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";