var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"how_to_enable_undo_and_redo\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>How to Enable Undo and Redo</h1></div><p>The undo / redo system is managed by a global instance of the <code>Hold</code> class called <code>theHold</code>. To use the undo / redo system the developer must derive a class from <code>RestoreObj</code> and register an instance with the <code>theHold</code> using the method <code>theHold::Put()</code>. The class derived from <code>RestoreObj</code> saves the data needed to undo and redo the operation of the plug-in and to implement several methods required by 3ds Max.</p>\n\
<p>Any operation that modifies the scene state should check to see if <code>theHold</code> is &apos;holding&apos;. This means the 3ds Max undo system has had the <code>Begin()</code> method called. If <code>theHold</code> is not &apos;holding&apos; and the code is UI code, the developer should call <code>theHold</code>. Begin(). This signals the start of a potential undo operation. Otherwise, non-UI code does not need to check to see if <code>theHold</code> is holding before calling <code>theHold</code>. Begin(). The hold system knows how to deal with nested Begin/Accept calls.</p>\n\
<p>Methods exposed using the function publishing system should not call <code>theHold</code>. Begin(). Otherwise, if the caller has not called <code>theHold</code>. Begin(), each call to the method would create an undo entry, but other operations being done by the caller would not.</p>\n\
<p>If <code>theHold</code> is holding, any operation that modifies the scene state must register a restore object with the system before it modifies the scene state.</p>\n\
<p>Note that you should check to make sure you are holding before creating a RestoreObj and Putting it to the hold system. Otherwise, you may try to do a Put when not holding, causing a memory violation.</p>\n\
<p>For the difference between a set of nested Begin/Accepts and a SuperBegin/Begin/Accept/SuperAccept consider the following pseudo-code examples:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Begin\n\
  Put( a )\n\
  Begin\n\
    Put( b )\n\
  Cancel\n\
  Put( c )\n\
Accept</code></pre><p>and</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">SuperBegin\n\
  Put ( a )\n\
  Begin\n\
    Put ( b )\n\
  Cancel\n\
  Put ( c )\n\
SuperAccept</code></pre><p>In the first example, the <code>Cancel</code> call deletes both <code>RestoreObjs</code> A and B. In the second, only <code>RestoreObj</code> B is deleted. The only time you need to use <code>SuperBegin</code> is when you have a multistage operation, and individual stages of the operation may be cancelled without cancelling the entire operation.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../the_undo_and_redo_system.html\">The Undo and Redo System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";