var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"undo_and_redo_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Undo and Redo Example</h1></div><p>As a simple example consider a utility plug-in that allows the user to change the wire-frame color of a node in the scene. The restore object needs to save the previous color and a pointer to the node being changed. It also needs storage to save the current color prior to an undo. This allows it to revert the undo.</p>\n\
<p>To register the restore object with the system, the developer calls <code>theHold</code>. Put(), passing the restore object pointer. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">if ( theHold.Holding() ) {\n\
  //The INode you are changing the color of\n\
  theHold.Put(new ColorRestoreObj(currentColor,INode*));\n\
}</code></pre><p>In the example above the <code>ColorRestoreObj</code> is a developer defined class derived from <code>RestoreObj</code>.</p>\n\
<p>Once the restore object has been registered with <code>theHold</code>, there are two potential cases to terminate the <code>Begin()</code>. The user can complete the operation or cancel it.</p>\n\
<ul>\n\
<li>If the user completes the operation, the developer calls <code>theHold</code>. Accept() to register an undo object with the undo system and leave the scene state in its modified state.</li>\n\
<li>If the user cancels the operation, the developer calls <code>theHold</code>. Cancel() to restore the scene state to its previous state and discard the restore object.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../the_undo_and_redo_system.html\">The Undo and Redo System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";