var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"undo_memory_limits\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Undo Memory Limits</h1></div><p>If <code>RestoreObj::Size()</code> returns a value that exceeds 4000000 (~4Mb) then 3ds Max may exhibit inconsistent behavior then not every object passed to <code>theHold</code>. Put() appears in then Undo/Redo Menu, some of them of them are skipped.</p>\n\
<p>The undo manager (the global instance of the <code>Hold</code> class named <code>theHold</code>) has a limit of 4 MB ( 8 * 500 * 1024) for all the restore objects in the Undo manager in 32 bit versions of 3ds Max. The 64 bit versions of 3ds Max has limit of 40 MB (80 * 500 * 1024) for all the restore objects. This is the amount of memory actually used. It is not pre-allocated or anything like that.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> In versions of 3ds Max prior to 3ds Max 2008, this limit was 500 KB.</div>\n\
<p>When you attempt to put restore objects into the undo manager, it adds the sizes of the restore objects. That is the values you return in <code>RestoreObj::Size()</code>. This value is added to the size of the currently existing undo stack. If the new number is greater than 3/4 of the limit, then it rejects all the restore objects put between begin / accept pairs.</p>\n\
<p>The decision to accept or reject your restore object is not done when you call <code>Hold::Put()</code>, but when you call <code>Hold::Accept()</code>. Also, at that time, the decision to accept or reject the restore object is not done on a case by case basis, but for all the restore objects you &#39;put&#39; between a begin / accept pair. So if you put 4 restore objects between a begin / accept pair, where each is 1.2 MB, then when accept is called, the system will look at it as 4.8 MB of memory that needs to get added to the undo stack. And the decision to accept or reject will be performed accordingly.</p>\n\
<p>If the undo manager rejects your restore objects, it will flush the entire undo stack, and delete the references to the restore objects. It will not automatically delete the memory referenced pointers, because they are reference targets, and are managed by the reference system.</p>\n\
<p><code>RestoreObj::Size()</code> is implemented by the developer. If you provide an incorrect size, you lose the protection that the undo manager will offer you.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../the_undo_and_redo_system.html\">The Undo and Redo System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";