var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"3dsmax_main_window_hwnd\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Getting the 3ds Max Main Window</h1></div><p>Prior to 3ds Max 2018, external applications could obtain the <code>HWND</code> of the 3ds Max main window by looking for an active window with the class name of <code>3DSMAX</code>.  As of 3ds Max 2018, the main window is a Qt window, and requires a different method to access.</p>\n\
<p>The <em>maxsdk\\include\\Process_Data_3DSMAX.h</em> exposes the <code>FindProcessMainWindow()</code> function you can use to get the main window handle for the first running process with the specified version number.  Here is an example of how to use this function:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">// Utility function to get the process id of a running session of 3ds Max.\n\
// Finds the first 3ds Max session that has the specified max_version number, unless\n\
// max_version is 0 in which the first 3ds Max session is used.\n\
// The main HWND of the 3ds Max session is returned through max_hwnd.\n\
// This function only works on sessions of 3ds Max 2018 and higher.\n\
//\n\
DWORD Get3dsMaxProcessHandle(DWORD max_version, HWND &amp;max_hwnd)\n\
{\n\
    PROCESSENTRY32 entry;\n\
    entry.dwSize = sizeof(PROCESSENTRY32);\n\
\n\
    HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);\n\
    DWORD result = 0;\n\
\n\
    if (Process32First(snapshot, &amp;entry) == TRUE) {\n\
        while (Process32Next(snapshot, &amp;entry) == TRUE) {\n\
            if (_wcsicmp(entry.szExeFile, L&quot;3dsmax.exe&quot;) == 0) {\n\
                DWORD process_max_version = 0;\n\
                HWND process_max_hwnd = MaxSDK::Util::FindProcessMainWindow(entry.th32ProcessID, process_max_version);\n\
                if (process_max_hwnd &amp;&amp; (max_version == 0 || max_version == process_max_version))\n\
                {\n\
                    max_hwnd = process_max_hwnd;\n\
                    result = entry.th32ProcessID;\n\
                    break;\n\
                }\n\
            }\n\
        }\n\
    }\n\
\n\
    CloseHandle(snapshot);\n\
    return result;\n\
}</code></pre>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";