var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"classes_involved_in_the_action_s\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Classes Involved in the Action System</h1></div><p>The following are the primary classes involved in the Action System.</p>\n\
<p><code>ActionTable</code> - An <code>ActionTable</code> holds a set of <code>ActionItem</code>s, which are operations that can be tied to various UI elements, such as keyboard shortcuts, custom user interface buttons, the 3ds Max main menu and the quad menu. 3ds Max&#39;s core code exports several action tables for built-in operations in 3ds Max. Plug-ins can also export their own action tables via methods available in <code>ClassDesc</code>.</p>\n\
<p><code>ActionItem</code> - The <code>ActionItem</code> class is used to represent a single operation that lives in an <code>ActionTable</code>. <code>ActionItem</code> is an abstract class with operations to support various UI operations. The system provides a default implementation of this class that works when the table is built with the <code>ActionTable::BuildActionTable()</code> method. However, developers may want to specialize this class for more specific-purpose applications. For example, MAXScript uses this mechanism to export macro scripts to an <code>ActionTable</code>.</p>\n\
<p><code>ActionDescription</code> - This structure is used when creating action tables. An array of these structures is created with one element for each action in the table to be built. This array is then passed as a parameter to the <code>ActionTable</code> constructor.</p>\n\
<p><code>ActionCallback</code> - This is the callback class that executes an action in response to a user request. The <code>ActionCallback::ExecuteAction()</code> method is overridden by the developer to perform the specific work associated with the action. This usually consists of a case statement that switches based on the ID of the command being executed.</p>\n\
<p><code>ActionContext</code> - This class functions as an identifier for a group of actions. Several action tables can share a single <code>ActionContext</code>. The class maintains an ID, a name, and an active state for the context and has methods to retrieve these. When an action context is active all of the action tables that use that context are active as well.</p>\n\
<p><code>IActionManager</code> - This class provides methods to work with the available action tables. There are methods to get the number of and a pointer to specific action tables, activate and deactivate action tables, work with action contexts and determine if they are active. To get a pointer to the global instance of this class, use <code>Interface::GetActionManager()</code>.</p>\n\
<p><code>DynamicMenu</code> - This is a helper class used in dynamically displaying additional quad or toolbar menus. This class has a few methods related to adding new menu items, beginning and ending sub-menus, checking menu flags, and getting a pointer to the menu after it has been created. The dynamic menu created by this class is provided to the method <code>ActionItem::GetDynamicMenu()</code>.</p>\n\
<p><code>DynamicMenuCallback</code> - This is a callback used when creating dynamic menus. An instance of this class is passed to the constructor of the helper class <code>DynamicMenu</code>. This class has a single method called <code>DynamicMenuCallback::MenuItemSelected()</code> that is called when the user has chosen an item from the menu.</p>\n\
<p><code>MAXIcon</code> - This is an abstract class that represents an icon image for toolbar buttons, icons in list boxes, etc. The class is based on Win32 <code>ImageList</code>s. A <code>MaxIcon</code> must provide an image list and index into the list for both large (24x24) and small (16x15) icons</p>\n\
<p><code>ClassDesc</code> - When a plug-in wants to make its ActionTable(s) available, it uses the methods <code>ClassDesc::NumActionTables()</code> and <code>ClassDesc::GetActionTable()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../action_system.html\">Action System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";