var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"keyboard_accelerators_and_dialog\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Keyboard Accelerators and Dialog Messages</h1></div><h2 id=\"keyboard-shortcuts\">Keyboard Shortcuts</h2><p><em>Important Note</em>: A new system to handle keyboard accelerators was added for R4. This system supercedes those used in previous release. For information on this system see Class <code>ActionTable</code>. The information shown below applies to previous version of the SDK APIs.</p>\n\
<p><em>Important Note</em>: In release 3.0 a new system to handle keyboard shortcuts was established. This system is used to register shortcuts in a uniform manner. In the Customize / Preference Settings / Keyboard tab dialog there is a section to assign plugin shortcuts to commands.</p>\n\
<h2 id=\"keyboard-accelerators\">Keyboard Accelerators</h2><p>Developers might want to implement keyboard accelerators for some of their plugins functions. Because 3ds Max plugins are modeless, when using R1 there was inherently a conflict between the accelerator keys that the user expected to run standard 3ds Max functions, and those supplied by the plugin. For this reason, a developer had to limit their accelerator key usage as much as possible. However in R2 and later the &#39;plugin Keyboard Shortcut Toggle&#39; icon was added. This controls this conflict such that the user can choose if the plugin accelerators are in effect or if the system accelerators are. Thus in R2 and later developer are free to registers all the accelerators they need and the user can control which are available.</p>\n\
<p>When a plugin has its parameters up and registers some accelerators, these accelerators take precedence over 3ds Max when the &#39;plugin Keyboard Shortcut Toggle&#39; is on. The methods below (from Class <code>Interface</code>) enable the developer to do this.</p>\n\
<ul>\n\
<li><code>Interface::RegisterAccelTable()</code> - This method registers a keyboard accelerator table. Window messages generated by the accelerator table are sent to the <code>hWnd</code> parameter.</li>\n\
<li><code>Interface::UnRegisterAccelTable()</code> - This method un-registers a keyboard accelerator table.</li>\n\
</ul>\n\
<h2 id=\"receiving-input-to-edit-controls\">Receiving Input to Edit Controls</h2><p>If a plugin wants to receive keyboard input using a Windows edit control, it must disable the keyboard accelerators. 3ds Max uses unmodified keys (such as <code>&#39;f&#39;</code> to change to the front view). Unless a plugin disabled the accelerators it would not get this input. The following global functions are used to enable, disable and check the enabled state of the keyboard accelerators.</p>\n\
<ul>\n\
<li>DisableAccelerators() - When this method is called, ALL keyboard accelerators are disabled and are no longer processed.</li>\n\
<li>EnableAccelerators() - When this method is called, the keyboard accelerators are processed again.</li>\n\
<li>AcceleratorsEnabled() - Determines if the keyboard accelerators are enabled. Returns TRUE if enabled; FALSE if disabled.</li>\n\
</ul>\n\
<p>For modal dialogs, Windows itself essentially handles disabling and enabling accelerators automatically. For modeless dialogs, a plugin may have to deal with these functions. If a plugin uses all standard 3ds Max custom edit controls for its editing, it won&#39;t need to deal with enabling and disabling accelerators as this is handled by the custom controls. On the other hand, if a plugin uses any Windows edit controls, such as a combo box that has an edit field and drop down, they will have to call these functions.</p>\n\
<p>For example, in a combo box, when an edit field gets focus, the Windows message CBN_SETFOCUS is sent. At this time, a plugin should call <code>DisableAccelerators()</code>. If the plugin did not do this, and if the user typed an <code>&#39;f&#39;</code>, the current 3ds Max viewport would change to the front view. By disabling all the accelerators, the plugin will receive the characters itself. When the dialog proc receives CBN_KILLFOCUS, the accelerators may be enabled using <code>EnableAccelerators()</code>.</p>\n\
<h2 id=\"floating-dialogs\">Floating Dialogs</h2><p>If a plugin creates a floating dialog box there are two important things that should be done.</p>\n\
<p>1) A plugin must use the 3ds Max window handle as the parent passed to the &quot;DialogBox&quot; of &quot;DialogBoxParam&quot;. One can get this handle using the method <code>Interface::GetMAXHWnd()</code>.</p>\n\
<p>2) The method <code>Interface::RegisterDlgWnd</code>( HWND hDlg) must be called passing the handle of the dialog window.</p>\n\
<p>Following these steps will prevent problems with the user of the dialog being able to operate the rest of 3ds Max while your dialog is active.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../action_system.html\">Action System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";