var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"when_to_derive_from_actiontable_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>When to Derive from ActionTable and ActionItem</h1></div><p>Developers have the option of deriving their own classes from <code>ActionTable</code> and <code>ActionItem</code>, but are not required to do either. Only <code>ActionCallback</code> is required to be derived.</p>\n\
<p>Developers will derive their own class from <code>ActionItem</code> only in rare cases. The default implementation of this class stores internal strings for its name, description, category, icon, etc. In some cases this might lead to duplicate storage if that information is stored elsewhere. In that case, you might want to provided a specialization of this class for memory efficiency.</p>\n\
<p>The <code>ActionTable</code> class also has several virtual methods that the developer might want to implement. All these methods have default implementations, so specializing this class is not required unless special behavior is needed.</p>\n\
<p>The default handlers for some of the handlers may not be appropriate. For example <code>ActionTable::IsEnabled()</code> returns TRUE in every case in the default implementation. If you want command to be disabled under some conditions, then you will need to build a specialization of ActionTable and implement this method. The methods of <code>ActionTable</code> that you might want to implement are:</p>\n\
<ul>\n\
<li><code>ActionTable::GetButtonText()</code></li>\n\
<li><code>ActionTable::GetMenuText()</code></li>\n\
<li><code>ActionTable::GetDescriptionText()</code></li>\n\
<li><code>ActionTable::IsChecked()</code></li>\n\
<li><code>ActionTable::IsItemVisible()</code></li>\n\
<li><code>ActionTable::IsEnabled()</code></li>\n\
<li><code>ActionTable::WritePersistentActionId()</code></li>\n\
<li><code>ActionTable::ReadPersistentActionId()</code></li>\n\
</ul>\n\
<p>You only need to implement the last two methods if your table uses command identifiers that are not persistent from session to session. An example of this is the <code>ActionTable</code> that exports scripts from MAXScript. This system reads all the scripts in your system and assigns command IDs that are based on the order the scripts are read from the file. This might change from session to session, so when we want a persistent ID to write out to our keyboard or CUI files, we need one that doesn&#39;t change. For scripts, it writes the name of the script concatenated with the category of the script. The <code>ReadPersistent</code> ActionId takes that string and returns its integer command ID for the current session.</p>\n\
<p>For tables that use constant integer identifiers that don&#39; t change from session to session, like the FDD example in the section on <a href=\"building_action_tables.html\"\">Building Action Tables</a> there is no need to implement these method.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../action_system.html\">Action System</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";