var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"available_custom_controls\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Available Custom Controls</h1></div><h2 id=\"custom-edit-controls\">Custom Edit Controls</h2><p><img src=\"./images/GUID-F2AD7A20-98A4-4A1D-A917-9F73604911F3-low.gif\" alt=\"\"></p>\n\
<p>This control is a simple text input control. The user may type any string into the field and the plugin is notified when the user presses the ENTER key. There are also methods to parse and return integer and floating point values entered in the control. If the edit control is to be used with numeric values, it is typically used in conjunction with a custom spinner control.</p>\n\
<h2 id=\"spinner-controls\">Spinner Controls</h2><p><img src=\"./images/GUID-D4835C2A-E502-4499-AFEE-BBCF67436FD1-low.gif\" alt=\"\">(Spinner control)</p>\n\
<p><img src=\"./images/GUID-C0DBC968-FC81-4234-928F-71234A3B4B97-low.gif\" alt=\"\"> (Edit control and Spinner control)</p>\n\
<p>The spinner control is used (usually in conjunction with the custom edit control) to provide input of values limited to a fixed type. For example, the control may be limited to the input of only positive integers. The input options are integer, float, universe (world space units), positive integer, positive float, positive universe, and time. This control allows the user to increment or decrement a value by clicking on the up or down arrows. The user may also click and drag on the arrows to interactively adjust the value. The Ctrl key may be held to accelerate the value changing speed, while the Alt key may be held to decrease the value changing speed. The user may also right click on the arrows to reset the value its default.</p>\n\
<h2 id=\"slider-controls\">Slider Controls</h2><p>This control is available in release 3.0 and later only.</p>\n\
<p>The custom slider control is functionality similar to the custom spinner control with some additional functionality. The slider control is used (sometimes in conjunction with the custom edit control) to provide input of values limited to a fixed type.</p>\n\
<p><img src=\"./images/GUID-F94EF40C-7025-4E42-B76F-434ACFE1A774-low.gif\" alt=\"\"> (Slider Control)</p>\n\
<p><img src=\"./images/GUID-D97DE2CA-A851-48CC-BBFF-32187DEE9158-low.gif\" alt=\"\"> (&#39;Bracketed&#39; Slider Control)</p>\n\
<h2 id=\"custom-button-controls\">Custom Button Controls</h2><p><img src=\"./images/GUID-762FAD95-6572-40D3-915B-D7188EBA7C70-low.gif\" alt=\"\"></p>\n\
<p><img src=\"./images/GUID-0B3E4815-D31B-4860-B03C-CCF3DD3F04CB-low.gif\" alt=\"\"></p>\n\
<p><img src=\"./images/GUID-0A68D76D-3E7B-4067-9001-7E9A8CFFA749-low.gif\" alt=\"\"></p>\n\
<p>Custom Buttons allow the developer to have extra control of the way buttons appear and behave in the dialog box. These custom buttons have the following features:</p>\n\
<p>The button can be either a check button (which stays pressed in until the user selects it again), or a push button (which pops back out immediately).</p>\n\
<p>The highlight color of the check button may be specified.</p>\n\
<p>A button may function as a fly-off. Any number of additional buttons may be specified to fly off. The direction of the fly off may be specified or computed automatically.</p>\n\
<p>The buttons may be labeled with text or images. Four images may be specified allowing precise control over how the button appears when enabled or disabled and pressed in or released.</p>\n\
<h2 id=\"custom-status-control\">Custom Status Control</h2><p><img src=\"./images/GUID-1141D505-E6E6-4DDE-A68F-04FC26A3E0F9-low.gif\" alt=\"\"></p>\n\
<p>This control provides a recessed area of the dialog which the developer may use as a status prompt area.</p>\n\
<h2 id=\"custom-toolbar-control\">Custom Toolbar Control</h2><p><img src=\"./images/GUID-92310119-AEA6-4F3B-A597-8168C2799AAA-low.gif\" alt=\"\"></p>\n\
<p>This control allows the creation of toolbars containing buttons (push, check, and fly-offs), status fields, separators (spacers), and other Windows or user defined controls. 3ds Max toolbar button icons can be of either 16x15 or 16x16 pixels.</p>\n\
<h2 id=\"custom-curve-control\">Custom Curve Control</h2><p>This is a spline based control which returns output values from a user adjustable curve. An example of this control in the 3ds Max user interface can be seen in the Color Map section of the Output rollup of a 2D Texture map. Sample code using these APIs is available in  <em>\\MAXSDK\\SAMPLES\\UTILITIES\\CCUTIL\\CCUTIL.CPP</em> .</p>\n\
<p><img src=\"./images/GUID-CE3B2983-57C3-44F5-822A-57A5F375FB81-low.gif\" alt=\"\"></p>\n\
<h2 id=\"custom-image-control\">Custom Image Control</h2><p><img src=\"./images/GUID-F7E4C80A-693C-4C64-956F-FC354113D722-low.gif\" alt=\"\"></p>\n\
<p>The custom image control provides a recessed area in the dialog to display a bitmap image.</p>\n\
<h2 id=\"color-swatch-control\">Color Swatch Control</h2><p><img src=\"./images/GUID-DE601ABF-3FB3-42D0-80DB-84C7B57ABF20-low.gif\" alt=\"\"></p>\n\
<p>The Color Swatch control presents the user with the standard 3ds Max modeless color selector when the user clicks on the control. The color swatch control displays the currently-selected color and may be continuously updated as the user interactively selects new colors. Color Swatches also handle drag and drop between color swatches.</p>\n\
<h2 id=\"rollup-window-control\">Rollup Window Control</h2><p><img src=\"./images/GUID-FE84DBBB-91E2-4415-A5E5-DAAC17D5C80A-low.gif\" alt=\"\"></p>\n\
<p><img src=\"./images/GUID-488196E6-40A5-4E5F-AE85-0E08F5062C32-low.gif\" alt=\"\"></p>\n\
<p>This control is used if you are creating a dialog box which will not be used in the command panel. This control adds a container area for rollup pages to be added to the dialog, and provides a scroll bar just like the command panel itself.</p>\n\
<p>Note that this is a special case. Normally, adding rollup pages to the command panel is done using the simple <code>AddRollupPage()</code> method of the <code>Interface</code> class. This control is only used when you want to have a scrolling region for rollup pages in a dialog box.</p>\n\
<h2 id=\"window-thumb-tack-control\">Window Thumb Tack Control</h2><p>This control installs a thumb tack into a window title bar which allows the user to make the window &#39;Always On Top&#39;.</p>\n\
<h2 id=\"off-screen-buffer-control\">Off Screen Buffer Control</h2><p>This control provides an off-screen buffer which the developer may draw into, then quickly blit onto the actual display for flicker-free image updates.</p>\n\
<h2 id=\"tcb-graph\">TCB Graph</h2><p><img src=\"./images/GUID-24775C94-7444-4A47-A055-E171AB45953F-low.gif\" alt=\"\"></p>\n\
<p>This control displays a tension / continuity / bias graph.</p>\n\
<h2 id=\"drag-and-drop-window-control\">Drag and Drop Window Control</h2><p>This kind of custom control is used to provide drag and drop to and from things other than Custom Buttons.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../custom_user_interface_controls.html\">Custom User Interface Controls</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";