var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"creating_a_rollup_page_using_cus\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Creating a Rollup Page using Custom Controls</h1></div><p>The tool for creating the rollup page portion the user interface of your plugin is the dialog editor of Visual C++ Developers Studio. You use the dialog editor to create the rollup page, and place and arrange the controls.</p>\n\
<p>The custom controls are positioned in a rollup page like any other control. Each one is created using the Custom Control button. The Custom Control button is the one shown highlighted below.</p>\n\
<p><img src=\"./images/GUID-87336921-EE6E-462E-9103-32EA7DA799D7-low.png\" alt></p>\n\
<p>The control is identified as being custom by filling in the Class field of the Custom Control Properties dialog box with an appropriate string indicating the type of control. To bring up this dialog, double click on the control in the dialog editor window.</p>\n\
<p><img src=\"./images/GUID-25126E43-6265-4EF3-BC2A-936FCEE0DB2D-low.png\" alt></p>\n\
<p>These are the values to be used in the Class field of the Custom Control Properties dialog for those custom controls which may appear in a rollup page:</p>\n\
<p>Custom Edit control - <code>CustEdit</code></p>\n\
<p>Custom Spinner Control - <code>SpinnerControl</code></p>\n\
<p>Custom Button control - <code>CustButton</code></p>\n\
<p>Custom Toolbar control - <code>CustToolbar</code></p>\n\
<p>Custom Image control - <code>CustImage</code></p>\n\
<p>Custom Status control - <code>CustStatus</code></p>\n\
<p>Color Swatch control - <code>ColorSwatch</code></p>\n\
<p>Custom Rollup Window - <code>RollupWindow</code></p>\n\
<p>Custom DragAndDrop Window control - <code>DragDropWindow</code></p>\n\
<p>Custom TCB Graph - <code>TCBGraph</code></p>\n\
<p>The other fields in the user control properties dialog are these:</p>\n\
<p>ID - This is the resource&apos;s identifier. The resource ID is usually a symbol supplied by Visual C++ and defined in the .H file that Visual C++ creates as part of your project. This is where you define the symbolic name for the resource.</p>\n\
<p>Caption - This is the text that appears as part of the control to label it. This field is used for Custom Buttons and Status controls.</p>\n\
<p>Visible - This determines whether or not the control is visible when the application is first run.</p>\n\
<p>Disabled - This determines if the resource is displayed as disabled when the dialog box is created.</p>\n\
<p>Group - This specifies the first control of a group of controls in which the user can move from one control to the next by using the arrow keys. All controls in the tab order after the first control with the Group property set to False belong to the same group. The next control in the tab order with Group set to True ends the first group of controls and starts the next group.</p>\n\
<p>Tabstop - This specifies that the user can move to this control with the TAB key. This is only appropriate for the edit and button controls.</p>\n\
<p>Class - The name of the control&apos;s Windows class. This class must be registered before the dialog box containing the control is created. See the class list above.</p>\n\
<p>Help ID - Assigns a help ID to the control. The help ID is based on the resource ID. Type: Bool. Default: False.</p>\n\
<p>Style - A 32-bit hexadecimal value specifying the control&apos;s style, primarily used to edit the lower 16 bits that make up a user control&apos;s sub-style.</p>\n\
<p>ExStyle - A 32-bit hexadecimal value specifying the control&apos;s extended style.</p>\n\
<p>When the rollup page dialog is created, it must be compiled and the resource file it generates must be included in the CPP source file. The default name for this file is <code>RESOURCE</code>.H. This may be changed by right clicking on the resource file name from the Resource View list (the top line) and choosing the Resource Includes... option. From this dialog, change the entry under Symbol header file.</p>\n\
<p>Once you create a rollup page layout, there are several ways to present it to the user. The standard way is using a rollup page in the command panel. Typically, this is called from within <code>BeginEditParams()</code> when the user is in the position of editing an items parameters.</p>\n\
<p>There is a method of the interface class to handle adding the rollup. Its called <code>AddRollupPage()</code>. The syntax looks like this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">hParams = interfacePtr-&gt;AddRollupPage(\n\
   hInstance, // DLL instance handle.\n\
   MAKEINTRESOURCE(IDD_CUSTCTRL), // ID of the dialog box.\n\
   DialogProc, // Dialog procedure to process user input.\n\
   ROLLUP_PAGE_TITLE, // Rollup title text.\n\
   (LPARAM)this); // Saves the this ptr of the item</code></pre><p>The standard width for rollup pages in the command column in the United States is 108 units. When you create dialogs for use in the command panel, always use 108 as the overall width (for use in the United States). Note the width and height are visible in the lower right hand corner of the IDE.</p>\n\
<p>In summary, the custom controls are added to a rollup page layout using the resource editor window of VC++. The Class field of the resource indicates which type of control you are creating. The finished rollup page layout is displayed to the user using the <code>AddRollupPage()</code> function.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../custom_user_interface_controls.html\">Custom User Interface Controls</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";