var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"getting_and_setting_user_prefere\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Getting and Setting User Preferences</h1></div><p>This section provides an overview of the global functions, classes and methods used to retrieve and set the user preferences of 3ds Max. Many of these are from the various pages of the Customize / Preferences... dialog.</p>\n\
<h2 id=\"user-interface-colors\">User Interface Colors</h2><p>A 3ds Max user may set various colors in the user interface via the settings in the Customize...  Preferences...  Color tab dialog. A developer may access and set these settings using the following global functions:</p>\n\
<ul>\n\
<li><code>GetUIColor()</code> - Returns the specified color value for drawing various items in the 3ds Max viewports.</li>\n\
<li><code>SetUIColor()</code> - Sets the specified color value for drawing various items in the 3ds Max viewports.</li>\n\
<li><code>GetDefaultUIColor()</code> - Returns the default color used for drawing various items in the 3ds Max user interface. The values returned are not affected by the user&#39;s color selections or those set by <code>SetUIColor()</code>.</li>\n\
<li><code>setUseVertexDots()</code> - Sets the Use Vertex Dots preference to on or off. This corresponds to the &#39;Show Vertices As Dots&#39; in the 3ds Max user interface.</li>\n\
<li><code>getUseVertexDots()</code> - Returns the Use Vertex Dots preference -- nonzero for on; zero for off.</li>\n\
<li><code>setVertexDotType()</code> - Sets the Vertex Small Dots / Large Dots preference. This corresponds to the &#39;Show Vertices As Dots&#39; Small Dots / Large Dots radio buttons in the 3ds Max user interface.</li>\n\
<li><code>getVertexDotType()</code> - Returns the Vertex Small Dots / Large Dots preference. One of the following values:</li>\n\
</ul>\n\
<h2 id=\"access-to-the-3ds-max-viewport-settings-\">Access to the 3ds Max Viewport settings:</h2><p>Access to the user settings includes the 3ds Max toolbars, snap settings, crossing setting, animate button, 3ds Max window handle, sub-object selection color, axis constraints, coordinate centers, and reference coordinate system setting. Some of the viewport settings are global in nature -- that is they affect all the viewports. These methods are in class <code>Interface</code>. Examples are <code>Interface::getBkgImageName()</code>, <code>Interface::GetGridSpacing()</code>, etc.</p>\n\
<p>Other viewport settings are specific to a viewport. These are available in class <code>ViewExp</code>. Examples are <code>getBkgImageDsp()</code>, <code>getSFDisplay()</code>, etc.</p>\n\
<h2 id=\"access-to-the-3ds-max-gamma-settings-\">Access to the 3ds Max gamma settings:</h2><p>The <code>GammaMgr</code> class allows access to the user specified gamma settings for display gamma, file input and output gamma.</p>\n\
<h2 id=\"system-settings\">System Settings</h2><p>There is also another API that allows a plug-in to query various system settings.</p>\n\
<p><code>GetSystemSetting()</code> - This method will return nonzero if the setting whose <code>id</code> is passed is on; otherwise zero. You may pass the following values:</p>\n\
<ul>\n\
<li><code>SYSSET_ENABLE_EDITABLEMESH</code> - Used to verify if <code>TriObject</code>s created will be the standard ones or the editable variety. Nonzero is returned if editable meshes will be created; otherwise zero for standard <code>TriObject</code>s.</li>\n\
<li><code>SYSSET_CLEAR_UNDO</code> - For release 1.1 and later if this ID is passed to this method the undo buffer is flushed.</li>\n\
<li><code>SYSSET_EDITABLEMESH_ENABLE_KEYBOARD_ACCEL</code> - This option is available in release 2.0 and later only. Determines if keyboard accelerators are enabled for the editable mesh. Nonzero if so; otherwise zero.</li>\n\
<li><code>SYSSET_ENABLE_EDITMESHMOD</code> - This option is available in release 2.0 and later only. Determines if the edit mesh modifier is enabled. Nonzero if so; otherwise zero.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";