var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"icons\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Icons</h1></div><div class=\"note note:\"><strong><span class=\"notetitle\">Note:</span></strong> Icon loading and handling has changed significantly in 3ds Max 2017 to support multi-resolution icons for high-DPI/4K displays.  </div>\n\
<p>Your plug-ins can use icons in their user interfaces (e.g. command panels or menus). Icons are images that can be loaded from a pre-compiled RCC file, or from a PNG or SVG file on disk.  In the case of PNG files, you should supply multiple sizes that the system can select for optimum display depending on the display scaling.  3ds Max generally supplies icons in these sizes:</p>\n\
<ul>\n\
<li>24x24</li>\n\
<li>30x30</li>\n\
<li>36x36</li>\n\
<li>48x48</li>\n\
</ul>\n\
<p><strong>New in 3ds Max 2023.1 Update:</strong> In the case of SVG files, which are scalable, you do not need to provide multiple resolutions.  However, you may wish to provide the smallest version of the image as PNG file to ensure it appears correctly at smaller sizes and lower resolutions.  3ds Max will use the scaled PNG version first, and then the SVG version at larger sizes and higher resolutions.</p>\n\
<p>The naming convention for scaled icons is to specify the size after the icon name, such as <code>Angle_24.png</code> for the 24x24 version.  </p>\n\
<p>In code, this icon would be specified to <code>MaxBmpFileIcon()</code> simply as</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\"> myIcon = new MaxBmpFileIcon(_T(&quot;&lt;path&gt;/Angle&quot;));</code></pre><p>Here <code>&lt;path&gt;</code> is either a relative path to the file system or to a location in an RCC file registered with the system. If it&apos;s a path, the path is relative to the MaxRoot\\UI_ln\\Icons\\[Light|Dark]\\ directory.  If it&apos;s a directory path (specified by starting with a colon, &apos;:&apos;), the RCC file must be registered before calling this method by using QResource::registerResource(). For more information, see <code>MaxBmpFileIcon()</code>.  For an example of loading custom multi-resolution icons in a plug-in, using both file-based icons and a compiled RCC resource, see the sample project in <code>maxsdk\\\\howto\\\\ui\\\\menudemo\\\\</code>.</p>\n\
<p>3ds Max loads icons from the compiled resources UI_ln/Icons[Dark|Light].rcc, depending on the active theme.  Using an RCC file is the recommended method for plug-ins to distribute and load multi-resolution icons.  For more information about the Qt Resource Compiler, see <a href=\"http://doc.qt.io/qt-5/resources.html\" target=\"_blank\">this link</a>.</p>\n\
<p>In UI_ln/Resources you will find .png versions of the current icon set.  These are the same icons compiled into UI_ln/Icons[Light|Dark].rcc.</p>\n\
<h2 id=\"legacy-single-resolution-icons\">Legacy Single Resolution Icons</h2><div class=\"note note:\"><em><span class=\"notetitle\">Note:</span></em> This section describes the legacy method of loading and using icons.</div>\n\
<p>3ds Max still supports the legacy icon loading method, and legacy icons are located in a couple of different places:</p>\n\
<ul>\n\
<li>UI_ln/Icons - images lists in .bmp format, 16x16 and 24x24 versions, as well as some .ico files.</li>\n\
<li>UI_ln/IconsDark - same as above, but for the Dark theme</li>\n\
</ul>\n\
<p>These icons are alpha-composited background icons and reside as *.bmp files in the  <em>\\UI_ln\\Icons</em>  folder. It is also possible for developers to integrate one or more resource based icons in their plug-in DLL file. In this case, those resource based icons will need to be converted to external icons and be stored as 24-bit image files with associated 24-bit alpha mask image files. The name of these files follow a fairly standard naming convention. As an example, the material editor icons and image files will be used for the following outline. The icon image files for this example can be found in the \\UI\\Icons folder as:</p>\n\
<ul>\n\
<li><p>MeditImages_a.bmp* //The 24-bit icon alpha mask</p>\n\
</li>\n\
<li><p>MeditImages_i.bmp* //The 24-bit icon images</p>\n\
</li>\n\
</ul>\n\
<p>One difference with ordinary icon formats is that these use an alpha mask instead of an XOR mask. An XOR mask needs to be inverted in order to create a proper alpha mask out of it. The process for this is fairly straightforward; copy the images directly to a file (i.e.  <em>myicons_i.bmp</em> ), invert the mask file and storing that in the associated file (i.e.  <em>myicons_a.bmp</em> ). This process will result in icons which are identical to the XOR masked versions. Of course, you can also tweak the alpha mask to give it fuzzy edges and other effects you might like for your icons to help composite with the background color in a seamless and smooth way.</p>\n\
<p>In the plugin code you will need to create image lists for the icons. Once again, taking the material editor as an example, you can create the image list in the following manner:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">hMeditImages = ImageList_Create(BUTW, BUTH, ILC_COLOR24 | ILC_MASK, 5, 0);\n\
LoadMAXFileIcon(&quot;MeditImages&quot;, hMeditImages, kBackground, FALSE);</code></pre><p>The first thing we do is to create an image list with 24-bit images and a mask. Next, we need to call <code>LoadMAXFileIcon()</code>to load the images into the image list. See below for more information on this function.</p>\n\
<p>If you want your icons to respond when the user customizes colors, you will need to implement a color change callback to reload the icons. This is not required, but it does enable your UI to integrate well with the color customization system. You need to create a callback as outlined below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">staticvoidColorChangeNotifyProc(void* param, NotifyInfo* pInfo)\n\
{\n\
   ImageList_RemoveAll(hMeditImages);\n\
   LoadMAXFileIcon(&quot;MeditImages&quot;, hMeditImages, kBackground, FALSE);\n\
}</code></pre><p>Then you will need to register it after you load the icons for the first time:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">RegisterNotification (ColorChangeNotifyProc, NULL, NOTIFY_COLOR_CHANGE);\n\
</code></pre><p>This way your buttons will always look correct when the user starts customizing colors.</p>\n\
<h3 id=\"dark-icons\">Dark Icons</h3><p>When using the dark color scheme for the icons, 3ds Max automatically darkens the bitmap based icons. This might result in poor readability of the icons. In order to increase the readability of the icons in such case, a set of dark icons optimized for the dark color scheme are provided in an icon folder called  <em>&lt;3dsMax_Root&gt;\\UI\\IconsDark</em> . 3ds Max looks into this folder for dark icons first, and falls back to  <em>&lt;3dsMax_Root&gt;\\UI\\Icons</em>  if it can&apos;t find any dark icons in the former location.</p>\n\
<p>This change may impact the way that your plug-in icons are displayed when 3ds Max uses the dark color theme. The following scenarios illustrate some types of problems you may encounter, and the corresponding solutions.</p>\n\
<h3 id=\"your-bitmap-based-icons-don-39-t-display-at-all\">Your bitmap based icons don&apos;t display at all</h3><p>Make sure your plug-in always loads the icons from  <em>&lt;3dsMax_Root&gt;\\UI_ln\\Icons</em>  using class <code>MaxBmpFileIcon</code> and install your icons (the same set) in both  <em>&lt;3dsMax_Root&gt;\\UI_ln\\Icons</em>  and  <em>&lt;3dsMax_Root&gt;\\UI_ln\\IconsDark</em> . This class will look for icons in the folder that corresponds to the current color theme used by 3ds Max.</p>\n\
<h3 id=\"you-want-to-improve-the-readability-of-your-bitmap-based-icons\">You want to improve the readability of your bitmap based icons</h3><p>Install a set of icons optimized for the dark color scheme into  <em>&lt;3dsMax_Root&gt;\\UI_ln\\IconsDark</em>  and make sure your plug-in uses class <code>MaxBmpFileIcon</code> to retrieve the right set of icons, or load the icons from the location supplied by the<code>IColorManager::GetIconFolder()</code> method.</p>\n\
<h3 id=\"your-icons-are-resources-in-your-plug-in-dll\">Your icons are resources in your plug-in DLL</h3><p>In some cases plug-ins manage icons as Window resources and manually handle the loading of icons instead of using the <code>MaxBmpFileIcon</code> class. To make sure your plug-in starts up with the correct icons (matching Max&apos;s color theme) you can call <code>AppFrameColorTheme IColorManager::GetAppFrameColorTheme()</code>. The plug-in can also subscribe to the <code>NOTIFY_APP_FRAME_THEME_CHANGED</code> notification (see <code>maxsdk\\\\include\\\\notify.h</code>) in order to react to changes in the 3ds Max color theme.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";