var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"menu_manager\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Menu Manager</h1></div><p>The menu manager API lets plugins register menus and menu contexts that are saved in 3ds Max&#39;s menus customization file (found at  <em>[MaxInstallDirectory]\\[Language]\\UI\\DefaultUI.mnux</em>  for the default UI) , and can be configured by the user.</p>\n\
<p>Menus are populated with action items published from action tables. Menu contexts are places where menus can appear in 3ds Max&#39;s UI. Menu contexts can be either for the main menu bar, or for places where a quad menu can be displayed. 3ds Max ships with a few pre-defined menu contexts, including the main menu bar, the viewport quad menu and the active shade quad menu. Only a single menu-bar context is allowed, but plugins may register new quad menu context as appropriate. For example, the UVW Unwrap plug-in in the 3ds Max SDK defines a quad menu context that is used when the user right-clicks in the UVW Unwrap window.</p>\n\
<p>Menu creation is handled with the <code>IMenu</code> API defined in the <code>iMenus.h</code> header. Projects using this header must link against  <em>menus.lib</em> .</p>\n\
<p>Custom menus added to 3ds Max using the <code>IMenu</code> API become part of the current user&#39;s local  <em>.mnux</em>  definition file, and will persist between sessions if the plug-in does not remove it. It is up to the plug-in developer to decide whether to remove the menu on exit. Plug-ins that do not do this should check whether the menu exists on start-up before creating it.</p>\n\
<h2 id=\"sample-code\">Sample Code</h2><p>Examples of Action Table API&#39;s in use are found in many places in the SDK. One example is  <em>/maxsdk/samples/modifiers/ffd.</em>  Another simple example of how to hook up your own ActionTables to a custom menu is located in  <em>maxsdk/howto/ui/maxmenudemo</em> .</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"menu_manager/extending_3ds_max_s_default_menu.html\">Extending 3ds Max&#x27;s Default Menus</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"menu_manager/menu_context_ids.html\">Menu Context IDs</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"menu_manager/imenubarcontext.html\">IMenuBarContext</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";