var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"processing_controls_not_managed_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Processing Controls not Managed by the Parameter Map</h1></div><p>Some controls may need to be processed by the developer directly. For example the sphere has a &apos;Create&apos; button in the &apos;Keyboard Entry&apos; rollup. Button controls are not processed by parameter maps. In order to process the messages sent when the user operates the button, the developer needs to derive a class from <code>ParamMapUserDlgProc</code> and set it as the parameter map&apos;s user using <code>SetUserDialogProc()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class SphereTypeInDlgProc : public ParamMapUserDlgProc {\n\
 public:\n\
  SphereObject *so;\n\
  SphereTypeInDlgProc(SphereObject *s) {so=s;}\n\
  BOOL DlgProc(TimeValue t,IParamMap *map,\n\
  HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);\n\
  void DeleteThis() {delete this;}\n\
 };</code></pre><p>The <code>IParamMap::SetUserDlgProc()</code> method is then used to set the callback to handle the messages. Note that the callback is called after the default processing is complete.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\"> pmapTypeIn-&gt;SetUserDlgProc(new SphereTypeInDlgProc(this));\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";