var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"schematic_view_window\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Schematic View Window</h1></div><p>The Schematic View window allows users to browse, and perform certain operations on, many of the objects that compose a 3ds Max scene. Like Track Views, multiple Schematic Views can be opened within 3ds Max, both in modeless windows and docked in viewports.</p>\n\
<p>Within a Schematic View window, a subset of the set of all Animatable objects within the 3ds Max scene is represented by a collection of rectangular &quot;nodes.&quot; These nodes are organized in tree form (or directed acyclic graph). The set of objects displayed depends on the current filter settings, the hide/show state of the nodes, and which objects were added to the Schematic View during the traversal phase. Schematic View is a <code>GlobalReferenceMaker</code> and any time it detects a change in the structure of the 3ds Max scene it performs a traversal of the scene&#39;s object network and updates the Schematic View graph. During the traversal, the actual Animatable objects (object&#39;s derived from Animatable) are responsible for adding themselves to the Schematic View and continuing the traversal by recursively calling <code>SvTraverseAnimGraph</code>(...). In practice, many objects in the scene are not added to the schematic view. In general, these omitted objects are either internal data structures that might confuse the user if displayed or they are objects whose shear quantity might overwhelm the user (vertices, for example). Furthermore, although the Schematic View requires that the represented objects be derived from Animatable, there are very few restrictions on the reference pointers between objects (called &quot;node pointers&quot; in this section to distinguish them from 3ds Max references). In particular, node pointers need not necessarily correspond to actual 3ds Max references (though in practice they usually do). This flexibility allows the schematic view to represent object relationships in a manner different from the actual internal reference relationships. This can be useful in places where the internal structure does not agree with the user&#39;s notion of how the objects are structured (e.g., a linked list displayed as siblings under a parent node, or vice-versa).</p>\n\
<h2 id=\"topology\">Topology</h2><p>The topology of the objects added to the schematic view must be a directed acyclic graph (DAG). Cyclic references are currently not allowed.</p>\n\
<p>Currently, nodes in the schematic view are arranged in tree form even if the underlying topology is a DAG. This is accomplished by duplicating shared nodes in the DAG. The DAG is essentially &quot;flattened&quot; into a tree. This is also how the track view works but, as will be explained in detail later, the schematic view stores additional information about the context of &quot;shared&quot; nodes which allows greater insight into instance relationships in the tree (multiple objects referencing a common node).</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"schematic_view_window/schematic_view_api.html\">Schematic View API</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"schematic_view_window/schematic_view_events.html\">Schematic View Events</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"schematic_view_window/schematic_view_relationships.html\">Schematic View Relationships</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";