var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"schematic_view_api\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Schematic View API</h1></div><p>There currently are three interfaces into the schematic view objects. <code>IGraphObjectManager</code>, <code>IGraphNode</code>, and <code>IGraphRef</code>. <code>IGraphObjectManager</code> represents an instance of a schematic view window and provides methods for adding nodes and node pointers, refreshing the schematic view, accessing filter bits and updating and controlling the various editors within 3ds Max in ways that are not surfaced in the general interface. <code>IGraphNode</code> represents a node in the schematic view graph and provides a few methods for querying information about the node. Finally, <code>IGraphRef</code> represents a node pointer and, currently, has no methods. Each of these three interfaces is described in greater detail below.</p>\n\
<p>In addition to the three schematic view interfaces, there is a set of methods in <code>Animatable</code> that can be overridden, all or in part, to specialize the behavior of the schematic view nodes which represents the Animatable object. Most of these methods are appropriately implemented for the various abstract base classes from which plug-in developers derive their classes. In most cases, there is no need for the plug-in developer to override any of these methods. All of the schematic view <code>Animatable</code> methods are prefixed by <code>Sv</code>. In addition to the &quot;Sv&quot; methods, there are a half dozen or so &quot;Sv&quot; prefixed functions in <code>Animatable</code> which are called to perform various schematic view related tasks. They are implemented in <code>Animatable</code> instead of <code>IGraphNode</code> because they are more closely associated with the <code>Animatable</code> than with the graph node or because they are called in places where the <code>IGraphNode</code> and <code>IGraphObjectManager</code> interfaces are not available.</p>\n\
<p>Taken as a whole, the three interfaces (<code>IGraphObjectManager</code>, <code>IGraphNode</code>, and <code>IGraphRef</code>) along with the &quot;Sv&quot; <code>Animatable</code> methods and functions represent the majority of the complete schematic view API.</p>\n\
<p>In general, the <code>IGraphObjectManager</code>, <code>IGraphNode</code>, and <code>IGraphRef</code> interfaces are not accessible to plug-ins outside of the scope of the Animatable &quot;Sv&quot; methods and should not be cached by the plug-in.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../schematic_view_window.html\">Schematic View Window</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";