var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"schematic_view_relationships\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Schematic View Relationships</h1></div><p>Animatable derived classes can add relationships to schematic view by override the <code>Animatable::SvTraverseAnimGraph()</code> method. In Relationships are added to schematic view during scene traversal. If <code>SvTraverseAnimGraph</code> is already implemented, add your relationship code after the existing code. In our example, the default implementation for controllers (<code>Control::SvTraverseAnimGraph()</code>) is called first. Valid flags to the method <code>Animatable::SvTraverseAnimGraph()</code> are values of type <code>SvRelationshipType</code>.</p>\n\
<p>The following example is taken from <code>maxsdk</code>\\samples\\controllers\\lookat_cnstrnt. cpp.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">SvGraphNodeReference LookAtConstRotation::SvTraverseAnimGraph( IGraphObjectManager *gom, Animatable *owner, int id, DWORD flags)\n\
{\n\
     SvGraphNodeReference nodeRef = Control::SvTraverseAnimGraph( gom, owner, id, flags );\n\
    if( nodeRef.stat == SVT_PROCEED ) {\n\
        for( int i=0; i&lt;GetNumTargets(); i++ ) {\n\
             gom-&gt;AddRelationship( nodeRef.gNode, GetNode(i), i, RELTYPE_CONSTRAINT );\n\
        }\n\
    }\n\
    return nodeRef;\n\
}</code></pre><p>You can provide your own tool-tip to describe the relationship by overriding <code>Animatable::SvGetRelTip()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">TSTR LookAtConstRotation::SvGetRelTip( IGraphObjectManager *gom, IGraphNode *gNodeTarget, int id, IGraphNode *gNodeMaker)\n\
{\n\
    return SvGetName(gom, gNodeMaker, false) + &quot; -&gt; &quot; + gNodeTarget-&gt;GetAnim()-&gt;SvGetName(gom, gNodeTarget, false);\n\
}</code></pre><p>Relationships can also be deleted or detached. The following two methods are used to provide detach functionality for the relationship. The id parameter passed into <code>Animatable::SvDetachRel()</code> is the same id passed into <code>IGraphObjectManager::AddRelationship()</code> in <code>Animatable::SvTraverseAnimGraph()</code>. This id could also have been used to identify which relationship to detach.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bool LookAtConstRotation::SvCanDetachRel( IGraphObjectManager *gom, IGraphNode *gNodeTarget, int id, IGraphNode *gNodeMaker)\n\
{\n\
    return true;\n\
}  \n\
bool LookAtConstRotation::SvDetachRel( IGraphObjectManager *gom, IGraphNode *gNodeTarget, int id, IGraphNode *gNodeMaker)\n\
{\n\
    for( int i=0; i&lt;GetNumTargets(); i++ ) {\n\
        if( GetNode(i) == gNodeTarget-&gt;GetAnim() ) {\n\
             DeleteTarget(i);\n\
             return true;\n\
        }\n\
    }\n\
    return false;\n\
}</code></pre><p>Classes adding relationships can also provide double-click functionality. The Look At Constraint in our example does not implement any double-click functionality. To do this, you would implement the <code>Animatable::SvHandleRelDoubleClick()</code> method. You can use the <code>IGraphObjectManager::GetHWnd()</code> method to use the schematic view as the parent window for your dialog.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bool MyPlugin::SvHandleRelDoubleClick( IGraphObjectManager *gom, IGraphNode *gNodeTarget, int id, IGraphNode *gNodeMaker)\n\
{\n\
    ShowMyDialog( gom-&gt;GetHWnd(), gNodeTarget-&gt;GetAnim() );\n\
    return true;\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../schematic_view_window.html\">Schematic View Window</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";