var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"units_of_measurement\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Units of Measurement</h1></div><p>3ds Max allows users to work with units that they are most comfortable with. Users may specify that they wish to work in US Standard units (Inches, Feet, Miles) or Metric units (Millimeters, Centimeters, Meters or Kilometers). Or they may specify a custom setting (for example perhaps they want to work in fathoms). Users may also work with generic units (these are the same as the default 3ds Max master units).</p>\n\
<p>Internally 3ds Max keeps track of all measurements in its own internal unit called the master unit. The program converts measurements from user-defined units into the master defined unit for storage and computation. The master unit is defined as 1.0 inch.</p>\n\
<p>To retrieve the current unit display information one can use <code>GetUnitDisplayInfo()</code>.This returns the information describing 3ds Max&#39;s current system of measurement. This includes the type of units used, how they are displayed and custom unit name and scale. A developer may also use <code>SetUnitDisplayInfo()</code>. This allows the developer to control the unit settings.</p>\n\
<p>Two functions are available for converting units in and out of ASCII form. These are <code>FormatUniverseValue()</code>and <code>DecodeUniverseValue()</code>. <code>FormatUniverseValue()</code> converts the specified value to its ASCII representation using the current unit display settings. <code>DecodeUniverseValue()</code> parses the specified measurement string and converts it to a floating point value.</p>\n\
<p>Developers can use the method <code>GetMasterScale()</code> to retrieve the master scale in terms of the specified unit type. For example passing <code>UNITS_INCHES</code> returns the number of inches per unit (unless altered by the user this would be 1.0).</p>\n\
<p>Consult the C++ Reference&#39;s &quot;<code>Related Pages &amp;gt; Lists and Functions &amp;gt; Units of Measurement Reference</code>&quot; to review the methods discussed above.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";