var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"windows_message_filtering\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Windows Message Filtering</h1></div><p>A common idiom used in progress dialogs is to remove all messages from the windows message queue except for paint messages and messages indicating that processing must be aborted (e.g. the escape key was pressed). By handling paint messages the application can continue to be responsive and prevent Windows from labeling the process as unresponsive.</p>\n\
<p>Plug-in developers must allow certain windows messages (that are defined in the <code>WM_USER</code> message range) to be propagated to WPF controls. These messages are critical to the proper functioning of the 3ds Max application menu. The <code>MaxSDK::WindowsMessageFilter</code> class exposed in the SDK is the preferred way to safely filter windows messages, in the context of a progress dialog. This class ensures proper dispatch of messages, and can be used to allow the application to respond to paint updates.</p>\n\
<p>We strongly recommend using the <code>MaxSDK::WindowsMessageFilter</code> class instead of rolling your own message filtering loop.</p>\n\
<p>For more information and a code example see the <code>MaxSDK::WindowsMessageFilter</code> class documentation.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../user_interface.html\">User Interface</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";