var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"geometric_primitives_supported_b\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Geometric Primitives Supported by the Graphics Window</h1></div><p>The geometric primitives supported by the <code>GraphicsWindow</code> class were designed to provide optimal support for rendering triangular meshes. As noted earlier, the preferred way to render such meshes is through the <code>Mesh::Render()</code> method.</p>\n\
<p>If you need to use the geometric primitives in the <code>GraphicsWindow</code> class directly, you should be aware that there is no direct support for illuminated primitives, so rendering illuminated surfaces is a two-step process.</p>\n\
<p>There are two levels of primitive support within the <code>GraphicsWindow</code> class: one set uses device-independent 3D eye coordinates and the other uses device-dependent window coordinates. At each level there are routines for polylines, polygons (triangles), markers, and annotation text.</p>\n\
<p>The device-dependent routines do not provide any support for clipping or range testing. For speed, these routines assume that all coordinate values passed in are valid. If invalid values are present, the results are unpredictable, but a program crash or corruption of the 3ds Max system is almost guaranteed.</p>\n\
<p>The higher-level routines transform their coordinate lists through the current affine and camera transformations, clipping when necessary, and then call the corresponding low-level routines.</p>\n\
<p>These routines are designed to optimize the rendering of meshes composed of vertex and connectivity lists. This process works as follows:</p>\n\
<ul>\n\
<li>Each vertex is transformed using the model-to-device transformation routine, and the resulting device coordinates and clip flags are cached.</li>\n\
<li>For each triangle in the connectivity list, the clip flags are examined to classify the triangle into one of the following three cases:</li>\n\
<li>If all vertices lie outside the viewing frustrum, the triangle is trivially rejected.</li>\n\
<li>If all vertices lie inside the viewing region, it is rasterized using the cached device coordinates and the low-level primitive routines.</li>\n\
<li>If the triangle is clipped by the viewing region, its model coordinates are sent to the high-level routines where the triangle is appropriately clipped and rasterized.</li>\n\
</ul>\n\
<p>Note that this approach only transforms and clip-checks most vertices once. Only in the rare case that a primitive is clipped do the associated vertices have to be transformed again. Since most vertices in a mesh are shared, this provides an efficient means to rasterize the entire mesh.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../graphics_window.html\">Graphics Window</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";