var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"graphics_window_coordinate_syste\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Graphics Window Coordinate Systems</h1></div><p>There are two primary coordinate systems within a <code>GraphicsWindow</code>: device-independent 3D eye coordinates and device-dependent window coordinates.</p>\n\
<p>Device-dependent coordinates are integer triples that have their origin at the lower-left corner of the window and increase toward the upper right. One unit corresponds to a single pixel. Z values closest to the user are 0, and they increase into the screen. The maximum Z value is driver-dependent. This coordinate system is left-handed.</p>\n\
<p>Eye coordinates are floating point triples that correspond to relative distances from the camera (or &quot;eye&quot;) associated with the window. In eye coordinates, x increases toward the right, y increases upward, and z decreases away (and in front of) the eye point. This coordinate system is right-handed.</p>\n\
<p>There are two ways to set up eye coordinates. In the first, the camera is assumed to be sitting at the origin looking down the negative z axis. You specify camera parameters (perspective/orthographic, field-of-view, etc.) and then provide a transformation matrix for an object&#39;s position relative to the camera. This is most easily accomplished by concatenating the inverse affine transformation for the camera&#39;s position in world space with the (forward) affine transformation of the object in world space.</p>\n\
<p>An affine transformation is a geometric transformation -- move, rotation, or scale -- that can alter distances between points or angles between lines, but preserves straight lines and the parallel relation between parallel lines.</p>\n\
<p>In the second method, a camera matrix is specified that includes both the world position (affine transformation) and projection information. This allows for a simple camera &quot;look at&quot; transformation model.</p>\n\
<p>Note that the system stores two matrices: a camera matrix (which can be a pure projection), and an affine transformation matrix. When deriving device coordinates for a geometric primitive, each position is logically transformed through the affine transformation first, followed by the camera transformation. This allows each geometric primitive to be represented in its own local coordinates.</p>\n\
<p>In addition to providing a method for transforming points from local, model coordinates to floating point device coordinates, a method is provided that transforms model coordinates into integer window coordinates with the origin at the upper left. These integer coordinates correspond to the coordinates used by GDI and the Windows mouse routines.</p>\n\
<p>Both model-to-device coordinate methods return clipping values indicating whether the transformed point lies outside of the view volume. Flags are provided for each of the six planes bounding the viewing frustum.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../graphics_window.html\">Graphics Window</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";