var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"rendering_modes_and_rendering_li\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Rendering Modes and Rendering Limits</h1></div><p>A <code>GraphicsWindow</code> instance can be in any of several different rendering modes. The various rendering modes may be combined in a large number of ways. For example, it is possible to request Gouraud-shaded z-buffered lines, or textured flat-shaded triangles. The actual output will depend on the capabilities of the underlying device driver.</p>\n\
<p>Each <code>GraphicsWindow</code> has a master mode (called the rendering limit) and a current mode. The current mode is always a &quot;subset&quot; of the master mode, in that any limits imposed by the master mode are forced onto the current mode. For example, if the master mode restricts primitives to wire-frame rendering, then setting the current mode to filled polygons will have no effect. On the other hand, if the master mode restricts rendering to flat shading, then the current mode can be set to wire-frame to force polygons to render at the wire-frame level.</p>\n\
<p>The rendering mode used by a viewport is accessed using a call to <code>GraphicsWindow::getRndMode()</code>. The rendering mode is a subset of the rendering limits, retrieved by <code>GraphicsWindow::getRndLimits()</code> and set by <code>GraphicsWindow::setRndLimits()</code>.</p>\n\
<p>Setting the rendering limits is used in communication between the various parts of 3ds Max that handle the display of objects. For example, setting this limit to <code>GW_POLY_EDGES</code> and then drawing a polygon won&#39;t result in a polygon drawn with edges. It only sets a flag that indicates that</p>\n\
<p>Consult the C++ Reference&#39;s &quot;<code>Related Pages &amp;gt; Lists and Functions &amp;gt; List of Rendering Limits</code>&quot; for a list of the valid rendering limit flags.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../graphics_window.html\">Graphics Window</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";