var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"hit_testing\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Hit Testing</h1></div><p>Hit testing is the process of determining if a given point (e.g. the location of a mouse) intersects an item (for example a node, a modifier gizmo/center, or a controller gizmo). A plug-in developer&#39;s responsibility regarding hit testing depends upon the type of plug-in and how much functionality is supplied by the base class the plug-in is derived from. For example, plug-ins that are derived from <code>SimpleObject</code>, <code>SimpleMod</code> or <code>StdControl</code> are not required to implement methods for hit testing as it is all handled internally by the base class. Other plug-ins that don&#39;t derive from these classes (for example the Boolean object or the Mapping modifier) must perform their own hit testing, by providing an implementation of one of the following methods:</p>\n\
<ul>\n\
<li><code>BaseObject::HitTest()</code> - For hit-testing geometric objects.</li>\n\
<li><code>Modifier::HitTest()</code> - A modifier uses a hit test function with a different signature than the inherited <code>BaseObject::HitTest()</code> method that has an additional <code>ModContext</code> parameter.</li>\n\
<li><code>Control::HitTest()</code> - For hit-testing controllers.</li>\n\
</ul>\n\
<p>There are two types of hit testing:</p>\n\
<ul>\n\
<li>Node level - This is for determining if a given node in the scene has been hit.</li>\n\
<li>Sub-object level - This can be for objects, modifier or controllers. This is for determining if a sub-component of an item has been hit. Object space modifiers can have a visual representation in the scene that the user can manipulate. For example, many of the 3ds Max object space modifiers have a gizmo and center mark. These are the modifier&#39;s sub-object levels. In the case of an edit modifier this can be the sub-object parts of the object itself (like vertices, edges, or face for the Edit Mesh modifier). An object may hit test sub-object parts as well. For example, a compound object like the boolean object may hit test the operands of the boolean operation. The loft model compound object may hit test parts of the loft model such as the path or shapes.</li>\n\
</ul>\n\
<p>There is also a distinction to be made between &#39;simple&#39; hit testing and &#39;smart&#39; hit testing. Simple hit testing involves finding any hit on an item. As soon as a single hit is found the process of searching for hits can stop. Smart hit testing involves finding the part of an item that was the close to the pick point. This involves hit testing everything and then searching through all the hits to find the closest one.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/hit_testing_in_the_graphics_wind.html\">Hit Testing in the Graphics Windows</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/using_sethitcode_and_sethitdista.html\">Using setHitCode and setHitDistance</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/sub-object_hit_testing.html\">Sub-Object Hit Testing</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/hit_lists.html\">Hit Lists</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/gizmo_hit_testing_using_polyline.html\">Gizmo Hit Testing using PolyLines</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/node_level_hit_testing.html\">Node Level Hit Testing</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"hit_testing/hit_regions.html\">Hit Regions</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../viewports_and_graphics_windows.html\">Viewports and Graphics Windows</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";