var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"gizmo_hit_testing_using_polyline\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Gizmo Hit Testing using PolyLines</h1></div><p>The following sample code demonstrates controller gizmo hit testing. This method hit tests a series of &apos;footstep&apos; shaped <code>PolyLine</code>s that serves as the controller&apos;s gizmo.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int FootStepControl::HitTest(\n\
               TimeValue t,\n\
              INode* inode,\n\
              int type,\n\
              int crossing,\n\
              int flags,\n\
              IPoint2 *p,\n\
              ViewExp *vpt)\n\
{\n\
   int savedLimits, res = 0;\n\
   GraphicsWindow *gw = vpt-&gt;getGW();\n\
   Matrix3 ntm = inode-&gt;GetNodeTM(t);\n\
   HitRegion hr;\n\
   MakeHitRegion(hr,type,crossing,4,p);\n\
\n\
   gw-&gt;setHitRegion(&amp;hr);\n\
   gw-&gt;setRndLimits(((savedLimits =\n\
   gw-&gt;getRndLimits()) | GW_PICK) &amp; ~GW_ILLUM);\n\
   gw-&gt;clearHitCode();\n\
\n\
   BOOL abortOnHit = flags&amp;SUBHIT_ABORTONHIT?TRUE:FALSE;\n\
   BOOL selOnly = flags&amp;SUBHIT_SELONLY?TRUE:FALSE;\n\
   BOOL unselOnly = flags&amp;SUBHIT_UNSELONLY?TRUE:FALSE;\n\
   for (int i=0; i&lt;NUM_FOOTSTEPS; i++)\n\
   {\n\
     if (selOnly &amp;&amp; !sel[i]) continue;\n\
     if (unselOnly &amp;&amp; sel[i]) continue;\n\
     gw-&gt;setTransform(fs[i]*ntm);\n\
     gw-&gt;polyline(FOOT_POINTS,footPts,NULL,NULL,TRUE,NULL);\n\
     if (gw-&gt;checkHitCode())\n\
     {\n\
      res = TRUE;\n\
      vpt-&gt;CtrlLogHit(inode,gw-&gt;getHitDistance(),i,0);\n\
      if (abortOnHit)\n\
       {\n\
         break;\n\
       }\n\
      gw-&gt;clearHitCode();\n\
     }\n\
   }\n\
   gw-&gt;setRndLimits(savedLimits);\n\
   return res;\n\
}</code></pre><p>If you are hit testing polygons they must be drawn as 3 sided entities for 3ds Max to properly hit test them. Polygons drawn with more than 3 sides will not hit test properly.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../hit_testing.html\">Hit Testing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";