var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"hit_testing_in_the_graphics_wind\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Hit Testing in the Graphics Windows</h1></div><p>Hit testing is performed in the graphics window (<code>GraphicsWindow</code>) using a side-effect mechanism. There is a special rendering mode (see <a href=\"./../graphics_window/rendering_modes_and_rendering_li.html\">Rendering Modes and Rendering Limits</a>) that performs hit testing. In this mode (called <code>GW_PICK</code>), the item is not actually drawn, but is instead tested for intersection with the specified hit region. When hit-testing is enabled, primitives set a flag if they pass through or are fully contained in the hit region. When in this mode, the primitives do not cause any visual side-effects -- in particular, they do not change the image or Z buffers If an item needs to be hit tested, a developer must simply draw the item using a rendering level <code>GW_PICK</code> and then check the result.</p>\n\
<p>By clearing the flag before a primitive is rendered, and checking it immediately afterwards, a hit-check for that particular primitive is made. Hit testing on vertices, edges, entire meshes, etc., can be accomplished by rendering only the desired primitives and checking the hit flag at the desired granularity.</p>\n\
<p>When the hit region is a single point, each &quot;hit&quot; primitive also sets a distance variable (representing distance from the hit point to the line in wire-frame mode, and Z distance in filled mode), so that &quot;smart&quot; hit testing -- i.e. choosing the closest primitive to the hit point -- may be implemented.</p>\n\
<p>The following methods are used for hit testing.</p>\n\
<ul>\n\
<li><code>GraphicsWindow::setHitRegion()</code> - Sets the hit region used for hit testing.</li>\n\
<li><code>GraphicsWindow::clearHitCode()</code> - This methods clears the hit code. Call this method before performing a hit test.</li>\n\
<li><code>GraphicsWindow::checkHitCode()</code> - Returns TRUE if a hit was made; otherwise FALSE.</li>\n\
<li><code>GraphicsWindow::getHitDistance()</code>- If <code>checkHitCode()</code> returns TRUE you may call this method to return the hit distance. In wire-frame mode this is the distance to the line. In shaded mode, this is the z distance. This allows you to perform &#39;smart&#39; hit testing by choosing the item with the smallest hit distance.</li>\n\
</ul>\n\
<p>Typically you use these methods in the following sequence:</p>\n\
<ol>\n\
<li>You set a hit regions using <code>GraphicsWindow::setHitRegion()</code>.</li>\n\
<li>You clear the hit code using <code>GraphicsWindow::clearHitCode()</code>.</li>\n\
<li>You &quot;render&quot; the primitive by setting the graphics mode <code>GW_PICK</code> (using <code>GraphicsWindow::setRndLimits()</code>) and at whatever level you want to check at. For example, if you are in interested in vertex hit testing, you would &quot;render&quot; a series of markers using a rendering mode that included <code>GW_PICK</code>. The <code>GW_PICK</code> mode will cause the system to perform hit testing rather than actually render the item.</li>\n\
<li>After each item is &quot;rendered&quot; you check to see if a hit was made using <code>GraphicsWindow::checkHitCode()</code>. If you are looking for just a single hit, you could abort as soon as the method returns TRUE. If you are interested in the closest hit, you loop through all the items calling <code>clearHitCode()</code>, <code>checkHitCode()</code>, and <code>getHitDistance()</code>. After checking all the items you simply choose the smallest hit distance from all the items you&#39;ve checked.</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../hit_testing.html\">Hit Testing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";