var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"node_level_hit_testing\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Node Level Hit Testing</h1></div><p>If a plug-in wants to perform hit testing of nodes in the scene it may use the following methods of the <code>Interface</code> class.</p>\n\
<ul>\n\
<li><code>Interface::PickNode()</code> - This method hit tests the screen position for nodes and returns a <code>INode</code> pointer if one is hit, NULL otherwise.</li>\n\
<li><code>Interface::SubObHitTest()</code> - This method performs a sub-object hit test. You may access the number of hits using: <code>ViewExp::NumSubObjHits()</code>. To return a list of the hits use <code>ViewExp::GetCtrlHitList()</code>.</li>\n\
</ul>\n\
<p>The following code demonstrates the use of this method:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">BOOL GenControlSelectionProcessor::HitTest(\n\
   ViewExp *vpt, IPoint2 *p, int type, int flags )\n\
{\n\
   vpt-&gt;ClearCtrlHitList();\n\
   ip-&gt;SubObHitTest(ip-&gt; GetTime(),type,ip-&gt;GetCrossing(),flags,p,vpt);\n\
   if (vpt-&gt;GetCtrlHitList().First())\n\
   {\n\
     return TRUE;\n\
   }\n\
   else\n\
   {\n\
     return FALSE;\n\
   }\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../hit_testing.html\">Hit Testing</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";