var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"about_renderitem\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>About RenderItem</h1></div><p>The basic element that Nitrous uses to display anything on the screen is <code>RenderItem</code>. The object plug-in must generate a list of <code>RenderItem</code>s according to the scene and viewport context. The object plug-ins usually do not need to hold references to these <code>RenderItem</code>s. Nitrous internally organizes the <code>RenderItem</code>s and manages their lifetime.</p>\n\
<p>Many render nodes can refer to a <code>RenderItem</code> simultaneously. The following figure shows a Nitrous scene graph example:</p>\n\
<p><img src=\"./images/GUID-AB4AA00E-552F-4A19-B652-C7F5E88022F9-low.png\" alt></p>\n\
<p>In Nitrous, the <code>RenderNode</code> has one-one mapping to max <code>INode</code>, while the object/modifier plug-in generates <code>RenderItem</code>s under the <code>RenderNode</code>.</p>\n\
<h2 id=\"-code-renderitem-code-types\"><code>RenderItem</code> Types</h2><p>All <code>RenderItem</code>s are exposed in the Nitrous SDK as <code>SmartHandle</code>s. The base class of all <code>RenderItem</code>s is <code>RenderItemHandle</code>. The following diagram shows the relationship between the <code>RenderItemHandle</code> classes:</p>\n\
<p><img src=\"./images/GUID-58976711-5AA5-41D0-966D-7DE380B049AC-low.png\" alt></p>\n\
<h2 id=\"visibility-group-of-code-renderitem-code-\">Visibility Group of <code>RenderItem</code></h2><p>The visibility group of a <code>RenderItem</code> can be one of the following values:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th>Value</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td><code>RenderItemVisible_Shaded</code></td>\n\
<td>The <code>RenderItem</code> is visible if the visual style is shaded, realistic, hidden line, flat, facet, and others.</td>\n\
</tr>\n\
<tr>\n\
<td><code>RenderItemVisible_Wireframe</code></td>\n\
<td>The <code>RenderItem</code> is visible in wireframe visual style. The edged faces are on or the display selected edged faces is on, and the node is selected.</td>\n\
</tr>\n\
<tr>\n\
<td><code>RenderItemVisible_Gizmo</code></td>\n\
<td>The <code>RenderItem</code> is always visible irrespective of the visual style. This is the default visibility group for all <code>RenderItem</code>. Any <code>RenderItem</code> in this group does not receive lights because this group is for gizmos.</td>\n\
</tr>\n\
</tbody></table>\n\
<p>The visibility group provides a basic visibility control. For more flexible visibility control, the plug-in can use <code>IObjectDisplay2::UpdatePerNodeItems()</code> and <code>IObjectDisplay2::UpdatePerViewItems()</code>.</p>\n\
<h2 id=\"getting-code-renderitems-code-from-code-mesh-code-and-code-mnmesh-code-\">Getting <code>RenderItems</code> from <code>Mesh</code> and <code>MNMesh</code></h2><p>A lot of plug-ins use <code>Mesh</code> or <code>MNMesh</code> to store the display data. The Nitrous SDK allows plug-ins to quickly get render items from a <code>Mesh</code> or <code>MNMesh</code> and display them.</p>\n\
<p>To get <code>GeometryRenderItemHandle</code>, you need to do the following:</p>\n\
<ol>\n\
<li>Get the <code>IMeshDisplay2</code> interface from the <code>Mesh</code> or <code>MNMesh</code> instance.</li>\n\
<li>Call <code>IMeshDisplay2::PrepareDisplay()</code>, which is usually called in the plug-in&apos;s <code>PrepareDisplay()</code> function.</li>\n\
<li>Use <code>IMeshDisplay2::GetRenderItems()</code> in the plug-in&apos;s <code>UpdatePerNodeItems()</code> or <code>UpdatePerViewItems()</code> function.</li>\n\
</ol>\n\
<h3 id=\"mesh-elements\">Mesh Elements</h3><p>Elements in <code>Mesh</code> and <code>MNMesh</code> include the following:</p>\n\
<ul>\n\
<li>Solid mesh</li>\n\
<li>Selected face</li>\n\
<li>Vertex ticks</li>\n\
<li>Wireframe</li>\n\
<li>Selected edge</li>\n\
<li>Diagonal</li>\n\
<li>Selected Diagonal</li>\n\
<li>Wireframe with soft selection color</li>\n\
<li>Backface culled wireframe</li>\n\
</ul>\n\
<p>The typical elements of a <code>Mesh</code> and <code>MNMesh</code> are show in the following figure:</p>\n\
<p><img src=\"./images/GUID-F5166A7E-5310-4358-A78A-AA26463F1F3E-low.png\" alt></p>\n\
<p>The Nitrous SDK allows plug-ins to get the specified element easily. Each element is represented as a render item.</p>\n\
<h3 id=\"-code-imeshdisplay2-code-\"><code>IMeshDisplay2</code></h3><p>The <code>IMeshDisplay2</code> interface can be used to obtain the render items from a <code>Mesh</code> and <code>MNMesh</code>. It is easy to get the <code>IMeshDisplay2</code> interface from a <code>Mesh</code> or <code>MNMesh</code> instance as shown in the following example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IMeshDisplay2* pMeshDisplay = NULL;\n\
pMeshDisplay = static_cast&lt;IMeshDisplay2*&gt;(mesh.GetInterface(IMesh_DISPLAY2_INTERFACE_ID));</code></pre><p>The <code>IMeshDisplay2</code> interface is defined as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class IMeshDisplay2:public BaseInterface\n\
{\n\
    virtual void PrepareDisplay(\n\
        const GenerateMeshRenderItemsContext&amp; renderItemContext) = 0;\n\
    virtual bool GetRenderItems(\n\
        const GenerateMeshRenderItemsContext&amp; renderItemContext,\n\
        UpdateNodeContext&amp; nodeContext,\n\
        IRenderItemContainer&amp; targetRenderItemContainer) = 0;\n\
};</code></pre><p>The two functions must be called in strict order. The <code>IMeshDisplay2::PrepareDisplay()</code> is for initializing the internal render item builder with a element list. After the render item builder is initialized, the plug-ins can call <code>IMeshDisplay2::GetRenderItems()</code> multiple times to get the render items that are prepared. Plug-ins must make sure that the <code>renderItemContext</code> passed to <code>GetRenderItems()</code> equals or is a subset of the <code>renderItemContext</code> passed to <code>PrepareDisplay()</code>.</p>\n\
<p>Usually,<code>IMeshDisplay2::PrepareDisplay()</code> is called in <code>Object::PrepareDisplay()</code>, and <code>IMeshDisplay2::GetRenderItems()</code> is called in <code>Object::UpdatePerNodeItems()</code> or <code>Object::UpdatePerViewItems()</code>. However, you can call these functions in other places.</p>\n\
<h3 id=\"-code-generatemeshrenderitemscontext-code-\"><code>GenerateMeshRenderItemsContext</code></h3><p>Both functions of <code>IMeshDisplay2</code> require a <code>renderItemContext</code> input. This parameter defines the required mesh element list and their vertex buffer format. Usually, an object/modifier plug-in can use the default mesh render item context to make the mesh display exactly the same as a standard object (respond to visual style, respond to node properties, and others). The following code shows how to create the default <code>GenerateMeshRenderItemContext</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GenerateMeshRenderItemsContext renderItemContext;\n\
renderItemContext.GenerateDefaultContext(displayContext);</code></pre><p>You can create your own<code>GenerateMeshRenderItemContext</code> to get certain render items from the mesh. For example, you might only want to get the backface culled vertex tick of the mesh, and then you can just specify the vertex tick element.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GenerateMeshRenderItemsContext renderItemContext;\n\
MeshElementDescription elementDescription;\n\
\n\
elementDescription = GetBuiltInMeshElementDescription(ElementDescriptionVetexTicks);\n\
elementDescription.SetBackfaceCull(true);\n\
renderItemContext.AddMeshElementDescription(elementDescription);</code></pre><h2 id=\"customize-code-renderitems-code-\">Customize <code>RenderItems</code></h2><h3 id=\"-code-geometryrenderitemhandle-code-\"><code>GeometryRenderItemHandle</code></h3><p>The <code>GeometryRenderItemHandle</code> is a commonly used <code>RenderItem</code> type. It contains two parts: the display properties and actual geometry. The display properties include the following:</p>\n\
<ul>\n\
<li>World matrix - By default, the owner node&apos;s world matrix is used. Usually, a plug-in does not need to specify the world matrix for a <code>GeometryRenderItemHandle</code>. However, if this value is specified, the <code>GeometryRenderItemHandle</code> uses the specified world matrix regardless of the owner node&apos;s matrix.</li>\n\
<li>Material - By default, the owner node&apos;s material is used. Usually, a plug-in does not need to specify the material for a <code>GeometryRenderItemHandle</code>. However if this value is specified, the <code>GeometryRenderItemHandle</code> uses the specified material regardless of the node material.</li>\n\
</ul>\n\
<p>The geometry contains a set of buffers. It controls how these buffers are drawn. For example, if a plug-in needs to display triangles, it can create a <code>PrimitiveListGeometry</code> instance to store the triangle data. The following example code shows the implementation of <code>PrimitiveListGeometry</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class PrimitiveListGeometry:public IRenderGeometry\n\
{\n\
public:\n\
    // From IRenderGeometry\n\
    virtual void Display(\n\
        DrawContext&amp; dc,\n\
        int start,\n\
        int count,\n\
        int lod)\n\
    {\n\
        IVirtualDevice&amp; vd = *dc.GetVirtualDevice();\n\
        vd.SetStreamFormat(mStreamFormat);\n\
        vd.SetVertexStreams(mVertexBufferArray);\n\
        if (mIndexBuffer.IsValid())\n\
        {\n\
            vd.SetIndexBuffer(&amp;mIndexBuffer);\n\
        }\n\
        else\n\
        {\n\
            vd.SetIndexBuffer(nullptr);\n\
        }\n\
        vd.Draw(mPrimType, start, count);\n\
    }\n\
\n\
    virtual PrimitiveType GetPrimitiveType()\n\
    {\n\
        return mPrimType;\n\
    }\n\
\n\
    virtual size_t GetVertexCount()\n\
    {\n\
        if (mVertexBufferArray.length() &gt; 0)\n\
        {\n\
            return mVertexBufferArray[0].GetNumberOfVertices();\n\
        }\n\
        else\n\
        {\n\
            return 0;\n\
        }\n\
    }\n\
    // Other functions\n\
\n\
private:\n\
    VertexBufferHandleArray mVertexBufferArray;\n\
    IndexBufferHandle mIndexBuffer;\n\
    PrimitiveType mPrimType;\n\
    MaterialRequiredStreams mStreamFormat;\n\
    size_t mPrimitiveCount;\n\
};</code></pre><p>The plug-in must make sure that the geometry has consistent format with the material. Otherwise, if the geometry has inconsistent vertex buffer format compared to the material stream requirement, the geometry is not displayed in the viewport.</p>\n\
<h3 id=\"-code-customrenderitemhandle-code-\"><code>CustomRenderItemHandle</code></h3><p>If a plug-in wants to use a low-level device API to better control the display process, the plug-in needs to initialize and provide its own <code>CustomRenderItemHandle</code>. The following code shows the <code>CustomRenderItemHandle</code> declaration:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class CustomRenderItemHandle:public RenderItemHandle\n\
{\n\
public:\n\
    virtual void SetCustomImplementation(ICustomRenderItem* impl) = 0;\n\
    virtual ICustomRenderItem* GetCustomImplementation() = 0;\n\
};</code></pre><p>The <code>CustomRenderItemHandle</code> is just a container. The actual display code is provided by <code>ICustomRenderItem</code>. Plug-ins need to create <code>ICustomRenderItem</code> and set the pointer to a valid <code>CustomRenderItemHandle</code>. The following code shows the interface declaration of <code>ICustomRenderItem</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class ICustomRenderItem:public ARefObject, public BaseInterfaceServer\n\
{\n\
public:\n\
    virtual void Realize(DrawContext&amp; dc) = 0;\n\
    virtual void Display(DrawContext&amp; dc) = 0;\n\
};</code></pre><p>In <code>ICustomRenderItem::Realize()</code> function, the plug-in must build customized display data. In <code>ICustomRenderItem::Display()</code> function, the plug-in must use the pre-built display data to draw. The <code>ICustomRenderItem::Realize()</code> function is provided because the render item might be realized once, but displayed multiple times (for example, shadow map pass). In the <code>ICustomRenderItem::Realize()</code> function, the plug-ins must cache and try to reuse the display data whenever possible.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> Nitrous might be running in a separate thread, and it is important for plug-ins to implement their <code>ICustomRenderItem</code> as self-independent. It must not have any dependency on the object plug-in or other outside resources.</p>\n\
\n\
</div></div>\n\
\n\
<p>The following example shows a typical <code>Display()</code> function.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class SampleItemDX9 : public ICustomRenderItem\n\
{\n\
    ...\n\
};\n\
void SampleItemDX9::Display(DrawContext&amp; dc)\n\
{\n\
    IVirtualDevice&amp; vd = drawContext.GetVirtualDevice();\n\
    BaseMaterialHandle&amp; material = const_cast&lt;BaseMaterialHandle&amp;&gt;(drawContext.GetMaterial()); //Use draw context\\&apos;s material\n\
    vd.SetStreamFormat(const_cast&lt;MaterialRequiredStreams&amp;&gt;(*material.GetRequiredStreams()));\n\
    vd.SetVertexStreams(mVertexBuffer);\n\
    vd.SetIndexBuffer(&amp;mIndexBuffer);\n\
\n\
    material.Activate(drawContext);\n\
    unsigned int passCount = material.GetPassCount(drawContext);\n\
    for (int pass = 0; pass &lt; passCount; ++pass) //Loop through all passes\n\
    {\n\
        material.ActivatePass(drawContext, pass);\n\
        vd.Draw(PrimitiveTriangleList, 0, (int)mPrimitiveCount);\n\
    }\n\
    material.Terminate(drawContext);\n\
}</code></pre><p>To create and add the custom render item handle, you must first create the instance of the item. Therefore, the <code>PrepareDisplay()</code> function might be as shown in the following example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bool CustomPlugin::PrepareDisplay(\n\
      const MaxSDK::Graphics::UpdateDisplayContext&amp; displayContext)\n\
{\n\
      if (nullptr == mpSampleItem)\n\
      {\n\
           MaxSDK::Graphics::DeviceCaps caps;\n\
           GetIDisplayManager2()-&gt;GetDeviceCaps(caps);\n\
           if (caps.FeatureLevel != Level5_0)\n\
           {\n\
               mpSampleItem = new SampleItemDX9;\n\
           }\n\
           else\n\
           {\n\
               mpSampleItem = new SampleItemDX11;\n\
           }        \n\
      }\n\
}</code></pre><p>After creating the custom render item instance, you can use a <code>CustomRenderItemHandle</code> to wrap it and add it to the render pipeline. This is typically done in the <code>UpdatePerNodeItems()</code> function.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">bool CustomPlugin::UpdatePerNodeItems(\n\
      const UpdateDisplayContext&amp; updateDisplayContext,\n\
      UpdateNodeContext&amp; nodeContext,\n\
      IRenderItemContainer&amp; targetRenderItemContainer)\n\
{\n\
      CustomRenderItemHandle newHandle;\n\
      newHandle.Initialize();\n\
      //VisibilityGroup can be shaded or gizmo. By putting to shaded group,\n\
      //the render item can take benefit from multipass effects like DOF.\n\
      //Gizmo group is rendered in each viewport.\n\
      newHandle.SetVisibilityGroup(RenderItemVisible_Gizmo);\n\
      newHandle.SetCustomImplementation(mpSampleItem.GetPointer());\n\
      targetRenderItemContainer.AddRenderItem(newHandle);\n\
      return true;\n\
}</code></pre><h3 id=\"-code-drawcontext-code-\"><code>DrawContext</code></h3><p>When implementing the <code>ICustomRenderItem::Realize()</code> or<code>ICustomRenderItem::Display()</code> function, plug-ins might follow the draw context. The following figure shows what a draw context is:</p>\n\
<p><img src=\"./images/GUID-F71F3C9F-5AE6-4A43-823E-42EC7F20D2EB-low.png\" alt></p>\n\
<h3 id=\"-code-renderitemhandledecorator-code-\"><code>RenderItemHandleDecorator</code></h3><p>At times if you are not satisfied with the render item generated by the mesh or other objects, the <code>RenderItemHandleDecorator</code> can help replace the display properties (matrix, material) of another <code>GeometryRenderItemHandle</code> without modifying the original render item. This is especially useful when you want to customize the display of an object that the plug-in references, but you do not have the source code of the object.</p>\n\
<p>The following figure shows how <code>RenderItemHandleDecorator</code> works:</p>\n\
<p><img src=\"./images/GUID-5F95C87B-22EA-4227-BFD4-10E2199EC2B7-low.png\" alt></p>\n\
<p>Following is an example that shows the use of <code>RenderItemHandleDecorator</code>. A <code>BoolObject</code> might refer to two sub-objects and it wants to display both the sub-objects correctly.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class BoolObject : \n\
      public GeomObject, \n\
      public IObjectDisplay2\n\
{\n\
      ...\n\
      Mesh mMesh;\n\
      Tab&lt;IObjectDisplay*&gt; mSubObjectDisplays;\n\
      Tab&lt;IObjectDisplay2*&gt; mSubObject2Displays;\n\
};\n\
\n\
BaseInterface* BoolObject::GetInterface(Interface_ID id)\n\
{\n\
      // Remember to expose IOBJECT_DISPLAY2_INTERFACE_ID for \n\
      // the BoolObject that helps Nitrous determine if the plug-in \n\
      // is ported using IOjbectDisplay2\n\
      if (id == IOBJECT_DISPLAY2_INTERFACE_ID)\n\
      {\n\
          return static_cast&lt;IObjectDisplay2*&gt;(this);\n\
      }\n\
      return IBoolObject::GetInterface(id);\n\
}\n\
\n\
unsigned long BoolObject::GetObjectDisplayRequirement() const\n\
{\n\
      using namespace MaxSDK::Graphics;\n\
      unsigned long requirement = ObjectDisplayRequireLegacyDisplayMode;\n\
      if (!GetDisplayResult())\n\
      {\n\
          // Because updating render items on per view basis \n\
          // is very time consuming, so please append the \n\
          // ObjectDisplayRequireUpdatePerViewItems requirement\n\
          // when you really need to add per view items.\n\
          requirement |= ObjectDisplayRequireUpdatePerViewItems;\n\
      }\n\
\n\
      return requirement;\n\
}\n\
\n\
bool BoolObject::PrepareDisplay(\n\
      const UpdateDisplayContext&amp; prepareDisplayContext)\n\
{\n\
      TimeValue t = prepareDisplayContext.GetDisplayTime();\n\
      RenderItemHandleArray tempRenderItemArray;\n\
      IObjectDisplay* pObjDisplay = NULL;\n\
\n\
      mRenderItemHandles.ClearAllRenderItems();\n\
      mSubObjectDisplays.SetCount(0);\n\
      mSubObject2Displays.SetCount(0);\n\
\n\
      if (GetDisplayResult()) {\n\
          UpdateMesh(t,true);  \n\
          IMeshDisplay2* pMeshDisplay = static_cast&lt;IMeshDisplay2*&gt;(mMesh.GetInterface(IMesh_DISPLAY2_INTERFACE_ID));\n\
          if (NULL == pMeshDisplay)\n\
          {\n\
              return false;\n\
          }\n\
          GenerateMeshRenderItemsContext itemContext;\n\
          itemContext.GenerateDefaultContext(prepareDisplayContext);\n\
          pMeshDisplay-&gt;PrepareDisplay(itemContext);\n\
\n\
          return true;\n\
      } \n\
      // display the two sub-objects\n\
      // Note : Currently there are still some plug-ins not yet ported \n\
      // using IObjectDisplay2. So, check if \n\
      // IObjectDisplay is exposed from the operand of this bool \n\
      // object and then call IObjectDisplay::UpdateDisplay \n\
      // accordingly.\n\
\n\
      for (int i = 0; i &lt; 2; i++) \n\
      {\n\
          IObjectDisplay *pObjDisplay = NULL;\n\
          IObjectDisplay2 *pObjDisplay2 = NULL;\n\
          Object *pObject = GetPipeObj(t,i);\n\
          if (NULL != pObject)\n\
          {\n\
              pObjDisplay2 = static_cast&lt;IObjectDisplay2*&gt;(pObject-&gt;GetInterface(IOBJECT_DISPLAY2_INTERFACE_ID));\n\
              if (NULL != pObjDisplay2)\n\
              {\n\
                  pObjDisplay2-&gt;PrepareDisplay(prepareDisplayContext);\n\
              }\n\
              else\n\
              {\n\
                  pObjDisplay = static_cast&lt;IObjectDisplay*&gt;(pObject-&gt;GetInterface(IOBJECT_DISPLAY_INTERFACE_ID));\n\
                  if (NULL != pObjDisplay)\n\
                  {\n\
                      pObjDisplay-&gt;UpdateDisplay(prepareDisplayContext);\n\
                  }\n\
              }\n\
          }\n\
          mSubObjectDisplays.Append(1,&amp;pObjDisplay);\n\
          mSubObject2Displays.Append(1,&amp;pObjDisplay2);\n\
      }\n\
\n\
      return true;\n\
}\n\
\n\
void BoolObject::PopulateSubObjectRenderItems(\n\
      const Matrix3&amp; renderItemMatrix,\n\
      const IRenderItemContainer&amp; sourceItems,\n\
      IRenderItemContainer&amp; targetItems)\n\
{\n\
      // Using RenderItemHandleDecorator to decorate the render \n\
      // items of the sub-object if we need to customize the \n\
      // behavior of those render items. In this sample, we \n\
      // need RenderItemHandleDecorator for two reasons:\n\
      // 1. When choosing the &apos;Operands&apos; option in the \n\
      //    &apos;Display&apos; panel, we need to customize the position \n\
      //    of render items of operands.\n\
      // 2. When choosing the &apos;Billboard Operands&apos; option in \n\
      //    the &apos;Display&apos; panel, we need to customize the \n\
      //    rotation of those render items of operands to \n\
      //    align with the view camera.\n\
      for (size_t i = 0; i &lt; sourceItems.GetNumberOfRenderItems(); ++i)\n\
      {\n\
          RenderItemHandleDecorator hRenderItemDecorator;\n\
          if (hRenderItemDecorator.Initialize(sourceItems.GetRenderItem(i)))\n\
          {\n\
              Matrix44 offsetMatrix;\n\
              MaxWorldMatrixToMatrix44(offsetMatrix,renderItemMatrix);\n\
              hRenderItemDecorator.SetOffsetMatrix(offsetMatrix);\n\
              targetItems.AddRenderItem(hRenderItemDecorator);\n\
          }\n\
      }\n\
}\n\
\n\
void BoolObject::AddSubObjectRenderItems(\n\
      int subObjectindex,\n\
      const Matrix3&amp; subObjectOffsetMatrix,\n\
      const UpdateDisplayContext&amp; updateDisplayContext,\n\
      UpdateNodeContext&amp; nodeContext,\n\
      IRenderItemContainer&amp; targetItems)\n\
{\n\
      using namespace MaxSDK::Graphics;\n\
      if (NULL != mSubObjectDisplays[subObjectindex])\n\
      {\n\
          RenderItemHandleArray renderItems;\n\
          // For IObjectDisplay instance, we still call \n\
          // IObjectDisplay::AddRenderItems() to add render \n\
          // items according to the properties of the current node\n\
          mSubObjectDisplays[subObjectindex]-&gt;AddRenderItems(nodeContext.GetRenderNode(),renderItems);\n\
          PopulateSubObjectRenderItems(subObjectOffsetMatrix, renderItems, targetItems);\n\
      }\n\
      if (NULL != mSubObject2Displays[subObjectindex])\n\
      {\n\
          RenderItemHandleArray renderItems;\n\
          mSubObject2Displays[subObjectindex]-&gt;UpdatePerNodeItems(updateDisplayContext, nodeContext, renderItems);\n\
          PopulateSubObjectRenderItems(subObjectOffsetMatrix, renderItems, targetItems);\n\
      }\n\
}\n\
\n\
bool BoolObject::UpdatePerNodeItems(\n\
      const UpdateDisplayContext&amp; updateDisplayContext,\n\
      UpdateNodeContext&amp; nodeContext,\n\
      IRenderItemContainer&amp; targetItems)\n\
{\n\
      using namespace MaxSDK::Graphics;\n\
\n\
      RenderNodeHandle&amp; hRenderNode = nodeContext.GetRenderNode();\n\
      if (GetDisplayResult()) \n\
      {  \n\
          IMeshDisplay2* pMeshDisplay = static_cast&lt;IMeshDisplay2*&gt;(mMesh.GetInterface(IMesh_DISPLAY2_INTERFACE_ID));\n\
          if (NULL == pMeshDisplay)\n\
          {\n\
              return false;\n\
          }\n\
          GenerateMeshRenderItemsContext itemContext;\n\
          itemContext.GenerateDefaultContext(updateDisplayContext);\n\
          // If you are not sure whether any mMesh element is not \n\
          // required for the current node, feel free to call \n\
          // GenerateMeshRenderItemsContext::\n\
          //     RemoveInvisibleMeshElementDescriptions()\n\
          // that will help you remove unwanted render items \n\
          // for hRenderNode.\n\
          itemContext.RemoveInvisibleMeshElementDescriptions(hRenderNode);\n\
          pMeshDisplay-&gt;GetRenderItems(itemContext,nodeContext,targetItems);\n\
      }\n\
      else if (TestFlag(BOOL_DISP_OPS))\n\
      {\n\
          TimeValue t = updateDisplayContext.GetDisplayTime();\n\
          for (int i = 0; i &lt; mSubObjectDisplays.Count(); ++i)\n\
          {\n\
          AddSubObjectRenderItems(i, GetOpTM(t,i), updateDisplayContext, nodeContext, targetItems);\n\
          }\n\
      }\n\
\n\
      return true;\n\
}\n\
\n\
bool BoolObject::UpdatePerViewItems(\n\
      const UpdateDisplayContext&amp; updateDisplayContext,\n\
      UpdateNodeContext&amp; nodeContext,\n\
      UpdateViewContext&amp; viewContext,\n\
      IRenderItemContainer&amp; targetItems)\n\
{\n\
      using namespace MaxSDK::Graphics;\n\
      if (GetDisplayResult())\n\
      {\n\
          return false;\n\
      }\n\
\n\
      bool bResult = false;\n\
      TimeValue t = updateDisplayContext.GetDisplayTime();\n\
      // To display Billborad operands\n\
      if (TestFlag(BOOL_DISP_BILLBOARD_OPS))\n\
      {\n\
          Matrix3 viewMatrix;\n\
          viewContext.GetView()-&gt;GetAffineTM(viewMatrix);\n\
          Matrix3 inverseViewMatrix = Inverse(viewMatrix);\n\
          for (int i = 0; i &lt; mSubObjectDisplays.Count(); ++i)\n\
          { \n\
              // Assign view-dependent offset matrix to the \n\
              // render items of operands\n\
              inverseViewMatrix.SetTrans(GetOpTM(t,i).GetTrans());\n\
              AddSubObjectRenderItems(i, inverseViewMatrix, updateDisplayContext, nodeContext, targetItems);\n\
              bResult = true;\n\
          }\n\
      }\n\
\n\
      for (int i = 0; i &lt; mSubObject2Displays.Count(); ++i)\n\
      {\n\
          RenderItemHandleArray renderItems;\n\
          IObjectDisplay2* pObjectDisplay2 = mSubObject2Displays[i];\n\
          // For operands exposing IObjectDisplay2, we have to \n\
          // check if they require updating their render items \n\
          // on per-view basis and call IObjectDisplay2::\n\
          // UpdatePerViewItems() accordingly.\n\
          if (NULL != pObjectDisplay2 &amp;&amp;\n\
              (pObjectDisplay2-&gt;GetObjectDisplayRequirement() &amp; \n\
              ObjectDisplayRequireUpdatePerViewItems) &amp;&amp;\n\
              pObjectDisplay2-&gt;UpdatePerViewItems(updateDisplayContext, nodeContext, viewContext, renderItems))\n\
          {\n\
              bResult = true;\n\
              PopulateSubObjectRenderItems(\n\
              GetOpTM(t,i),\n\
              renderItems,\n\
              targetItems);\n\
          }\n\
      }\n\
      return bResult;\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../nitrous.html\">Nitrous</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";