var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"implementing_advanced_material_a\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Implementing Advanced Material and Texture Map Plug-ins with Nitrous</h1></div><h2 id=\"advanced-material-and-texture-map-display-api\">Advanced Material and Texture Map Display API</h2>\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> MetaSL is no longer supported in 3ds Max 2016. You can use HLSL shaders instead.</p>\n\
\n\
</div></div>\n\
\n\
<h2 id=\"use-hlsl-to-customize-the-viewport-display-in-realistic-mode\">Use HLSL to Customize the Viewport Display in Realistic Mode</h2><p>Materials can use programmable shaders to describe their appearance when displayed in the Nitrous viewport and rendered with Quicksilver. 3ds Max 2014 supports HLSL shader. This enables the material plug-ins to use a DirectX effect to control how the material displays when <strong>Show realistic material in viewport</strong> (for this material) is selected.</p>\n\
<h2 id=\"ihlslmaterialtranslator\">IHLSLMaterialTranslator</h2><p><code>IHLSLMaterialTranslator</code> provides a chance in its <code>UpdateHLSLMaterial()</code> to update the parameters of <code>HLSLMaterialHandle</code>, such as parameter values and map channel values. See <code>HLSLMaterialHandle</code> for more details. Plug-ins derive from <code>IHLSLMaterialTranslator</code>. They rather need to create instances of <code>HLSLMaterialHandle</code>. 3ds Max queries the plug-in for its <code>IHLSLMaterialTranslator</code> through a request for the interface identified by <code>IHLSL_MATERIAL_TRANSLATOR_INTERFACE_ID</code>. Then, gets <code>HLSLMaterialHandle</code> using <code>GetHLSLMaterialHandle()</code> of <code>IHLSLMaterialTranslator</code>. Typically, a plug-in implements <code>GetHLSLMaterialHandle()</code> of <code>IHLSLMaterialTranslator</code> in response to this request, and its override of <code>Animatable::GetInterface(Interface_ID)</code> for <code>IHLSLMaterialTranslator</code>.</p>\n\
<p>The following code snippet shows how a material plug-in might implement <code>IHLSLMaterialTranslator</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#include &lt;./graphics/IHLSLMaterialTranslator.h&gt;\n\
\n\
// A material plug-in has HLSLMaterialHandle and needs to update HLSLMaterial parameters.\n\
class MyMtlPlugin : public MtlBase, public MaxSDK::Graphics::IHLSLMaterialTranslator {\n\
    // omitted for brevity\n\
private:\n\
    HLSLMaterialHandle mHLSLMaterialHandle;\n\
public:\n\
    virtual bool UpdateHLSLMaterial(\n\
        const TimeValue t, \n\
        GraphicFeatureLevel featureLevel)\n\
    {\n\
        mHLSLMaterialHandle.SetFloatParameter(\n\
            _M(&quot;myFloatShaderParam&quot;),\n\
            floatValue);\n\
        mHLSLMaterialHandle.SetIntParameter(\n\
            _M(&quot;myIntShaderParam&quot;), \n\
            intValue);\n\
        return true;\n\
    }\n\
\n\
    virtual const HLSLMaterialHandle&amp; GetHLSLMaterialHandle(\n\
        GraphicFeatureLevel featureLevel)\n\
    {\n\
        return mHLSLMaterialHandle;\n\
    }\n\
\n\
    BaseInterface* GetInterface(Interface_ID iid)\n\
    {\n\
\n\
        if (IHLSL_MATERIAL_TRANSLATOR_INTERFACE_ID == iid)\n\
            return static_cast&lt;IHLSLMaterialTranslator*&gt;(this);\n\
        else\n\
            return MtlBase::GetInterface(iid);\n\
    }\n\
}</code></pre><h2 id></h2><h2 id=\"hlslmaterialhandle\">HLSLMaterialHandle</h2><p><code>HLSLMaterialHandle</code> is a class to support HLSL custom material. This class is used for viewport display and Quicksilver. It is used by <code>RenderItemHandle::SetCustomMaterial()</code> to describe HLSL custom material. It can also be used for realistic material display. See <code>IHLSLMaterialTranslator</code> for more information.</p>\n\
<p>The following code snippet shows how to use <code>HLSLMaterialHandle</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">HLSLMaterialHandle hMaterial;\n\
hMaterial.Initialize(shaderFileName);\n\
hMaterial.SetFloatParameter(_M(&quot;myFloatShaderParam&quot;), floatValue);</code></pre><h2 id=\"transparency-hints\">Transparency Hints</h2><p>The Nitrous viewport display system and the Quicksilver renderer optimize the display lists to work with transparency. A new <code>MtlBase::GetTransparencyHint()</code> method is used to get a boolean value that indicates whether transparency is supported at a certain time (a transparency &quot;hint&quot;), and to provide the validity interval for it. The validity of this hint is checked by 3ds Max in each frame.</p>\n\
<p>Once it becomes invalid,<code>MtlBase::GetTransparencyHint()</code> is called again. By default, this method returns <em>TRUE</em>. If the material does not support transparency in any form, then the plug-in&apos;s override of this method must return <em>FALSE</em>. This is particularly important for custom materials that use shading languages. Only the shader or the host material knows what is happening internally and whether transparency is affected. Supporting this method helps optimize their drawing and rendering.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../nitrous.html\">Nitrous</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";