var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"directory_structure\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Directory Structure</h1></div><p>You can download and install the SDK from <a href=\"https://www.autodesk.com/developer-network/platform-technologies/3ds-max#3dsmax-sdk\" target=\"_blank\">this location</a>. By default, the SDK is installed in the  <em>3ds Max YYYY SDK</em>  folder, which is located alongside the  <em>3ds Max YYYY</em>  installation folder (where <em>YYYY</em> is the release number). The  <em>3ds Max YYYY SDK</em>  folder contains the following:</p>\n\
<p><em>\\help</em>\n\
:  This folder contains the  <em>gencid.exe</em>  file, which is a program that generates a random Class ID for your plug-in. See the topic about Generating Class IDs for more information.</p>\n\
<p><em>\\howto</em>\n\
:  This folder contains the explanatory sample code for the 3ds Max plug-ins. Each sample plug-in consists of a Visual Studio project and all of its code. These sample plug-ins are helpful for getting started because they are smaller and easier to understand than the sample plug-ins in the  <em>\\samples</em>  folder.\n\
    It also contains the 3dsMaxPluginWizard, a Visual Studio wizard which helps to create new 3ds Max plugin projects.</p>\n\
<p><em>\\include</em>\n\
:  This folder contains the header files for the core of 3ds Max, as well as separate folders for the following 3ds Max plug-in systems:</p>\n\
<ul>\n\
<li><em>\\AssetManagement</em>  - Asset management classes</li>\n\
<li><em>\\ATS</em>  - Asset tracking system headers</li>\n\
<li><em>\\CATAPI</em> - Character Animation Toolkit (CAT) classes</li>\n\
<li><em>\\containers</em>  - Container class declarations</li>\n\
<li><em>\\CS</em>  - Character studio</li>\n\
<li><em>\\CustomFileStreamAPI</em> - Custom File Stream API for OLE Structured Storage</li>\n\
<li><em>\\DaylightSimulation</em>  - Daylight simulation system</li>\n\
<li><em>\\geom</em> - 3d math library, containing classes such as points, matrices, helper geometry data structures, bounding boxes and accompanying algorithms.  It also contains useful math operations, such as mesh triangulation.</li>\n\
<li><em>\\Graphics</em>  - APIs for using the Nitrous viewport display mode and the Quicksilver renderer</li>\n\
<li><em>\\IGame</em>  - 3ds Max data exchange interface</li>\n\
<li><em>\\ManagedServices</em>  - Headers for performing string conversion in C++/CLI</li>\n\
<li><em>\\Materials</em>  - Headers for material-related APIs</li>\n\
<li><em>\\maxscript</em>  - MAXScript SDK and implementation files</li>\n\
<li><em>\\network</em>  - Network rendering related headers</li>\n\
<li><em>\\NotificationAPI</em> - Headers for working with the Notification API (mainly for interactive rendering)</li>\n\
<li><em>\\ParticleFlow</em>  - Particle flow system headers</li>\n\
<li><em>\\PluginPackageManager</em> - Headers for working with the Plug-in Package system</li>\n\
<li><em>\\PointCloud</em>  - Point Cloud headers</li>\n\
<li><em>\\Populate</em>  - Populate system headers</li>\n\
<li><em>\\Qt</em>  - 3ds Max Qt integration</li>\n\
<li><em>\\Rendering</em>  - Old rendering API</li>\n\
<li><em>\\RenderingAPI</em>  - New rendering API</li>\n\
<li><em>\\Scene</em>  - Physical camera headers</li>\n\
<li><em>\\SkinEngine</em> - Framework and accompanying library for skin modifiers. It is used by skin, skinwrap, bonesdef, etc. </li>\n\
<li><em>\\Util</em>  - Utility headers that are part of  <em>maxutil.lib</em> </li>\n\
<li><em>\\XRef</em>  - xref system related headers</li>\n\
</ul>\n\
<p><em>\\ProjectSettings</em>\n\
:  This folder contains the compiler and linker settings in the form of property sheets.</p>\n\
<p><em>\\samples</em>\n\
:  This folder contains the complete code for some of the 3ds Max standard plug-ins and the corresponding Visual Studio project file for each plug-in.</p>\n\
<p><em>\\plugin</em>\n\
:  The plug-ins in the  <em>\\howto</em>  folder put their 64-bit binaries after compilation and linking in this folder.</p>\n\
<p><em>\\pdb</em>\n\
:  The symbols are generated to this folder.</p>\n\
<p><em>\\lib</em>\n\
:  This folder contains the library files (.LIB) needed for the 64-bit plug-ins.</p>\n\
<p><em>\\tools</em>\n\
:  This folder contains a tool that extracts resources into a  <em>.mui</em>  file (related to language pack ) automatically. This tool is invoked when third party plug-ins use 3ds Max property sheets.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../about_the_3ds_max_sdk.html\">About the 3ds Max SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";