var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"material_and_texture_map_plug-in\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Material and Texture Map Plug-ins</h1></div><h2 id=\"color-modifier-texture-maps\">Color Modifier Texture Maps</h2><p>Color Modifier maps alter the colors of pixels in a material. A color modifier derives from <code>MultiTex</code>.</p>\n\
<ul>\n\
<li><p>RGB Tint - <em>\\samples\\materials\\tint.cpp</em></p>\n\
<p>The RGB tint material adjusts the value of the three color channels in an image, allowing them to be changed to arbitrary colors.</p>\n\
</li>\n\
<li><p>Color Correction - <em>\\samples\\materials\\color_correction.cpp</em></p>\n\
<p>The Color Correction map provides an assortment of tools for modifying the colors of an incorporated, underlying map, using a stack-based method. Tools for correcting color include monochrome, inversion, custom rewiring of color channels, hue shift, and adjustment of saturation and lightness.</p>\n\
</li>\n\
<li><p>Output Map - <em>\\samples\\materials\\output.cpp</em></p>\n\
<p>Applies output settings to procedural maps, such as Checker or Marble, that don&#39;t have these settings.</p>\n\
</li>\n\
<li><p>Vertex Color Map - <em>\\samples\\materials\\vertcol.cpp</em></p>\n\
<p>Vertex Color map makes any vertex coloring applied to an object available for rendering. You can assign vertex colors using the VertexPaint Modifier, the Assign Vertex Colors utility, or the vertex controls for an editable mesh, editable patch, or editable poly.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"compositor-texture-maps\">Compositor Texture Maps</h2><p>Compositor texture maps combine other maps, and derive from <code>Texmap</code>.</p>\n\
<ul>\n\
<li><p>Mask - <em>\\maxsdk\\samples\\materials\\mask.cpp</em></p>\n\
<p>With the Mask map, you can view one material through another on the surface. The mask controls where a second map is applied to the surface.</p>\n\
</li>\n\
<li><p>Mix - <em>\\maxsdk\\samples\\materials\\mix.cpp</em></p>\n\
<p>With the Mix map, you can combine two colors or materials on a single side of the surface. You can also animate the Mix Amount parameter, and draw map morphing function curves to control how the two maps are blended over time.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"materials\">Materials</h2><p>A material describes how an object reflects or transmits light. The user can assign materials to individual objects or selection sets. Material plug-ins derive from the <code>Mtl</code> class.</p>\n\
<ul>\n\
<li><p>Camera Map Per Pixel - samples<em>\\materials\\CameraMapTexture</em></p>\n\
<p>This plug-in takes an incoming channel and replaces it with a camera projection</p>\n\
</li>\n\
<li><p>Normal Bump Map - samples<em>\\materials\\NormalBump</em></p>\n\
<p>The Normal Bump map lets you use a texture-baked normals map.</p>\n\
</li>\n\
<li><p>Procedural Texture Maps - samples<em>\\materials\\ProcMap</em></p>\n\
<p>Implements Planet, Smoke, Speckle, Splat, Stucco, and Water Texture maps</p>\n\
</li>\n\
<li><p>Shaders - samples<em>\\materials\\shaders</em></p>\n\
<p>Implements Anisotropic, Multilayer, ONB, Strauss, Translucent, Ward, and other base shaders (BRDF)</p>\n\
</li>\n\
<li><p>Swirl Texture Map - samples<em>\\materials\\swirl</em></p>\n\
<p>Implements the swirl texture map</p>\n\
</li>\n\
<li><p>Wood Dent - samples<em>\\materials\\wooddent.vcproj</em></p>\n\
<p>Implements the dent 3d texture map</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"texture-maps\">Texture Maps</h2><p>A texture map, is an image or algorithm used to add color and patterns to an object surface.</p>\n\
<ul>\n\
<li><p>Checker - <em>\\samples\\materials\\checker.cpp</em></p>\n\
<p>A 2D procedural texture map derived from <code>Texmap</code>.</p>\n\
</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><p>Marble - <em>\\samples\\materials\\marble.cpp</em></p>\n\
<p>A 3D procedural texture map derived from <code>Tex3D</code>.</p>\n\
</li>\n\
<li><p>Noise - <em>\\samples\\materials\\noise.cpp</em></p>\n\
<p>A 3D procedural texture map derived from <code>Tex3D</code>.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";