var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"miscellaneous_samples_and_plug-i\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Miscellaneous Samples and Plug-ins</h1></div><h2 id=\"asset-tracking-system\">Asset Tracking System</h2><ul>\n\
<li><p>Sample ATS provider - <em>\\samples\\assettrackingsystem\\SampleATSProvider</em></p>\n\
<p>The sample ATS provider is a template project for creating asset tracking system (ATS) providers, and demonstrates implementation of the <code>IATSProvider</code> interface. ATS Provider plug-ins must be placed in the <em>\\stdplugs\\AssetTracking</em> folder to be loaded</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"com-dcom-server-plug-ins\">COM/DCOM Server Plug-ins</h2><ul>\n\
<li><p>COM Server - <em>\\samples\\gup\\comsrv</em></p>\n\
<p>This plug-in allows 3ds Max to act as an OLE / COM server.</p>\n\
</li>\n\
<li><p>COM Server Registration Utility - <em>\\samples\\utilities\\comsrv</em></p>\n\
<p>This utility allows 3ds Max to be registered as a COM server.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"function-publishing-samples\">Function Publishing Samples</h2><ul>\n\
<li><p>Simple Function Publishing - <em>\\howto\\functionpublishing\\simplefp</em></p>\n\
<p>A simple example of the function publishing system. This sample is implemented as a global utility plug-in (.gup) to demonstrate how to perform MAXScript exposure for a function published interface outside of the standard MAXScript plug-ins (.dlx).</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"ik-solvers\">IK Solvers</h2><p>An IK solver creates an inverse kinematic solution to rotate and position links in a chain. It applies an IK controller to govern the transforms of the children in a linkage.</p>\n\
<ul>\n\
<li>Human Limb IK Solver - <em>\\samples\\iksolvers\\iklimb</em></li>\n\
<li>Spline IK Solver - <em>\\samples\\iksolvers\\SplineIKSolver</em></li>\n\
</ul>\n\
<h2 id=\"image-viewers\">Image Viewers</h2><p>An image viewer plug-in is available from the 3ds Max File menu under View File. A developer may replace the viewer DLL launched by this command to provide enhanced functionality for image browsing. An image viewer inherits from <code>ViewFile</code>.</p>\n\
<ul>\n\
<li><p>View File - <em>\\samples\\viewfile</em></p>\n\
<p>Implements the 3ds Max external image viewer.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"miscellaneous-how-to-samples\">Miscellaneous How-to Samples</h2><ul>\n\
<li><p>Character Studio Iteration Techniques - <em>\\howto\\CharacterStudio\\TestApi.cpp</em></p>\n\
<p>Demonstrates how to iterate by keys and biped driven controllers.</p>\n\
</li>\n\
<li><p>Source Code Example - <em>\\howto\\SourceCodeExamples</em></p>\n\
<p>Contains miscellaneous CPP files (with no visual studio projects) that demonstrate different features of the API.</p>\n\
</li>\n\
<li><p>CUI Utility - <em>\\howto\\UI\\cuitest</em></p>\n\
<p>Used to test various toolbar API&#39;s. Adds a toolbar to the interface when certain events occur</p>\n\
</li>\n\
<li><p>Custom Control Utilty - <em>\\howto\\UI\\CustomControls</em></p>\n\
<p>This demonstrates the use of many of 3ds Max&#39;s custom controls (e.g. buttons, spinners, edit boxes, list boxes)</p>\n\
</li>\n\
<li><p>Extension Channel Plug-in - <em>\\howto\\objects\\ExtensionChannel</em></p>\n\
<p>Implements 2 new plug-in classes, an extended GSphere with extended channels, and a modifier that adds and extension channel to the pipeline. See XGsphere.cpp for excellent detailed comments on parameter blocks. Each of these plug-in classes implements more than one parameter block.</p>\n\
</li>\n\
<li><p>Custom Data per Face - <em>\\howto\\objects\\PerFaceData</em></p>\n\
<p>Demonstrate attaching custom data to each face of a mesh object. This project turns face data created by other local modifiers into visible colors.</p>\n\
</li>\n\
<li><p>Custom Data per Vertex - <em>\\howto\\objects\\PerVertexData</em></p>\n\
<p>A Project to demonstrate attaching custom data to each vertex of a mesh object. This project attaches a simple user-entered number value to each vertex.</p>\n\
</li>\n\
<li><p>Widget Object - <em>\\howto\\objects\\Widget</em></p>\n\
<p>A simple object for 3ds Max.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"motion-capture-samples\">Motion Capture Samples</h2><ul>\n\
<li><p>Motion Capture Input Device - <em>\\samples\\motioncapture\\</em></p>\n\
<p>A motion capture input device plug-ins connect to the 3ds Max motion capture system, by implementing <code>IMCInputDevice</code>.</p>\n\
</li>\n\
<li><p>Keyboard Driver - <em>\\samples\\motioncapture\\mckbddev</em></p>\n\
<p>Keyboard device driver for motion capture system</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"opensubdiv-sample\">OpenSubdiv Sample</h2><p>A sample that exercises SDK exposure of the OpenSubdiv feature (such as accessing OpenSubdivParameters and mesh picking) is located at:</p>\n\
<ul>\n\
<li><code>*\\\\samples\\\\utilities\\\\OpenSubdivTest</code>*</li>\n\
</ul>\n\
<h2 id=\"painter-interface-samples\">Painter Interface Samples</h2><p>Plug-ins that implement the painter interface (<code>IPainterInterface_V7</code>) make it possible to be painted on.</p>\n\
<ul>\n\
<li>Painter Interface - <em>\\samples\\PainterInterface</em></li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li><p>Painter Deform Test - <em>\\howto\\painterinterface\\painterdeformtest</em></p>\n\
</li>\n\
<li><p>Painter Tester - <em>\\howto\\painterinterface\\PainterTester</em></p>\n\
<p>A plug-in that demonstrates the Painter Interface.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"populate-interfaces-sample\">Populate Interfaces Sample</h2><p>The Populate feature exposes several interfaces: <code>IPopulate</code>, <code>IPopulateFlow</code>, <code>IPopulateIdleArea</code>, and <code>IPopulateSeat.</code> A sample utility plug-in that uses these interfaces is located in  <strong>\\howto\\Populate</strong> .</p>\n\
<h2 id=\"shadow-generator-plug-ins\">Shadow Generator Plug-ins</h2><p>The standard 3ds Max mapped and ray-traced shadows are Shadow Generator plug-ins. There is presently no sample of this type of plug-in; however, a plug-in template is available through the application wizard in Visual Studio. The primary classes involved in shadow generators are: <code>ShadBufRenderer</code>, <code>ShadowType</code>, and <code>ShadowGenerator</code>.</p>\n\
<h2 id=\"snap-plug-ins\">Snap Plug-ins</h2><p>Snap plug-ins (also called Object Snap plug-ins) allows custom points to be provided to the 3ds Max snapping system. For example, a door plug-in could provide a custom snap for the hinge center. Snap plug-ins derive from <code>Osnap</code>.</p>\n\
<ul>\n\
<li>Various Snap Samples - <em>\\samples\\snaps.</em></li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li><p>Sphere Saps - <em>\\howto\\snaps\\sphere</em></p>\n\
<p>An example object snap. This plug-in will respond to spheres and supports two sub-snaps: quadrant and center. Center being the (0,0,0) point in object space. The quadrants are the points (+-r,0,0),(0,+-r,0),(0,0,+-r) in object space.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"sound-plug-ins\">Sound Plug-ins</h2><p>A sound plug-in can take control of sound (and music) production in 3ds Max. These plug-ins control not only the sounds they generate but also the system clock. They can thus coordinate the timing of external sound input/output devices with the animation. Sound plug-ins can provide their user interface as part of the 3ds Max Track View. A sound plug-in derives from <code>SoundObj</code>.</p>\n\
<ul>\n\
<li><p>VRML Export -  <strong>\\samples\\import_export\\vrmlexp\\sound.cpp</strong> </p>\n\
<p>Demonstrates export of sound objects.</p>\n\
</li>\n\
<li><p>Sound Object Test -  <strong>\\samples\\utilities\\utiltest.cpp</strong> </p>\n\
<p>Demonstrates a simple sound plug-in.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"system-plug-ins\">System Plug-ins</h2><p>System plug-ins are combinations of plug-ins working together. These plug-ins can provide high-order parametric control over a complex collection of scene entities.</p>\n\
<ul>\n\
<li><p>Sunlight -  <em>*\\samples\\systems\\sunlight</em> * </p>\n\
<p>A sunlight emulation system. Also illustrates how to use Qt for the plug-in UI.</p>\n\
</li>\n\
<li><p>Ring Array -  <em>*\\samples\\objects\\RingArray.cpp</em> * </p>\n\
<p>The Ring Array object consists of a dummy master object surrounded by a ring of driven objects, coordinated using a controller.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"viewport-volume-display-api\">Viewport Volume Display API</h2><p>This API simplifies displaying a volume in the viewport when a plugin provides the voxel data, positions and display options. </p>\n\
<ul>\n\
<li><strong>\\howto\\objects\\VolumeSampleObject</strong>\n\
 A plugin that illustrates how to implement the Volume Display API for a geometry object.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";