var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modifier_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modifier Plug-ins</h1></div><h2 id=\"object-space-modifiers\">Object Space Modifiers</h2><p>Modifiers provide a way to edit an object&#39;s parameters and geometry. A modifier derives from the <code>Modifier</code> class.</p>\n\
<ul>\n\
<li><p>Basic modifiers -  <em>\\samples\\modifiers\\basicOps</em> </p>\n\
<p>Implements the basic mesh editing modifiers.</p>\n\
</li>\n\
<li><p>Bone Deformations -  <em>\\samples\\modifiers\\bonesdef</em> </p>\n\
<p>A simple bone deformation plug-in.</p>\n\
</li>\n\
<li><p>Camera Map modifiers -  <em>\\samples\\modifiers\\cammap</em> </p>\n\
<p>Implements two modifiers. The Camera Map modifier (object-space version) assigns planar mapping coordinates based on the current frame and the camera specified in the Camera Map modifier. This differs from the Camera Map (WSM) modifier that updates the object&#39;s mapping coordinates on each frame.</p>\n\
</li>\n\
<li><p>Turn to Mesh / Poly / Patch modifiers -  <em>\\samples\\modifiers\\convert</em> </p>\n\
<p>Implements three conversion modifiers. A Turn To modifier lets you apply object conversions in the modifier stack.</p>\n\
</li>\n\
<li><p>Edit Patch modifier -  <em>\\samples\\modifiers\\editpatch</em> </p>\n\
<p>Transforms an object into an editable patch object.</p>\n\
</li>\n\
<li><p>Edit Poly modifier -  <em>\\samples\\mesh\\EditPoly</em> </p>\n\
<p>Transforms an object into an editable poly mesh.</p>\n\
</li>\n\
<li><p>Edit Mesh modifier -  <em>\\samples\\modifiers\\EditMesh</em> </p>\n\
<p>Transforms an object into an editable mesh.</p>\n\
</li>\n\
<li><p>Free Form Deformation modifiers -  <em>\\samples\\modifiers\\ffd</em> </p>\n\
<p>Implements three Free Form Deformation (FFD) modifiers. An FFD modifier surrounds the selected geometry with a lattice. By adjusting the control points of the lattice, you can deform the enclosed geometry.</p>\n\
</li>\n\
<li><p>Flex modifier -  <em>\\samples\\modifiers\\flex</em> </p>\n\
<p>Simulates soft-body dynamics using virtual springs between an object&#39;s vertices.</p>\n\
</li>\n\
<li><p>Melt modifier -  <em>\\samples\\modifiers\\melt</em> </p>\n\
<p>The Melt modifier lets you apply a realistic melting effect to all types of objects, including editable patches and NURBS objects, as well as to sub-object selections passed up the stack.</p>\n\
</li>\n\
<li><p>Skin Morph modifier -  <em>\\samples\\modifiers\\morphByBone</em> </p>\n\
<p>The Skin Morph modifier lets you use a bone&#39;s rotation to drive a morph.</p>\n\
</li>\n\
<li><p>Morpher modifier -  <em>\\samples\\modifiers\\morpher</em> </p>\n\
<p>The Morpher modifier changes the shape of a mesh, patch, or NURBS model.</p>\n\
</li>\n\
<li><p>Patch Select modifier -  <em>\\samples\\modifiers\\patchSelect</em> </p>\n\
<p>The Patch Select modifier lets you pass a sub-object selection up the stack to subsequent modifiers. It provides a superset of the selection functions available in the Edit Patch modifier.</p>\n\
</li>\n\
<li><p>Point Cache modifier -  <em>\\samples\\modifiers\\patchSelect</em> </p>\n\
<p>The Point Cache modifier lets you store the modifier animation to a disk file that records only changes in the vertex positions, and then play back the animation using the information in the disk file instead of the modifier keyframes.</p>\n\
</li>\n\
<li><p>Renderable Spline modifier -  <em>\\samples\\modifiers\\renderableSpline</em> </p>\n\
<p>The Renderable Spline modifier lets you set the renderable properties of a spline object, without collapsing the spline to an editable spline.</p>\n\
</li>\n\
<li><p>Skin Wrap modifier -  <em>\\samples\\modifiers\\renderableSpline</em> </p>\n\
<p>The Skin Wrap modifier allows one or more objects to deform another.</p>\n\
</li>\n\
<li><p>Shell modifier -  <em>\\samples\\modifiers\\Solidify</em> </p>\n\
<p>Creates solid geometry from a surface.</p>\n\
</li>\n\
<li><p>Spherify modifier -  <em>\\samples\\modifiers\\spherify</em> </p>\n\
<p>Projects the vertices of an object onto the surface of a sphere.</p>\n\
</li>\n\
<li><p>Spline IK modifier -  <em>\\samples\\modifiers\\SplineIKControl</em> </p>\n\
<p>When applied to a spline, this creates one point helper for each knot in the spline.</p>\n\
</li>\n\
<li><p>Stretch modifier -  <em>\\samples\\modifiers\\stretch</em> </p>\n\
<p>Stretch applies a scale effect along a specified stretch axis and an opposite scale along the two remaining minor axes.</p>\n\
</li>\n\
<li><p>UVW Unwrap modifier -  <em>\\samples\\modifiers\\uvwUnwrap</em> </p>\n\
<p>A UVW map modifier that unwraps the UVWs onto an image.</p>\n\
</li>\n\
<li><p>Vertex Paint modifier -  <em>\\samples\\modifiers\\uvwUnwrap</em> </p>\n\
<p>A modifier for painting on geometry.</p>\n\
</li>\n\
<li><p>Various modifiers -  <em>\\samples\\modifiersmods.vcproj</em> </p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li><p>Bend modifier -  <em>\\howto\\Bend</em> </p>\n\
<p>Implements the Bend modifier. This is identical to bend.cpp that resides in \\samples\\modifiers folder. This modifier is wrapped in its own Visual Studio project. This sample is a good starting point for learning about modifiers.</p>\n\
</li>\n\
<li><p>Stack Boss modifier -  <em>\\howto\\StackBoss</em> </p>\n\
<p>Shows how you can keep custom attributes persistent even when the modifier stack is collapsed.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"world-space-modifiers-space-warps-\">World Space Modifiers (Space Warps)</h2><p>World space modifiers combine a non-rendering object and a modifier that modifies the world-space representation of an object. A world space modifier derives from the class <code>WSModifier</code>.</p>\n\
<ul>\n\
<li><p>Sine Wave -  <em>\\samples\\modifiers\\sinwave.cpp</em> </p>\n\
<p>The Wave space warp creates a linear wave through world space. It affects geometry and behaves the same as the Wave modifier. The Wave space warp is used when you want the wave to affect a large number of objects, or to affect an object relative to its position in world space.</p>\n\
</li>\n\
<li><p>Gravity -  <em>\\samples\\modifiers\\gravity.cpp</em> </p>\n\
<p>The Gravity space warp simulates the effect of natural gravity on particles generated by a particle system. Gravity is directional. Particles moving in the direction of the gravity arrow accelerate, while those moving against the arrow decelerate.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";