var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"object_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Object Plug-ins</h1></div><h2 id=\"camera-objects\">Camera Objects</h2><p>Plug-in cameras derive from <code>CameraObject</code> and <code>GenCamera</code>.</p>\n\
<ul>\n\
<li><p>Camera - <em>\\samples\\objects\\camera.cpp</em></p>\n\
<p>Cameras present a scene from a particular point of view. Camera objects simulate still-image, motion picture, or video cameras in the real world.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"compound-objects\">Compound Objects</h2><p>Compound objects take several objects and combine them together to produce a new object. Examples includes Boolean and Morph objects. The principal class involved in compound objects is <code>IBoolObject</code>.</p>\n\
<ul>\n\
<li><p>Boolean - <em>\\samples\\objects\\boolobj.cpp</em></p>\n\
<p>Produce a new object using union, intersection and difference operations.</p>\n\
</li>\n\
<li><p>Blob Mesh Compound Object - <em>\\samples\\objects\\BlobMesh</em></p>\n\
<p>The Blob Mesh compound object creates a set of spheres from geometry or particles, and connects the spheres together as if they were made of a soft, liquid substance. When the spheres move within a certain distance of one another, they connect together. When they move apart, they take on a spherical form again.</p>\n\
</li>\n\
<li><p>Mesher Compound Object - <em>\\samples\\objects\\mesher</em></p>\n\
<p>The Mesher compound object converts objects to mesh objects on a per-frame basis so that you can apply modifiers such as Bend or UVW Map. It can be used with any type of object, but is designed primarily to work with particle systems.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"geometric-object-plug-ins\">Geometric Object Plug-ins</h2><p>Geometric object plug-ins derive derived from <code>GeomObject</code> or <code>SimpleObject2</code>.</p>\n\
<ul>\n\
<li><p>Primitive Geometric Objects - <em>\\samples\\objects\\prim.vcproj</em></p>\n\
<p>Implements numerous primitive geometric objects such as boxes, spheres, cones, cylinders, and tubes.</p>\n\
</li>\n\
<li><p>Extended Primitives - <em>\\samples\\objects\\ExtendedObjects</em></p>\n\
<p>Implements all the extended primitive objects available in the Create Command Panel such as chamfer cubes, oil tanks, pyramids etc..</p>\n\
</li>\n\
<li><p>Geodesic Sphere Primitive - <em>\\samples\\objects\\GSphere</em></p>\n\
<p>Creates spheres and hemispheres based on three classes of regular polyhedrons.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"helper-objects\">Helper Objects</h2><p>Helper objects are items such as dummy objects, grids, tape measurers and point objects. Helper objects derive from <code>ConstObject</code> or <code>HelperObject</code>.</p>\n\
<ul>\n\
<li><p>Grid Helper - <em>\\samples\\objects\\helpers\\gridhelp.cpp</em></p>\n\
<p>The grid, also called User Grid or Custom Grid, is a 2D object with adjustments for overall size and grid spacing. The user can move and orient user grids anywhere in world space.</p>\n\
</li>\n\
<li><p>Pointer Helper - <em>\\samples\\objects\\helpers\\pthelp.cpp</em></p>\n\
<p>The point helper provides a specific location in 3D space that can be used as a reference or by other program functions</p>\n\
</li>\n\
<li><p>Expose Transform - <em>\\samples\\objects\\Helpers\\Exposeform</em></p>\n\
<p>The Expose Transform helper object exposes values of non-keyed objects for use in expressions and scripts.</p>\n\
</li>\n\
<li><p>Luminaire Helper Object - <em>\\samples\\objects\\Helpers\\Luminaire</em></p>\n\
<p>The Luminaire helper object serves primarily as a head, or control, object for light fixtures.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"light-objects\">Light Objects</h2><p>Examples of plug-ins lights include point lights, direct lights, and spot lights. Light plug-ins derive from <code>LightObject</code> or <code>GenLight</code>.</p>\n\
<ul>\n\
<li><p>Light - <em>\\samples\\objects\\light.cpp</em></p>\n\
<p>Lights are objects that simulate real lights such as household or office lamps, the light instruments used in stage and film work, and the sun itself. Different kinds of light objects cast light in different ways, emulating different kinds of real-world light sources.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"manipulator-helper-objects\">Manipulator Helper Objects</h2><p>Manipulator helpers are objects you can create to manipulate other objects. They let you add customized controls to your scene that provide visual feedback in viewports. To control other objects, manipulators use the parameter wiring feature. The following samples demonstrate implementing manipulators by inheriting from <code>SimpleManipulator</code>.</p>\n\
<ul>\n\
<li><p>Cone Angle Manipulator - <em>\\samples\\manipulators\\coneanglemanip.cpp</em></p>\n\
<p>The Cone Angle manipulator is a cone whose base you can adjust. By wiring its Angle value to a parameter of another object, you can create a custom control, with visual feedback, within a scene.</p>\n\
</li>\n\
<li><p>Plane Angle Manipulator - <em>\\samples\\manipulators\\planeanglemanip.cpp</em></p>\n\
<p>The Plane Angle manipulator looks like a lever or joystick. By wiring its Angle value to a parameter of another object, you can create a custom control, with visual feedback, within a scene.</p>\n\
</li>\n\
<li><p>Slider Manipulator - <em>\\samples\\manipulator\\slider.cpp</em></p>\n\
<p>The Slider manipulator is a graphic control that appears in the active viewport. By wiring its Value to a parameter of another object, you can create a custom control, with visual feedback, within a scene</p>\n\
</li>\n\
<li><p>Bend Manipulator - <em>\\howto\\manipulators\\bend</em></p>\n\
<p>A how-to sample showing a full manipulator. It uses the Bend modifier to provide a gizmo and also handles setting up of a<code>HitData</code> object.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"mesh-object-samples\">Mesh Object Samples</h2><ul>\n\
<li><p>Editable Mesh Object - <em>\\samples\\mesh\\editablemesh</em></p>\n\
<p>A triangular mesh object.</p>\n\
</li>\n\
<li><p>Editable Poly Mesh Object - <em>\\samples\\mesh\\editablepoly</em></p>\n\
<p>A polygon mesh object.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"nurbs-objects\">NURBS Objects</h2><p>The NURBS API provides an interface into the NURBS objects used by 3ds Max. You can create new NURBS objects or modify existing ones. A NURBS object plug-in will derive from <code>NURBSObject</code>.</p>\n\
<ul>\n\
<li><p>NURBS Test Utility - <em>\\samples\\utilties\\nurbs</em></p>\n\
<p>A test harness for the NURBS API that can be used an example of how to work with NURBS.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"patch-object\">Patch Object</h2><p>Developers can create patch modeling systems for 3ds Max. Patch object plug-ins derive from <code>PatchObject</code>.</p>\n\
<ul>\n\
<li><p>Editable Patch Object - <em>\\samples\\objects\\tripatch.cpp</em></p>\n\
<p>Editable Patch provides controls for manipulating an object as a patch object and at five sub-object levels: vertex, handle, edge, patch, and element.</p>\n\
</li>\n\
<li><p>Patch Grid - <em>\\samples\\objects\\patchgrd.cpp</em></p>\n\
<p>Patch grids provide convenient &quot;building material&quot; for custom surfaces and objects, or for adding patch surfaces to existing patch objects.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"spline-objects\">Spline Objects</h2><p>These are shapes such as circles, arcs, rectangles, and donuts. Spline objects derived from <code>SimpleSpline.</code></p>\n\
<ul>\n\
<li>Circle - <em>\\samples\\objects\\circle.cpp</em></li>\n\
<li>Ellipse - <em>\\samples\\objects\\ellipse.cpp</em></li>\n\
<li>Arc - <em>\\samples\\objects\\arc.cpp</em></li>\n\
</ul>\n\
<h3 id=\"shape-objects\">Shape Objects</h3><p>These are shapes such as the helix. Shape objects derive from <code>ShapeObject</code>.</p>\n\
<ul>\n\
<li>Helix - <em>\\samples\\objects\\helix.cpp</em></li>\n\
</ul>\n\
<h2 id=\"instance-objects\">Instance Objects</h2><p>Objects can display instances of themselves, either in the viewport or at render-time, without creating new scene objects.</p>\n\
<p>The Render-time Instancing API allows you to display multiple instances of a single object at render-time.  Plug-ins that use this API must implement the required methods in <code>MaxSDK::RenderTimeInstancing::RenderTimeInstancingInterface</code>.  </p>\n\
<ul>\n\
<li><em>\\howto\\objects\\RenderTimeInstancedObject</em> -  An example plug-in that implements the <code>RenderTimeInstancingInterface</code>.  It creates a new type of object that can display multiple instances of itself at render-time.</li>\n\
</ul>\n\
<p>The Viewport Instancing API allows an object plug-in to display many instances in the viewport without creating them all in the scene. The plug-in describes the instance data based on a single object, and 3ds Max creates efficient representations of that object on the GPU. The instances can have different transforms, materials, mapping coordinates, and vertex colors. Plug-ins that use this API use the methods of class <code>InstanceDisplayGeometry</code>.</p>\n\
<ul>\n\
<li><em>\\howto\\objects\\InstancedObject</em> - An example plug-in that implements <code>InstanceDisplayGeometry</code>.  It creates a new type of object that can display multiple instances of itself in the viewport.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";