var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"particle_system_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Particle System Plug-ins</h1></div><h2 id=\"atmospheric-effects\">Atmospheric Effects</h2><p>An atmospheric effect is a function in 3ds space. Atmospheric plug-ins are used for effects such as 3ds Max&#39;s Fog and Volume Fog. Certain particle effects can be accomplished using atmospherics more efficiently. For example, a fire effect that is not done with particles but rather as a function in 3D space. These plug-ins typically use very little memory relative to a particle system equivalent. Atmospheric plug-ins also have the ability to reference items in the scene. For example, 3ds Max&#39;s Volume Lights reference lights in the scene. Atmospheric effect plug-ins often derive from<code>Atmospheric</code>,<code>StdFog</code> or<code>IXRefAtmospheric</code>.</p>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li>Fog - <em>\\howto\\SourceCodeExamples\\fog.cpp</em></li>\n\
</ul>\n\
<h2 id=\"particle-flow-samples\">Particle Flow Samples</h2><p>The source code for the Particle Flow particle system operators, particles tests, and particle channels is provided with 3ds Max in the folder:  <strong>\\samples\\particleflow\\actions</strong> .</p>\n\
<ul>\n\
<li><p>Speed Operator - <em>\\samples\\particleflow\\actions\\PFOperatorSimpleSpeed.cpp</em></p>\n\
<p>Applies a speed to a particle after it has been birthed (created).</p>\n\
</li>\n\
<li><p>Speed Test - <em>\\samples\\particleflow\\actions\\PFTestSpeed.cpp</em></p>\n\
<p>Tests the speed of a particle.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"particle-objects\">Particle Objects</h2><p>Developers may create object plug-ins for the non-event-driven particle system. Some examples are particles that depend upon motion like fireworks, explosions, and water, or particles that track the surface of objects such as electrical fields or flame. Particle objects derive from <code>ParticleObject</code> or <code>SimpleParticle</code>.</p>\n\
<ul>\n\
<li><p>Various Particle Systems - <em>\\samples\\objects\\particles</em></p>\n\
<p>Implements blizzard, parray, pclouds, pbomb and other basic particle systems.</p>\n\
</li>\n\
<li><p>Particle Colliders - <em>\\samples\\objects\\particles\\colliders</em></p>\n\
<p>Collision engines for particles.</p>\n\
</li>\n\
<li><p>Spray and Snow - <em>\\samples\\objects\\rain.cpp</em></p>\n\
<p>Snow simulates falling snow or confetti.</p>\n\
</li>\n\
<li><p>Gravity - <em>\\samples\\objects\\gravity.cpp</em></p>\n\
</li>\n\
<li><p>SuperSpray and Blizzard - <em>\\samples\\objects\\particles\\blizzard.cpp</em></p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";