var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"rendering_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Rendering Plug-ins</h1></div><h2 id=\"anti-aliasing-filters\">Anti-Aliasing Filters</h2><p>Anti-aliasing filter plug-in are used for filtering and anti-aliasing an image</p>\n\
<ul>\n\
<li><p>Anti Aliasing Filters - <em>\\samples\\render\\aaFilters</em></p>\n\
<p>Implements numerous anti-aliasing filters.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"hardware-shaders\">Hardware Shaders</h2><ul>\n\
<li><p>Cube-map Vertex Shader - <em>\\samples\\hardwareshaders\\CubeMap</em></p>\n\
</li>\n\
<li><p>Light Map Shader - <em>\\samples\\hardwareshaders\\LightMap</em></p>\n\
</li>\n\
<li><p>Metal Bump Selector - <em>\\samples\\hardwareshaders\\mb_select</em></p>\n\
<p>A DirectX shader plug-in.</p>\n\
</li>\n\
<li><p>Metal Bump Shader - <em>\\samples\\hardwareshaders\\MetalBump</em></p>\n\
<p>A DirectX shader plug-in.</p>\n\
</li>\n\
<li><p>Viewport Manager - <em>\\samples\\hardwareshaders\\ViewportManager</em></p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples:</p>\n\
<ul>\n\
<li><p>SineWave XTC Modifier - <em>\\howto\\hwardwareshaders\\SineWave</em></p>\n\
</li>\n\
<li><p>Sample shader - <em>\\howto\\hardwareshaders\\SampleShaderplug-in</em></p>\n\
<p>A simple shader plug-in.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"image-filter-post-filter-plug-ins\">Image Filter (Post-Filter) Plug-ins</h2><p>Image filter (also called post-filter) plug-ins alter images in the video post data stream. Filters can operate on a single image or can combine two images together to create a new composite image. Also see the section on <a href=\"./../../3ds_max_sdk_features/rendering/working_with_bitmaps.html\">Working with Bitmaps</a> and the class <code>ImageFilter</code>.</p>\n\
<ul>\n\
<li><p>Image Alpha Filter - <em>\\samples\\postfilters\\alpha</em></p>\n\
<p>Replaces the image&#39;s alpha channel with the channel specified by the filter mask.</p>\n\
</li>\n\
<li><p>Negative Filter - <em>\\samples\\postfilters\\negative</em></p>\n\
<p>Inverts the colors in the scene, making it negative like a negative color photograph.</p>\n\
</li>\n\
<li><p>Add Filter - <em>\\samples\\postfilters\\add</em></p>\n\
<p>Combines two image filters.</p>\n\
</li>\n\
<li><p>Fade Filter - <em>\\samples\\postfilters\\fade</em></p>\n\
<p>The Fade filter fades an image in or out over time. The rate of the fade is determined by the length of the Fade filter&#39;s time range.</p>\n\
</li>\n\
<li><p>Starfield Filter - <em>\\samples\\postfilters\\starfield</em></p>\n\
<p>Generates a realistic starfield with optional motion blur. The Starfield Filter requires a camera view. Any motion of the stars is a result of camera motion.</p>\n\
</li>\n\
<li><p>Simple Wipe Filter - <em>\\samples\\postfilters\\wipe</em></p>\n\
<p>The Simple Wipe filter reveals or erases the foreground image with a wipe transition. Unlike the Wipe Layer compositor, Wipe Filter wipes across a fixed image.</p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li>Glow Image Filter - <em>\\howto\\postfilters\\glow</em></li>\n\
<li>Node Track Image Filter - <em>\\howto\\postfilters\\NodeTrack</em></li>\n\
</ul>\n\
<h2 id=\"network-rendering-samples\">Network Rendering Samples</h2><p>The following how-to samples demonstrate utilties for working with the network rendering system.</p>\n\
<ul>\n\
<li><p>Job Assign - <em>\\howto\\NetRender\\JobAssign</em></p>\n\
<p>A command line executable that demonstrates assigning jobs for netrendering.</p>\n\
</li>\n\
<li><p>List Jobs - <em>\\howto\\NetRender\\ListJobs</em></p>\n\
<p>A command line executable that demonstrates listing netrendered jobs.</p>\n\
</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><p>Network Manager Notification Program - <em>\\howto\\utilities\\notify</em></p>\n\
<p>The Notify sample is used simply as a demonstration. It plays a different wave file for each of the event types. If invoked with no command line, it brings up a dialog box asking the user to define each of the three wave files. The dialog has &quot;Browse&quot; buttons next to each wave file field that puts the user right into the Windows&#39; &quot;Media&quot; directory where wave files are saved. There are also &quot;play&quot; buttons next to each sound for testing.</p>\n\
<p>The notify.exe program in the 3ds Max folder is invoked by the network manager to handle network progress notifications. A developer can write another &quot;notify&quot; program to perform any proprietary type of notifications. Note that &quot;notify&quot; can be either a native code executable (.exe) or a Windows script (.bat). This allows a user to create a simple script without having to resort to create a native a stand-alone program.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"renderers\">Renderers</h2><p>A renderer plug-in derives from the class <code>Render</code>.</p>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li><p>Simple Renderer - <em>\\howto\\render\\CJRender</em></p>\n\
<p>Implements a fully functioning simple renderer. (Note. In order to open the dialogs in the resource editor, you must first make sure that buildver.h is set in the right directory relative to your project directory. Open up the resource file in a text editor, and in the top of the page, you will see a path to buildver.h that needs to be in place)</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"render-elements\">Render Elements</h2><p>Render elements allow renderers to output to separate bitmaps portions of the final shaded image so that they can be manipulated/composited at a later time, without re-rendering.</p>\n\
<ul>\n\
<li>Render Elements Sample - <em>\\samples\\render\\renderelements</em></li>\n\
</ul>\n\
<h2 id=\"rendering-effects\">Rendering Effects</h2><p>A rendering effect is a post-rendering image-processing effect. This kind of plug-in appears under the Rendering menu and displays the Rendering Effects dialog. This lets the user apply image processing without using Video Post, and has the added advantage of allowing animated parameters and references to scene objects. Most rendering effects derive from the <code>Effect</code> class.</p>\n\
<ul>\n\
<li><p>Blur - <em>\\samples\\render\\rendereffects\\blur</em></p>\n\
<p>The Blur effect allows the user to blur your image in three different methods: Uniform, Directional, and Radial.</p>\n\
</li>\n\
<li><p>Brightness And Contrast - <em>\\samples\\render\\rendereffects\\brightcon</em></p>\n\
<p>Allows the user to adjust the contrast and brightness of an image. This can be used to match rendered scene objects with background images or animations.</p>\n\
</li>\n\
<li><p>File Output - <em>\\samples\\render\\rendereffects\\fileout</em></p>\n\
<p>The file output rendering effect allows you to take a snapshot&quot;of a rendering before some or all of the other render effects are applied, depending on the placement of file output in the render effects stack. You can save different channels such as luminance, depth, or alpha to a separate file while rendering an animation</p>\n\
</li>\n\
<li><p>Film Grain - <em>\\samples\\render\\rendereffects\\filmgrain</em></p>\n\
<p>Film Grain is used to recreate the look of film grain in a rendered scene. When applied, Film Grain automatically randomizes to create the look of moving frames.</p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li>Simple Render Effect - <em>\\howto\\render\\RenderEffects\\SampleEff</em></li>\n\
</ul>\n\
<h2 id=\"sampler-plug-ins\">Sampler Plug-ins</h2><p>A sampler is a plug-in that determines where inside a single pixel the shading and texture samples are computed. The user interface of samplers appears in the SuperSampling rollout in the Sampler drop-down. The core class for a sampler plug-in is <code>Sampler</code>.</p>\n\
<ul>\n\
<li><p>Samplers - <em>\\samples\\render\\samplers</em></p>\n\
<p>Various standard sampler plug-ins.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"shader-plug-ins\">Shader Plug-ins</h2><p>The shader is the piece of code which controls how light is reflected off the surface. Every material has a shader, it handles all the texturing for the material and manages the user interface. A shader plug-in should derive from <code>Shader</code> instead of <code>BaseShader</code> otherwise the interactive renderer won&#39;t know how to render the shader in the viewports.</p>\n\
<ul>\n\
<li><p>Blinn Shader - <em>\\samples\\materials\\stdmtl.cpp</em></p>\n\
<p>Has the same features as the Phong shader, but its mathematics are more accurate. This is the default shader for standard materials.</p>\n\
</li>\n\
<li><p>Strauss Shader - <em>\\samples\\materials\\shaders\\shaderstrauss.cpp</em></p>\n\
<p>For modeling metallic surfaces. It uses a simpler model and has a simpler interface than the Metal shader.</p>\n\
</li>\n\
<li><p>Anisotropic - <em>\\samples\\materials\\shaders\\shaderaniso.cpp</em></p>\n\
<p>Used for brushed metal or hair. Creates a highlight that is stretched and angled, rather than the standard circular highlight.</p>\n\
</li>\n\
<li><p>Translucent - <em>\\samples\\materials\\shaders\\shadertranslucent.cpp</em></p>\n\
<p>Similar to Blinn shading, but it also lets you specify translucency. A translucent object allows light to pass through, and also scatters light within the object. You can use translucency to simulate frosted and etched glass</p>\n\
</li>\n\
<li><p>Oren-Nayar Shader - <em>\\samples\\materials\\shaders\\shaderonb.cpp</em></p>\n\
<p>An adaptation of the Blinn shader. It gives objects a porous, non-plastic appearance, and is suitable for surfaces like skin.</p>\n\
</li>\n\
<li><p>Phong Shader - <em>\\samples\\materials\\shaders\\stdmtl.cpp</em></p>\n\
<p>A classic shading method that was the first to enable specular highlights. Suitable for plastic surfaces.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";