var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"utility_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Utility Plug-ins</h1></div><h2 id=\"color-selection-plug-ins\">Color Selection Plug-ins</h2><p>A color selection plug-in (i.e. color picker) is a utility plug-in that provides the user with a custom color picker that appears whenever a standard 3ds Max color swatch control is clicked. These plug-ins are selected in the General tab of the Preferences dialog. The color picker chosen is saved in the 3DSMAX.INI file in the &quot;ColorPicker&quot; section so that the choice is maintained between sessions. If the DLL for the selected color picker is not available, it always defaults back to the &quot;Default&quot; color picker.</p>\n\
<p>A color selection plug-in derives from <code>ColPick</code>. No sample code is provided with the SDK.</p>\n\
<h2 id=\"global-utility-plug-ins-gups-\">Global Utility Plug-ins (GUPs)</h2><p>A global utility plug-ins (GUP) has no user interface, and do not show in Utility page of the command panel. A GUP usually derives from the <code>GUP</code> class. GUPs are loaded after 3ds Max initialization, but before the message loop starts, and remain loaded until after other plug-ins are shutdown.</p>\n\
<ul>\n\
<li><p>Plug-in Manager - <em>\\samples\\gup\\plug-inmanager</em></p>\n\
<p>This is a global utility that lets the user load and unload plug-ins during runtime.</p>\n\
</li>\n\
<li><p>Save Verification - <em>\\samples\\gup\\saveverification</em></p>\n\
<p>Demonstrates a callback mechanism to validate that scene files are saved correctly.</p>\n\
</li>\n\
<li><p>Geometry Checker - <em>\\samples\\gup\\geometrycheckers</em></p>\n\
<p>Analyzes mesh models, flags various potential problems and errors, and displays the results in the viewports both graphically and as text. Tests include isolated and overlapping vertices, open edges, various UVW statistics, and more.</p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples:</p>\n\
<ul>\n\
<li><p>Layers Test - <em>\\howto\\gup\\layers</em></p>\n\
<p>Demonstrates the layers functionality.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"track-view-utilities\">Track View Utilities</h2><p>Track view utility plug-ins are launched using the &#39;Track View Utility&#39; icon just to the left of the track view name field in the toolbar. Clicking on this button brings up a dialog of all the track view utilities currently installed in the system. These may provide general utility functions that operate on keys, time or function curves in Track View. A track view plug-in will derive from <code>TrackViewUtility</code>.</p>\n\
<ul>\n\
<li><p>Euler Filter - <em>\\samples\\utilities\\filter.cpp</em></p>\n\
<p>Corrects for gimbal flipping (anomalous rotation animation) in objects animated using Euler rotation by processing existing animation keys in selected</p>\n\
</li>\n\
<li><p>Create Out of Range Keys - <em>\\samples\\utilities\\ortkeys.cpp</em></p>\n\
<p>Creates keys in the out-of-range time of a track when the out of range type is something other than Constant. It converts the specified out-of-range area to a keyed area that you can edit and adjust.</p>\n\
</li>\n\
<li><p>Randomize Keys - <em>\\samples\\utilities\\randkeys.cpp</em></p>\n\
<p>Applies random offset values to Time or Value of selected keys or selected time.</p>\n\
</li>\n\
<li><p>Select Keys by Time - <em>\\samples\\utilities\\selkeys.cpp</em></p>\n\
<p>Selects keys within a specified start and end range of time. Lets a user select a large range of time when using the mouse might be awkward -- for example, if keys are not visible in the Track View Key window.</p>\n\
</li>\n\
</ul>\n\
<h2 id=\"utility-plug-ins\">Utility Plug-ins</h2><p>A utility plug-in will normally derive from the <code>UtilityObj</code> class.</p>\n\
<ul>\n\
<li><p>Vertex Color Modifier - <em>\\samples\\utilities\\applyvc</em></p>\n\
<p>This modifier is the keeper of vertex colors generated by the &quot;Apply Vertex Colors&quot; Utility plug-in.</p>\n\
</li>\n\
<li><p>Resource Collector - <em>\\samples\\utilities\\collector</em></p>\n\
<p>A resource (bitmaps) collection plug-in</p>\n\
</li>\n\
<li><p>Fix Ambient - <em>\\samples\\utilities\\fixAmbient</em></p>\n\
<p>A utility that locks the ambient and diffuse colors and textures.</p>\n\
</li>\n\
<li><p>Map Paths Utility - <em>\\samples\\utilities\\MapPath</em></p>\n\
<p>Manages bitmap file paths.</p>\n\
</li>\n\
<li><p>Max File Finder - <em>\\samples\\utilities\\MaxFind</em></p>\n\
<p>Searches for Max Files in a system</p>\n\
</li>\n\
<li><p>Material Editor Utilities - <em>\\samples\\utilities\\meditUtils</em></p>\n\
</li>\n\
<li><p>Scene Manager - <em>\\samples\\utilities\\scenemgr</em></p>\n\
</li>\n\
<li><p>MaxFind Launcher - <em>\\samples\\utilities\\umaxfind</em></p>\n\
<p>A utility to start an external MAXFinder executable.</p>\n\
</li>\n\
<li><p>UVW Coordinate Remover - <em>\\samples\\utilities\\uvremove</em></p>\n\
</li>\n\
<li><p>Various Utilities - <em>\\samples\\utilities\\utility.vcproj</em></p>\n\
</li>\n\
</ul>\n\
<p>How-to Samples</p>\n\
<ul>\n\
<li><p>Curve Control - <em>\\howto\\utilities\\Ccutil</em></p>\n\
<p>Demonstrates the use of a curve control.</p>\n\
</li>\n\
<li><p>Custom Attribute Example - <em>\\howto\\utilities\\CustomAttribute</em></p>\n\
<p>Adds a custom attribute to an object, modifier and material</p>\n\
</li>\n\
<li><p>Mesh Split - <em>\\howto\\utilities\\MeshSplit</em></p>\n\
<p>This plug-in splits editable meshes into separate nodes based on materials</p>\n\
</li>\n\
<li><p>Reference Check - <em>\\howto\\utilities\\ReferenceCheck</em></p>\n\
<p>This utility shows the messages that get passed to reference makers from a reference targets.</p>\n\
</li>\n\
<li><p>Transform Visualizer - <em>\\howto\\utilities\\TransformMatrixViz</em></p>\n\
<p>Allows the user to visualize the way transformation matrices are constructed in 3ds Max.</p>\n\
</li>\n\
<li><p>XRef Demonstration - <em>\\howto\\utilities\\xref</em></p>\n\
<p>A simple utility that shows how to work with XRefs.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sample_plug-ins.html\">Sample Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";