var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"sdk_requirements\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>SDK Requirements</h1></div><p>This topic provides information about the platform requirements for building plug-ins in different versions of 3ds Max.</p>\n\
<p>The following table shows the supported operating systems, compatible 3ds Max SDK, supported C++ compiler, .NET Framework and Qt versions, for  each 3ds Max version.</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th>3ds Max</th>\n\
<th>Target Operating Systems</th>\n\
<th>Compatible 3ds Max SDK</th>\n\
<th>C++ Compiler</th>\n\
<th>Minimum .NET Framework</th>\n\
<th>Qt</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>2024 (26.0)</td>\n\
<td><ul><li>Windows 10 x64</li><li>Windows 11</li></ul></td>\n\
<td>2024</td>\n\
<td>Microsoft Visual Studio 2019, version 16.10.4, C++ Platform Toolset v142, Windows Platform SDK 10.0.19041.0</td>\n\
<td>.NET 4.8</td>\n\
<td>Qt 5.15.1</td>\n\
</tr>\n\
<tr>\n\
<td>2023 (25.0)</td>\n\
<td><ul><li>Windows 10 x64</li><li>Windows 11</li></ul></td>\n\
<td>2023</td>\n\
<td>Microsoft Visual Studio 2019, version 16.10.4, C++ Platform Toolset v142, Windows Platform SDK 10.0.19041.0</td>\n\
<td>.NET 4.8</td>\n\
<td>Qt 5.15.1</td>\n\
</tr>\n\
<tr>\n\
<td>2022 (24.0)</td>\n\
<td><ul><li>Windows 10 x64</li></ul></td>\n\
<td>2022</td>\n\
<td>Microsoft Visual Studio 2017, Platform Toolset v141, <a href=\"https://developer.microsoft.com/en-us/windows/downloads/sdk-archive\" target=\"_blank\">Windows SDK 10.0.17134.0</a></td>\n\
<td>.NET 4.8</td>\n\
<td>Qt 5.15.1</td>\n\
</tr>\n\
<tr>\n\
<td>2021 (23.0)</td>\n\
<td><ul><li>Windows 8.1 x64</li><li>Windows 10 x64</li></ul></td>\n\
<td>2020</td>\n\
<td>Microsoft Visual Studio 2017, Platform Toolset v141, <a href=\"https://developer.microsoft.com/en-us/windows/downloads/sdk-archive\" target=\"_blank\">Windows SDK 10.0.17134.0</a></td>\n\
<td>.NET 4.7.2 or 4.8</td>\n\
<td>Qt 5.12.5 <br> Qt VS Tools 2.4.3 or higher</td>\n\
</tr>\n\
<tr>\n\
<td>2020 (22.0)</td>\n\
<td><ul><li>Windows 7 SP1 x64</li><li>Windows 8.1 x64</li><li>Windows 10 x64</li></ul></td>\n\
<td>2020</td>\n\
<td>Microsoft Visual Studio 2017, Platform Toolset v141, <a href=\"https://developer.microsoft.com/en-us/windows/downloads/sdk-archive\" target=\"_blank\">Windows SDK 10.0.17134.0</a></td>\n\
<td>.NET 4.7</td>\n\
<td>Qt 5.11.2</td>\n\
</tr>\n\
<tr>\n\
<td>2019 (21.0)</td>\n\
<td><ul><li>Windows 7 SP1 x64</li><li>Windows 8.1 x64</li><li>Windows 10 x64</li></ul></td>\n\
<td>2019</td>\n\
<td>Microsoft Visual Studio 2015 Update 3, Platform Toolset v140, <a href=\"https://developer.microsoft.com/en-us/windows/downloads/sdk-archive\" target=\"_blank\">Windows SDK 10.0.10586</a></td>\n\
<td>.NET 4.7</td>\n\
<td>Qt 5.6.3 or 5.6.2</td>\n\
</tr>\n\
<tr>\n\
<td>2018 (20.0)</td>\n\
<td><ul><li>Windows 7 SP1 x64</li><li>Windows 8.1 x64</li><li>Windows 10 x64</li></ul></td>\n\
<td>2018</td>\n\
<td>Microsoft Visual Studio 2015 Update 3, Platform Toolset v140, <a href=\"https://developer.microsoft.com/en-us/windows/downloads/sdk-archive\" target=\"_blank\">Windows SDK 10.0.10586</a></td>\n\
<td>.NET 4.6</td>\n\
<td>Qt 5.6.2</td>\n\
</tr>\n\
<tr>\n\
<td>2017 (19.0)</td>\n\
<td><ul><li>Windows 7 SP1 x64</li><li>Windows 8.1 x64</li><li>Windows 10 x64</li></ul></td>\n\
<td>2017</td>\n\
<td>Microsoft Visual Studio 2015 Update 3, Platform Toolset v140</td>\n\
<td>.NET 4.6</td>\n\
<td>Autodesk patched Qt 4.8.5. <br><a href=\"http://www.autodesk.com/develop3dsmax\" target=\"_blank\">Download binaries.</a> <br><a href=\"http://www.autodesk.com/company/legal-notices-trademarks/open-source-distribution\" target=\"_blank\">Download sources.</a></td>\n\
</tr>\n\
</tbody></table>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<div class=\"note note:\"><strong>Note</strong>: Older SDK requirements can be found in <a href=\"./sdk_requirements/sdk_requirements_archive.html\">SDK Requirements Archive</a>.</div>\n\
\n\
</div></div>\n\
\n\
<h2 id=\"microsoft-visual-studio-edition\">Microsoft Visual Studio Edition</h2><p>Microsoft ships several editions of the Visual Studio development environment: Community, Professional, and Enterprise. Any of these versions can be used to develop plug-ins for 3ds Max. More details about the various editions of Visual Studio and Visual C++ can be found at <a href=\"https://visualstudio.microsoft.com/vs/compare/\" target=\"_blank\">Compare Visual Studio Editions</a>.</p>\n\
<h2 id=\"microsoft-platform-sdk\">Microsoft Platform SDK</h2><p>You need the Microsoft Platform SDK to develop plug-ins for 3ds Max. The Platform SDK is included with Visual Studio.</p>\n\
<h2 id=\"qt\">Qt</h2><p>Starting with 3ds Max 2017, you can use the popular cross-platform development package Qt to create the user interface for your 3ds Max plug-in.  See <a href=\"./../3ds_max_developer_help/writing_plug-ins/using_qt_with_3ds_max_plug-ins.html\">Using Qt with 3ds Max Plug-ins</a> for more information.  3ds Max uses the LGPL version of Qt.</p>\n\
<p>Qt can be downloaded at: <a href=\"https://www.qt.io/download\" target=\"_blank\">https://www.qt.io/download</a></p>\n\
<p>The customized source code of Qt used by 3ds Max can be found <a href=\"https://www.autodesk.com/company/legal-notices-trademarks/open-source-distribution\" target=\"_blank\">here</a>.  These may be useful for debugging, as the source will exactly match the code used by 3ds Max.</p>\n\
<h2 id=\"third-party-sdks\">Third Party SDKs</h2><p>Various &quot;howto&quot; and &quot;sample&quot; projects require third party SDKs to compile.</p>\n\
<h3 id=\"directx-sdk\">DirectX SDK</h3><p>Some projects require the <a href=\"https://www.microsoft.com/en-us/download/details.aspx?id=6812\" target=\"_blank\">DirectX SDK June 2010</a>.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p><strong></strong> If you have an existing Microsoft Visual C++ 2010 Redistributable installed, you may receive an &quot;S1023&quot; error when you install the DirectX SDK.  This issue is resolved by uninstalling the MSVC++ 2010 Redistributable.  See <a href=\"https://support.microsoft.com/en-ca/help/2728613/s1023-error-when-you-install-the-directx-sdk-june-2010\" target=\"_blank\">this article</a> for more information.</p>\n\
\n\
</div></div>\n\
\n\
<h3 id=\"fbx-sdk\">FBX SDK</h3><p>The Point Cache modifier requires the FBX SDK 2020.3 VS2019 to compile. The FBX SDK can be found at <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">www.autodesk.com/fbx</a>. After installing, create two environment variables called <code>FBX_SDK_INC_DIR</code> and <code>FBX_SDK_LIB_DIR</code> that point to the include and library directories of the installed SDK, respectively. For example: </p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">FBX_SDK_INC_DIR=C:\\Program Files\\Autodesk\\FBX\\FBX SDK\\2020.3\\include \n\
FBX_SDK_LIB_DIR=C:\\Program Files\\Autodesk\\FBX\\FBX SDK\\2020.3\\lib\\vs2019</code></pre><h3 id=\"tbb-sdk\">TBB SDK</h3><p>The skinwrap (<em>maxsdk\\samples\\modifiers\\SkinWrap</em>) sample plug-in requires Intel TBB to compile. TBB Version 2020.3 is required. This can be downloaded at: <a href=\"https://github.com/oneapi-src/oneTBB/releases/tag/v2020.3\" target=\"_blank\">https://github.com/oneapi-src/oneTBB/releases/tag/v2020.3</a>. Note the licensing restrictions described at <a href=\"https://github.com/oneapi-src/oneTBB\" target=\"_blank\">https://github.com/oneapi-src/oneTBB</a>. After installing, create an environment variable called <code>TBB_DIR</code> that points to the installed SDK. For example: <code>TBB_DIR=D:\\tbb2020_3</code></p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p> 3ds Max itself uses TBB 2020.3, but other versions of the tbb.dll may be used by other processes that 3ds Max launches.</p>\n\
\n\
</div></div>\n\
\n\
<h3 id=\"zlib-sdk\">ZLib SDK</h3><p>The tif image library in the SDK samples (<strong>maxsdk\\samples\\images\\tif</strong>) previously required a customized version of zlib that was included as part of the 3ds Max install as <code>zlibdll.dll</code>. This sample now requires zlib 1.2.11 headers and libraries.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p><strong></strong> 3ds Max has moved to zlib 1.2.11 from a customized version of zlibdll used internally. zlib supports files larger than 4GB and fixes some security issues. For this reason, we recommend that you use zlib for your own plug-ins rather than the customized version used by the SDK samples. The required zlib 1.2.11 headers and libs are packaged in a zip file available on the Autodesk Developer Network here: <a href=\"https://www.autodesk.com/developer-network/platform-technologies/3ds-max\" target=\"_blank\">3ds Max Developer Center</a>.</p>\n\
\n\
</div></div>\n\
\n\
<blockquote>\n\
<p>After installing, create an environment variable called ZLIB_SDK_DIR that points to the installed zlib header and lib files.  For example: <code>ZLIB_SDK_DIR=H:\\zlib</code>.</p>\n\
</blockquote>\n\
<h3 id=\"libtiff-sdk\">LibTIFF SDK</h3><p>The tif image library in the SDK samples (<em>maxsdk\\samples\\images\\tif</em>) also requires the libtiff 4.3.0 headers and libraries. The required libtiff 4.3.0 headers and libs are packaged in a zip file available on the Autodesk Developer Network here: <a href=\"https://www.autodesk.com/developer-network/platform-technologies/3ds-max\" target=\"_blank\">3ds Max Developer Center</a>.</p>\n\
<p>After installing, create an environment variable called LIB_TIFF_DIR that points to the installed libtiff header and lib files. For example: <code>LIB_TIFF_DIR=D:\\libtiff</code>.</p>\n\
<h3 id=\"libpng-sdk\">LIBPNG SDK</h3><p>The png (<strong>maxsdk\\samples\\images\\png</strong>) sample plug-in requires libpng 1.6.37 to compile.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p><strong></strong> The required libpng 1.6.37 headers and libs are packaged in a zip file available on the Autodesk Developer Network here: <a href=\"https://www.autodesk.com/developer-network/platform-technologies/3ds-max\" target=\"_blank\">3ds Max Developer Center</a>.</p>\n\
\n\
</div></div>\n\
\n\
<blockquote>\n\
<p>After installing, create an environment variable called LIBPNG_SDK_DIR that points to the installed libpng header and lib files. For example: <code>LIBPNG_SDK_DIR=D:\\libpng\\libpng-1.6.37-upload\\libpng</code>.</p>\n\
</blockquote>\n\
<h2 id=\"operating-system\">Operating System</h2><p>It is recommended that you use the same version of Windows for development as the operating system used by the targeted version of 3ds Max.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p><strong></strong> Although a 64-bit version of Microsoft Windows is not required to build a 64-bit compatible plug-in, a 64-bit Microsoft Windows operating system is required to run the compiled plug-in.</p>\n\
\n\
</div></div>\n\
\n\
<h2 id=\"hardware-configurations\">Hardware Configurations</h2><p>Hardware configurations that can run 3ds Max are sufficient to develop plug-ins. See the 3ds Max user documentation for minimum hardware configurations necessary to run 3ds Max.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"sdk_requirements/sdk_requirements_archive.html\">SDK Requirements Archive</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../about_the_3ds_max_sdk.html\">About the 3ds Max SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";