var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"correctly_clearing_xor-ed_lines_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Correctly Clearing XOR-ed Lines Drawn in the Viewport</h1></div><p>Sometimes a plug-in needs to draw two-dimensional lines and shapes that are XOR-ed with the viewport image. The following is an example of drawing a XOR-ed rectangle using <code>XORDottedRect()</code> :</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">HWND hWnd = // the viewport&apos;s HWND to draw into\n\
IPoint2 p1, p2; // Opposites corners of the new rectangle \n\
IPoint2 p1_old, p2_old; // Opposite corners of the old rectangle \n\
XORDottedRect(hWnd, p1_old, p2_old); // Erase old rectangle\n\
XORDottedRect(hWnd, p1, p2); // Draw new rectangle</code></pre><p>When the Nitrous viewport is active, the code above will not clear the old rectangle. To ensure that the old lines are cleared in all viewport modes, the <code>bErase</code> parameter needs to be set to true in the first call to <code>XORDottedRect()</code>. The example then becomes:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">HWND hWnd = // the viewport&apos;s HWND to draw into\n\
IPoint2 p1, p2; // Opposites corners of the new rectangle \n\
IPoint2 p1_old, p2_old; // Opposite corners of the old rectangle \n\
XORDottedRect(hWnd, p1_old, p2_old, 0, true); // Erase old rectangle, explicitly erase foreground\n\
XORDottedRect(hWnd, p1, p2); // Draw new rectangle</code></pre><p>The above recommendation applies to the following functions: <code>XORDottedRect()</code>, <code>XORDottedCircle()</code>, <code>XORDottedPolyline()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../best_practices.html\">Best Practices</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";