var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"exception_safety\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Exception Safety</h1></div><p>Good C++ programming practices dictates that classes should be exception-safe. This can improve the stability of code, by preventing the possibility of partial construction of objects.</p>\n\
<p>One mechanism to achieve this is to use member initialization lists in a constructor instead of making assignments in the body of the constructor. This also improves the ability of the compiler to optimize your code. For more information consult the book The C++ Programming Language by Bjarne Stroustrup.</p>\n\
<p>Another mechanism is usage of the resource acquisition is initialization (RAII) pattern. This pattern is well-documented in various books on C++, and is out of the scope of this documentation.</p>\n\
<p>The 3ds Max SDK provides the <code>MaxSDK::VariableGuard</code> class which is a simple example of the RAII pattern in action. <code>MaxSDK::VariableGuard</code> automates the task of setting a variable to a new value, then resetting it to its old value in an exception safe manner. For more details see <code>maxsdk\\\\include\\\\VariableGuard.h.</code></p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../best_practices.html\">Best Practices</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";