var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"handling_wm_notify_messages\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Handling WM_NOTIFY Messages</h1></div><p>Plug-in code should not assume when receiving a <code>WM_NOTIFY</code> message that <code>lParam</code> is always a pointer to a structure of type <code>OFNOTIFY</code>. The <code>lParam</code> parameter should always be interpreted as a pointer to an object of type struct <code>NMHDR</code>. If <code>NMHDR::code</code> is between <code>\\[CDN_LAST</code>, CDN_FIRST and is equal to <code>CDN_INITDONE</code>, <code>lParam</code> could then be interpreted as a pointer to a <code>OFNOTIFY</code> struct.</p>\n\
<p>Here&apos;s a code snipped that correctly interprets the <code>lParam</code> parameter received with a <code>WM_NOTIFY</code> message sent to a file I/O hook procedure:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static INT_PTR CALLBACK HookProc(\n\
  HWNDhWnd, UINTmsg, WPARAMwParam, LPARAMlParam)\n\
{\n\
  switch (msg) {\n\
    case WM_NOTIFY: {\n\
      LPNMHDRpNMHDR = (LPNMHDR)lParam;\n\
      if (CDN_INITDONE == pNMHDR-&gt;code){\n\
         OFNOTIFY* pOfnotify = (OFNOTIFY*)lParam;\n\
        // Do something with pOfnotify\n\
      }\n\
      break;\n\
    }\n\
    // react to more messages\n\
  }\n\
return FALSE;\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../best_practices.html\">Best Practices</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";