var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"loadin_dlls_from_plugins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Loading DLLs From Plug-ins</h1></div><p>If your native plugin needs additional libraries, the easiest thing for plugin developers is to statically link any needed library into their plugins. The next easiest thing is to create implicit dependencies to required dlls and make sure these dlls are stored in the same folder as your binary plugin. </p>\n\
<p>In both cases, you have nothing special to do at runtime to load your libraries. If you must explicitly load dlls at runtime, you will need to take care also of any dependencies your dlls require. By default, the loader will not search in your plugin folder for dependent dlls. To ensure that, you need to:</p>\n\
<ul>\n\
<li>Save the value returned by <code>GetDllDirectory()</code></li>\n\
<li>Use <code>SetDllDirectory()</code> to specify the folder you want to load from or the folder where the dependencies of the dll you want to load are located</li>\n\
<li>Load your dll</li>\n\
<li>Use <code>SetDllDirectory()</code> again to restore the previous value</li>\n\
<li>Make sure that your override of the dll directory is active for the shortest time possible.</li>\n\
</ul>\n\
<p>Never call <code>SetDllDirectory(nullptr)</code>, it adds the current working directory to the search path and causes a security vulnerability.</p>\n\
<p>Always restore the dll directory to its original value. Not doing so can cause load issues for other plugins.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../best_practices.html\">Best Practices</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";