var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"memory_management\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Memory Management</h1></div><p>To ensure that a plug-in does not cause instability in the 3ds Max, the following rules must be followed for all objects that may be shared from a plug-in with 3ds Max.</p>\n\
<ol>\n\
<li>A class or struct defined by the plug-in should inherit directly or indirectly from the <code>MaxHeapOperators</code> class.</li>\n\
<li>Do not use custom allocation schemes (e.g. overloading operator <code>new</code>, or using the placement <code>new</code> operator).</li>\n\
<li>Use <code>MAX_malloc()</code> and related operations from <code>maxheapdirect.h</code> to allocate objects on the heap which are not derived from <code>MaxHeapOperators</code> instead of standard C memory handling routines such as <code>malloc</code>.</li>\n\
</ol>\n\
<p>Virtually every class and struct in the 3ds Max SDK has <code>MaxHeapOperators</code> as a base class, so inheriting from any of these classes assures that you have <code>MaxHeapOperators</code> as a base class. Although this can create a diamond-shaped inheritance pattern for types with multiple base classes, <code>MaxHeapOperators</code> uses only static member functions; name-resolution ambiguities should not occur.</p>\n\
<p>These rules are important because objects shared with 3ds Max have to be allocated on a single shared heap managed by 3ds Max. For more information on what problem <code>MaxHeapOperators</code> is trying to solve see <a href=\"http://msdn.microsoft.com/en-us/library/ms235460.aspx\" target=\"_blank\">MSDN</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"memory_management/smart_pointers_autoptr.html\">Smart Pointers (AutoPtr)</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"memory_management/addappdatachunk_and_max_malloc.html\">AddAppDataChunk and MAX_malloc()</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../best_practices.html\">Best Practices</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";