var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_maxscript_or_c\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: MAXScript or C++</h1></div><p>There are several approaches to writing plug-in applications:</p>\n\
<ul>\n\
<li><em>MAXScript</em>, the native scripting language for 3ds Max</li>\n\
<li>Native code compiled from C++ using the <em>3ds Max SDK</em></li>\n\
<li>A combination of <em>MAXScript</em> and the <em>3ds Max SDK</em></li>\n\
</ul>\n\
<p>Which approach you choose depends partly on how you want to work, and partly on what you want your plug-in to accomplish. Each approach has its strengths and limitations, but you can develop complex applications regardless of your choice.</p>\n\
<h2 id=\"maxscript\">MAXScript</h2><p><em>MAXScript</em> provides some methods that are higher level than those to be found in the <em>SDK</em>, and supports a few 3ds Max features and capabilities that are not exposed to the <em>SDK</em>.</p>\n\
<p>If your feature needs functionality supported by MAXScript but not the SDK, then MAXScript is your only choice. In particular, exposing 3ds Max features through OLE/ActiveX controls is easier to code in MAXScript than it is with the SDK.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> There is also a Python API available. Since Python code is executed from MAXScript, you need to create a MAXScript plug-in to use it as a plug-in. See the 3ds Max Python API Help for more information.</p>\n\
\n\
</div></div>\n\
\n\
<p><em>MAXScript</em> is often used for creating plug-ins that don&#39;t requires high performance, prototypes of plug-ins and writing test suites.</p>\n\
<h2 id=\"3ds-max-sdk\">3ds Max SDK</h2><p>Plug-ins written in C++ with the <em>SDK</em> generally run faster than their <em>MAXScript</em> counterparts.</p>\n\
<p>The <em>SDK</em> is preferable when performance is important, particularly when computation rather than interactivity is the main purpose of the plug-in. Performance is most often an issue when the plug-in handles large sets of entities such as objects, sub-objects, files, notification messages, and so on.</p>\n\
<h2 id=\"combination-of-maxscript-and-the-3ds-max-sdk\">Combination of MAXScript and the 3ds Max SDK</h2><p>The combination of <em>MAXScript</em> and native C++ code gives you the best of both worlds when speed of development, complexity and performance are attributes of your development goals. Also see the topic on the <a href=\"./../3ds_max_sdk_features/maxscript_scripting_engine.html\">MAXScript Scripting Engine</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";