var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_parameter_blocks\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: Parameter Blocks</h1></div><p>The 3ds Max parameter block system is a mechanism used by 3ds Max to manage parameters used by a plug-in (e.g. a bend modifier&#39;s angle parameter, or a sphere&#39;s radius parameter).</p>\n\
<p>3ds Max uses the parameter block system to:</p>\n\
<ol>\n\
<li>Expose a UI element to the user either automatically or manually</li>\n\
<li>Notify the plug-in of changes to parameters using the reference system.</li>\n\
<li>Serialize plug-in data (specifically the data stored in parameters associated with a parameter block)</li>\n\
<li>Expose plug-in data to MAXScript.</li>\n\
</ol>\n\
<p>Parameter blocks are represented using the class <code>IParamBlock2</code>, and are constructed from a parameter block descriptor class (<code>ParamBlockDesc2</code>).</p>\n\
<h2 id=\"parameter-blocks-are-reference-targets\">Parameter Blocks are Reference Targets</h2><p>It is key point to realize that a parameter block is a reference target, and that a plug-in which manages a parameter block is supposed to derive from <code>ReferenceMaker</code> and must properly override <code>ReferenceMaker::GetReference()</code> and <code>ReferenceMaker::SetReference()</code> to handle <code>IParamBlock2</code> objects as reference targets.</p>\n\
<p>This will allow the plug-in to be notified (i.e. 3ds Max will call the plug-in&#39;s implementation of <code>ReferenceMaker::NotifyRefChanged()</code>) whenever a change occurs on the parameter (e.g. when the user manipulates the associated UI element, or another plug-in updates the parameter, or when it is changed through MAXScript).</p>\n\
<p>For more information see the topic <a href=\"./../writing_plug-ins/plug-in_basics/exposing_and_managing_references.html\">Exposing and Managing References</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";