var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: Plug-ins</h1></div><p>A plug-in describes scene entities, such as procedural (parametric) objects, materials, etc, processes that manipulate them, such as the process of rendering or exporting a scene, or customize how 3ds Max looks and behaves. Plug-ins can be written in C++, MAXScript, or .NET. Most plug-ins are written in C++.</p>\n\
<p>Plugins are packaged in DLLs (dynamic load libraries). 3ds Max recognizes DLLs that contain plugins and loads them into its process space when it starts up or when an instance of a plug-in from that DLL is required to perform a task, such as importing data from a file in a given format into the 3ds Max scene. To speed up the plug-in DLL identification process, 3ds Max looks in specific folders for DLL files with specific extensions such as dlo, dlm, dlt, dlu, etc .</p>\n\
<p>Most plug-ins fall into one of the following categories:</p>\n\
<ul>\n\
<li>Object Plug-ins - These plug-ins (also called procedural or parametric object plug-ins) represent objects the user can create and manipulate interactively in the viewport. Examples of such plug-ins include geometrical primitives (teapot, torus, etc), shapes, lights, camera, and helpers. Plug-ins in this category are expected to be packaged in DLLs with the &quot;dlo&quot; extension.</li>\n\
<li>Modifier Plug-ins - These are plug-ins that take as input a procedural object or a mesh of some kind (triangle mesh, patch mesh, poly-mesh) and apply a transformation to it. Examples include deformers such as bend, taper, etc, mesh editing modifiers such as extrude, bevel, etc. Plug-ins in this category are expected to be packaged in DLLs with the &quot;dlm&quot; extension.</li>\n\
<li>Animation Controller Plug-ins - The main role of these plug-ins is to store and interpolate between animation keyframe values of basic data types such as integers and floats. Controllers can expose sub-controllers. This allows for creating more complex controllers such as constraints. Controllers are used everywhere in 3ds Max, starting with the position, rotation and scale of objects to constraints, from evaluators of expressions written in MAXScript to generators of fractal noise. Plug-ins in this category are expected to be packaged in DLLs with the &quot;dlc&quot; extension.</li>\n\
<li>Materials and Texture Plug-ins - These plug-ins allow for defining the look, or appearance of objects when displayed in the viewport and rendered. Materials define how objects interact (reflect, transmit, etc) light. Texture maps add details or complexity to the appearance of objects. Plug-ins in this category are expected to be packaged in DLLs with the &quot;dlt&quot; extension.</li>\n\
<li>Rendering plug-ins - These plug-ins can add effects such as glare, shadows, etc to a scene, or render the entire scene. The plug-in is not restricted in the rendering method it implements (scan-line, ray-tracing, etc). Plug-ins in this category are normally expected to be packaged in DLLs with the &quot;dlr&quot; or &quot;dlv&quot; extension.</li>\n\
<li>Scene Data Import Export Plug-ins - These plug-ins either import or export 3D scene data such as geometry, lights, camera, materials, textures, etc. Plug-ins in this category are normally expected to be packaged in DLLs with the &quot;dle&quot; or &quot;dli&quot; extension.</li>\n\
<li>Image File IO Plug-ins - These plug-ins allow for importing and saving images (such as a rendering of the scene) in various formats such as bmp, jpg, png, high-dynamic range, etc). Plug-ins in this category are expected to be packaged in DLLs with the &quot;bmi&quot; extension.</li>\n\
<li>Utility Plug-ins - These plug-ins usually perform some operation on scene entities, such as display information about the selected objects, or provide other miscellaneous services. Plug-ins in this category are expected to be packaged in DLLs with the &quot;dlu&quot; or &quot;gup&quot; extension.</li>\n\
<li>MAXScript Plug-ins - These plug-ins customize how the MAXScript engine works or extend it with new functionality, such as C++ implemented functions.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";