var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_reference_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: Reference System</h1></div><p>A reference indicates a dependency between two plug-ins, or a 3ds Max object and a plug-in. 3ds Max uses the reference system for several purposes:</p>\n\
<ol>\n\
<li>Notifying dependent scene objects of changes or events</li>\n\
<li>Managing automatic deletion of objects</li>\n\
<li>Loading and saving the scene graph</li>\n\
</ol>\n\
<p>Most references can be observed in 3ds Max using the schematic view. Note some references are not shown in the schematic view, such as parameter blocks).</p>\n\
<p>The following diagram demonstrates the reference relationship between a camera, the look-at controller, it&#39;s parameter block, and the teapot.</p>\n\
<p><img src=\"./images/GUID-54A60EEC-D576-42B8-9A78-C8DF8E0C8152-low.png\" alt=\"\"></p>\n\
<h2 id=\"references-as-observer-subject-relations\">References as Observer-Subject Relations</h2><p>In its first role the reference system is essentially an implementation of the observer design pattern. Observers derive from the <code>ReferenceMaker</code> class, while subjects derive from the <code>ReferenceTarget</code> class. The relationship is initiated by calling <code>ReferenceMaker::ReplaceReference(int,ReferenceTarget*)</code>.</p>\n\
<p>The Look-At constraint controller illustrates the purpose of the reference system. The Look-At Constraint is a rotation controller - it controls the rotation of an object in the scene. The Look-At Constraint rotates the item it is assigned to so that it always points towards (or &quot;looks at&quot;) another object. For example, you create a Free Camera and assign the Look-At Constraint as the camera&#39;s rotation controller; you then pick a Teapot in the scene as the target of the Look-At Constraint. This causes the Free Camera to rotate to remain aimed at the Teapot. If the Teapot moves, the controller adjusts itself to point the camera towards the Teapot. Also, if the Teapot is deleted from the scene, the Camera recognizes this and simply remains stationary.</p>\n\
<p>Now consider that each of these items (the Camera, the Look-At Constraint, and the Teapot) are all plug-ins, each written without any specific knowledge of the other objects, but 3ds Max needs to coordinate them. How does the Camera know that the Teapot moves so it can change the direction it is pointed in? Or how does the Look-At Constraint know that the Teapot has been deleted from the scene? These objects communicate using reference messages.</p>\n\
<p>A reference associates two scene objects. One object is considered to be dependent upon the other. In the above example, the Look-At Constraint is dependent on the Teapot and the Camera is dependent on the Look-At Constraint controller. That is to say, if the Teapot changes in some way it needs to let other objects that might depend on it know it has changed. The controller, via the Reference, is notified that the Teapot has changed. And the controller needs to do the same for those items which depend on it. When the controller changes, it lets those items which may depend on it know. Thus the camera is notified.</p>\n\
<p>In the example above, the Camera is a <code>ReferenceMaker</code>. It references the Look-At Constraint which is the <code>ReferenceTarget</code> of the Camera. The Look-At Constraint is also a<code>ReferenceMaker</code>, it references the Teapot. In fact <code>ReferenceTarget</code> derives from <code>ReferenceMaker</code>, because anything that can be an observer, can also be observed.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";