var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_scene_graph_and_nodes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: Scene Graph and Nodes</h1></div><p>In a 3ds Max scene the objects that a user can create and manipulate in the viewports are called scene objects. Scene objects derive from the <code>Object</code> class. Examples of scene objects are geometric objects (<code>GeomObject</code>), lights (<code>LightObject</code>), cameras (<code>CameraObject</code>), particles, and world space modifiers (not to be confused with regular modifiers).</p>\n\
<p>The geometry pipeline system of 3ds Max handles mesh processing and conversion. It allows objects to be operated on by modifiers, with the eventual generation of a triangle mesh suitable for rendering and display in the viewports. For more information, see the section on the <a href=\"./../3ds_max_sdk_features/modeling/geometry_pipeline_system.html\">Geometry Pipeline System</a>. For information on how objects and modifiers work together to facilitate modification, see the section on <a href=\"./../3ds_max_sdk_features/modeling/modifiers.html\">Modifiers</a>.</p>\n\
<p>Like most modeling and rendering software 3ds Max has a notion of scene graph, which is a tree of scene nodes. Each node is a hub of information for scene objects in the scene. A node is implemented by 3ds Max and exposes its services through the <code>INode</code> interface class.</p>\n\
<p>A node has multiple responsibilities, including:</p>\n\
<ul>\n\
<li>Storing a pointer to a scene object.</li>\n\
<li>Storing information about what modifiers have been applied to the object</li>\n\
<li>Applying modifiers to an object</li>\n\
<li>Storing information about the geometry</li>\n\
<li>Stores information about the material that defines the surface properties of the object the node represents in the scene.</li>\n\
<li>Storing position, rotation and scale information of an object using a transform controller</li>\n\
<li>Managing appearance and surface properties through the material</li>\n\
<li>Storing node tree hierarchy information (e.g. parent - child relationships)</li>\n\
</ul>\n\
<p>Usually you will get a node and then extract the specific 3ds Max scene object from it. In effect, the node wraps the scene object. When creating a scene object, you also have to create a node in order for it to appear in the scene. Nodes are managed entirely by 3ds Max, and are not implemented by plug-ins. Plug-ins can however access, create, and delete nodes.</p>\n\
<p>For more information, see the section on <a href=\"./../3ds_max_sdk_features/scenes_and_nodes/nodes.html\">Nodes</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";