var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_time_and_intervals\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: Time and Intervals</h1></div><p>Developers working with animation need to specify points in time and time intervals. The basic unit of time in 3ds Max and the SDK is 1/4800th of a second. This length of time is a data type named <code>TimeValue</code>. <code>TimeValue</code>s are used throughout the class methods in the SDK when a particular instant in time needs to be specified. For example, if your plug-in needs to know the current system time (the position of the 3ds Max frame slider) it calls <code>Interface::GetTime()</code>, which returns a <code>TimeValue</code> that indicates the current time.</p>\n\
<p>In 3ds Max, intervals are commonly used to define the time period in which an object remains unchanged. For processing efficiency, 3ds Max avoids re-computing objects whenever it can. If an animated plug-in can specify how long it will remain unchanged, 3ds Max does not need to re-evaluate the object during that time interval. For example, 3ds Max needs to know for how long a modification made by a modifier can be assumed to be valid. Consider a Bend modifier where the user has animated the bend angle over time: un-bent from frame 0 to frame 50, and then bent 45 degrees at frame 100. So that 3ds Max does not need to re-evaluate the modifier every frame (it is not bending from frame 0 to 50) the modifier provides 3ds Max with a Validity Interval that indicates how long the object remains unmodified. This Validity Interval is expressed as a Time Interval that starts at given time. So, if 3ds Max asks the modifier, at Frame 0, for the Time Interval that the object remains unmodified, the response is 50. If 3ds Max asks the modifier, at Frame 75, for example, the Time Interval that the object remains unmodified, the response is 1, because the modifier continuously bends, at each frame, from frame 51 to frame 100.</p>\n\
<p>Intervals of time are specified in the SDK using an Interval object. This object has a start and end time and various methods to work with the interval. There are numerous methods that a plug-in implements to specify Validity Intervals. The modifier example above would do so using the method <code>Modifier::LocalValidity</code>().</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";