var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"overview_user_interface\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Overview: User Interface</h1></div><p>The user interacts with 3ds Max and plug-ins mainly using the command panel roll-ups and dialogs, the mouse (or tablet), the keyboard, and the 3D viewport. The 3ds Max SDK provides developers with the ability to control each of these methods of user interaction.</p>\n\
<p>Plug-ins generally provide their user interface controls in one of these ways:</p>\n\
<ol>\n\
<li>In one or more of the command panel branches</li>\n\
<li>In roll-ups which appear in the Materials Editor, Environment, or Render dialogs</li>\n\
<li>Using modal or modeless floating dialogs.</li>\n\
</ol>\n\
<p>Many of the buttons, spinners, edit fields, etc. that appear in these dialogs and roll-ups are from the set of the 3ds Max&#39;s custom controls. Use of them makes the UI of plug-ins consistent in appearance. For more information on these controls and how to work with them see the topic on <a href=\"./../3ds_max_sdk_features/user_interface/custom_user_interface_controls.html\">Custom User Interface Controls</a>.</p>\n\
<p>As of 3ds Max 2017, plug-in UIs can also be created using Qt. For more information see <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins.html\">Using Qt with 3ds Max Plug-ins</a>.</p>\n\
<p>In addition to the custom controls, the mouse is used for interaction. The way this type of interaction is handled in the SDK is through what are called Command Modes. For more information see the topic on <a href=\"./../3ds_max_sdk_features/user_interface/command_modes_and_mouse_procedur.html\">Command Modes and Mouse Procedures</a>.</p>\n\
<p>Plug-ins can also use the keyboard to facilitate user interaction. This is done by interacting with the action system, handled principally by the <code>ActionTable</code> class.</p>\n\
<p>Finally, plug-ins often need to draw in the 3D viewports to show themselves or their &#39;gizmos&#39;. This is accomplished using the methods provided by the interactive renderer <code>GraphicsWindow</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../overview.html\">Overview</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";