var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_2009_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 2009 SDK</h1></div><p>Autodesk&#39;s goal was to minimize the effort required by 3rd party developers to migrate their plug-ins to 3ds Max 2009. Only important changes that benefit the robustness and flexibility of the SDK are implemented. The following is a brief summary of the new features and enhancements introduced in 3ds Max 2009 SDK, with links to more information where applicable:</p>\n\
<ul>\n\
<li><em>Scene Event Manager - I</em>n previous versions of the 3ds Max SDK, developers faced significant complexities in order to monitor changes to properties of nodes in the scene, such as node geometry, material and controller assignments, or location in the scene hierarchy. Different events were reported through different mechanisms, and obtaining complete information about every node would require managing large numbers of references, degrading system performance. In 3ds Max 2009 the Scene Event System (implemented by the interface <code>ISceneEventManager</code>) provides a simplified, unified mechanism for monitoring changes to all properties of all nodes simultaneously. Using the Scene Event Manager greatly simplifies client code, and increases robustness while improving performance and stability. This simplified system supports a broad range of messages compared to previous systems, but provides less details regarding single events. The Scene Event System is useful in situations requiring high-level information about scene changes and where precision timing of messages is not a priority. For more information, see <code>ISceneEventManager.h</code>.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>Support for Combo Boxes in Parameter Block Descriptors -</em> A new control type, <code>TYPE_INT_COMBOBOX</code>, can now be associated with parameters of type <code>TYPE_INT</code> and <code>TYPE_INT_TAB</code>. For more information, see the <code>p_ui</code> entry in the C++ Reference&#39;s &quot;<code>Related Pages &amp;gt; Lists and Functions &amp;gt; List of ParamTags Choices</code>&quot;.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>Support for Tooltips in Parameter Block Descriptors -</em> A tooltip can be specified as part of the user interface description of a parameter in a parameter block using the <code>p_tooltip</code> flag. See the <code>p_tooltip</code> entry in the C++ Reference&#39;s &quot;<code>Related Pages &amp;gt; Lists and Functions &amp;gt; List of ParamTags Choices</code>&quot;. In addition, all custom controls allow for setting a tooltip string using the method <code>ICustomControl::SetTooltip()</code>. See <code>custcont.h</code> for more details. The <code>ToolTipExtender</code> class simplifies the task of setting up tooltips for user interface elements that do not derive from <code>ICustomControl</code>. For more information, see maxsdk\\include\\winutil.h.</li>\n\
<li><em>Generic Meta Data Support -</em> Meta-data are custom attributes that can be created by SDK clients at run-time and stored on instances of Animatable, as opposed to having to write a custom attribute plug-in, compile it, have 3ds Max load it and then create instances of it. For more information see <code>imetadata.h</code>.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>New photometric light types -</em> New photometric light types (disc, sphere, and cylinder) are supported by the <em>3ds Max 2009 SDK</em>. See <code>lslights.h</code> for details.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>Biped improvements -</em> Bipeds now support triangle neck, fore-feet and in-place mirroring. See <code>Biped11.Api.h</code> for details.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>Edit Soft-Selection Command Mode -</em> A new command mode allows for interactive editing of the falloff, pinch and bubble parameters of a soft-selection. See <code>EditSoftSelectionMode.h</code> for details.</li>\n\
</ul>\n\
<!-- -->\n\
\n\
<ul>\n\
<li><em>Improved compatibility between GDI calls and Vista Aero -</em> <code>XOR</code> drawing methods in the SDK (such as <code>XORDottedRect</code>, <code>XORDottedCircle</code>, and <code>XORDottedPolyline</code>) have been extended to support Vista Aero. See <code>winutil.h</code> for details.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../archive.html\">What&#x27;s New in Older Versions</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";