var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"incremental_improvements_2010\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Incremental Improvements</h1></div><p>The following is a list of incremental improvements to the 3ds Max SDK:</p>\n\
<ul>\n\
<li><p>Windows Message Filtering - A new class <code>MaxSDK::WindowsMessageFilter</code> has been added that allows safe and convenient filtering of messages for progress dialogs. For more information see <a href=\"./../../../3ds_max_sdk_features/user_interface/windows_message_filtering.html\">Windows Message Filtering</a>.</p>\n\
</li>\n\
<li><p>Thread tools - A new class that allow control of the amount of threading in various parts of 3ds Max. See <a href=\"./../../../3ds_max_sdk_features/miscellaneous_topics/thread_tools.html\">Thread Tools</a> for more information</p>\n\
</li>\n\
<li><p>Bitmap pager - The new bitmap pager feature reduces the memory footprint of bitmap data by swapping that data to and from disk. The <code>IBitmapPager</code> interface controls the pager and memory usage for bitmaps.</p>\n\
</li>\n\
<li><p>Variable guard - A new helper class allows exception safe setting and resetting of variables. See <a href=\"./../../../best_practices/exception_safety.html\">Exception Safety</a> for more information.</p>\n\
</li>\n\
<li><p>Biped enhancements - The new interface <code>IBipMaster12</code> extends <code>IBipMaster11</code> with support for knuckles and choosing the number of links in thumbs and for retargeting biped layer animation. The retargeting can be done either to the base layer or a reference biped. See <code>maxsdk</code>\\include\\CS\\Biped12Api.h for more information.</p>\n\
</li>\n\
<li><p>Policy based AutoPtr - The <code>AutoPtr</code>&lt;&gt; class template is now policy based. This means that an optional policy parameter can be passed as a template argument that allows the method of destruction of the resource to be dictated. See <a href=\"./../../../best_practices/memory_management/smart_pointers_autoptr.html\">Smart Pointers (AutoPtr)</a> for more information.</p>\n\
</li>\n\
<li><p>File extension defaults - The <code>FilterList</code> class now records the user&#39;s choice of file extension. Plug-ins can use that as the default choice the next time they need to present the user with a File Open or File Save dialog.</p>\n\
</li>\n\
<li><p>Querying language - Two new methods allow for retrieving the language used by 3ds Max. The language can be retrieved either as a combination of primary and secondary language ids (such as LANG_CHINESE and SUBLANG_CHINESE_SIMPLIFIED) or as a three letter acronym (TLA). These methods allow plugins to switch their user interfaces at run-time based on the language used by 3ds Max. <code>MaxSDK::Util::GetLanguageID()</code> and <code>MaxSDK::Util::GetLanguageTLA()</code>.</p>\n\
</li>\n\
<li><p>Drag-and-Drop improvements - New <code>DADMgr</code> methods allow for querying the destination object on which an item is dropped and the source drag-and-drop manager. These new methods allow for deeper customization of the drag-and-drop process <code>DADMgr::GetDestinationInstance()</code> and <code>DADMgr::Drop()</code>.</p>\n\
</li>\n\
<li><p>Viewport button - The new <code>IViewportButton</code> class represents buttons displayed in the viewport. They allow the user to perform actions associated with the buttons via mouse input. For more information see <a href=\"./../../../3ds_max_sdk_features/viewports_and_graphics_windows/graphics_window/viewport_button.html\">Viewport Button</a>.</p>\n\
</li>\n\
<li><p>Hardware mesh - Plug-ins can now build a mesh that is meant only for display by the graphics window system (which may or may not use hardware acceleration). The hardware mesh can be displayed without having to use the <code>Mesh</code> or <code>MNMesh</code> classes. This means that they are considerably cheaper on memory usage since the objects don&#39;t need to be instantiated in order to display the mesh. For more information see <a href=\"./../../../3ds_max_sdk_features/modeling/meshes/hardware_mesh_support.html\">Hardware Mesh Support</a>.</p>\n\
</li>\n\
<li><p>Assert Improvement - Failed assertions now provide additional information in the assert dialog (i.e. function name and expression). This happens automatically in all use of the <code>DbgAssert</code> macro. <code>CAssertCB::Assert()</code> has been replaced with <code>CAssertCB::AssertEx()</code>.</p>\n\
</li>\n\
<li><p>Retrieving Product Type - The new API <code>UtilityInterface::GetProductID()</code> provides a robust method to programmatically identify whether the currently executing 3ds Max product flavor is 3ds Max Design or 3ds Max. Note that the method <code>UtilityInterface::GetProductName()</code> is not a robust way for plug-ins to distinguish between the different 3ds Max product flavors, since the names are subject to change, and such a change could break existing plug-in code.</p>\n\
</li>\n\
<li><p>Virtual Destructors - Destructors have been made virtual in a number of base classes, making deletion of classes possible using a base class pointer.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2010_sdk.html\">What&#x27;s New: 3ds Max 2010 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";