var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plug-in_upgrade_guide\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plug-in Upgrade Guide</h1></div><p>3ds Max 2010 is not binary compatible with plug-ins built with earlier versions of the 3ds Max SDK. This guide describes most changes needed to upgrade a plug-in to 3ds Max 2010. Depending on what version of 3ds Max your plug-in was compiled against you should consult the appropriate what&#39;s new guide for each intermediate version of 3ds Max SDK.</p>\n\
<p>The following are the major new features in 3ds Max SDK 2010 that require changes to existing plug-ins.</p>\n\
<ul>\n\
<li><p>Asset file management - The methods in the 3ds Max SDK that were passing file names as strings have been replaced by methods that use <code>MaxSDK::AssetManagement::AssetUser</code> instead. File paths representing assets should never be stored by plug-ins as strings. Plug-ins should switch to representing file assets as described in the topic <a href=\"./../../../3ds_max_sdk_features/scenes_and_nodes/assets/declaring_and_representing_asset.html\">Declaring and Representing Assets</a>.</p>\n\
</li>\n\
<li><p>Asset file resolution - Any code related to asset file resolution using the <code>IPathConfigMgr</code> and <code>Interface</code> classes will have to be updated to use the corresponding methods of the new class <code>IFileResolutionManager</code>. The various directory methods on class <code>Interface</code> and class <code>IPathConfigMgr</code> are replaced with new methods that uses <code>MaxSDK::AssetManagement::AssetType</code>. In <code>IFileResolutionManager</code> a set of methods have been exposed to manage a path caching mechanism. We have removed the <code>xref</code> boolean parameter that could be passed to <code>IFileResolutionManager::GetFullFilePath()</code>. See <a href=\"./../../../3ds_max_sdk_features/scenes_and_nodes/assets/asset_file_path_resolution.html\">Asset File Path Resolution</a> for more information.</p>\n\
</li>\n\
<li><p>Asset enumeration - Code that referred to <code>IAssetAccessor::AssetType</code> needs to be updated to use the new enumeration <code>MaxSDK::AssetManagement::AssetType</code>. See <a href=\"./../../../3ds_max_sdk_features/scenes_and_nodes/assets/enumerating_and_exposing_assets.html\">Enumerating and Exposing Assets</a> for more information.</p>\n\
</li>\n\
<li><p>AutoPtr - The new policy based <code>MaxSDK::AutoPtr</code> has no impact on existing plug-ins except when <code>MaxSDK::AutoPtr</code> had ownership of an object that is not destroyed via the delete operator. In those cases, the plug-in code will need to change to use the appropriate specialization of the <code>MaxSDK::AutoPtr</code> class template.</p>\n\
</li>\n\
<li><p>User interface updates - A number of changes to the 3ds Max user interface will have an impact on existing plug-ins. See <a href=\"user_interface_updates.html\"\">User Interface Updates</a> for more information.</p>\n\
</li>\n\
<li><p>Window message filtering - Progress dialogs should now use the class <code>MaxSDK::WindowsMessageFilter</code> for filtering windows messages to avoid issues that may cause Windows WPF controls to cease functioning. For more information see <a href=\"./../../../3ds_max_sdk_features/user_interface/windows_message_filtering.html\">Windows Message Filtering</a>.</p>\n\
</li>\n\
</ul>\n\
<p>There have been several changes to the SDK designed to increase the stability of 3ds Max. The following is a summary of changes.</p>\n\
<ul>\n\
<li><p>The 3ds Max SDK now uses <code>MCHAR</code> instead of <code>TCHAR</code> and <code>MSTR</code> instead of <code>TSTR</code>. While no change is necessary to plug-in code for this version of 3ds Max, future versions of 3ds Max may deprecate <code>TCHAR</code> and <code>TSTR</code> in order to support Unicode.</p>\n\
</li>\n\
<li><p>3ds Max SDK now uses <code>const</code> qualifiers on arguments and return values of type <code>MCHAR</code>* and <code>MSTR</code>&amp; where appropriate.</p>\n\
</li>\n\
<li><p><code>RefListItem</code>, <code>RefList</code> and <code>ReferenceTarget::GetRefList()</code> were deprecated. Also, the public data member <code>ReferenceTarget::refs</code> has been made private. Plug-ins should use <code>DependentIterator</code> to iterate through the direct dependents (<code>ReferenceMaker</code>s) of a given <code>ReferenceTarget</code> instance. See the <code>DependentIterator</code> documentation for an example on how to iterate over the dependents of a <code>ReferenceTarget</code>.</p>\n\
</li>\n\
<li><p>The <code>IAssetAccessor</code> has been modified to handle assets as <code>MaxSDK::AssetManagement::AssetUser</code> instances. The methods that were using strings for asset representation were deprecated. The class <code>NameEnumCallback</code> and the corresponding method <code>Animatable::EnumAuxFiles()</code> have also been deprecated. The new <code>AssetEnumCallback</code> class and corresponding <code>Animatable::EnumAuxFiles()</code> should be implemented and used by plug-ins.</p>\n\
</li>\n\
<li><p>The file <code>IAssetAccessor</code>. h has moved from the folder <code>maxsdk</code>\\include to <code>maxsdk</code>\\include\\assetmanagement.</p>\n\
</li>\n\
<li><p>3ds Max now enforces correct deletion of plug-in instances via pointers to class <code>Animatable</code>, <code>ReferenceMaker</code>, or <code>ReferenceTarget</code>; the destructor of these classes has been made protected. As a side effect, instances of these classes cannot be allocated on the stack or passed by value as function parameters. For information on how to properly deallocate these objects see the topic <a href=\"./../../../3ds_max_sdk_features/reference_system/reference_object_lifetime_manage.html\">Reference Object Lifetime Management</a>.</p>\n\
</li>\n\
<li><p>Destructors have been made virtual in a number of base classes, making deletion of classes possible using a base class pointer.</p>\n\
</li>\n\
</ul>\n\
<p>See the reference section for a <code>list of deprecated API elements</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2010_sdk.html\">What&#x27;s New: 3ds Max 2010 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";