var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"incremental_improvements_2011\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Incremental Improvements</h1></div><p>The following is a list of incremental improvements to the 3ds Max SDK:</p>\n\
<h2 id=\"environment-variables\">Environment Variables</h2><p>The installer of 3ds Max and the SDK now create the following environment variables:</p>\n\
<ul>\n\
<li><code>3DSMAX_2011_PATH</code> - Path to 3ds Max 2011 executable directory 32 bit version</li>\n\
<li><code>3DSMAX_2011x64_PATH</code> - Path to 3ds Max 2011 executable directory 64 bit version</li>\n\
<li><code>3DSMAX_2011_SDK_PATH</code> - Path to the 3ds Max 2011 SDK directory</li>\n\
</ul>\n\
<h2 id=\"ui-changes\">UI Changes</h2><p>The method <code>ICustomControl::UpdateEnableState()</code> has been added to the class <code>ICustomControl</code>. This is a helper function to enable or disable a UI control based on whether the <code>Animatable</code> associated with it supports keyframes or not. Note that locked parameters or scripted parameters can not be keyframed.</p>\n\
<h2 id=\"changes-to-sdk-header-files\">Changes to SDK Header Files</h2><p>The 3ds Max SDK header files have been cleaned up and the following changes have been implemented:</p>\n\
<ul>\n\
<li>All header files now compile cleanly at warning level 4.</li>\n\
<li>Each header file can compile correctly on its own.</li>\n\
<li>The MAXScript header files have been renamed and reorganized. They are now contained in a new folder called  <em>maxscript</em> . Including one of the old header files now automatically includes the appropriate header file from the new directory.</li>\n\
<li>No SDK header files include  <em>max.h</em> </li>\n\
<li>The header file  <em>animtbl.h</em>  has been broken up into several new header files</li>\n\
</ul>\n\
<p>As a result of this refactoring effort, in some cases projects that relied on the fact that  <em>max.h</em>  was included indirectly through another file, may now require additional include directives to successfully compile. In this case we suggest consulting the Max SDK reference guide to find the header files missing, or to use a 3rd party tool such as Visual Assist. Our suggestions for updating your plug-ins to take advantage of these changes are as follows:</p>\n\
<ul>\n\
<li>Do not include  <em>max.h</em>  or  <em>animtbl.h</em>  directly, but instead include the header files that contain the symbol definitions or declarations that you require.</li>\n\
<li>Replace references to header files from the old  <em>maxscrpt</em>  [sic folder to the appropriate header in the new folder  <em>maxscript</em> . To see which header files should be used instead consult the header file in the original folder.</li>\n\
<li>Set your plug-in projects to compile with warning level 4 turned on.</li>\n\
</ul>\n\
<h2 id=\"cloning-objects\">Cloning objects</h2><p>A more robust method of cloning objects is recommended: use <code>RemapDir::CloneRef()</code> or <code>::CloneRefHierarchy()</code> instead of <code>ReferenceTarget::Clone()</code>. This will correctly perform backpatching of references in the reference hierarchy. If backpatching is not performed, a reference graph can keep references to the original object, instead of to the copied object. Backpatching of references is performed automatically by the <code>RemapDir</code> destructor. Do not call <code>RemapDir::Backpatch()</code> directly.</p>\n\
<p>For more information see the topics <a href=\"./../../../writing_plug-ins/plug-in_basics/implementing_clone_in_a_plug-in.html\">Implementing Clone in a Plug-in</a> and <a href=\"./../../../3ds_max_sdk_features/reference_system/reference_system_common_tasks/cloning_reference_targets.html\">Cloning Reference Targets</a>.</p>\n\
<h2 id=\"changes-to-api-behavior\">Changes to API Behavior</h2><ul>\n\
<li>There have been improvements to the efficiency of <code>Interface::MakeNameUnique()</code> which has a direct impact on the efficiency of node creation. With this is the ability to specify the number of suffix digits used in the creation of new methods via <code>Interface13::SetNameSuffixLength()</code> (see also <code>Interface13::GetNameSuffixLength()</code>).</li>\n\
<li>The management of <code>DragAndDropHandler</code> memory lifetime has been changed. In previous versions, it was up to 3rd party developers to &#39;unregister&#39; their drag and drop handlers, before 3ds Max was shut down. If they didn&#39;t it 3ds Max would crash on shut-down. Now, the manager automatically &#39;unregisters&#39; all <code>DragAndDropHandler</code> pointers during a broadcast of <code>NOTIFY_SYSTEM_SHUTDOWN</code>. For more information see <code>IDragAndDropMgr</code>.</li>\n\
<li>When calling the global function <code>DisableRefMsgs</code> the message <code>REFMSG_GET_PARAM_NAME</code> now is also disable in addition to <code>REFMSG_TARGET_DELETED</code>.</li>\n\
</ul>\n\
<h2 id=\"-net-action-items\">.NET Action Items</h2><p>It is now possible to create custom action items in a .NET assembly. This is done by creating a public class that implements the interface <code>ICuiActionCommand</code> (found in  <em>MaxCustomControls.dll</em> ) and placing the DLL containing the implemented interface in the  <em>bin\\assemblies</em>  folder. For more information see the topic <a href=\"./../../../3ds_max_dotnet_sdk/dotnet_action_items.html\">.NET Action Items</a>.</p>\n\
<h2 id=\"deprecation-of-appwizard\">Deprecation of AppWizard</h2><p>The AppWizard is no longer actively supported. It is still being shipped with the 3ds Max SDK but we are recommending people to instead use template projects available online at <a href=\"http://www.autodesk.com/3dsmax-sdk-docs\" target=\"_blank\">www.autodesk.com/3dsmax-sdk-docs</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2011_sdk.html\">What&#x27;s New: 3ds Max 2011 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";