var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"major_new_features_2011\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Major New Features</h1></div><p>The following are the most significant changes to the 3ds Max 2011 since the previous version.</p>\n\
<h2 id=\"hardwarelockid-is-deprecated\">HardwareLockID() is Deprecated</h2><p><code>HardwareLockID()</code> has been deprecated. In 3ds Max 2010 it always returned 0. You will have to implement your own licensing mechanisms for plug-ins if desired.</p>\n\
<h2 id=\"save-to-previous\">Save to Previous</h2><p>It is now possible to save a 3ds Max scene to a format compatible with 3ds Max 2010. This functionality is available from the new <code>Interface13</code> class. Saving the scene to a previous version is like saving out a copy of the current scene in a format compatible with the previous Max version. The saved scene does not become the current scene. Plug-ins present only in 3ds Max 2011, will load as stand-ins in the previous versions. Plug-ins that need to change either their chunk structure, parameter definitions, animatable structure, or reference structure, need to follow specific guidelines outlined in the topic <a href=\"./../../../writing_plug-ins/plug-in_basics/plug-in_versioning/supporting_save_to_previous.html\">Supporting Save to Previous</a>.</p>\n\
<p>It is important that plug-in developers realize that the save to previous feature does not manage the task of saving plug-ins to another specific version of the plug-in. To do this plug-ins will have to implement their own system to allow users to specify what version of the plug-in to save to.</p>\n\
<h2 id=\"caddy-grips-\">Caddy (Grips)</h2><p>The interactive modeling dialogs for editable poly objects have been replaced with a new transparent floating UI called a caddy. You can write your own caddy by overriding the class: <code>IBaseGrip</code>. The <code>IGripManager</code>, which is implemented by 3ds Max, is used to activate and manage caddies. For more information see the topic <a href=\"./../../../3ds_max_sdk_features/user_interface/caddy_controls.html\">Caddy Controls</a>.</p>\n\
<h2 id=\"container-enhancements\">Container Enhancements</h2><p>The container feature introduced in 3ds Max 2010 has been extended in 3d Max 2011. Previously, containers would only allow for no access or access to edit in place when inherited so that a user can save a copy on top of the original definition. Now in addition a container can grant access to only add new objects over the inherited container or to get full freedom to access anything that was unlocked on the original source definition. For the latter case the user can specify additional locks over certain items, such as all materials, all modifiers, all transforms or all objects, to restrict what&#39;s accessible further. The new containers support is covered in the classes: <code>IContainerObject13</code> and <code>IContainerPreferences</code>.</p>\n\
<h2 id=\"open-exr-bitmap-io-plug-in\">Open EXR Bitmap IO Plug-in</h2><p>The Open EXR bitmap IO plug-in, is not part of 3ds Max SDK 2011. This means that using the SDK you will not be able to get a valid pointer to an object of class <code>IBitmapIO_EXR</code>. Usually when we deprecate an interface, the implementation is still available for a couple of releases, but this was not possible for 3ds Max SDK 2011.</p>\n\
<h2 id=\"assembly-loader\">Assembly Loader</h2><p>A new plug-in loader has been created specifically for .NET plug-ins which makes it safer for 3ds Max to load and unload .NET and mixed-mode 3ds Max plug-ins. Assemblies (DLLs) which contain .NET or C++/CLI plug-ins should now be placed in the  <em>bin/assemblies</em>  subfolder of the 3ds Max installation, instead of the plugins folder. The <code>AssemblyLoader</code> class is contained in  <em>maxsdk/assemblies/AssemblyLoader.dll</em>  and the 64 bit version can be found in  <em>maxsdk/x64/assemblies/AssemblyLoader.dll</em> . For more information see the topic <a href=\"./../../../3ds_max_dotnet_sdk/loading_3ds_max_dotnet_assemblies.html\">Loading 3ds Max .NET Assemblies</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2011_sdk.html\">What&#x27;s New: 3ds Max 2011 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";