var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"sdk_change_details\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>SDK Change Details</h1></div><p>The following is a more comprehensive list of the changes to API elements. Deprecated API elements are <code>listed here</code>.</p>\n\
<h2 id=\"new-global-functions\">New Global Functions</h2><ul>\n\
<li><code>DisplayOutOfMemoryWarning()</code> - shows an out of memory warning dialog box informing the user that they should save their data and shut down 3ds Max.</li>\n\
</ul>\n\
<h2 id=\"new-classes\">New Classes</h2><ul>\n\
<li><code>IBaseGrip</code> - A pure virtual interface for implementing grips.</li>\n\
<li><code>IBitmapIO_Rgb</code> - Represents the interface for the Bitmap IO RGB format. The interface ID is defined as <code>BMPIO_INTERFACE</code>.</li>\n\
<li><code>IContainerObject13</code> - Extends container object functionality. In particular it provides support for new access rules that inherited containers may follow.</li>\n\
<li><code>IContainerPreferences</code> - This interface provides access to the container preferences.</li>\n\
<li><code>IGripManager</code> - The interface to the functionality for using the grip manager.</li>\n\
<li><code>ILockedContainerUpdate</code> - An interface for plug-ins that may need to augment the new container update process.</li>\n\
<li><code>IContainerUpdateReplacedNode</code> - Provides an interface to retrieve what new node will replace an existing one during the local edit process of containers.</li>\n\
<li><code>IMNMeshUtilities13</code> - extends the <code>MNMeshUtilities</code> class, adding new functionality applied on a <code>MNMesh</code>. The added functions are used for selecting sub-object loops or rings when the Shift key is pressed</li>\n\
<li><code>INamedSelectionSetManager</code> - The user may use functions exposed by this class to manage all the named selection sets of objects.</li>\n\
<li><code>Interface13</code> - Extends <code>Interface12</code>.</li>\n\
<li><code>ObjectDefinitionChangeNotificationParam</code> - A parameter that accompanies the new notifications: <code>NOTIFY_OBJECT_DEFINITION_CHANGE_BEGIN</code> and <code>NOTIFY_OBJECT_DEFINITION_CHANGE_END</code>.</li>\n\
<li><code>PickClassCallback</code> - This allows added filtering of classes that the user will be able to choose from in <code>Interface13::DoPickClassDlg()</code>.</li>\n\
<li><code>ViewExp13</code> - Extends <code>ViewExp11</code>.</li>\n\
<li><code>MAXRootScene</code> - Exposes a new object to MAXScript that represents the scene.</li>\n\
</ul>\n\
<h2 id=\"new-enums\">New Enums</h2><ul>\n\
<li><code>PRODUCT_VERSION_EMR</code></li>\n\
<li><code>mtlDlgMode</code></li>\n\
</ul>\n\
<h2 id=\"new-notifications\">New Notifications</h2><ul>\n\
<li><code>NOTIFY_CLASSDESC_ADDED</code> - Sent after new a <code>ClassDesc</code> or <code>ClassDesc2</code> has been registered with 3ds Max.</li>\n\
<li><code>NOTIFY_COLOR_CHANGE</code> - Sent when one of the custom colors managed by 3ds Max is redefined. See the functions: <code>GetUIColor()</code>, <code>SetUIColor()</code>, and <code>GetDefaultUIColor()</code>.</li>\n\
<li><code>NOTIFY_OBJECT_DEFINITION_CHANGE_BEGIN</code> - Sent immediately before object instances are updated to a new object definition.</li>\n\
<li><code>NOTIFY_OBJECT_DEFINITION_CHANGE_END</code> - Sent immediately after object instances are updated to a new object definition. See also <code>REFMSG_OBJECT_DEFINITION_CHANGE_END</code> and the struct <code>ObjectDefinitionChangeNotificationParam</code>.</li>\n\
<li><code>NOTIFY_NAMED_SEL_SET_POST_MODIFY</code> - Sent after the node set of a named selection set has been changed.</li>\n\
<li><code>NOTIFY_NAMED_SEL_SET_PRE_MODIFY</code> - Sent before the node set of a named selection will be changed.</li>\n\
<li><code>NOTIFY_POST_MAXMAINWINDOW_SHOW</code> - Sent immediately after the main window of 3ds Max is shown.</li>\n\
<li><code>NOTIFY_PRE_MAXMAINWINDOW_SHOW</code> - Sent when the main window of 3ds Max is about to show.</li>\n\
</ul>\n\
<h2 id=\"new-reference-messages\">New Reference Messages</h2><ul>\n\
<li><code>REFMSG_OBJECT_DEFINITION_CHANGE_BEGIN</code> - Sent immediately before an object instance is updated to a new object definition. See also <code>NOTIFY_OBJECT_DEFINITION_CHANGE_BEGIN</code>.</li>\n\
<li><code>REFMSG_OBJECT_DEFINITION_CHANGE_END</code> - Sent immediately after an object instance is updated to a new object definition. See also <code>NOTIFY_OBJECT_DEFINITION_CHANGE_END</code>.</li>\n\
</ul>\n\
<h2 id=\"new-macros\">New Macros</h2><ul>\n\
<li><code>ALPHA_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>CUI_MINIMIZED_DOCK</code></li>\n\
<li><code>CUI_MINIMIZED_DOCKABLE</code></li>\n\
<li><code>DECLARE_LOCAL_GENERIC_CLASS</code></li>\n\
<li><code>DEFINE_LOCAL_GENERIC_CLASS</code></li>\n\
<li><code>DEFINE_LOCAL_GENERIC_CLASS_DEBUG_OK</code></li>\n\
<li><code>DL_TYPENAME_OUTSIDE_TEMPLATE</code></li>\n\
<li><code>EPOLY_MOD13_INTERFACE</code></li>\n\
<li><code>EDIT_POLY_MODIFIER_CLASS_ID</code></li>\n\
<li><code>GetEPolyMod13Interface</code></li>\n\
<li><code>GetIGripManager</code></li>\n\
<li><code>I_LIGHTOBJ</code></li>\n\
<li><code>IGRIPMANAGER_INTERFACE</code></li>\n\
<li><code>IID_CONTAINER13</code></li>\n\
<li><code>IID_IContainerPreferences</code></li>\n\
<li><code>IID_NAMED_SELECTION_SET_MANAGER</code></li>\n\
<li><code>ILLUMINANCE_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>IMNMESHUTILITIES13_INTERFACE_ID</code></li>\n\
<li><code>LIGHTING_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>LOCKMAT_CLASS_ID</code></li>\n\
<li><code>MATERIALID_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>MAX_RELEASE_R13_ALPHA</code></li>\n\
<li><code>MAX_RELEASE_R13</code></li>\n\
<li><code>OBJECTID_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>RGBIO_INTERFACE</code></li>\n\
<li><code>SHADOWS_RENDER_ELEMENT_CLASS_ID</code></li>\n\
<li><code>SNAP_USE_XFORM_AXIS_AS_START_SNAP_POINT</code></li>\n\
<li><code>UNUSED_PARAM</code></li>\n\
</ul>\n\
<h2 id=\"removed-macros\">Removed Macros</h2><ul>\n\
<li><code>DISPLAY_XRAY</code></li>\n\
<li><code>HIGHPRIORITY</code></li>\n\
<li><code>IMAGE_LOAD</code></li>\n\
<li><code>is_msplugin_class</code></li>\n\
<li><code>is_objectset</code></li>\n\
<li><code>LOWPRIORITY</code></li>\n\
</ul>\n\
<h2 id=\"removed-classes\">Removed Classes</h2><ul>\n\
<li><code>IReagent</code></li>\n\
<li><code>IValence</code></li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2011_sdk.html\">What&#x27;s New: 3ds Max 2011 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";