var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"incremental_improvements_2012\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Incremental Improvements</h1></div><h2 id=\"dark-icon-enhancements\">Dark Icon Enhancements</h2><p>Bitmap based icons which were automatically darkened by 3ds Max for use with the dark color scheme have had readability problems. In an effort to solve this problem, 3ds Max 2012 ships with a set of dark icons optimized for the dark color scheme in a new icon folder called  <em>&lt;3dsMax_Root&gt;\\UI\\IconsDark</em> . 3ds Max 2012 looks into this new folder for dark icons, but falls back to  <em>&lt;3dsMax_Root&gt;\\UI\\Icons</em>  if it can&#39;t find any.</p>\n\
<p>This change may impact the way your plug-in&#39;s icons are displayed when 3ds Max uses the dark color theme. More information on this matter is provided in <a href=\"./../../../3ds_max_sdk_features/user_interface/icons.html\">Icons</a> of the <a href=\"./../../../3ds_max_sdk_features/user_interface/icons.html\">Icons</a> topic.</p>\n\
<h2 id=\"improved-robustness-of-reference-system\">Improved Robustness of Reference System</h2><p>There are some incorrect usages of the reference system that can allow plug-ins to cause instabilities in 3ds Max, and eventually leading to unexpected behavior or crashes. One such case is when plug-ins call <code>ReferenceMaker::SetReference()</code> directly on other plug-ins. Doing so only partially updates the reference graph which results in system instability when the reference links are deleted. The visibility <code>ReferenceMaker::SetReference()</code> has been changed from public to protected in the class <code>ReferenceMaker</code> and all of its sub-classes, to prevent plug-ins from accidentally calling this method. Plug-ins that have been calling <code>ReferenceMaker::SetReference()</code> on objects of types other than themselves or their parent class, will have to change their code to call <code>ReferenceMaker::ReplaceReference()</code> instead.</p>\n\
<h2 id=\"eliminated-ambiguity-caused-by-paramid\">Eliminated Ambiguity Caused by ParamID</h2><p>Since <code>ParamID</code> is defined as a short integer using a typedef, a compiler can incorrectly resolve calls to a method overloaded with parameters of type <code>ParamID</code> and <code>int</code>. If a pair of overloaded methods differ only by the type of one of their parameters, and this parameter was of type <code>int</code> in the first method and of type <code>ParamID</code> in the second method, the compiler&#39;s method resolution rules would always choose the first method with the integer parameter. This would result in a value representing a parameter id being interpreted as a parameter index which could lead to hard to track down defects.</p>\n\
<p>The method pairs where the compiler would resolve to the wrong method overload are methods of class <code>IParamBlock2</code>:</p>\n\
<ul>\n\
<li><code>Control* GetController( int i, int tabIndex=0)</code> and <code>Control* GetController( ParamID id, int tabIndex=0)</code></li>\n\
<li><code>void SetController( int i, int tabIndex, Control *c, BOOL preserveFrame0Value=TRUE)</code> and <code>void SetController( ParamID id, int tabIndex, Control *c, BOOL preserveFrame0Value=TRUE)</code></li>\n\
<li><code>BOOL KeyFrameAtTime( int i, TimeValue t, int tabIndex=0)</code> and <code>BOOL KeyFrameAtTime( ParamID id, TimeValue t, int tabIndex=0)</code></li>\n\
</ul>\n\
<p>These methods have been deprecated and replaced with methods whose names clearly indicates whether a parameter id (&quot;ByID&quot; ) or a parameter index (&quot;ByIndex&quot;) is expected as a parameter:</p>\n\
<ul>\n\
<li><code>Control* GetControllerByIndex(int i, int tabIndex=0)</code></li>\n\
<li><code>Control* GetControllerByID(ParamID id, int tabIndex=0)</code></li>\n\
<li><code>void SetControllerByIndex(int i, int tabIndex, Control *c, BOOL preserveFrame0Value=TRUE)</code></li>\n\
<li><code>void SetControllerByID(ParamID id, int tabIndex, Control *c, BOOL preserveFrame0Value=TRUE)</code></li>\n\
<li><code>BOOL KeyFrameAtTimeByIndex(int i, TimeValue t, int tabIndex=0)</code></li>\n\
<li><code>BOOL KeyFrameAtTimeByID(ParamID id, TimeValue t, int tabIndex=0)</code></li>\n\
</ul>\n\
<p>Plug-ins calling the now-deprecated methods will have to update their code.</p>\n\
<h2 id=\"plug-in-dll-api-changes\">Plug-in DLL API Changes</h2><p>The API for working with the system wide registry of plug-in DLLs and the class descriptors it exposes has been updated. The reason for this has been to make plug-in defer loading faster and more robust. Now instances of the classes <code>DllDesc</code>, <code>ClassDirectory</code>, and <code>SubClassList</code> can be allocated and deleted only by the system. Plug-ins are discouraged to create instances of class <code>ClassEntry</code>, as support will be retired in future versions of 3ds Max. Following is the list of changes to the classes concerning this issue.</p>\n\
<ul>\n\
<li>Changes to the class <code>DllDir</code><ul>\n\
<li><code>DllDir::UnloadAllDlls()</code> has been deprecated because 3ds Max 2012 does not support unloading plug-in Dlls in a safe way.</li>\n\
<li>Once loaded, plug-ins Dlls cannot be reloaded or deferred via <code>DllDir::LoadADll()</code>, <code>DllDir::LoadDllsDromDir()</code> and <code>DllDir::LoadDlls()</code>.</li>\n\
</ul>\n\
</li>\n\
<li>Changes to class <code>ClassEntry</code> and class <code>DataClassDesc</code><ul>\n\
<li>Usage of <code>ClassEntry::FullCD()</code> and that of class <code>DataClassDesc</code>, although supported in 3ds Max 2012, is discouraged as these will be retired in a future version of 3ds Max. Calling <code>void* ClassDesc::Create()</code> will ensure that the plug-in Dll is loaded before attempting to create the requested plug-in object.</li>\n\
</ul>\n\
</li>\n\
<li>Changes to class <code>DllDesc</code><ul>\n\
<li>All data members are now private and must be accessed through member methods.</li>\n\
<li>Copying and calling copy constructor is not allowed.</li>\n\
<li>It now stores the plug-in Dll&#39;s path, directory name and file name in lower case.</li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<h2 id=\"auto-tangent-manager\">Auto-Tangent Manager</h2><p>A new auto-tangent algorithm has been introduced in 3ds Max 2012. The new class <code>IAutoTangentMan</code> allows plug-in developers to determine if a controller supports auto-tangents, and whether the legacy or new algorithm is used. The new algorithm is referred to as &quot;unified&quot; in the <code>IAutoTangentMan</code> documentation because it is used across several Autodesk products.</p>\n\
<p>At this time the 3ds Max 2012 auto-tangents cannot be supported by controllers developed using the 3ds Max SDK.</p>\n\
<h2 id=\"help-system-enhancements\">Help System Enhancements</h2><p>3ds Max 2012 help will support both local and online delivery. New methods have been added to the API to allow setting and getting the user guide&#39;s location. A number of functions related to 3ds Max&#39;s help system have been deprecated and the functionality of the  <em>helpsys.lib</em>  has been migrated to  <em>core.lib</em> . The impact of these changes on plug-ins should be minimal since the help system methods do not handle plug-in specific user guides.</p>\n\
<h2 id=\"removed-deprecated-sdk-elements\">Removed Deprecated SDK Elements</h2><p>Over the last few releases of 3ds Max many SDK, certain elements have been deprecated but were not removed. These elements are now removed from the SDK. Plug-ins compiled for a version of 3ds Max older than 2011, should compile first against the 3ds Max 2011 SDK, and after that migrate to 3ds Max 2012. This will permit SDK users to avoid compilation errors caused by the removal of deprecated SDK elements. Note that the SDK elements deprecated during the 3ds Max 2012 development cycle will not be removed from the 3ds Max SDK.</p>\n\
<h2 id=\"removed-retired-sdk-sample-projects\">Removed Retired SDK Sample Projects</h2><p>The projects under the  <em>maxsdk\\samples\\retired</em>  were using outdated techniques and have been removed from the SDK samples folder.</p>\n\
<h2 id=\"visual-studio-appwizard-updated-for-2010\">Visual Studio AppWizard Updated for 2010</h2><p>The AppWizard - which was deprecated in 3ds Max 2011 - is supported again in this release of 3ds Max, and has been updated to support Visual Studio 2010.</p>\n\
<p>The Visual Studio AppWizard is a plug-in to Visual Studio 2010 that facilitates the creation of skeleton plug-in projects. for more information on using AppWizard to create plug-in projects, refer to <a href=\"./../../../writing_plug-ins/creating_a_plug-in_project/using_appwizard_to_create_a_new_/using_the_plug-in_wizard.html\">Using the Plug-in Wizard</a></p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2012_sdk.html\">What&#x27;s New: 3ds Max 2012 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";