var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"interface_querying_2012\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Interface Querying</h1></div><p>When navigating a scene, a plug-in reference will often be retrieved without knowing the concrete type of the plug-in. There are two mechanisms used for querying run-time type information from a plug-in. Each mechanism uses a function named <code>GetInterface()</code>. The first one is <code>InterfaceServer::GetInterface()</code> and the second one is <code>Animatable:: GetInterface().</code> These functions both return an abstract base class (interface) using an interface identifier.</p>\n\
<h2 id=\"interfaceserver-getinterface-\">InterfaceServer::GetInterface()</h2><p>The function <code>InterfaceServer::GetInterface()</code>uses the type <code>Interface_ID</code> to identify interfaces. An <code>Interface_ID</code> for a given interface can usually be found as a macro in the same file as the interface definition. For example, <code>IDX8PixelShader</code> has its interface ID defined in the same header file  <em>d3dx8.h</em> .</p>\n\
<p>Plug-ins should correctly handle the requests for interfaces in their implementation of <code>InterfaceServer::GetInterface()</code>, or they may not be displayed correctly in the Nitrous viewport. Developers are encouraged to read the <a href=\"./../../../best_practices/handling_requests_for_interfaces.html\">Handling Requests for Interfaces</a> best practices to find more information on this issue.</p>\n\
<h2 id=\"animatable-getinterface-\">Animatable::GetInterface()</h2><p>The function <code>Animatable::GetInterface()</code> uses integers to identify the interface IDs. Consult the C++ Reference&#39;s &quot;<code>Modules &amp;gt; List of interface IDs supported by different plugin types</code>&quot; for the list of pre-defined constants used to identify interfaces. To determine if an animatable can be used as the type a certain interface is representing, it is recommended to see if that animatable implements that interface or not, rather than to perform casts using <code>dynamic_cast</code> or <code>static_cast.</code></p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>   <strong></strong> <code>Animatable</code> derives from <code>InterfaceServer</code>, so objects deriving from <code>Animatable</code> will need to support both <code>InterfaceServer::GetInterface()</code> and <code>Animatable::GetInterface()</code>.</p>\n\
\n\
</div></div>\n\
\n\
<p>See also:</p>\n\
<p><a href=\"./../../../best_practices/rtti_and_getinterface.html\">RTTI and GetInterface()</a></p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2012_sdk.html\">What&#x27;s New: 3ds Max 2012 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";