var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"major_new_features_2012\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Major New Features</h1></div><p>The following are the most significant changes to the 3ds Max 2012 since the previous version.</p>\n\
<h2 id=\"viewport-graphics-api\">Viewport Graphics API</h2><p>3ds Max 2012 has introduced a new viewport graphics API that allows procedural object, modifier, material, and texture map plug-ins to take advantage of the new Nitrous viewport display driver. The details for this new graphics API including object display API, simple and advanced material, and texture map display API and their impact on plug-ins are covered in detail in <a href=\"porting_object_plug-ins_to_nitro.html\"\">Porting Object Plug-ins to Nitrous</a>, <a href=\"porting_simple_material_and_text.html\"\">Porting Simple Material and Texture Map Plug-ins to Nitrous</a>, and <a href=\"porting_advanced_material_and_te.html\"\">Porting Advanced Material and Texture Map Plug-ins to Nitrous</a>. See the <a href=\"./../../../best_practices/handling_requests_for_interfaces.html\">Handling Requests for Interfaces</a> topic to learn how to override the <code>InterfaceServer::GetInterface()</code> correctly. Incorrect overrides of this function can prevent a plug-in from displaying correctly in the Nitrous viewport.</p>\n\
<h2 id=\"plug-in-dll-defer-loading-enhancements\">Plug-in DLL Defer Loading Enhancements</h2><p>3ds Max by default tries to defer load the plug-in DLLs unless the developer has explicitly opted-out by returning <code>FALSE</code> from his implementation of the <code>CanAutoDefer()</code> function. This is in oppose to the default behaviour of the previous versions, in which the plug-in DLLs were not defer loaded unless the developed opted-in by returning <code>TRUE</code> from <code>CanAutoDefer()</code> function.</p>\n\
<p>Prior to 3ds Max 2012, many plug-in DLLs could not be declared as deferrable because they were using features that were not supported by the defer-loading mechanism, such as:</p>\n\
<ul>\n\
<li>Action tables - see class <code>ActionTable</code></li>\n\
<li>Function publishing of core interfaces. A core interface object is a static variable of type <code>FPStaticInterface</code> marked with the <code>FP_CORE</code> flag</li>\n\
<li>Startup notifications such as <code>NOTIFY_SYSTEM_STARTUP</code></li>\n\
</ul>\n\
<p>Declaring a plug-in DLL as deferrable that supported the last two items did not prevent 3ds Max from defer loading it. This ultimately resulted in run-time defects. Besides, defer loading was usually not implemented in the plug-ins because it was optional. In 3ds Max 2012, many of the restrictions preventing plug-in DLLs from being defer loaded (including the above-mentioned cases) are eliminated. Also, to significantly improve start-up times and over-all memory consumption, defer-loading of plug-in DLLs is now the default behavior of 3ds Max, even if the CanAutoDefer() function is not implemented.</p>\n\
<h3 id=\"impact-on-plug-ins\">Impact on Plug-ins</h3><p>Potentiality of the plug-ins to be deferred need to be re-assessed in 3ds Max 2012 as following:</p>\n\
<ul>\n\
<li>Plug-in DLLs that already declare themselves as deferrable (<code>CanAutoDefer()</code> returns <code>1</code> or <code>TRUE</code>) are now more likely to be deferred by 3ds Max even if they weren&apos;t in the past.</li>\n\
<li>Plug-in DLLs that do not implement<code>CanAutoDefer()</code> might now be deferred. If deferring them creates a negative impact on the user experience, they should explicitly disallow deferring. For this, the function <code>ULONG CanAutoDefer()</code> should be implemented and should return <code>0</code>. Moreover, this function needs to be exported from the DLL.</li>\n\
<li>Plug-in DLLs that explicitly disallow being deferred should be reviewed, to see whether the reasons for disallowing defer loading still apply.</li>\n\
</ul>\n\
<p>There are also certain flags defined in the file  <em>3dsmax.ini</em>  that control each of the new features of 3ds Max for plug-in DLL defer loading. For more information and details on this topic, refer to <a href=\"./../../../writing_plug-ins/advanced_plug-in_topics/deferred_loading_of_plug-ins.html\">Deferred Loading of Plug-ins</a></p>\n\
<h2 id=\"better-support-for-save-to-previous\">Better Support For Save-to-previous</h2><p>Changes to the reference structure of a plug-in used to be very restricted if the plug-in tried to save itself to a previous version of 3ds Max. One scenario where such a reference structure change is inevitable is when a plug-in migrates from using parameter block 1 (<code>IParamBlock</code>) to using parameter block 2 (<code>IParamBlock2</code>). In this case, the reference to the plug-ins parameter block would change.</p>\n\
<h3 id=\"saving-an-alternate-reference-hierarchy\">Saving An Alternate Reference Hierarchy</h3><p>A new class called <code>ReferenceSaveManager</code> has been introduced to help plug-ins define a different reference structure than the one they have at run-time. For example, the number and type of references the plug-in saves can be different than those it has at run-time. This new API helps to eliminate the restrictions that applied to reference structure changes of a plug-in, so that it can be saved to a previous version of 3ds Max. For information on this new API, refer to the topic <a href=\"./../../../3ds_max_sdk_features/reference_system/guidelines_for_changing_the_refe.html\">Guidelines for Changing the Reference Structure</a>. You can also see the documentation of <code>ReferenceMaker::SpecifySaveReferences()</code> member function and that of class <code>ReferenceSaveManager</code> for more information and sample code.</p>\n\
<h2 id=\"support-for-net-4-0-run-time-and-microsoft-visual-studio-2010\">Support for .NET 4.0 Run-Time and Microsoft Visual Studio 2010</h2><p>3ds Max 2012 targets version 4.0 of the .NET Framework. The SDK sample and howto project files have been upgraded to Visual Studio 2010, while still targeting the Visual C++ 9.0 SP1 compiler that is part of Visual Studio 2008.</p>\n\
<p>Plug-ins can be developed using either VS 2008 or VS 2010. When plug-in projects are upgraded from VS 2008 to VS 2010, the following requirements apply:</p>\n\
<ul>\n\
<li>Non-managed and mixed plug-ins must target the v90 toolset (see the FAQ in the <a href=\"upgrading_the_target_dotnet_framew.html\"\"\">Upgrading the target .NET framework version to .Net 4.0</a> for instructions on how to set this up). The Visual C++ 9.0 SP1 compiler needs to be installed in order to build non-managed (C++) and mixed (C++\\CLI) plug-ins.</li>\n\
<li>Mixed (C++\\CLI) plug-in projects cannot target .NET 4.0 since they need to be built using the v90 toolset which does not support.NET 4.0. See the FAQ in <a href=\"upgrading_the_target_dotnet_framew.html\"\"\">Upgrading the target .NET framework version to .Net 4.0</a> for instructions on how to change the target .NET framework version. Managed plug-ins are free to target .NET 4.0.</li>\n\
</ul>\n\
<p>This feature is discussed in more details in <a href=\"./../../../3ds_max_dotnet_sdk.html\">3ds Max .NET SDK</a>.</p>\n\
<h2 id=\"morpher-api\">Morpher API</h2><p>A new set of classes and member functions have been exposed to make it easier to access data stored by the 3ds Max Morpher modifier. This new Morpher API replaces the legacy, now deprecated <code>IMorphClass</code> class. The Morpher API has been modeled after the MAXScript exposure of the morpher modifier.</p>\n\
<p>The Morpher API is not part of the official 3ds Max SDK ( <em>maxsdk\\include</em> ), but instead ships as part of the morpher modifier sample project:</p>\n\
<ul>\n\
<li>Morpher API include files: * maxsdk\\samples\\modifier\\morpher\\include* </li>\n\
<li>Morpher API libraries:  <em>maxsdk\\samples\\modifier\\morpher\\lib</em> </li>\n\
</ul>\n\
<p>Because it is a sample, the Morpher API is subject to change in subsequent releases of 3ds Max, even in those where the 3ds Max SDK stays binary backwards compatible.</p>\n\
<p>The Morpher API consists of two main classes, class <code>MaxMorphModifier</code>, which is a wrapper around a 3ds Max morph modifier instance, and class <code>MaxMorphChannel</code>, which is a wrapper around a morph channel of the 3ds Max morph modifier. For more details see the comments in  *maxsdk\\samples\\modifiers\\morpher\\include\\MorpherApi.h * </p>\n\
<p>The following code example uses the new Morpher API to get the name of morph channel 0:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Modifier* morphModifier; // must point to a MorphR3 instance\n\
MaxMorphModifier maxMorphModifier(morphModifier);\n\
const MCHAR* morphChannelName = maxMorphModifier.GetMorphChannel(0).GetName();\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2012_sdk.html\">What&#x27;s New: 3ds Max 2012 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";