var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"stabilizing_changes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Stabilizing Changes</h1></div><h2 id=\"addition-of-operator-\">Addition of operator==</h2><p>As part of the .NET work, the equals method (operator==) was added to many classes. These methods all implement deep comparisons to check if an instance is equal to another instance.</p>\n\
<h2 id=\"static-compile-time-assert\">Static Compile Time Assert</h2><p>Functionality was added in <code>maxsdk\\\\include\\\\Util\\\\StaticAssert.h</code> to enable compile time asserts. If the assert fails it will emit a compiler error. Users can use this assert, or the new static assert that comes with the new VC10 compiler.</p>\n\
<h2 id=\"minimizing-use-of-tab-with-non-pod-types\">Minimizing use of Tab with non-POD types</h2><p>Usage of the Tab class was minimized in the SDK and in the product. In many places it was found that Tab was used with data types that were not Plain Old Data (POD), despite warnings in the documentation that this is bad practice.</p>\n\
<p>To enable the compile time asserts, the file <code>maxsdk\\\\include\\\\PodTypeCheck.h</code> contains a define (ADSK_MAXSDK_NO_POD_TYPE_CHECK) that, when turned off (or not defined) emits a compiler error when Tab is used with a non-POD type. For instance, to activate this, comment out the define in PodTypeCheck.h. Attempting to use a Tab of BitArray&apos;s will emit an error:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// [PodTypeCheck.h]\n\
// #define ADSK_MAXSDK_NO_POD_TYPE_CHECK\n\
\n\
// ...\n\
\n\
Tab&lt;BitArray&gt; foo; // emits a compiler error</code></pre><p>Other changes in the SDK included changes to parameter types and changes to class inheritance. For instance GUPList now inherits from <code>MaxSDK::Array</code> instead of Tab.</p>\n\
<h2 id=\"hold-put-returns-a-boolean\">Hold::Put() returns a boolean</h2><p>The method <code>Hold::Put(RestoreObj *)</code> used to return <code>void</code>, but now returns <code>bool</code>. It returns <code>true</code> if the <code>RestoreObj</code> pointer was successfully kept in the hold storage, and <code>false</code> otherwise. This is important, because it gives the user the ability to delete the <code>RestoreObj</code> if the result is <code>false</code>. Note that the <code>Hold</code> class does not free the <code>RestoreObj</code>&apos;s memory if the put operation fails.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// Avoid this:\n\
lHold.Put(new MyRestoreAction()); // A memory leak occurs if this fails.\n\
\n\
// Do this:\n\
MyRestoreAction* undoable = new MyRestoreAction();\n\
if (lHold.Put(undoable) == false)\n\
    delete undoable;\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2013_sdk.html\">What&#x27;s New: 3ds Max 2013 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";