var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"understanding_the_automatic_gamm\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Understanding the Automatic Gamma Correction</h1></div><p>This topic describes how the gamma correction used to work before 3ds Max 2014 and how it changed.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p>  <strong></strong> Color Management has been substantially changed again in 3ds Max 2024. See <a href=\"topicid=bitmap_gamma_correction\">Bitmap Color Management</a>.</p>\n\
\n\
</div></div>\n\
\n\
<h2 id=\"previous-method-for-gamma-correction\">Previous Method for Gamma Correction</h2><p>The dialog for <em>loading</em> bitmaps had three options:</p>\n\
<p><img src=\"./images/GUID-ABDE9372-C267-4653-B7D7-619A7434C762-low.png\" alt=\"Load Bitmap gamma options prior to 3ds Max 2014\"></p>\n\
<p>Similarly, the dialog for <em>saving</em> bitmaps had two options:</p>\n\
<p><img src=\"./images/GUID-BD9325D5-FBE6-4F08-82DA-9C54D6B7BF52-low.png\" alt=\"Save Bitmap gamma options prior to 3ds Max 2014\"></p>\n\
<p>The following table defines these options:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th>Option</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td><strong>Use image&#39;s own gamma</strong></td>\n\
<td>Checks whether the file header contains a gamma value to use. If gamma value is not found, the <strong>Use system default gamma</strong> option is selected automatically.</td>\n\
</tr>\n\
<tr>\n\
<td><strong>Use system default gamma</strong></td>\n\
<td>Uses the globally defined gamma value (the sRGB gamma of 2.2).</td>\n\
</tr>\n\
<tr>\n\
<td><strong>Override</strong></td>\n\
<td>Allows a user override.</td>\n\
</tr>\n\
</tbody></table>\n\
<h3 id=\"limitations\">Limitations</h3><p>In general, this gamma correction method worked well for <em>loading</em> files when the file type stored actual gamma value in the file header. However, if the file header did not contain a gamma value, the following issues occurred:</p>\n\
<ul>\n\
<li>The globally defined gamma value is always used and the file type is ignored even though 8-bit or 16-bit files are generally stored in sRGB (= gamma 2.2), and floating points are stored linearly (= gamma 1.0).</li>\n\
<li>The file dialog automatically selected the <strong>Use system default gamma</strong> option. However, the next file that you attempt to load also uses this option even if it has a better value in the file header.</li>\n\
</ul>\n\
<p>For <em>saving</em> files, this method always used the system default gamma value and ignored the file type being saved. For example, EXR files that must be stored linearly (= gamma 1.0) were saved as sRGB (= gamma 2.2). You had to either create an override for such files, or modify the output default.</p>\n\
<h2 id=\"current-method-of-automatic-gamma-correction\">Current Method of Automatic Gamma Correction</h2><p>Currently, both <em>saving</em> and <em>loading</em> dialog has the same options as shown in the following figure:</p>\n\
<p><img src=\"./images/GUID-72130E73-286D-49B9-A1F0-FB6C5066B0F0-low.png\" alt></p>\n\
<p>The gamma value in the file header is used when you choose the <strong>Automatic</strong> option for <em>loading</em> files. When file headers do not contain the gamma value, the file type is considered and 3ds Max checks whether the particular file IO plug-in prefers linear storage or not. For example, the plug-in for JPG files do not prefer linear storage, and is assumed to be sRGB (= gamma 2.2). The plug-in for HDR files prefer linear storage and is assumed to be linear (= gamma 1.0).</p>\n\
<p>Similarly, when <em>saving</em> files, the file type is considered and 3ds Max checks whether the file IO plug-in prefers to be saved linearly. For example, a JPG plug-in is saved in sRGB (= gamma 2.2) by default, whereas an HDR plug-in is saved linearly (= gamma 1.0) by default.</p>\n\
<p>You can override this default behavior using the <strong>Override</strong> option for loading and saving the files.</p>\n\
<h3 id=\"advantages\">Advantages</h3><p>You rarely have to care about the gamma correction because it is automatically done based on the file type, bit depth, and so on.</p>\n\
<p>It is no longer recommended to change the global file-input and file-output gamma values from their sRGB default value of 2.2 because of the automatic choice for loading and saving. Therefore, these options are removed from the user interface of the Gamma/LUT Setup dialog. However, they can still be changed by editing the .ini files.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../automatic_gamma_correction.html\">Automatic Gamma Correction</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";