var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"build_changes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Build Changes</h1></div><h2 id=\"new-preprocessor-definition\">New preprocessor definition</h2><p>You must set the <code>WIN64</code> preprocessor definition in your project configuration settings.</p>\n\
<h2 id=\"build-configurations\">Build configurations</h2><p>The official build configuration has changed in 3ds Max 2014. In 3ds Max 2013, the official MSBuild configuration property was <em>DebugUnicode</em>, <em>HybridUnicode</em>, and <em>RelaseUnicode</em>. In 3ds Max 2014, the <em>Unicode</em> part is removed and the official build configurations are <em>Debug</em>, <em>Hybrid</em>, and <em>Release</em>.</p>\n\
<h2 id=\"directories-and-property-sheets\">Directories and property sheets</h2><p>In this release, many build settings were migrated to property sheets. This reduced duplication of build properties in Visual Studio project files, but also resulted in slight changes to the SDK folder structure. Now, the assemblies, libraries, and plug-ins are located in the following directories:</p>\n\
<ul>\n\
<li><code>&amp;lt;maxsdk&amp;gt;\\\\assemblies\\\\x64\\\\Release</code></li>\n\
<li><code>&amp;lt;maxsdk&amp;gt;\\\\lib\\\\x64\\\\Release</code></li>\n\
<li><code>&amp;lt;maxsdk&amp;gt;\\\\plugin\\\\x64\\\\Release</code></li>\n\
</ul>\n\
<p>These build locations are specified as MSBuild properties in a property sheet that is located at: <code>.\\\\maxsdk\\\\ProjectSettings\\\\propertySheets\\\\3dsmax.general.project.settings.props</code>.</p>\n\
<p>See the following example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">... &lt;!-- The directory where the SDK resides --&gt;\n\
&lt;MaxSdkDir&gt;$([System.IO.Path]::GetFullPath(&apos;$(MSBuildThisFileDirectory)..\\..\\&apos;))&lt;/MaxSdkDir&gt;\n\
&lt;!-- The directory where the SDK how to example projects are built --&gt;\n\
&lt;MaxSdkPlugin&gt;$(MaxSdkDir)\\plugin\\$(MaxPlatform)\\$(MaxConfiguration)\\&lt;/MaxSdkPlugin&gt;\n\
&lt;!-- The directory in the SDK where managed plug-in assemblies are copied --&gt;\n\
&lt;MaxSdkAssemblies&gt;$(MaxSdkDir)\\assemblies\\$(MaxPlatform)\\$(MaxConfiguration)\\&lt;/MaxSdkAssemblies&gt;\n\
&lt;!-- The include directory for header files in the public SDK --&gt;\n\
&lt;MaxSdkInc&gt;$(MaxSdkDir)\\include&lt;/MaxSdkInc&gt;\n\
...\n\
&lt;!-- The public Max SDK library directory --&gt;\n\
&lt;MaxSdkLib&gt;$(MaxSdkDir)lib\\$(Platform)\\$(Configuration)\\&lt;/MaxSdkLib&gt;\n\
...</code></pre><p>These build properties can be used to simplify the maintenance of your project files.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2014_sdk.html\">What&#x27;s New: 3ds Max 2014 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";