var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"new_classes_and_methods\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>New Classes and Methods</h1></div><h2 id=\"new-classes\">New Classes</h2><p>Following are the new classes:</p>\n\
<ul>\n\
<li><code>BezFontEX2</code> - Replaces the <code>BezFontEX</code> class.</li>\n\
<li><code>BitmapIOMetaData</code> - Exposes extended parameters for the <code>BitmapIO</code> class that relates to things like gamma correction preferences.</li>\n\
<li><code>IBaseGrip2</code> - Extends the <code>IBaseGrip</code> class to provide extra functionality for updating the visibility of the caddy.</li>\n\
<li><code>IMenuItemExtension</code> - The new menu system in 3ds Max 2014 allows the display of an icon next to the menu, if the new graphical menu system is enabled. This class extends the old <code>IMenuItem</code> class and can point to a file for the icon.</li>\n\
<li><code>IMenuManagerExtension</code> - Extends the <code>IMenuManager</code> class and this must be used instead of the old one.</li>\n\
<li><code>IPathConfigMgrEx</code> - Provides extended access to application path configuration.</li>\n\
<li><code>ISceneCallbackPriority</code> - Callback classes that inherit from <code>ViewportDisplayCallback</code> can also sub-class <code>ISceneCallbackPriority</code> to assign a priority. Callbacks with a higher priority are called before the callbacks with a priority of zero.</li>\n\
<li><code>MaxSDK::Util::IBailOutBusyProcessManager</code> - Enables early termination from long computations by pressing the <strong>Esc</strong> key. See  <em>maxsdk\\util\\bailout.h</em>  for more details.</li>\n\
<li><code>MaxSDK::Util::IDlgShowingStatusForPolyObj</code> - Helps with using caddies for the mesh classes. See  <em>maxsdk\\include\\Util\\IDlgShowingStatusForPolyObj.h</em>  for more details.</li>\n\
<li><code>Mergeable</code> - Allows <code>ReferenceTarget</code> that is not attached to <code>INode</code> to be merged into the scene. See  <em>mergeable.h</em>  for more details.</li>\n\
<li><code>ParamBlockPLCBEx</code> - Replaces the <code>ParamBlockPLCB</code> class.</li>\n\
<li><code>TextureHandleUtility</code> - Utility class to create <code>TextureHandle</code> from <code>Texmap</code>.</li>\n\
</ul>\n\
<p>The following new classes are related to the Particle Flow.</p>\n\
<ul>\n\
<li><code>IParticleChannelExt2</code></li>\n\
<li><code>IParticleChannelINodeHandleR</code></li>\n\
<li><code>IParticleChannelINodeHandleW</code></li>\n\
<li><code>IParticleChannelTrueFalseIterator2</code></li>\n\
<li><code>IParticleGroupExt</code></li>\n\
<li><code>IPFActionExt</code></li>\n\
<li><code>IPFActionListMaterialHolder</code></li>\n\
<li><code>IPFOperatorPhysXWorld</code></li>\n\
<li><code>IPFSystemWorld</code></li>\n\
</ul>\n\
<p>Additionally, some minor modifications are made in the <code>BitArray</code> class to improve performance.</p>\n\
<h2 id=\"changes-in-the-code-animatable-code-class\">Changes in the <code>Animatable</code> class</h2><ul>\n\
<li>Virtual <code>GetClassName()</code> overridden in <code>Animatable</code> sub-classes - This virtual method is overridden in 19 public SDK classes that inherit from the <code>Animatable</code> class.</li>\n\
<li>New static <code>Animatable::IsDeleted()</code> method - This method can be used to test whether an <code>Animatable</code> pointer is valid and not deleted. This method provides a useful shortcut for storing an <code>AnimHandle</code> and using that to test whether an object is deleted. However, this is not a complete replacement for storing an <code>AnimHandle</code> because it can return false positives.</li>\n\
<li>New <code>AnimProperty</code> methods - Two new non-virtual methods are added to <code>Animatable</code> to append and find <code>AnimProperty</code> pointers:<ul>\n\
<li><code>Animatable::AppendProperty()</code></li>\n\
<li><code>Animatable::FindProperty()</code></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<h2 id=\"new-methods\">New Methods</h2><ul>\n\
<li>To support the new menu system in 3ds Max 2014, the following new methods are added for tooltips and icons to <code>ActionItem</code>:<ul>\n\
<li><code>ActionItem::GetTooltipKey()</code></li>\n\
<li><code>ActionItem::SetTooltipKey()</code></li>\n\
<li><code>ActionItem::MaxSDK::Util::Path GetIconPath()</code></li>\n\
<li><code>ActionItem::SetIconPath()</code></li>\n\
</ul>\n\
</li>\n\
<li>Following non-virtual method is added to the <code>MNMesh</code> and <code>Mesh</code> classes to complement the mesh <code>GenerateRenderItems()</code> function:<ul>\n\
<li><code>MNMesh::GenerateDeferredRenderItems()</code></li>\n\
<li><code>Mesh::GenerateDeferredRenderItems()</code></li>\n\
</ul>\n\
</li>\n\
<li>Following new non-virtual methods that aid in FileIO is added to the <code>MaxSDK::Util::TextFile::Reader</code> class:<ul>\n\
<li><code>Reader::ConvertNumUTF8CharsToNumBytes()</code></li>\n\
<li><code>Reader::ConvertNumUTF16CharsToNumBytes()</code></li>\n\
<li><code>Reader::ConvertNumCharsToNumBytes()</code></li>\n\
</ul>\n\
</li>\n\
<li>A new <code>Path::SaveBaseFile()</code> method is added to <code>MaxSDK::Util::Path</code> for supporting future Autodesk 360 features.</li>\n\
<li>A new <code>BezFontManager::BuildCharacterEx()</code> method is added to the <code>BezFontManager</code> class to replace the <code>BezFontManager::BuildCharacter()</code> method.</li>\n\
</ul>\n\
<p>Additionally, many non-virtual methods in <code>Point3</code> were modified with <code>\\__forceinline</code> to improve performance.</p>\n\
<h2 id=\"miscellaneous\">Miscellaneous</h2><p>There are other minor changes in the SDK mostly related to Particle Flow. Most of these changes involve addition of enumerators, functions, macros and typedefs.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2014_sdk.html\">What&#x27;s New: 3ds Max 2014 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";