var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"particle_flow_sdk_extensions\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Particle Flow SDK Extensions</h1></div><p>The following headers are added to the Particle Flow SDK ( <em>maxsdk\\include\\ParticleFlow</em> ).</p>\n\
<ul>\n\
<li><em>IParticleChannelExt2.h</em> </li>\n\
<li><em>IParticleChannelINodeHandle.h</em> </li>\n\
<li><em>IParticleChannelShapeNodeHandle.h</em> </li>\n\
<li><em>IParticleChannelTrueFalseIterator2.h</em> </li>\n\
<li><em>IParticleGroupExt.h</em> </li>\n\
<li><em>IPFActionExt.h</em> </li>\n\
<li><em>IPFActionListMaterialHolder.h</em> </li>\n\
<li><em>IPFOperatorPhysXWorld.h</em> </li>\n\
<li><em>PFVrayClassIDs.h</em> </li>\n\
</ul>\n\
<p>The <code>IParticleChannel*.h</code> headers are added to improve the handling of particle data in the form of particle data channels.</p>\n\
<p>If you implement your own data channel, you can use the <code>IParticleChannelExt2::Deglobalize()</code> method that makes the data non-global in the particle channel. This allows multi-threaded read/write access to the data.</p>\n\
<p>If you create your own operators/test, you can now use the <code>IParticleChannelINodeHandle</code> interface (through <code>GetParticleChannelShapeNodeHandleRInterface</code> and <code>GetParticleChannelShapeNodeHandleWInterface</code> calls) for querying about the handles assigned to the particles. It is relevant when the particle shapes are defined as reference to the geometry objects in a scene through the particle instance or a similar operator.</p>\n\
<p>The <code>IPFActionExt</code> interface (<code>IPFActionExt::InteruptUpdate()</code> method) can be used when a developer implements a PFlow operator/test with complex logic that is dependent on the entire PFlow system. This method can be used to signal a container update for a particle group. The container update can continue only after all the particle groups in the system are updated (including possible interruptions as well). This is done for operators that are instanced across a PFlow system to ensure real instant snapshot of the whole system and to guarantee proper interaction between particles at the same instant moment.</p>\n\
<p>The interfaces related to the files  <em>IParticleGroupExt.h</em> , <code>IPFActionListMaterialHolder.h</code>, <code>IPFOperatorPhysXWorld.h</code>, and <code>PFVrayClassIDs.h</code> are used for internal communication between different modules of Particle Flow.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2014_sdk.html\">What&#x27;s New: 3ds Max 2014 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";