var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"graphics_api\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Graphics API</h1></div><p>This section covers changes and additions to the Graphics API in 3ds Max 2015.</p>\n\
<h2 id=\"new-fragment-system-and-basic-view-system-apis\">New Fragment System and Basic View System APIs</h2><p>The fragment system is the largest change in the Graphics API in 3ds Max 2015. It introduces the concepts of a &quot;view fragment&quot; and &quot;fragment graph&quot;. A view fragment is a plugin that contributes to the rendering result in a viewport, and inherits from class <code>MaxSDK::Graphics::ViewFragment</code>. One or more view fragment plug-ins may be connected into the fragment graph that makes up the viewport rendering system. This allows flexible customization of viewport rendering.</p>\n\
<p>3ds Max 2015 only supports shader fragments. Other fragment types will be supported in future releases.</p>\n\
<p>The basic view API works together with the fragment system, and is used for managing, saving and loading the fragment graph for a viewport.</p>\n\
<p>A sample fragment plugin project can be found in the SDK samples directory, under  <em>maxsdk\\samples\\render\\activeshadefragment</em> .</p>\n\
<p>Header files for the fragment system API are located in  <em>maxsdk\\include\\Graphics\\FragmentGraph</em> .</p>\n\
<p>The header files for the view system can be found under  <em>maxsdk\\include\\Graphics\\ViewSystem</em> .</p>\n\
<h2 id=\"new-consolidation-api\">New consolidation API</h2><p>The consolidation API is used to improve the Graphics System, consolidating certain related render items together to reduce draw calls and speed up viewport performance. Consolidation APIs are located in:</p>\n\
<ul>\n\
<li><em>maxsdk\\include\\Graphics\\IConsolidationRenderItem.h</em> </li>\n\
<li><ul>\n\
<li>maxsdk\\include\\Graphics\\IConsolidationStrategy.h* </li>\n\
</ul>\n\
</li>\n\
<li><em>maxsdk\\include\\Graphics\\IConsolidationStrategy.h</em> </li>\n\
</ul>\n\
<p>See class documentation in the C++ API Reference, and samples in  <em>maxsdk\\samples\\objects\\camera.cpp</em>  (<code>SimpleCamera::UpdatePerNodeRenderItem</code>).</p>\n\
<h2 id=\"new-built-in-render-items\">New built-in render items</h2><p>New built-in render items have been added in:</p>\n\
<ul>\n\
<li><ul>\n\
<li>maxsdk\\include\\Graphics\\Utilities\\MarkerRenderItem.h*  - class <code>MarkerRenderItem</code>, an alternate solution for marker functions in class GraphicsWindow.</li>\n\
</ul>\n\
</li>\n\
<li><em>maxsdk\\include\\Graphics\\Utilities\\SplineRenderItem.h</em>  - class <code>SplineRenderItem</code>, an alternate solution for polyline functions in class GraphicsWindow.</li>\n\
<li><em>maxsdk\\include\\Graphics\\Utilities\\MeshEdgeRenderItem.h</em>  - class <code>MeshEdgeRenderItem</code>, a class designed for small meshes that only render edges.</li>\n\
</ul>\n\
<h2 id=\"new-hit-test-api\">New hit test API</h2><p>There are two new methods added to class ICustomRenderItem:</p>\n\
<ul>\n\
<li><code>HitTest()</code></li>\n\
<li><code>OnHit()</code></li>\n\
</ul>\n\
<p>The two methods are used for hit testing an object that owns a custom render item (such as a custom gizmo). For details see class <code>ICustomRenderItem</code> in the C++ API Reference, and  <em>maxsdk\\include\\Graphics\\ICustomRenderItem.h</em> .</p>\n\
<h2 id=\"deprecated-and-removed-items\">Deprecated and Removed Items</h2><p>The following deprecated classes, methods and parameters have been removed from the Graphics API:</p>\n\
<ul>\n\
<li>Merged IDisplayManager2 methods to IDisplayManager and removed IDisplayManager2.</li>\n\
<li>Removed the IObjectDisplay interface. Use IObjectDisplay2 instead.</li>\n\
<li>Removed the MaxContext parameter from IObjectDisplay2 methods.</li>\n\
<li>Removed the global function GenerateRenderItems().</li>\n\
<li>3ds Max 2015 no longer supports the DirectX 10 driver, therefore support for it has been removed from the SDK.</li>\n\
</ul>\n\
<p>The following classes are deprecated. We recommend that you no longer use them, as they will be removed from a future release:</p>\n\
<ul>\n\
<li>IPrimitiveRenderer related (use IVirtualDevice instead):</li>\n\
<li>IPrimitiveRenderer</li>\n\
<li>IRenderStateManager</li>\n\
<li>Immediate Render item (use CustomRenderItemHandle and ICustomRenderItem instead):</li>\n\
<li>ImmediateRenderItem</li>\n\
<li>IDisplayCallback</li>\n\
<li>DisplayCallbackContext</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2015_sdk.html\">What&#x27;s New: 3ds Max 2015 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";