var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"incremental_improvements_2015\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Incremental Improvements</h1></div><h2 id=\"layer-property-enhancements\">Layer property enhancements</h2><p>Layer properties can now be propagated to child layers by setting the &quot;propagate&quot; parameter for those <code>ILayer</code> methods that set properties to true. By default properties are not propagated. For more information see class <code>ILayer</code> and its methods in the C++ API Reference.</p>\n\
<h2 id=\"renderelement-enhancements\">RenderElement enhancements</h2><p>The <code>BOOL MaxRenderElement::IsVisibleToScanlineRenderer()</code> method is added so render elements can inform 3ds Max whether or not they are compatible with the scanline renderer. A render element that overwrites this method to return FALSE is not shown in the selection dialog for the scanline renderer. By default this method returns true to respect legacy behavior.</p>\n\
<h2 id=\"apis-promoting-the-use-of-dynamic-length-string-arrays-mstr-\">APIs promoting the use of dynamic length string arrays (MSTR)</h2><p>The SDK now provides wrappers for several Windows APIs for getting text out of windows and various controls that work with dynamic length strings (MSTR). They ensure that the string buffer passed to the Windows API has sufficient space to hold the window&apos;s text, thus improving robustness of the code that uses these APIs. Using dynamic length string arrays (MSTR) over fixed sized arrays of characters (<code>MCHAR var[MAX_PATH]</code>) has the advantage of reducing the chances for buffer overruns.</p>\n\
<p>One example of such a function is:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">UtilExport TSTR\n\
GetListBoxItemText(HWND hDlg, int nIDDlgItem, int\n\
nListboxItem);</code></pre><p>For a full list of the available functions, see  <em>maxsdk\\include\\winutil.h</em>  and  <em>winutil.h</em>  in the C++ API Reference.</p>\n\
<h2 id=\"ability-to-filter-animatables\">Ability to filter animatables</h2><p>Plug-ins can now filter animatable instances during a hit test with the newly added <code>PickAnimatableCallback</code> class. Previously only nodes could be filtered with the <code>PickNodeCallback</code> class.</p>\n\
<h2 id=\"access-to-the-main-thread-id\">Access to the main thread ID</h2><p>The <code>DWORD Interface15::GetMainThreadID()</code> method provides access to 3ds Max&apos;s main thread id.</p>\n\
<h2 id=\"xref-scene-enumeration\">Xref Scene Enumeration</h2><p>You can now enumerate the scene entities in xref nodes using <code>IScene::EnumTree()</code> by passing true as the value for the new <code>bIncludeXref</code> parameter.</p>\n\
<h2 id=\"notifications-on-action-item-execution\">Notifications on action item execution</h2><p><code>NOTIFY_ACTION_ITEM_PRE_EXEC</code> and <code>NOTIFY_ACTION_ITEM_POST_EXEC</code> have been renamed to <code>NOTIFY_ACTION_ITEM_HOTKEY_PRE_EXEC</code> and <code>NOTIFY_ACTION_ITEM_HOTKEY_POST_EXEC</code> to better reflect their semantics. These notifications are sent only when action items are executed via hotkeys.</p>\n\
<p><code>NOTIFY_ACTION_ITEM_EXECUTION_STARTED</code> and <code>NOTIFY_ACTION_ITEM_EXECUTION_ENDED</code> are two new notifications sent on action items execution, regardless of the way the action item execution was triggered (such as hotkey, menu, toolbar, ribbon, maxscript, SDK, or python).</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2015_sdk.html\">What&#x27;s New: 3ds Max 2015 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";