var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_system_changes_2015\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference System Changes</h1></div><h2 id=\"singlerefmaker-can-drop-references-automatically\">SingleRefMaker can drop references automatically</h2><p><code>SingleRefMaker</code> now supports dropping its reference automatically when certain events occur. This reduces the potential for errors and eliminates the burden on developers to clean up references. This new behavior of <code>SingleRefMaker</code> instances is controlled by flags (set by the constructor or by <code>SetAutoDropRefOnShutdown()</code>) that can be set by the owner object. However, the default behavior is to maintain the reference on shutdown or plug-in unloading, unless the <code>SingleRefMaker&apos;s</code> owner explicitly instructs it to drop it when these events occur.</p>\n\
<p>For more information see <code>AutoDropRefOnShutdown</code> in class <code>SingleRefMaker</code> in the C++ API Reference.</p>\n\
<h2 id=\"changes-to-code-notifydependents-code-and-code-notifyrefchanged-code-\">Changes to <code>NotifyDependents()</code> and <code>NotifyRefChanged()</code></h2><p>The signature of <code>ReferenceMaker::NotifyDependents()</code> was changed from:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual RefResult ReferenceMaker::NotifyDependents(\n\
    Interval changeInt, \n\
    PartID partID, \n\
    RefMessage message, \n\
    SClass_ID sclass = NOTIFY_ALL,\n\
    BOOL propagate = TRUE, \n\
    RefTargetHandle hTarg = NULL);</code></pre><p>To:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual RefResult ReferenceMaker::NotifyDependents(\n\
    const Interval&amp; changeInt, \n\
    PartID partID, \n\
    RefMessage message, \n\
    SClass_ID sclass = NOTIFY_ALL,\n\
 BOOL propagate = TRUE, \n\
    RefTargetHandle hTarg = NULL);</code></pre><p>The signature of method ReferenceMaker::NotifyRefChanged() was changed from:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual RefResult ReferenceMaker::NotifyRefChanged(\n\
    Interval changeInt, \n\
    RefTargetHandle hTarget, \n\
    PartID&amp; partID,  \n\
    RefMessage message) = 0;</code></pre><p>To:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">virtual RefResult ReferenceMaker::NotifyRefChanged(\n\
    const Interval&amp; changeInt, \n\
    RefTargetHandle hTarget, \n\
    PartID&amp; partID,  \n\
    RefMessage message, \n\
    BOOL propagate) = 0;</code></pre><p>C++ and .NET plug-ins that implement or call the updated methods will need to be changed. A compiler error is generated for code using the old method signatures, which makes it easier to find the code that needs to be updated.</p>\n\
<p>If <code>ReferenceMaker::NotifyRefChanged()</code> is called through <code>ReferenceMaker::NotifyDependents()</code>, the value of &apos;propagate&apos; is that passed to <code>ReferenceMaker::NotifyDependents()</code>.</p>\n\
<p>If the plug-in directly calls an implementation of <code>ReferenceMaker::NotifyRefChanged()</code>, the correct value to pass for the &quot;propagate&quot; parameter depends on its actual behavior (implementation details). A common case is when an implementation of <code>ReferenceMaker::NotifyRefChanged()</code> calls the parent&apos;s class implementation of the same method, in which case the plug-in should just pass the received value for the &quot;propagate&quot; parameter. Another common case is when the plug-in needs to update or request information from a reference maker to which it may hold a simple pointer (which is not a recommended practice). In most but not all of these cases FALSE should be passed in as the value of the &quot;propagate&quot; flag.</p>\n\
<p>If the plug-in needs to call <code>ReferenceMaker::NotifyDependents()</code> from its implementation of <code>ReferenceMaker::NotifyRefChanged()</code>, it would normally do so only if the &quot;propagate&quot; flag passed to <code>NotifiyDependents()</code> is TRUE.</p>\n\
<h2 id=\"changes-in-ireftargcontiner-and-iindirectreftargcontainer\">Changes in IRefTargContiner and IIndirectRefTargContainer</h2><h3 id=\"improved-support-for-reference-management\">Improved support for reference management</h3><p>You can now specify whether an instance of <code>IRefTargContainer</code> holds strong or weak references when you create the instance (strong references are the default behavior). <code>GetHoldAsWeakReference()</code> and <code>SetHoldAsWeakReference()</code> can also be used to determine this behavior. Note that indirect references are always treated as weak, regardless of this setting.</p>\n\
<p>There is now a revised set of reference messages to allow owners of IRefTargContainers to know when an element has been removed, added, set or nulled:</p>\n\
<ul>\n\
<li><code>REFMSG_CONTAINER_ELEMENT_NULLED</code> (replaces the deprecated <code>REFMSG_INDIRECT_REFTARG_MONITOR_CONTAINER_TARGET_DELETED</code> and <code>REFMSG_TAB_ELEMENT_NULLED</code> ) - Sent when a reftarg held by ParamBlock2 or a <code>IRefTargContainer</code>-derived class instance is deleted.</li>\n\
<li><code>REFMSG_CONTAINER_ELEMENT_ADDED</code> - Notification sent by <code>IRefTargContainer</code>-derived class instances to immediate dependents when an item slot is added.</li>\n\
<li><code>REFMSG_CONTAINER_ELEMENT_REMOVED</code> - Notification sent by <code>IRefTargContainer</code>-derived class instances to immediate dependents when an item slot is removed.</li>\n\
<li><code>REFMSG_CONTAINER_ELEMENT_SET</code> - Notification sent by <code>IRefTargContainer</code>-derived class instances to immediate dependents when an item slot is set.</li>\n\
</ul>\n\
<p>See <code>IRefTargContainer</code> in the C++ API Reference for more information.</p>\n\
<h3 id=\"maxscript-exposure\">MAXScript exposure</h3><p><code>RefTargContainer</code> and <code>IndirectRefTargContainer</code> instances can be now created in MAXScript, as in this example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">rtc = RefTargContainer ()\n\
showinterfaces rtc\n\
\n\
irtc = IndirectRefTargContainer()\n\
showinterfaces irtc</code></pre><p>See the MAXScript Guide for more information.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2015_sdk.html\">What&#x27;s New: 3ds Max 2015 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";