var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"support_for_multi-threaded_textu\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Support for Multi-Threaded Texture Baking</h1></div><p>A new system to improve the performance of baking textures for display in the viewport has been added to 3ds Max 2015. The system uses multi-threading to evaluate the Texmap&apos;s <code>EvalColor()</code> and <code>EvalMono()</code> methods. Because these methods can be called from multiple threads, they must be made thread safe by the developer. For example, if the method modifies a parameter block or other global variable, it must do so in a thread safe manner. See <a href=\"./../../../best_practices/thread_safety.html\">Thread Safety</a> in the Programmer&apos;s Guide.</p>\n\
<p>To use the API, include  <em>TexmapThreadSafe.h</em>  . A typical implementation is as follows and can be added to the constructor of the plugin class:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">MaxSDK::TexmapThreadSafe* pTexmapThreadSafe =\n\
static_cast&lt;MaxSDK::TexmapThreadSafe*&gt;(GetInterface(ITEXMAP_THREAD_SAFE));\n\
 DbgAssert(pTexmapThreadSafe != nullptr);\n\
 pTexmapThreadSafe-&gt;SetFunctionFlag(MaxSDK::TexmapThreadSafe::FunctionEvalMono,\n\
true);\n\
 pTexmapThreadSafe-&gt;SetFunctionFlag(MaxSDK::TexmapThreadSafe::FunctionEvalColor,\n\
true);\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2015_sdk.html\">What&#x27;s New: 3ds Max 2015 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";