var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_2016_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 2016 SDK</h1></div><p>The 3ds Max 2016 SDK is binary backward compatible with the 3ds Max 2015 SDK. This means you can run plug-ins compiled with the 3ds Max 2015 SDK in 3ds Max 2016 (but not vice versa) without recompilation. The changes to the 3ds Max 2016 SDK are mostly additions and extensions.</p>\n\
<p>See the <a href=\"./../about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a> to know the platform requirements for building plug-ins in 3ds Max 2016.</p>\n\
<h2 id=\"metasl-support\">MetaSL Support</h2><p>MetaSL is no longer supported in 3ds Max 2016. This affects <code>IShaderManager</code> and <code>IHLSLMaterialTranslator</code>. To customize the viewport display in realistic mode, use HLSL directly.</p>\n\
<h2 id=\"opensubdiv-support\">OpenSubdiv Support</h2><p>The OpenSubdiv modifier was introduced in the 3ds Max 2015 Extension.</p>\n\
<p>SDK exposure can be found in the classes <code>OpenSubdiv</code> and <code>OpenSubdivParameters.</code></p>\n\
<p>A code sample exercising these classes can be found in  <em>maxsdk/samples/utilities/OpenSubdivTest</em> .</p>\n\
<h2 id=\"rendering\">Rendering</h2><p><code>IRenderMessageManager.h</code> is now public.</p>\n\
<p>New class <code>ThreadedProcessor</code> ( <em>toneop.h</em> ). This extends the SDK, adding an interface that enables processing the tone operator in a separate thread. The Rendering API now makes use of this, whenever available, to avoid hogging the main thread.</p>\n\
<p>New interface to access Oxygen ID services on A360 for cloud rendering: <code>IAutodesk360</code>.</p>\n\
<p><code>Interface16::GetCurrentRenderView()</code> - A new method that enables querying the view which is currently selected for rendering in the render panel.</p>\n\
<p><code>GetRendViewID()</code>, <code>SetRendViewID()</code> - These methods allow you to query render settings for any render mode (production, active shade, etc.) rather than just the current render mode.</p>\n\
<p>Extension to Sky Environment SDK interface: <code>IMRPhysicalSkyEnvironmentMap2</code> - This class represents the Mental Ray Physical Sky Environment Map, implemented by 3ds Max. SDK client code can get this interface by querying 3ds Max for the current environment map, then asking that object for this interface.</p>\n\
<h2 id=\"physical-camera-feature\">Physical Camera Feature</h2><p>The new Physical Camera feature is exposed with the <code>IPhysicalCamera</code> class ( <em>IPhysicalCamera.h</em> ). This class includes methods for getting and setting the camera parameters (such as film width, effective focal length, crop zoom factor, and so on). See the SDK Reference for more information.</p>\n\
<p>As part of this feature, there is a new <code>ToneOperator2</code> class. The new interface adds methods which accept camera and view information, enabling the tone operator to fetch exposure parameters from the camera and to support features such as vignetting (which requires pixel coordinates).</p>\n\
<h2 id=\"xref-changes\">XRef Changes</h2><p>The new XRefMaterial override material feature is exposed in <code>IXRefMaterial18</code>.</p>\n\
<p>Changes to the XRef Objects dialog are exposed in the <code>IObjXRefManager16</code> methods: <code>GetTracksStatus()</code> and <code>SetTracksStatus()</code>. In addition, there are two new Object Xref Options: <code>XREF_TRACKS_XREF</code> (track will inherit the source), <code>XREF_TRACKS_LOCAL</code> (track will be local for editing).</p>\n\
<h2 id=\"editpoly-changes\">EditPoly Changes</h2><p><code>EditPoly</code> now has support for hard &amp; smooth edges:</p>\n\
<ul>\n\
<li>In  <em>iepoly.h</em>  there are new <code>epolyParameters</code>: <code>ep_hard_edge_display_color</code>, <code>ep_hard_edge_display</code></li>\n\
<li>In  <em>iEPolyMod.h</em> , new <code>epolyModParameters</code> values: <code>epm_data_channel</code>, <code>epm_data_value</code>, <code>epm_hard_edge_display_color</code>, <code>epm_hard_edge_display</code></li>\n\
</ul>\n\
<p><code>MNMesh</code> now supports colors in per-vertex and per-edge data channels, currently used in <code>VDATA_COLOR</code> and <code>EDATA_COLOR</code> channels to define colors to be used when displaying these items in the viewports (Crease Set colors and Hard/Smooth edges). Per-element data now may be <code>PERDATA_TYPE_COLOR24</code> in addition to <code>PERDATA_TYPE_FLOAT</code> (see <code>mesh.h</code>).</p>\n\
<p>New display flags (<code>MNDISP_USE_VERTEX_COLORS</code> and <code>MNDISP_USE_EDGE_COLORS</code>) may be set to display these colors in the viewports if these channels are present on the mesh. If these flags are set and no per-item color channels are defined, the items are drawn normally.</p>\n\
<p><code>MNMesh</code> now has several new Topology Utilities, smoothing group methods:</p>\n\
<ul>\n\
<li><code>FindAvailableSmoothingGroups()</code></li>\n\
<li><code>FindAvailableSmoothingGroupFromFaceList()</code></li>\n\
<li><code>OptimizeSmoothingGroups()</code></li>\n\
<li><code>FaceFindEdgeAdjacentFaces()</code></li>\n\
<li><code>FaceFindAdjacentFaces()</code></li>\n\
<li><code>VertexFindAdjacentFaces()</code></li>\n\
</ul>\n\
<p>A new class extends <code>EPolyMod</code>: <code>EPolyMod18</code>.</p>\n\
<h2 id=\"alembic-importer-support\">Alembic Importer Support</h2><p>New standard color IDs: <code>kTrackbarCachedLineColor</code>, <code>kTrackbarCacheLineColor.</code></p>\n\
<h2 id=\"atf-importer-support\">ATF Importer Support</h2><p>Open recursively is now defined in maxcom.h: <code>MAXCOM_GROUP_OPEN_RECURSIVELY</code>.</p>\n\
<h2 id=\"max-creation-graph-support\">Max Creation Graph Support</h2><p>New asset type in  <em>AssetType.h</em> : <code>AssetType.kMaxCreationGraph</code></p>\n\
<h2 id=\"chamfer-modifier-support\">Chamfer Modifier Support</h2><p>In  <em>mnmesh.h</em>  there is a new edge flag <code>MN_EDGE_WAS_PROCESSED</code>.</p>\n\
<h2 id=\"parameterblock-changes\">ParameterBlock Changes</h2><h3 id=\"new-flags\">New Flags</h3><p> <em><code>P_USE_NODE_OS_VALIDITY</code> and <code>P_USE_NODE_TM_VALIDITY</code></em><br>When specified, the validity interval of the param block will take into account that of the node parameter&#39;s transform (<code>P_USE_NODE_VALIDITY</code>) or object space/geometry pipeline (<code>P_USE_NODE_OS_VALIDITY</code>).</p>\n\
<p>These new flags can be used in conjunction with any other PB2 parameter flag. They need to be specified as the second flag value (See <code>P_READ_SECOND_FLAG_VALUE</code> for details on the second per-parameter flag value).</p>\n\
<p> <em><code>P_READ_ONLY_ASSET</code></em><br>When set as a second PB2 param flag, this flag means that the asset is not retargetable and not editable via Maxscript (equivalent to <code>P_READ_ONLY</code> being set too).</p>\n\
<p> <em><code>P_ENUMERATE_AS_ASSET</code></em><br>This flag indicates that the parameter&#39;s value will be recognized and treated as an asset without extra code from the plug-in developer. For example, the plugin will not need to override Animatable::EnumAuxFiles() in order for the parameter&#39;s value to show up in the Asset Tracker System, to be archived, etc. This flag needs to be specified as the second flag value when declaring ParameterBlock2 parameters.</p>\n\
<p> <em><code>P_NO_MACRO_RECORDER</code></em><br>When set, changes to this parameter will not be recorded by the macro recorder. This can be useful when using <code>P_USE_ACCESSOR_ONLY</code> entries to control other parameters indirectly. This flag needs to be specified as the second flag value when declaring ParameterBlock2 parameters.</p>\n\
<h3 id=\"new-methods\">New Methods</h3><p> <em><code>SetValueByName()</code>, <code>GetValueByName()</code></em><br>These two new methods provide a way to get and set parameter values by name instead of ID.</p>\n\
<p> <em><code>GetParamDefByIndex()</code></em><br>This method&#39;s purpose is to provide an efficient way of iterating over parameter definitions without having to access the public data members directly. This is more efficient than the traditional way of calling <code>GetParamDef(IndexToID(i))</code>.</p>\n\
<h3 id=\"other-changes\">Other Changes</h3><p>Get Value Methods Now Take Validity Intervals<br>All get value methods (such as <code>GetInt()</code>) now have validity intervals.</p>\n\
<p> Set Value Methods Now Take Const Objects<br>Setters (the various <code>SetValue()</code> methods) now take references to const objects, enabling clients to write code which is const-correct and safer.</p>\n\
<h2 id=\"graphics-sdk-changes\">Graphics SDK Changes</h2><p>New classes <code>RenderWorldHandle</code>, <code>ICamera</code>, <code>CustomRenderStageHandle</code>, and <code>SimpleRenderGeometry</code> are now exposed. These are demonstrated in new how-to samples for fragment systems. The new samples are:</p>\n\
<ul>\n\
<li><em>howto/Graphics/Bloom</em> </li>\n\
<li><em>howto/Graphics/CustomBackground</em> </li>\n\
<li><em>howto/Graphics/lightsample</em> </li>\n\
<li><code>howto/Graphics/SimDesktop</code></li>\n\
</ul>\n\
<p>New interfaces supporting ActiveShade renders: <code>INoSignalCheckProgress</code>, <code>IAbortableRenderer</code>.</p>\n\
<p>New methods on <code>TextureHandle</code> to control Mipmap generation: <code>SetAutoGenerateMipMaps()</code> and <code>GetAutoGenerateMipMaps()</code>.</p>\n\
<p>New methods in <code>HLSLMaterialHandle</code>: <code>InitializeWithResource()</code>, <code>SetBufferParameter()</code>.</p>\n\
<h3 id=\"-code-irenderview-code-code-ifixedviewportpipeline-code-\"><code>IRenderView</code>, <code>IFixedViewportPipeline</code></h3><p>The root entry for the fragment graph system is now exposed as <code>IRenderView2</code>. To acquire the <code>IRenderView2</code> instance , use <code>ViewExp18::GetRenderView()</code>. With this interface, you can set customized background/shade fragments, and add customized post-shading/overlay fragments. Moreover, you can set your own override graph to the render view.</p>\n\
<h2 id=\"other-changes\">Other Changes</h2><p>The <code>IContainerObject16</code> Interface (in  <em>IContainerObject.h</em> ) provides support for control of how layer merges are handled.</p>\n\
<p><code>Point2 XY() const</code> - this function allows you to easily convert from <code>Point3</code> to <code>Point2</code>.</p>\n\
<p>Support for pinned layers is exposed in new methods in <code>ILayerManagerEx</code>: <code>SetPinnedLayer()</code>, <code>GetPinnedLayer()</code>.</p>\n\
<p><code>UtilExport MSTR CaptureCallStack()</code> - this function walks the current call stack and for each level captures the source file name, line number, and method name.</p>\n\
<h2 id=\"versioning\">Versioning</h2><p>SDK release numbering is updated for this release:</p>\n\
<ul>\n\
<li><code>MAX_RELEASE</code> is <code>MAX_RELEASE_R18</code> now</li>\n\
<li>Use <code>GetCOREInterface16()</code> to access <code>Interface16</code>.</li>\n\
</ul>\n\
<p><code>GetAppID()</code> in <code>plugapi.h</code> is now deprecated because it is no longer needed, as there is only one product version (Max Design no longer exists).</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../archive.html\">What&#x27;s New in Older Versions</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";