var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_2017_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 2017 SDK</h1></div><p>This topic describes new items and changes that affect the 3ds Max 2017 C++ SDK.</p>\n\
<h2 id=\"sdk-break\">SDK Break</h2><p>3ds Max 2017 is not binary compatible with previous versions. This means that plug-ins must be recompiled using the 3ds Max 2017 SDK and the Microsoft Visual C/C++ version 14.0 compiler. See the <a href=\"./../about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a> to know the platform requirements for building plug-ins in 3ds Max 2017.</p>\n\
<h2 id=\"text-plus\">Text Plus</h2><p>New classes support TextPlus bevel profiles:</p>\n\
<ul>\n\
<li><code>BevelProfileEditorInformation</code></li>\n\
<li><code>BevelProfileUtilityInterface</code></li>\n\
<li><code>BevelProfileCurveUser</code></li>\n\
<li><code>BevelProfileCurveInterface</code></li>\n\
</ul>\n\
<p>See the header  <em>&lt;maxsdk&gt;\\include\\BevelProfileInterface.h</em> .</p>\n\
<h2 id=\"skin-weighting\">Skin Weighting</h2><p>The Voxel/Heat Map skin weighting feature is now exposed in the SDK by the following classes:</p>\n\
<ul>\n\
<li><code>ITransformHierarchy</code> - defines the skeleton that skin is using. You just add the transform, node name, and parent name of all the skin bones. Note names have to be unique.</li>\n\
<li><code>IMesh</code> - is the mesh definition used by the solver. It is simple triangle soup. There are no checks for valid meshes which need to be pre-processed.</li>\n\
<li><code>ISparseVertexWeights</code> - where the output is stored from the solvers. The skin weights are simple arrays of pairs of weights and bone indices per vertex.</li>\n\
<li><code>IProgress</code> - a simple abort and progress interface used track how far along the algorithm is and allows it to be canceled.</li>\n\
<li><code>IContext</code> - the actual weighting engine and has all the calls to solve the weights.</li>\n\
</ul>\n\
<p>See the header  <em>&lt;maxsdk&gt;\\include\\geombind.h</em> , and the example at  <em>&lt;maxsdk&gt;\\samples\\modifiers\\bonesdef\\VoxelWeights\\BMD_Command_VoxelWeight.cpp</em> .</p>\n\
<p>Note that the solver uses openGL and assumes that there is already a valid context. So before calling any of the methods an openGL context must be created first and set current. Also all formats are in an openGL format.</p>\n\
<p>See  <em>Geombind.h</em>  for documentation and  <em>maxsdk\\samples\\modifiers\\bonesdef\\VoxelWeights\\BMD_Command_VoxelWeight.cpp</em>  for example usage.</p>\n\
<h2 id=\"opensubdiv\">OpenSubdiv</h2><p>The OpenSubdiv feature now has SDK exposure via the <code>OSDModifierInterface</code> class (see the  <em>OSDModInterface.h</em>  header). You can get and set the modifier&#39;s parameters.</p>\n\
<p>OpenSubdiv Crease Sets are exposed by the  <em>CreaseSetContainer.h</em>  header, which allows plug-ins to work with creased edges and vertices.</p>\n\
<h2 id=\"simplepolyobject\">SimplePolyObject</h2><p>The <code>SimplePolyObject</code> class (in  <em>SimplePolyObj.h</em> ) allows you to easily create procedural objects compatible with Editable Poly.</p>\n\
<h2 id=\"trackview\">Trackview</h2><p>The Trackview layout is now saved (made &quot;sticky&quot;), and this is customizable with <code>GetDefaultCurveEditorLayout()</code> and <code>SetDefaultCurveEditorLayout()</code>, in  <em>itreevw.h</em> .</p>\n\
<h2 id=\"qt\">Qt</h2><p>The SDK now supports Qt for creating plug-in UIs. The <code>QMaxParamBlockWidget</code> class integrates Qt widgets with parameter blocks, and some widgets specialized for use in 3ds Max are available in  <em>&lt;maxsdk&gt;\\include\\Qt</em> . <em>Note</em>: some of these widgets are experimental and will change in a future release.</p>\n\
<p>See the  <em>&lt;maxsdk&gt;\\samples\\systems\\sunlight</em>  project for an example of a plug-in using Qt for its UI.</p>\n\
<p>3ds Max uses a patched version of Qt 4.8.5, and you can build this from source, or use a pre-compiled package available on ADN. See <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins.html\">Using Qt with 3ds Max Plug-ins</a> in the Developer&#39;s Guide for more information.</p>\n\
<h2 id=\"daylight-simulation\">Daylight Simulation</h2><p>The new Physical Sun and Sky feature is exposed in the headers under  <em>&lt;maxsdk&gt;\\include\\DaylightSimulation</em> . This is an interface the handles computations related to the Perez All-Weather sky model.</p>\n\
<h2 id=\"mental-ray\">Mental Ray</h2><p>The Mental Ray renderer is now an install option (on by default) in 3ds Max.  The mental ray SDK and related headers have been removed from the main SDK.</p>\n\
<h2 id=\"materials\">Materials</h2><p>Material-related headers have been re-organized, and are now in a new  <em>&lt;maxsdk&gt;\\include\\Materials</em>  directory. These changes are reflected in imtl.h.</p>\n\
<p>The  <em>imtl.h</em>  header has been re-organized into several smaller files. Projects that reference this header may have to now explicitly include  <em>splineshp.h</em>  and  <em>spline3d.h</em> , which are no longer included in  <em>imtl.h</em> .</p>\n\
<h2 id=\"physical-material\">Physical Material</h2><p>The new Physical Material feature replaces older common materials that were not consistent or standard, and mental ray-specific.</p>\n\
<h2 id=\"multi-tile-sdk\">Multi-Tile SDK</h2><p>Multi-tile functionality is exposed in the IMultiTile class (in IMultiTile.h), and supports:</p>\n\
<ul>\n\
<li>Get/set pattern format</li>\n\
<li>Get/set viewport quality</li>\n\
<li>Set patterned image files.</li>\n\
<li>Get patterned file prefix, for constructing file name string.</li>\n\
<li>Get/Set UV index</li>\n\
</ul>\n\
<p>For an example, see  <em>&lt;maxsdk&gt;\\samples\\materials\\MultiTile</em> .</p>\n\
<h2 id=\"notification-api\">Notification API</h2><p>A new notification API facilitates ActiveShade renderer implementations. This API provides methods for monitoring scene elements, and is a more effective mechanism than having to monitor ReferenceTargets directly in the scene. See the <code>IInteractiveRenderingManager</code> class and the headers located in  <em>maxsdk/include/NotificationAPI/</em> .</p>\n\
<h2 id=\"rendering\">Rendering</h2><p>Several extension classes have been eliminated, and their functionality is moved into the class being extended:</p>\n\
<ul>\n\
<li>Functionality of <code>IAbortableRenderer</code> folded into class <code>IInteractiveRenderer</code>.</li>\n\
<li>Functionality of <code>IRenderElementCompatible</code> folded into class <code>Renderer</code></li>\n\
<li>Functionality of <code>IRendererInformation</code> folded into class <code>Renderer</code></li>\n\
<li>Functionality of <code>IStoppableRenderer</code> folded into class <code>Renderer</code></li>\n\
<li>Functionality of <code>IRendererRequirements</code> folded into class <code>Renderer</code></li>\n\
<li>Removed <code>kRequirement_NoPauseSupport</code>, which no longer had a reason to be, now that class <code>Renderer</code> has a method to query Pause support.</li>\n\
</ul>\n\
<p>Changed the mechanism for getting a <code>IInteractiveRenderer</code> from Renderer; now using a direct method, rather than going through the interface mechanism.</p>\n\
<p> <em>render.h</em>  and  <em>InteractiveRenderer.h</em>  have been split into several smaller files, all under  <em>&lt;maxsdk&gt;\\include\\rendering</em> , with about one class per file.  <em>render.h</em>  still exists and can continue to be used; it includes all the new files.</p>\n\
<p>Class <code>RendProgressCallback2</code> has been eliminated and folded into <code>RendProgressCallback</code>, adding method: <code>virtual void SetStep(int current, int total) = 0</code>;</p>\n\
<p>Class <code>IRenderProgressCallback</code> was renamed to <code>IInteractiveRenderer::IProgressCallback</code>, to remove ambiguity in the way the class was named.</p>\n\
<p>All renderer requirements (<code>kRequirement_\\*</code>) were renamed to remove references to the Max version number.</p>\n\
<h2 id=\"mouse-cursors\">Mouse Cursors</h2><p>Plug-ins can now load specific cursors as needed. For a list of available cursor images, see the  <em>MouseCursors.h</em>  documentation.</p>\n\
<h2 id=\"removed-and-deprecated\">Removed and Deprecated</h2><p>RendParams::GetRenderMode() is deprecated, and the associated RenderMode enum is removed.</p>\n\
<p>The Windows Theme option has been removed from the 3ds Max UI, and the corresponding SDK exposure has been removed as well. In <code>IColorManager</code>, the <code>ColorSchemeType</code> enum, and the <code>GetColorSchemeType()</code> and <code>SetColorSchemeType()</code> methods.</p>\n\
<p>See the C++ API Reference &gt; Topics &gt; <strong>Deprecated List</strong> for more deprecated items.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../archive.html\">What&#x27;s New in Older Versions</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";