var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_2018_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 2018 SDK</h1></div><p>This topic describes new items and changes that affect the 3ds Max 2018 C++ SDK.</p>\n\
<h2 id=\"update-1\">Update 1</h2><p>The Developer&#39;s Guide has a new <a href=\"./../icon_guide/icon_guide.html\">Icon Reference</a> that lists all the standard system icons, their paths, and resolutions, available in\n\
<code>UI_ln/IconsDark.rcc</code> and <code>UI_ln/IconsLight.rcc</code>.  See <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins/using_multi_res_icons.html\">Using Multi-Res Icons in Max and Qt</a> for information about how to load and use these icons\n\
in your plug-ins.</p>\n\
<h2 id=\"sdk-break\">SDK Break</h2><p>3ds Max 2018 is not binary compatible with previous versions. This means that plug-ins must be recompiled using the 3ds Max 2018 SDK and the Microsoft Visual C/C++ version 14.0 compiler. See the <a href=\"./../about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a> to know the platform requirements for building plug-ins in 3ds Max 2018.</p>\n\
<h2 id=\"qt\">Qt</h2><p>3ds Max 2018 now uses Qt 5.6.2, and plug-ins can build UIs in Qt using the standard GPL Qt 5.6.2 distribution, and the Visual Studio 2015 Qt add-on.  See <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins.html\">Using Qt with 3ds Max Plug-ins</a> for more information.</p>\n\
<h2 id=\"parameter-block-1-to-parameter-block-2-migration\">Parameter Block 1 to Parameter Block 2 Migration</h2><p>In preparation of deprecating the Parameter Block 1 system in the future, plug-in developers should start migrating projects to use Parameter Block 2.  All samples in the SDK have been migrated, and the Developer Guide now has a <a href=\"./../3ds_max_sdk_features/working_with_plug-ins/parameter_blocks/pb1_to_pb2_conversion.html\">Porting Guide</a>.</p>\n\
<p>These headers contain some small changes due to this migration:\n\
include\\iparamb.h\n\
include\\iparamb2.h\n\
include\\iparamb2.inline.h\n\
include\\iparamm2.h</p>\n\
<p><strong>Note</strong>: Parameter Block 1 is not deprecated in this release, but will be in a future release.  </p>\n\
<h3 id=\"other-parameter-block-changes\">Other Parameter Block Changes</h3><p>PBAccessor now has new <code>PreSet()</code> and <code>PostSet()</code> methods, which guarantee the state of the value returned by <code>GetValue()</code> to be either the original or new value, respectively.  In general, plug-ins should now use <code>PreSet()</code> instead of <code>Set()</code>.</p>\n\
<p>ParamBlock2 now supports Point2 and IParamBlock2 value types.</p>\n\
<p>PB2Value has some new helper methods for handling strings, <code>Initialize()</code> and  <code>ReplaceString()</code>.</p>\n\
<h2 id=\"data-channel-modifier\">Data Channel Modifier</h2><p>The new <em>maxsdk\\include\\IMNMeshDataChannel.h</em> contains classes and enums that allow you to\n\
create additional operators (&quot;engines&quot;) to be used by the Data Channel Modifier.</p>\n\
<h2 id=\"bezier-trajectories\">Bezier Trajectories</h2><p>The new <code>IAdjustTangents</code> class (<em>istdplug.h</em>) supports tangent adjustment.</p>\n\
<h2 id=\"ui-related-changes\">UI Related Changes</h2><ul>\n\
<li><code>Actiontables::IconSize</code> - adds new sizes (to support HDPI) 30x30, 36x36, 46x48</li>\n\
<li><code>QmaxDockingWinHostDelegate bool SetUserDlgProc(ParamBlockDesc2* pbd, ParamMap2UserDlgProc* proc=NULL);</code> - Previously was void type</li>\n\
<li><code>Interface17</code> - added</li>\n\
<li><em>include\\helpsys.h</em> <code>ShowProductHelp*</code> - all return bool now to indicate the help was displayed</li>\n\
<li><em>include\\hold.h</em> Hold::Accept signature using OperationDesc<ul>\n\
<li>New header: <em>\\include\\operationdesc.h</em></li>\n\
</ul>\n\
</li>\n\
<li><em>include\\idraganddrop.h</em>  - new <code>MCGFILE_DROPTYPE</code> for MCG</li>\n\
<li><em>include\\imenuman.h</em> - new <code>QMenuBar</code></li>\n\
</ul>\n\
<h2 id=\"rendering-related-changes\">Rendering Related Changes</h2><ul>\n\
<li><em>include\\NotificationAPI\\NotificationAPI_Subscription.h</em> - new\n\
<code>INotificationManager::NotifyRenderSettingsEvent</code> and <code>INotificationManager::NotifyEnvironmentEvent</code></li>\n\
<li><em>include\\Rendering\\IRendParams.h</em> - new <code>IRendParams2</code> interface with new methods</li>\n\
<li><em>include\\RenderingAPI\\Translator\\Translator.h</em><ul>\n\
<li><code>Translator::Translate</code> – added param</li>\n\
<li>New: <code>Translator::TranslateKeyframe</code></li>\n\
<li>New: <code>Translator::InvalidateParents</code></li>\n\
</ul>\n\
</li>\n\
<li><em>include\\Scene\\IHairModifier.h</em> - supports the Hair modifier</li>\n\
</ul>\n\
<h2 id=\"maxscript-changes\">MAXScript Changes</h2><p>The <code>ClassDesc::InternalName</code>() returns a fixed, parsable internal name for the plug-in.\n\
By default, Plug-in names exposed to MAXScript are generated using both the strings from <code>ClassName()</code> and <code>InternalName()</code>.  You can change this behavior by returning true from <code>ClassDesc::UseOnlyInternalNameForMAXScriptExposure()</code>, in which case the plug-in exposes only its <code>InternalName()</code>.   We recommend that new plugins implement this method and return true. </p>\n\
<h2 id=\"other-changes\">Other changes</h2><ul>\n\
<li><strong>iepoly.h</strong> includes new divide faces methods.</li>\n\
<li>New: <em>include\\IRootNode.h</em> – mainly for xref support</li>\n\
<li><em>include\\iskin.h</em> - DQBlend</li>\n\
<li><em>include\\istdplug.h</em> – PB2 work</li>\n\
<li><em>include\\itreevw.h</em> – testfilters and few misc changes</li>\n\
<li><em>include\\linshape.h</em> – removed <code>LinearShape::CreateTriObjRep(TimeValue t)</code></li>\n\
<li>include\\simpshp.h* – removed <code>SimpleShape::CreateTriObjRep(TimeValue t)</code></li>\n\
<li><em>include\\simpspl.h</em> – removed <code>SimpleSpline::CreateTriObjRep</code></li>\n\
<li><em>include\\splshape.h</em> – removed <code>SplineShape::CreateTriObjRep</code></li>\n\
<li><em>include\\triobj.h</em> - removed <code>TriObj::CreateTriObjRep</code></li>\n\
<li><em>include\\matrix3.h</em> – added methods PseudoInverse, AffineTranspose, AffineTranspose</li>\n\
<li><em>include\\maxapi.h</em><ul>\n\
<li><code>MaxSDK::QmaxMainWindow* GetQmaxMainWindow()</code></li>\n\
</ul>\n\
</li>\n\
<li>Interface17 <code>Get/SetEnableTMCache</code>, <code>NonInteractiveMode</code>, <code>SecureMode</code>, <code>SelectedKeyTangent</code>, <code>PathColoringType</code>, <code>Trajectory</code> methods</li>\n\
<li><em>include\\MaxHeap.h</em>, <em>maxheapdirect.h</em> -  <code>aligned_malloc</code>, <code>aligned_free</code>, <code>aligned_realloc</code></li>\n\
<li><em>include\\mnmesh.h</em> - <code>IMNMeshLegacySnap</code></li>\n\
<li><em>include\\notify.h</em> - <code>NOTIFY_SCENE_EXPLORER_NEEDS_UPDATE</code></li>\n\
<li><em>include\\object.h</em> - <code>HIT_MIRROREDTM</code></li>\n\
<li><em>include\\paramtype.h</em> – reordered enum</li>\n\
<li><em>include\\paramtype.h</em> - <code>ControlType2::TYPE_POINT2LISTBOX</code>, <code>TYPE_FLOAT_EDITABLE_COMBOBOX</code></li>\n\
<li><em>include\\include\\RTMax.h</em> – new <code>IParameterManager::kPType_Point3</code></li>\n\
<li><em>include\\simpobj.h</em> – <code>SimpleObject</code> cleanup, added new base.</li>\n\
<li><em>include\\snap.h</em> - <code>SNAP_OVERRIDE_UNSEL_OBJS_ONLY</code>, <code>SNAP_DURING_CREATION</code></li>\n\
<li><em>include\\TrackFlags.h</em> - <code>ADJTAN_ABSOLUTE</code>, <code>ADJTAN_ANGLE</code>, <code>ADJTAN_LENGTH</code></li>\n\
</ul>\n\
<h2 id=\"software-security-changes\">Software Security Changes</h2><p>The SDK property sheets (maxsdk\\ProjectSettings\\propertySheets\\3dsmax.general.project.settings.props) have been updated with software security settings.  Existing projects should be updated to use this property sheet.</p>\n\
<h2 id=\"removed-and-deprecated\">Removed and Deprecated</h2><h3 id=\"cui-frame\">CUI Frame</h3><p>Elements of the CUIFrame system have been removed as part of the migration to a native Qt UI for 3ds Max.  The following classes are removed:</p>\n\
<ul>\n\
<li><code>CUIPosData</code></li>\n\
<li><code>CUIFrameMsgHandler</code></li>\n\
<li><code>ICUIFrame</code></li>\n\
</ul>\n\
<p>The <code>CUIFrameMgr::GetCount()</code> method is removed.</p>\n\
<p>The <code>CreateCUIFrameWindow()</code> method is also removed.  To create a\n\
new window frame for a toolbar, use <code>MaxSDK::QmaxToolBar()</code> instead.  See the <em>maxsdk/howto/ui/cuitest</em> sample for an\n\
example.</p>\n\
<h3 id=\"deprecated\">Deprecated</h3><p>See the C++ API Reference &gt; Topics &gt;  <strong>Deprecated List</strong> for more deprecated items.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../archive.html\">What&#x27;s New in Older Versions</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";