var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_9_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 9 SDK</h1></div><p>The 3ds Max 9 SDK have added new classes and updated existing classes to introduce significant performance, functionality and, especially, memory management improvements. This means that, to achieve optimal performance of your plug-ins, you will need to visit the code of your existing plug-ins and consider making changes.</p>\n\
<h2 id=\"upgrading-plug-ins-built-using-earlier-versions\">Upgrading plug-ins built using earlier versions</h2><p>Upgrade information is organized under the following topics:</p>\n\
<ul>\n\
<li><a href=\"./../../writing_plug-ins/advanced_plug-in_topics/upgrading_to_64-bit.html\">Upgrading to 64-Bit</a> - 3ds Max now operates in both 32- and 64-bit environments. Several topics describe considerations for developing, compiling and operating in this new situation.</li>\n\
<li><a href=\"./../../best_practices/memory_management.html\">Memory Management</a> - New memory management practices have been introduced.</li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/vault_and_asset_tracking.html\">Vault and Asset Tracking</a> - Built-in asset tracking system interfaces have been updated.</li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/reference_system_changes_9.html\">Reference System Changes</a> - Much work has been done to enhance and stabilize the Reference System. Developers who found the need to use node pointers to induce the effect of circular reference hierarchies should use <a href=\"./../../3ds_max_sdk_features/reference_system/kinds_of_references/indirect_references.html\">Indirect References</a> instead of pointers as of Version 9.</li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/noremap_was_deprecated.html\">NoRemap() was Deprecated</a> - NoRemap() no longer exists.</li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/superclassid_cleanup.html\">SuperClassID Cleanup</a> - Classes derived directly from Animatable were not required to overwrite <code>Animatable::SuperClassID()</code> causing invalid super class ID&#39;s to be reported. SDK classes derived directly from Animatable now overwrite the method and existing plug-ins with classes derived directly from <code>Animatable</code> should be updated.</li>\n\
<li><a href=\"./../../3ds_max_sdk_features/miscellaneous_topics/plugin.ini.html\">Plugin.ini</a> - The method to access the  <em>plugin.ini</em>  file has changed.</li>\n\
</ul>\n\
<h2 id=\"new-features-and-other-changes-to-the-3ds-max-sdk\">New Features and Other Changes to the 3ds Max SDK</h2><p>The following is a list of what else is new as of the <em>3ds Max 9 SDK</em>:</p>\n\
<ul>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/relative_paths.html\">Relative Paths</a></li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/nvidia_cg_support.html\">NVIDIA Cg Support</a></li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/what_s_new_in_3dxi.html\">What&#39;s New in 3DXI</a></li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/paramblockdesc2_flags.html\">ParamBlockDesc2 Flags</a></li>\n\
<li><a href=\"what_s_new_3ds_max_9_sdk/mbcs_versus_unicode.html\">MBCS Versus Unicode</a></li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/upgrading_to_visual_studio_2005_.html\">Upgrading to Visual Studio 2005 (Visual C++ 8.0)</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/reference_system_changes_9.html\">Reference System Changes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/relative_paths.html\">Relative Paths</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/nvidia_cg_support.html\">NVIDIA Cg Support</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/what_s_new_in_3dxi.html\">What&#x27;s New in 3DXI</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/paramblockdesc2_flags.html\">ParamBlockDesc2 Flags</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/superclassid_cleanup.html\">SuperClassID Cleanup</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/noremap_was_deprecated.html\">NoRemap() was Deprecated</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/mbcs_versus_unicode.html\">MBCS Versus Unicode</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/vault_and_asset_tracking.html\">Vault and Asset Tracking</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/method_for_including_.lib_files.html\">Method for Including .lib files</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/size_t_considerations.html\">size_t Considerations</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"what_s_new_3ds_max_9_sdk/max_file_format_change.html\">Max File Format Change</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../archive.html\">What&#x27;s New in Older Versions</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";