var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"mbcs_versus_unicode\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>MBCS Versus Unicode</h1></div><p>3ds Max is a multi-byte character set (MBCS) system. Yet, there is a need for certain plug-ins to support Unicode. For this release of the <em>3ds Max SDK</em>, we have started the process of converting to a selectable MBCS/Unicode product. The approach permits MBCS or Unicode plug-ins to operate with 3ds Max, at the developer&#39;s discretion, but 3ds Max itself has yet to be converted to Unicode.</p>\n\
<h2 id=\"what-has-actually-changed-\">What has actually changed?</h2><p>Character types in the <em>3ds Max 9 SDK</em> have been remapped, not comprehensively, according to the following table:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td><em>Usual Types</em></td>\n\
<td><em>Max Types</em></td>\n\
</tr>\n\
<tr>\n\
<td>TCHAR</td>\n\
<td>MCHAR</td>\n\
</tr>\n\
<tr>\n\
<td>TSTR</td>\n\
<td>MSTR</td>\n\
</tr>\n\
<tr>\n\
<td>_T()</td>\n\
<td>_M()</td>\n\
</tr>\n\
</tbody></table>\n\
<p>The mapping of M-types is the same as the original T-types.</p>\n\
<h2 id=\"impact\">Impact</h2><p>There is no impact to 3rd party plug-ins. All changes are binary compatible with existing <em>3ds Max 9</em> plug-ins. Developers should keep the following points in mind:</p>\n\
<ul>\n\
<li>Some parameter types may appear to be changed on the surface, but these are all macros that map to the same values as <em>3ds Max 8 SDK</em> and earlier versions</li>\n\
<li>Experienced plug-in developers will likely not see a difference until they are faced with compile-time warnings or errors, similar to what occurred with the Microsoft Windows Platform SDK, which seemed to arrive unbidden</li>\n\
<li>Again, 3ds Max has not been converted to a Unicode system; it now only tolerates Unicode plug-ins</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";