var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"paramblockdesc2_flags\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>ParamBlockDesc2 Flags</h1></div><p>The topic describes significant new <code>ParamBlockDesc2</code> flags.</p>\n\
<h2 id=\"p_read_second_flag_value\">P_READ_SECOND_FLAG_VALUE</h2><p>If this flag is set on the first per param constructor-specifiable flag value, a second <code>DWORD</code>-size per-parameter constructor-specifiable flag value follows the first. The value is read-in, shifted left <code>DWORD</code> places and combined with the first flag value to form the <code>ParamDef</code> flag value. This input flag bit is not set in the <code>ParamDef</code> flag value after the flag values are read-in, and this bit can be re-used as a per-parameter internal flag bit.</p>\n\
<p>The following code is an example of how to use this new flag:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">static  ParamBlockDesc2 bend_param_blk ( bend_params, _T(&quot;Bend Parameters&quot;), 0, &amp;bendDesc, P_AUTO_CONSTRUCT + P_AUTO_UI, SIMPMOD_PBLOCKREF,\n\
//rollout\n\
IDD_BENDPARAM, IDS_RB_PARAMETERS, 0, 0, NULL,\n\
// params\n\
\n\
bend_angle, _T(&quot;BendAngle&quot;), TYPE_FLOAT, P_RESET_DEFAULT|P_ANIMATABLE|P_READ_SECOND_FLAG_VALUE,   P_USE_ACCESSOR_ONLY, IDS_ANGLE,\n\
  p_default, 0.0f,\n\
  p_range, -BIGFLOAT, BIGFLOAT,\n\
  p_ui, TYPE_SPINNER, EDITTYPE_FLOAT, IDC_ANGLE, IDC_ANGLESPINNER, 0.5f,\n\
  end,\n\
\n\
bend_dir, _T(&quot;BendDir&quot;), TYPE_FLOAT, P_RESET_DEFAULT|P_ANIMATABLE, IDS_DIR,\n\
  p_default, 0.0f,\n\
  p_range, -BIGFLOAT, BIGFLOAT,\n\
  p_ui, TYPE_SPINNER, EDITTYPE_FLOAT, IDC_DIR, IDC_DIRSPINNER, 0.5f,\n\
  end,</code></pre><p>The 2nd flag value is read on BendAngle because <code>P_READ_SECOND_FLAG_VALUE</code> is set in the first flag value.</p>\n\
<h2 id=\"p_use_accessor_only\">P_USE_ACCESSOR_ONLY</h2><p>When this flag is set, the <code>paramblock2</code> will only go through an objects&apos;s accessor when getting or setting a value, or when determining if a key exists at a certain time.</p>\n\
<p>If <code>P_USE_ACCESSOR_ONLY</code> is not set:</p>\n\
<ul>\n\
<li>on a <code>SetValue</code>, the normal operation is to send the value through the accessor first, and then set the controller&apos;s value</li>\n\
<li>on a <code>GetValue</code>, the normal operation is to get the value from the controller and then send it through the accessor</li>\n\
</ul>\n\
<p><code>P_USE_ACCESSOR_ONLY</code> is specified in the second per-parameter constructor-specifiable flag value.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";