var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"reference_system_changes_9\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Reference System Changes</h1></div><p>This topic describes changes to <em>3ds Max&#39;s Reference System</em> that affect existing plug-ins developed under Version 8 and earlier of the <em>3ds Max SDK</em>.</p>\n\
<h2 id=\"referencemaker-makerefbyid-has-been-deprecated\">ReferenceMaker::MakeRefByID() has been Deprecated</h2><p>This function has been deprecated for public use. Use ReplaceReference() instead.</p>\n\
<p>Also note the following:</p>\n\
<p>It is extremely important to initialize a reference to <code>NULL</code> before a plug-in&#39;s first call to <code>ReplaceReference()</code>.</p>\n\
<p>Failure to do so will result in generally volatile behavior of 3ds Max.</p>\n\
<h3 id=\"tests-to-ensure-that-references-are-set-up-correctly\">Tests to ensure that references are set up correctly</h3><p>There are 2 tests that can be enabled to ensure that plug-ins set up their references correctly. Both are executed when a plug-in calls <code>ReplaceReference()</code>:</p>\n\
<ol>\n\
<li>The first test ensures that all references of a plug-in are initialized to <code>NULL</code> before it establishes its first reference. Whether to perform this check defaults to <code>TRUE</code> for Hybrid and Debug builds, and <code>FALSE</code> for Release builds. The <code>3DSMAX_REFCHECK_ENABLED</code> environment variable can be used to override the default behavior. See the description of <code>bool``UtilityInterface::GetBoolEnvironmentVariable</code>( TCHAR* pEnvVar, bool DefaultVal) for the values this environment variable can take.</li>\n\
<li>The second test ensures that all references of a plug-in have been set up correctly. This test can also detect &quot;dangling&quot; references - those that are non-<code>NULL</code> but point to non-existent reference targets. Whether to perform this check defaults to <code>FALSE</code> for all build configurations (Debug, Hybrid and Release). The <code>3DSMAX_REFCHECK_PARANOID_ENABLED</code> environment variable can be used to override the default behavior. See the description of <code>bool``UtilityInterface::GetBoolEnvironmentVariable</code>( TCHAR* pEnvVar, bool DefaultVal) for the values this environment variable can take.</li>\n\
</ol>\n\
<h4 id=\"referencemaker-enumdependents-has-been-deprecated\">ReferenceMaker::EnumDependents() has been Deprecated</h4><p>This function has been deprecated for public use. Two new methods are provided for developers. If you want to call the built-in replacement for EnumDependents(), call DoEnumDependents(). If your plug-in needs to customize the default dependent enumeration, it can overwrite DoEnumDependentsImpl(). The behavior of DoEnumDependents guarantees that each <code>ReferenceMaker</code> is visited only once.</p>\n\
<h4 id=\"remapdir-amp-noremap-replaced-by-class-defaultremapdir\">RemapDir&amp; NoRemap() replaced by class DefaultRemapDir</h4><p>The NoRemap() function, which returned a reference to a <code>RemapDir</code> has been removed. Its functionality has been replaced by a the class <code>DefaultRemapDir</code> whose constructor provides the same information.</p>\n\
<h4 id=\"iweakreference-renamed-to-iindirectreference\">IWeakReference renamed to IIndirectReference</h4><p>See IIndirectRefMaker.h in which the class is declared and all symbols and methods renamed.</p>\n\
<h4 id=\"indirect-references-can-be-used-instead-of-node-pointers\">Indirect References Can Be Used Instead of Node Pointers</h4><p>Many plug-in developers need to use circular reference hierarchies in their work. The problem caused by using node pointers to create circular references is that node pointers are not automatically saved and loaded by external reference (Xref) code, nor are they valid between 3ds Max sessions. Indirect references give developers a safe, official method for handling circular reference hierarchies. The following topics address these subject in more detail:</p>\n\
<ul>\n\
<li><a href=\"./../../../3ds_max_sdk_features/reference_system/kinds_of_references/indirect_references.html\">Indirect References</a></li>\n\
<li><a href=\"./../../../3ds_max_sdk_features/reference_system/kinds_of_references/indirect_references/using_indirect_references_instea.html\">Using Indirect References Instead of Pointers</a></li>\n\
<li><a href=\"./../../../3ds_max_sdk_features/scenes_and_nodes/organizing_nodes/xref_scenes_and_objects.html\">XRef Scenes and Objects</a></li>\n\
</ul>\n\
<h4 id=\"referencemaker-isrealdependency-\">ReferenceMaker::IsRealDependency()</h4><p>The default behavior of <code>ReferenceMaker::IsRealDependency()</code> continues to return TRUE so that references are, by default, real or strong. If IsRealDependency returns FALSE, the return value from ShouldPersistWeakRef (not ShouldPersistIndirectRef) is checked on file save. If it returns FALSE, we do not force the save of the RT.</p>\n\
<p>The return values from <code>IsRealDependency</code> and <code>ShouldPersistWeakRef</code> are stored in the scene file. If we do a load of an RM where both are <code>FALSE</code>, the RT is not forced to load. If <code>ShouldPersistWeakRef</code> returns <code>TRUE</code>, and this <code>ReferenceMaker</code> is loaded or saved, the weak reference will be forced to be loaded or saved. If <code>FALSE</code>, the reference will not be forced to be loaded or saved, but will be hooked back up if it is loaded.</p>\n\
<p>As before, any <code>ReferenceMakers</code> that hold a weak reference to the reference target will receive a <code>REFMSG_TARGET_DELETED</code> notification.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";