var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"relative_paths\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Relative Paths</h1></div><p>Version 9 of the 3ds Max SDK introduces the notion of a user defined project folder and a library of functions that facilitate the use of relative paths (relative to the project folder) for managing users&#39; assets. <code>MaxSDK::Util::Path</code> is a type designed for doing path-related string manipulations. It also works well with the newly introduced methods of <code>IPathConfigMgr</code>.</p>\n\
<p>The following is a summary of the more conspicuous of the numerous methods provided:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Method</td>\n\
<td>.h File</td>\n\
<td>Description</td>\n\
</tr>\n\
<tr>\n\
<td>ConvertToRelativeTo</td>\n\
<td>Path.h</td>\n\
<td>Convert this absolute Path so that it points to the same location but relative to the new base path.</td>\n\
</tr>\n\
<tr>\n\
<td>ConvertToAbsolute</td>\n\
<td>Path.h</td>\n\
<td>Converts a given relative path to an absolute path rooted at the current project folder.</td>\n\
</tr>\n\
<tr>\n\
<td>GetResolvedAbsolutePath</td>\n\
<td>Path.h</td>\n\
<td>Get the fully-resolved, lower case, path converted to absolute rooted at the current project folder.</td>\n\
</tr>\n\
<tr>\n\
<td>ConvertToRelativeToProjectFolder</td>\n\
<td>Path.h</td>\n\
<td>Get the fully-resolved, lower case, path converted to absolute rooted at the current project folder.</td>\n\
</tr>\n\
<tr>\n\
<td>Normalize</td>\n\
<td>Path.h</td>\n\
<td>Transforms a path in to its normal form (without extra relative indicators).</td>\n\
</tr>\n\
<tr>\n\
<td>SearchForExternalFiles</td>\n\
<td>IPathConfigMgr.h</td>\n\
<td>Resolves a given path using a predefined path search order for external files.</td>\n\
</tr>\n\
<tr>\n\
<td>MakePathRelativeToProjectFolder</td>\n\
<td>IPathConfigMgr.h</td>\n\
<td>Converts an absolute path into a path that is relative to the current project folder.</td>\n\
</tr>\n\
<tr>\n\
<td>GetProjectFolderPath</td>\n\
<td>IPathConfigMgr.h</td>\n\
<td>Returns the fully-qualified path of the project file, given the root folder of an existing project.</td>\n\
</tr>\n\
<tr>\n\
<td>SetCurrentProjectFolder</td>\n\
<td>IPathConfigMgr.h</td>\n\
<td>Sets the current project folder.</td>\n\
</tr>\n\
</tbody></table>\n\
<p>The library supports the free conversion to and from Universal Naming Convention (UNC) paths. See <code>maxsdk</code>\\include\\Path.h and <code>maxsdk</code>\\include\\IPathCOnfigMgr.h.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";