var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"size_t_considerations\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>size_t Considerations</h1></div><p>A <code>size_t</code> has a different size depending on the target platform.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#ifdef _WIN64\n\
typedef unsigned __int64 size_t;\n\
#else\n\
typedef _W64 unsigned int size_t;\n\
#endif</code></pre><p>When porting 3ds Max to <em>x64</em>, size_t compatibility was forsaken</p>\n\
<p>We chose the following practices for the <em>x64</em> version of 3ds Max:</p>\n\
<ul>\n\
<li>Existing containers would keep their existing limits of 2 and 4 billion entries.</li>\n\
<li>Existing implementations would down-cast their size_t values to int and unsigned int as required by the interfaces. That is, an implementation using an <em>STL</em> container and returning a count to the outside world.</li>\n\
<li>We would not focus on the number of entities, but rather on the total allocated <em>RAM</em>. No explicit support for single entities over 4GB (and in most cases the actual closer to 2GB because of int), but no hard limit on the total sum.</li>\n\
<li>If a module uses an appropriate algorithm and can handle vast amounts of data then it can be upgraded to perfect <em>x64</em> size_t compatability.</li>\n\
</ul>\n\
<p>The above also applies to a few other major APIs, such as <code>fread</code> and <code>fwrite</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";