var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"superclassid_cleanup\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>SuperClassID Cleanup</h1></div><p>Since plug-ins were never forced to overwrite the method <code>virtual``SClass_ID``Animatable::SuperClassID</code>(), and the <code>ReferenceMaker</code> and <code>ReferenceTarget</code> classes have not been overwriting this method either, some plug-in classes were reporting an incorrect superclassid - a value of 0 or <code>REF_MAKER_CLASS_ID</code> when, in fact, they derive from class <code>ReferenceTarget</code>.</p>\n\
<p>This led to subtle bugs and to special case code for checking whether a superclassid is 0 which is not an official superclassid value - it i&#39;s not defined as a superclassid value in the <em>3ds Max SDK</em>.</p>\n\
<p>Existing plug-ins fail to recompile if one of their classes derives directly from <code>Animatable</code> and do not overwrite the <code>SuperClassID()</code> method. The class should derive from a different <em>3ds Max SDK</em> class, such as <code>ReferenceMaker</code> or <code>ReferenceTarget</code> which now correctly overwrite the method.</p>\n\
<p>Legacy files containing the plug-in may fail to load. This is most likely caused by a change in the superclassid a plug-in class reports. This can be fixed by defining and exposing two class descriptors for that plug-in class. One would be the old <code>ClassDesc</code> returning the old superclassid, with the <code>IsPublic</code> method modified to return <code>FALSE</code>. The plug-in should not be creatable by the user via this <code>ClassDesc</code>. The other <code>ClassDesc</code> would be the new one, reporting the new superclassid. If the plug-in object can be created using the <em>3ds Max UI</em> or <em>MaxScript</em>, this new <code>ClassDesc::IsPublic</code> method must return <code>TRUE</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";