var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"changes_to_dllmain\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Changes to DllMain()</h1></div><p>Writing correct DllMain() functions is difficult. <em>MSDN</em> describes a series of restrictions, but these are so often ignored that Microsoft had to relax these restrictions by adding <em>IJW</em> (&quot;It Just Works&quot;) technology.</p>\n\
<p>Briefly, the following are all disallowed within a <code>DllMain()</code>:</p>\n\
<ul>\n\
<li>Call into another DLL, except functions in <code>kernel32</code>.dll</li>\n\
<li>Directly, or indirectly, call <code>FreeLibrary</code>, LoadLibrary, <code>LoadLibraryEx</code></li>\n\
<li>Perform synchronization between objects, using any of the <code>Wait</code> functions, such as <code>WaitForSingleObject</code></li>\n\
<li>Throw an exception</li>\n\
</ul>\n\
<p>In C++, this also applies to global C++ objects, which are constructed just before <code>DllMain</code>(DLL_PROCESS_ATTACH) is called, and destroyed just after <code>DllMain</code>(DLL_PROCESS_DETACH) is called.</p>\n\
<p>A majority of 3ds Max plug-ins violated one or more of these &quot;rules&quot;, but worked properly because of IJW. With <em>VS2005</em>, we made the following changes:</p>\n\
<ul>\n\
<li><p><code>DllMain()</code> doesn&#39;t do anything anymore, except keep the DLL&#39;s <code>HINSTANCE</code>, and call <code>DisableThreadLibraryCalls()</code> if nothing special needs to be done during <code>DLL_THREAD_ATTACH</code> and <code>DLL_THREAD_DETACH</code>.</p>\n\
</li>\n\
<li><p>All the <code>InitCommon</code>* are now &#39;obsolete&#39; -- calling them does nothing, and <code>core</code>.dll simply works for everyone</p>\n\
</li>\n\
<li><p>If a DLL still requires special initialization and cleanup, then it should do so in one of the two following functions:</p>\n\
<p>__declspec( dllexport ) int LibInitialize(void);\n\
__declspec( dllexport ) intLibShutdown(void);</p>\n\
</li>\n\
</ul>\n\
<p>These should be called only once each, but it is not strictly enforced; the functions must keep track of this. Changes will also have to be done in the module definition files (*.DEF) to take these two functions into account. See <a href=\"changes_to_module_definition_fil.html\"\">Changes to Module Definition Files(.DEF)</a>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../upgrading_to_visual_studio_2005_.html\">Upgrading to Visual Studio 2005 (Visual C++ 8.0)</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";