var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"changes_to_module_definition_fil\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Changes to Module Definition Files(.DEF)</h1></div><p>A typical <code>.def</code> file looked like the following example prior to Visual Studio 2005:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">LIBRARY update1\n\
EXPORTS\n\
   LibDescription   @1\n\
   LibNumberClasses @2\n\
   LibClassDesc     @3\n\
   LibVersion       @4\n\
SECTIONS\n\
.data READ WRITE</code></pre><p>With Visual Studio 2005, we now have the following code. The numbers in parentheses point to the footnotes below:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">LIBRARY update1.dlo(1)\n\
EXPORTS\n\
   LibDescription   @1\n\
PRIVATE (2)\n\
   LibNumberClasses @2\n\
PRIVATE\n\
   LibClassDesc     @3\n\
PRIVATE\n\
   LibVersion       @4\n\
PRIVATE\n\
   LibInitialize    @6\n\
PRIVATE (3)\n\
   LibShutdown      @7\n\
PRIVATE SECTIONS\n\
.data READ WRITE</code></pre><p>Notes:</p>\n\
<ol>\n\
<li>If the extension is not given, the linker assumes .DLL as the extension. Because, it does not match the actual output filename, a warning appears.</li>\n\
<li><code>PRIVATE</code> will export the function from the DLL, but will not include the function prototype in the import library.</li>\n\
<li>We have generally used 6 and 7 for the ordinal number on the two new functions, but this is not enforced and your plug-in will work if you use a different number.</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../upgrading_to_visual_studio_2005_.html\">Upgrading to Visual Studio 2005 (Visual C++ 8.0)</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";