var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"for_loop_scoping\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>for() Loop Scoping</h1></div><p>We have upgraded all <code>for()</code> loops to follow the <em>C++</em> standard. The following code shows an example of when <code>for()</code> loop scope is misunderstood:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">for ( int i = 0; i &lt; 10; ++i ) { /* stuff... */ }\n\
for ( i = 0; i &lt; 20; ++i ) { /* more stuff, including a break */ }\n\
return (i == 20) ? this_stuff : that_stuff;</code></pre><p>Since <code>i</code> is declared inside the first <code>for()</code> loop, it goes out of scope when the loop completes, causing the second <code>for()</code> loop to fail to compile. The same is true for the <code>return</code> statement.</p>\n\
<p>Generally, with code that was simple enough, we modified the previous code as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">for( int i = 0; i &lt; 10; ++i ) { /* stuff... */ }\n\
for( int i = 0; i &lt; 20; ++i ) { /* if break condition met, return this_stuff */ }\n\
return that_stuff;</code></pre><p>To keep the impact of the changes as small as possible, non-trivial <code>for()</code> loops were changed as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int i;\n\
for( i = 0; .... )</code></pre><p><em>3ds Max SDK</em> users are encouraged to follow the <em>C++</em> convention for keeping the scope of <code>for()</code> loop counters within the loops.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../upgrading_to_visual_studio_2005_.html\">Upgrading to Visual Studio 2005 (Visual C++ 8.0)</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";