var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"manifests\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Manifests</h1></div><p>Up to <em>VS2005 Beta2</em>, one could largely ignore <em>Microsoft&apos;s*<code>.manifest</code> and what it implied. However, with the arrival of *VS2005 RC1</em> and <em>VS2005 RTM</em>, using <code>/MANIFEST</code>:NO became problematic. Anything that links to the <em>Microsoft</em> DLLs (the <em>RTL, MFC, ATL</em>) must use a manifest, or the DLL&apos;s <code>DllMain()</code> will not be loaded into the process&apos;s memory. The use of manifests is now an issue because 3rd-party developers submit plug-ins without manifests, preventing their use in debug builds.</p>\n\
<p>The <code>.manifest</code> files can be embedded into the binaries, or they can be left external. We chose to embed them for convenience. If you examine one of the Max binaries, you would see a <code>RT_MANIFEST</code> resource file, which contains the <code>.manifest</code> data. A <code>.manifest</code> file looks like this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; standalone=&quot;yes&quot;?&gt;\n\
&lt;assemblyxmlns=&quot;urn:schemas-microsoft-com:asm.v1&quot; manifestVersion=&quot;1.0&quot;&gt;\n\
    &lt;dependency&gt;\n\
        &lt;dependentAssembly&gt;\n\
            &lt; assemblyIdentity type=&quot;win32&quot; name=&quot;Microsoft.VC80.DebugCRT&quot; version=&quot;8.0.50608.0&quot; processorArchitecture=&quot;amd64&quot; publicKeyToken=&quot;1fc8b3b9a1e18e3b&quot;&gt;\n\
            &lt;/ assemblyIdentity&gt;\n\
        &lt;/dependentAssembly&gt;\n\
    &lt;/dependency&gt;\n\
&lt;/assembly&gt;</code></pre>\n\
<p>This code lists the dependencies of the binaries, but in a more detailed way than just saying &quot;msvcrt80.dll&quot;.</p>\n\
<p>Linking against the manifest is only half of the story: the other half involves finding the binary referenced by the manifest. When you start 3ds Max on a computer which does not have the Microsoft RTLs installed, you do not get the typical <code>&quot;xxxxx</code>.DLL not found&quot;. Rather you see a message indicating that the application was not configured properly and that re-installing may solve the problem.</p>\n\
<p>You do not need to install <em>Microsoft&apos;s RTL</em> if you use the same one as 3ds Max, and doing so will not cause problems. With the proper use of manifests, you cannot corrupt the 3ds Max installation by installing your own versions of the DLLs.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../upgrading_to_visual_studio_2005_.html\">Upgrading to Visual Studio 2005 (Visual C++ 8.0)</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";