var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_in_3dxi\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New in 3DXI</h1></div><p>This article summarizes features and improvements made to the <em>3ds Max Data eXchange Interface</em> (3DXI) for release with the <em>3ds Max 9 SDK</em> and released previously in January 2006.</p>\n\
<h2 id=\"3dxi-version-2-2-released-with-3ds-max-9-sdk\">3DXI Version 2.2 - Released with 3ds Max 9 SDK</h2><h3 id=\"new-features\">New Features</h3><ul>\n\
<li>3DXI materials and textures map are constructible from corresponding <em>3ds Max SDK</em> classes</li>\n\
<li>Binormals and Tangents initialization</li>\n\
<li><code>GetClassName()</code> method added to <code>IGame</code> classes</li>\n\
<li>Map Channel access added to <code>IGameTextureMap</code></li>\n\
</ul>\n\
<h3 id=\"improvements\">Improvements</h3><ul>\n\
<li>Support for DirectX_9_Shader scripted material added</li>\n\
<li>Better handling of object in modifier stack for Skin</li>\n\
</ul>\n\
<h2 id=\"3dxi-version-2-0-released-in-january-2006\">3DXI version 2.0 - Released in January 2006</h2><h3 id=\"new-features\">New Features</h3><ul>\n\
<li>Access to DX Material Shader data: new IGameFX interface permits extraction of shader information from FXs assigned to objects within a scene. It provides access to the parameters, functions samplers, etc.</li>\n\
<li>Access to sub-object animation: support for Master Point controller through the IGameController interface</li>\n\
<li>Redesign of IGameProperty algorithms: all paramblock-based properties, including Custom attributes and Scripted plug-ins, are directly supported. The XML-based presentation is no longer needed. The IGameProp.xml file is only used for User Defined properties.</li>\n\
</ul>\n\
<h3 id=\"improvements\">Improvements</h3><p>Mesh and Skin functionalities:</p>\n\
<ul>\n\
<li>Support for N-sided polygons: New methods have been added to export polygon mesh representation. However, for shape animated geometry we recommend the usage of the triangle representation of the object.</li>\n\
<li>Tangents and Binormals are calculated for each active map channel (accessed by channel ID). The access to the original indexing is based on face parameters.</li>\n\
<li>New methods for better handling of skin bones.</li>\n\
<li>New option to get normals in object space.</li>\n\
</ul>\n\
<p>XRef interface:</p>\n\
<ul>\n\
<li>New access to the XRef manager.</li>\n\
<li>Implementation of the IGameXRefObject interface.</li>\n\
<li>XRef object is now supported by IGameObject.</li>\n\
</ul>\n\
<p>XML Exporter:</p>\n\
<ul>\n\
<li>The memory leak from ATL/COM is now fixed.</li>\n\
</ul>\n\
<h3 id=\"changed-behavior\">Changed behavior</h3><p><code>IGameMesh::GetActiveMapChannelNum()</code> now returns all active map channels including Alpha, Illumination, and Vertex Colors.</p>\n\
<h3 id=\"known-3dxi-limitations\">Known 3DXI Limitations</h3><p>In the <em>3ds Max 8 SDK</em>, importing a skinned mesh could bring the wrong weights position. This is a temporary redraw defect in 3ds Max. The workaround is to save the scene or manually toggle the &#39;Weight all vertices&#39; option in the Skin modifier UI.</p>\n\
<h3 id=\"xmlexporter-dle\">XMLExporter.dle</h3><p>No change since last drop. See schema specification for details on the XML format. This project is a good starting point to become familiar with <em>3DXI</em>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_9_sdk.html\">What&#x27;s New: 3ds Max 9 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";