var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"what_s_new_3ds_max_2019_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&apos;s New: 3ds Max 2019 SDK</h1></div><p>This topic describes new items and changes that affect the 3ds Max 2019 C++ SDK.</p>\n\
<p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#sdk-break\">SDK Break</a></li>\n\
<li><a href=\"#qt\">Qt</a></li>\n\
<li><a href=\"#plugin-installation\">Plugin Installation</a><ul>\n\
<li><a href=\"#improved-support-for-loading-binary-dependencies\">Improved support for loading binary dependencies</a></li>\n\
<li><a href=\"#support-for-autodesk-application-plug-in-packages\">Support for Autodesk Application Plug-in Packages</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#parameter-blocks\">Parameter Blocks</a><ul>\n\
<li><a href=\"#improved-parameter-block-validation\">Improved parameter block validation</a></li>\n\
<li><a href=\"#improved-support-for-saving-to-previous-scene-file-versions-of-pb1-plugins-migrated-to-pb2\">Improved support for saving to previous scene file versions of PB1 plugins migrated to PB2</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#rendering\">Rendering</a><ul>\n\
<li><a href=\"#open-shading-language-osl-\">Open Shading Language (OSL)</a></li>\n\
<li><a href=\"#thread-safe-evalxxx-methods\">Thread Safe EvalXXX Methods</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#modeling\">Modeling</a><ul>\n\
<li><a href=\"#vertex-velocity\">Vertex Velocity</a></li>\n\
<li><a href=\"#double-precision-geometric-primitives\">Double precision geometric primitives</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#miscellaneous\">Miscellaneous</a><ul>\n\
<li><a href=\"#custom-file-stream-api\">Custom File Stream API</a></li>\n\
<li><a href=\"#qt-related-project-settings\">Qt related project settings</a></li>\n\
<li><a href=\"#improved-robustness-of-some-apis\">Improved robustness of some APIs</a></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"sdk-break\">SDK Break</h2><p>The 3ds Max 2019 SDK is not binary backward compatible with the 3ds Max 2018 SDK. This means that plugins will need to be re-compiled in order to work in 3ds Max 2019.</p>\n\
<h2 id=\"qt\">Qt</h2><p>3ds Max 2019 uses Qt 5.6.3 which is binary compatible with Qt 5.6.2 used by 3ds Max 2018. 3rd party plugins can compile against the official Qt 5.6.3 version. </p>\n\
<h2 id=\"plugin-installation\">Plugin Installation</h2><h3 id=\"improved-support-for-loading-binary-dependencies\">Improved support for loading binary dependencies</h3><p>3ds Max will load dynamic-link libraries (dlls) that plugins have a link-time, or implicit, depency on from the folder where the plugin resides. In other words, the dll the plugin depends on does not have to be installed in 3ds Max&apos;s root folder (<code>&lt;maxroot&gt;</code>), nor does the plugin need to do extra work to load the dlls at run-time (by calling LoadLibrary() for example). </p>\n\
<p>Simply deploy the dlls the plugin depends on side-by-side within the same folder where the plugin resides, and 3ds Max will be able to load the plugin.</p>\n\
<p>If a plugin needs to explicitly load a dll, the safest way is to load it by specifying a complete path. If a plugin needs to change the dll search path, it must respect the following rules:</p>\n\
<ul>\n\
<li>The <code>SetDllDirectory()</code> API is used instead of <code>AddDllDirectory()</code> to modify the DLL search path </li>\n\
<li>Save the value returned by <code>GetDllDirectory()</code></li>\n\
<li>Use <code>SetDllDirectory(</code>) to specify the non standard folder you want to load from</li>\n\
<li>Load your dll.</li>\n\
<li>Use <code>SetDllDirectory()</code> again to restore the previous value.</li>\n\
<li>The changes to the DLL search path are in effect for as short of a code-scope as possible</li>\n\
<li>Never call <code>SetDllDirectory(nullptr)</code>, it adds the current working directory to the search path and causes a security vulnerability.</li>\n\
</ul>\n\
<p>For more information see the MSDN topic on <a href=\"https://msdn.microsoft.com/en-us/library/windows/desktop/ff919712(v=vs.85).aspx\" target=\"_blank\">Dynamic-Link Library Security</a>.</p>\n\
<h3 id=\"support-for-autodesk-application-plug-in-packages\">Support for Autodesk Application Plug-in Packages</h3><p>3ds Max will find and load plugins that have a PackageContent.xml file installed in one of the these two standard locations:</p>\n\
<ul>\n\
<li>%PROGRAMDATA%\\Autodesk\\ApplicationPlugins</li>\n\
<li>%APPDATA%\\Autodesk\\ApplicationPlugins</li>\n\
</ul>\n\
<p>Using the Autodesk Application Plug-in Package format eliminates the need for plugin installers to deploy the plugin into the plugins folder of the 3ds Max installation, or to add the plugin&apos;s install directory to the user&apos;s Plugin.UserSettings.ini.\n\
Plugins do not need to be published on the <a href=\"https://apps.autodesk.com/\" target=\"_blank\">Autodesk App Store</a> in order to use the Autodesk Application Plug-in Package format.\n\
For more details, see <a href=\"./../writing_plug-ins/packaging_plugins/packaging_plugins.html\">Packaging Plug-ins</a></p>\n\
<h2 id=\"parameter-blocks\">Parameter Blocks</h2><h3 id=\"improved-parameter-block-validation\">Improved parameter block validation</h3><p>Localized names of ParamBlock2 (PB2) parameters are now tested to ensure they use resource ids instead of string literals.  </p>\n\
<p>Using string literals instead of resource id generates the following error:\n\
<img src=\"./images/ParamBlockError.jpg\" alt=\"ParamBlockDesc2 definition error\"></p>\n\
<p>This means that the definition for parameter &apos;Uuid&apos; in ParamBlockDesc2 &apos;Object UUUID&apos; has an invalid resource id for the localized name. Most likely the name was specified as a string literal instead of a resource id. For example:</p>\n\
<p><code>XRefMaterial::pbEnableOverride, _T(&quot;enableOverride&quot;), TYPE_BOOL, 0, _T(&quot;&quot;),</code></p>\n\
<p>should be:</p>\n\
<p><code>XRefMaterial::pbEnableOverride, _T(&quot;enableOverride&quot;), TYPE_BOOL, 0, IDS_XREFMATERIAL_ENABLE_OVERRIDE,</code></p>\n\
<p>or</p>\n\
<p><code>XRefMaterial::pbEnableOverride, _T(&quot;enableOverride&quot;), TYPE_BOOL, 0, 0,</code></p>\n\
<p>A resource id of 0 in this context is interpreted as a null string. Valid resource id values are in the range of 0 to 65535.</p>\n\
<h3 id=\"improved-support-for-saving-to-previous-scene-file-versions-of-pb1-plugins-migrated-to-pb2\">Improved support for saving to previous scene file versions of PB1 plugins migrated to PB2</h3><p>The ParamBlock1 (PB1) to ParamBlock2 (PB2) migration documentation in the 3ds Max 2018 SDK help shows an implementation of  <code>BoxObject::SpecifySaveReferences()</code> that replaces the PB2 reference with a PB1 reference with a call to <code>ReferenceSaveManager::ReplaceReferenceSlot()</code>. It was found that this was insufficient, as other objects may hold a reference to the PB2, and those references needed to point to the PB1. </p>\n\
<p>An example of this is the Script Controller, which can hold a reference to the PB2 as part of a Target type variable. Adding the following code causes all references to the PB2 to use the PB1 instead in the saved file:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">// register the reference slot replacement\n\
referenceSaveManager.ReplaceReferenceSlot(PBLOCK_REF_NO, paramBlock1);\n\
// register transferring all refs to the pb2 to the pb1\n\
ReferenceSaveManager&amp; pb2_referenceSaveManager = pblock2&#x2192;GetReferenceSaveManager();\n\
pb2_referenceSaveManager.SetReplacementReferenceTarget(paramBlock1);</code></pre>\n\
<p>For 3ds Max 2019, the bulk of the code needed in the implementation of  <code>ReferenceMaker::SpecifySaveReferences()</code> of the plugin being migrated from PB1 to PB2, was placed in a helper function exported by <code>paramblk2.lib</code>. As a result, a typical implementation of this method becomes:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">bool BoxObject::SpecifySaveReferences(ReferenceSaveManager&amp; referenceSaveManager)\n\
{\n\
    // if saving to previous version that used pb1 instead of pb2...\n\
    DWORD saveVersion = GetSavingVersion();\n\
    if (saveVersion != 0 &amp;&amp; saveVersion &lt;= MAX_RELEASE_R19)\n\
    {\n\
        ProcessPB2ToPB1SaveToPrevious(this, pblock2, PBLOCK_REF_NO, descVer1, PBLOCK_LENGTH, CURRENT_VERSION);\n\
    }\n\
    return __super::SpecifySaveReferences(referenceSaveManager);\n\
}</code></pre>\n\
<h2 id=\"rendering\">Rendering</h2><h3 id=\"open-shading-language-osl-\">Open Shading Language (OSL)</h3><p>3ds Max 2019 introduces support for the <a href=\"http://opensource.imageworks.com/?p=osl\" target=\"_blank\">Open Shading Language</a> (OSL). \n\
The new OSL Texmap is an execution environment for OSL shaders within 3ds Max. \n\
Being a regular 3ds Max Texmap object (shader) (i.e. it implements Textmap::EvalColor(), Texmap::EvalMono() and Texmap::EvalNormalPerturb() methods), it works in any renderer supporting the classic 3ds Max shader API (Scanline, vRay, Corona etc.). It also means it works outside of renderers, anywhere in 3ds Max where a regular texture map is requested, such as in the Displacement modifier, etc.\n\
It can also work with renderers that support OSL natively, such as Arnold. In that case, the execution environment inside the OSL Map is not used, instead, the OSL code, the parameter values, and shader bindings are sent to the renderer, which executes the OSL code itself.</p>\n\
<p>Going forward the recommended way to write texture maps (shaders) for 3ds Max is through OSL.</p>\n\
<p>For more information, see <a href=\"./../3ds_max_sdk_features/rendering/osl.html\">Open Shading Language Support</a>.</p>\n\
<h3 id=\"thread-safe-evalxxx-methods\">Thread Safe EvalXXX Methods</h3><p>class TexmapThreadSafe has been deprecated. The Texmap::EvalXXX() overrides of your plugin are required to be thread safe by definition. \n\
The Texmap::EvalXXX() overrides should not read or write directly or indirectly scene data. They should only read data in member variables local to the shader instance.\n\
3ds Max guarantees a thread-safe execution of the Texmap::EvalXXX() methods by first ensuring that everything is updated (calling Texmap::Update()) from within the main thread, and then calling Texmap::EvalXXX() in multiple threads during rendering.</p>\n\
<p>For compatibility, and as a safety measure, the TexmapThreadSafe interface still exists in the 3ds Max 2019 SDK.\n\
Rendering of a Texmap instance will be single-threaded when it uses class TexmapThreadSafe to set the thread safety to false, as follows:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">    // Error checking omitted for brevity\n\
    MaxSDK::TexmapThreadSafe* pTexmapThreadSafe = static_cast&lt;MaxSDK::TexmapThreadSafe*&gt;(GetInterface(ITEXMAP_THREAD_SAFE));\n\
    pTexmapThreadSafe-&gt;SetFunctionFlag(MaxSDK::TexmapThreadSafe::FunctionEvalMono, false);\n\
    pTexmapThreadSafe-&gt;SetFunctionFlag(MaxSDK::TexmapThreadSafe::FunctionEvalColor, false);</code></pre>\n\
<p>Note that class TexmapThreadSafe&apos;s semantics is only used when texture backing in 3ds Max (i.e. Interface::RenderTexmap()), and the scene rendering is always multi-threaded, unless explicitly disabled in the renderer.</p>\n\
<h2 id=\"modeling\">Modeling</h2><h3 id=\"vertex-velocity\">Vertex Velocity</h3><p>The new <code>IVertexVelocity</code> interface allows for easily extracting per-vertex velocity data computed from fluid simulations or Alembic and stored on the mesh. This interface simplifies the task of getting to the vertex velocity data stored in the map channels of a mesh.</p>\n\
<h3 id=\"double-precision-geometric-primitives\">Double precision geometric primitives</h3><p>The following new classes have been added: <code>class DPoint2</code>, <code>class DBox2</code>, <code>class DRay2</code>. Their functionality mirrors that of their floating point counterparts <code>class Point2</code>, <code>class Box2</code>, and <code>class Ray</code>.</p>\n\
<h2 id=\"miscellaneous\">Miscellaneous</h2><h3 id=\"custom-file-stream-api\">Custom File Stream API</h3><p>3ds Max 2019 supports user defined data streams in scene files (.max).\n\
The data streams can be accessed through MAXScript (see the <code>CustomFileStream</code> and <code>CustomSceneStreamManager</code> interfaces) and a C++ API found in <em>maxsdk\\include\\customfilestreamapi</em>.\n\
The implementation of the CustomFileStream API and that of the two MAXScript interfaces is available in maxsdk\\samples\\utilities\\customfilestream.</p>\n\
<p>The CustomFileStreamAPI library does not have dependencies on the 3ds Max SDK, so you can write 3ds Max agnostic applications that use custom scene file data.</p>\n\
<h3 id=\"qt-related-project-settings\">Qt related project settings</h3><p>In order to prevent memory access violation issues when unloading plugins using Qt, the QT_NO_UNICODE_LITERAL was added to the PreProcessorDefinition setting in <em>maxsdk/projectsettings/3dsmax.common.tools.settings.props</em></p>\n\
<h3 id=\"improved-robustness-of-some-apis\">Improved robustness of some APIs</h3><p>In an effort to reduce the chances for buffer overflow we modified several 3ds Max SDK functions to take <code>MSTR&amp;</code> arguments instead of <code>MCHAR*</code>, or added buffer length arguments when we had to keep the <code>MCHAR*</code> arguments. </p>\n\
<p>Examples:</p>\n\
<ul>\n\
<li><code>maxsdk\\include\\strclass.h</code>: Added buffer length arguments to <code>SplitFilenameOld()</code> and the <code>char* (wchar_t*)</code> versions of <code>SplitFilename()</code>.</li>\n\
<li><code>maxsdk\\include\\systemutilities.h</code>: Modified <code>UtilGetFolderPath()</code>, <code>GetSpecDir()</code>, and <code>TryCSIDLDir()</code> to accept <code>MSTR&amp;</code> arguments instead of raw string buffer pointers.</li>\n\
</ul>\n\
<p>Note that we will continue to make changes to the 3ds Max SDK in future releases in order to increase the robustness of 3ds Max.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new.html\">What&#x27;s New</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";