var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"new_apis\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>New APIs, Interfaces, and Notifications</h1></div><ul>\n\
<li><a href=\"#new-apis-for-handling-keyboard-shortcut-files\">New APIs for handling keyboard shortcut files</a></li>\n\
<li><a href=\"#new-message-box-api\">New message box API</a></li>\n\
<li><a href=\"#new-normal-mapping-api\">New Normal mapping API</a></li>\n\
<li><a href=\"#mikk-tangent-support-and-tangent-computation-callback\">Mikk Tangent support, and tangent computation callback</a></li>\n\
<li><a href=\"#new-iautobackup-interface\">New IAutoBackup interface</a></li>\n\
<li><a href=\"#new-modifier-name-change-notification\">New modifier name change notification</a></li>\n\
</ul>\n\
<h2 id=\"new-apis-for-handling-keyboard-shortcut-files\">New APIs for handling keyboard shortcut files</h2><p>The <code>IActionManager</code> interface has been extended with APIs that support the new keyboard shortcut file format (.hsx) introduced in <strong>3ds Max 2020 Update 1</strong>. See <code>IActionManager::SaveKeyboardFile()</code> and <code>IActionManager::LoadKeyboardFile()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual BOOL IActionManager::LoadKeyboardFile(const MCHAR* pFileName) = 0; \n\
virtual BOOL IActionManager::SaveKeyboardFile(const MCHAR* pFileName) = 0; \n\
virtual const MCHAR* IActionManager::GetKeyboardFile() = 0; </code></pre>\n\
<p>The new <code>.hsx</code> file format only contain user-customized or additional factory preset shortcuts which will get applied on top of the base shortcuts that 3ds Max loads internally. That&apos;s different compared to the legacy keyboard shortcut files which contained both built-in, plug-in-defined and user-customized shortcuts. </p>\n\
<p>3rd&#x202F;party developers should note that <code>IActionManager::GetKeyboardFile()</code> now returns the path to a  file with a different format and extension than the old <code>.kbdx</code> one. Please do not assume that the returned file is in the <code>.kbdx</code> format, and make sure you don&apos;t output shortcuts in the old kbdx to the new hsx file. </p>\n\
<h2 id=\"new-message-box-api\">New message box API</h2><p>The new <code>MaxSDK::MaxMessageBox()</code> and <code>MaxSDK::QmaxMessageBox()</code> APIs should be used instead of the Win32 <code>MessageBox()</code> API and 3ds Max&apos;s <code>MaxMsgBox()</code> API, in order to avoid text clipping that can occur with the later with certain locales, font types and sizes on Windows 10 when DPI scaling is greater than 100%. The new message box APIs have built-in handling of quiet mode: they will log a message and will not be displayed. </p>\n\
<h2 id=\"new-normal-mapping-api\">New Normal mapping API</h2><p>The <code>INormalMappingManager</code> interface manages the normal mapping modes that can affect how 3ds Max calculates and interprets the tangent/binormal (also called bitangent) at the vertex or pixel shading level during baking and rendering. In addition to the 3ds Max default mode, it allows for using Maya, DirectX and Mikk-t modes. This interface is implemented by the system. </p>\n\
<h2 id=\"mikk-tangent-support-and-tangent-computation-callback\">Mikk Tangent support, and tangent computation callback</h2><p>A new API is provided for computing the bump basis vector in MikkT way for the U texture channel (called the tangent), and the cross product of the surface normal with the tangent (called the binormal). These along with the surface normal are used as the basis vectors for normal mapping. </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">void ComputeMikkTangents(ITangentsComputationCallback* tangentsComputationCallback); </code></pre>\n\
<p>class <code>ITangentsComputationCallback</code> allows for customizing computing the bump basis vectors on a given set of triangle/quad faces. The callback could be used as an input parameter of the method ComputeMikkTangents() to compute the tangent and binormal(bitangent). </p>\n\
<h2 id=\"new-iautobackup-interface\">New IAutoBackup interface</h2><p>The <code>IAutoBackup</code> interface allows plugin developers to control AutoBackup settings programmatically. </p>\n\
<h2 id=\"new-modifier-name-change-notification\">New modifier name change notification</h2><p><code>REFMSG_MODIFIER_NAMECHANGE</code></p>\n\
<p>This reference message is sent by a modifier when its name has been changed. One example where this notification is useful is to dynamically update the UI where a modifier&apos;s name is displayed.&#x202F;The pointer to the modifier is sent as partid. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">NotifyDependents(FOREVER, (INT_PTR)modifier, REFMSG_MODIFIER_NAMECHANGE);&#x202F; </code></pre>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2021_sdk.html\">What&#x27;s New: 3ds Max 2021 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";