var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"physical_material\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Physical Material as Default</h1></div><p>3ds Max 2021 defaults to using physical materials everywhere, even in places where standard materials were the norm before. The type of material used by default is in fact governed by the Market Default settings (accessible through the  main menu <strong>Customize &gt; Custom Defaults Switcher</strong>). All options that ship with 3ds Max 2021 in the Custom Default Switcher use the Physical Material, except the <em>MAX.Legacy</em> option, which when selected switches 3ds Max 2021 back to the same material and rendering settings as 3ds Max 2020 used. Please note that a 3rd party developer could install their own Market Default, as does VRay for example, and so a plugin should be prepared to handle any type of materials. </p>\n\
<blockquote>\n\
<p><strong>Important</strong>: Plugin developers and scripters should test that their code works as expected in 3ds Max 2021, both with Physical Material as default, and when using the <em>MAX.Legacy</em> option.  </p>\n\
</blockquote>\n\
<p>The following new APIs have been added to 3ds Max 2021 to support 3rd party plugin developers when they need to create material: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">CoreExport Mtl* NewDefaultMaterial(const MCHAR *configkey = nullptr); </code></pre>\n\
<p>The <code>NewDefaultMaterial()</code> API creates a new material instance based on the current Market Defaults. By default, 3ds Max uses physical material in all its market defaults, except when using the <em>MAX.Legacy</em> market default, or when a 3rd party has installed a custom market default and that is currently used.  </p>\n\
<blockquote>\n\
<p><strong>Important</strong>: If you call this function, be prepared to handle any material being returned. </p>\n\
</blockquote>\n\
<p>A plugin developer can ask that this API creates a standard material (type <code>StdMat2</code>) by calling it with a configkey value equal to the name of a key set in <em>3dsmax.ini</em> under the <code>[LegacyMaterial]</code> section, and by setting that key to a value of 1. For example, if a 3rd party material plugin called &quot;FooBar&quot; would like to always populate its instance with <code>StdMat2</code> sub-materials, it would set the key named &quot;FooBar&quot; under the [LegacyMaterial] section of <em>3dsmax.ini</em> to 1, and then call <code>NewDefaultMaterial(_M(&quot;FooBar&quot;))</code>. </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">CoreExport Mtl* NewPhysicalMaterial(const MCHAR *configkey = nullptr, bool *legacy = nullptr); </code></pre>\n\
<p>The <code>NewPhysicalMaterial()</code> API creates a new instance of the Physical Material, or a standard material (type <code>StdMat2</code>) if called with a configkey that is the name of a key set in <em>3dsmax.ini</em> under the [LegacyMaterial] section, and that key is set to 1. When you call this API, be prepared to handle either a physical material, or a standard material being returned. You can check the classid of the returned material, or attempt to dynamic_cast it to <code>StdMat2</code> to verify its type. </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">CoreExport int GetPrimaryMapSlot(Mtl * mtl); </code></pre>\n\
<p>The <code>GetPrimaryMapSlot()</code> API allows you to set the color texture of a material without having to know about the exact material type. It returns the main color map slot of the material passed as parameter, which in most cases (but not necessarily) is the &quot;diffuse&quot; slot. </p>\n\
<p>Since the <code>NewDefaultMaterial()</code> function can return any material, code that tries to set the color texture by calling <code>mtl-&gt;SetSubTexmap(ID_DI, &#x2026;. )</code> will be most likely wrong. The ID_DI macro applies for a standard material (type <code>StdMat2</code>), but it is no longer guaranteed to be a relevant texture slot for another kind of material. </p>\n\
<p>If the material derives from <code>StdMat2</code> this function is equivalent to calling <code>StdMat2::StdIDtoChannel(ID_DI)</code>. If not, a heuristic is used.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2021_sdk.html\">What&#x27;s New: 3ds Max 2021 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";