var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"qt_support\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Qt-Related Improvements</h1></div><ul>\n\
<li><a href=\"#improved-support-for-qt-based-parameterblock2\">Improved support for Qt based ParameterBlock2</a></li>\n\
<li><a href=\"#qt-spinboxes\">Qt Spinboxes:</a></li>\n\
<li><a href=\"#support-for-qt-visual-studio-tools-add-on-version-243\">Support for QT Visual Studio Tools add-on version 2.4.3</a></li>\n\
</ul>\n\
<h2 id=\"improved-support-for-qt-based-parameterblock2\">Improved support for Qt based ParameterBlock2</h2><p>Support has been added for <code>TYPE_BITMAP</code> </p>\n\
<p>Tooltip resource-IDs are now picked up from the parameter block definition. However, the tooltips, if present in the Qt control (from code or <code>.ui</code> file) take precedence over the ones from the paramblock). </p>\n\
<h2 id=\"qt-spinboxes-\">Qt Spinboxes:</h2><p>The scale of the paramblock definition now gets correctly set as the <code>singleStep</code> property on Qt spinners.  If the scale inside the paramblock definition is set to <code>SPIN_AUTOSCALE</code>, the control is now correctly set to <code>QAbstractSpinBox::AdaptiveDecimalStepType</code>, as intended. \n\
This also fixes the intermediate problem with the step-size not being recognized from the UI. </p>\n\
<h2 id=\"support-for-qt-visual-studio-tools-add-on-version-2-4-3\">Support for QT Visual Studio Tools add-on version 2.4.3</h2><p>3ds Max 2021 now supports Qt VS Tools add-on version 2.4.3, which was released in January 2020.   </p>\n\
<p>Qt VS Tools v2.4 supports Qt Visual Studio projects having different Qt VS project formats, including the latest Qt/MsBuild project format v2.4, as well as the older Qt/MSBuild v2.3, or Qt custom build tools formats. </p>\n\
<p>Both Qt/MSBuild and Qt custom build steps are valid Qt VS project formats.  Existing Qt projects can still be built as-is.  However, if Qt VS Tools v2.4 will be used to modify an existing Qt project configuration, the Visual Studio project file (.vcxproj) should first be upgraded to the latest Qt/MSBuild v2.4 format. </p>\n\
<p>To support Qt VS Tool v2.4.3, the 3ds Max SDK property sheet <code>3dsmax.general.project.settings.props</code> has been updated as follows: </p>\n\
<ul>\n\
<li><p>Added a new property named <code>&lt;QtInstall&gt;</code>, which is conditionally defined for Qt projects that are configured with the latest Qt/MSBuild project format v2.4.  Qt/MSBuild v2.4 uses <code>&lt;QtInstall&gt;</code> to automatically derive <code>&lt;QTDIR&gt;</code> and other Qt related properties. </p>\n\
</li>\n\
<li><p>The property <code>&lt;QTDIR&gt;</code> is now explicitly defined only for Qt projects that are configured with either custom build steps, or the older Qt/MSBuild project format (v2.3 or lower). </p>\n\
</li>\n\
<li><p>The <code>&lt;Keyword&gt;</code> property in the .vcxproj files identifies the applicable Qt VS project format version and is used to determine whether to define either <code>&lt;QtInstall&gt;</code> or <code>&lt;QTDIR&gt;</code>: </p>\n\
<ul>\n\
<li>&quot;QtVS_v300&quot; or higher: The project uses Qt/MSBuild VS project format v2.4 or higher </li>\n\
<li>&quot;Qt4VS*&quot; pattern:  The project uses Qt custom build steps or QtMsBuild VS project format older than version v2.3 </li>\n\
</ul>\n\
<p>The Max SDK sample project <code>CameraMapTexture.vcxproj</code> had previously been converted to a Qt-based project using the older QtMsBuild project format v2.3.2.  It has now been upgraded to use QtMsBuild v2.4.3. Other Qt-based Max SDK sample and how-to projects remain unchanged; they are still configured using Qt custom build steps. </p>\n\
</li>\n\
</ul>\n\
<div class=\"note important:\"><span class=\"importanttitle\">Important:</span> starting with Qt/MSBuild v2.4, .NET Framework v4.7.2 or v4.8 is required to provide the <code>Enumerable.ToHashSet()</code> method that is used in $(QtMsBuild)/qt_tasks.targets.</div>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2021_sdk.html\">What&#x27;s New: 3ds Max 2021 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";