var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"windows_regional_settings\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Improved support for Windows regional settings</h1></div><p>The support for Windows regional settings, most notably decimal separators has been improved. The technical terms and Windows APIs involved refer to this aspect as &quot;user locale&quot;. The rules governing the locale settings for processes, threads and various run-times is relatively complex. Our goal is to ensure that the users of 3ds Max have a great experience regardless of the Windows regional settings they choose. </p>\n\
<p>3ds Max 2021 is forcing worker threads to use per-thread locales, so they won&apos;t interfere with the locale settings of the main thread, which observes the regional settings.  </p>\n\
<p>We recommend that plug-ins follow these guidelines: </p>\n\
<ul>\n\
<li><p>Use string-to-float and float-to-string APIs that take a locale object rather than switching locales. These Windows APIs usually have names that end in &quot;_l&quot;. An example is the string-to-float conversion function &#x202F;<code>_atoflt_l()</code>. The 3ds Max SDK now provides formatted print functions that take a locale object. Examples include: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">  size_t BaseTextWriter::Printf_l (const wchar_t* format, const _locale_t theLocale, ...)\n\
  size_t BaseTextWriter::Vprintf_l(const wchar_t* format, const _locale_t theLocale, va_list argList); \n\
  int CStr::printf_l(const char *format, const _locale_t theLocale, ...); \n\
  int CStr::vprintf_l(const char *format, const _locale_t theLocale, va_list args); \n\
  int WStr::printf_l(const wchar_t *format, const _locale_t theLocale, ...); \n\
  int WStr::vprintf_l(const wchar_t *format, const _locale_t theLocale, va_list args); \n\
</code></pre>\n\
</li>\n\
<li><p>Code that formats locale-specific values for UI display, such as floating point numbers, date and time, should use the current Windows locale. For more details see&#x202F;the <code>GetUserLocale()</code> API in the <em>C++ API Reference</em>. </p>\n\
</li>\n\
<li><p>Code that writes or reads locale-specific data to and from data files, such as floating point numbers, date and time, etc, should use the C Numeric locale in order to read and write the data in a local independent format such as a minimal ANSI conforming environment for C translation, known as &quot;C&quot; locale. For more details see&#x202F;the <code>GetCNumericLocale()</code> API and class <code>MaxLocaleHandler</code> in the <em>C++ API Reference</em>.</p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new_3ds_max_2021_sdk.html\">What&#x27;s New: 3ds Max 2021 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";