var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"localization\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Changes related to localization of MAXScript-exposed property names</h1></div><p>3ds Max&apos;s support for language packs extends to names of scene element properties. These are displayed in the user interface, such as TrackView, and are also accessible to MAXScript and Python. </p>\n\
<p>3ds Max allows for executing scripts that use English property names, using a different language pack. For example:  </p>\n\
<p>The scripts &quot;b=Box length:20&quot; and &quot;b=Box longueur:20&quot; would both work and produce the same results in 3ds Max running with the French language pack.  </p>\n\
<p>Modifying the length of the box instance in the Modify panel would result in an English script output to the Macro Recorder &quot;$.length = 30&quot;. </p>\n\
<p>The TrackView would display the Box&apos;s properties in French.  </p>\n\
<p>To achieve this, 3ds Max must maintain one mapping (dictionary) per supported language pack, between the English name of a property and its translation(s) in a certain supported language. Each of these dictionaries is kept in a file named <em>maxscrpt.lcl</em> in a corresponding language folder. For French, the mapping is in <code>&lt;3dsmax_install&gt;\\fr-FR\\maxscrpt.lcl</code>. </p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> To start 3ds Max with French language pack, run the following command: <code>3dsmax.exe -lang=FRA</code> </div>\n\
<p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#challenges-with-the-current-approach\">Challenges with the current approach</a></li>\n\
<li><a href=\"#solution-implemented-in-3ds-max-2022\">Solution implemented in 3ds Max 2022</a><ul>\n\
<li><a href=\"#new-virtual-methods-that-were-added\">New virtual methods that were added</a></li>\n\
<li><a href=\"#non-virtual-methods-whose-signatures-have-been-updated\">Non-Virtual methods whose signatures have been updated</a></li>\n\
<li><a href=\"#virtual-methods-that-were-replaced\">Virtual methods that were replaced</a></li>\n\
<li><a href=\"#trackview-and-controller-property-and-sub-anim-name-support\">Trackview and Controller property and sub-anim name support</a></li>\n\
<li><a href=\"#new-reference-message-added\">New reference message added</a></li>\n\
<li><a href=\"#new-parameter-definition-tag-added\">New parameter definition tag added</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#maxscript-changes-related-to-localization-of-maxscript-exposed-property-names\">MAXScript changes related to localization of MAXScript exposed property names</a><ul>\n\
<li><a href=\"#maxscript-functions-that-take-the-localizedname-parameter\">MAXScript functions that take the <code>localizedName</code> parameter</a></li>\n\
<li><a href=\"#maxscript-functions-that-take-the-localizednames-parameter\">MAXScript functions that take the localizedNames parameter</a></li>\n\
<li><a href=\"#new-properties-related-to-localized-property-names\">New properties related to localized property names</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#translation-support-for-trackview-nodes\">Translation support for Trackview nodes</a></li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"challenges-with-the-current-approach\">Challenges with the current approach</h2><p>In 3ds Max 2021 and older releases, this mapping could not be created for 3rd party plugins that choose to localize the names of the properties exposed to MAXScript, and so the capabilities described above would not work for these 3rd party plugins. 3rd party plugins would need to keep the name of their properties in English to allow scripts that use them to work when 3ds Max uses a non-English language pack.  </p>\n\
<p>The mapping described above has no sense of context. For example, an English property name could have multiple translations in a non-English language, or a non-English property name could have multiple English translations. </p>\n\
<h2 id=\"solution-implemented-in-3ds-max-2022\">Solution implemented in 3ds Max 2022</h2><p>The solution is to eliminate the need for the dictionaries (<em>maxscrpt.lcl</em> files) by allowing plugins to supply both the English and non-English names of their properties. </p>\n\
<p>For 3rd party developers who provide localized versions of their plugins, this solution will allow their users to use their plugins in MAXScripts written either in English or one of the languages the plugin is localized for and 3ds Max also supports. </p>\n\
<p>3rd party developers who do not provide localized versions of their plugins will not be affected by this solution, other than minor updates to their code. </p>\n\
<p>The following changes implement the solution described above. </p>\n\
<h3 id=\"new-virtual-methods-that-were-added\">New virtual methods that were added</h3><p>The following new method should return the same name that <code>ClassDesc::ClassName()</code> returns in locale en-US.  </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual const MCHAR* ClassDesc::NonLocalizedClassName() = 0; </code></pre>\n\
<h3 id=\"non-virtual-methods-whose-signatures-have-been-updated\">Non-Virtual methods whose signatures have been updated</h3><p>The signatures of the following non-virtual methods have been updated: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">MSTR Animatable::ClassName() \n\
MSTR ISubMap::GetSubTexmapTVName(int i) \n\
MSTR Mtl::GetSubMtlTVName(int i) \n\
ShapeObject::GetParameterName(int pbIndex) </code></pre>\n\
<p>They now have a new parameter (bool localized) with a default value of true: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">MSTR Animatable::ClassName(bool localized = true) \n\
MSTR ISubMap::GetSubTexmapTVName(int i, bool localized = true) \n\
MSTR Mtl::GetSubMtlTVName(int i, bool localized = true) \n\
MSTR ShapeObject::GetParameterName(int pbIndex, bool localized = true) </code></pre>\n\
<p>If <code>localized</code> is true, then the name returned should be localized in the language 3ds Max is currently using. Otherwise, it should be the name in locale en-US. </p>\n\
<p>The default value of true was added so that developers who do not localize their plugins only need to update the signatures of the methods listed above and not their call sites. </p>\n\
<p>Developers who do localize their plugins should analyze the places where they call the methods listed above to decide what value to pass them for the new parameter (bool localized). </p>\n\
<p>If, for example, a developer calls one of the methods listed above to get a name to display in the UI, they probably want to pass that method a value of true for the new parameter so that the string will be localized when it is displayed in the UI. On the other hand, if they are calling one of the methods above to perform a comparison with a hardcoded string that is not localized, then they must pass that method a value of false for the new parameter. </p>\n\
<h3 id=\"virtual-methods-that-were-replaced\">Virtual methods that were replaced</h3><p>The following methods have been replaced and therefore sealed: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual void Animatable::GetClassName(MSTR&amp; s) \n\
virtual Animatable* Animatable::SubAnimName(int i) \n\
virtual const MCHAR* BaseObject::GetObjectName() \n\
virtual MSTR Modifier::GetName() \n\
virtual MSTR SpecialFX::GetName() \n\
virtual MSTR BaseShader::GetTexChannelName(long nTextureChan) \n\
virtual MSTR ISubMap::GetSubTexmapSlotName(int i) \n\
virtual MSTR Mtl::GetSubMtlSlotName(int i) \n\
virtual MSTR MtlBase::GetFullName() \n\
virtual MSTR GizmoObject::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleMod::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleWSMMod::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleObject::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleWSMObject::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleParticle::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleShape::GetParameterName(int pbIndex) \n\
virtual MSTR SimpleSpline::GetParameterName(int pbIndex) \n\
virtual MSTR PBAccessor::GetLocalName (ReferenceMaker* owner, ParamID id, int tabIndex) \n\
virtual const MCHAR* CustAttrib::GetName() </code></pre>\n\
<p>They have been replaced with the following methods, which have a new parameter in their signatures (bool localized): </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual void Animatable::GetClassName(MSTR&amp; s, bool localized) \n\
virtual Animatable* Animatable::SubAnimName(int i, bool localized) \n\
virtual const MCHAR* BaseObject::GetObjectName(bool localized) \n\
virtual MSTR Modifier::GetName(bool localized) \n\
virtual MSTR SpecialFX::GetName(bool localized) \n\
virtual MSTR BaseShader::GetTexChannelName(long nTextureChan, bool localized) \n\
virtual MSTR ISubMap::GetSubTexmapSlotName(int i, bool localized) \n\
virtual MSTR Mtl::GetSubMtlSlotName(int i, bool localized) \n\
virtual MSTR MtlBase::GetFullName(bool localized) \n\
virtual MSTR GizmoObject::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleMod::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleWSMMod::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleObject::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleWSMObject::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleParticle::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleShape::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR SimpleSpline::GetParameterName(int pbIndex, bool localized) \n\
virtual MSTR PBAccessor::GetLocalName (ReferenceMaker* owner, ParamID id, int tabIndex, bool localized) \n\
virtual const MCHAR* CustAttrib::GetName(bool localized) </code></pre>\n\
<p>If <code>localized</code> is true, then the name returned should be localized in the language 3ds Max is currently using. Otherwise, it should be the name in locale en-US. </p>\n\
<p>If a plugin does not provide localized string resources, it can disregard the <code>localized</code> parameter and always return the name in locale en-US. </p>\n\
<p>You may be wondering why the methods in this section were sealed but not deprecated. This was done so that developers who do not localize their plugins only need to update the signatures of the methods listed above and not their call sites. To enable this, the default implementations of the sealed methods now call their new versions with <code>localized</code> set equal to true, which preserves the existing behavior. </p>\n\
<p>Developers who do localize their plugins should analyze the places where they call the methods listed above to decide what value to pass them for the new parameter (<code>bool localized</code>). If, for example, a developer calls one of the methods listed above to get a name to display it in the UI, they probably want to pass that method a value of true for the new parameter so that the string will be localized when it is displayed in the UI. On the other hand, if they are calling one of the methods above to perform a comparison with a hardcoded string that is not localized, then they must pass that method a value of false for the new parameter. </p>\n\
<h3 id=\"trackview-and-controller-property-and-sub-anim-name-support\">Trackview and Controller property and sub-anim name support</h3><p>Developers can now specify and retrieve nonlocalized names for their TrackView nodes and controllers using three new methods found in the <code>MaxSDK::TranslationSupport</code> namespace: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">bool RegisterTranslation(ResolutionContext context, const MCHAR* localizedString, const MCHAR* nonLocalizedString) \n\
bool GetLocalizedStrings(ResolutionContext context, const MCHAR* nonLocalizedString, Tab&lt;const MCHAR*&gt;&amp; localizedStrings) \n\
GetNonLocalizedStrings(ResolutionContext context, const MCHAR* localizedString, Tab&lt;const MCHAR*&gt;&amp; nonLocalizedStrings) </code></pre>\n\
<p>MAXScript scripts are typically written in English, but when MAXScript accesses names from TrackView nodes only localized names are available. By specifying localized and English string pairs using the <code>RegisterTranslation()</code> method, MAXScript can retrieve the English name corresponding to a localized name to see if it matches the property name or SubAnim name specified by a script. </p>\n\
<p>Code that operates on TrackView nodes via <code>ITrackViewNode::AddNode()</code> or <code>ITrackViewNode::AddController()</code> should register via <code>RegisterTranslation()</code> the English name corresponding to the localized name specified in these methods. </p>\n\
<p>TrackView nodes persist their names to the scene file, so to ensure that the translations are present when loading the scene file, the translations should be registered when the plugin dll is loaded. For an example of how to do this, see <code>\\maxsdk\\include\\TranslationSupport.h</code></p>\n\
<h3 id=\"new-reference-message-added\">New reference message added</h3><p>This new message is sent by a parameter block to its client when it needs the nonlocalized animatable name of the i-th parameter. </p>\n\
<p><code>REFMSG_GET_PARAM_NAME_NONLOCALIZED</code></p>\n\
<p>If a plugin overrides <code>ReferenceMaker::NotifyRefChanged(...)</code>, but does not provide localized string resources, it can simply handle this message in the exact same way that it handles <code>REFMSG_GET_PARAM_NAME</code>. </p>\n\
<p>If a plugin overrides <code>ReferenceMaker::NotifyRefChanged(...)</code> and provides localized string resources, it can handle this message in the same way that it handles <code>REFMSG_GET_PARAM_NAME</code>, but the name returned should be in locale en-US. </p>\n\
<h3 id=\"new-parameter-definition-tag-added\">New parameter definition tag added</h3><p>The parameter definition tag below was added to the ParamTags enum: </p>\n\
<p><code>p_nonLocalizedName</code></p>\n\
<p>This new tag allows 3rd party developers to supply a non-localized parameter name for a parameter. The value assigned to this tag should be the parameter name in English, and it should be specified if the specified parameter name (&quot;radialStrength&quot; in the example below) is not the same as the localized name of the parameter acquired using the parameter&apos;s resource ID (<code>IDS_EP_RDSTR</code> in the example below). </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">PB_RADSTR, _T(&quot;radialStrength&quot;), TYPE_FLOAT, P_ANIMATABLE + P_RESET_DEFAULT, IDS_EP_RDSTR, \n\
   p_default,          0.5f, \n\
   p_range,            0.0f,1000.0f, \n\
   p_ui,               TYPE_SPINNER, EDITTYPE_FLOAT, IDC_VORTEX_RD, IDC_VORTEX_RDSPIN, SPIN_AUTOSCALE,  \n\
   p_nonLocalizedName, _T(&quot;Radial Pull Strength&quot;),  \n\
   p_end, </code></pre>\n\
<h2 id=\"maxscript-changes-related-to-localization-of-maxscript-exposed-property-names\">MAXScript changes related to localization of MAXScript exposed property names</h2><p>As a result of the work that was done to remove the usage of the <em>MAXScript.lcl</em> files from 3ds Max, some MAXScript functions can now take the following optional parameters: </p>\n\
<ul>\n\
<li><code>localizedName</code> </li>\n\
<li><code>localizedNames</code> (note the plural form) </li>\n\
</ul>\n\
<p>These parameters control whether localized or nonlocalized (English) property names are returned by functions they are passed to. </p>\n\
<h3 id=\"maxscript-functions-that-take-the-code-localizedname-code-parameter\">MAXScript functions that take the <code>localizedName</code> parameter</h3><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">getObjectName &lt;object&gt;&#x202F;[localizedName:&lt;bool&gt;] \n\
getSubAnimName &lt;obj&gt; &lt;index&gt;&#x202F;[asString:&lt;bool&gt;]&#x202F;[localizedName:&lt;bool&gt;] \n\
getSubMtlSlotName &lt;material&gt; &lt;index&gt;&#x202F;[localizedName:&lt;bool&gt;] \n\
getSubTexmapSlotName (&lt;material&gt; | &lt;texture&gt;) &lt;index&gt;&#x202F;[localizedName:&lt;bool&gt;] \n\
getClassName &lt;MAXWrapper&gt;&#x202F;[localizedName:&lt;bool&gt;] \n\
WM3_MC_GetName&#x202F;[Morpher Modifier]&#x202F;[Channel Index]&#x202F;[localizedName:&lt;bool&gt;] \n\
WM3_MC_SetName&#x202F;[Morpher Modifier]&#x202F;[Channel Index]&#x202F;[Name String]&#x202F;[localizedName:&lt;bool&gt;] </code></pre><p>The&#x202F;localizedName&#x202F;parameter has a default value of true. </p>\n\
<h3 id=\"maxscript-functions-that-take-the-localizednames-parameter\">MAXScript functions that take the localizedNames parameter</h3><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">getSubAnimNames &lt;obj&gt;&#x202F;[localizedNames:&lt;bool&gt;] \n\
dumpMAXStrings &lt;file_name&gt; which:[&lt;array of maxclass&gt;]&#x202F;PB2SpecialCases:[&lt;bool&gt;|&lt;int&gt;|&lt;array of maxclass&gt;]&#x202F;localizedNames:[&lt;bool&gt;] </code></pre><p>The&#x202F;localizedNames&#x202F;parameter has a default value of true. </p>\n\
<h3 id=\"new-properties-related-to-localized-property-names\">New properties related to localized property names</h3><p>The MAXModifier class now has a new read/write property:<code>nonLocalizedName</code> </p>\n\
<p>Here is an example of how it can be accessed: </p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">myMod = UVWMap()  \n\
\n\
myMod.name -- Returns &quot;UVW Map&quot; \n\
myMod.nonLocalizedName -- Returns &quot;UVW Map&quot;  \n\
\n\
myMod.name = &quot;Bonjour&quot; \n\
myMod.nonLocalizedName = &quot;Hello&quot; </code></pre><p>The <code>MAXCustAttrib</code> class now has a new read-only property:<code>localizedName</code> </p>\n\
<p>Here is an example of how it can be accessed: </p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">myCustAttrib = SimpleFaceData()  \n\
\n\
myCustAttrib.name -- Returns &quot;SimpleFaceData&quot; \n\
myCustAttrib.localizedName -- Returns &quot;SimpleFaceData&quot; </code></pre><h2 id=\"translation-support-for-trackview-nodes\">Translation support for Trackview nodes</h2><p>Scripters can now specify and retrieve nonlocalized names for their TrackView nodes and controllers using the following new functions: </p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">translationSupport.registerTranslation #trackViewNodes &lt;localized string&gt; &lt;non-localized string&gt; \n\
translationSupport.getLocalizedStrings #trackViewNodes &lt;non-localized string&gt; \n\
translationSupport.getNonLocalizedStrings #trackViewNodes &lt;localized string&gt; </code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../whats_new_3dsmax_2022_sdk.html\">What&#x27;s New: 3ds Max 2022 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";