var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"miscellaneous\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Miscellaneous Changes and Improvements</h1></div><p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#inclusive-language-changes\">Inclusive Language Changes</a></li>\n\
<li><a href=\"#c-17-support-and-geometry-library-performance\">C++17 support and geometry library performance</a></li>\n\
<li><a href=\"#-maxsdk-array-and-standard-library-algorithms\"><code>MaxSDK::Array</code> and Standard Library algorithms</a></li>\n\
<li><a href=\"#-maxsdk-array-static-assertions-ensure-requirements-on-the-types-it-can-store\"><code>MaxSDK::Array</code> static assertions ensure requirements on the types it can store</a></li>\n\
<li><a href=\"#class-windowsmessagefilter-and-handling-of-qt-events\">Class <code>WindowsMessageFilter</code> and handling of Qt events</a></li>\n\
<li><a href=\"#new-gettypedinterface-api\">New <code>GetTypedInterface</code> API</a></li>\n\
<li><a href=\"#-ipathconfigmgr-interface-changes\"><code>IPathConfigMgr</code> interface changes</a></li>\n\
<li><a href=\"#deprecation-of-interface18-and-interface19-\">Deprecation of <code>Interface18</code> and <code>Interface19</code></a></li>\n\
<li><a href=\"#deprecation-of-refmsg_get_param_name-reference-message\">Deprecation of <code>REFMSG_GET_PARAM_NAME</code> reference message</a></li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"inclusive-language-changes\">Inclusive Language Changes</h2><p>Several terms in the 3ds Max user interface, class, and method names in 3ds Max SDK, and MAXScript have been changed or removed because they were not aligned with Autodesk values of diversity and inclusion. We want everyone to feel welcome when using 3ds Max as an end user or tool developer.  </p>\n\
<p>Therefore, the names of several SDK elements that included words such as &quot;master&quot; or &quot;slave&quot; have been changed to use the terms &quot;driver&quot; and &quot;driven&quot; respectively. Usage of the old SDK elements will trigger a deprecation warning that will inform the developer of the new APIs to use instead of the old ones. </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">GetMasterController(anim) -&gt; GetDriverController(...)\n\
I_MASTER -&gt; I_DRIVER\n\
dh_master_unit_dialog -&gt; dh_system_unit_dialog\n\
MasterPointControl -&gt; PointControllerContainer\n\
NewDefaultMasterPointController() -&gt; NewDefaultPointControllerContainer()\n\
CreateMasterPointControl() -&gt; CreatePointControllerContainer()\n\
I_BIPMASTER\n\
I_BIPMASTER8\n\
I_BIPMASTER9\n\
I_BIPMASTER10\n\
I_BIPMASTER11\n\
I_BIPMASTER12 -&gt; BipDriver\n\
BIPSLAVE_CONTROL_CLASS_ID -&gt; BipDriven\n\
IGAME_MASTER -&gt; IGAME_POINTCTRLCONTAINER\n\
GetMasterBase()\n\
GetMaster()\n\
AddSlaveNode()\n\
CreateIKMasterControl(...)\n\
CreateIKSlaveControl(...) -&gt; Driver/Driven\n\
MASTERLAYERCONTROLMANAGER_CLASS_ID    -&gt; MAIN\n\
virtual bool PreReplacement(..., INode *masterNode, Animatable *masterAnim, ...) = 0;\n\
virtual bool PostReplacement(..., INode *masterNode, ...) = 0;\n\
virtual INode *NewNode(INode *masterNode) = 0; -&gt; main\n\
MasterPointControlImp::Save(...) MasterPointControlImp::Load(...) -&gt; SamplePointControlImp\n\
MasterDlgDeleted(...) -&gt; MainDlgDeleted(...)\n\
masterMDlg -&gt; mainMDlg\n\
masterEDlg\n\
masterRDlg\n\
is_master()\n\
Is_slave()\n\
set_slave_animation(...)\n\
get_slave_animation() -&gt; Driver/Driven\n\
pc_load_type_slave -&gt; pc_load_type_network\n\
MASTERLIST_CONTROL_CLASS_ID -&gt; DRIVERBLOCKLIST_CONTROL_CLASS_ID\n\
MasterEnable() -&gt; SuperEnable()\n\
virtual unsigned int DeleteNode(..., BOOL overrideSlaves=FALSE) = 0;\n\
virtual unsigned int DeleteNodes(..., bool overrideSlaveTM = false) = 0; -&gt; overrideDriven\n\
MASTERMAXCLIP_CLASS_ID\n\
SLAVE_CONTROL_CLASS_ID\n\
SLAVEFLOAT_CONTROL_CLASS_ID\n\
SLAVEPOS_CONTROL_CLASS_ID\n\
SLAVEROTATION_CONTROL_CLASS_ID\n\
SLAVESCALE_CONTROL_CLASS_ID\n\
SLAVEPOINT3_CONTROL_CLASS_ID\n\
SLAVEPOINT4_CONTROL_CLASS_ID\n\
SLAVEMATRIX3_CONTROL_CLASS_ID\n\
I_MIXSLAVEINTERFACE -&gt; Driver/Driven\n\
master_block_controller -&gt; driver_block_controller\n\
masterMDlg -&gt; mainMDlg\n\
masterFXDlg -&gt; mainFXDlg\n\
RO_UTIL_MASTER -&gt; RO_UTIL_MAIN\n\
EP_MASTER_CONTROL_REF -&gt; EP_POINT_CTRL_CONTAINER_REF\n\
masterCont -&gt; pointCtrlContainer\n\
MASTERBLOCK_SUPER_CLASS_ID -&gt; DRIVERBLOCK_SUPER_CLASS_ID\n\
CTRL_MASTERPOINT_CLASS_ID -&gt; POINTCTRLCONTAINER_SUPERCLASS_ID\n\
MASTERPOINTCONT_CLASS_ID -&gt; POINTCTRLCONTAINER_CLASS_ID\n\
PROP_MASTER -&gt; PROP_POINT_CONTROLLER_CONTAINER\n\
ES_MASTER_CONTROL_REF -&gt; ES_POINT_CTRL_CONTAINER_REF\n\
masterCont -&gt; pointCtrlContainer\n\
SV_FILTER_MASTER_POINT -&gt; SV_FILTER_POINTCTRLCONTAINERS\n\
GetMasterScale(...) -&gt; System Unit Scale\n\
GetMasterUnitInfo(...) -&gt; System Unit Info\n\
SetMasterUnitInfo(...)</code></pre>\n\
<h2 id=\"c-17-support-and-geometry-library-performance\">C++17 support and geometry library performance</h2><p>We have made several changes to the 3ds Max SDK with the goal of making its entire code base C++17 standard compliant.  </p>\n\
<p>We have also modernized our geometry library to enable standard C++11 optimizations. This improves performance and stability when using standard containers and algorithms. </p>\n\
<p>This effort will continue throughout future releases of 3ds Max. </p>\n\
<h2 id=\"-code-maxsdk-array-code-and-standard-library-algorithms\"><code>MaxSDK::Array</code> and Standard Library algorithms</h2><p>Class <code>MaxSDK::Array</code> has been updated with begin() and end() methods and can now be used with Standard Library algorithms. </p>\n\
<h2 id=\"-code-maxsdk-array-code-static-assertions-ensure-requirements-on-the-types-it-can-store\"><code>MaxSDK::Array</code> static assertions ensure requirements on the types it can store</h2><p>The following static assertion has been added to the <code>MaxSDK::Array</code> class template: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">static_assert(std::is_trivial&lt;T&gt;::value || (std::is_copy_constructible&lt;T&gt;::value &amp;&amp; std::is_copy_assignable&lt;T&gt;::value), &quot;The type stored by MaxSDK::Array must be trivial, or it must have a copy constructor and a copy assignment operator.&quot;);</code></pre>\n\
<p>The purpose of that static assertion is to validate that the type of the objects stored by the MaxSDK::Array satisfies at least one of the following conditions: </p>\n\
<p>The type is trivial. See <a href=\"https://en.cppreference.com/w/cpp/named_req/TrivialType\" target=\"_blank\">this page</a> for information on what this means. </p>\n\
<p>The type has a copy constructor and a copy assignment operator. </p>\n\
<p>If neither of those conditions is satisfied, then certain functions that the MaxSDK::Array class template calls internally could result in undefined behavior. To protect 3rd party developers from that problem, we have added the static assertion described above, which causes a compilation error when the assertion is violated. </p>\n\
<h2 id=\"class-code-windowsmessagefilter-code-and-handling-of-qt-events\">Class <code>WindowsMessageFilter</code> and handling of Qt events</h2><p>The <code>WindowsMessageFilter</code> class ensures that any messages required by the internal Qt event system are passed through for the Qt UI. This is automatically done within the default implementation of <code>IsAcceptableMessage()</code>, which calls the <code>IsQtSystemMessage()</code> method.  </p>\n\
<p>Custom overrides of IsAcceptableMessage() should include a call to <code>IsQtSystemMessage()</code>. Failure to do that can cause the Qt UI to freeze. </p>\n\
<h2 id=\"new-code-gettypedinterface-code-api\">New <code>GetTypedInterface</code> API</h2><p>Some interfaces that derive from class InterfaceServer can now be retrieved by simply specifying the interfaces name, without the need to specify the interface ID. </p>\n\
<p>For example, the following retrieves the INode interface of an object: </p>\n\
<p><code>INode* node = obj-&gt;GetTypedInterface&lt;INode&gt;();</code></p>\n\
<p>To support the <code>GetTypedInterface</code> mechanism in your interface class, you need to declare a <code>constexpr</code> member of type <code>Interface_ID</code>, called ID, that has the value of the interface ID of your class.  </p>\n\
<p>Here&apos;s how this is done for class <code>ILayerProperties</code> </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">class ILayerProperties : public FPMixinInterface \n\
{ \n\
public: \n\
static constexpr Interface_ID ID = LAYERPROPERTIES_INTERFACE; \n\
&#x2026; \n\
\n\
} </code></pre>\n\
<p>These are the 3ds Max SDK interfaces that support <code>GetTypedInterface</code>: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">INode \n\
ILayerProperties \n\
IMNMeshUtilities18 \n\
IMNMeshUtilities17 \n\
IMNMeshUtilities16 \n\
IMNMeshUtilities15 \n\
IMNMeshUtilities14 \n\
IMNMeshUtilities13 \n\
IMNMeshUtilities10 \n\
IMNMeshUtilities8 \n\
IMNTempData10 \n\
IMNFaceExtrude </code></pre>\n\
<h2 id=\"-code-ipathconfigmgr-code-interface-changes\"><code>IPathConfigMgr</code> interface changes</h2><p>The <code>IPathConfigMgrEx</code> and <code>IPathConfigMgrEx2</code> pure virtual classes where collapsed down to the base <code>IPathConfigMgr</code> class. </p>\n\
<p>The <code>IPathConfigMgr::DoProjectSetupStepsUsingDirectory</code> and <code>DoProjectSetupSteps</code> were invoking the &apos;Set Project Folder&apos; macroscript rather than the &apos;Create Default Project&apos; macroscript. The proper macroscript is now being called. \n\
Added <code>IPathConfigMgr::DoSetProjectFolderStepsUsingDirectory</code> and <code>DoSetProjectFolder</code> which invoke the &apos;Set Project Folder&apos; macroscript. </p>\n\
<h2 id=\"deprecation-of-code-interface18-code-and-code-interface19-code-\">Deprecation of <code>Interface18</code> and <code>Interface19</code></h2><p>Methods of class <code>Interface18</code> and class <code>Interface19</code> have been moved to class <code>Interface13</code> and class <code>Interface14</code> respectively. </p>\n\
<h2 id=\"deprecation-of-code-refmsg_get_param_name-code-reference-message\">Deprecation of <code>REFMSG_GET_PARAM_NAME</code> reference message</h2><p><code>REFMSG_GET_PARAM_NAME</code> has been deprecated and replaced by <code>REFMSG_GET_PARAM_NAME_LOCALIZED</code>. This message is sent by a parameter block to its client when it needs the localized animatable name of the i-th parameter. </p>\n\
<p>If a plugin overrides <code>ReferenceMaker::NotifyRefChanged(...)</code>, but does not provide localized string resources, it can simply handle this message in the exact same way that it handles <code>REFMSG_GET_PARAM_NAME_NONLOCALIZED</code>, namely by returning a name in locale en-US. </p>\n\
<p>If a plugin overrides <code>ReferenceMaker::NotifyRefChanged(...)</code> and provides localized string resources, it can handle this message in the same way that it handles <code>REFMSG_GET_PARAM_NAME_NONLOCALIZED</code>, but the name returned should be localized.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../whats_new_3dsmax_2022_sdk.html\">What&#x27;s New: 3ds Max 2022 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";