var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modeling_2022\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modeling</h1></div><p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#changes-to-class-matrix3-and-dmatrix3-\">Changes to class <code>Matrix3</code> and <code>DMatrix3</code></a></li>\n\
<li><a href=\"#changes-to-class-triobjectnormalxtc-\">Changes to class <code>TriObjectNormalXTC</code></a></li>\n\
<li><a href=\"#changes-to-class-deformer\">Changes to class Deformer</a></li>\n\
<li><a href=\"#new-functions-added-to-the-mnmesh-class\">New functions added to the <code>MNMesh</code> class</a></li>\n\
<li><a href=\"#new-function-added-to-the-modifier-class\">New function added to the Modifier class</a></li>\n\
<li><a href=\"#improve-sub-object-picking-with-high-dpi-systems\">Improve sub-object picking with High DPI systems</a></li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"changes-to-class-code-matrix3-code-and-code-dmatrix3-code-\">Changes to class <code>Matrix3</code> and <code>DMatrix3</code></h2><p>Starting with 3ds Max 2022, instances of <code>Matrix3</code> and <code>DMatrix3</code> will be initialized to the identity matrix. All the methods of these two classes will update the identity related flags stored by the matrix for the purposes to optimize performance of some operations. </p>\n\
<p>3rd party code that used to call <code>Matrix3::SetNotIdent()</code> following certain matrix operations can remove those calls. Leaving them does not impact the correctness of matrix functionality, but it could have a slight performance impact. </p>\n\
<h2 id=\"changes-to-class-code-triobjectnormalxtc-code-\">Changes to class <code>TriObjectNormalXTC</code></h2><p>Non-deformer modifiers might be affected by a performance boosting change to class <code>TriObjectNormalXTC</code>. </p>\n\
<p><code>TriObjectNormalXTC</code> instances now only depend on the topology channel (<code>TOPO_CHANNEL</code>).  </p>\n\
<p>Modifiers that indicated that they processed normals correctly, by setting the <code>MESH_NORMAL_MODIFIER_SUPPORT</code> flag in their <code>Modifier::ModifyObject()</code> method, are not affected by this change. </p>\n\
<p>Modifiers that do not set the <code>MESH_NORMAL_MODIFIER_SUPPORT</code> flag and change topology (<code>TOPO_CHANNEL</code>) will have their NormalSpec cleared. Those that do not set the <code>MESH_NORMAL_MODIFIER_SUPPORT</code> flag and only change geometry (<code>GEOM_CHANNEL</code>) may now generate incorrect normals. These modifiers need to be updated to support the MeshNormalSpec or MNNormalSpec. Note that those modifiers that affect the <code>GEOM_CHANNEL</code> only through the Deformer interface (see class Deformer) will have deformation of normal handled correctly and are not affected by this change. </p>\n\
<h2 id=\"changes-to-class-deformer\">Changes to class Deformer</h2><p>In order to improve the performance of Deformer, its non-const <code>Map()</code> and <code>IsThreadSafe()</code> methods have been deprecated. A new method called MapNormal() has been added, which together with <code>Map()</code> have to be thread safe. </p>\n\
<h2 id=\"new-functions-added-to-the-code-mnmesh-code-class\">New functions added to the <code>MNMesh</code> class</h2><p>The following methods have been added to the <code>MNMesh</code> class: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">int MNMesh::NumDeadVerts() \n\
int MNMesh::NumDeadEdges() \n\
int MNMesh::NumDeadFaces() </code></pre>\n\
<p>In 3ds Max, when a vertex, edge or face is deleted, it is sometimes flagged as &apos;dead&apos; instead of being deleted right away. This is done for performance reasons: instead of deleting each element individually and reallocating memory every time this happens, we wait until many elements have been flagged as &apos;dead&apos;, and then we delete them all at the same time. </p>\n\
<p>The methods listed above allow 3rd party developers to query the number of dead vertices, edges and faces, which are now cached in three private member variables that have also been added to the MNMesh class. </p>\n\
<p>Before these methods were added, the only way to access these numbers was to iterate over the vertices, edges and faces and count the number of dead ones. Now it is possible to do this in an efficient manner thanks to how these values are cached. </p>\n\
<h2 id=\"new-function-added-to-the-modifier-class\">New function added to the Modifier class</h2><p>The following method has been added to the Modifier class:  </p>\n\
<p><code>virtual bool Modifier::ShouldCollapseOnSave()</code></p>\n\
<h2 id=\"improve-sub-object-picking-with-high-dpi-systems\">Improve sub-object picking with High DPI systems</h2><p>Picking with the mouse now properly accounts for high DPI displays and a tunable scaling factor is also present. 3rd party plugin developers can take advantage of the following new APIs to update their code: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">float IMouseConfigManager::GetSelectionRadius() const \n\
float IMouseConfigManager::GetSelectionRadiusScale() const \n\
void IMouseConfigManager:: SetSelectionRadiusScale(float selectionRadiusScale) </code></pre>\n\
<p>In most cases, 3rd party plugins can simply query the selection radius computed by 3ds Max and use it instead of a hard-coded pixel value. </p>\n\
<p>These settings are exposed to MAXScript through the MouseConfigManager interface.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../whats_new_3dsmax_2022_sdk.html\">What&#x27;s New: 3ds Max 2022 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";