var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plugin_package\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plugin Package format changes</h1></div><p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#-adsk_application_plugins-can-point-to-a-specific-plugin-package-3ds-max-update-2022-2-\"><code>ADSK_APPLICATION_PLUGINS</code> can point to a specific plugin package (3ds Max Update 2022.2)</a></li>\n\
<li><a href=\"#-seriesmax-attribute-is-mandatory\"><code>SeriesMax</code> attribute is mandatory</a></li>\n\
<li><a href=\"#-seriesmin-and-seriesmax-attributes-allow-for-fine-grained-version-specification\"><code>SeriesMin</code> and <code>SeriesMax</code> attributes allow for fine grained version specification</a><ul>\n\
<li><a href=\"#examples\">Examples</a></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"-code-adsk_application_plugins-code-can-point-to-a-specific-plugin-package-3ds-max-update-2022-2-\"><code>ADSK_APPLICATION_PLUGINS</code> can point to a specific plugin package (3ds Max Update 2022.2)</h2><p>The <code>ADSK_APPLICATION_PLUGINS</code> environment variable can now include paths that contain a plugin package XML file at the top level.  This can be used to only load specific plugins, or versions of plugins.  See <a href=\"./../../writing_plug-ins/plugin_package/packaging_plugins.html\">Packaging Plugins</a> for more information.</p>\n\
<h2 id=\"-code-seriesmax-code-attribute-is-mandatory\"><code>SeriesMax</code> attribute is mandatory</h2><p>The &quot;SeriesMax&quot; attribute of the <code>&lt;RuntimeRequirements&gt;</code> element is now mandatory for plugins using the Plugin Package format. </p>\n\
<p>To assist third-party developers in providing a great user experience and prevent 3ds Max from attempting to load incompatible plugins, scripts and associated resources, developers should now specify the maximum version of 3ds Max their plugins are compatible with. </p>\n\
<p>While it was previously possible to omit the SeriesMax attribute on <code>&lt;RuntimeRequirements&gt;</code> elements of the PackageContents.xml file, plugins will no longer be loaded if the attribute is not found.  </p>\n\
<h2 id=\"-code-seriesmin-code-and-code-seriesmax-code-attributes-allow-for-fine-grained-version-specification\"><code>SeriesMin</code> and <code>SeriesMax</code> attributes allow for fine grained version specification</h2><p>The format of the &quot;SeriesMin&quot; and &quot;SeriesMax&quot; attributes of the <code>&lt;RuntimeRequirements&gt;</code> element has been extended to support additional version information about a 3ds Max release. </p>\n\
<p>Previously, the specification only supported the release year of 3ds Max that plugins were compatible with (e.g. &quot;2022&quot;). This has now been expanded to support the YYYYY.u.h.bbbb format (e.g. &quot;2021.2.1.4567&quot;), where: </p>\n\
<ul>\n\
<li>YYYY is the product release year (e.g. &quot;2022&quot;) </li>\n\
<li>u is the update number (e.g. &quot;2&quot; for 2022 Update 2)</li>\n\
<li>h is the hotfix number (e.g. &quot;1&quot; for 2022 Update 2, Hotfix 1) </li>\n\
<li>bbbb is the build number (e.g. &quot;4567&quot;) </li>\n\
</ul>\n\
<p>When SeriesMax is set to the release year only (for example, &quot;2022&quot;) the plugin package will be supported by all update releases of that main 3ds Max release version.</p>\n\
<p>Through this change we support third-party developers in the 3ds Max Beta program, who wish to recompile their plugins for 3ds Max 2022, before its SDK is finalized. The previous notation (limited to the release year) had a limitation where 3ds Max beta builds would attempt to load plugins that could be binary-incompatible, resulting in errors, and a degraded user experience.  </p>\n\
<p>Since update and hotfix releases of 3ds Max (e.g 3ds Max 2022 Update 2) are binary compatible with their main release (e.g. 3ds Max 2022), the YYYY notation for the &quot;SeriesMin&quot; and &quot;SeriesMax&quot; attributes is still supported, and it is useful in the context of non-beta builds. </p>\n\
\n\
<div class=\"callout callout-tip\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-lightbulb-o\" aria-hidden=\"true\"></i>Tip:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p> Developers may wish to use the <code>maxVersion()</code> MAXScript function to identify the values to use for a specific release, using indices 4 to 8 of the returned array. </p>\n\
\n\
</div></div>\n\
\n\
<h3 id=\"examples\">Examples</h3><p>A plugin that is compatible with 3ds Max 2022, and all its updates </p>\n\
<p><code>&lt;RuntimeRequirements OS=&#39;Win64&#39; Platform=&#39;3ds Max&#39; SeriesMin=&#39;2022&#39; SeriesMax=&#39;2022&#39; /&gt;</code></p>\n\
<p>A value of &quot;2022&quot; for SeriesMin means &quot;3ds Max 2022 is minimally required for this plugin to work correctly&quot;. A value of &quot;2022&quot; for SeriesMax means &quot;the plugin works in all 3ds Max 2022 updates, but not major versions of 3ds Max greater than 2022&quot;. This notation relies on the fact that 3ds Max Updates remain binary and source compatible with previous updates of the same main 3ds Max release, which is guaranteed by the 3ds Max team. </p>\n\
<p>A plugin that requires 3ds Max 2022 Update 1 and is compatible with all future 3ds Max 2022 updates </p>\n\
<p><code>&lt;RuntimeRequirements OS=&#39;Win64&#39; Platform=&#39;3ds Max&#39; SeriesMin=&#39;2022.1&#39; SeriesMax=&#39;2022&#39; /&gt;</code></p>\n\
<p>A value of &quot;2022.1&quot; for SeriesMin means &quot;3ds Max 2022 Update 1 is minimally required for this plugin to work correctly&quot;. A value of &quot;2022&quot; for SeriesMax means &quot;all 3ds Max 2022 updates, but not major versions of 3ds Max greater than 2022&quot;.  </p>\n\
<p>A plugin that requires a certain beta build of 3ds Max </p>\n\
<p><code>&lt;RuntimeRequirements OS=&#39;Win64&#39; Platform=&#39;3ds Max&#39; SeriesMin=&#39;2022.0.0.514&#39; SeriesMax=&#39;2022.0.0.514&#39; /&gt;</code></p>\n\
<p>The above runtime requirements express the fact that the plugin was compiled against beta build 514 of 3ds Max. Constraining a plugin to a given beta build is useful when the 3ds Max SDK is undergoing breaking changes, and beta builds do not maintain binary and/or source compatibility with each other.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../whats_new_3dsmax_2022_sdk.html\">What&#x27;s New: 3ds Max 2022 SDK</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";