var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"whats_new_3dsmax_2023_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&apos;s New: 3ds Max 2023 SDK</h1></div><p>This topic describes new items and changes that affect the 3ds Max 2023 C++ SDK.</p>\n\
<p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#2023-1-update-svg-icon-support\">2023.1 Update - SVG Icon Support</a></li>\n\
<li><a href=\"#sdk-break\">SDK Break</a></li>\n\
<li><a href=\"#compiler-upgrade\">Compiler Upgrade</a></li>\n\
<li><a href=\"#instance-display-api\">Instance Display API</a></li>\n\
<li><a href=\"#instance-rendering-api\">Instance Rendering API</a></li>\n\
<li><a href=\"#volume-display-api\">Volume Display API</a></li>\n\
<li><a href=\"#max-to-viewport-material-conversion-api\">Max to viewport material conversion API</a></li>\n\
<li><a href=\"#-sharedmesh-class\"><code>SharedMesh</code> class</a></li>\n\
<li><a href=\"#autobackup\">AutoBackup</a><ul>\n\
<li><a href=\"#plugin-packages-improvements\">Plugin Packages Improvements</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#user-interface\">User Interface</a></li>\n\
<li><a href=\"#software-security\">Software Security</a><ul>\n\
<li><a href=\"#safe-script-execution\">Safe Script Execution</a></li>\n\
<li><a href=\"#secure-way-for-plugins-to-load-binary-dependencies\">Secure way for plugins to load binary dependencies</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#geom-lib-updates\">Geom lib updates</a><ul>\n\
<li><a href=\"#geom-headers-moved-to-its-own-folder\">Geom headers moved to its own folder</a></li>\n\
<li><a href=\"#geom-support-for-std-span-in-the-form-of-geo-span-\">Geom support for <code>std::span</code> in the form of <code>geo::span</code></a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#manipulator-improvements\">Manipulator Improvements</a><ul>\n\
<li><a href=\"#all-active-manipulator-display-control\">All/Active Manipulator Display Control</a></li>\n\
<li><a href=\"#manipulator-right-button-mouse-interaction\">Manipulator Right Button Mouse Interaction</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#deprecated-features\">Deprecated features</a></li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"2023-1-update-svg-icon-support\">2023.1 Update - SVG Icon Support</h2><p>Starting with <strong>3ds Max 2023.1 Update</strong>, you can use Scalable Vector Graphics (SVG) files for icons in plug-ins, either as stand-alone files or compiled into RCC resource files.  See <a href=\"./../3ds_max_sdk_features/user_interface/icons.html\"\">Icons</a> and <a href=\"./../writing_plug-ins/using_qt_with_3ds_max_plug-ins/using_multi_res_icons.html\"\">Using Multi-Resolution Icons</a> for more information.</p>\n\
<h2 id=\"sdk-break\">SDK Break</h2><p>3ds Max 2023 is an SDK breaking release. Plugins compiled for 3ds Max 2022 will need to be recompiled to work in 3ds Max 2023 builds.  </p>\n\
<h2 id=\"compiler-upgrade\">Compiler Upgrade</h2><p>3ds Max 2023 has been compiled with Visual Studio 2019 16.10.4, MSVC Platform Toolset v142, and Windows Platform SDK 10.0.19041.0.<br>Conformance improvements and bug fixes are made in every major and minor release of Microsoft C/C++ in Visual Studio (MSVC).  These changes could potentially cause new build errors and warnings in code that previously compiled cleanly, and could also cause different runtime behavior. 3ds Max benefited from several code improvements because of migrating to the new compiler. </p>\n\
<p>To learn more about MSVC conformance improvements, bug fixes, and potential upgrade issues, refer to Microsoft&apos;s Visual Studio documentation:  </p>\n\
<ul>\n\
<li><a href=\"https://docs.microsoft.com/en-us/cpp/overview/cpp-conformance-improvements?view=msvc-160\" target=\"_blank\">C++ Conformance Improvements in Visual Studio 2019</a></li>\n\
<li><a href=\"https://docs.microsoft.com/en-us/cpp/porting/overview-of-potential-upgrade-issues-visual-cpp?view=msvc-160\" target=\"_blank\">Overview of potential upgrade issues (Visual C++)</a></li>\n\
<li><a href=\"https://docs.microsoft.com/en-us/cpp/error-messages/compiler-warnings/compiler-warnings-by-compiler-version?view=msvc-160\" target=\"_blank\">Compiler warnings by compiler version</a></li>\n\
</ul>\n\
<p>There is no single correct method of fixing upgrade issues, but the <a href=\"https://docs.microsoft.com/en-us/cpp/porting/visual-cpp-porting-and-upgrading-guide?view=msvc-160\" target=\"_blank\">Microsoft C++ Porting and Upgrade Guide</a> provides suggestions for a <a href=\"https://docs.microsoft.com/en-us/cpp/porting/upgrading-projects-from-earlier-versions-of-visual-cpp?view=msvc-160\" target=\"_blank\">phased approach</a>.  In the 3ds Max SDK, the Platform Toolset, Windows SDK version, and C++ Language Standard are specified in the <code>3dsmax.general.project.settings.props</code> property sheet.</p>\n\
<h2 id=\"instance-display-api\">Instance Display API</h2><p>This new API allows an object plugin to display many instances in the viewport without creating them all in the scene. The plugin describes the instance data based on a single object, and 3ds Max creates efficient representations of that object on the GPU. The instances can have different transforms, materials, mapping coordinates, and vertex colors. Examples of plugins that would benefit from using this API are particle systems, scattering tools, instancers, etc. </p>\n\
<p>To take advantage of this API, plugins should use the methods of class <code>InstanceDisplayGeometry</code>, which are implemented by 3ds Max. For more details, please see <em>maxsdk\\include\\graphics\\InstanceDisplayGeometry.h</em>, and the sample project located in <em>maxsdk\\howto\\objects\\InstancedObject\\</em> folder of the 3ds Max SDK. </p>\n\
<h2 id=\"instance-rendering-api\">Instance Rendering API</h2><p>This new API allows object plugins (the producer) to produce many instances for rendering purposes efficiently, and allows renderers (the consumer) to access them and render them efficiently. Examples of plugins that would produce many instances of things to be rendered are particle systems, scattering tools, instancers, etc. </p>\n\
<p>Class <code>RenderTimeInstancingInterface</code> allows a renderer to access an object&apos;s instancing information so that it can do efficient instancing at render-time. This interface is implemented by an object and called by a renderer. A renderer should not call the object&apos;s <code>GetRenderMesh()</code> method if the object supports the <code>RenderTimeInstancingInterface</code> interface. However, even if an object implements this interface, it should ideally still implement <code>GetRenderMesh()</code> to return an aggregate mesh of all instances, so that a renderer that does not support <code>RenderTimeInstancingInterface</code> will still render it. </p>\n\
<p>The API supports passing material, UVW, transform, motion blur and custom channel info per instance to the renderer. </p>\n\
<p>Note that the Arnold rendering plugin for 3ds Max 2023 supports this new API, making it easy for 3rd party plugins to experiment with it and support it. </p>\n\
<p>For more information, please see the <em>maxsdk\\include\\Rendering\\RenderTimeInstancing.h</em> header file. For an example of an object that produces instances using this API, please see the <em>maxsdk\\howto\\objects\\RenderTimeInstancedObject\\</em> sample project in the 3ds Max SDK. </p>\n\
<h2 id=\"volume-display-api\">Volume Display API</h2><p>This new API simplifies displaying a volume in the viewport when a plugin provides the voxels data, positions and display options. 3ds Max will convert the voxels data on the GPU and display it according to the different supported viewport modes such as wireframe, shaded, and so on. This API proposes many options for the display such as: bounding box, wireframe, voxels, volume with a voxel color and opacity, black body, turbo gradient, or gradient custom texmaps color modes are also available. So far, it supports the volume grids of type fog and level sets. You can use a slice axis to show only a part of the volume at display time. The voxels&apos; grid data can be normalized automatically, or manually, or not normalized at all.<br>You can use a 1D density transfer texture to remove some parts of the voxels data at display time, so a 3rd party can control how the volume looks. It also provides support for selection hit testing and wireframe display. </p>\n\
<p>For detailed information about this API please see the header file located in <em>maxsdk\\include\\graphics\\ViewportVolumeDisplay.h</em>, and the sample plugin found in <em>maxsdk\\howto\\objects\\VolumeSampleObject</em>.</p>\n\
<h2 id=\"max-to-viewport-material-conversion-api\">Max to viewport material conversion API</h2><p>There are additional helper functions in <code>MaxSDK::Graphics::MaterialConversionHelper</code>\n\
to convert from a 3ds Max material (<code>Mtl</code> class) into a Nitrous viewport material (<code>BaseMaterialHandle</code> class) with the function <code>ConvertMaxToNitrousMaterial()</code>, and to create a Nitrous viewport material from a physical material preset with the function <code>GetNitrousMaterialFromPhysicalMaterialPreset()</code>. </p>\n\
<p>For detailed information about this API please see the header file located in \n\
<em>maxsdk\\include\\Graphics\\MaterialConversionHelper.h</em></p>\n\
<h2 id=\"-code-sharedmesh-code-class\"><code>SharedMesh</code> class</h2><p><code>SharedMesh</code> is a class to share a mesh between different classes. It uses reference counting and gets automatically deleted and the pointer null&apos;ed once its ref count reaches 0. </p>\n\
<p>For detailed information about this API please see the header file located in <em>maxsdk\\include\\SharedMesh.h</em>.</p>\n\
<h2 id=\"autobackup\">AutoBackup</h2><p>There are additional methods for controlling Auto Backup during long running operations. </p>\n\
<p><code>IAutoBackup::SetTempDisable and IAutoBackup::GetTempDisable</code> - Temporarily disables Autobackup. Use this during operations where Autobackup should not occur (for example, Computations on separate threads, heavy scene manipulations). </p>\n\
<p><code>class AutoBackupDisableHelper</code> - Helper class to temporarily disable and re-enable Autobackup during a computation. </p>\n\
<div class=\"head-block\"><h1>Plugin Packages Improvements</h1></div><p>The Plugin Package description file (<em>PackageContents.xml</em>) now supports environment variable definitions of type string and path. Plugins often make use of env vars to configure themselves or their environment.&#x202F; Hotkey definitions can now be specified as part of the package definition.</p>\n\
<p>For more information see <a href=\"./../writing_plug-ins/plugin_package/packaging_plugins.html\"\">Packaging Plug-ins</a>.</p>\n\
<h2 id=\"user-interface\">User Interface</h2><p>Class <code>QmaxRollupContainer</code> exposed.</p>\n\
<p>When you need to create a pure Qt dialog with closable groups/rollups, similar to the ones used in the command panel, use <code>QmaxRollupContainer</code> widget and add QmaxRollup&apos;s to it. The <code>QmaxRollupContainer</code> will act as a host for the rollups and will take care of the proper layout and scrollbar adjustments. </p>\n\
<p>For detailed information about this API see the header file located in <em>maxsdk\\include\\Qt\\QmaxRollupContainer.h</em></p>\n\
<h2 id=\"software-security\">Software Security</h2><h3 id=\"safe-script-execution\">Safe Script Execution</h3><p>Addition of enum value <code>MaxSDK::AssetManagement::AssetType::kScript</code> - An asset file reflecting any script file other than a pre- or post-render script file. </p>\n\
<p>Addition of enum value <code>MAXScript::ScriptSource::Dynamic</code> &#x2013; To be used for scripts that are dynamically generated at runtime and could contain input from various sources that are interpreted as scripted commands. Dynamic scripts will always execute with restricted security rights, regardless of Safe Scene Script Execution settings. </p>\n\
<p>Addition of <code>ExecuteScriptAsset()</code> function - Executes the given script file specified as an AssetUser. This function should be used for executing script files whose name is stored in the scene file. </p>\n\
<p>Addition of <code>MAXScript::ScriptSource</code> argument to <code>ExecuteMAXScriptScript()</code> function - specifies the security rights of the evaluated script string. </p>\n\
<h3 id=\"secure-way-for-plugins-to-load-binary-dependencies\">Secure way for plugins to load binary dependencies</h3><p>3ds Max will load dynamic-link libraries (DLLs) that plugins have a link-time (implicit) dependency on from the folder where the plugin resides. In other words, the DLLs the plugin depends on do not have to be installed in 3ds Max&apos;s root folder (<code>&lt;maxroot&gt;</code>), nor does the plugin need to do extra work to load the dlls at run-time (by calling <code>LoadLibrary()</code> for example). </p>\n\
<p>Simply deploy the DLLs the plugin depends on side-by-side within the same folder where the plugin resides, and 3ds Max will be able to load the plugin. </p>\n\
<p>If a plugin needs to explicitly load a DLL, the safest way is to load it by specifying a complete path. If a plugin needs to change the DLL search path, it must respect the following rules: </p>\n\
<ul>\n\
<li>The <code>SetDllDirectory()</code> API is used instead of <code>AddDllDirectory()</code> to modify the DLL search path </li>\n\
<li>Save the value returned by <code>GetDllDirectory()</code> </li>\n\
<li>Use <code>SetDllDirectory()</code> to specify the nonstandard folder you want to load from </li>\n\
<li>Load the DLL. </li>\n\
<li>Use <code>SetDllDirectory()</code> again to restore the previous value. </li>\n\
<li>Keep the changes to the DLL search path in effect for as short of a code-scope as possible </li>\n\
<li>Never call <code>SetDllDirectory(nullptr)</code> as it adds the current working directory to the search path and causes a security vulnerability. </li>\n\
</ul>\n\
<p>For more information see the MSDN topic on&#x202F;<a href=\"https://msdn.microsoft.com/en-us/library/windows/desktop/ff919712(v=vs.85).aspx\" target=\"_blank\">Dynamic-Link Library Security</a>.</p>\n\
<h2 id=\"geom-lib-updates\">Geom lib updates</h2><h3 id=\"geom-headers-moved-to-its-own-folder\">Geom headers moved to its own folder</h3><p>All the header files that make up the 3ds Max geom library have moved to <em>maxsdk\\include\\geom</em>. To make it easy for your project to absorb this change, you could add the <code>$(MaxSdkGeomInc)</code> path to the list of include paths of your project settings. To benefit from this your code needs to include geom header files without a qualified path. </p>\n\
<h3 id=\"geom-support-for-code-std-span-code-in-the-form-of-code-geo-span-code-\">Geom support for <code>std::span</code> in the form of <code>geo::span</code></h3><p>Span is a very simple type. You can think of it as a &quot;view&quot; on some memory. It holds a non-owning pointer to some data and a size. You can create spans from&#x202F;<code>std::vector</code>, from&#x202F;Tab, from raw arrays, etc. Using <code>geo::span</code> is much safer than passing raw pointers around, and it supports developer-friendly features such as&#x202F;ranged for loops.  </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">// Creating spans from a std::vector. \n\
\n\
std::vector&lt;int&gt; v; \n\
geo::span&lt;const int&gt; const_vec_span{v}; \n\
geo::span&lt;int&gt; vec_span{v}; \n\
\n\
\n\
// Creating spans from a Tab. \n\
Tab&lt;int&gt; t; \n\
geo::span&lt;const int&gt; const_tab_span{t}; \n\
geo::span&lt;int&gt; tab_span{t}; \n\
\n\
\n\
// You can create spans from a pointer and a size. \n\
const int* buffer; \n\
geo::span&lt;const int&gt; buf_span{buffer, 10}; \n\
\n\
// You can create spans from iterators, as long as they point to contiguous memory. \n\
std::vector&lt;int&gt; v2; \n\
geo::span&lt;int&gt; range_span{v2.begin(), v2.begin() + 5}; </code></pre>\n\
<p>For more information on <code>std::span</code> see <a href=\"https://en.cppreference.com/w/cpp/container/span\" target=\"_blank\">https://en.cppreference.com/w/cpp/container/span</a> </p>\n\
<h2 id=\"manipulator-improvements\">Manipulator Improvements</h2><h3 id=\"all-active-manipulator-display-control\">All/Active Manipulator Display Control</h3><p>Previously, when an object and modifiers applied to it both had Manipulators, when editing the modifier, both the modifier&apos;s manipulators and the base object&apos;s manipulators were active at the same time.  This could cause problems due to conflicts between the two sets of manipulators -- the user might inadvertently click on the base object&apos;s manipulator when the intention was to click on the modifier&apos;s manipulator. </p>\n\
<p>3ds Max 2023 allows the user to set the Manipulator system to display all the manipulators for an object (legacy behavior) or display only the manipulators for the active object or modifier. This is available in the main menu, <strong>Customize &gt; Preferences &gt; Gizmos &gt; Manipulators</strong> (Object / Only Active). </p>\n\
<p>Developers can detect and set this behavior programmatically via the IManipulatorManager interface (see <em>3dswin\\src\\maxsdk\\include\\manipulator.h</em>): </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual ObjectManipulatorDisplayMode GetObjectManipulatorMode() \n\
virtual ObjectManipulatorDisplayMode SetObjectManipulatorMode(ObjectManipulatorDisplayMode newMode) </code></pre>\n\
<p><code>ObjectManipulatorDisplayMode</code> is defined as: </p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">kAllManipulators = 0, \n\
kActiveManipulators = 1, </code></pre><h3 id=\"manipulator-right-button-mouse-interaction\">Manipulator Right Button Mouse Interaction</h3><p>Manipulators can now use the right mouse button for interaction in addition to the left mouse button. </p>\n\
<p>3ds Max 2023 adds the following to the Manipulator class: </p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-cpp prettyprint\">virtual void OnRButtonDown(TimeValue t, ViewExp* pVpt, IPoint2&amp; m, DWORD flags, ManipHitData* pHitData) {} \n\
\n\
virtual void OnRButtonUp(TimeValue t, ViewExp* pVpt, IPoint2&amp; m, DWORD flags, ManipHitData* pHitData) {} </code></pre>\n\
<p>These methods are called when the right mouse button is clicked or released, respectively. Functionality is essentially the same as for the left mouse button. </p>\n\
<h2 id=\"deprecated-features\">Deprecated features</h2><ul>\n\
<li>Combustion Map </li>\n\
<li>Panorama Exporter&apos;s support for Quicktime VR output format</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new.html\">What&#x27;s New</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";