var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"whats_new_3dsmax_2024_sdk\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>What&#39;s New: 3ds Max 2024 SDK</h1></div><p>This topic describes new items and changes that affect the 3ds Max 2024 C++ SDK.</p>\n\
<p><a name=\"toc\"></a></p>\n\
<!-- toc -->\n\
\n\
<ul>\n\
<li><a href=\"#sdk-break\">SDK Break</a></li>\n\
<li><a href=\"#sdk-requirements\">SDK Requirements</a></li>\n\
<li><a href=\"#qt-version-and-pyside2\">Qt version and PySide2</a></li>\n\
<li><a href=\"#python-version\">Python version</a></li>\n\
<li><a href=\"#-net-version\">.NET version</a></li>\n\
<li><a href=\"#c-version\">C++ version</a></li>\n\
<li><a href=\"#c-standard-conformance\">C++ standard conformance</a></li>\n\
<li><a href=\"#removal-of-min-and-max-macros\">Removal of min and max Macros</a></li>\n\
<li><a href=\"#color-management-api\">Color Management API</a></li>\n\
<li><a href=\"#mesh-mnmesh-and-beziershape-api-changes\">Mesh, MNMesh, and bezierShape API Changes</a><ul>\n\
<li><a href=\"#important-new-sdk-headers\">Important New SDK headers</a></li>\n\
<li><a href=\"#mesh\">Mesh</a></li>\n\
<li><a href=\"#mnmesh\">MNMesh</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#better-qt-ui-binding-control-for-params\">Better Qt UI Binding Control for Params</a></li>\n\
<li><a href=\"#openexr-sdk\">OpenEXR SDK</a></li>\n\
<li><a href=\"#volumeobject-classes\">VolumeObject Classes</a></li>\n\
<li><a href=\"#deprecated-items\">Deprecated Items</a></li>\n\
</ul>\n\
<!-- tocstop -->\n\
\n\
<h2 id=\"sdk-break\">SDK Break</h2><p>3ds Max 2024 is an SDK breaking release. Plugins compiled for 3ds Max 2023 will need to be recompiled to work in 3ds Max 2024 builds.</p>\n\
<h2 id=\"sdk-requirements\">SDK Requirements</h2><p>3ds Max 2024 is built with Microsoft Visual Studio 2019, version 16.10.4, C++ Platform Toolset v142, and Windows Platform SDK 10.0.19041.0. For compatibility reasons, we recommend that plugins for 3ds Max 2024 are built with the same version of the compiler, toolset and platform SDK as 3ds Max 2024 itself.</p>\n\
<p>With 3ds Max 2024, we have updated to C++17 from C++14.  We recommend that plugins do the same.  See the section below on upgrading to C++17.</p>\n\
<p>We have also enabled some compiler switches to enforce C++ standard conformance in our code. See the section below on C++ standard conformance.</p>\n\
<p>Note that installers for other versions of Visual Studio 2019 are available.</p>\n\
<h2 id=\"qt-version-and-pyside2\">Qt version and PySide2</h2><p>3ds Max 2024 is built with Qt 5.15.1 and PySide2 5.15.1</p>\n\
<h2 id=\"python-version\">Python version</h2><p>3ds Max 2024 ships with Python 3.10.8</p>\n\
<h2 id=\"-net-version\">.NET version</h2><p>3ds Max 2024 is targeting the .NET 4.8 Framework and run-time.</p>\n\
<h2 id=\"c-version\">C++ version</h2><p>3ds Max 2024 is built with the C++17 language standard.</p>\n\
<p>Plugins can still be compiled with C++14, as long as the required compiler version is used. However, we do not guarantee that all SDK headers can be used with C++14. Some recent additions to some SDK headers require features from C++17.</p>\n\
<p>Some standard library features were deprecated and/or removed in C++17. It is likely that new warnings and errors will pop up when upgrading. Here are some issues we faced and how we fixed them:</p>\n\
<ul>\n\
<li>error C2872: &#39;byte&#39;: ambiguous symbol (and other ambiguous symbols). There is an ambiguity between typedef byte in Windows headers and std::byte introduced in C++17 in header <cstddef>.<ul>\n\
<li>Solution: Remove using namespace std;</li>\n\
<li>See <a href=\"https://en.cppreference.com/w/cpp/types/byte\" target=\"_blank\">https://en.cppreference.com/w/cpp/types/byte</a></li>\n\
</ul>\n\
</li>\n\
<li>Deprecation warning for <codecvt> header<ul>\n\
<li>Solution: Define macro _SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING before including any standard header to silence warning</li>\n\
<li>See <a href=\"https://devblogs.microsoft.com/cppblog/c17-feature-removals-and-deprecations/\" target=\"_blank\">https://devblogs.microsoft.com/cppblog/c17-feature-removals-and-deprecations/</a></li>\n\
</ul>\n\
</li>\n\
<li>Error because of removed old function binders, like std::binary_function and std::unary_function<ul>\n\
<li>Solution: Remove these classes completely. Use lambdas instead if needed.</li>\n\
<li>See <a href=\"https://en.cppreference.com/w/cpp/utility/functional#Old_binders_and_adaptors\" target=\"_blank\">https://en.cppreference.com/w/cpp/utility/functional#Old_binders_and_adaptors</a></li>\n\
</ul>\n\
</li>\n\
<li>Error because of removed std::auto_ptr.<ul>\n\
<li>Solution Use std::unique_ptr instead.</li>\n\
<li>See <a href=\"https://en.cppreference.com/w/cpp/memory/auto_ptr\" target=\"_blank\">https://en.cppreference.com/w/cpp/memory/auto_ptr</a></li>\n\
</ul>\n\
</li>\n\
<li>Error because of removed std::random_shuffle<ul>\n\
<li>Solution: Use std::shuffle with a custom URNG. See implementation of std::random_shuffle in Microsoft headers for inspiration.</li>\n\
<li>See <a href=\"https://en.cppreference.com/w/cpp/algorithm/random_shuffle\" target=\"_blank\">https://en.cppreference.com/w/cpp/algorithm/random_shuffle</a></li>\n\
</ul>\n\
</li>\n\
<li>Warning because of non-standard throw specification<ul>\n\
<li>Solution: Remove throw(type) and throw(…). Replace throw() with noexcept</li>\n\
<li>See<ul>\n\
<li><a href=\"https://en.cppreference.com/w/cpp/language/except_spec\" target=\"_blank\">https://en.cppreference.com/w/cpp/language/except_spec</a></li>\n\
<li><a href=\"https://en.cppreference.com/w/cpp/language/noexcept_spec\" target=\"_blank\">https://en.cppreference.com/w/cpp/language/noexcept_spec</a></li>\n\
<li><a href=\"https://docs.microsoft.com/en-us/cpp/cpp/exception-specifications-throw-cpp?view=msvc-160\" target=\"_blank\">https://docs.microsoft.com/en-us/cpp/cpp/exception-specifications-throw-cpp?view=msvc-160</a></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
</li>\n\
<li>Errors because of auto and register keywords<ul>\n\
<li>Solution: Remove auto and register keywords</li>\n\
<li>See <a href=\"https://en.cppreference.com/w/cpp/language/storage_duration\" target=\"_blank\">https://en.cppreference.com/w/cpp/language/storage_duration</a></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<p>For a more complete list of changes in C++17, see <a href=\"https://en.cppreference.com/w/cpp/17\" target=\"_blank\">https://en.cppreference.com/w/cpp/17</a></p>\n\
<h2 id=\"c-standard-conformance\">C++ standard conformance</h2><p>There are many C++ code constructs historically accepted by MSVC that are not officially valid C++ code according to the C++ standard. This code works fine when compiling with Visual Studio, but it is sometimes an obstacle to using other modern development tools that expect standard conformant code only. MSVC provides a compiler switch to prevent compilation of all this non-conformant code: <code>/permissive-</code>.\n\
See: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/permissive-standards-conformance?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/permissive-standards-conformance?view=msvc-170</a></p>\n\
<p>The goal is to eventually enable <code>/permissive-</code> in 3ds Max to ensure our code is fully conformant. There is no official timeframe for this goal at this point. Consider enabling this switch already when compiling your plugins to get a head start.\n\
For an application as large as 3ds Max, this represents a massive effort. Luckily, MSVC provides many other compiler switches to gradually enable standard conformance instead of enabling everything at once.</p>\n\
<p>Here are the compiler switches that were enabled in 3ds Max 2024:</p>\n\
<ul>\n\
<li><code>/Zc:strictStrings</code><ul>\n\
<li>Prevent assigning string literal to non-const pointer.</li>\n\
<li>Example: TCHAR* str = _T(&quot;hello&quot;); will no longer compile because str is not const.</li>\n\
<li>Mitigations: Add const wherever possible. Otherwise, use const_cast</li>\n\
<li>See: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-strictstrings-disable-string-literal-type-conversion?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-strictstrings-disable-string-literal-type-conversion?view=msvc-170</a></li>\n\
</ul>\n\
</li>\n\
<li><code>/Zc:externC</code><ul>\n\
<li>Prevent using extern &quot;C&quot; on functions that aren&#39;t compatible with C language</li>\n\
<li>See: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-externc?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-externc?view=msvc-170</a></li>\n\
</ul>\n\
</li>\n\
<li><code>/Zc:inline</code><ul>\n\
<li>Ensure that all functions marked as inline are defined in the current cpp file.</li>\n\
<li>See: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-inline-remove-unreferenced-comdat?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-inline-remove-unreferenced-comdat?view=msvc-170</a></li>\n\
</ul>\n\
</li>\n\
<li><code>/Zc:lambda</code><ul>\n\
<li>Add some restrictions to lambda definitions</li>\n\
<li>See: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-lambda?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-lambda?view=msvc-170</a></li>\n\
</ul>\n\
</li>\n\
<li><code>/Zc:rvalueCast</code><ul>\n\
<li>Ensure the result of c-style casts is considered as a temporary (rvalue).</li>\n\
<li>Example: int i; std::cin &gt;&gt; (int)i; won&#39;t compile, because std::cin can&#39;t write to a temporary.</li>\n\
<li>Mitigation: Remove c-style casts</li>\n\
<li><a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-rvaluecast-enforce-type-conversion-rules?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-rvaluecast-enforce-type-conversion-rules?view=msvc-170</a></li>\n\
</ul>\n\
</li>\n\
<li>Treat warning C4596 as error<ul>\n\
<li>Prevent using class name inside class definition</li>\n\
<li>Example: class Thing { void Thing::my_func(); }; won&#39;t compile.</li>\n\
<li>Solution: Remove Thing:: from inside class definition</li>\n\
<li>See: <a href=\"https://learn.microsoft.com/en-us/cpp/error-messages/compiler-warnings/c4596?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/error-messages/compiler-warnings/c4596?view=msvc-170</a>\n\
Note: You can disable these switches by adding &quot;-&quot; in your property sheets. For example: <code>/Zc:strictStrings-</code>. This is not recommended.</li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<p>Here are the switches that are being considered for a future version of 3ds Max (not yet confirmed):</p>\n\
<ul>\n\
<li><code>/Zc:hiddenFriend</code>: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-hiddenfriend?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-hiddenfriend?view=msvc-170</a></li>\n\
<li><code>/Zc:referenceBinding</code>: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-referencebinding-enforce-reference-binding-rules?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-referencebinding-enforce-reference-binding-rules?view=msvc-170</a></li>\n\
<li><code>/Zc:ternary</code>: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-ternary?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-ternary?view=msvc-170</a></li>\n\
<li><code>/Zc:static_assert</code>: <a href=\"https://learn.microsoft.com/en-us/cpp/build/reference/zc-static-assert?view=msvc-170\" target=\"_blank\">https://learn.microsoft.com/en-us/cpp/build/reference/zc-static-assert?view=msvc-170</a></li>\n\
</ul>\n\
<h2 id=\"removal-of-min-and-max-macros\">Removal of min and max Macros</h2><p>In this release, the Windows <code>min</code> and <code>max</code> macros are disabled to improve compile speeds and reduce errors. A preprocessor definition <code>NOMINMAX</code> has been defined across the SDK. To avoid getting build errors related to min and max macros, consider defining <code>NOMINMAX</code> in your codebase. Alternatively, you can #undef min and #undef max.</p>\n\
<p>To replace usage of min and max macros, consider using <code>std::min</code> and <code>std::max</code>\n\
Alternatively, consider using <code>&lt;maxsdk/include/Util/minmax.h&gt;</code> if T1 and T2 are different.</p>\n\
<p>To fix errors in header <code>&lt;gdiplus.h&gt;</code>, include <code>&lt;maxsdk/include/Util/safegdiplus.h&gt;</code> instead.</p>\n\
<h2 id=\"color-management-api\">Color Management API</h2><p>Up until version 2024, 3ds Max has provided only basic color management capability through the process known as de-gamma/re-gamma linear workflow where sRGB color primaries were assumed throughout the system, including the input textures, output images and display devices. In 3ds Max 2024 we are introducing a modern color management capability and concepts using the industry standard OpenColorIO (OCIO) library. Although there have been some major changes in the 3ds Max codebase to make it possible to integrate OCIO library and to add modern color management concepts, we have tried our best to keep the impact minimal for the end users and the 3rd party developers. The existing gamma-based color management mode is still available to users and should behave as before. Similarly, the API that exposes the fundamental gamma-based color management workflows were mostly retained, but we have deprecated or removed some entry points and functionality which were clashing with the modern color management concepts. The majority of plugins will require no or trivial changes to work as before in the gamma mode.</p>\n\
<p>Although GammaMgr and IColorCorrectionMgr classes are retained for backward compatibility as described above, those classes are streamlined and will only work in the gamma mode. We&#39;re planning to phase out these gamma-only classes in time, therefore, we suggest 3rd party developers start using the new color management API that supersedes GammaMgr and IColorCorrectionMgr by supporting all color management modes, including the unmanaged and gamma modes.</p>\n\
<p>Although there are changes in various places, the central pieces of the new API are defined under the MaxSDK::ColorManagement namespace and are located in the <em>maxsdk/include/ColorManagement</em> subfolder. The main management class is IColorPipelineMgr. Please check the developer guide and header files for detailed information.</p>\n\
<p>The new ColorConverter is included as a sample project in the SDK under <code>maxsdk\\samples\\ColorManagement\\ColorConverter</code>, and illustrates the use of the new ColorManagement API.</p>\n\
<h2 id=\"mesh-mnmesh-and-beziershape-api-changes\">Mesh, MNMesh, and bezierShape API Changes</h2><p>The <code>Mesh</code> and <code>MNMesh</code> classes have been refactored to have internal data organized into channel objects. This provides improved stack performance, stability and a lot of code cleanup and modernization. The goal was no functional change to these meshes and minimal API changes to avoid ifdefs.</p>\n\
<p><code>Mesh</code> -&gt; <code>MeshTopoChannelData</code>, <code>MeshGeomChannelData</code>, <code>MeshVertexColorChannelData</code>, <code>MeshTextureMapChannelData</code>, <code>MeshEdgeVisibilityChannelData</code>, <code>MeshMaterialChannelData</code></p>\n\
<p><code>MNMesh</code> -&gt; <code>MNTopoChannelData</code>, <code>MNGeomChannelData</code>, <code>MNVertexColorChannelData</code>, <code>MNTextureMapChannelData</code></p>\n\
<h3 id=\"important-new-sdk-headers\">Important New SDK headers</h3><ul>\n\
<li><code>MeshChannelContainer.h</code> and<code>MNChannelContainer.h</code>, container for the channel objects for Mesh and MNMesh</li>\n\
<li><code>MeshChannelData.h</code> and <code>MNChannelData.h</code>, declarations of the new channel objects for Mesh and MNMesh</li>\n\
</ul>\n\
<p>The public mesh members of <code>Mesh</code> and <code>MNMesh</code> that are not owned by channel objects have been either replaced by getter/setter or wrapped with &quot;BlockWrite&quot; objects. The purpose of these is to block the ability to write to these members directly because it isn&#39;t Mesh that owns the data, they are simply mirrors. This should not be too disruptive.</p>\n\
<p>For example, you can access <code>mesh-&gt;faces[f]</code> and alter the faces but you cannot write to the faces member itself.  If you want to do this, you still can but it&#39;s not adviced. See documentation for <code>Mesh::GetChannelDataContainer()</code> and <code>MNMesh::GetChannelDataContainer()</code> in the API Reference.</p>\n\
<h3 id=\"mesh\">Mesh</h3><p>Change highlights:</p>\n\
<ul>\n\
<li>Deprecated public members that have been replaced with getter/setters: <code>vdSupport</code>, <code>vData</code>, <code>vertSel</code>, <code>faceSel</code>, <code>edgeSel</code>, <code>vertHide</code>, <code>mtlIndex</code>, <code>numMaps</code>, <code>maps</code></li>\n\
<li>With the exception of the per vertex data members, you should be able to update your code to use existing public methods to access the data you are after.</li>\n\
<li>Meshes <code>SELECT_CHANNEL</code> has been removed. The data that was in it has been moved into topo and geom channels respectively. This fixed issues related to face / vert counts changing and getting out of sync with selection BitBrrays.</li>\n\
<li>Modified the handling of the MeshMap flags. Previously there were some cases with the stack operations where the flags were not properly cleared. Ex:<code>mesh.FreeChannels(TEXMAP_CHANNEL)</code> would not clear the map flags.</li>\n\
</ul>\n\
<h3 id=\"mnmesh\">MNMesh</h3><p>Change highlights:</p>\n\
<ul>\n\
<li>Deprecated public members that have been replaced with getter/setter: <code>m</code>, <code>numm</code>, <code>ed</code>, <code>edSupport</code>, <code>vd</code>, <code>vdSupport</code></li>\n\
<li>The concept of allocated maps versus used maps has been removed, there is just used maps now. <code>MAlloc</code> and <code>MShrink</code> have been deprecated.</li>\n\
<li><code>MNMesh</code> no longer inherits from <code>FlagUser</code>. This is because some of the flags in there are now owned by the topo channel. Appropriate methods have been added to <code>MNMesh</code> so no code change should be required.</li>\n\
</ul>\n\
<h2 id=\"better-qt-ui-binding-control-for-params\">Better Qt UI Binding Control for Params</h2><p>New methods have been introduced to provide manual Qt UI binding with params, which is useful for dealing with dynamic data, such as tab-type params with <code>P_VARIABLE_SIZE</code>.  The new methods are:</p>\n\
<ul>\n\
<li><code>QMaxParamBlockWidget::PreConnectUI([[maybe_unused]] const MapID paramMapID)</code></li>\n\
<li><code>QMaxParamBlockWidget::PostConnectUI([[maybe_unused]] const MapID paramMapID)</code></li>\n\
<li><code>IParamMap2::ConnectUI(MaxSDK::QMaxParamBlockWidget* widget)</code></li>\n\
<li><code>IParamMap2::ConnectUI(ParamID id, QObject* uiControl, int tabIndex = 0)</code></li>\n\
<li><code>IParamMap2::DisconnectUI()</code></li>\n\
<li><code>IParamMap2::DisconnectUI(QObject* uiControl)</code></li>\n\
</ul>\n\
<p>The <code>PostConnectUI()</code> is a callback that can be registered for a ParamMap, and can be used to call the <code>IParamMap2::ConnectUI(ParamID id, QObject* uiControl, int tabIndex = 0)</code> method to manually create a binding.</p>\n\
<p>The <em>maxsdk/howto/UI/qtObjectDemo</em> sample project is updated with a new <code>QtVariableFloatTabRollupWidget</code> to demonstrate how to use this approach to dynamically re-connect to a param with a variable size.</p>\n\
<h2 id=\"openexr-sdk\">OpenEXR SDK</h2><p>The activeshadefragment (<em>maxsdk\\samples\\render\\activeshadefragment</em>) sample plugin requires OpenEXR to compile. OpenEXR 2.5.3 is required. This can be downloaded at: <a href=\"https://github.com/AcademySoftwareFoundation/openexr\" target=\"_blank\">https://github.com/AcademySoftwareFoundation/openexr</a></p>\n\
<h2 id=\"volumeobject-classes\">VolumeObject Classes</h2><p>Two new classes have been added to support volume rendering, and provide access to OpenVDB grids.  Note that these classes are a work in progress, and are not intended for production use.  They are:</p>\n\
<ul>\n\
<li><code>ArnoldMaxVolumeInterfaceObject</code>  (in <em>include/ArnoldMaxVolumeInterface.h</em>)</li>\n\
<li><code>MaxVolumeInterfaceObject</code> (in <em>include/MaxVolumeInterface.h</em>)</li>\n\
</ul>\n\
<h2 id=\"deprecated-items\">Deprecated Items</h2><p>These items have been deprecated in the 3ds Max 2024 SDK.  See the <em>3ds Max SDK C++ API Reference</em> for a complete list that includes items deprecated in previous releases.</p>\n\
<p><code>Member BitmapIO::__declspec (deprecated) virtual void EvalMatch(MCHAR *matchString) final</code>\n\
This has been deprecated as of 3ds Max 2024, please use MSTR&amp; overload instead</p>\n\
<p><code>Member BitmapStorage::__declspec (deprecated) static MCHAR *evalString</code>\n\
This has been deprecated as of 3ds Max 2024, please use m_evalString instead</p>\n\
<p><code>Member bmmHistoryList::__declspec (deprecated) static MCHAR title[MAX_PATH]</code>\n\
This has been deprecated as of 3ds Max 2024, please use m_title instead</p>\n\
<p><code>Member bmmHistoryList::__declspec (deprecated) static MCHAR initDir[MAX_PATH]</code>\n\
This has been deprecated as of 3ds Max 2024, please use m_initDir instead</p>\n\
<p><code>Member FILE_SUPPORT_MERGE</code>\n\
Deprecated as of 3ds Max 2024. Unsupported for many versions.</p>\n\
<p><code>Class IColorCorrectionMgr</code>\n\
This class is deprecated. Please use IColorPipelineMgr which provides better color management functionality.</p>\n\
<p><code>Member MaxSDK::Util::__declspec (deprecated) StaticAssert</code>\n\
This has been deprecated in 3ds Max 2024, please use builtin <code>static_assert(b, &quot;msg&quot;)</code> instead</p>\n\
<p><code>Member ReferenceTarget::__declspec (deprecated) virtual void RefDeleted() final</code>\n\
Deprecated method in terms of implementation as of 3ds Max 2024 - re-implement with ReferenceMaker* method signature</p>\n\
<p><code>Member ReferenceTarget::__declspec (deprecated) virtual void RefDeletedUndoRedo() final</code>\n\
Deprecated method in terms of implementation as of 3ds Max 2024 - re-implement with ReferenceMaker* method signature</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../what_s_new.html\">What&#x27;s New</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";