var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"custom_plug-in_creation_processe\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Custom Plug-in Creation Processes</h1></div><p>Two methods of the plug-in&apos;s class descriptor <code>ClassDesc::BeginCreate()</code> and <code>ClassDesc::EndCreate()</code>, allow the plug-in to customize the process of creation. When the system is about to create a plug-in object <code>ClassDesc::BeginCreate()</code> is called. The default implementation of this method returns 0, which tells the system to use the default process. If the plug-in does require a custom creation phase, it does so in its implementation of this method. When it is finished it returns nonzero to indicate it does not want the default process invoked.</p>\n\
<p>The target camera is an example of a plug-in that must handle its own creation process. The system-managed creation procedure using <code>BaseObject::GetCreateMouseCallBack()</code> is not adequate to meet the needs of this plug-in. This is because it creates two nodes in the scene: the camera and the target. It also must link the camera to the target using a lookat controller that ensures the camera is always &apos;looking at&apos; the target.</p>\n\
<p>The creation process can be terminated by calling the method <code>Interface::StopCreating()</code>. This will tell the system to call <code>ClassDesc::EndCreate()</code>.</p>\n\
<p>Note that <code>GetCreateMouseCallback()</code> is pure virtual. Therefore plug-ins derived from BaseObject that use <code>ClassDesc::BeginCreate()</code> must still provide a NULL implementation of this method, for example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">CreateMouseCallBack* BaseObject::GetCreateMouseCallBack() { return NULL; }\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced_plug-in_topics.html\">Advanced Plug-in Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";