var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plug-in_configuration_system\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plug-in Configuration System</h1></div><p>Developers often need to store configuration files for use with their plugin applications. There is a standard location defined for these files. This allows a 3ds Max user to have all their configuration files stored together and not spread around different hard-to-find locations.</p>\n\
<p>The standard location is the <code>PlugCFG</code> directory off the 3ds Max root directory. This location may be changed by a user using the <em>Files &gt; Configure Paths</em> menu command. The developer should retrieve the location of this directory using the <code>GetDir</code>(<code>APP_PLUGCFG_DIR</code>) method of the <code>BitmapManager</code> class or the <code>Interface</code> class.</p>\n\
<p>The following samples code from  <em>\\MAXSDK\\SAMPLES\\RETIRED\\WSD\\WSD.CPP</em>  demonstrates one approach a developer may use to read and write configuration files:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#defineWSDCONFIGNAME_T(&quot;wsd.ini&quot;)\n\
#defineWSDSECTION   _T(&quot; Default State&quot;)\n\
#defineWSDHOSTKEY   _T(&quot;Hostname&quot;)\n\
#defineWSDSYSKEY    _T(&quot;System&quot;)\n\
#defineWSDDEFAULT   _T(&quot;accom&quot;)\n\
#defineWSDDEFSYS    _T(&quot;ntsc&quot;)\n\
\n\
// GetCfgFilename()\n\
voidBitmapIO_WSD::GetCfgFilename( TCHAR *filename )\n\
{\n\
\n\
   _tcscpy( filename, TheManager-&gt;GetDir(APP_PLUGCFG_DIR));\n\
\n\
   intlen = _tcslen(filename);\n\
   if (len)\n\
   {\n\
     if(_tcscmp(&amp;filename[len-1,_T(&quot;\\\\&quot;)))\n\
      _tcscat(filename,_T(&quot;\\\\&quot;));\n\
   }\n\
   _tcscat(filename,WSDCONFIGNAME);\n\
\n\
}</code></pre><div class=\"note note:\"><span class=\"notetitle\">Note:</span> The <code>GetPrivateProfileString</code> function retrieves a string from the specified section in an initialization file. This function is part of the Windows API. See the Windows API on-line help for more details.</div>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// ReadCfg()\n\
intBitmapIO_WSD::ReadCfg()\n\
{\n\
   TCHARfilename[MAX_PATH;\n\
   TCHARsystem[64;\n\
   GetCfgFilename(filename);\n\
   intres = GetPrivateProfileString(\n\
     WSDSECTION,\n\
     WSDHOSTKEY,\n\
     WSDDEFAULT,\n\
     hostname,\n\
     MAX_PATH,\n\
     filename);\n\
   if (res)\n\
   {\n\
     GetPrivateProfileString(\n\
      WSDSECTION,\n\
      WSDSYSKEY,\n\
      WSDDEFSYS,\n\
      system,\n\
      64,\n\
      filename);\n\
   }\n\
   else\n\
   {\n\
     _tcscpy(system,WSDDEFSYS);\n\
   }\n\
\n\
   if (!_tcscmp(system,WSDDEFSYS))\n\
   {\n\
     ntsc = TRUE;\n\
     height = 486;\n\
   }\n\
   else\n\
   {\n\
     ntsc = FALSE;\n\
     height = 576;\n\
   }\n\
   return (res);\n\
}</code></pre><div class=\"note note:\"><span class=\"notetitle\">Note:</span> The <code>WritePrivateProfileString</code> function copies a string into the specified section of the specified initialization file. This function is part of the Windows API. See Windows API on-line help for more details.</div>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// WriteCfg()\n\
voidBitmapIO_WSD::WriteCfg()\n\
{\n\
   TCHARfilename[MAX_PATH;\n\
   TCHARsystem[64;\n\
   if (ntsc)\n\
     _tcscpy(system,WSDDEFSYS);\n\
   else\n\
     _tcscpy(system,_T(&quot;pal&quot;));\n\
\n\
   GetCfgFilename(filename);\n\
   WritePrivateProfileString(WSDSECTION,WSDHOSTKEY,hostname,filenam);\n\
   WritePrivateProfileString(WSDSECTION,WSDSYSKEY,system,filename);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced_plug-in_topics.html\">Advanced Plug-in Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";