var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"registry_key_structure\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Registry Key Structure</h1></div><p>The following chain of Registry keys establishes the base for all plug-in descriptions:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">HKEY_CURRENT_USER\\SOFTWARE\\Autodesk\\3dsMax\\&lt;VersionNumber&gt;\\Plugins\\Discreet</code></pre><p>Under the &apos;Plugins&apos; key, there can be one key for each supplier of plug-ins; for the internal 3ds Max plug-ins, this key is &apos;Discreet&apos;. Under the key for a supplier there will be one key per deferrable plug-in, with a name that is distinct from all other plug-in key names from that supplier.</p>\n\
<p>This &apos;plug-in key&apos; has certain mandatory values, and under it there will be one key per 3ds Max class implemented by the plug-in. The name of each class key must be distinct, at least within the given plug-in. Each such &apos;class key&apos; has a set of values, describing certain important properties of the class.</p>\n\
<h2 id=\"example\">Example</h2><p>The following is an example from the VRML plug-in for 3ds Max:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Name</td>\n\
<td>Type</td>\n\
<td>Data</td>\n\
</tr>\n\
<tr>\n\
<td>DLLFile</td>\n\
<td>REG_SZ</td>\n\
<td>vrmlimp.dli</td>\n\
</tr>\n\
<tr>\n\
<td>LibDescription</td>\n\
<td>REG_SZ</td>\n\
<td>VRML Scene Importer (Discreet)</td>\n\
</tr>\n\
<tr>\n\
<td>LibVersion</td>\n\
<td>REG_DWORD</td>\n\
<td>0x1f401100 (524292352)</td>\n\
</tr>\n\
<tr>\n\
<td>TimeStampHigh</td>\n\
<td>REG_DWORD</td>\n\
<td>0x01c6203e (29761598)</td>\n\
</tr>\n\
<tr>\n\
<td>TimeStampLow</td>\n\
<td>REG_DWORD</td>\n\
<td>0x63bc8c00 (1673300992)</td>\n\
</tr>\n\
</tbody></table>\n\
<p>Notes: The <code>DLLFile</code> value gives the name of the DLL file that this key describes; case is disregarded. The name must be unique, and must not match two different files, even if they are in different directories.</p>\n\
<p>Class Key Values</p>\n\
<p><img src=\"./images/GUID-13B0E14B-A8DC-4E38-BFB2-E8F296204151-low.jpg\" alt></p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Name</td>\n\
<td>Type</td>\n\
<td>Data</td>\n\
</tr>\n\
<tr>\n\
<td>Category</td>\n\
<td>REG_SZ</td>\n\
<td></td>\n\
</tr>\n\
<tr>\n\
<td>ClassIDA</td>\n\
<td>REG_DWORD</td>\n\
<td>0x35da0f0a (903483146)</td>\n\
</tr>\n\
<tr>\n\
<td>ClassIDB</td>\n\
<td>REG_DWORD</td>\n\
<td>0x10ce4af8 (281955064)</td>\n\
</tr>\n\
<tr>\n\
<td>ClassName</td>\n\
<td>REG_SZ</td>\n\
<td>VrmlImp</td>\n\
</tr>\n\
<tr>\n\
<td>Ext</td>\n\
<td>REG_SZ</td>\n\
<td>WRL;WRZ</td>\n\
</tr>\n\
<tr>\n\
<td>ExtCount</td>\n\
<td>REG_DWORD</td>\n\
<td>0x00000002 (2)</td>\n\
</tr>\n\
<tr>\n\
<td>IsPublic</td>\n\
<td>REG_DWORD</td>\n\
<td>0x00000001 (1)</td>\n\
</tr>\n\
<tr>\n\
<td>OKToCreate</td>\n\
<td>REG_DWORD</td>\n\
<td>0x00000001 (1)</td>\n\
</tr>\n\
<tr>\n\
<td>ShortDesc</td>\n\
<td>REG_SZ</td>\n\
<td>VRML</td>\n\
</tr>\n\
<tr>\n\
<td>SuperClassID</td>\n\
<td>REG_DWORD</td>\n\
<td>0x00000a10 (2576)</td>\n\
</tr>\n\
</tbody></table>\n\
<p>Notes: The <code>IsPublic</code> and <code>OKToCreate</code> values should be 0 (no) or 1 (yes). The <code>Ext</code> value consists of upper-case file extensions (without the leading dot); if there are more than one, they are separated by semicolons, with no spaces before or after. The number of extensions given in the Ext value must agree with the ExtCount value. The <code>InternalName</code> value should not be defined if it returns NULL.</p>\n\
<p>The following extra value types are required for different types of plug-ins, listed below:</p>\n\
<table>\n\
<thead>\n\
<tr>\n\
<th></th>\n\
<th></th>\n\
<th></th>\n\
<th></th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Value</td>\n\
<td>Type</td>\n\
<td>Data</td>\n\
<td>Required for:</td>\n\
</tr>\n\
<tr>\n\
<td>SupportsOptions</td>\n\
<td>REG_DWORD</td>\n\
<td>0</td>\n\
<td>Exporters</td>\n\
</tr>\n\
<tr>\n\
<td>LongDesc</td>\n\
<td>REG_SZ</td>\n\
<td>BMP</td>\n\
<td>Image File Bitmap loaders</td>\n\
</tr>\n\
<tr>\n\
<td>Capability</td>\n\
<td>REG_DWORD</td>\n\
<td>0</td>\n\
<td>Bitmap loaders</td>\n\
</tr>\n\
<tr>\n\
<td>InputTypeA</td>\n\
<td>REG_DWORD</td>\n\
<td>0x10</td>\n\
<td>Modifiers</td>\n\
</tr>\n\
<tr>\n\
<td>InputTypeB</td>\n\
<td>REG_DWORD</td>\n\
<td>0x00</td>\n\
<td>Modifiers</td>\n\
</tr>\n\
<tr>\n\
<td>InternalName</td>\n\
<td>REG_SZ</td>\n\
<td>BitmapTex</td>\n\
<td>All plug-ins using ParamBlock2/ClassDesc2</td>\n\
</tr>\n\
<tr>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
</tr>\n\
<tr>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
</tr>\n\
<tr>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
</tr>\n\
<tr>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
<td></td>\n\
</tr>\n\
</tbody></table>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../advanced_plug-in_topics.html\">Advanced Plug-in Topics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";