var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"dialog_and_window_procedures\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Dialog and Window Procedures</h1></div><p>A windows procedure must have the following signature:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">LRESULT CALLBACK MyWndProc(HWND, UINT, WPARAM, LPARAM);</code></pre><p>A dialog procedure must have the following signature:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">INT_PTR CALLBACK MyDlgProc(HWND, UINT, WPARAM, LPARAM);</code></pre><p>If you need to cast your windows or dialog procedure then you should double-check the signature. If it is correct, there should be no need to cast unless you are attempting to put it into a <code>LONG_PTR</code>.</p>\n\
<p>In x64, <code>INT_PTR</code> and <code>LRESULT</code> are essentially the same; but in <em>Win32</em> with <code>/Wp64</code>, they are treated differently.</p>\n\
<p>Along the same lines as <code>DLSetWindowLongPtr</code> and <code>GetWindowLongPtr</code> (in <code>maxsdk</code>\\include\\3dsmaxport.h), there are also <code>DLGetWindowProc</code> and <code>SetWindowProc</code>. <code>DLGetWindowLongPtr</code> and <code>SetWindowLongPtr</code> also have overloaded versions that will accept a <code>WNDPROC</code> properly. If you want to put a <code>WNDPROC</code> into <code>GWLP_USERDATA</code>, you can explicitly specify it, otherwise it is routed to <code>GWLP_WNDPROC</code>.</p>\n\
<p>In versions of 3ds Max previous to version 9 there were cases where windows procedures return <code>INT_PTR</code> instead of <code>LRESULT</code>, and these were being routed quietly to <code>GWLP_USERDATA</code> in <em>Win32</em> builds. This changed the pointer to <code>MyClass</code>* with a pointer to a function which is undesirable. Since 3ds Max there is an overloaded version which accepts this signature and routes it to <code>GWLP_WNDPROC</code> as well.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../upgrading_to_64-bit.html\">Upgrading to 64-Bit</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";