var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"specifying_the_output_file\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Specifying the Output File</h1></div><p>You now need to specify the output file name. The output file path consists of three parts: the directory path, the filename and the extension. Starting with Visual Studio 2010, the file path specified in the <em>Linker &gt; General &gt; Output Directory</em> property needs to match the paths specified under <em>Configuration &gt; General</em>. That means the directory portion of the output path must match the <em>Configuration &gt; General &gt; Output Directory</em> property. Also the filename portion of the output path must match the <em>Configuration &gt; General &gt; Target Name</em> property. And the file extension part of the output path must match the <em>Configuration &gt; General &gt;Target Extension</em> property. If the paths do not match, the compiler will emit a long verbose warning. Therefore the easiest and best way to specify the output path is to specify the three separate elements of the output path under <em>Configuration &gt; General</em>. For example:</p>\n\
<ol>\n\
<li>Open the Project Property Pages dialog (e.g. from the menu under Project &gt; Properties ...)</li>\n\
<li>Choose <em>All Configurations</em> from the <em>Configuration:</em> drop-down list at the top of the dialog.</li>\n\
<li>From the tree-control in the left pane choose the <em>Configuration Properties</em> <em>&gt; General</em> folder.</li>\n\
<li>For the <em>Output Directory</em> property, specify the path to where you want the file to be built.</li>\n\
<li>For the <em>Intermediate Directory</em> property, It is usually best to specify <em>obj\\$(Platform)\\$(Configuration)</em>. That way the intermediate files for different build configurations do not overwrite each other. This will also allow you to quickly and easily delete any intermdiate files after the build is cleaned up.</li>\n\
<li>For the <em>Target Name</em> property specify the name of the file.</li>\n\
<li>For the <em>Target Extension</em> property specify the file extension of the file.</li>\n\
<li>From the tree-control in the left pane chose the <em>Linker &gt; General</em> folder.</li>\n\
<li>For the <em>Output File</em> property specify <em>$(OutDir)$(TargetName)$(TargetExt)</em>. This will take the values you entered in earlier and combine them to form the output path.</li>\n\
</ol>\n\
<p>When the project is compiled and linked successfully, the DLL is written to this location.</p>\n\
<p>The example output file used (myplugin.dlo) uses the extension typically used by object plug-ins. For a list of the standard filename extensions for all plug-ins see the topic <a href=\"plug-in_file_extensions.html\"\">Plug-in File Extensions</a>. 3ds Max will only load DLLs that use these standard extensions.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../manually_creating_a_new_plug-in_.html\">Manually Creating a New Plug-in Project</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";