var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"installing_the_plug-in_wizard\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Installing the Plug-in Wizard (AppWizard)</h1></div><p>The 3ds Max Plug-in Wizard (commonly called the AppWizard) is an add-in for Visual Studio that builds skeleton plug-ins for 3ds Max. You simply have to specify what plug-in type you would like to build, and follow the directions in the wizard. The wizard generates the Visual Studio project files, the CPP files, and skeleton code with &quot;TODO&quot; comments.</p>\n\
<h2 id=\"wizard-prerequisites\">Wizard Prerequisites</h2><p>Your Visual Studio installation must include the &quot;Visual C++ ATL for x86 and x64&quot; component and the &quot;Visual C++ MFC for x86 and x64&quot; component. You can verify that these components are installed by launching the Visual Studio Installer and selecting <em>More &gt; Modify</em>, which will show you the details of your installation.</p>\n\
<p>Additionally, if you plan to use the wizard to create plugins with Qt-based UIs, you will need to have Qt and the Qt Visual Studio Tools installed, and you will need to define a default Qt version in Visual Studio by navigating to <em>Qt VS Tools &gt; Qt Options</em>.</p>\n\
<p>For more information about the specific versions of Visual Studio and Qt required, see <a href=\"./../../../about_the_3ds_max_sdk/sdk_requirements.html\">SDK Requirements</a> .</p>\n\
<h2 id=\"wizard-installation\">Wizard Installation</h2><p>Open the  <em>3dsMaxPluginWizard.vsz</em>  file (in the  <em>maxsdk\\howto\\3dsmaxPluginWizard</em>  directory root) in a text editor and edit the ABSOLUTE PATH parameter to reflect the new location of the 3dsmaxPluginWizard root directory. Do not add a backslash after the directory name.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Param=&quot;ABSOLUTE_PATH = [Absolute Path Location of 3dsmaxPluginWizard Root Directory]&quot;</code></pre><p>Also make sure the &quot;Wizard&quot; variable has the correct value based on the version of Visual Studio you are using:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">For Visual Studio 2010 use: Wizard=VsWizard.VsWizardEngine.10.0\n\
For Visual Studio 2012 use: Wizard=VsWizard.VsWizardEngine.11.0\n\
For Visual Studio 2015 use: Wizard=VsWizard.VsWizardEngine.14.0\n\
For Visual Studio 2017 use: Wizard=VsWizard.VsWizardEngine.15.0\n\
For Visual Studio 2019 use: Wizard=VsWizard.VsWizardEngine.16.0</code></pre><p>Once you have completed the previous steps, select the  <em>maxsdk\\howto\\3dsmaxPluginWizard</em>  directory&apos;s properties, and make all the files it contains writeable (clear the &quot;Read Only&quot; checkbox). This prevents Visual Studio from crashing after it creates a PluginWizard project.</p>\n\
<p>Finally, copy the following files from the 3dsmaxPluginWizard root to the &apos;VC\\vcprojects&apos; directory under your Visual Studio installation directory (e.g. for Visual Studio 2015 copy them to C:\\Program Files\\Microsoft Visual Studio 2015\\VC\\vcprojects, for Visual Studio 2017 copy them to C:\\Program Files (x86)\\Microsoft Visual Studio\\2017\\Professional\\Common7\\IDE\\VC\\vcprojects and for Visual Studio 2019 copy them to C:\\Program Files (x86)\\Microsoft Visual Studio\\2019\\Professional\\Common7\\IDE\\VC\\vcprojects):</p>\n\
<ul>\n\
<li>3dsmaxPluginWizard.ico</li>\n\
<li>3dsmaxPluginWizard.vsdir</li>\n\
<li>3dsmaxPluginWizard.vsz</li>\n\
</ul>\n\
<p>If the vcprojects directory doesn&apos;t exist, you will need to create it.</p>\n\
<p>The 3ds Max Plugin Wizard project should appear under <strong>File &gt; New &gt; Project &gt; Visual C++</strong> in Visual Studio 2012 to 2017. In Visual Studio 2019 you will need to go to <strong>File &gt; New &gt; Project</strong> and you will need to select the &quot;All languages&quot;, &quot;All platforms&quot; and &quot;All project types&quot; filters in order to see the 3ds Max Plugin Wizard option.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../using_appwizard_to_create_a_new_.html\">Using AppWizard to Create a New Project</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";