var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"exposing_and_managing_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Exposing and Managing References</h1></div><p>Virtually all plug-ins derive from <code>ReferenceMaker</code>. This allows them to be notified of changes to that certain functions must be implemented. See the topic <a href=\"./../../3ds_max_sdk_features/reference_system.html\">Reference System</a> for more information.</p>\n\
<p>In the case of a plug-in derived from the base class <code>SimpleObject2</code> or <code>SimpleMod2</code> these are implemented automatically for you. In the case of more complex plug-ins such as controllers, you will have to do this manually.</p>\n\
<p>If a plug-in has a parameter block 3ds Max will automatically call <code>ReferenceMaker::SetReference()</code> passing it a pointer to the parameter block.</p>\n\
<p>The following example demonstrates a simple implementation of <code>ReferenceMaker</code> for a plug-in with a single parameter block and no other referenced objects:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">\n\
class MyPlugIn : MyPlugInBase\n\
{\n\
  ParamBlock2* pblock;\n\
\n\
  RefTargetHandle GetReference(int i)\n\
  {\n\
    switch (i)\n\
    {\n\
      case 0:\n\
       return pblock;       \n\
    }\n\
    return NULL;\n\
  }\n\
\n\
  intNumRefs() {\n\
    return 1;\n\
  }\n\
\n\
  voidSetReference(inti, RefTargetHandle rtarg)\n\
  {\n\
     switch (i)\n\
     {\n\
      case 0:\n\
       {\n\
         IParamBlock* tmp = dynamic_cast&lt;IParamBlock2*&gt;(rtarg);\n\
        if (tmp != NULL)\n\
            pblock = tmp;\n\
       }\n\
       break;\n\
     }\n\
  }\n\
\n\
  RefResult NotifyRefChanged(Interval iv, RefTargetHandle hTarg,\n\
    PartID&amp; partID, RefMessage msg)\n\
  {\n\
    return REF_DONTCARE;\n\
  }\n\
};\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-in_basics.html\">Plug-in Basics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";