var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"exposing_parameter_blocks_to_3ds\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Exposing Parameter Blocks to 3ds Max</h1></div><p>If a plug-in uses parameter blocks, and inherits from <code>Animatable</code>, it must expose the parameter blocks to 3ds Max by overriding the following methods of <code>Animatable</code>:</p>\n\
<ul>\n\
<li><code>Animatable::NumParamBlocks()</code> - Returns the number of parameter blocks used by the plug-in. Returns 0 by default.</li>\n\
<li><code>Animatable::GetParamBlock()</code> - Returns the nth parameter block in this instance (or NULL if not available). By default this returns NULL.</li>\n\
<li><code>Animatable::GetParamBlockByID()</code> - Returns a pointer to a <code>ParamBlock2</code> as specified by the ID passed. By default this returns NULL. Note that the ID is not the same as the index.</li>\n\
</ul>\n\
<p>The following example shows a typical implementation for a plug-in with only one parameter block:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class MyPlugin : SimpleObject2\n\
{\n\
  intNumParamBlocks() {\n\
    return 1;\n\
  }\n\
\n\
  IParamBlock2* GetParamBlock(int i)  {\n\
    return i == 0 ? pblock2 : NULL;\n\
  }\n\
\n\
  IParamBlock2* GetParamBlockByID(BlockID id) {\n\
    return (pblock2-&gt;ID() == id) ? pblock2 : NULL;\n\
  }\n\
};</code></pre><p>Note that even if you override these functions, you will still haveto expose a parameter block as a reference. See the topic <a href=\"exposing_and_managing_references.html\"\">Exposing and Managing References</a> for more information.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-in_basics.html\">Plug-in Basics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";