var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"plug-in_identification\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Plug-in Identification</h1></div><p>Each individual plug-in is identified by a Class ID (<code>Class_ID</code>) and the plug-in category is identified by a super class ID (<code>SClass_ID</code>).</p>\n\
<p>In addition to the class descriptor (see the topic <a href=\"class_descriptors.html\"\">Class Descriptors</a>) a plug-in that derives from <code>Animatable</code> (which is true for most plug-ins) must provide implementation of the following functions to identify themselves to 3ds Max.</p>\n\
<ul>\n\
<li><code>Animatable::ClassID()</code> - This method must return a unique <code>Class_ID</code> for the object. If two IDs conflict, the system will only load the first one it finds, therefore all IDs must be unique to ensure they are loaded properly. The program gencid.exe is provided in the 3ds Max SDK to generate these randomly.</li>\n\
<li><code>Animatable::SuperClassID()</code>- This method must return a <code>SClass_ID</code> which is a system defined constant describing the class this plug-in class was derived from.</li>\n\
<li><code>Animatable::GetClassName()</code>- This method must return the name of the plug-in class. This name is usually used internally for debugging purposes. For material plug-ins this method is used to put up the material &quot;type&quot; name in the Material Editor. The default implementation of this method returns <code>\\_M</code>(&quot;<code>Animatable</code>&quot;).</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-in_basics.html\">Plug-in Basics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";