var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"adding_and_deleting_parameters\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Adding and Deleting Parameters</h1></div><p>When adding parameters, new parameter IDs may be added at the end or between other parameters</p>\n\
<p>To deleting parameters they must be first marked using the <code>P_OBSOLETE</code> flag. For example:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">   pb_onOff_OBSOLETE, _T(&quot;onOff_OBSOLETE&quot;),\n\
     TYPE_BOOL_TAB, ONOFF_COUNT, P_OBSOLETE, IDS_ONOFF_OBSOLETE,\n\
     p_end,\n\
</code></pre><p>Obsolete parameters are loaded normally, but after the post-load they are reset to default value, drop any references (which may free objects from memory).</p>\n\
<p>The following tags may be removed from obsolete parameters: <code>p_ui</code>, <code>p_default</code>, <code>p_range</code>, <code>p_accessor</code>, <code>p_validator</code>.</p>\n\
<p>The parameter can only be removed completely, if the plug-in only loads files where the parameter was already marked <code>P_OBSOLETE</code>. Attempting to load files where the parameter exists but was not marked obsolete is unsafe; hence complete removal of a parameter is not supported when you need to load files from multiple versions prior.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_block_versioning.html\">Parameter Block Versioning</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";