var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"changing_parameter_types\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Changing Parameter Types</h1></div><p>Parameter types can be changed by deleting and adding a new parameter. To migrate from the old value a post-load callback must be used. The old parameter ids will be used until after the load and all post-load callbacks are completed</p>\n\
<p>The following example demonstrates how you might do this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">IParamBlock* pBlock;\n\
\n\
class TestClassPLCB\n\
  : public  PostLoadCallback\n\
{\n\
  TestClass* parent;\n\
\n\
public:\n\
\n\
  TestClassPLCB( TestClass* p )\n\
    : parent(p) { }\n\
\n\
  voidproc(ILoad *iload)  {\n\
    parent-&gt;PostLoadCallback(iload);\n\
    delete this;\n\
  }\n\
};\n\
\n\
void TestClass::PostLoadCallback( ILoad* iload )\n\
{\n\
  IParamBlock2PostLoadInfo* postLoadInfo = (IParamBlock2PostLoadInfo*)\n\
    pblock-&gt;GetInterface( IPARAMBLOCK2POSTLOADINFO_ID );\n\
\n\
  // Check for specific obsolete version\n\
  if(postLoadInfo!=NULL &amp;&amp; postLoadInfo-&gt;GetVersion()==OBSOLETE_VERSION)\n\
  {\n\
    // get the original value\n\
    BOOL onOff = pblock-&gt;GetInt(pb_onOff_OBSOLETE, 0, 0);\n\
\n\
    //set the original value\n\
    pblock-&gt;SetValue( pb_onOff, 0, onOff );\n\
\n\
    // see if it has a controller\n\
    Control* onOffCtrl=pblock-&gt;GetController(pb_onOff_OBSOLETE,0);\n\
\n\
    // if a controller exists add it to the new parameter\n\
    if( onOffCtrl )\n\
      pblock-&gt;SetController(pblock-&gt;IDtoIndex(pb_onOff),0,onOffCtrl);\n\
\n\
    // NOTE: not necessary to set obsolete params to NULL,\n\
    // or unlink controllers/references\n\
  }\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../parameter_block_versioning.html\">Parameter Block Versioning</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";