var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"viewport_functionality\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Viewport Functionality</h1></div><p>Many plug-ins (e.g. modifiers and objects) have visual representations in a viewport and must implement a number of functions for displaying themselves in the viewport and interacting with the user.</p>\n\
<h2 id=\"displaying-plug-ins-in-the-viewport\">Displaying Plug-ins in the Viewport</h2><p>A plug-in displays itself in the viewport by overriding the method <code>BaseObject::Display()</code>. In the case of a modifier plug-in, the modifier will draw its gizmo in this method.</p>\n\
<h2 id=\"hit-tests\">Hit Tests</h2><p>Plug-ins with a viewport representation must implement the <code>BaseObject::HitTest()</code> method to indicate if a mouse point passed intersects the entity. Hit testing is used extensively by Max. For example, when the user wants to select a node and clicks the mouse in a viewport, the system calls the <code>HitTest()</code> method of nodes within range of the point picked.</p>\n\
<p>For modifiers the <code>BaseObject::HitTest()</code> method checks to see if the pointer location intersects the gizmo or center mark of the modifier. <code>SimpleMod</code> provides a default implementation (<code>SimpleMod::HitTest()</code>)</p>\n\
<h2 id=\"bounding-boxes\">Bounding Boxes</h2><p>An object or modifier plug-in is expected to implement two methods that return bounding boxes. Bounding boxes are used primarily for fast rejection during hit testing and for computing the extent of an object or modifier gizmos.</p>\n\
<p>The <code>BaseObject::GetLocalBoundBox()</code> method returns the object space bounding box. The system expects that requesting the object space bounding box will be fast, so in most cases an object should cache its bounding box. The object should not, for instance, traverse a long list of vertices calculating minimums and maximums. In the Ripple sample, the cached mesh is used for these bounding box computations.</p>\n\
<p>The <code>BaseObject::GetWorldBoundBox()</code> method returns the world space bounding box. The bounding box returned by this method does not need to be precise. It should, however, be calculated rapidly. The object can handle this by transforming the 8 points of its local bounding box into world space and take the minimums and maximums of the result. Although this isn&#39;t necessarily the tightest bounding box of the object&#39;s points in world space, it is close enough. This box is mainly used for trivial rejection during hit testing and rendering.</p>\n\
<h2 id=\"node-snapping\">Node Snapping</h2><p>Plug-ins that can be selected in the viewport by a mouse, and that wish to support node snapping must implement the <code>BaseObject::Snap()</code> method.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plug-in_basics.html\">Plug-in Basics</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";