var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"packagexml_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
      <script src=\"/cloudhelp/2024/ENU/Max-Developer-Help/scripts/prettify/lang-maxscript.js\"></script>\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Example Plug-in Package</h1></div><p>This example will walk through creating and packaging a simple MAXScript-based plug-in that has assorted assets configured as components in the <em>PackageContents.xml</em> file, using the Autodesk Application Plug-in Package format.</p>\n\
<p>Consider this simple MAXScript macroScript, called <code>new_menu_demo.ms</code>, that creates a menu item with an icon:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-maxscript prettyprint\">-- create a menu w/ an icon\n\
macroScript demo_icon_menu category: &quot;mxs docs&quot; tooltip:&quot;Demo Icon Menu&quot;\n\
IconName:&quot;test1&quot;\n\
(\n\
    helloWorld (&quot;MAXScript Menu&quot;)\n\
)\n\
\n\
-- This contextID is randomly generated with genClassID(), \n\
-- don&apos;t use this one in your own code\n\
-- See the docs for menuMan.registerMenuContext for more info\n\
if menuMan.registerMenuContext 0x93166fc then (\n\
    mainMenu = menuMan.getMainMenuBar()\n\
    myTestMenu = menuMan.createMenu &quot;Demo Menu&quot;\n\
    myTestMenuItem = menuMan.createSubMenuItem &quot;Demo Menu&quot; myTestMenu\n\
    mainMenu.addItem myTestMenuItem -1\n\
    myAction = menuMan.createActionItem &quot;demo_icon_menu&quot; &quot;mxs docs&quot;\n\
    myTestMenu.addItem myAction (myTestMenu.numItems()+1)\n\
    menuMan.updateMenuBar()\n\
)</code></pre>\n\
<p>We can create a the PackageContents.xml file for the above macro script that looks like this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">    &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;\n\
    &lt;ApplicationPackage \n\
        SchemaVersion=&quot;1.0&quot; \n\
        AutodeskProduct=&quot;3ds Max&quot; \n\
        ProductType=&quot;Application&quot; \n\
        Name=&quot;My 3ds Max Plugin&quot;\n\
        AppVersion=&quot;1.0.0&quot;\n\
        ProductCode=&quot;{caedfa12-cf58-4188-a22b-e4cf2e52baa2}&quot; \n\
        UpgradeCode=&quot;{68b04f36-d00b-436e-9386-7337afcffa4a}&quot;&gt;\n\
        &lt;CompanyDetails /&gt;\n\
        &lt;Components Description=&quot;post-start-up scripts parts&quot;&gt;\n\
            &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2018&quot; SeriesMax=&quot;2020&quot; /&gt;\n\
            &lt;ComponentEntry AppName=&quot;DemoMenu&quot; Version=&quot;1.0.0&quot; ModuleName=&quot;./post_startup_scripts/new_menu_demo.ms&quot; /&gt;\n\
        &lt;/Components&gt;\n\
    &lt;/ApplicationPackage&gt;</code></pre>\n\
<p>Here we specify a single component, a &quot;post-start-up script&quot;.  Note that there are two types of start-up script parts.  In this case, we run post start up, after the UI system has initialized, because we need to have menus present.  </p>\n\
<p>Create the following folder and file structure for testing:\n\
C:\\Test\\NewMenuDemo\\PackageContents.xml\n\
C:\\Test\\NewMenuDemo\\post_startup_scripts\\new_menu_demo.ms\n\
Set the <code>ADSK_APPLICATION_PLUGINS</code> environment variable to C:\\Test\\</p>\n\
<p>Launch 3ds Max to confirm that the script loads properly.</p>\n\
<p>To add the icon used by the plug-in, we need to set additional paths for 3ds Max to search for icons in.  A plug-in should set both light and dark theme paths, even if the icons are the same for both themes.  Our script is looking for a multi-resolution icon named &quot;test1&quot;, so we will create an icon directory inside the package directory for each theme, and put the icons in them.<br>C:\\Test\\NewMenuDemo\\icons\\dark\\test1.ico\n\
C:\\Test\\NewMenuDemo\\icons\\light\\test1.ico</p>\n\
<p>We then add these components to the <em>PackageContents.xml</em>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">    &lt;Components Description=&quot;light icon paths parts&quot;&gt;\n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2018&quot; SeriesMax=&quot;2020&quot; /&gt;\n\
        &lt;ComponentEntry AppName=&quot;lighticons&quot; Version=&quot;1.0.0&quot; ModuleName=&quot;./icons/Light&quot; /&gt;\n\
    &lt;/Components&gt;\n\
    &lt;Components Description=&quot;dark icon paths parts&quot;&gt;\n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2018&quot; SeriesMax=&quot;2020&quot; /&gt;\n\
        &lt;ComponentEntry AppName=&quot;darkicons&quot; Version=&quot;1.0.0&quot; ModuleName=&quot;./icons/Dark&quot; /&gt;\n\
    &lt;/Components&gt;</code></pre>\n\
<p>Adding more components involves adding the item to the package directory, and then adding a component entry to the <em>PackageContents.xml</em> file.  For example, we can add another MAXScript called by our menu, called <em>mxs_function.ms</em>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-maxscript prettyprint\">fn helloWorld msg = (\n\
    format &quot;Hello world %\\n&quot; msg\n\
)</code></pre>\n\
<p>Because there is no dependency on a UI in this script, we can add it to the pre-start-up scripts:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">    &lt;Components Description=&quot;pre-start-up scripts parts&quot;&gt;\n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2018&quot; SeriesMax=&quot;2020&quot; /&gt;\n\
        &lt;ComponentEntry AppName=&quot;DemoMenu&quot; Version=&quot;1.0.0&quot; ModuleName=&quot;./pre_startup_scripts/mxs_function.ms&quot; /&gt;\n\
    &lt;/Components&gt;</code></pre>\n\
<p>Once you have tested that the package loads from the test folder, you can create a zip archive for upload to the <a href=\"https://apps.autodesk.com/\" target=\"_blank\">Autodesk App Store</a>, or add it to an installer for distribution to 3ds Max users, and install to one of the locations described in the <a href=\"packaging_plugins.html\"\">Packaging Plug-ins</a>  topic.</p>\n\
<h2 id=\"osl-and-amg-shaders-example\">OSL and AMG Shaders Example</h2><p>This example shows how to package OSL shaders:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">    &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; \n\
    &lt;ApplicationPackage SchemaVersion=&quot;1.0&quot; AutodeskProduct=&quot;3ds Max&quot; Name=&quot;OSL and AMG Shaders&quot; Description=&quot;OSL and AMG Plugin Package Example&quot; AppVersion=&quot;1.0.0&quot;    ProductType=&quot;Application&quot; AppNameSpace=&quot;appstore.exchange.autodesk.com&quot; Author=&quot;Autodesk&quot; ProductCode=&quot;{89013b63-a8b6-4e83-81c0-9cc1ecbb308e}&quot; UpgradeCode=&quot;{4f6e7e7c-ad40-4093-8063-4be9f1b78eb4}&quot;&gt; \n\
    &lt;CompanyDetails Name=&quot;Autodesk Productions&quot; Url=&quot;http://www.autodesk.com&quot; /&gt; \n\
    &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2021&quot; SeriesMax=&quot;2021&quot; /&gt; \n\
    &lt;Components Description=&quot;osl folders parts&quot;&gt; \n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2021&quot; SeriesMax=&quot;2021&quot; /&gt; \n\
        &lt;ComponentEntry ModuleName=&quot;./Contents/OSL/&quot; /&gt; \n\
    &lt;/Components&gt; \n\
    &lt;Components Description=&quot;amg folders parts&quot;&gt; \n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2021&quot; SeriesMax=&quot;2021&quot; /&gt; \n\
        &lt;ComponentEntry ModuleName=&quot;./Contents/AMG/&quot; /&gt; \n\
    &lt;/Components&gt; \n\
    &lt;Components Description=&quot;hotkey parts&quot;&gt; \n\
        &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2023&quot; SeriesMax=&quot;2023&quot; /&gt; \n\
        &lt;ComponentEntry ModuleName=&quot;./Contents/Hotkeys/SnapPivotHotkeys.hsx&quot; /&gt; \n\
    &lt;/Components&gt; \n\
    &lt;/ApplicationPackage&gt; </code></pre>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plugin_package.html\">Packaging Plug-Ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";