var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"packagexml_format\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Autodesk Application Plug-in Package Format Specification</h1></div><p>This topic describes the elements that can make up a package XML (<em>PackageContents.xml</em>) file for a <strong>3ds Max plug-in</strong>.</p>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<div class=\"note note:\"><strong>Note</strong>: The way 3ds Max handles plug-in packages differs slightly from the way other Autodesk products such as AutoCAD do.  Specifically, 3ds Max does not require the <em>ProductCode</em> element, but does require the <em>UpgradeCode</em> element.  See details in the table below.</div>\n\
\n\
</div></div>\n\
\n\
<ul>\n\
<li><a href=\"#autodesk-application-plug-in-package-format-specification\">Autodesk Application Plug-in Package Format Specification</a><ul>\n\
<li><a href=\"#xml-version-required\">XML version (required)</a></li>\n\
<li><a href=\"#applicationpackage-required\"><code>&lt;ApplicationPackage&gt;</code> (required)</a><ul>\n\
<li><a href=\"#applicationpackage-attributes\"><code>&lt;ApplicationPackage&gt;</code> Attributes</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#companydetails-required\"><code>&lt;CompanyDetails&gt;</code> (required)</a><ul>\n\
<li><a href=\"#companydetails-attributes\"><code>&lt;CompanyDetails&gt;</code> Attributes</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#runtimerequirements\"><code>&lt;RuntimeRequirements&gt;</code></a><ul>\n\
<li><a href=\"#runtimerequirements-attributes\"><code>&lt;RuntimeRequirements&gt;</code> Attributes</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#components\"><code>&lt;Components&gt;</code></a><ul>\n\
<li><a href=\"#components-sub-nodes\"><code>&lt;Components&gt;</code> Sub Nodes</a></li>\n\
<li><a href=\"#components-description-attribute-values\"><code>&lt;Components&gt;</code> <code>Description</code> attribute values</a></li>\n\
</ul>\n\
</li>\n\
<li><a href=\"#environmentvariables-optional\"><code>&lt;EnvironmentVariables&gt;</code> (optional)</a></li>\n\
<li><a href=\"#environmentvariable-optional\"><code>&lt;EnvironmentVariable&gt;</code> (optional)</a><ul>\n\
<li><a href=\"#environmentvariable-attributes\"><code>&lt;EnvironmentVariable&gt;</code> Attributes</a></li>\n\
</ul>\n\
</li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<h2 id=\"xml-version-required-\">XML version (required)</h2><p>Example: <code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;</code></p>\n\
<h2 id=\"-code-lt-applicationpackage-gt-code-required-\"><code>&lt;ApplicationPackage&gt;</code> (required)</h2><p>Each <em>PackageContents.xml</em> file must contain an ApplicationPackage element. The ApplicationPackage element&apos;s attributes contain general information about the plug-in. It also encapsulates other XML elements (nodes) that help to define the contents of the plug-in.</p>\n\
<p>The <code>&lt;ApplicatonPackage&gt;</code> must have a <code>&lt;CompanyDetails&gt;</code> node.\n\
It can optionally contain a <code>&lt;RuntimeRequirements&gt;</code> node.\n\
It also contains an array of 0 or more <code>&lt;Components&gt;</code> nodes.</p>\n\
<p>Starting with <strong>3ds Max 2023</strong> it can optionally contain one or more <code>&lt;EnvironmentVariables&gt;</code> node.</p>\n\
<h3 id=\"-code-lt-applicationpackage-gt-code-attributes\"><code>&lt;ApplicationPackage&gt;</code> Attributes</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Name</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>AutodeskProduct (required)</td>\n\
<td>Must be set to &quot;3ds Max&quot;</td>\n\
</tr>\n\
<tr>\n\
<td>ProductType (required)</td>\n\
<td>Must be set to &quot;Application&quot;</td>\n\
</tr>\n\
<tr>\n\
<td>Name (optional)</td>\n\
<td>Plug-in name</td>\n\
</tr>\n\
<tr>\n\
<td>Description (optional)</td>\n\
<td>Plug-in description</td>\n\
</tr>\n\
<tr>\n\
<td>AppVersion (required)</td>\n\
<td>Version string in the form of &quot;MMM.mmm.bbb&quot; (major.minor.build)</td>\n\
</tr>\n\
<tr>\n\
<td>UpgradeCode (required)</td>\n\
<td>Unique identifier (GUID) for the plug-in that should be used for all its versions. <br>If 3ds Max finds two packages with the same UpgradeCode, it will load the one with the higher AppVersion. <br><strong>Note</strong>: You must increment <code>AppVersion</code> in order to allow for proper upgrading of a plug-in. <br>When you upload your plugin package to the Autodesk App Store in order to publish it, this code is used for generating an installer that will upgrade existent installations of previous versions of your plugin, without the need to uninstall the old version first.<br></td>\n\
</tr>\n\
<tr>\n\
<td>ProductCode (optional/required)</td>\n\
<td>This property is not required by 3ds Max.  However, if the plug-in package is distributed through the Autodesk App Store, it is required, and the following description applies: <br>This is the unique identifier (GUID) for a specific version of the plug-in. The ProductCode is used for first run notifications and as the installer ID for Add/Remove Programs in Windows when installed from the Autodesk App Store website. <br>A new ProductCode should be used whenever the AppVersion is changed. This is so upgrade installs of the plugin package work properly.<br>On Windows, you can use the MSI installer ProductCode or generate a GUID using an application such as GuidGen.exe. There are also websites that allow you to generate a GUID.</td>\n\
</tr>\n\
</tbody></table>\n\
<h2 id=\"-code-lt-companydetails-gt-code-required-\"><code>&lt;CompanyDetails&gt;</code> (required)</h2><p>The plug-in will not load if this element is not defined.\n\
All attributes are optional.</p>\n\
<h3 id=\"-code-lt-companydetails-gt-code-attributes\"><code>&lt;CompanyDetails&gt;</code> Attributes</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Name</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Url</td>\n\
<td>URL to reference back to the company</td>\n\
</tr>\n\
<tr>\n\
<td>Email</td>\n\
<td>E-mail, read as a string, no format required</td>\n\
</tr>\n\
<tr>\n\
<td>Phone</td>\n\
<td>Phone, read as a string, no format required</td>\n\
</tr>\n\
<tr>\n\
<td>Name</td>\n\
<td>Company name</td>\n\
</tr>\n\
</tbody></table>\n\
<h2 id=\"-code-lt-runtimerequirements-gt-code-\"><code>&lt;RuntimeRequirements&gt;</code></h2><p>This element enables the plug-in&apos;s host application to quickly process an application plug-in package.  It identifies which operating systems, Autodesk products and releases the package is compatible with.</p>\n\
<p>Optional in the <code>&lt;ApplicationPackage&gt;</code> node.\n\
Required in the <code>&lt;Components&gt;</code> nodes.</p>\n\
<h3 id=\"-code-lt-runtimerequirements-gt-code-attributes\"><code>&lt;RuntimeRequirements&gt;</code> Attributes</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Name</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>OS</td>\n\
<td>Must be set to &quot;Win64&quot;</td>\n\
</tr>\n\
<tr>\n\
<td>Platform</td>\n\
<td>Must be set to &quot;3ds Max&quot;</td>\n\
</tr>\n\
<tr>\n\
<td>SeriesMin</td>\n\
<td>The minimum 3ds Max release the plug-in is compatible with. Currently this should be the 3ds Max product release number the application is compatible with. For example, it might be &quot;2020&quot;.   Year, build, update, and hotfix versions are also supported - see below.  If not specified, a value of 0 is used.</td>\n\
</tr>\n\
<tr>\n\
<td>SeriesMax</td>\n\
<td>The maximum 3ds Max release the plug-in is compatible with. Currently this should be the 3ds Max product release number the application is compatible with. For example, it might be &quot;2020&quot;.  Year, build, update, and hotfix versions are also supported - see below.</td>\n\
</tr>\n\
</tbody></table>\n\
<p>The <code>SeriesMin</code> and <code>SeriesMax</code> attributes support version specification in the form of <strong>YYYYY.u.h.bbbb</strong>  (e.g. &quot;2021.2.1.4567&quot;), where:</p>\n\
<ul>\n\
<li>YYYY is the product release year (e.g. &quot;2022&quot;)</li>\n\
<li>u is the update number (e.g. &quot;2&quot; for 2022 Update 2)</li>\n\
<li>h is the hotfix number (e.g. &quot;1&quot; for 2022 Update 2, Hotfix 1)</li>\n\
<li>bbbb is the build number (e.g. &quot;4567&quot;)</li>\n\
</ul>\n\
<p>Recommended practice:</p>\n\
<p>When creating a DLL that is compiled with the 3ds Max SDK, <code>SeriesMin</code> and <code>SeriesMax</code> should specify the &quot;release year&quot; range the plug-in is compatible with.\n\
The plug-in DLL should be binary compatible with all the application releases that fall between the values specified in <code>SeriesMin</code> and <code>SeriesMax</code>.</p>\n\
<p>Note that 3ds Max does not test for binary compatibility.  Even if the current version of 3ds Max is binary compatible with an older <code>SeriesMax</code> version, the plugin is not loaded.   For example, if the <code>SeriesMin</code> and <code>SeriesMax</code> is 2015, 3ds Max 2016 is binary compatible, but will not load the plug-in.</p>\n\
<p>The <code>SeriesMax</code> attribute is mandatory.</p>\n\
<h2 id=\"-code-lt-components-gt-code-\"><code>&lt;Components&gt;</code></h2><pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">&lt;Components Description=&quot;xxx&quot;&gt;\n\
...\n\
&lt;/Components&gt;</code></pre>\n\
<p>This node describes a component, its runtime requirements, and a list of component entries. The &quot;Description&quot; attribute is <strong>required</strong> and defines how to load the component entries. Possible valid values are listed below.</p>\n\
<h3 id=\"-code-lt-components-gt-code-sub-nodes\"><code>&lt;Components&gt;</code> Sub Nodes</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Name</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td><code>&lt;RuntimeRequirements&gt;</code> (required)</td>\n\
<td>See above table for runtime requirements which can be specified for more specific modules here.  For example, <code>SeriesMin</code> and <code>SeriesMax</code> may be different for a specific component.</td>\n\
</tr>\n\
<tr>\n\
<td><code>&lt;ComponentEntry ModuleName=&quot;XXX&quot; /&gt;</code></td>\n\
<td>List of ComponentEntry nodes. At least one needs to be present. Each defines a file to be loaded through its &quot;ModuleName&quot; attribute, which can be an absolute or relative file path to the package XML file.  <br>You can specify a wildcard in the file name, such as &quot;*.ms&quot; to specify all MAXScript files.  Wildcards are supported in file names only, not in file paths. If a file is specified twice, 3ds Max will display an error message.</td>\n\
</tr>\n\
</tbody></table>\n\
<h3 id=\"-code-lt-components-gt-code-code-description-code-attribute-values\"><code>&lt;Components&gt;</code> <code>Description</code> attribute values</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Tag</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>plugins parts</td>\n\
<td>Loads the file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element as a 3ds Max plug-in DLL.</td>\n\
</tr>\n\
<tr>\n\
<td>assemblies parts</td>\n\
<td>Loads the file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element as a managed assembly DLL.</td>\n\
</tr>\n\
<tr>\n\
<td>ui schemes parts</td>\n\
<td>The file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element defines a UI scheme file that can be used by the defaults switcher.</td>\n\
</tr>\n\
<tr>\n\
<td>default setting paths parts</td>\n\
<td>The path in the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element defines a folder where defaults are stored.</td>\n\
</tr>\n\
<tr>\n\
<td>pre-start-up scripts parts</td>\n\
<td>Loads the file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element as a plug-in script. This is done after plug-in DLLs are loaded. The UI system is not yet in place so scripts have &quot;limited&quot; functionality.</td>\n\
</tr>\n\
<tr>\n\
<td>macroscripts parts</td>\n\
<td>Loads the file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element as a macroscript.</td>\n\
</tr>\n\
<tr>\n\
<td>post-start-up scripts parts</td>\n\
<td>Loads the file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element as a startup script. The UI system is fully in place.</td>\n\
</tr>\n\
<tr>\n\
<td>light icon paths parts</td>\n\
<td>The path defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element will be added as a path to the CUI frame manager to load light icons from.</td>\n\
</tr>\n\
<tr>\n\
<td>dark icon paths parts</td>\n\
<td>The path defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element will be added as a path to the CUI frame manager to load dark icons from.</td>\n\
</tr>\n\
<tr>\n\
<td>scene converter folders parts</td>\n\
<td>The path defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element is used by the Scene Converter to load preset and conversion scripts.  Presets are loaded from a sub-directory named <code>ConversionPresets</code>, and have pattern <code>[name]_preset.ms</code>.  Conversion scripts are loaded from a sub-directory named <code>ConversionScripts</code>.</td>\n\
</tr>\n\
<tr>\n\
<td>osl folders parts</td>\n\
<td>The path defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element is parsed for OSL shaders and loaded.  The last (main) directory in this path must be named <code>OSL</code>.  Sub-directories are added as categories in the list of OSL shaders.</td>\n\
</tr>\n\
<tr>\n\
<td>amg folders parts</td>\n\
<td>The path defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element is parsed for AMG shaders and loaded. Any sub-directory that exists in the system AMG directory can also exist under this folder, and will be used in the same way.  AMG files in the system AMG directory are loaded first.</td>\n\
</tr>\n\
<tr>\n\
<td>hotkey parts</td>\n\
<td>The .hsx file defined by the <code>ModuleName</code> attribute of the <code>ComponentEntry</code> element is parsed for hotkey definitions.</td>\n\
</tr>\n\
</tbody></table>\n\
<p>See <a href=\"./packagexml_example.html\">Example Plug-in Package</a> for an example of how to use <code>&lt;ComponentEntry&gt;</code>.</p>\n\
<h2 id=\"-code-lt-environmentvariables-gt-code-optional-\"><code>&lt;EnvironmentVariables&gt;</code> (optional)</h2><p>This element provides a way for plug-ins to define environment variables for the 3ds Max process.  This element contains a <code>&lt;RuntimeRequirements&gt;</code> element (required)  and one or more optional <code>&lt;EnvironmentVariable&gt;</code> elements that define environment variables available to the running 3ds Max process.  Environment variables can be defined, modified, or removed.</p>\n\
<h2 id=\"-code-lt-environmentvariable-gt-code-optional-\"><code>&lt;EnvironmentVariable&gt;</code> (optional)</h2><p>Each <code>&lt;EnvironmentVariable&gt;</code> element defines an environment variable that is created when the package is loaded, and is available to that instance of 3ds Max.  All environment variables are processed before 3ds Max loads any components. An environment variable can only be defined once.</p>\n\
<h3 id=\"-code-lt-environmentvariable-gt-code-attributes\"><code>&lt;EnvironmentVariable&gt;</code> Attributes</h3><table>\n\
<thead>\n\
<tr>\n\
<th>Tag</th>\n\
<th>Description</th>\n\
</tr>\n\
</thead>\n\
<tbody><tr>\n\
<td>Name (required)</td>\n\
<td>The name of the environment variable.  <strong>Note</strong>: environment variable names are case sensitive.</td>\n\
</tr>\n\
<tr>\n\
<td>Value (required)</td>\n\
<td>The value of the environment variable, specified as a string.</td>\n\
</tr>\n\
<tr>\n\
<td>Type  (required)</td>\n\
<td>The type of the environment variable, either &quot;string&quot; or &quot;path&quot;.</td>\n\
</tr>\n\
</tbody></table>\n\
<p>You can use OS defined variables in the <code>value</code>, which get expanded when the environment variable is created.  For example, <code>%LOCALAPPDATA%/Renderer/Cache</code> is expended to <code>C:/Users/&lt;username&gt;/AppData/Local/Renderer/Cache</code>.  If the expansion fails (the variable is not defined, for example), no environment variable is created and an error is written to <em>max.log</em>.</p>\n\
<p>The <code>value</code> can optionally start with one of these operators:</p>\n\
<ul>\n\
<li><code>&lt;</code> - prepends the value to the existing definition</li>\n\
<li><code>+</code> - appends the value to the existing definition, or if the type is a path, adds the path if it is not already in the list</li>\n\
<li><code>-</code> - removes the value from the existing definition, or if the type is a path, removes the path from the list</li>\n\
</ul>\n\
\n\
<div class=\"callout callout-note\">\n\
<div class=\"callout-title\"><i class=\"callout-icon fa fa-pencil\" aria-hidden=\"true\"></i>Note:</div>\n\
<div class=\"callout-body\">\n\
\n\
<p> Operators can be escaped by using the backslash character, eg: <code>\\+</code>.</p>\n\
\n\
</div></div>\n\
\n\
<p>For example:</p>\n\
<p>Defining a new environment variable:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&lt;EnvironmentVariable Name=&quot;GPU_PLATFORMS&quot; Value=&quot;titan;gtx 980&quot; Type=&quot;string&quot;&gt;</code></pre><p>Results in the environment variable: <code>GPU_PLATFORMS=titan;gtx 980</code></p>\n\
<p>Appending a value (note that the separator is part of the appended string):</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&lt;EnvironmentVariable Name=&quot;GPU_PLATFORMS&quot; Value=&quot;+;amd&quot; Type=&quot;string&quot;&gt;</code></pre><p>The environment variable is now <code>GPU_PLATFORMS=titan;gtx 980;amd</code></p>\n\
<p>Removing a substring:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">&lt;EnvironmentVariable Name=&quot;GPU_PLATFORMS&quot; Value=&quot;-;gtx 980&quot; Type=&quot;string&quot;&gt;</code></pre><p>Results in: <code>GPU_PLATFORMS=titan;amd</code></p>\n\
<p>If the environment variable is a &quot;path&quot; type: 3ds Max normalizes and resolves relative paths before creating the environment variable. Paths that are not fully qualified are resolved relative to the <code>PackageContents.xml</code> that defines them. Plugins do not need to resolve relative paths themselves. If the path is invalid, the environment variable is not defined and the error is logged to <em>max.log</em>. 3ds Max continues to execute and load plugins.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plugin_package.html\">Packaging Plug-Ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";