var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"packaging_plugins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Packaging Plug-ins</h1></div><p>Plug-ins can be packaged using the Autodesk Application Plug-in Package format, which makes it easy to distribute them on the <a href=\"https://apps.autodesk.com\" target=\"_blank\">Autodesk App Store</a>, and  simplifies plug-in development and installation in 3ds Max.</p>\n\
<p>A plug-in package, or bundle, consists of a folder structure containing all files related to the plug-in, and an XML file that defines the various components of the plug-in. Deploying plug-ins in this format, makes it easier to target multiple operating systems and product releases since the parameters of your plug-in are defined in the XML file of the package. \n\
Plug-ins using the package format can be installed without having to know the location where 3ds Max is installed, and their installers can simply copy the plug-in package into one of ApplicationPlugins folders described below in &apos;Install Locations&apos;.  3ds Max scans the ApplicationPlugins folders and loads all applicable plug-ins. </p>\n\
<p>Setting up a plug-in package is straight-forward.  To do so you:</p>\n\
<ol>\n\
<li>Create an xml file named <code>PackageContents.xml</code> that describes your plug-in&apos;s components.  See the detailed description below and the <a href=\"packagexml_format.html\"\"\">Autodesk Application Plug-in Package Format Specification</a> topic.</li>\n\
<li>Create the physical layout of your plug-in consisting in all the files and folders that it needs. Besides the main binary, or script that represents your plug-in, it may have additional binary dependencies, macro scripts, icons, help file, etc. Place the PackageContents.xml file in the root folder of your plug-in package. To test it, you can set the <code>ADSK_APPLICATION_PLUGINS</code> environment variable to the root folder of your plug-in package. This environment variable is recognized by 3ds Max starting with version 2019.  </li>\n\
<li>Optionally, you can create a zip archive of your plug-in package (including the PackgeContents.xml file) to upload to the Autodesk App Store. The App Store also provides a method of uploading all the files and creating a zip.</li>\n\
</ol>\n\
<h2 id=\"install-locations\">Install Locations</h2><p>3ds Max supports these locations for plug-in installation using the Autodesk Application Plug-in Package format:</p>\n\
<dl>\n\
\n\
\n\
\n\
<dt><p>\n\
%ALLUSERSPROFILE%\\Autodesk\\ApplicationPlugins\\[plugin_name]<br>\n\
Example:<br>\n\
C:\\ProgramData\\Autodesk\\ApplicationPlugins\\MyPlugin\n\
</p>\n\
</dt>\n\
\n\
<dd>\n\
This is the preferred install location when a plug-in is installed by the Autodesk store installer. Plug-ins installed to this location are available to all users on the machine.\n\
</dd>\n\
\n\
<dt><p>\n\
%PROGRAMFILES%\\Autodesk\\ApplicationPlugins<br>\n\
Example:<br>\n\
C:\\Program Files\\Autodesk\\ApplicationPlugins\\[plugin_name]\n\
</p></dt>\n\
<dd>\n\
An alternate secure install location that is write protected by the operating system.\n\
</dd>\n\
\n\
<dt>%APPDATA%\\Autodesk\\ApplicationPlugins\\[plugin_name]<br>\n\
Example:<br>\n\
C:\\Users\\&lt;username&gt;\\AppData\\Roaming\\Autodesk\\ApplicationPlugins\\MyPlugin\n\
</dt>\n\
<dd>This is the fallback install location when a user does not have administrator privileges, and it allows only that user to access the plug-in through 3ds Max.</dd>\n\
\n\
<dt>Custom folder<br>\n\
</dt>\n\
<dd>3ds Max looks at the <i>ADSK_APPLICATION_PLUGINS</i> environment variable for a list of paths from which it will load plugin packages.  These paths can point to either: 1) a directory containing a single plugin package XML file, allowing you to load only a specific plugin, or 2) a &quot;parent&quot; directory that contains one or more sub-directories that contain a plugin package XML file, allowing you to bulk load multiple plugins from a single path.  The <i>ADSK_APPLICATION_PLUGINS</i> environment variable can contain a mix of these path types.\n\
\n\
<div class=\"note note:\"><b><span class=\"notetitle\">Note:</span></b> Parent paths for multiple plugin packages was first available with 3ds Max 2019, single paths for specific plugin packages was first available in 3ds Max 2022.2 Update.</div>\n\
<p>Example 1: Loading multiple plugin packages by specifying path to their parent folder\n\
In this example, various plugins for a certain version of 3ds Max, perhaps from different vendors, are located in sub-directories of:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">D:\\Plugins\\3dsMax2022\\:\n\
D:\\Plugins\\3dsMax2022\\Plugin1\n\
D:\\Plugins\\3dsMax2022\\Plugin2\n\
...\n\
D:\\Plugins\\3dsMax2022\\PluginN</code></pre><p>To instruct 3ds Max 2022 to load all plugins under <code>\\Plugins\\3dsMax2022</code>, you would set:\n\
<code>ADSK_APPLICATION_PLUGINS=D:\\Plugins\\3dsMax2022</code></p>\n\
<p>Example 2: Loading different plugin packages, or different versions of the same plugin, based on the needs of the projects being worked on. In this example, various plugins, sometimes different versions of the same plugin are stored on a server. The <code>ADSK_APPLICATION_PLUGINS</code> environment variable is configured differently based on the project the user works on:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">\\\\Plugins\\3dsMax2022\\Plugin1.0\n\
\\\\Plugins\\3dsMax2022\\Plugin2.1\n\
\\\\Plugins\\3dsMax2022\\Plugin2.4\n\
...\n\
\\\\Plugins\\3dsMax2022\\PluginN.1.1</code></pre><p>For Project 1, Plugin2.1 is needed, while for Project 2 Plugin2.4 is needed, therefore the environment variables specific for the 2 projects are set to point precisely to the folders representing the required plugins.</p>\n\
<p>Setup for Project 1: <code>ADSK_APPLICATION_PLUGINS=\\\\Plugins\\3dsMax\\Plugin2.1;\\\\Plugins\\3dsMax\\Plugin1.0</code>\n\
Setup for Project 2: <code>ADSK_APPLICATION_PLUGINS=\\\\Plugins\\3dsMax\\Plugin2.4;\\\\Plugins\\3dsMax\\Plugin1.0</code></p>\n\
<div class=\"note note:\"><b>Note</b>: The standard enforces the location of the package file, not the location of the 3ds Max plug-in files.\n\
The package file format uses paths to the files. These can be anything you want.</div>\n\
</dd>\n\
</dl>\n\
\n\
\n\
<h2 id=\"a-basic-package-xml-file\">A basic package XML file</h2><p>The following is an example of a simple Autodesk Application Plug-in package file for a utility plugin named <code>MyPlugin.dlu</code> that is compatible with 3ds Max 2020:</p>\n\
<pre class=\"pre codeblock\"><code class=\"lang-xml prettyprint\">    &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;\n\
    &lt;ApplicationPackage \n\
        SchemaVersion=&quot;1.0&quot; \n\
        AutodeskProduct=&quot;3ds Max&quot; \n\
        ProductType=&quot;Application&quot; \n\
        Name=&quot;My 3ds Max Plugin&quot;\n\
        AppVersion=&quot;1.0.0&quot;\n\
        UpgradeCode=&quot;{bef4b961-c3dc-4197-b663-ed8dde1197ee}&quot;\n\
        ProductCode=&quot;{07849d02-b914-4593-bf03-49bdd74526d0}&quot;&gt;\n\
        &lt;CompanyDetails /&gt;\n\
        &lt;Components Description=&quot;plugin parts&quot;&gt;\n\
            &lt;RuntimeRequirements OS=&quot;Win64&quot; Platform=&quot;3ds Max&quot; SeriesMin=&quot;2020&quot; SeriesMax=&quot;2020&quot; /&gt;\n\
            &lt;ComponentEntry ModuleName=&quot;./Contents/MyPlugin.dlu&quot; /&gt;\n\
        &lt;/Components&gt;\n\
    &lt;/ApplicationPackage&gt;</code></pre>\n\
<p>At the top level, the package format requires a node called <code>&lt;ApplicationPackage&gt;</code>.\n\
The &quot;AutodeskProduct&quot; attribute defines which product the package is meant for, in this case 3ds Max.\n\
The &quot;ProductType&quot;, in the context of 3ds Max plug-ins, is always &quot;Application&quot;.\n\
The &quot;AppVersion&quot; is a version string in the format &quot;MMM.mmm.bbb&quot; (major.minor.build). Using the version string, two packages with different versions can co-exist. The package with the higher version will be loaded. \n\
The &quot;UpgradeCode&quot; is the unique identifier for the plug-in package. Only one package with a particular product code will be loaded.\n\
The &quot;ProductCode&quot; is a unique identifier that needs to be changed every time the AppVersion changes.</p>\n\
<p>The <code>&lt;CompanyDetails&gt;</code> node can contain publisher details.  It is mandatory, but the content is optional. </p>\n\
<p>The <code>&lt;Components&gt;</code> node lists a group of files that need to be managed by the application. These are associated with a &quot;Description&quot;, which defines what to do with these files. See the <a href=\"packagexml_format.html\"\"\">Autodesk Application Plug-in Package Format Specification</a> topic for a list of valid description strings.\n\
The &quot;plugin parts&quot; value tells the application to load these as plug-in DLLs.</p>\n\
<p>The <code>&lt;RuntimeRequirement&gt;</code> needs to be defined for each <code>&lt;Components&gt;</code> node.\n\
Defining runtime requirements per components can be valuable when creating a plug-in that targets multiple releases of 3ds Max. In this case, a <code>&lt;Components&gt;</code> node per 3ds Max release would define the appropriate component (plug-in dll) and run-time requirement (version of 3ds Max the plug-in dll was built for).\n\
Generally, plug-in DLLs will need to be matched with a version of 3ds Max they have been built for, while scripts and other files could be shared for all supported 3ds Max releases.</p>\n\
<p>The folder structure for the above plug-in package could look like:\n\
C:\\Plugins\\bin\\MyPlugin\\PackageContents.xml\n\
C:\\Plugins\\bin\\MyPlugin\\Contents\\MyPlugin.dlu\n\
C:\\Plugins\\bin\\MyPlugin\\Contents\\en-US\\MyPlugin.dlu.mui</p>\n\
<p>For a more complete example of a plug-in package see the <a href=\"packagexml_example.html\"\">Example Plug-in Package</a> topic.</p>\n\
<h2 id=\"debugging-plugin-packages\">Debugging Plugin Packages</h2><p>When an error occurs while loading plugin packages, 3ds Max will display an error message. \n\
In case you need to turn off this behavior, you will need to create an entry in <code>3dsmax.ini</code>:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">[PluginPackageManager]\n\
ShowMessageDialogOnError=0</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../plugin_package.html\">Packaging Plug-Ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";