var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"profiling_plug-in_performance\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Profiling Plug-in Performance</h1></div><p>There 3ds Max Profiler is a utility plug-in that allows developers to analyze the execution and performance of their plug-ins. The profiler supports analyzing Release build plug-ins. This allows profiling to take place with full optimization, inlining, etc. (Hybrid and Debug builds can also be profiled however this doesn&apos;t provide accurate information since the code is not optimized).</p>\n\
<h2 id=\"polling-versus-instrumented-profiling\">Polling versus Instrumented Profiling</h2><p>There are two types of profiling that may be done. One is called <em>Polling</em> and the other is called <em>Instrumented</em>.</p>\n\
<ul>\n\
<li><em>Polling profiling</em> requires no special compliler settings other than generating debug information (a PDB file). This works by setting up a separate thread and periodically looking at the context of the main thread. It looks at the instruction pointer to determine what instruction the CPU is at and stores this information. When finished, the stored addresses are used to report the module, source file and line number of the function (see below for the details on enabling these options).</li>\n\
<li><em>Instrumented profiling</em> requires a special compiler setting but provides much more accurate profiling information.</li>\n\
</ul>\n\
<p>Typically both of these are used. The polling profiler is used first to get a rough idea of where the greatest amount of execution time is being spent. Then instrumented profiling is done for those time consuming areas. This allows one to get a quick overview using polling and then collect very accurate, detailed information using instrumented profiling.</p>\n\
<h2 id=\"preparing-for-profiling-compiler-and-link-settings\">Preparing For Profiling -- Compiler and Link Settings</h2><p>There are several things that need to be done to get a plug-in ready for profiling. These are:</p>\n\
<ol>\n\
<li><p>Generating debugging information.</p>\n\
</li>\n\
<li><p>For Instrumented Profiling Only -- Linking to the profiling LIB file.</p>\n\
</li>\n\
<li><p>For Instrumented Profiling Only -- Compiling using a special compiler flag.</p>\n\
</li>\n\
</ol>\n\
<p>These steps are outlined below:</p>\n\
<ol>\n\
<li><p>You need to make sure debugging information is available. This can be turned on in the IDE using <em>Project / Settings / C++ Tab</em> and choosing <em>General</em> from the <em>Category</em> dropdown and choosing <em>Program Database</em> from the <em>Debug info</em> combo box. You&apos;ll also need to check the <em>Generate Debug Info</em> check box in the <em>General Category</em> of the <em>Link Tab</em> of the dialog. This will cause a PDB file to be written. The profiler needs the PDB file in order associate the addresses it collects as the program executes with actual entry points in the code.</p>\n\
</li>\n\
<li><p>For Instrumented Profiling Only -- You must add <code>ACAP</code>.LIB to the plug-ins link libraries. This is done using the <em>Project / Add To Project / Files</em> command from the pulldown menus. From the dialog presented choose <code>\\\\MAXSDK</code>\\LIB\\ACAP.LIB.</p>\n\
</li>\n\
<li><p>For Instrumented Profiling Only -- to work the plug-in must be compiled with a special compiler flag: <code>/Gh</code>. This option isn&apos;t available through the IDE in a check box -- it must be manually typed into the Project Options list. You access this list from the IDE using <em>Project / Settings / C++ Tab / General Category</em> . At the beginning of the list of options add <code>/Gh</code>. What the <code>/Gh</code> option does is instruct the compiler to call a special function named <code>penter()</code> prior to doing anything for every procedure entry point. The <code>penter()</code> function is provided by the profiler and is used to collect all the profiling information.</p>\n\
</li>\n\
</ol>\n\
<h2 id=\"using-the-3ds-max-profiler-plug-in\">Using the 3ds Max Profiler Plug-in</h2><p>The profiler is a utility plug-in ( <strong>\\maxsdk\\plugin\\x64\\release\\maxprofiler.dlu</strong> ) with an interface in both the command panel and a small floating dialog. The command panel interface is used to indicate which type of profiling is done, which information is written to the output file, and what file name its written to. The floating dialog is used for starting, stopping, saving and clearing the profile recording.</p>\n\
<p>To run the profiler, copy it and the associated <strong>.dlu.mui</strong> file to a location in 3ds Max&apos;s plugin search path, for example <strong>[maxdir]\\Plugins</strong>. Select <em>3ds Max Profiler</em> from the list of utility plug-ins. A smaller floating dialog appears as well as the command panel interface. Via radio buttons in the Collection area choose if you want to perform Instrumented or Polling profiling.</p>\n\
<p>To collect profiling information you select the options you want to record using the check boxes in the <em>Report</em> area of the command panel rollup. Next choose the desired output file name, from the <em>Output</em> rollup. By default the output file is written to <code>maxprof0</code>.txt in the same directory as the currently loaded 3ds Max file.</p>\n\
<p>Once these choice have been made, click on the <em>Record</em> button in the floating dialog. This puts the profiler in record mode -- ready for the collection of profiling information.</p>\n\
<p>Next, simply use the plug-in you wish to profile. For instance, if your plug-in is a modifier, apply it to an object and adjust its settings. As you work with the plug-in, or 3ds Max calls its methods, the profiling information is collected. The floating dialog stays active even if you leave the utility branch of the command panel so you&apos;re free to use all of 3ds Max to fully test your plug-in. Note that the profiler is persistent even through a 3ds Max File / Reset operation. This allows developers to track what calls are made during a Reset as well. If you want to reset the profiling information, press the Clear button on the floating dialog.</p>\n\
<p>This section list each of the controls in the command panel user interface:</p>\n\
<p><img src=\"./images/profiler.png\" alt>  </p>\n\
<h3 id=\"report-section-\">Report section:</h3><p>The check boxes in this section determine which portions of the output file are written. Below is a description of each of the options in this dialog. The sample output file shown later in this topic shows an example what is written for each of these.</p>\n\
<ul>\n\
<li><em>Summary</em>: This generates some basic information about the speed of the machine 3ds Max is running on, the amount of time spent profiling, and the number of functions that were profiled.</li>\n\
<li><em>Module list</em>: This generates a list of all the modules that are loaded into process memory.</li>\n\
<li><em>M</em> <em>ax stack depth</em> : This reports the maximum depth of function calls the profiler reached.</li>\n\
</ul>\n\
<p>The following options are reported for every function that is called. These items appear as columns of data in a table where each row represents one function call.</p>\n\
<ul>\n\
<li><em>Time (in msecs)</em>: This is the amount of time spent in the function in milliseconds. This is labeled <em>SelfTime</em> in the output table.</li>\n\
<li>Time (in ticks): This is amount of time spent in the function in ticks. This is labeled <em>SelfTicks</em> in the output table.</li>\n\
<li><em>Time (in percent)</em>: This is the time in a function as a percent of the overall time spent in all the functions that were profiled. This is labeled <em>SelfPercent</em> in the output table.</li>\n\
<li><em>Child times</em>: If this is checked, three new columns are added to the output table. These are labeled <em>HierTicks</em>, <em>HierTime</em> and <em>HierPercent</em>. These are similar to those above, but include not only the function itself, but also any functions it calls. This one is useful because you can sort the table by child times (in a spreadsheet such as Excel) and it will display the most time intensive functions first.  </li>\n\
<li><em>Recursion counts</em>: This option is useful if you have recursive functions. It shows how many time the function calls back on itself. This is labeled <em>Recursions</em> in the output table.</li>\n\
<li><em>Calling functions</em>: This generates a multiline entry. For each function profiled, a list of all the functions, or places within a function, that called it are shown. This also lists how many times each of the functions called it.</li>\n\
<li><em>Function addresses</em>: This generates the address in memory for the function. This is labelled <em>Address</em> in the output.</li>\n\
<li><em>Source module</em>: This generates the name of the module (the name of the DLL that the profiled function lives in). If you are running under NT5 and have <code>IMAGEHLP</code>.DLL you&apos;ll get the source file name and line number. This is labelled <em>Module</em> in the output. The number of calls (labeled <em>Count</em> in the output table) is always reported. This is the number of times the function was entered.</li>\n\
</ul>\n\
<h2 id=\"output-section-\">Output section:</h2><p><em>Output file selector button</em>: By default, the output is written to the path where the 3ds Max file was loaded. Clicking on this button brings up the file selector dialog for choosing a new output file.</p>\n\
<p><em>Increment after save</em>: This check box is enabled only when the filename has a number or numbers at the end. If checked, the file name shown on the button is incremented each time the profiling information is saved. If unchecked, the file is overwritten on a save.</p>\n\
<p><em>Clear data after save</em>: This check box resets the profiler after each time the profiling information is saved. If this is off, profiling information continues to accumulate after a save.</p>\n\
<p><em>Close</em>: This closes the 3ds Max Profiler plug-in in the user interface.</p>\n\
<p>This section list the controls in the floating dialog.</p>\n\
<p><img src=\"./images/profiler_buttons.png\" alt></p>\n\
<p>The floating dialog has three buttons used for starting/stopping, saving and clearing the profile recording.</p>\n\
<p><em>Record / Stop</em>: This button is used to start and stop the collection of profiling information.</p>\n\
<p><em>Save</em>: This button is used to save the collected profiling information to disk.</p>\n\
<p><em>Clear</em>: This button is used to reset the profiling information so new recording will start from a clear state. If you want to clear out any existing profiling information generated press this button.</p>\n\
<h3 id=\"interpreting-the-profiler-output-file\">Interpreting the Profiler Output File</h3><p>This section presents an example of output from the profiler and describes the meaning of each section.</p>\n\
<h4 id=\"the-summary-section-\">The summary section:</h4><p>This section is written if the &apos;Summary&apos; check box is checked.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Tue Jul 29 15:46:10 1997\n\
WinNT 4.0\n\
microSecsPerTick 0.12126</code></pre><p>This simply gives data about the timing of the CPU. This is the number of micro seconds per tick. Tick counts are used in several places in the profiler output.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Ticks (elapsed/counted) 1860866843/305119085</code></pre><p>This tells how many CPU ticks went by during the run of the profiler (between when the Record and Stop buttons were pressed) over how many were actually collected (counted) by the profiler.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Secs (elapsed/counted) 225.649/36.9988</code></pre><p>This tells the same information as above, only in seconds.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Total functions 76</code></pre><p>This is the total number of functions that were profiled.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Total calls 7493</code></pre><p>This is the total number of calls that were found while profiling.</p>\n\
<p>The module list section:</p>\n\
<p>This section is written if the &apos;Module list&apos; check box is checked.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">module  base\n\
3dsmax  0x400000\n\
ntdll  0x77f60000\n\
. . .etc. . .\n\
GDI5  0x33600000\n\
SZB5  0x33200000\n\
msafd  0x77660000\n\
wshtcpip  0x77690000</code></pre><p>This simply lists all the modules that are loaded into process memory and the address of where they actually wound up.</p>\n\
<p>Max stack depth section.</p>\n\
<p>This section is written if the &apos;Max stack depth&apos; check box was checked.</p>\n\
<p><code>Max</code> <code>Stack</code> Depth 8</p>\n\
<p>This indicates how far into the procedure chain the profiler was used. That is, how many calls deep was the profiler involved in. This number is exclusive of recursion.</p>\n\
<p>The profiling data section.</p>\n\
<p>The data shown below is copied from an Excel spreadsheet to make it appear in a table format. In pure text form as output by the profiler the data is tab delimited. One can simply copy this data to the clipboard, paste it into Excel, and it fills out the spreadsheet cleanly into rows and columns. The data here is just as described above under the user interface controls. Of particular note is the list of calling functions. When that option is checked the table may contain multiple lines per function. For each function profiled, a list of all the functions, or places within a function, that called it are shown. This also lists how many times each of the functions called it. For example, in the table below, <code>GetString()</code> was called 13 times, 1 time by <code>EnterMode()</code>, 4 times by <code>DoPoint()</code>, 1 time by <code>DefineStroke()</code>, 2 times by <code>DefineStroke()</code> at a different address, 3 times by <code>UpdateStrokeInfo()</code>, and 2 times by <code>ReviewStrokes()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">Count Recursions SelfTicks SelfTicks/Call SelfTime SelfPercent HierTicks HierTime HierPercent Address Function Module\n\
\n\
13 0 7502 577 1 0 7502 1 0 822087728 GetString stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@44\n\
\n\
1 822090354 StrokeCMode::EnterMode +32 stroke!@\n\
\n\
4 822091673 StrokePrgm::DoPoint +69 stroke!@\n\
\n\
1 822101165 StrokeTable::DefineStroke +60d stroke!@\n\
\n\
2 822102498 StrokeTable::DefineStroke +b42 stroke!@\n\
\n\
3 822103004 UpdateStrokeInfo +7c stroke!@\n\
\n\
2 822105572 StrokeTable::ReviewStrokes +7b4 stroke!@\n\
\n\
3 0 1050 350 0 0 1050 0 0 822087792 BuildStrokeSetPathName stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@179\n\
\n\
1 822100149 StrokeTable::DefineStroke +215 stroke!@\n\
\n\
2 822103881 StrokeTable::ReviewStrokes +119 stroke!@\n\
\n\
21 0 1727 82 0 0 1727 0 0 822087968 Stroke::Stroke stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@424\n\
\n\
21 822103715 StrokeTable::ReviewStrokes +73 stroke!@\n\
\n\
144 0 885 6 0 0 885 0 0 822088224 Stroke::GetFunctionName stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@447\n\
\n\
60 822089505 StrokeTable::Sort +51 stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@583\n\
\n\
60 822089514 StrokeTable::Sort +5a stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@590\n\
\n\
1 822101304 StrokeTable::DefineStroke +698 stroke!@\n\
\n\
20 822102448 StrokeTable::DefineStroke +b10 stroke!@\n\
\n\
3 822102962 UpdateStrokeInfo +52 stroke!@\n\
\n\
31 0 17268 557 2 0 17268 2 0 822088256 Stroke::Save stroke!E:\\\\devel\\\\3dswin\\\\src\\\\DLL\\\\STROKE\\\\stroke.cpp@451\n\
\n\
31 822089776 StrokeTable::Save +80 stroke!@</code></pre><h4 id=\"profiling-and-processors\">Profiling and Processors</h4><p>The profiler forces 3ds Max to run on a single processor. This provides more accurate timing results than trying to collect the data from multiple processors.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../troubleshooting.html\">Troubleshooting</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";