var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_3ds_max_generated_minidump\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using 3ds Max Generated Minidump Files</h1></div><h2 id=\"what-is-a-minidump-file\">What is a Minidump File</h2><p>A minidump file is a snapshot of the memory of a process, including the registers, the stack and possibly the heap memory. The size and the information within a minidump file depends on the machine architecture as well as specific OS settings.</p>\n\
<p>When an application crashes for any reason, a minidump file is created. The Minidump file provides information for debugging the program. It is most useful in the cases that the crash happens on a machine on which there is no access to the source code, and local debugging is not an option. The Microsoft Visual Studio Debugger open minidump files and allow developers to investigate the reasons for the crash.</p>\n\
<h2 id=\"3ds-max-and-minidump-files\">3ds Max and Minidump Files</h2><p>For each crash, 3ds Max can create two separate minidump files and with different information in each. The basic minidump is sent to the Autodesk servers for analysis, and the second file (which often includes the full program heap memory and is in the order of gigabytes in size) is stored locally. The filename for the second minidump is the same for the first basic minidump, except it has an additional &quot;_big&quot; at the end of the filename. Users can define the information in each minidump file through the Registry settings, Environment variables or the Command line switches. This article does not discuss the Registry settings.</p>\n\
<h3 id=\"environment-variables\">Environment Variables</h3><p>There are two environmental variables defined to control both minidump files:</p>\n\
<ul>\n\
<li><code>AMED_MAX_MINIDUMP</code> Customizes the standard minidump that is sent to Autodesk.</li>\n\
<li><code>AMED_MAX_BIGMINIDUMP</code> Customizes the second minidump that is kept locally on the computer. Parameters for this can be specified separately from the standard minidump. This second minidump will be created immediately after the standard minidump only if the environment variable is specified, or if the appropriate command line parameter is passed in.</li>\n\
</ul>\n\
<p>Both of these environment variables can be set with one of the following options:</p>\n\
<ul>\n\
<li><code>default</code> - The default setting. Currently this is set to medium.</li>\n\
<li><code>bas</code> or <code>basic</code> - A basic minidump, including no heap memory. Usually used only for <code>AMED_MAX_MINIDUMP</code>.</li>\n\
<li><code>med</code> or <code>medium</code> - A basic minidump plus 1024 bytes of heap information for each pointer on the stack. This is the same as default. Usually used only for <code>AMED_MAX_MINIDUMP</code>.</li>\n\
<li><code>full</code> - Generates a full heap minidump. For 3ds Max, this file size can be up to a few Gigs in file size. Usually used only for <code>AMED_MAX_BIGMINIDUMP</code>.</li>\n\
<li><code>none</code> - Used for <code>AMED_MAX_BIGMINIDUMP</code> only. It turns off the second, alternate minidump.</li>\n\
</ul>\n\
<h3 id=\"command-line-switches\">Command Line Switches</h3><ul>\n\
<li><code>-tm</code> Controls the behavior for the standard minidump file. You can pass in one of the options specified above after the switch. For example the command <code>3dsmax -tm basic</code> will generate a basic minidump file.</li>\n\
<li><code>-tbm</code> Turns on the second or additional minidump. Pass in one of the options specified above after the switch. For example, the command <code>3dsmax -tbm full</code> will generate an additional full heap snapshot called  <em>3dsmax_minidump_big.dmp</em>  and will place it in the user&#39;s local temp directory.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../troubleshooting.html\">Troubleshooting</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";