var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_qt_with_3ds_max_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using Qt with 3ds Max Plug-ins</h1></div><p>Starting with 3ds Max 2017, you can use the popular cross-platform development package Qt to create the user interface for your 3ds Max plug-in. See the  <em>maxsdk\\include\\Qt</em>  directory for headers exposing utilities for integrating Qt, as well as some customized Qt widgets used in the 3ds Max UI. Some of the standard plug-ins shipped with 3ds Max use Qt for their UI, and you can look at these in the SDK samples collection. Look at the  <em>maxsdk/samples/systems/sunlight</em>  project for an example of a plug-in that uses Qt for its UI.  There is also a very simple sample located in <em>maxsdk/howto/ui/qtObjectDemo</em>.</p>\n\
<p>The version of Qt required depends on the version of 3ds Max you are targeting.  See the SDK Requirements topic for specific version information. Before you can create new plug-ins or build existing ones that require Qt, you need to download Qt, and install the Visual Studio Qt VS Tools add-on.</p>\n\
<h2 id=\"getting-and-configuring-qt-for-3ds-max\">Getting and Configuring Qt for 3ds Max</h2><ol>\n\
<li>Download and install the required version of Qt from <a href=\"http://www.qt.io/download/\" target=\"_blank\">www.qt.io/download/</a>.  </li>\n\
</ol>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> There are different licensing options for Qt, including commercial and open-source licenses.  Any of the license versions will work for 3ds Max plug-in development, and it&#39;s up to the user to determine which best meets your needs.  See the <a href=\"https://doc.qt.io/qt-5/licensing.html\" target=\"_blank\">Qt Licensing</a> topic for more information.<br>Note: The Qt Maintenance tool makes it easy to install and update Qt.  For previous versions, you may need to look in the <a href=\"https://download.qt.io/archive/\" target=\"_blank\">Archive for older versions</a>.\n\
Note: When installing Qt, the only component you need to install is <em>MSVC 2019 64-bit</em>, the pre-built components for Visual Studio 2019 64-bit compiler.</div>\n\
<ol>\n\
<li><p>In Visual Studio, go to <strong>Tools &gt; Extension and Updates ... &gt; Online</strong> and search for Qt.  Install the <em>Qt Visual Studio Tools (2019)</em> add-on.  You will need to re-start Visual Studio.</p>\n\
</li>\n\
<li><p>The Qt Visual Studio Tools add-on determines the version and location of Qt for a project.  Set this under <strong>Extensions &gt; Qt VS Tools &gt; Qt Options</strong>.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"using_qt_with_3ds_max_plug-ins/creating_a_qt-based_plug-in.html\">Creating a Qt-based plug-in</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"using_qt_with_3ds_max_plug-ins/manual_widget_binding.html\">Manual Widget Binding</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"using_qt_with_3ds_max_plug-ins/using_multi_res_icons.html\">Using Multi-Res Icons in Max and Qt</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_plug-ins.html\">Writing Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";