var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_animation_controller_plu\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Animation Controller Plug-ins</h1></div><p>Controllers are the plug-in type responsible for directing all animation in 3ds Max. The section uses the Position constraint controller as a running example. The files that are relevant for this discussion are:</p>\n\
<ul>\n\
<li><em>\\MaxSDK\\Samples\\Controllers\\Position_cnstrnt.cpp</em>  The source code for the constraint.</li>\n\
<li><em>\\MaxSDK\\Samples\\Controllers\\ctrl.cpp</em>  DLL implementation of some controllers</li>\n\
<li><em>\\MaxSDK\\Samples\\Controllers\\ctrl.h</em>  Header file for class control. The relevant line of code here is:</li>\n\
<li><em>\\MaxSDK\\Include\\istdplug.h</em>  Interfaces into some of the standard plug-ins (including many of the controllers) that ship with Max.</li>\n\
<li><em>\\MaxSDK\\Include\\plugapi.h</em>  This file contains class ID&#39;s for plug-in classes.</li>\n\
</ul>\n\
<p>Controllers derive from the <code>Control</code> class. The primary methods that must be implemented by a plug-in are:</p>\n\
<p><code>Control::GetValue()</code> - Implementations usually cache the value and validity interval from the previous <code>GetValue()</code> call. An implementation is responsible to make sure that the validity interval gets updated correctly.</p>\n\
<p><code>Control::SetValue()</code> - The implementation is responsible for sending update notifications and needs to make sure any cached values get correctly cleared.</p>\n\
<p>The class <code>Control</code> is derived from class <code>Animatable</code>. A controller will need to implement methods from this class, as the default implementations are not valid.</p>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li><p><a href=\"plug-in_basics.html\"\">Plug-in Basics</a></p>\n\
</li>\n\
<li><p><a href=\"./../3ds_max_sdk_features/animation_time_and_controllers.html\">Animation, Time, and Controllers</a></p>\n\
</li>\n\
<li><p><a href=\"advanced_plug-in_topics.html\"\">Advanced Plug-in Topics</a></p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/serializing_controllers.html\">Serializing Controllers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/position_constraint_workflow.html\">Position Constraint Workflow</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/control_virtual_methods.html\">Control Virtual Methods</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/ctrl_relative_and_ctrl_absolute.html\">CTRL_RELATIVE and CTRL_ABSOLUTE</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/undo_and_redo_in_a_controller.html\">Undo and Redo in a Controller</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/responding_to_changes_in_paramet.html\">Responding to Changes in Parameters</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_animation_controller_plu/making_controllers_lockable.html\">Making Controllers Lockable</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_plug-ins.html\">Writing Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";