var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"control_virtual_methods\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Control Virtual Methods</h1></div><p>The following methods of <code>Control</code> are often overridden by a plug-in controller.</p>\n\
<ul>\n\
<li><code>Control::Copy()</code> - When a controller is assigned to a track in the track view, the new controller is plugged into the parameter and this method is called on the new controller. A pointer to the old controller is passed in to this method. The new controller can attempt to copy any data that it can from the old controller. At the very least it should initialize itself to the value of the old controller at frame 0.</li>\n\
<li><code>Control::IsKeyable()</code> - Indicates if the controller is a keyframe controller. This means the controller stores keys at certain frames and interpolates between keys at other times. It returns a nonzero value if the controller is a keyframe controller or zero otherwise. The default implementation returns one indicating that it is a keyframe controller.</li>\n\
<li><code>Control::IsLeaf()</code> - Indicates whether the controller is a leaf controller. If a controller is a leaf controller, then it must not by definition have any sub-controllers or references. The controller should return <code>TRUE</code> if it has no sub-controllers. For example, a PRS controller is not a leaf controller (because it has sub-controllers for Position, Rotation and Scale), but a simple key-framed float controller is a leaf controller. The default implementation returns <code>TRUE</code> indicating the controller is a leaf controller.</li>\n\
<li><code>Control::GetValue()</code> - Retrieves the value of the controller at the specified time, and updates the validity interval passed in to reflect the interval of the controller. This method is responsible for handling Out of Range Types, Ease Curves and Multiplier Curves.</li>\n\
<li><code>Control::SetValue()</code> - This method sets the value of the controller at the specified time. This method is responsible for handling Out of Range Types, Ease Curves and Multiplier Curves.</li>\n\
<li><code>Control::CommitValue()</code> - This method, along with <code>SetValue()</code> comprise an &quot;inner&quot; hold and restore mechanism (see the topic <a href=\"undo_and_redo_in_a_controller.html\"\">Undo and Redo in a Controller</a>). When the controller&#39;s <code>SetValue()</code> method is called, if the commit parameter is nonzero, then the controller should save the value of the controller at the current time into its cache and also &#39;commit&#39; the value. For example, this stores a key in the case of a keyframe controller. If the set value was not committed then <code>RestoreValue()</code> may be called to restore the previous value. The default implementation does nothing.</li>\n\
<li><code>Control::RestoreValue()</code> - This method is the other half of the &quot;inner&quot; hold and restore mechanism. This method is called to restore a previously saved value. This method restores the current cache value to the value that was set before <code>SetValue()</code> was last called. The way the standard 3ds Max controllers handle this is as follows: When <code>SetValue()</code> is called a temporary hold mechanism (<code>TempStore</code> defined in <code>control.h</code>) is used to hold the current value. Then the new value is set. If <code>RestoreValue()</code> is later called then it restores the current value from the temporary storage. Note that in addition to restoring from the <code>TempStore</code>, another way a controller may restore the current value is to re-interpolate the keys. The default implementation does nothing.</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";