var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"ctrl_relative_and_ctrl_absolute\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>CTRL_RELATIVE and CTRL_ABSOLUTE</h1></div><p>The absolute (<code>CTRL_ABSOLUTE</code>) and relative (<code>CTRL_RELATIVE</code>) options are used by both <code>Control::GetValue()</code> and <code>Control::SetValue()</code> in a similar way.</p>\n\
<ul>\n\
<li><code>Control::GetValue()</code><ul>\n\
<li><code>CTRL_RELATIVE</code> means that we&#39;re passing in a data structure which already contains a value and the controller is supposed to modify that value. In the case of position, rotation, scale, and TM controllers, this structure is a matrix. Note that not all controllers work in this way. A Lookat constraint, for example, ignores the incoming transform, because the desired world orientation is independent of the incoming orientation.</li>\n\
<li><code>CTRL_ABSOLUTE</code> indicates that we want the absolute value directly from the controller.</li>\n\
</ul>\n\
</li>\n\
<li><code>Control::SetValue()</code><ul>\n\
<li><code>CTRL_ABSOLUTE</code> indicates that the given value should completely replace the current value in the controller.</li>\n\
<li><code>CTRL_RELATIVE</code> indicates that the given value should be &#39;added&#39; to the current value. For data types which operate in a multiplicative space (rotation and scale) &#39;added&#39; means &#39;multiply&#39;.</li>\n\
</ul>\n\
</li>\n\
</ul>\n\
<p>In the example of a position controller, <code>CTRL_RELATIVE</code> indicates that the <code>val</code> pointer passed in points to a matrix. Typically the position controller would then pre-multiply in its translation however the controller could modify the matrix in other ways. For example the path controller overwrites the translation portion of the matrix instead of pre-multiplying.</p>\n\
<h2 id=\"note-about-rotation-controllers\">Note about Rotation Controllers</h2><p>One other important issue is that rotation controllers expect different data types depending on whether <code>Control::GetValue()</code> or <code>Control::SetValue()</code> are called with <code>CTRL_ABSOLUTE</code> or <code>CTRL_RELATIVE</code>. In the <code>CTRL_RELATIVE</code> case, an angle/axis structure is used, and in the <code>CTRL_ABSOLUTE</code> case a quaternion is used. This allows for multiple revolutions to be tracked by the controller (which would have been lost if the angle/axis was converted to a quaternion).</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";