var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"position_constraint_workflow\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Position Constraint Workflow</h1></div><p>The user can employ the Position Constraint to make a source object move to and be coincident with another object, called the target object. Position Constraint,which constrains the position of an object to a target, is similar to instancing the position controller of one object and pasting it on another. Rotation and scaling is completely free. Once engaged, the source object becomes constrained to the target object&#39;s position. Animating the target object&#39;s position causes the source (constrained) object to follow.</p>\n\
<p><img src=\"./images/position_constraint.png\" alt=\"\"></p>\n\
<p>In the figure below the red sphere is the source object and it is position constrained to the yellow sphere, which is the target object. The constraint is under the special option called &#39;Keep Initial Offset&#39;, such that the source object doesn&#39;t jump to the target object when assigned but preserves its current position. Essentially the source object appears to be connected by a rigid rod to the target object. If the target object&#39;s position is animated through different frames, the source object faithfully follows the target on an identical trajectory - the trajectories are shown below with red lines.</p>\n\
<p><img src=\"./images/GUID-06A50539-FF03-49DF-AC87-FD69EE8850B8-low.jpg\" alt=\"\"></p>\n\
<p>The Position Constraint can also move an object to the position of the weighted-average of several different targets. Each target has a weight value defining its influence. A value of 0 is equal to &quot;off&quot;. Any value greater than 0 will cause the target to influence the constrained object. Weight values may be animated to create effects such as a ball being picked up from a table. Note that the weights are pure numbers (which are normalized &quot;under the hood&quot; before being applied) and not percentages.</p>\n\
<p>Procedure to engage the position constraint:</p>\n\
<ol>\n\
<li>Select the object you want to constrain</li>\n\
<li>Choose Animation menu &gt; Constraints &gt; Position Constraint.</li>\n\
<li>Select the target object.</li>\n\
</ol>\n\
<p>The user interface of the Position Constraint in 3ds Max is shown below. The various options of the constraint can be accessed through the motion panel - see the UI snapshot below. A familiarity with the UI will be necessary when we discuss how this is handled by the code.</p>\n\
<p><img src=\"./images/position_constraint2.png\" alt=\"\"></p>\n\
<h2 id=\"user-interface-description\">User Interface Description</h2><p>The UI works as follows. The user selects an object and assigns Position Constraint. Next, in the Position Constraint UI menu the following functions can be performed:</p>\n\
<ol>\n\
<li>Add Position Target: The user clicks on this button and selects one or multiple targets on the scene. The Position Constraint mode is cancelled by a right mouse click. The selected targets appear in the listbox with their default weight of 50.</li>\n\
<li>Delete Position Target: The user can select (highlight) a target in the listbox and remove it from the target list by clicking on the &quot;Delete Position Target&quot; button.</li>\n\
<li>The weight spinner control: The user can type-in the required numerical weight for the target selected in the listbox. The weight can be modified with the adjacent spinner. The listbox shows the weights as integers but the weight edit box shows the selected weight as a decimal point float.</li>\n\
<li>&quot;Keep Initial Offset&quot; option. This option is off by default. In the default mode once the constraint is applied to a single source object, the object jumps to the to the weighted-average position of the targets and their pivot points coincide. When this option is selected the source object maintains the offset between its initial position and the initial position of the target.</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";