var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"responding_to_changes_in_paramet\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Responding to Changes in Parameters</h1></div><p>When the position target weight parameter is changed for the Position Constraint controller, the list box must be redrawn. To do this the Position Constraint controller implements <code>ReferenceMaker::NotifyRefDependent()</code>. The message parameters passed into this method is the specific message which needs to be handled. The <code>hTarget</code> parameter is a pointer to the reference target that sent the message. The reference maker uses this handle to know specifically which reference target sent the message.</p>\n\
<h2 id=\"example\">Example</h2><pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">RefResult PosConstPosition::NotifyRefChanged(\n\
  Interval iv, RefTargetHandle hTarg, PartID&amp; partID, RefMessage msg)\n\
 {\n\
   switch (msg)\n\
   {\n\
     case REFMSG_CHANGE:\n\
      if (hTarg == pblock) {\n\
         ParamID changing_param = pblock-&gt;LastNotifyParamID();\n\
         switch (changing_param)\n\
         {\n\
          case position_target_weight:\n\
            RedrawListbox(GetCOREInterface()-&gt;GetTime());\n\
            break;\n\
          default:\n\
            pos_const_paramblk.InvalidateUI(changing_param);\n\
            break;\n\
         }\n\
         ivalid.SetEmpty();\n\
       }\n\
      break;\n\
\n\
     case REFMSG_OBJECT_CACHE_DUMPED:    \n\
       return REF_STOP;\n\
      break;\n\
     }\n\
   return REF_SUCCEED;\n\
   }\n\
};\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";