var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"serializing_controllers\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Serializing Controllers</h1></div><p>When writing the <code>ReferenceMaker::Load()</code> and <code>ReferenceMaker::Save()</code> methods of a controller it is important that the before you read or write any custom data (i.e. chunks) that you call the <code>Control::Load()</code> and <code>Control::Save()</code> functions.</p>\n\
<p>The following code demonstrates how this works:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">#define LOCK_CHUNK  0x2535  //the lock value\n\
\n\
IOResult IndePosition::Save(ISave *isave)\n\
{\n\
  Control::Save(isave);\n\
\n\
  ULONG nb;\n\
  int on = (mLocked==true) ? 1 :0;\n\
  isave-&gt;BeginChunk(LOCK_CHUNK);\n\
  isave-&gt;Write(&amp;on, sizeof(on), &amp;nb); \n\
  isave-&gt;EndChunk();   \n\
\n\
  return IO_OK;\n\
}\n\
\n\
IOResult IndePosition::Load(ILoad *iload)\n\
{\n\
  ULONG nb;\n\
  IOResult res;\n\
  res = Control::Load(iload);\n\
  if (res!=IO_OK) return res;\n\
  while (IO_OK==(res=iload-&gt;OpenChunk()))\n\
  {\n\
    ULONG curID = iload-&gt;CurChunkID();\n\
    if (curID==LOCK_CHUNK)\n\
    {\n\
       int on;\n\
       res=iload-&gt;Read(&amp;on, sizeof(on), &amp;nb);      \n\
       mLocked = on ? true : false;\n\
    }\n\
    iload-&gt;CloseChunk();\n\
    if (res!=IO_OK)  return res;\n\
  }\n\
  return IO_OK; \n\
}\n\
</code></pre><p>This is necessary so that the <code>Control</code> base clas is given a chance to serialize the before and after out of range type (ORT) values.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";