var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"undo_and_redo_in_a_controller\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Undo and Redo in a Controller</h1></div><p>Controllers, like objects and modifiers, need to be able to undo and redo themselves. Whenever a controller is about to modify its data, it checks the state of the global <code>Hold</code> object (<code>theHold</code>) to see if it is holding. If so it must register a <code>RestoreObject</code> with the hold. Controllers also support another type of undo and redo through two methods: <code>Control::CommitValue()</code> and <code>Control::RestoreValue()</code>.</p>\n\
<p>The purpose of this &#39;inner&#39; hold and restore buffer is not to hold and restore the entire state of the controller, but to hold and restore the value of the controller at a single instant in time. When <code>Control::SetValue()</code> is called on a controller with the commit parameter equal to zero, the controller records the new value, but does not necessarily modify any data. For example, a keyframe controller doesn&#39;t actually generate a new key -- it just updates a cache it maintains. Then, if the controller is asked to evaluate itself at the exact same TimeValue for which the controller was just set, it can just return the cached value.</p>\n\
<p>The <code>Control::SetValue()</code> method will simply throw out the temporary value whereas the <code>Control::CommitValue()</code> method will cause the value to be actually committed (a key generated in the case of a keyframe controller).</p>\n\
<p>The purpose of this inner hold and restore is for iterative procedures that need to set values many times at a single <code>TimeValue</code> and don&#39;t want to incur the overhead of things like recalculating the tangents at adjacent keys. Some examples of these types of procedures are inverse kinematics and collision detection.</p>\n\
<h2 id=\"hold-system-example\">Hold System Example</h2><p>The following are the steps taken by 3ds Max when a manipulator is dragged:</p>\n\
<ol>\n\
<li><p>3ds Max sets <code>theHold</code>.</p>\n\
</li>\n\
<li><p>3ds Max calls <code>Control::SetValue()</code> to set the new value</p>\n\
</li>\n\
<li><p>Repeat each time the mouse moves, until the mouse button goes up</p>\n\
</li>\n\
<li><ol>\n\
<li>3ds Max calls <code>theHold::Cancel()</code>, which restores the manipulator to the original position</li>\n\
<li>3ds Max calls <code>Control::SetValue()</code> with the new position minus the original position</li>\n\
</ol>\n\
</li>\n\
<li><p>3ds Max calls <code>theHold::Cancel()</code>, which restores the manipulator to the original position</p>\n\
</li>\n\
<li><p>3ds Max calls <code>Control::SetValue()</code> with the new position minus the original position</p>\n\
</li>\n\
<li><p>When the mouse button goes up <code>theHold::Accept()</code> is called.</p>\n\
</li>\n\
</ol>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_animation_controller_plu.html\">Writing Animation Controller Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";