var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"displaying_the_modifier_gizmo\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Displaying the Modifier Gizmo</h1></div><p>Gizmos (also called the modifier apparatus) are viewport icons that provide a visual representation in the scene of a modifier at that the user can manipulate. They can be as simple as the 3D box used by the bend modifier, or as complex as an FFD lattice.</p>\n\
<p>For simple modifiers, a gizmo is a 3d box that the modifier has been applied to. For more information see <a href=\"./../../3ds_max_sdk_features/modeling/modifiers/modifier_types/object_modifiers/simple_modifiers.html\">Simple Modifiers</a>.</p>\n\
<p>A modifier plug-in must implement a method to display the modifier&#39;s gizmo in the 3D viewport. This is done by implementing a member function of the <code>BaseObject</code> class called <code>BaseObject::Display()</code>. The <code>GraphicsWindow</code> class provides a number of drawing routines for this purpose.</p>\n\
<p>If the plug-in is inherited from <code>SimpleMod</code>, the member function <code>SimpleMod::Display()</code> provides a default implementation that draws the gizmo as a 3D box to which the modifier is applied. For example, the Bend modifier&#39;s gizmo is drawn as a bent 3D box. The developers may display their modifier&#39;s gizmo in any manner they wish, if they are not inherited from <code>SimpleMod</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_modifier_plug-ins.html\">Writing Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";