var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"indicating_required_channels\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Indicating Required Channels</h1></div><p>A modifier must indicate to the system which channels of the pipeline it requires in order to perform its modification. To do this the developer must override the method <code>Modifer::ChannelsUsed()</code>. This specifies the channels that a modifier needs in order to apply its deformation. This should at least contain the channels indicated by the <code>Modifer::ChannelsChanged()</code> method, but may be more. For example, a modifier that applies a UV mapping may need the geometry channel but may only modify the texture map channel.</p>\n\
<p>A default implementation provided by <code>SimpleMod::ChannelsUsed()</code> is:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">return PART_GEOM|PART_TOPO|SELECT_CHANNEL|SUBSEL_TYPE_CHANNEL;</code></pre><p>This means it needs the geometry channel (the vertices) and the topology channel (the face and polygon structures), and the sub-selection channel.</p>\n\
<p>If a modifier doesn&apos;t specify that it needs a given channel then that channel may not be valid in the object state that is passed into that modifier&apos;s <code>ModifyObject()</code> method.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_modifier_plug-ins.html\">Writing Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";