var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"modifier_validity\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Modifier Validity</h1></div><p>When a modifier is finished deforming the object, it needs to include its validity interval in the validity interval of the object.</p>\n\
<p>This way if an object was static, but had an animated modifier applied to it, the system would know that the modifier would need to be re-evaluated if the user moves to a new time. To do this, the modifier calls the <code>BaseObject::UpdateValidity()</code> function on the object, specifying the channel altered and the modifier&#39;s interval. Modifiers that only affect the geometry channel would specify <code>GEOM_CHAN_NUM</code>. Modifiers that affect other channels would have to call this method once for each channel modified. The interval that is passed in to this method is then intersected with the interval that the object keeps for each channel. So as the object travels through the pipeline, its validity intervals are potentially getting smaller as (possibly) animated modifiers are applied to it.</p>\n\
<p>The base class <code>SimpleMod</code> and <code>SimpleWSMMod</code> calls <code>BaseObject::UpdateValidity()</code> with <code>GEOM_CHAN_NUM</code>. The developer must supply the modifier&#39;s validity interval to <code>SimpleWSMMod</code> by implementing the virtual method <code>RefTarget::GetValidity()</code>.</p>\n\
<h2 id=\"bend-example\">Bend Example</h2><p>The Bend modifier sample implements the <code>RefTarget::GetValidity()</code> method by starting with an interval of <code>FOREVER</code>, then intersecting it with the intervals of its animated parameters. This computes the overall validity interval for the modifier.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_modifier_plug-ins.html\">Writing Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";