var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"sub-object_selection\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Sub-Object Selection</h1></div><p>If the modifier supports sub-object selection, the plug-in must provide methods to allow the system to manipulate the sub-object components of the modifier. When a modifier&#39;s parameters are being edited, it has the option of providing the system with different levels of sub-object selection. There are two types of sub-object selection:</p>\n\
<ol>\n\
<li>Selection of a modifier&#39;s Gizmo or Center - A modifier can have a visual representation in the scene which users can manipulate called a gizmo. This can be something as simple as a 3D box or something more complex like an FFD lattice. The Bend modifier uses a 3D box. When Gizmo is selected in the sub-object selection list of Max&#39;s UI, the user can transform the modifier&#39;s gizmo itself -- that is, they can adjust its location, orientation, and scale in relation to the object it is affecting. When Center is selected in the list, they can transform the pivot point of the modifier&#39;s gizmo. For example, if you want a bend to occur about the base of the Bend gizmo, you could move the center to the base of the gizmo.</li>\n\
<li>Selection of components in the pipeline - The second type of sub-object selection is selection of components of the object flowing through the pipeline. If the object in the pipeline is a triangle object, then sub-object selection level might be things like vertex, face, edge, etc. These are options for the Edit Mesh modifier, for instance.</li>\n\
</ol>\n\
<p>A modifier notifies the system of the sub-object selection levels that it provides when the modifier&#39;s <code>Animatable::BeginEditParams()</code> method is called.</p>\n\
<p>The Bend modifier for example has sub-object levels for Gizmo and Center. When the user enters sub-object level they expect the standard tool bar translation tools will work for adjusting the sub-object components, for instance moving the center or scaling the gizmo.</p>\n\
<p>When the user changes the selection of the sub-object drop down, the modifier is notified. At the time of the notification, the modifier is expected to provide an instance of a class derived from <code>CommandMode</code> to support move, rotate, uniform scale, non-uniform scale, and squash modes. These modes replace their object level counterparts, although the user still uses the move/rotate/scale tool buttons in the tool bar to activate these modes. A plug-in developer does not need to support all of these modes. For example, they may just support move because rotate and scale don&#39;t apply to the specific plug-in type. Any modes that the plug-in doesn&#39;t support will be grayed out in the toolbar.</p>\n\
<p>In addition to move/rotate/scale, a plug-in can always have other modes. For instance, the Edit Mesh modifier has an extrude mode where the user can click and drag to interactively extrude faces of a mesh.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/implementing_sub-object_selectio.html\">Implementing Sub-Object Selection</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/modifier_selection_methods.html\">Modifier Selection Methods</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/sub-object_selection_in_edit_mod.html\">Sub-Object Selection in Edit Modifiers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/edit_mesh_selection_example.html\">Edit Mesh Selection Example</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/named_sub-object_selection_sets.html\">Named Sub-Object Selection Sets</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"sub-object_selection/sub-object_coordinate_systems.html\">Sub-Object Coordinate Systems</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_modifier_plug-ins.html\">Writing Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";