var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"edit_mesh_selection_example\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Edit Mesh Selection Example</h1></div><p>The sample code below is from  <em>\\MAXSDK\\SAMPLES\\MODIFIERS\\EDITMESH.H</em> . It shows how the extrude command mode of the Edit Mesh modifier uses the <code>SelectionProcessor</code> class to handle selection yet performs its own work after the selection process has been handled. The extrude command mode allows the user to select items with the mouse using all the standard logic such as box selection, and using the <em>Ctrl</em> and <em>Alt</em> keys. If the user drags the mouse however, the extrude operation is performed. By using the selection processor all the logic for selection is handled automatically.</p>\n\
<p>A command mode has a method <code>MouseProc()</code> that returns an instance of <code>MouseCallBack</code> to handle the user / mouse interaction. In the extrude command mode&apos;s implementation of <code>MouseProc()</code> it returns an instance of a selection processor (which is derived from <code>MouseCallBack</code>). The constructor for the selection processor takes a pointer to another <code>MouseCallBack</code>. This is the extrude mouse callback. When the command mode is processing mouse input, the selection processor mouse callback is called first. It processes all the logic for the selection. If the user drags the mouse however the selection processor calls the extrude mouse callback to handle the extrude operation. Below are the class definitions showing how this is set up.</p>\n\
<p>The mouse callback below implements the user / mouse interaction for the extrude operation.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class ExtrudeMouseProc : publicMouseCallBack\n\
{\n\
   private:\n\
      MoveTransformer moveTrans;\n\
     EditMeshMod *em;\n\
     IObjParam *ip;\n\
     IPoint2 om;\n\
   public:\n\
     //constructor\n\
     ExtrudeMouseProc(EditMeshMod* mod, IObjParam *i)\n\
       : moveTrans(i)\n\
         {em=mod;ip=i;}\n\
\n\
     int proc(HWND hwnd, int msg, int point, int flags, IPoint2 m );\n\
};</code></pre><p>The code below defines a class derived from <code>GenModSelectionProcessor</code>. The constructor passes on the mouse procedure for the extrusion interaction to the base class <code>GenModSelectionProcessor</code>. This allows the selection processor to call the extrusion mouse procedure.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class ExtrudeSelectionProcessor : public  GenModSelectionProcessor\n\
{\n\
   protected:\n\
     HCURSOR GetTransformCursor();\n\
   public:\n\
     ExtrudeSelectionProcessor(ExtrudeMouseProc *mc, Modifier *m, IObjParam *i)\n\
       : GenModSelectionProcessor(mc,m,i) {}\n\
};</code></pre><p>The command mode declares an instance of the selection processor and extrude mouse procedure. The extrude mouse procedure is passed into the selection processor.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">class ExtrudeCMode : public CommandMode\n\
{\n\
   private:\n\
      ChangeFGObject fgProc;\n\
     ExtrudeSelectionProcessor mouseProc;\n\
     ExtrudeMouseProc eproc;\n\
     EditMeshMod* em;\n\
   public:\n\
     //Constructor\n\
     ExtrudeCMode(EditMeshMod* mod, IObjParam *i)\n\
       : fgProc(mod), mouseProc(&amp;eproc,mod,i), eproc(mod,i)\n\
         {em=mod;}\n\
\n\
     int Class() { return MODIFY_COMMAND; }\n\
     int ID()   { return CID_EXTRUDE; }\n\
\n\
     MouseCallBack *MouseProc(int *numPoints)\n\
       { *numPoints=2; return &amp;mouseProc; }\n\
      ChangeForegroundCallback *ChangeFGProc()\n\
       { return &amp;fgProc; }\n\
     BOOL ChangeFG( CommandMode *oldMode )\n\
       { return oldMode-&gt;ChangeFGProc() != &amp;fgProc; }\n\
\n\
     void EnterMode();\n\
     void ExitMode();\n\
};</code></pre><p>See the source code in <code>EDITMOPS</code>.CPP for the full implementation of the methods of these classes.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sub-object_selection.html\">Sub-Object Selection</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";