var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"named_sub-object_selection_sets\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Named Sub-Object Selection Sets</h1></div><p>A modifier that supports sub-object selection can choose to support named sub-object selection sets. This allows the user to save and restore certain sub-object selection sets and not have to pick them over and over. The modifier indicates it wishes to do so by returning TRUE from <code>BaseObject::SupportsNamedSubSels()</code>.</p>\n\
<p>A modifier that wishes to support this capability maintains its list of named sub-object selections. When the user enters sub-object selection mode the modifier should add its named selection sets into the drop down by overriding the method <code>Interface::AppendSubObjectNamedSelSet()</code>.</p>\n\
<p>A modifier may call this method to add sub-object named selection sets to the named selection set drop down list in the 3ds Max tool bar. This should be done whenever the selection level changes (in the Modifiers <code>BaseObject::ActivateSubobjSel()</code> method).</p>\n\
<p>The following methods of <code>BaseObject</code> are called when the user picks items from the drop down list:</p>\n\
<ul>\n\
<li><code>BaseObject::ActivateSubSelSet()</code> - When the user chooses a name from the drop down list this method is called. The plug-in should respond by selecting the set identified by the name passed.</li>\n\
<li><code>BaseObject::NewSetFromCurSel()</code> - If the user types a new name into the named selection set drop down then this method is called. The plug-in should respond by creating a new set and give it the specified name.</li>\n\
<li><code>BaseObject::RemoveSubSelSet()</code> - If the user selects a set from the drop down and then chooses Remove Named Selections from the Edit menu this method is called. The plug-in should respond by removing the specified selection set.</li>\n\
</ul>\n\
<p>The following methods from <code>Interface</code> class also deal with named sub-object selection sets:</p>\n\
<ul>\n\
<li><code>Interface::ClearSubObjectNamedSelSets()</code> - Clears the named selections from the drop down.</li>\n\
<li><code>Interface::ClearCurNamedSelSet()</code> - Clears the current edit field of the named selection set drop down.</li>\n\
</ul>\n\
<p>For sample code that deals with named sub-object selection sets see  <em>\\MAXSDK\\SAMPLES\\MODIFIERS\\EDITMESH.CPP</em> .</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sub-object_selection.html\">Sub-Object Selection</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";