var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"sub-object_coordinate_systems\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Sub-Object Coordinate Systems</h1></div><p>When a modifier or controller is in a sub-object selection level, it has the ability to define the meaning of some of 3ds Max&apos;s reference coordinate systems. 3ds Max&apos;s reference coordinate system has two parts:</p>\n\
<ol>\n\
<li>The reference coordinate system drop down list</li>\n\
<li>The coordinate center button.</li>\n\
</ol>\n\
<h2 id=\"reference-coordinate-system-drop-down-list\">Reference coordinate system drop down list</h2><p><img src=\"./images/coordinate_system_dropdown.png\" alt></p>\n\
<p>This lets the user select the orientation of the reference coordinate system. While the user is in a sub-object selection state, &apos;local&apos; refers to the local coordinate system of the currently selected sub-object element and &apos;parent&apos; refers to the node&apos;s local coordinate system.</p>\n\
<p>What a sub-object&apos;s local coordinate system means is up to the modifier or controller. For example, Bend (and in fact, any modifier using <code>SimpleMod</code> as a base class) define local to mean the coordinate system of the gizmo. The Edit Mesh modifier defines local to mean different things for face and vertex selection levels. For face, the modifier constructs a coordinate system where the Z axis is parallel to the face&apos;s normal and X lies somewhere in the world XY plane perpendicular to Z. The Y axis is then given by X and Z. For vertices, a similar thing is done -- the vertex normal used for smoothing is used to define the Z axis. X and Y are constructed the same way as above.</p>\n\
<h2 id=\"the-coordinate-center-button\">The coordinate center button</h2><p><img src=\"./images/coordinate_system_buttons.png\" alt></p>\n\
<p>These buttons allows the user to choose the position of the center of the reference coordinate system. It has 3 options:</p>\n\
<ul>\n\
<li>Use Pivot Point Center</li>\n\
<li>Use Selection Center</li>\n\
<li>Use Transform Coordinate Center</li>\n\
</ul>\n\
<p>If the reference drop down list is set to local and the center button is set to center of the transform coordinate system, then the modifier or controller defines the position of the center when it constructs the local coordinate system. For center of selection and pivot point, it is up to the modifier or controller to decide what these mean. The Edit Mesh modifier defines center of the selection set to be the average of all vertices referenced by selected faces and the pivot point to be the center of a face cluster.</p>\n\
<h2 id=\"coordinate-and-tm-methods\">Coordinate and TM Methods</h2><p>When the user is in a sub-object selection level, the system needs to get the reference coordinate system definition from the current modifier or controller being edited so that it can display the axes. Two methods (from <code>BaseObject</code> or <code>Control</code>) allow the system to do this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GetSubObjectCenters( SubObjAxisCallback *cb,TimeValue t,INode *node)</code></pre><p>This method specifies the position of the center. The plug-in enumerates its centers and calls the callback <code>cb</code> once for each.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">GetSubObjectTMs( SubObjAxisCallback *cb,TimeValue t,INode *node)</code></pre><p>This method returns the axis system of the reference coordinate system. The plug-in enumerates its transformation matrices and calls the <code>SubObjAxisCallback</code> callback once for each.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../sub-object_selection.html\">Sub-Object Selection</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";