var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"using_a_deformer\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Using a Deformer</h1></div><p>A <code>Deformer</code> derived object implements a <code>Deformer::Map()</code> method that takes an object&#39;s point and returns a new object. Any modifier can use a deformer, but a simple modifier requires that this mechanism is used. A modifier that inherits from <code>SimpleMod</code> must override <code>SimpleMod::GetDeformer()</code> and return an object that inherits from the <code>Deformer</code> base class.</p>\n\
<p>The <code>Deformer::Map()</code> is called by the system for each point in the modified mesh or selection and returns the modified (deformed) point.</p>\n\
<p>Alternatively a deformer can be passed to a deformable object&#39;s <code>Object::Deform()</code> method.</p>\n\
<h2 id=\"bend-example\">Bend Example</h2><p>In the Bend example the <code>BendDeformer</code> class inherits from <code>Deformer</code>. The <code>BendDeformer::Map()</code> function operates on the incoming point in a different coordinate system. Thus it first converts the point into local coordinates by multiplying it a transform matrix. Various operations are done upon the point, and then the point is converted back into a different coordinate system and returned.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_modifier_plug-ins.html\">Writing Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";