var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"displaying_the_object_in_the_vie\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Displaying the Object in the Viewport</h1></div><p>When deriving from a <code>SimpleObject2</code>, a plug-in only has to build the mesh in its override of the virtual function <code>SimpleObject::BuildMesh()</code>. In other plug-ins that derives from <code>BaseObject</code>, the plug-in must draw itself in the viewport in its implementation of <code>BaseObject::Display()</code> function.</p>\n\
<p>The following code snippet is an example implementation of <code>BaseObject::Display()</code>.</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">int SimpleObject::Display(TimeValue t, INode* inode, ViewExp *vpt, int flags)\n\
{\n\
   if (!OKtoDisplay(t)) return 0;\n\
   GraphicsWindow *gw = vpt-&gt;getGW();\n\
   Matrix3 mat = inode-&gt;GetObjectTM(t);  \n\
   UpdateMesh(t);\n\
   gw-&gt;setTransform(mat);\n\
   mesh.render(gw, inode-&gt;Mtls(),\n\
     (flags&amp;USE_DAMAGE_RECT) ? &amp;vpt-&gt;GetDammageRect() : NULL, COMP_ALL, inode-&gt;NumMtls());\n\
   return(0);\n\
}\n\
\n\
\n\
</code></pre>\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_object_plug-ins.html\">Writing Object Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";