var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_crowd_behavior_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Crowd Behavior Plug-ins</h1></div><p>A crowd behavior plug-in for character studio inherits from the <code>BaseBehavior</code> class found in <code>bhvr</code>.h. A behavior plug-in has a super class of BEHAVIOR_SUPER_CLASS_ID exists in the 3ds Max plug-in directory. The 3ds Max crowd system uses the super class id to find the plug-in as an available behavior.</p>\n\
<p>There are three basic kind of behaviors: force, constraint, and orientation. The type of behavior is queried using the function <code>BaseBehavior::BehaviorType()</code>.</p>\n\
<p>Before writing a behavior plug-in it is important to understand the basic algorithm used by the crowd system during a simulation. This algorithm is performed for each delegate each frame. The crowd system always computes on a frame by frame basis, not ticks.</p>\n\
<ol>\n\
<li>All of the force vectors and speeds for a delegate are gotten from its active force behaviors by calling the plug-ins <code>BaseBehavior::Perform()</code> function.</li>\n\
<li>Based upon the delegate&#39;s motion parameters, these force vectors and speeds are averaged and integrated to compute a velocity for the delegate.</li>\n\
<li>This velocity may then be modified, if the delegate has an active constraint behavior, by calling the behavior&#39;s <code>BaseBehavior::Constrain()</code> function.</li>\n\
<li>The velocity may then be modified if the delegate has an active avoidance behavior.</li>\n\
<li>After the velocity is set, if there is an active orientation behavior, it is used to set the orientation of the delegate by calling the behavior&#39;s <code>BaseBehavior::Orient()</code> function. Otherwise the orientation is calculated from the default delegate parameters.</li>\n\
<li>Finally, the velocity is integrated and a new position is calculated.</li>\n\
</ol>\n\
<p>The new position of the delegate isn&#39;t set until after all of the forces are calculated for all of the behaviors and all of the delegates.</p>\n\
<p>For a biped crowd, bipeds use goals and not forces to determine which direction they should go in. In order to create a force behavior that will work with a biped, a goal position must be specified. The movement of the biped is then determined by using the goal to select clips found in the motion flow graph.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_other_plug-in_types.html\">Writing Other Plug-in Types</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";