var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_global_utility_plug-ins_\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Global Utility Plug-ins (GUPs)</h1></div><p>A global utility plug-in should inherit from the GUP class, and may implement one ore more of the following functions.</p>\n\
<ul>\n\
<li><code>GUP::Start()</code> - Perform initialization tasks, and indicate to 3ds Max whether it is okay to be deallocated.</li>\n\
<li><code>GUP::Stop()</code> - Perform finalization tasks such as freeing resources.</li>\n\
<li><code>GUP::Control()</code> - Perform custom processing.</li>\n\
<li><code>GUP::Save()</code> - Called when 3ds Max is saving a scene file.</li>\n\
<li><code>GUP::Load()</code> - Called when 3ds Max is loading a scene file.</li>\n\
<li><code>GUP::DeleteThis()</code> - Called when 3ds Max requests the plug-in to be deleted. A typical implementation would be <code>{ delete this; }</code>.</li>\n\
</ul>\n\
<p>Once a GUP is started, 3ds Max will not make any other calls into the GUP until the GUP is unloaded and deallocated. Other plug-ins who access a pointer to the GUP may choose to call <code>GUP::Control()</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_other_plug-in_types.html\">Writing Other Plug-in Types</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";