var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_image_io_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing Image IO Plug-ins</h1></div><p>Image IO plug-ins load and save the various file types are derived from class <code>BitmapIO</code>. Examples of this type of plug-in are the GIF, FLC and JPG IO modules. When writing these kind of plug-ins the memory handling of bitmaps requires special attention.</p>\n\
<p>The memory allocated to a bitmap is managed internally by an instance of <code>BitmapStorage</code>. This class provides access to the pixels through a uniform interface.</p>\n\
<p>When a developer creates an image, the memory is allocated by the system. As long as the bitmap is being used within the system, the bitmap remains allocated. This is handled internally by a usage counter that tracks if a bitmap is still being used. If another use of the bitmap takes place, the usage count is incremented. If the use of a bitmap ends, the usage count is decremented. When the usage count for the bitmap goes to zero, the system frees the memory. This happens automatically without intervention from the plug-in.</p>\n\
<p>For example, once a bitmap is loaded (this is never the case when a bitmap is created), a storage for the image is created to hold the actual bitmap. If a second attempt to open this same bitmap is made (the same file and the same frame), instead of creating a new storage, the bitmap is created pointing to the existing storage. In the storage a counter is incremented to tell how many bitmaps are using it. When a developer deletes the bitmap (i.e. <code>delete</code> MyMap;) the destructor calls the storage and asks to be unlinked from the storage. The storage decrements the usage count and if it reaches 0, the storage itself is also deleted.</p>\n\
<p>Note that this is only the case when a bitmap is loaded because when you create a bitmap, it doesn&#39;t yet exist in the file system. There is no way for someone else to &quot;open&quot; it. This is why when you create a bitmap, it is said this is a &quot;WRITE ONLY&quot; bitmap, and when you load a bitmap it is said this is a &quot;READ ONLY&quot; bitmap. In order to read and write a bitmap you must load the original bitmap, create a second, copy the data (doing whatever processing in between), and then write the newly created bitmap.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_other_plug-in_types.html\">Writing Other Plug-in Types</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";