var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"writing_system_plug-ins\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Writing System Plug-ins</h1></div><p>System plug-ins are combinations of one or more objects, along with optional controllers, or modifiers, or space warps, all working together. These plug-ins can provide high-order parametric control over a complex collection of scene entities. An example system is Biped which uses objects and driver/driven controllers.</p>\n\
<p>The Ring Array sample (<em>\\MAXSDK\\SAMPLES\\OBJECTS\\RINGARRAY.CPP</em>) demonstrates how a driver controller can direct the animation of several nodes in the scene that have driven controllers assigned to them. In the Ring Array plug-in, box objects form a ring that take the shape of an animatable cyclic wave centered about a driver parent dummy object. The nodes corresponding to the box objects are positioned and oriented by their driven transform controllers. The driven controllers simply reference the driver controller and get their parameters from it at a certain time. This arrangement ensures that the driver maintains control and directs the entire system.</p>\n\
<p>This plug-in uses several parameters to define the behavior of the system, as follows:</p>\n\
<ul>\n\
<li>Number - Sets the number of nodes in the ring that represents the system; cannot be animated</li>\n\
<li>Radius - Sets the overall size of the ring of boxes</li>\n\
<li>Amplitude - Sets the height of the wave cycle</li>\n\
<li>Cycles - Sets the number of times the cyclic pattern repeats itself.</li>\n\
</ul>\n\
<p>These parameters can be altered at creation time in the Create panel, or can be later altered and animated using the Motion panel.</p>\n\
<div class=\"note note:\"><span class=\"notetitle\">Note:</span> This topic discusses the use of parameter block version 1 and thus is partially obsolete.</div>\n\
<h4 id=\"see-also\">See Also</h4><ul>\n\
<li><p><a href=\"plug-in_basics.html\"\">Plug-in Basics</a></p>\n\
</li>\n\
<li><p><a href=\"advanced_plug-in_topics.html\"\">Advanced Plug-in Topics</a></p>\n\
</li>\n\
</ul>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
      <div class=\"relinfo relchildren\">\n\
        <strong>Pages in this section</strong>\n\
        <ul class=\"ullinks\">\n\
          <li class=\"link ulchildlink\"><a href=\"writing_system_plug-ins/ring_array_classes.html\">Ring Array Classes</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_system_plug-ins/ring_array_driven_and_driver_cont.html\">Ring Array Driven and Driver Controllers</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_system_plug-ins/ring_array_references.html\">Ring Array References</a></li>\n\
          <li class=\"link ulchildlink\"><a href=\"writing_system_plug-ins/ring_array_creation_process.html\">Ring Array Creation Process</a></li>\n\
        </ul>\n\
      </div>\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_plug-ins.html\">Writing Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";