var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"ring_array_classes\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Ring Array Classes</h1></div><p>The ring array plug-in has several key classes:</p>\n\
<ul>\n\
<li>The <code>RingDriver</code> class.</li>\n\
<li>The <code>DrivenControl</code> class.</li>\n\
<li>The <code>RingDriverCreationManager</code> class.</li>\n\
<li>The <code>RingDriverCreateMode</code> class.</li>\n\
</ul>\n\
<p>This section examines each of these classes in terms of their function within the system.</p>\n\
<p>The <code>RingDriver</code> class (derived from <code>ReferenceTarget</code>) is responsible for directing the entire system after it is created. It maintains a table of all the nodes it controls. It also manages the user interface parameters of the system using a parameter block. For more details on parameter blocks see the topic on <a href=\"./../../3ds_max_sdk_features/plug-ins/parameter_blocks.html\">Parameter Blocks</a>. This class has a very important method named <code>GetValue()</code>. The driven controllers directing the position of the ring nodes call this method in their implementation of <code>Control::GetValue()</code>. This allows the <code>RingDriver</code> to control all the driven controllers based on their position in the ring array and the UI parameters.</p>\n\
<p>The class <code>DrivenControl</code> is derived from class <code>Control</code>. In its implementation of <code>GetValue()</code> the driven controller calls the method of the same name on the <code>RingDriver</code>. This is how the driven controllers derive their position and orientation from the driver -- the driver simply supplies all the values to each of its driven controllers. Each driven controller has a reference to the <code>RingDriver</code>. This is used to register a dependency between the driven controller and the <code>RingDriver</code> in the system. If the user changes the parameters of the driver controller, it sends a <code>REFMSG_CHANGE</code> message up to the driven controllers, which sends it to the nodes they control. This invalidates the nodes and causes them to get redrawn in the next screen update.</p>\n\
<p>The class <code>RingDriverCreationManager</code> (derived from both <code>MouseCallBack</code> and <code>ReferenceMaker</code>) manages the user interaction during the creation process. It is used to handle the creation of the center dummy object and the box objects in the ring surrounding the center. In addition to creating the objects, it creates nodes in the scene for these objects, sets their transform controllers, and links the ring nodes to the parent node at the center of the ring. The creation manager maintains a data member <code>theMaster</code>. This is a pointer to an instance of class <code>RingDriver</code>. This is used to call methods of the driver such as its <code>BeginEditParams()</code> and <code>EndEditParams()</code>. This object also maintains a reference to the first driven node it creates. This is used so that if the user deselects this driven node the creation process will begin with a new item (and not continue to edit the existing item if the UI controls are adjusted). An instance of this class is the mouse callback object for the <code>RingDriverCreateMode</code> class described below.</p>\n\
<p>The class <code>RingDriverCreateMode</code> (derived from <code>CommandMode</code>) is the command mode that is put into effect when the Ring Array is being created. A command mode has a mouse procedure that handles the user/mouse interaction during creation. This takes place during execution of the <code>ClassDesc::BeginCreate()</code> method. See the section below for more details on how <code>BeginCreate()</code> and <code>EndCreate()</code> bracket the creation phase of a plug-in. The mouse callback object portion of the command mode (returned from method <code>CommandMode::MouseProc()</code>) is an instance of class <code>RingDriverCreationManager</code>.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_system_plug-ins.html\">Writing System Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";