var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"ring_array_driven_and_driver_cont\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Ring Array Driven and Driver Controllers</h1></div><p>This section discusses the use of controllers within the Ring Array plug-in.</p>\n\
<p>Each box object node in the circle of the Ring Array has a driven controller that positions it within the system. As mentioned previously, the driven controllers have their position and orientation set by the <code>RingDriver</code>. The method of a controller that the system calls to get its value (position) at a certain time is called <code>GetValue()</code>. The driven controller implementation looks like this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">void DrivenControl::GetValue(TimeValue t,\n\
              void *val,\n\
              Interval &amp;valid,\n\
              GetSetMethod method)\n\
{\n\
   assert(driver);\n\
   driver-&gt;GetValue(t,val,valid,method,id);\n\
}</code></pre><p>This method simply calls the <code>RingDriver</code>&apos;s method of the same name. The <code>RingDriver</code> uses the id passed to know which of the nodes in the Ring Array it is returning the position of. The id, as well as the user interface parameters, determines the position and rotation angle returned from the controller.</p>\n\
<p>The <code>RingDriver</code> implementation of <code>GetValue()</code> looks like this:</p>\n\
<pre class=\"pre codeblock\"><code class=\"language-cpp prettyprint\">// ======= This method is the crux of the system plug-in ==========\n\
// It takes an input (parent) matrix and modifies it according to the id\n\
// passed in. This id represents the position in the Ring Array system\n\
// of the node that is having its position set.\n\
//\n\
// The driven controllers that set the position and orientation of the\n\
// Ring Array nodes call this method in their implementation of the\n\
// method Control::GetValue().\n\
void RingDriver::GetValue(   TimeValue t,\n\
              void *val,\n\
              Interval &amp;valid,\n\
              GetSetMethod method,\n\
              int id)\n\
{\n\
   Matrix3 tmat, *mat = (Matrix3*)val;\n\
   tmat.IdentityMatrix();\n\
\n\
   // Retrieve the values of the UI parameters at the time passed in.\n\
   floatradius = GetRad(t,valid);\n\
   floatamplitude = GetAmp(t,valid);\n\
   floatcycles = GetCyc(t,valid);\n\
   floatphase = GetPhs(t,valid);\n\
\n\
// Calculate the Z angle rotation for the nodes based on the number\n\
   // of nodes in the Ring Array and the id of the node passed in.\n\
   floatang = float(id)*TWO_PI/(float)GetNum(t,valid);\n\
\n\
   // Calculate the translation of the node based on the id and the UI\n\
   // parameters.\n\
   tmat.Translate(Point3(radius, 0.0f,\n\
   amplitude*(float)cos(cycles*ang + TWO_PI*phase)));\n\
   tmat.RotateZ(ang);\n\
\n\
   // There are two ways of updating a value; relative or absolute.\n\
   // If the value is relative the calculated position is applied to\n\
   // the input value using matrix multiplication. If the method\n\
   // is absolute then the value is simply set to the calculated value.\n\
   (*mat) = (method==CTRL_RELATIVE) ? tmat*(*mat) : tmat;\n\
\n\
   // Make sure the UI spinners track when animating and in Motion Panel\n\
   UpdateUI(t);\n\
}</code></pre><p>Thus the driven controllers do nothing more than call the driver which establishes the proper values so each node is positioned properly within the ring. The above code is the basis of the Ring Array system.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_system_plug-ins.html\">Writing System Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";