var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"ring_array_references\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>Ring Array References</h1></div><p>There are several classes in the Ring Array that make references. This section provides an overview of how the references are used by the classes. For a general introduction to the 3ds Max reference mechanism topic on <a href=\"./../../3ds_max_sdk_features/reference_system.html\">Reference System</a>.</p>\n\
<p>The <code>RingDriver</code> is the class that manages the user interface parameters. It creates a parameter block and makes a reference to it. The <code>RingDriver</code> also maintains indirect references to the nodes in the system object. It creates a container of indirect references (<code>IIndirectRefTargContainer</code>) and makes a reference to it. The <code>RingDriver</code> ensures that the container&#39;s size is updated when the user changes the number of nodes in the Ring Array, and sets up the container&#39;s elements with the pointers to the nodes by calling <code>RingDriver::SetDrivenNode</code>(int I, <code>INode</code>* node). To find out more about indirect references, see <a href=\"./../../3ds_max_sdk_features/reference_system/kinds_of_references/indirect_references.html\">Indirect References</a>.</p>\n\
<p>The <code>RingDriverCreationManager</code> maintains a reference to the first driven node that it creates. This is done so it receives notification when the driven node is selected, deselected or deleted. This class is responsible for managing the editing of the Ring Array user interface parameters. When the selected driven node is deselected it indicates that the creation process is to begin on a new Ring Array. The user can no longer adjust the spinners in the UI and update the existing Ring Array. Therefore when the user deselects the node (via Edit / Select None) the creation manager calls <code>EndEditParams()</code> on the <code>RingDriver</code> to terminate the editing of the parameters. Note that Edit / Select None is the only way that this can happen. If the user were to choose the Select Object tool and deselect the node, the <code>RingDriverCreateMode</code> command mode would be replaced by the Select Object command mode and the entire process would be finished. If however the user selected Edit / Select None the node would be deselected but the Ring Array command mode would still be active.</p>\n\
<p>The <code>drivenController</code> makes a reference to the <code>RingDriver</code> object it uses to calculate its value. Because the driven controller has a pointer to the <code>RingDriver</code> it is dependent upon its existence. To indicate to the system that the dependency exists, it creates a reference to the <code>RingDriver</code>. If the user changes the parameters of the <code>RingDriver</code> controller, it sends a <code>REFMSG_CHANGE</code> message up to the driven controllers, which sends it to the nodes they control. This invalidates the nodes and causes them to be redrawn in the next screen update.</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_system_plug-ins.html\">Writing System Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";