var topic = "<html>\n\
<head>\n\
	<script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"/></script\n\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
	<!--script type=\"text/javascript\" src=\"..\\../scripts/utils/adsk.redirect.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/lang-maxscript.js\"/></script>\n\
	<script type=\"text/javascript\" src=\"..\\../scripts/prettify/run_prettify.js\"/></script-->\n\
    <title>3ds Max SDK Help</title>\n\
    <meta name=\"topicid\" content=\"world_space_modifier_plug-in_ove\" />\n\
    </head>\n\
<body height=\"100%\">\n\
  <a name=\"top\"></a>\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/bootstrap.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/additions.css\">\n\
  <link rel=\"stylesheet\" type=\"text/css\" href=\"/cloudhelp/2024/ENU/Max-Developer-Help/styles/font-awesome.min.css\">\n\
\n\
  <div class=\"body_content\" id=\"body-content\">\n\
  <div class=\"head-block\"><h1>World Space Modifier Plug-in Overview</h1></div><p>Writing a WSM involves creating instances of two key classes. One is derived from class <code>WSMObject</code>. The other class is derived from <code>Modifier</code>. These two classes work together. The object handles the display and management of its user interface parameters, the display of the WSM node in the scene, and provides a world space orientation. The modifier handles the actual deformation of the geometry of nodes bound to the space warp.</p>\n\
<p>The <code>SinWave</code>.cpp example has six plug-ins in a single source file. These are:</p>\n\
<ul>\n\
<li>The Ripple WSM Object - Implemented by <code>SinWaveObject</code> derived from <code>WaveObject</code>.</li>\n\
<li>The Ripple WSM Modifier - Implemented by <code>SinWaveMod</code> derived from <code>WaveMod</code>.</li>\n\
<li>The Ripple Object Space Modifier - Implemented by <code>SinWaveOMod</code> derived from <code>WaveOMod</code>.</li>\n\
<li>The Wave WSM Object - Implemented by <code>LinWaveObject</code> derived from <code>WaveObject</code>.</li>\n\
<li>The Wave WSM Modifier - Implemented by <code>LinWaveMod</code> derived from <code>WaveOMod</code>.</li>\n\
<li>The Wave Object Space Modifier - Implemented by <code>LinWaveOMod</code> derived from <code>WaveOMod</code>.</li>\n\
</ul>\n\
<p>The <code>WaveObject</code> class is derived from <code>SimpleWSMObject</code>, the <code>WaveMod</code> class is derived from <code>SimpleWSMMod</code> and the <code>WaveOMod</code> is derived from <code>SimpleMod</code>.</p>\n\
<p>The interface for WSM objects and modifiers is designed to be as general as possible so that virtually any type of space warp is possible. However, a larger number of useful space warp objects and modifiers may be fairly simple, following a standard format. The <code>SimpleWSMMod</code> and <code>SimpleWSMObject</code> classes encapsulates the common behavior of these types of modifiers and objects. This translates to fewer methods that must be implemented by the developer.</p>\n\
<p>The <code>SimpleWSMObject</code> source code can be found in  <em>\\MAXSDK\\HOWTO\\SOURCECODEEXAMPLES\\SIMPOBJ.CPP</em>  and the source code for <code>SimpleWSMMod</code> is available in  <em>\\MAXSDK\\HOWTO\\SOURCECODEEXAMPLES\\SIMPMOD.CPP</em> .</p>\n\
\n\
  </div>\n\
\n\
    <div class=\"related-links\">\n\
  \n\
    <div class=\"familylinks\">\n\
      <div class=\"parentLink\">\n\
        <strong>Parent page:</strong> <a class=\"link\" href=\"../writing_world_space_modifier_plu.html\">Writing World Space Modifier Plug-ins</a>\n\
      </div>\n\
  \n\
    </div>\n\
  \n\
    </div>\n\
\n\
</body>\n\
</html>\n\
";